import 'package:flutter/material.dart';

class SMapChinaColors {
  /// Anhui
  final Color? cn34;

  /// Beijing
  final Color? cn11;

  /// Chongqing
  final Color? cn50;

  /// Fujian
  final Color? cn35;

  /// Guangdong
  final Color? cn44;

  /// Gansu
  final Color? cn62;

  /// Guangxi Zhuang
  final Color? cn45;

  /// Guizhou
  final Color? cn52;

  /// Hainan
  final Color? cn46;

  /// Hebei
  final Color? cn13;

  /// Henan
  final Color? cn41;

  /// Hong Kong
  final Color? cn91;

  /// Heilongjiang
  final Color? cn23;

  /// Hunan
  final Color? cn43;

  /// Hubei
  final Color? cn42;

  /// Jilin
  final Color? cn22;

  /// Jiangsu
  final Color? cn32;

  /// Jiangxi
  final Color? cn36;

  /// Liaoning
  final Color? cn21;

  /// Macau
  final Color? cn92;

  /// Nei Mongol
  final Color? cn15;

  /// Ningxia Hui
  final Color? cn64;

  /// Quinghai
  final Color? cn63;

  /// Shaanxi
  final Color? cn61;

  /// Sichuan
  final Color? cn51;

  /// Shandong
  final Color? cn37;

  /// Shanghai
  final Color? cn31;

  /// Shanxi
  final Color? cn14;

  /// Tianjin
  final Color? cn12;

  /// Taiwan
  final Color? cn71;

  /// Xinjiang Uygur
  final Color? cn65;

  /// Xizang (Tibet)
  final Color? cn54;

  /// Yunnan
  final Color? cn53;

  /// Zhejiang
  final Color? cn33;
  SMapChinaColors({
    this.cn34,
    this.cn11,
    this.cn50,
    this.cn35,
    this.cn44,
    this.cn62,
    this.cn45,
    this.cn52,
    this.cn46,
    this.cn13,
    this.cn41,
    this.cn91,
    this.cn23,
    this.cn43,
    this.cn42,
    this.cn22,
    this.cn32,
    this.cn36,
    this.cn21,
    this.cn92,
    this.cn15,
    this.cn64,
    this.cn63,
    this.cn61,
    this.cn51,
    this.cn37,
    this.cn31,
    this.cn14,
    this.cn12,
    this.cn71,
    this.cn65,
    this.cn54,
    this.cn53,
    this.cn33,
  });
  Map<String, Color?> toMap() {
    return {
      "CN-34": cn34,
      "CN-11": cn11,
      "CN-50": cn50,
      "CN-35": cn35,
      "CN-44": cn44,
      "CN-62": cn62,
      "CN-45": cn45,
      "CN-52": cn52,
      "CN-46": cn46,
      "CN-13": cn13,
      "CN-41": cn41,
      "CN-91": cn91,
      "CN-23": cn23,
      "CN-43": cn43,
      "CN-42": cn42,
      "CN-22": cn22,
      "CN-32": cn32,
      "CN-36": cn36,
      "CN-21": cn21,
      "CN-92": cn92,
      "CN-15": cn15,
      "CN-64": cn64,
      "CN-63": cn63,
      "CN-61": cn61,
      "CN-51": cn51,
      "CN-37": cn37,
      "CN-31": cn31,
      "CN-14": cn14,
      "CN-12": cn12,
      "CN-71": cn71,
      "CN-65": cn65,
      "CN-54": cn54,
      "CN-53": cn53,
      "CN-33": cn33,
    };
  }

  static SMapChinaColors fromMap(Map<String, Color?> map) {
    return SMapChinaColors(
      cn34: map["CN-34"],
      cn11: map["CN-11"],
      cn50: map["CN-50"],
      cn35: map["CN-35"],
      cn44: map["CN-44"],
      cn62: map["CN-62"],
      cn45: map["CN-45"],
      cn52: map["CN-52"],
      cn46: map["CN-46"],
      cn13: map["CN-13"],
      cn41: map["CN-41"],
      cn91: map["CN-91"],
      cn23: map["CN-23"],
      cn43: map["CN-43"],
      cn42: map["CN-42"],
      cn22: map["CN-22"],
      cn32: map["CN-32"],
      cn36: map["CN-36"],
      cn21: map["CN-21"],
      cn92: map["CN-92"],
      cn15: map["CN-15"],
      cn64: map["CN-64"],
      cn63: map["CN-63"],
      cn61: map["CN-61"],
      cn51: map["CN-51"],
      cn37: map["CN-37"],
      cn31: map["CN-31"],
      cn14: map["CN-14"],
      cn12: map["CN-12"],
      cn71: map["CN-71"],
      cn65: map["CN-65"],
      cn54: map["CN-54"],
      cn53: map["CN-53"],
      cn33: map["CN-33"],
    );
  }
}

class SMapChina {
  static const String instructions =
      """{"n": "China", "w": 774.04419, "h": 569.65088, "g": {"a": "73.554302,53.561780","b": "134.775703,18.155060"}, "i":[{"n": "Anhui", "u": "CN-34", "i": ["m0.6992334,0.5907130", "l0.7001248,0.5903619", "l0.7011971,0.5926264", "l0.7027861,0.5941888", "l0.7024761,0.5947330", "l0.7055637,0.5954527", "l0.7066490,0.5974364", "l0.7079667,0.5969097", "l0.7088194,0.5973311", "l0.7089615,0.6003153", "l0.7103438,0.6014037", "l0.7098529,0.6031065", "l0.7115195,0.6044582", "l0.7115841,0.6051955", "l0.7125789,0.6059679", "l0.7144780,0.6060030", "l0.7152014,0.6054062", "l0.7162221,0.6071090", "l0.7177724,0.6061435", "l0.7188446,0.6082500", "l0.7196198,0.6070563", "l0.7203562,0.6079691", "l0.7209375,0.6107954", "l0.7218290,0.6108481", "l0.7213897,0.6150437", "l0.7247875,0.6149910", "l0.7252009,0.6140957", "l0.7275909,0.6140782", "l0.7287795,0.6146750", "l0.7282498,0.6151490", "l0.7284048,0.6167991", "l0.7276038,0.6180104", "l0.7276168,0.6216969", "l0.7266995,0.6212404", "l0.7264153,0.6217495", "l0.7261698,0.6244178", "l0.7252138,0.6251024", "l0.7255368,0.6260328", "l0.7247487,0.6283325", "l0.7254722,0.6283501", "l0.7255755,0.6295613", "l0.7264153,0.6305795", "l0.7282627,0.6297018", "l0.7285986,0.6285607", "l0.7291412,0.6289820", "l0.7297484,0.6344239", "l0.7308853,0.6352841", "l0.7295805,0.6362145", "l0.7297872,0.6382684", "l0.7304331,0.6379700", "l0.7306657,0.6400765", "l0.7317509,0.6402872", "l0.7318026,0.6416213", "l0.7331332,0.6411123", "l0.7353682,0.6415511", "l0.7361951,0.6409543", "l0.7373966,0.6416389", "l0.7380684,0.6410420", "l0.7379004,0.6382157", "l0.7389985,0.6380226", "l0.7389856,0.6364427", "l0.7394895,0.6363374", "l0.7396962,0.6353543", "l0.7410268,0.6358810", "l0.7423834,0.6353368", "l0.7423834,0.6367587", "l0.7428097,0.6366358", "l0.7438303,0.6388477", "l0.7450964,0.6387073", "l0.7455227,0.6415160", "l0.7452385,0.6428677", "l0.7458715,0.6445881", "l0.7456131,0.6454658", "l0.7450447,0.6448163", "l0.7445150,0.6475899", "l0.7434815,0.6486256", "l0.7426547,0.6469755", "l0.7417762,0.6472213", "l0.7410398,0.6458871", "l0.7403034,0.6459047", "l0.7405230,0.6450094", "l0.7394636,0.6455887", "l0.7391536,0.6446232", "l0.7386239,0.6452025", "l0.7374741,0.6445178", "l0.7351099,0.6450972", "l0.7349807,0.6458169", "l0.7357946,0.6469930", "l0.7355233,0.6479586", "l0.7370090,0.6480639", "l0.7368540,0.6503284", "l0.7372803,0.6515924", "l0.7364664,0.6526456", "l0.7365826,0.6547522", "l0.7340505,0.6553842", "l0.7339213,0.6572274", "l0.7321901,0.6583158", "l0.7318026,0.6621251", "l0.7334045,0.6643195", "l0.7340505,0.6644774", "l0.7337146,0.6656712", "l0.7344251,0.6670931", "l0.7360400,0.6665313", "l0.7368281,0.6674266", "l0.7370736,0.6680235", "l0.7363501,0.6688134", "l0.7365310,0.6696912", "l0.7376420,0.6699369", "l0.7384172,0.6686554", "l0.7388435,0.6701827", "l0.7398900,0.6702529", "l0.7402904,0.6728510", "l0.7400062,0.6753086", "l0.7390373,0.6767481", "l0.7379779,0.6769061", "l0.7372544,0.6785211", "l0.7381846,0.6791707", "l0.7386497,0.6803819", "l0.7435719,0.6802941", "l0.7450447,0.6785211", "l0.7453677,0.6793286", "l0.7466854,0.6798377", "l0.7477190,0.6795569", "l0.7479386,0.6785914", "l0.7484037,0.6794691", "l0.7480549,0.6809437", "l0.7487137,0.6811368", "l0.7484812,0.6816985", "l0.7525120,0.6827869", "l0.7525120,0.6827869", "l0.7524215,0.6859467", "l0.7513105,0.6885273", "l0.7514914,0.6905285", "l0.7507808,0.6920206", "l0.7501090,0.6919680", "l0.7500961,0.6937585", "l0.7493597,0.6953033", "l0.7488817,0.6954087", "l0.7484037,0.6943905", "l0.7472668,0.6960406", "l0.7460782,0.6961986", "l0.7464916,0.6971115", "l0.7460912,0.6981999", "l0.7465950,0.6988318", "l0.7474606,0.6983578", "l0.7478352,0.7012719", "l0.7486621,0.7025183", "l0.7480419,0.7029396", "l0.7474606,0.7023954", "l0.7462462,0.7031503", "l0.7458586,0.7044493", "l0.7435719,0.7035891", "l0.7428743,0.7040806", "l0.7414144,0.7026938", "l0.7402259,0.7038173", "l0.7403938,0.7060117", "l0.7408976,0.7065207", "l0.7396832,0.7078549", "l0.7404196,0.7080304", "l0.7399933,0.7092417", "l0.7405230,0.7113131", "l0.7404196,0.7132442", "l0.7395282,0.7135426", "l0.7393086,0.7149294", "l0.7381459,0.7159300", "l0.7378875,0.7187387", "l0.7364276,0.7208629", "l0.7347869,0.7217932", "l0.7337275,0.7244264", "l0.7326552,0.7244264", "l0.7323452,0.7252164", "l0.7309499,0.7247951", "l0.7308078,0.7266032", "l0.7297872,0.7263574", "l0.7289603,0.7273581", "l0.7289603,0.7273581", "l0.7279268,0.7266032", "l0.7280172,0.7244967", "l0.7260019,0.7226885", "l0.7246970,0.7233907", "l0.7227075,0.7227588", "l0.7210021,0.7234083", "l0.7201753,0.7217581", "l0.7190772,0.7224954", "l0.7182762,0.7221795", "l0.7178369,0.7214773", "l0.7181083,0.7207400", "l0.7168551,0.7198798", "l0.7168809,0.7183174", "l0.7161316,0.7171588", "l0.7163125,0.7157896", "l0.7153048,0.7167024", "l0.7149431,0.7157545", "l0.7142196,0.7164566", "l0.7136641,0.7162284", "l0.7135865,0.7142623", "l0.7129147,0.7137883", "l0.7116487,0.7143852", "l0.7115712,0.7154034", "l0.7106410,0.7162109", "l0.7116616,0.7175099", "l0.7112869,0.7192654", "l0.7093878,0.7199851", "l0.7068557,0.7228465", "l0.7061193,0.7229519", "l0.7055508,0.7221268", "l0.7049049,0.7229870", "l0.7037809,0.7211613", "l0.7042589,0.7201782", "l0.7038067,0.7197043", "l0.7054087,0.7170886", "l0.7063906,0.7167200", "l0.7078246,0.7132090", "l0.7073078,0.7124366", "l0.7066748,0.7126649", "l0.7066231,0.7116993", "l0.7061580,0.7118222", "l0.7059255,0.7110323", "l0.7040264,0.7100492", "l0.7027732,0.7105583", "l0.7019076,0.7145432", "l0.7008095,0.7145256", "l0.6973988,0.7174748", "l0.6964687,0.7162284", "l0.6953318,0.7164566", "l0.6953318,0.7164566", "l0.6952930,0.7147714", "l0.6943370,0.7128755", "l0.6946212,0.7110147", "l0.6941949,0.7067138", "l0.6930451,0.7054324", "l0.6928255,0.7043791", "l0.6915723,0.7040104", "l0.6917661,0.7033785", "l0.6912364,0.7021672", "l0.6922183,0.7010788", "l0.6914173,0.7003591", "l0.6917273,0.6986914", "l0.6910168,0.6968833", "l0.6900608,0.6967077", "l0.6899574,0.6954438", "l0.6892081,0.6944432", "l0.6895440,0.6926350", "l0.6909651,0.6921084", "l0.6905517,0.6905812", "l0.6909651,0.6897736", "l0.6943370,0.6872458", "l0.6938719,0.6859292", "l0.6921537,0.6851919", "l0.6910685,0.6825411", "l0.6893760,0.6834189", "l0.6882392,0.6811368", "l0.6875028,0.6808910", "l0.6862496,0.6825411", "l0.6854099,0.6797851", "l0.6843763,0.6793462", "l0.6843247,0.6781876", "l0.6838854,0.6772923", "l0.6831232,0.6774152", "l0.6828389,0.6759230", "l0.6828389,0.6759230", "l0.6829423,0.6734303", "l0.6847381,0.6705689", "l0.6849189,0.6689188", "l0.6878387,0.6661627", "l0.6886267,0.6666367", "l0.6893114,0.6660222", "l0.6900866,0.6666893", "l0.6916757,0.6657589", "l0.6913527,0.6636875", "l0.6918307,0.6626518", "l0.6920891,0.6561741", "l0.6916111,0.6547171", "l0.6911718,0.6476952", "l0.6905517,0.6471862", "l0.6918953,0.6455711", "l0.6914043,0.6453605", "l0.6895182,0.6482921", "l0.6892727,0.6472739", "l0.6890789,0.6480112", "l0.6880712,0.6475197", "l0.6875803,0.6497316", "l0.6864563,0.6492751", "l0.6857845,0.6499247", "l0.6860041,0.6495209", "l0.6834461,0.6454482", "l0.6817408,0.6460275", "l0.6817279,0.6451498", "l0.6800097,0.6450620", "l0.6800097,0.6380753", "l0.6790149,0.6368816", "l0.6773095,0.6367236", "l0.6769736,0.6358810", "l0.6758109,0.6359863", "l0.6748549,0.6347048", "l0.6756430,0.6337393", "l0.6750875,0.6320541", "l0.6752296,0.6308955", "l0.6757592,0.6300880", "l0.6773095,0.6319839", "l0.6791699,0.6320365", "l0.6798417,0.6310710", "l0.6815470,0.6307375", "l0.6827356,0.6256466", "l0.6819217,0.6242598", "l0.6824255,0.6210122", "l0.6828906,0.6205382", "l0.6832911,0.6209771", "l0.6835366,0.6195376", "l0.6858879,0.6195376", "l0.6872056,0.6188179", "l0.6860429,0.6137797", "l0.6868568,0.6135691", "l0.6871152,0.6112343", "l0.6857328,0.6109710", "l0.6865855,0.6069334", "l0.6874123,0.6060381", "l0.6899832,0.6058801", "l0.6907196,0.6076883", "l0.6912881,0.6069159", "l0.6925929,0.6077409", "l0.6931226,0.6087240", "l0.6928642,0.6102864", "l0.6940915,0.6114450", "l0.6938719,0.6122700", "l0.6943370,0.6135866", "l0.6957581,0.6155703", "l0.7002411,0.6130073", "l0.7003315,0.6117083", "l0.7016363,0.6112343", "l0.7023340,0.6102512", "l0.7035871,0.6107252", "l0.7037034,0.6084958", "l0.7017397,0.6047215", "l0.7024115,0.6031592", "l0.7019722,0.6017197", "l0.7025794,0.6003856", "l0.7013392,0.5998940", "l0.7005770,0.6006313", "l0.7003961,0.5999994", "l0.6991171,0.6005787", "l0.6990525,0.5993498", "l0.6966108,0.5975944", "l0.6957323,0.5954527", "l0.6963911,0.5940483", "l0.6962490,0.5923455", "l0.6962490,0.5923455", "l0.6970113,0.5930653", "l0.6977089,0.5915731", "l0.6983161,0.5917487", "c"]}, {"n": "Beijing", "u": "CN-11", "i": ["m0.7062614,0.4529619", "l0.7059255,0.4534008", "l0.7046206,0.4527337", "l0.7047886,0.4535939", "l0.7029928,0.4524002", "l0.7024890,0.4526635", "l0.7010291,0.4548403", "l0.6996985,0.4557004", "l0.7005253,0.4577719", "l0.6987037,0.4574910", "l0.6971921,0.4559638", "l0.6969854,0.4545067", "l0.6961844,0.4538397", "l0.6952284,0.4542610", "l0.6929159,0.4535061", "l0.6925154,0.4541907", "l0.6918953,0.4532955", "l0.6915981,0.4542785", "l0.6904613,0.4547525", "l0.6899962,0.4557707", "l0.6891306,0.4557707", "l0.6880195,0.4532428", "l0.6860429,0.4533130", "l0.6846605,0.4516980", "l0.6847897,0.4492228", "l0.6837045,0.4482397", "l0.6860817,0.4470811", "l0.6852548,0.4462561", "l0.6851902,0.4442724", "l0.6836916,0.4430962", "l0.6840792,0.4409897", "l0.6867793,0.4383038", "l0.6890401,0.4378123", "l0.6895569,0.4365835", "l0.6905258,0.4377070", "l0.6911718,0.4353898", "l0.6924766,0.4341785", "l0.6916757,0.4314926", "l0.6910297,0.4313698", "l0.6893890,0.4288770", "l0.6894665,0.4275253", "l0.6887947,0.4272093", "l0.6891693,0.4260683", "l0.6916498,0.4238564", "l0.6928771,0.4249623", "l0.6948021,0.4239266", "l0.6969983,0.4189060", "l0.6979156,0.4198188", "l0.6998147,0.4189586", "l0.7005511,0.4194677", "l0.7006286,0.4188182", "l0.6985486,0.4156057", "l0.6986003,0.4147455", "l0.6991042,0.4144471", "l0.6996209,0.4155179", "l0.7007966,0.4157813", "l0.7004607,0.4133938", "l0.7027990,0.4133412", "l0.7030187,0.4114102", "l0.7036000,0.4109713", "l0.7044269,0.4117261", "l0.7041039,0.4133587", "l0.7048920,0.4155706", "l0.7061322,0.4172734", "l0.7070236,0.4175718", "l0.7094395,0.4216445", "l0.7118295,0.4213987", "l0.7145296,0.4227855", "l0.7160929,0.4220307", "l0.7176302,0.4224520", "l0.7176173,0.4232946", "l0.7167517,0.4228382", "l0.7164675,0.4234000", "l0.7166871,0.4249974", "l0.7144263,0.4250150", "l0.7133798,0.4259103", "l0.7135607,0.4268407", "l0.7127210,0.4273497", "l0.7132894,0.4291228", "l0.7130827,0.4308958", "l0.7151498,0.4350562", "l0.7157311,0.4351791", "l0.7157311,0.4351791", "l0.7157311,0.4368117", "l0.7127080,0.4393571", "l0.7127080,0.4393571", "l0.7104601,0.4399540", "l0.7094912,0.4409019", "l0.7085868,0.4403753", "l0.7059126,0.4409370", "l0.7055508,0.4427100", "l0.7059384,0.4445357", "l0.7081347,0.4460454", "l0.7086514,0.4479940", "l0.7079021,0.4487839", "l0.7078117,0.4504867", "l0.7078117,0.4504867", "l0.7078892,0.4510134", "l0.7070495,0.4514522", "c"]}, {"n": "Chongqing", "u": "CN-50", "i": ["m0.5710107,0.6549628", "l0.5734524,0.6575785", "l0.5747056,0.6576311", "l0.5748994,0.6586669", "l0.5770440,0.6605803", "l0.5794340,0.6613527", "l0.5819145,0.6640035", "l0.5820824,0.6650041", "l0.5833614,0.6655834", "l0.5831160,0.6664260", "l0.5835810,0.6677953", "l0.5883482,0.6674266", "l0.5883482,0.6674266", "l0.5908287,0.6682517", "l0.5911517,0.6704811", "l0.5907512,0.6720259", "l0.5922110,0.6716748", "l0.5932575,0.6726754", "l0.5948207,0.6729914", "l0.5943298,0.6739569", "l0.5975208,0.6761688", "l0.5983735,0.6825060", "l0.5971591,0.6838402", "l0.5972237,0.6854025", "l0.5979472,0.6867191", "l0.5965002,0.6914238", "l0.5955442,0.6906338", "l0.5952600,0.6889135", "l0.5946657,0.6896332", "l0.5935288,0.6891768", "l0.5915651,0.6901774", "l0.5897047,0.6923717", "l0.5894334,0.6936181", "l0.5884774,0.6940921", "l0.5883353,0.6951980", "l0.5876764,0.6947065", "l0.5863328,0.6960582", "l0.5845112,0.6993409", "l0.5845758,0.6975328", "l0.5838524,0.6957598", "l0.5811393,0.6983227", "l0.5802996,0.6975152", "l0.5807776,0.6953911", "l0.5795244,0.6951980", "l0.5782196,0.6960757", "l0.5759975,0.6992707", "l0.5745118,0.6992005", "l0.5738271,0.6969359", "l0.5728840,0.6970237", "l0.5731036,0.6981296", "l0.5719021,0.6998324", "l0.5709203,0.6990951", "l0.5694862,0.6994989", "l0.5690987,0.7020268", "l0.5719150,0.7056430", "l0.5717342,0.7083289", "l0.5707523,0.7106285", "l0.5711657,0.7104881", "l0.5713337,0.7122260", "l0.5710495,0.7152980", "l0.5696542,0.7149294", "l0.5689049,0.7154034", "l0.5687886,0.7166322", "l0.5690599,0.7161582", "l0.5694087,0.7167024", "l0.5696930,0.7187036", "l0.5708428,0.7193180", "l0.5713337,0.7186685", "l0.5712045,0.7173870", "l0.5722122,0.7155965", "l0.5732845,0.7157194", "l0.5736333,0.7197920", "l0.5743051,0.7198096", "l0.5749252,0.7209506", "l0.5754032,0.7203011", "l0.5754549,0.7212842", "l0.5764109,0.7208629", "l0.5769535,0.7214948", "l0.5767339,0.7222848", "l0.5772894,0.7222497", "l0.5766435,0.7253919", "l0.5778449,0.7267612", "l0.5774574,0.7291311", "l0.5784651,0.7289906", "l0.5800024,0.7273581", "l0.5806484,0.7281480", "l0.5806355,0.7298859", "l0.5810747,0.7306232", "l0.5807001,0.7322207", "l0.5826767,0.7342570", "l0.5826767,0.7342570", "l0.5826121,0.7349943", "l0.5840978,0.7361705", "l0.5827284,0.7404011", "l0.5828188,0.7428939", "l0.5838394,0.7440701", "l0.5830126,0.7450531", "l0.5832581,0.7457026", "l0.5818757,0.7468437", "l0.5821341,0.7473703", "l0.5836198,0.7469139", "l0.5840978,0.7475810", "l0.5833485,0.7498455", "l0.5833485,0.7498455", "l0.5820307,0.7507584", "l0.5813848,0.7521276", "l0.5810101,0.7547081", "l0.5802479,0.7562530", "l0.5803771,0.7576047", "l0.5793177,0.7571131", "l0.5787880,0.7583595", "l0.5775607,0.7570429", "l0.5764109,0.7573764", "l0.5757779,0.7563056", "l0.5749640,0.7574467", "l0.5743826,0.7557263", "l0.5751578,0.7545677", "l0.5752094,0.7515483", "l0.5742534,0.7499157", "l0.5730649,0.7507935", "l0.5738012,0.7523383", "l0.5732328,0.7532862", "l0.5735429,0.7538831", "l0.5726902,0.7541815", "l0.5719796,0.7534091", "l0.5724318,0.7518819", "l0.5719150,0.7490205", "l0.5725481,0.7488098", "l0.5729227,0.7463873", "l0.5719538,0.7457904", "l0.5702872,0.7466681", "l0.5681168,0.7454920", "l0.5688661,0.7425955", "l0.5681685,0.7410858", "l0.5684010,0.7400852", "l0.5677034,0.7380839", "l0.5675613,0.7352401", "l0.5670316,0.7353279", "l0.5664373,0.7365567", "l0.5657526,0.7355736", "l0.5650162,0.7360476", "l0.5636468,0.7352050", "l0.5627683,0.7367322", "l0.5617477,0.7364689", "l0.5600553,0.7383121", "l0.5591122,0.7358369", "l0.5593576,0.7338357", "l0.5586212,0.7326420", "l0.5574068,0.7337479", "l0.5568126,0.7329404", "l0.5558953,0.7331160", "l0.5554690,0.7318169", "l0.5541900,0.7329580", "l0.5536344,0.7322031", "l0.5529368,0.7326771", "l0.5531435,0.7344150", "l0.5523684,0.7347661", "l0.5526267,0.7363460", "l0.5522392,0.7371009", "l0.5534148,0.7386983", "l0.5525621,0.7409629", "l0.5518516,0.7411384", "l0.5515674,0.7419459", "l0.5501204,0.7430694", "l0.5496941,0.7415773", "l0.5483117,0.7401027", "l0.5473686,0.7406469", "l0.5464643,0.7401905", "l0.5459088,0.7410155", "l0.5460380,0.7428939", "l0.5454566,0.7430694", "l0.5445652,0.7419635", "l0.5435446,0.7430694", "l0.5433120,0.7438770", "l0.5443326,0.7452989", "l0.5433508,0.7475634", "l0.5425498,0.7467735", "l0.5426144,0.7482305", "l0.5417746,0.7490029", "l0.5421493,0.7501615", "l0.5417876,0.7509339", "l0.5414000,0.7510392", "l0.5411158,0.7500562", "l0.5407153,0.7503546", "l0.5396817,0.7495998", "l0.5392167,0.7501615", "l0.5406248,0.7458431", "l0.5393846,0.7451233", "l0.5396042,0.7444036", "l0.5376276,0.7414544", "l0.5371754,0.7417177", "l0.5373175,0.7427710", "l0.5384286,0.7455271", "l0.5375501,0.7477741", "l0.5380669,0.7489151", "l0.5364778,0.7480374", "l0.5360644,0.7491784", "l0.5360644,0.7491784", "l0.5353409,0.7484938", "l0.5354184,0.7464750", "l0.5349017,0.7462819", "l0.5340361,0.7425779", "l0.5341394,0.7411735", "l0.5334547,0.7399623", "l0.5307029,0.7396463", "l0.5306642,0.7385755", "l0.5296823,0.7377855", "l0.5283258,0.7398043", "l0.5279899,0.7391021", "l0.5266980,0.7388388", "l0.5257807,0.7361705", "l0.5260133,0.7355561", "l0.5253415,0.7347310", "l0.5256774,0.7339937", "l0.5249281,0.7300439", "l0.5242563,0.7309568", "l0.5239850,0.7304126", "l0.5210394,0.7299913", "l0.5211428,0.7292364", "l0.5205485,0.7292891", "l0.5204064,0.7286220", "l0.5206777,0.7270772", "l0.5198121,0.7266032", "l0.5198767,0.7259537", "l0.5188561,0.7260766", "l0.5183393,0.7236716", "l0.5187140,0.7220215", "l0.5191532,0.7223726", "l0.5203676,0.7200729", "l0.5212978,0.7202133", "l0.5214399,0.7191249", "l0.5220988,0.7195112", "l0.5228222,0.7187739", "l0.5235457,0.7161933", "l0.5254707,0.7156491", "l0.5252123,0.7138410", "l0.5257161,0.7112780", "l0.5248635,0.7109094", "l0.5223701,0.7075565", "l0.5242950,0.7066436", "l0.5237266,0.7049408", "l0.5254836,0.7054324", "l0.5252510,0.7042211", "l0.5256903,0.7027816", "l0.5270985,0.7009033", "l0.5273956,0.7019565", "l0.5281449,0.7015177", "l0.5322403,0.7038349", "l0.5338164,0.7072229", "l0.5346820,0.7067841", "l0.5348500,0.7059590", "l0.5369170,0.7056079", "l0.5372013,0.7044317", "l0.5391133,0.7041684", "l0.5403794,0.7050988", "l0.5399789,0.7062925", "l0.5421364,0.7112254", "l0.5450044,0.7111025", "l0.5458054,0.7098386", "l0.5465547,0.7110323", "l0.5474074,0.7104705", "l0.5500042,0.7061872", "l0.5508051,0.7035716", "l0.5521100,0.7015001", "l0.5524976,0.6993058", "l0.5545517,0.6956369", "l0.5531435,0.6929510", "l0.5545775,0.6904583", "l0.5557532,0.6901598", "l0.5566575,0.6911605", "l0.5579753,0.6892997", "l0.5587246,0.6911253", "l0.5604816,0.6913009", "l0.5622515,0.6887555", "l0.5615280,0.6882815", "l0.5616572,0.6868245", "l0.5634788,0.6849988", "l0.5627554,0.6834891", "l0.5639956,0.6809086", "l0.5629879,0.6806452", "l0.5630008,0.6799079", "l0.5655330,0.6777487", "l0.5651067,0.6766428", "l0.5660110,0.6757826", "l0.5662565,0.6743431", "l0.5657526,0.6735356", "l0.5679230,0.6731494", "l0.5696025,0.6699720", "l0.5704035,0.6702354", "l0.5703647,0.6696561", "l0.5713337,0.6688837", "l0.5708944,0.6673915", "l0.5712174,0.6666542", "l0.5706748,0.6659169", "l0.5699513,0.6660047", "l0.5700547,0.6653376", "l0.5682977,0.6640210", "l0.5668766,0.6612474", "l0.5674579,0.6605452", "l0.5685173,0.6607559", "l0.5679747,0.6598606", "l0.5683881,0.6591760", "l0.5681943,0.6584562", "l0.5698609,0.6586493", "l0.5693183,0.6568236", "l0.5686594,0.6564901", "l0.5687111,0.6555773", "l0.5692279,0.6551384", "l0.5704810,0.6555421", "c"]}, {"n": "Fujian", "u": "CN-35", "i": ["m0.7159766,0.8658991", "l0.7165709,0.8671103", "l0.7179145,0.8666715", "l0.7179920,0.8675667", "l0.7174752,0.8673912", "l0.7175140,0.8689536", "l0.7164804,0.8689711", "l0.7166742,0.8707266", "l0.7147364,0.8709548", "l0.7164158,0.8685498", "l0.7150981,0.8681987", "l0.7159766,0.8658991", "c", "m0.7498377,0.8300876", "l0.7508325,0.8314745", "l0.7515430,0.8313165", "l0.7509358,0.8318782", "l0.7511684,0.8323522", "l0.7493985,0.8313867", "l0.7493209,0.8305967", "l0.7498377,0.8300876", "c", "m0.7549020,0.8201342", "l0.7549279,0.8215034", "l0.7553154,0.8212752", "l0.7559872,0.8226094", "l0.7566719,0.8225918", "l0.7561810,0.8233291", "l0.7554059,0.8232414", "l0.7553542,0.8243473", "l0.7562198,0.8249793", "l0.7545790,0.8256814", "l0.7544240,0.8261203", "l0.7549020,0.8263485", "l0.7544757,0.8267172", "l0.7531579,0.8248564", "l0.7535326,0.8239260", "l0.7542948,0.8239435", "l0.7541656,0.8218896", "l0.7537135,0.8224163", "l0.7534938,0.8217141", "l0.7549020,0.8201342", "c", "m0.7285340,0.8440962", "l0.7275522,0.8465890", "l0.7276684,0.8473614", "l0.7290120,0.8479056", "l0.7286761,0.8496610", "l0.7280172,0.8504159", "l0.7272421,0.8501350", "l0.7269450,0.8495382", "l0.7272421,0.8469225", "l0.7269191,0.8468523", "l0.7263248,0.8475896", "l0.7269450,0.8484673", "l0.7259373,0.8490642", "l0.7264411,0.8498893", "l0.7244128,0.8490993", "l0.7240123,0.8503106", "l0.7242836,0.8511356", "l0.7269062,0.8507670", "l0.7262473,0.8521714", "l0.7274488,0.8520309", "l0.7280818,0.8538741", "l0.7261827,0.8557700", "l0.7261052,0.8550503", "l0.7258210,0.8552610", "l0.7256014,0.8562616", "l0.7249683,0.8552785", "l0.7243870,0.8561387", "l0.7249296,0.8567004", "l0.7241673,0.8582452", "l0.7242965,0.8597901", "l0.7230821,0.8602640", "l0.7216352,0.8629674", "l0.7214543,0.8622477", "l0.7226687,0.8596496", "l0.7208342,0.8602991", "l0.7210409,0.8618264", "l0.7199040,0.8632308", "l0.7200332,0.8656357", "l0.7191676,0.8674439", "l0.7193872,0.8630552", "l0.7175398,0.8626339", "l0.7166613,0.8617035", "l0.7161962,0.8619493", "l0.7163125,0.8625637", "l0.7173589,0.8628797", "l0.7176044,0.8648458", "l0.7166871,0.8665135", "l0.7160929,0.8656884", "l0.7146718,0.8665135", "l0.7146072,0.8666539", "l0.7138837,0.8671981", "l0.7141162,0.8694802", "l0.7131990,0.8697435", "l0.7125530,0.8698488", "l0.7125530,0.8698488", "l0.7102146,0.8676721", "l0.7097625,0.8647580", "l0.7089356,0.8630201", "l0.7091165,0.8607204", "l0.7082122,0.8585963", "l0.7093361,0.8563318", "l0.7083801,0.8552961", "l0.7080055,0.8519080", "l0.7068686,0.8503106", "l0.7069719,0.8492046", "l0.7054733,0.8475369", "l0.7064164,0.8451495", "l0.7061451,0.8443244", "l0.7029024,0.8450091", "l0.7016105,0.8459921", "l0.7011196,0.8434818", "l0.6999698,0.8428323", "l0.7000085,0.8420950", "l0.6992592,0.8413226", "l0.6999439,0.8403747", "l0.6995563,0.8395496", "l0.6989362,0.8396900", "l0.6981611,0.8412875", "l0.6971017,0.8415333", "l0.6972180,0.8407257", "l0.6963395,0.8397778", "l0.6942853,0.8400762", "l0.6935231,0.8388650", "l0.6911976,0.8380574", "l0.6911976,0.8380574", "l0.6910039,0.8371446", "l0.6915594,0.8368111", "l0.6910555,0.8359509", "l0.6919986,0.8351609", "l0.6910685,0.8335986", "l0.6907842,0.8312814", "l0.6919470,0.8306143", "l0.6933164,0.8285428", "l0.6930063,0.8271560", "l0.6934456,0.8256463", "l0.6930063,0.8251372", "l0.6941045,0.8225216", "l0.6940399,0.8195900", "l0.6948667,0.8191511", "l0.6952026,0.8178345", "l0.6959390,0.8180276", "l0.6960552,0.8174659", "l0.6952672,0.8154120", "l0.6991171,0.8127964", "l0.6995047,0.8109531", "l0.7010937,0.8092152", "l0.7007578,0.8076353", "l0.6995951,0.8074598", "l0.6996468,0.8053356", "l0.7015846,0.8020705", "l0.7029412,0.8026849", "l0.7035354,0.8004204", "l0.7019464,0.7980154", "l0.7024244,0.7961019", "l0.7014942,0.7944693", "l0.7022564,0.7930123", "l0.7020885,0.7912042", "l0.7044785,0.7875704", "l0.7078892,0.7863942", "l0.7084835,0.7866926", "l0.7102276,0.7847968", "l0.7104989,0.7829711", "l0.7121913,0.7804432", "l0.7121784,0.7798112", "l0.7111448,0.7789862", "l0.7111448,0.7775818", "l0.7115970,0.7769849", "l0.7112869,0.7749837", "l0.7107573,0.7731932", "l0.7103697,0.7736847", "l0.7097883,0.7732809", "l0.7097366,0.7710866", "l0.7103955,0.7705424", "l0.7110802,0.7716483", "l0.7111965,0.7702440", "l0.7127726,0.7702089", "l0.7127726,0.7695242", "l0.7143488,0.7679443", "l0.7141292,0.7655393", "l0.7147622,0.7648196", "l0.7150335,0.7658904", "l0.7167517,0.7638717", "l0.7173719,0.7638014", "l0.7179791,0.7626077", "l0.7189480,0.7639594", "l0.7193097,0.7655569", "l0.7214026,0.7672421", "l0.7222165,0.7661713", "l0.7223328,0.7649425", "l0.7234439,0.7636610", "l0.7262602,0.7626428", "l0.7273196,0.7632572", "l0.7278364,0.7609576", "l0.7314537,0.7599219", "l0.7318930,0.7576573", "l0.7310145,0.7567269", "l0.7327973,0.7551295", "l0.7327973,0.7551295", "l0.7337921,0.7564109", "l0.7339471,0.7553928", "l0.7352132,0.7551470", "l0.7357041,0.7560247", "l0.7373578,0.7546379", "l0.7381975,0.7561125", "l0.7388952,0.7562881", "l0.7383009,0.7579031", "l0.7388564,0.7582717", "l0.7388047,0.7593777", "l0.7374870,0.7610454", "l0.7376679,0.7629939", "l0.7391019,0.7646616", "l0.7404067,0.7695242", "l0.7400321,0.7701738", "l0.7406263,0.7730352", "l0.7398124,0.7742991", "l0.7401742,0.7744571", "l0.7401742,0.7744571", "l0.7405618,0.7757386", "l0.7414661,0.7758263", "l0.7414661,0.7758263", "l0.7422929,0.7749311", "l0.7430551,0.7755806", "l0.7441404,0.7752646", "l0.7442566,0.7764934", "l0.7461041,0.7768094", "l0.7482616,0.7739831", "l0.7494889,0.7745097", "l0.7501865,0.7709286", "l0.7509100,0.7712446", "l0.7512071,0.7704546", "l0.7525507,0.7705951", "l0.7524215,0.7725261", "l0.7536747,0.7746677", "l0.7536747,0.7746677", "l0.7534163,0.7765812", "l0.7549020,0.7790915", "l0.7549020,0.7790915", "l0.7547082,0.7796357", "l0.7547082,0.7796357", "l0.7558193,0.7797761", "l0.7558193,0.7797761", "l0.7560518,0.7792319", "l0.7564394,0.7797235", "l0.7575117,0.7794250", "l0.7575117,0.7788106", "l0.7575117,0.7788106", "l0.7585452,0.7778100", "l0.7585452,0.7778100", "l0.7590620,0.7787580", "l0.7607415,0.7768270", "l0.7625243,0.7765110", "l0.7630152,0.7774765", "l0.7630152,0.7774765", "l0.7641005,0.7773536", "l0.7642942,0.7786877", "l0.7642942,0.7786877", "l0.7654441,0.7807767", "l0.7650823,0.7812156", "l0.7656508,0.7830237", "l0.7656508,0.7830237", "l0.7653407,0.7832695", "l0.7645914,0.7811278", "l0.7634674,0.7813560", "l0.7635579,0.7798815", "l0.7628861,0.7802677", "l0.7625114,0.7797235", "l0.7625889,0.7807767", "l0.7617621,0.7803905", "l0.7616846,0.7821987", "l0.7621884,0.7810401", "l0.7629636,0.7810050", "l0.7634028,0.7819880", "l0.7647206,0.7817422", "l0.7647335,0.7827078", "l0.7655732,0.7839190", "l0.7646560,0.7842526", "l0.7646431,0.7849899", "l0.7627827,0.7844808", "l0.7631703,0.7857974", "l0.7627181,0.7857096", "l0.7624856,0.7865522", "l0.7628602,0.7865873", "l0.7629119,0.7873773", "l0.7613745,0.7879566", "l0.7623176,0.7881848", "l0.7622789,0.7894312", "l0.7604831,0.7889572", "l0.7601214,0.7903616", "l0.7593979,0.7898876", "l0.7592816,0.7915904", "l0.7600826,0.7924330", "l0.7607673,0.7923101", "l0.7600697,0.7933283", "l0.7611032,0.7940480", "l0.7601989,0.7949258", "l0.7602635,0.7959966", "l0.7607544,0.7960317", "l0.7600697,0.7967690", "l0.7598242,0.7960141", "l0.7587778,0.7970674", "l0.7578088,0.7969797", "l0.7574213,0.7976292", "l0.7576667,0.7980680", "l0.7566719,0.7992618", "l0.7557159,0.7989809", "l0.7559872,0.7975238", "l0.7578476,0.7964881", "l0.7580801,0.7949609", "l0.7598113,0.7925559", "l0.7573567,0.7929245", "l0.7569820,0.7955577", "l0.7564006,0.7960844", "l0.7558839,0.7945220", "l0.7553542,0.7950311", "l0.7550700,0.7945045", "l0.7552508,0.7931176", "l0.7560001,0.7926788", "l0.7559872,0.7920819", "l0.7552121,0.7925383", "l0.7552767,0.7916255", "l0.7549020,0.7915202", "l0.7547470,0.7934512", "l0.7540881,0.7946449", "l0.7528737,0.7932756", "l0.7522407,0.7933283", "l0.7523828,0.7923277", "l0.7517110,0.7927841", "l0.7518789,0.7934863", "l0.7529900,0.7941358", "l0.7522407,0.7961897", "l0.7514526,0.7963477", "l0.7519564,0.7971552", "l0.7542044,0.7968743", "l0.7549666,0.7976467", "l0.7546953,0.7984542", "l0.7557805,0.8008943", "l0.7548503,0.8015439", "l0.7527833,0.7997884", "l0.7518273,0.8011401", "l0.7530804,0.8015439", "l0.7534551,0.8034573", "l0.7559097,0.8014034", "l0.7565040,0.8027376", "l0.7562714,0.8033169", "l0.7578863,0.8027025", "l0.7566978,0.8040542", "l0.7560518,0.8037031", "l0.7551733,0.8042824", "l0.7553283,0.8051601", "l0.7551087,0.8047037", "l0.7527962,0.8051952", "l0.7530287,0.8067400", "l0.7506129,0.8102509", "l0.7539331,0.8118660", "l0.7534551,0.8140603", "l0.7524732,0.8144640", "l0.7521632,0.8158860", "l0.7524345,0.8176414", "l0.7520081,0.8195724", "l0.7503932,0.8199762", "l0.7499927,0.8208013", "l0.7505095,0.8225392", "l0.7518402,0.8219774", "l0.7522278,0.8227147", "l0.7523053,0.8233291", "l0.7516593,0.8238909", "l0.7521761,0.8239786", "l0.7519306,0.8244877", "l0.7528995,0.8260501", "l0.7529383,0.8277880", "l0.7519306,0.8281566", "l0.7516851,0.8252601", "l0.7508325,0.8264187", "l0.7516076,0.8266821", "l0.7506258,0.8271560", "l0.7501994,0.8253479", "l0.7494372,0.8249090", "l0.7497344,0.8242771", "l0.7487783,0.8242771", "l0.7488300,0.8237855", "l0.7479515,0.8232765", "l0.7478998,0.8258570", "l0.7470859,0.8263134", "l0.7464787,0.8244000", "l0.7449801,0.8257868", "l0.7446571,0.8269103", "l0.7456907,0.8276300", "l0.7460524,0.8289290", "l0.7454581,0.8291573", "l0.7457940,0.8297717", "l0.7463495,0.8283849", "l0.7481582,0.8299472", "l0.7470342,0.8305441", "l0.7469309,0.8319309", "l0.7451481,0.8320362", "l0.7442954,0.8309829", "l0.7438045,0.8319484", "l0.7448897,0.8331597", "l0.7439207,0.8337566", "l0.7427322,0.8331246", "l0.7428355,0.8321766", "l0.7433652,0.8322995", "l0.7435073,0.8307021", "l0.7430681,0.8304739", "l0.7421508,0.8313340", "l0.7419053,0.8309478", "l0.7421379,0.8299121", "l0.7431327,0.8297892", "l0.7421637,0.8293328", "l0.7404842,0.8300701", "l0.7402259,0.8304914", "l0.7407685,0.8305090", "l0.7408718,0.8315973", "l0.7419441,0.8316500", "l0.7412465,0.8329666", "l0.7417503,0.8335635", "l0.7402129,0.8334581", "l0.7397478,0.8343359", "l0.7415565,0.8363546", "l0.7424867,0.8349854", "l0.7419699,0.8368286", "l0.7424350,0.8374606", "l0.7429001,0.8371973", "l0.7424479,0.8377941", "l0.7408847,0.8373728", "l0.7408201,0.8385139", "l0.7420216,0.8393916", "l0.7402000,0.8389352", "l0.7380684,0.8400762", "l0.7373449,0.8399885", "l0.7371898,0.8390405", "l0.7370219,0.8399182", "l0.7364147,0.8399885", "l0.7366731,0.8414104", "l0.7377712,0.8409715", "l0.7378746,0.8419019", "l0.7387272,0.8419721", "l0.7376808,0.8442718", "l0.7365956,0.8442016", "l0.7366860,0.8456235", "l0.7371382,0.8453953", "l0.7371253,0.8459746", "l0.7357946,0.8479934", "l0.7352778,0.8463783", "l0.7333399,0.8450617", "l0.7331720,0.8436047", "l0.7327069,0.8443947", "l0.7328490,0.8459746", "l0.7315183,0.8465188", "l0.7307174,0.8460272", "l0.7296709,0.8476247", "l0.7290637,0.8469050", "l0.7293996,0.8447984", "l0.7285340,0.8440962", "c"]}, {"n": "Guangdong", "u": "CN-44", "i": ["m0.6421307,0.9139636", "l0.6409550,0.9159648", "l0.6412263,0.9167372", "l0.6407871,0.9176149", "l0.6411488,0.9183522", "l0.6404383,0.9188613", "l0.6397794,0.9177729", "l0.6406837,0.9162808", "l0.6398311,0.9164739", "l0.6393918,0.9157015", "l0.6410067,0.9140514", "l0.6421307,0.9139636", "c", "m0.6480089,0.9111900", "l0.6489132,0.9110144", "l0.6486419,0.9097680", "l0.6479831,0.9099787", "l0.6480089,0.9111900", "c", "m0.6039804,0.9301665", "l0.6045230,0.9300963", "l0.6053886,0.9273578", "l0.6038254,0.9277615", "l0.6035799,0.9290430", "l0.6039804,0.9301665", "c", "m0.6044197,0.9353802", "l0.6051819,0.9354855", "l0.6057116,0.9338530", "l0.6050139,0.9333614", "l0.6042388,0.9346254", "l0.6044197,0.9353802", "c", "m0.6364333,0.9183522", "l0.6369889,0.9182645", "l0.6366917,0.9178783", "l0.6371180,0.9175096", "l0.6379578,0.9178607", "l0.6386425,0.9172112", "l0.6382033,0.9167723", "l0.6387588,0.9158244", "l0.6384875,0.9153153", "l0.6375056,0.9158595", "l0.6364333,0.9183522", "c", "m0.7083543,0.8704106", "l0.7093232,0.8696031", "l0.7098529,0.8700068", "l0.7105764,0.8691467", "l0.7108606,0.8716394", "l0.7125659,0.8698137", "l0.7125659,0.8698137", "l0.7102276,0.8676370", "l0.7097754,0.8647229", "l0.7089486,0.8629850", "l0.7091294,0.8606853", "l0.7082251,0.8585612", "l0.7093491,0.8562967", "l0.7083930,0.8552610", "l0.7080184,0.8518729", "l0.7068815,0.8502755", "l0.7069849,0.8491695", "l0.7054862,0.8475018", "l0.7064293,0.8451144", "l0.7061580,0.8442893", "l0.7029153,0.8449740", "l0.7016234,0.8459570", "l0.7011325,0.8434467", "l0.6999827,0.8427972", "l0.7000214,0.8420599", "l0.6992721,0.8412875", "l0.6999568,0.8403395", "l0.6995693,0.8395145", "l0.6989491,0.8396549", "l0.6981740,0.8412524", "l0.6971146,0.8414981", "l0.6972309,0.8406906", "l0.6963524,0.8397427", "l0.6942982,0.8400411", "l0.6935360,0.8388298", "l0.6912106,0.8380223", "l0.6912106,0.8380223", "l0.6915077,0.8394267", "l0.6901383,0.8388298", "l0.6891564,0.8426392", "l0.6899057,0.8440436", "l0.6893244,0.8446053", "l0.6904613,0.8470278", "l0.6885234,0.8476247", "l0.6878257,0.8462203", "l0.6861463,0.8456410", "l0.6846218,0.8423232", "l0.6836012,0.8417966", "l0.6828519,0.8419546", "l0.6826710,0.8427972", "l0.6814566,0.8424461", "l0.6786531,0.8446580", "l0.6779297,0.8436223", "l0.6758884,0.8449740", "l0.6753458,0.8446580", "l0.6746740,0.8471507", "l0.6726457,0.8458692", "l0.6720514,0.8479056", "l0.6712246,0.8467294", "l0.6701394,0.8477827", "l0.6691576,0.8473263", "l0.6675039,0.8489589", "l0.6662895,0.8465188", "l0.6654885,0.8468874", "l0.6650234,0.8455357", "l0.6633052,0.8444473", "l0.6658632,0.8426216", "l0.6659019,0.8411822", "l0.6669871,0.8394618", "l0.6669096,0.8376537", "l0.6691705,0.8359333", "l0.6696356,0.8344061", "l0.6710438,0.8345992", "l0.6714701,0.8337741", "l0.6723873,0.8335635", "l0.6721806,0.8325628", "l0.6715864,0.8322644", "l0.6725682,0.8305616", "l0.6724907,0.8296488", "l0.6719223,0.8286833", "l0.6707725,0.8284375", "l0.6691834,0.8262607", "l0.6685633,0.8271736", "l0.6675943,0.8271209", "l0.6667675,0.8287184", "l0.6654110,0.8283497", "l0.6654885,0.8291221", "l0.6642741,0.8293855", "l0.6624525,0.8288588", "l0.6609926,0.8302632", "l0.6607213,0.8295083", "l0.6610831,0.8276124", "l0.6602046,0.8266996", "l0.6603854,0.8258394", "l0.6598558,0.8253128", "l0.6598558,0.8253128", "l0.6586284,0.8258219", "l0.6575562,0.8284024", "l0.6566518,0.8284551", "l0.6564451,0.8276124", "l0.6564451,0.8276124", "l0.6535641,0.8288237", "l0.6535641,0.8288237", "l0.6535512,0.8280513", "l0.6529311,0.8275422", "l0.6513550,0.8276476", "l0.6501535,0.8266996", "l0.6499338,0.8257517", "l0.6491329,0.8255586", "l0.6489649,0.8237680", "l0.6487065,0.8242771", "l0.6479185,0.8238909", "l0.6467299,0.8245579", "l0.6462131,0.8264012", "l0.6457610,0.8262783", "l0.6443786,0.8279987", "l0.6432159,0.8281742", "l0.6429575,0.8289817", "l0.6418465,0.8283146", "l0.6419498,0.8304036", "l0.6437714,0.8302456", "l0.6446499,0.8316851", "l0.6435518,0.8326155", "l0.6443011,0.8343885", "l0.6437327,0.8358105", "l0.6443269,0.8369339", "l0.6442107,0.8381277", "l0.6418335,0.8389352", "l0.6405029,0.8389352", "l0.6405287,0.8378643", "l0.6399086,0.8373553", "l0.6398698,0.8364073", "l0.6392626,0.8361615", "l0.6395856,0.8349503", "l0.6385004,0.8332124", "l0.6366142,0.8333177", "l0.6353223,0.8327735", "l0.6350381,0.8319835", "l0.6342629,0.8329491", "l0.6336945,0.8317378", "l0.6320279,0.8325277", "l0.6311881,0.8314920", "l0.6302451,0.8359684", "l0.6296766,0.8368111", "l0.6306068,0.8384963", "l0.6303096,0.8403395", "l0.6294699,0.8405326", "l0.6281392,0.8427621", "l0.6281392,0.8427621", "l0.6271057,0.8433414", "l0.6265889,0.8454128", "l0.6278162,0.8473965", "l0.6275579,0.8493451", "l0.6287723,0.8520485", "l0.6274416,0.8544008", "l0.6270282,0.8542077", "l0.6256717,0.8555594", "l0.6257492,0.8584910", "l0.6266018,0.8614402", "l0.6253745,0.8618791", "l0.6255296,0.8625988", "l0.6247027,0.8633536", "l0.6245865,0.8651267", "l0.6228811,0.8644771", "l0.6219897,0.8650038", "l0.6214988,0.8671279", "l0.6222998,0.8675492", "l0.6214988,0.8692169", "l0.6194059,0.8695329", "l0.6192767,0.8715692", "l0.6179977,0.8734124", "l0.6173259,0.8765898", "l0.6177005,0.8772218", "l0.6172613,0.8778186", "l0.6179331,0.8806976", "l0.6176101,0.8824355", "l0.6184628,0.8837872", "l0.6173130,0.8855602", "l0.6175972,0.8863151", "l0.6172742,0.8872806", "l0.6149875,0.8906862", "l0.6124037,0.8911426", "l0.6129205,0.8919677", "l0.6123649,0.8929858", "l0.6107630,0.8932491", "l0.6105821,0.8939689", "l0.6085150,0.8946360", "l0.6082437,0.8952328", "l0.6076753,0.8946886", "l0.6072619,0.8974271", "l0.6063058,0.8973394", "l0.6067322,0.8979889", "l0.6067451,0.8998497", "l0.6072231,0.8999023", "l0.6079724,0.9018158", "l0.6070164,0.9015174", "l0.6065126,0.9019913", "l0.6057632,0.9030446", "l0.6061896,0.9041330", "l0.6055565,0.9050107", "l0.6044584,0.9039399", "l0.6034249,0.9050634", "l0.6020038,0.9036239", "l0.6012932,0.9045894", "l0.6007119,0.9039926", "l0.6004535,0.9046772", "l0.6011253,0.9055198", "l0.6009186,0.9088727", "l0.6013836,0.9095574", "l0.6013061,0.9112602", "l0.6004922,0.9112777", "l0.6000142,0.9106107", "l0.5991486,0.9114884", "l0.5971203,0.9109793", "l0.5960997,0.9118044", "l0.5948466,0.9114357", "l0.5941360,0.9126821", "l0.5935417,0.9167197", "l0.5918751,0.9171410", "l0.5914101,0.9163159", "l0.5910871,0.9187560", "l0.5910871,0.9187560", "l0.5919397,0.9213014", "l0.5935288,0.9214770", "l0.5936580,0.9221265", "l0.5942523,0.9217929", "l0.5936709,0.9224600", "l0.5937743,0.9237591", "l0.5912550,0.9240224", "l0.5914488,0.9270769", "l0.5898727,0.9294292", "l0.5904670,0.9308160", "l0.5897176,0.9346254", "l0.5914230,0.9391896", "l0.5909708,0.9409450", "l0.5918364,0.9410679", "l0.5923532,0.9421914", "l0.5924048,0.9440346", "l0.5935676,0.9442804", "l0.5948078,0.9455619", "l0.5954667,0.9453863", "l0.5948466,0.9468258", "l0.5936322,0.9455970", "l0.5934384,0.9463518", "l0.5928182,0.9462992", "l0.5939939,0.9478791", "l0.5938776,0.9506176", "l0.5949757,0.9489324", "l0.5953762,0.9495994", "l0.5961256,0.9489675", "l0.5973141,0.9501436", "l0.5981668,0.9502490", "l0.5983735,0.9494063", "l0.6001692,0.9497750", "l0.6023397,0.9481249", "l0.6038770,0.9446315", "l0.6031923,0.9426303", "l0.6027402,0.9399620", "l0.6017712,0.9403131", "l0.6009573,0.9396635", "l0.6006473,0.9394178", "l0.6005439,0.9384347", "l0.6014999,0.9391369", "l0.6014870,0.9365388", "l0.6005051,0.9357313", "l0.5983735,0.9355733", "l0.5978567,0.9326417", "l0.5986319,0.9311671", "l0.5991616,0.9316586", "l0.5999884,0.9300436", "l0.6000788,0.9307809", "l0.5985027,0.9328875", "l0.5985027,0.9336072", "l0.6008798,0.9323959", "l0.6027789,0.9323959", "l0.6037608,0.9340285", "l0.6041354,0.9306931", "l0.6022492,0.9310618", "l0.6016937,0.9300436", "l0.6005568,0.9305527", "l0.6005697,0.9298154", "l0.6020038,0.9277264", "l0.6033474,0.9270067", "l0.6038254,0.9273929", "l0.6055307,0.9269013", "l0.6078303,0.9228989", "l0.6097036,0.9231973", "l0.6128688,0.9213014", "l0.6124554,0.9207397", "l0.6117577,0.9210556", "l0.6115510,0.9204237", "l0.6120549,0.9198268", "l0.6127654,0.9201779", "l0.6131788,0.9214243", "l0.6162278,0.9206870", "l0.6157368,0.9225127", "l0.6188374,0.9190193", "l0.6192767,0.9203886", "l0.6212792,0.9197039", "l0.6220801,0.9201253", "l0.6228424,0.9181942", "l0.6243152,0.9167372", "l0.6243927,0.9154733", "l0.6228553,0.9145078", "l0.6229199,0.9139811", "l0.6244831,0.9138583", "l0.6255296,0.9164563", "l0.6264081,0.9159648", "l0.6260851,0.9170181", "l0.6252066,0.9169128", "l0.6254520,0.9178432", "l0.6247802,0.9190544", "l0.6255812,0.9189842", "l0.6264339,0.9179485", "l0.6281521,0.9172814", "l0.6276741,0.9167021", "l0.6267181,0.9168425", "l0.6264210,0.9159121", "l0.6267310,0.9153153", "l0.6298058,0.9133141", "l0.6310719,0.9134194", "l0.6312398,0.9146131", "l0.6321571,0.9156488", "l0.6344438,0.9148238", "l0.6347538,0.9126645", "l0.6370276,0.9142093", "l0.6378157,0.9141216", "l0.6407612,0.9098031", "l0.6420402,0.9102771", "l0.6420144,0.9111022", "l0.6429446,0.9119975", "l0.6446628,0.9097329", "l0.6442882,0.9061518", "l0.6455672,0.9045368", "l0.6455930,0.9032202", "l0.6460839,0.9050107", "l0.6459160,0.9068540", "l0.6472596,0.9096276", "l0.6482931,0.9084163", "l0.6481510,0.9075386", "l0.6485903,0.9071699", "l0.6491716,0.9084514", "l0.6502181,0.9087674", "l0.6509415,0.9068891", "l0.6503473,0.9064151", "l0.6503343,0.9053443", "l0.6509286,0.9046947", "l0.6506702,0.9040101", "l0.6509674,0.9037995", "l0.6523110,0.9068013", "l0.6530861,0.9058534", "l0.6525823,0.9044665", "l0.6537579,0.9027813", "l0.6534349,0.9013594", "l0.6540680,0.9008854", "l0.6538096,0.9000779", "l0.6543780,0.8995512", "l0.6530474,0.8991475", "l0.6530603,0.8982698", "l0.6549077,0.8941444", "l0.6533057,0.8909495", "l0.6542618,0.8903877", "l0.6538096,0.8896504", "l0.6541326,0.8892818", "l0.6550240,0.8899664", "l0.6550757,0.8907388", "l0.6557862,0.8904580", "l0.6564839,0.8910022", "l0.6579825,0.8952153", "l0.6588739,0.8958297", "l0.6582409,0.8966372", "l0.6586414,0.8976202", "l0.6594553,0.8960403", "l0.6611735,0.8964792", "l0.6611735,0.8964792", "l0.6631243,0.8951275", "l0.6641837,0.8955312", "l0.6641837,0.8955312", "l0.6649718,0.8944780", "l0.6669484,0.8938811", "l0.6684082,0.8957419", "l0.6686666,0.8977958", "l0.6704495,0.8966547", "l0.6702557,0.8956190", "l0.6693901,0.8948817", "l0.6686279,0.8952855", "l0.6687958,0.8943551", "l0.6694289,0.8942673", "l0.6702040,0.8928981", "l0.6686537,0.8930560", "l0.6689896,0.8916166", "l0.6698294,0.8920905", "l0.6697260,0.8907739", "l0.6718060,0.8895627", "l0.6729687,0.8897382", "l0.6732271,0.8885094", "l0.6739247,0.8896329", "l0.6725941,0.8907739", "l0.6725424,0.8940040", "l0.6748678,0.8943551", "l0.6748937,0.8955137", "l0.6754492,0.8951099", "l0.6753717,0.8934071", "l0.6762631,0.8921081", "l0.6754750,0.8911953", "l0.6749195,0.8915288", "l0.6745061,0.8901595", "l0.6752812,0.8906160", "l0.6758497,0.8901244", "l0.6764440,0.8920554", "l0.6772320,0.8916166", "l0.6770253,0.8910724", "l0.6776454,0.8896504", "l0.6791957,0.8890536", "l0.6796996,0.8899138", "l0.6796867,0.8887903", "l0.6802551,0.8885621", "l0.6809398,0.8888254", "l0.6805264,0.8898084", "l0.6836399,0.8896856", "l0.6832524,0.8906335", "l0.6824643,0.8903526", "l0.6825160,0.8914761", "l0.6829940,0.8920203", "l0.6844151,0.8916692", "l0.6860429,0.8929683", "l0.6859137,0.8916868", "l0.6865984,0.8905282", "l0.6858233,0.8904931", "l0.6856682,0.8914761", "l0.6851902,0.8904228", "l0.6871410,0.8876668", "l0.6880454,0.8875263", "l0.6881487,0.8881583", "l0.6891177,0.8882636", "l0.6900608,0.8907739", "l0.6911847,0.8893345", "l0.6915206,0.8896153", "l0.6929676,0.8885270", "l0.6943112,0.8881934", "l0.6946341,0.8888956", "l0.6953189,0.8884392", "l0.6977347,0.8855778", "l0.6991946,0.8862800", "l0.7011842,0.8860518", "l0.7021918,0.8839452", "l0.7017526,0.8816280", "l0.7021402,0.8806625", "l0.7025923,0.8800832", "l0.7036776,0.8805747", "l0.7047240,0.8786964", "l0.7059901,0.8794688", "l0.7062614,0.8788017", "l0.7057705,0.8787315", "l0.7053183,0.8763265", "l0.7070495,0.8741673", "l0.7075016,0.8712181", "l0.7087935,0.8714112", "l0.7083543,0.8704106", "c", "m0.7097366,0.8741673", "l0.7091682,0.8736055", "l0.7085481,0.8744657", "l0.7115324,0.8753259", "l0.7119846,0.8739917", "l0.7115582,0.8730613", "l0.7097366,0.8741673", "c"]}, {"n": "Gansu", "u": "CN-62", "i": ["m0.3860600,0.3600805", "l0.3967571,0.3932938", "l0.3931785,0.3981915", "l0.3930364,0.3992097", "l0.3989275,0.4098654", "l0.3994314,0.4095845", "l0.4031262,0.4141311", "l0.4048057,0.4151844", "l0.4051158,0.4161148", "l0.4054000,0.4174489", "l0.4035526,0.4265422", "l0.4099476,0.4260507", "l0.4135520,0.4199066", "l0.4186163,0.4166414", "l0.4249725,0.4170979", "l0.4267554,0.4146402", "l0.4322719,0.4154126", "l0.4335509,0.4160972", "l0.4357213,0.4208019", "l0.4359280,0.4243304", "l0.4323494,0.4302463", "l0.4305019,0.4356180", "l0.4257994,0.4399013", "l0.4230863,0.4453081", "l0.4281765,0.4450272", "l0.4322331,0.4492228", "l0.4361088,0.4507325", "l0.4369486,0.4524353", "l0.4372457,0.4555776", "l0.4402042,0.4566835", "l0.4401784,0.4590183", "l0.4458628,0.4590534", "l0.4455398,0.4643373", "l0.4460824,0.4670056", "l0.4456949,0.4682520", "l0.4459403,0.4700426", "l0.4473614,0.4690420", "l0.4486017,0.4715874", "l0.4519348,0.4696915", "l0.4512113,0.4716576", "l0.4518961,0.4720965", "l0.4523095,0.4739924", "l0.4537564,0.4746594", "l0.4536918,0.4765378", "l0.4569991,0.4781528", "l0.4584073,0.4799609", "l0.4593763,0.4791007", "l0.4605390,0.4791359", "l0.4610299,0.4798731", "l0.4622831,0.4794518", "l0.4624510,0.4781879", "l0.4659779,0.4733077", "l0.4616500,0.4674620", "l0.4679417,0.4655135", "l0.4721145,0.4631436", "l0.4745821,0.4651975", "l0.4810288,0.4674620", "l0.4830183,0.4646006", "l0.4851500,0.4633016", "l0.4868941,0.4605104", "l0.4946585,0.4572804", "l0.4963638,0.4571224", "l0.4988055,0.4584565", "l0.4981725,0.4618972", "l0.5006788,0.4677254", "l0.5001620,0.4720438", "l0.4978366,0.4734657", "l0.4952915,0.4804349", "l0.4877209,0.4871408", "l0.4888965,0.4894229", "l0.4898784,0.4942504", "l0.4869070,0.4960585", "l0.4876951,0.5028697", "l0.4919067,0.5045900", "l0.4955499,0.5100144", "l0.5002266,0.5151228", "l0.5018674,0.5145611", "l0.5018674,0.5145611", "l0.5041282,0.5151228", "l0.5050584,0.5141924", "l0.5081590,0.5151228", "l0.5093217,0.5147542", "l0.5082882,0.5163516", "l0.5088954,0.5170714", "l0.5070092,0.5188619", "l0.5075389,0.5201785", "l0.5083011,0.5210738", "l0.5088825,0.5209334", "l0.5101356,0.5195466", "l0.5111692,0.5203716", "l0.5121769,0.5236895", "l0.5131846,0.5251640", "l0.5163885,0.5267791", "l0.5166986,0.5295176", "l0.5173058,0.5292367", "l0.5180938,0.5299916", "l0.5190369,0.5321859", "l0.5184685,0.5332743", "l0.5169182,0.5343276", "l0.5179517,0.5381896", "l0.5176287,0.5390673", "l0.5192953,0.5400152", "l0.5201997,0.5440177", "l0.5213365,0.5458785", "l0.5211298,0.5474057", "l0.5218791,0.5498809", "l0.5216078,0.5511273", "l0.5205356,0.5511800", "l0.5189336,0.5534796", "l0.5190240,0.5568677", "l0.5200446,0.5578332", "l0.5196700,0.5592551", "l0.5204968,0.5588162", "l0.5210136,0.5606419", "l0.5216208,0.5614143", "l0.5226414,0.5613792", "l0.5228352,0.5624149", "l0.5241400,0.5609052", "l0.5258582,0.5611686", "l0.5258582,0.5619234", "l0.5251864,0.5616250", "l0.5249281,0.5623974", "l0.5265688,0.5656274", "l0.5269822,0.5655572", "l0.5273698,0.5677164", "l0.5281966,0.5661014", "l0.5302766,0.5668036", "l0.5302508,0.5675760", "l0.5313876,0.5674531", "l0.5307675,0.5687170", "l0.5308580,0.5677866", "l0.5283516,0.5684888", "l0.5283646,0.5698581", "l0.5312585,0.5685942", "l0.5308838,0.5694368", "l0.5317494,0.5712976", "l0.5328217,0.5692437", "l0.5330930,0.5699810", "l0.5338035,0.5699634", "l0.5340361,0.5718769", "l0.5358706,0.5746856", "l0.5381056,0.5713502", "l0.5382219,0.5689979", "l0.5376534,0.5687346", "l0.5378214,0.5681026", "l0.5372013,0.5668036", "l0.5377697,0.5652412", "l0.5371367,0.5622569", "l0.5387903,0.5608877", "l0.5404311,0.5618707", "l0.5411029,0.5615021", "l0.5419943,0.5625729", "l0.5422656,0.5613617", "l0.5432345,0.5617127", "l0.5435446,0.5607999", "l0.5441259,0.5609228", "l0.5442293,0.5599748", "l0.5447719,0.5601504", "l0.5445781,0.5591147", "l0.5450432,0.5591673", "l0.5437900,0.5569379", "l0.5452241,0.5557617", "l0.5445264,0.5552878", "l0.5453662,0.5542345", "l0.5453533,0.5502847", "l0.5448236,0.5506358", "l0.5434154,0.5476164", "l0.5423431,0.5479675", "l0.5409866,0.5465631", "l0.5400564,0.5466684", "l0.5391779,0.5459136", "l0.5388549,0.5468967", "l0.5379506,0.5465456", "l0.5376018,0.5454923", "l0.5382348,0.5458609", "l0.5383382,0.5433682", "l0.5377955,0.5425607", "l0.5383252,0.5408403", "l0.5357414,0.5383124", "l0.5372529,0.5385231", "l0.5370333,0.5369607", "l0.5377180,0.5365921", "l0.5383898,0.5339414", "l0.5394104,0.5333445", "l0.5404569,0.5341345", "l0.5401339,0.5333796", "l0.5406248,0.5314661", "l0.5400435,0.5303251", "l0.5403923,0.5295527", "l0.5396301,0.5293245", "l0.5386741,0.5270248", "l0.5393588,0.5280606", "l0.5397076,0.5273233", "l0.5403019,0.5274988", "l0.5404698,0.5249007", "l0.5398368,0.5227240", "l0.5416842,0.5231102", "l0.5421881,0.5239352", "l0.5427177,0.5221271", "l0.5444618,0.5235666", "l0.5445523,0.5223378", "l0.5464901,0.5233735", "l0.5467356,0.5227064", "l0.5477950,0.5229873", "l0.5489060,0.5223202", "l0.5507147,0.5241634", "l0.5507147,0.5241634", "l0.5512573,0.5287627", "l0.5541383,0.5290436", "l0.5550555,0.5312028", "l0.5568771,0.5315188", "l0.5573422,0.5310799", "l0.5578202,0.5318699", "l0.5609079,0.5330636", "l0.5617477,0.5359250", "l0.5627812,0.5352579", "l0.5629233,0.5359777", "l0.5624711,0.5364341", "l0.5632075,0.5375400", "l0.5640344,0.5374172", "l0.5650162,0.5385582", "l0.5661014,0.5365745", "l0.5660756,0.5382598", "l0.5674579,0.5389971", "l0.5682202,0.5386811", "l0.5695896,0.5419814", "l0.5709461,0.5408930", "l0.5741888,0.5438070", "l0.5738271,0.5459311", "l0.5731424,0.5467562", "l0.5741630,0.5501443", "l0.5737754,0.5533392", "l0.5731940,0.5553229", "l0.5720184,0.5553404", "l0.5707265,0.5570432", "l0.5711528,0.5587109", "l0.5711270,0.5635560", "l0.5727031,0.5661014", "l0.5724835,0.5717891", "l0.5721476,0.5726142", "l0.5705585,0.5733339", "l0.5686207,0.5732461", "l0.5681943,0.5727019", "l0.5664632,0.5738781", "l0.5662823,0.5730881", "l0.5654296,0.5726668", "l0.5619156,0.5744925", "l0.5618769,0.5738430", "l0.5603912,0.5740185", "l0.5590605,0.5728599", "l0.5581691,0.5728073", "l0.5579107,0.5742292", "l0.5568771,0.5744398", "l0.5584791,0.5786003", "l0.5602232,0.5810930", "l0.5593835,0.5821990", "l0.5566704,0.5829714", "l0.5564250,0.5820234", "l0.5555594,0.5817952", "l0.5549005,0.5834102", "l0.5510377,0.5827432", "l0.5506760,0.5836560", "l0.5495003,0.5842002", "l0.5490223,0.5827081", "l0.5477433,0.5818303", "l0.5476658,0.5804611", "l0.5465289,0.5801100", "l0.5449269,0.5784774", "l0.5388808,0.5786705", "l0.5378989,0.5809526", "l0.5379506,0.5826027", "l0.5392037,0.5859908", "l0.5386353,0.5868685", "l0.5389195,0.5876936", "l0.5381573,0.5878340", "l0.5372013,0.5892208", "l0.5374080,0.5907130", "l0.5367749,0.5905550", "l0.5350179,0.5923104", "l0.5354959,0.5938903", "l0.5364261,0.5941888", "l0.5375113,0.5936446", "l0.5387645,0.5948910", "l0.5392296,0.5947330", "l0.5404311,0.5973311", "l0.5416196,0.5978401", "l0.5408832,0.6011931", "l0.5395784,0.6010702", "l0.5393200,0.6002978", "l0.5384932,0.5999994", "l0.5380023,0.6010000", "l0.5380927,0.6014915", "l0.5388937,0.6013159", "l0.5395784,0.6040369", "l0.5380927,0.6050024", "l0.5376664,0.6084958", "l0.5367491,0.6106199", "l0.5368525,0.6113396", "l0.5375630,0.6112343", "l0.5379506,0.6118838", "l0.5374080,0.6133057", "l0.5378343,0.6139026", "l0.5377697,0.6155878", "l0.5387128,0.6160092", "l0.5395009,0.6188881", "l0.5384544,0.6210824", "l0.5381185,0.6203276", "l0.5373563,0.6202047", "l0.5369429,0.6179226", "l0.5356380,0.6187652", "l0.5346045,0.6183966", "l0.5329509,0.6198361", "l0.5316719,0.6192568", "l0.5315944,0.6181859", "l0.5292431,0.6182035", "l0.5273569,0.6212404", "l0.5270856,0.6242423", "l0.5251477,0.6242247", "l0.5265688,0.6274197", "l0.5285584,0.6279990", "l0.5293335,0.6288767", "l0.5292947,0.6304215", "l0.5288167,0.6291927", "l0.5282225,0.6304039", "l0.5287909,0.6305093", "l0.5285584,0.6344239", "l0.5276540,0.6358634", "l0.5270856,0.6355474", "l0.5239979,0.6374258", "l0.5217241,0.6366709", "l0.5217241,0.6366709", "l0.5207552,0.6361970", "l0.5197992,0.6376013", "l0.5210394,0.6411649", "l0.5182747,0.6434119", "l0.5172928,0.6430959", "l0.5168019,0.6443072", "l0.5154971,0.6449743", "l0.5142827,0.6435875", "l0.5117247,0.6448514", "l0.5108462,0.6431837", "l0.5093088,0.6437981", "l0.5086499,0.6428326", "l0.5076552,0.6431310", "l0.5065829,0.6413756", "l0.5047096,0.6408840", "l0.5030947,0.6390057", "l0.5022162,0.6387424", "l0.5017640,0.6372853", "l0.5019707,0.6358459", "l0.5032626,0.6357581", "l0.5035339,0.6344239", "l0.5042445,0.6338798", "l0.5027588,0.6331600", "l0.5034435,0.6313870", "l0.5022679,0.6263313", "l0.5038311,0.6267877", "l0.5042962,0.6258397", "l0.5033789,0.6251727", "l0.5020999,0.6254887", "l0.5016348,0.6239263", "l0.5008597,0.6236805", "l0.4998132,0.6200116", "l0.5000458,0.6181859", "l0.4980304,0.6161320", "l0.4934958,0.6168693", "l0.4905631,0.6154299", "l0.4897880,0.6165358", "l0.4891549,0.6162900", "l0.4888449,0.6149032", "l0.4896200,0.6136744", "l0.4892195,0.6128493", "l0.4885348,0.6130600", "l0.4880051,0.6144292", "l0.4866615,0.6146223", "l0.4834446,0.6128493", "l0.4839097,0.6104443", "l0.4828891,0.6088118", "l0.4834834,0.6076707", "l0.4829925,0.6062488", "l0.4837289,0.6053360", "l0.4830312,0.6046864", "l0.4827341,0.6030890", "l0.4806670,0.6025799", "l0.4801373,0.5999994", "l0.4792072,0.5993849", "l0.4784320,0.6005260", "l0.4775148,0.6001222", "l0.4765975,0.6007191", "l0.4759645,0.6024570", "l0.4745692,0.6035103", "l0.4753831,0.6056168", "l0.4716236,0.6054237", "l0.4709647,0.6085484", "l0.4690527,0.6080745", "l0.4685876,0.6089171", "l0.4676833,0.6091102", "l0.4688072,0.6117434", "l0.4685101,0.6133760", "l0.4698408,0.6141308", "l0.4694403,0.6154299", "l0.4702025,0.6148857", "l0.4697891,0.6165534", "l0.4701379,0.6179226", "l0.4719208,0.6190461", "l0.4724504,0.6220655", "l0.4721145,0.6218373", "l0.4721404,0.6223464", "l0.4704609,0.6239438", "l0.4689235,0.6232417", "l0.4675799,0.6254535", "l0.4682000,0.6261382", "l0.4679158,0.6284554", "l0.4663784,0.6272266", "l0.4657712,0.6291751", "l0.4643372,0.6290347", "l0.4625931,0.6314046", "l0.4617792,0.6310535", "l0.4619859,0.6290171", "l0.4609007,0.6275425", "l0.4625285,0.6260153", "l0.4627352,0.6242598", "l0.4636654,0.6225570", "l0.4630453,0.6214686", "l0.4631228,0.6199238", "l0.4619988,0.6180806", "l0.4613916,0.6179051", "l0.4614950,0.6193621", "l0.4609782,0.6198361", "l0.4609782,0.6198361", "l0.4603323,0.6210473", "l0.4586269,0.6210824", "l0.4579681,0.6165358", "l0.4565470,0.6157283", "l0.4553713,0.6159741", "l0.4548158,0.6171678", "l0.4522707,0.6162900", "l0.4510951,0.6169220", "l0.4515472,0.6134286", "l0.4508496,0.6120594", "l0.4493510,0.6116381", "l0.4481495,0.6104092", "l0.4453460,0.6039140", "l0.4445321,0.6030363", "l0.4453848,0.5993147", "l0.4462504,0.5988232", "l0.4466638,0.5976997", "l0.4480978,0.5977875", "l0.4491960,0.5991392", "l0.4525679,0.5998414", "l0.4536014,0.6005962", "l0.4535756,0.6012106", "l0.4584202,0.6029310", "l0.4590533,0.6038614", "l0.4589628,0.6045987", "l0.4597767,0.6046338", "l0.4603839,0.6057748", "l0.4609007,0.6045284", "l0.4620376,0.6044582", "l0.4622185,0.6037912", "l0.4638334,0.6049673", "l0.4639496,0.6035629", "l0.4645568,0.6034401", "l0.4648669,0.6017724", "l0.4655129,0.6016846", "l0.4657066,0.6001749", "l0.4670373,0.6006313", "l0.4676316,0.5982614", "l0.4687685,0.5982614", "l0.4672957,0.5955054", "l0.4671536,0.5942239", "l0.4659133,0.5933110", "l0.4646731,0.5933110", "l0.4634975,0.5919945", "l0.4632262,0.5897826", "l0.4618309,0.5910816", "l0.4600739,0.5890102", "l0.4617275,0.5881500", "l0.4620893,0.5870967", "l0.4632649,0.5879569", "l0.4633037,0.5842704", "l0.4644406,0.5838316", "l0.4644147,0.5827432", "l0.4655774,0.5824799", "l0.4667660,0.5806015", "l0.4682388,0.5794605", "l0.4692207,0.5794605", "l0.4701638,0.5766693", "l0.4710423,0.5763708", "l0.4709389,0.5746154", "l0.4703575,0.5742643", "l0.4703317,0.5734041", "l0.4691819,0.5727370", "l0.4697503,0.5718769", "l0.4692723,0.5707358", "l0.4695049,0.5694017", "l0.4716495,0.5694017", "l0.4734065,0.5657503", "l0.4741429,0.5664349", "l0.4764295,0.5667685", "l0.4770238,0.5642757", "l0.4759515,0.5611159", "l0.4758999,0.5593078", "l0.4774502,0.5576752", "l0.4801503,0.5583774", "l0.4799694,0.5554457", "l0.4804474,0.5528126", "l0.4790263,0.5515135", "l0.4798919,0.5509869", "l0.4808350,0.5484590", "l0.4819848,0.5481781", "l0.4813517,0.5468967", "l0.4782641,0.5445268", "l0.4764037,0.5370485", "l0.4749955,0.5361883", "l0.4743883,0.5345733", "l0.4744658,0.5338887", "l0.4764812,0.5328881", "l0.4749180,0.5302373", "l0.4738586,0.5295527", "l0.4736261,0.5285345", "l0.4720887,0.5271302", "l0.4727347,0.5256556", "l0.4726184,0.5239879", "l0.4742979,0.5218287", "l0.4725021,0.5202663", "l0.4716624,0.5184055", "l0.4705384,0.5186513", "l0.4703188,0.5172645", "l0.4680579,0.5147015", "l0.4679158,0.5151579", "l0.4664172,0.5136833", "l0.4648669,0.5132796", "l0.4659004,0.5105059", "l0.4646085,0.5094527", "l0.4642726,0.5050816", "l0.4624769,0.5077674", "l0.4619730,0.5122087", "l0.4606682,0.5117874", "l0.4600480,0.5100320", "l0.4588078,0.5096282", "l0.4539890,0.5042565", "l0.4515472,0.5027293", "l0.4499194,0.5001663", "l0.4475423,0.4984108", "l0.4469222,0.4988672", "l0.4454236,0.4972171", "l0.4423100,0.4957074", "l0.4417028,0.4916698", "l0.4399975,0.4905990", "l0.4394162,0.4910905", "l0.4390415,0.4902304", "l0.4374266,0.4896335", "l0.4369357,0.4878254", "l0.4362380,0.4881589", "l0.4355662,0.4857715", "l0.4338351,0.4847884", "l0.4339255,0.4863157", "l0.4333441,0.4870881", "l0.4340289,0.4890367", "l0.4346361,0.4893702", "l0.4348428,0.4925125", "l0.4333571,0.4907219", "l0.4267554,0.4863332", "l0.4243524,0.4832261", "l0.4239519,0.4813477", "l0.4229830,0.4815759", "l0.4215748,0.4783810", "l0.4167947,0.4733077", "l0.4174277,0.4717629", "l0.4160454,0.4708676", "l0.4156061,0.4715172", "l0.4127252,0.4679887", "l0.4117821,0.4679887", "l0.4088623,0.4722720", "l0.4082681,0.4716927", "l0.4068211,0.4717278", "l0.4056196,0.4695510", "l0.4040952,0.4693404", "l0.4037722,0.4716751", "l0.4008008,0.4761691", "l0.3996122,0.4744137", "l0.3944833,0.4714294", "l0.3941216,0.4700952", "l0.3912019,0.4681642", "l0.3886955,0.4656364", "l0.3834633,0.4646006", "l0.3821326,0.4673743", "l0.3830111,0.4688313", "l0.3829336,0.4723773", "l0.3823522,0.4737993", "l0.3829207,0.4746243", "l0.3825331,0.4754669", "l0.3828432,0.4787497", "l0.3820163,0.4795396", "l0.3820551,0.4811020", "l0.3829207,0.4819797", "l0.3823910,0.4890893", "l0.3799363,0.4885627", "l0.3781535,0.4866668", "l0.3769391,0.4868072", "l0.3755955,0.4860348", "l0.3751175,0.4853853", "l0.3752725,0.4835596", "l0.3719265,0.4806631", "l0.3704278,0.4811897", "l0.3690067,0.4796800", "l0.3682574,0.4803822", "l0.3675727,0.4794518", "l0.3674306,0.4776964", "l0.3650793,0.4769240", "l0.3630122,0.4739046", "l0.3628185,0.4745365", "l0.3616299,0.4737641", "l0.3599762,0.4712889", "l0.3597049,0.4700075", "l0.3586197,0.4698144", "l0.3572115,0.4683573", "l0.3551574,0.4646006", "l0.3529611,0.4653555", "l0.3491371,0.4634947", "l0.3488012,0.4641091", "l0.3460365,0.4635649", "l0.3443570,0.4616164", "l0.3386467,0.4616339", "l0.3382075,0.4607035", "l0.3364634,0.4613530", "l0.3361533,0.4623010", "l0.3341250,0.4628101", "l0.3320967,0.4630383", "l0.3314120,0.4623010", "l0.3292028,0.4631085", "l0.3258180,0.4621254", "l0.3249007,0.4640389", "l0.3226657,0.4642847", "l0.3201594,0.4657241", "l0.3196039,0.4651624", "l0.3184153,0.4660752", "l0.3173430,0.4661805", "l0.3169425,0.4654959", "l0.3169425,0.4654959", "l0.3165420,0.4620201", "l0.3169167,0.4610195", "l0.3168263,0.4573681", "l0.3157023,0.4547174", "l0.3138936,0.4452028", "l0.3164128,0.4387427", "l0.3163353,0.4273146", "l0.3235184,0.4280695", "l0.3281822,0.4239617", "l0.3309211,0.4162903", "l0.3341121,0.4100585", "l0.3408817,0.4011758", "l0.3451709,0.3943822", "l0.3517209,0.3897302", "l0.3592011,0.3875008", "l0.3616041,0.3884487", "l0.3644334,0.3879045", "l0.3665521,0.3863071", "l0.3676115,0.3828839", "l0.3671335,0.3798645", "l0.3682962,0.3652591", "l0.3726758,0.3617306", "l0.3726758,0.3617306", "l0.3777401,0.3609582", "l0.3819517,0.3618710", "c"]}, {"n": "Guangxi Zhuang", "u": "CN-45", "i": ["m0.5867462,0.8111989", "l0.5874956,0.8120240", "l0.5893301,0.8107951", "l0.5895109,0.8115500", "l0.5906607,0.8123048", "l0.5896660,0.8148502", "l0.5910612,0.8146220", "l0.5917330,0.8151662", "l0.5923661,0.8139550", "l0.5917976,0.8114798", "l0.5921723,0.8109005", "l0.5930637,0.8111462", "l0.5936838,0.8083375", "l0.5946528,0.8070911", "l0.5956475,0.8080566", "l0.5966036,0.8077757", "l0.5963064,0.8108478", "l0.5977275,0.8114798", "l0.5983993,0.8102509", "l0.5992003,0.8113744", "l0.5993295,0.8128490", "l0.6005051,0.8125330", "l0.6013449,0.8096190", "l0.6028823,0.8075475", "l0.6034766,0.8075826", "l0.6040450,0.8054761", "l0.6046005,0.8054234", "l0.6051948,0.8037206", "l0.6067968,0.8047563", "l0.6073006,0.8042122", "l0.6071456,0.8053181", "l0.6076236,0.8058096", "l0.6098586,0.8052128", "l0.6102333,0.8056692", "l0.6105175,0.8029307", "l0.6110213,0.8024918", "l0.6114606,0.8040717", "l0.6142124,0.8044930", "l0.6148067,0.8054234", "l0.6158144,0.8054761", "l0.6161761,0.8057745", "l0.6158531,0.8087764", "l0.6147808,0.8118484", "l0.6150780,0.8145518", "l0.6160727,0.8156051", "l0.6168608,0.8144465", "l0.6194963,0.8153242", "l0.6183982,0.8160440", "l0.6186436,0.8176063", "l0.6164345,0.8189931", "l0.6165120,0.8208013", "l0.6170029,0.8216790", "l0.6163053,0.8256288", "l0.6130755,0.8295083", "l0.6131530,0.8311760", "l0.6114089,0.8325453", "l0.6105950,0.8352136", "l0.6107630,0.8364424", "l0.6114089,0.8383383", "l0.6122487,0.8382330", "l0.6130497,0.8378117", "l0.6130755,0.8357051", "l0.6144837,0.8348274", "l0.6158402,0.8329139", "l0.6170675,0.8340901", "l0.6179073,0.8332650", "l0.6185791,0.8340023", "l0.6182819,0.8353891", "l0.6190958,0.8359158", "l0.6184886,0.8370568", "l0.6191217,0.8381101", "l0.6187858,0.8398656", "l0.6192767,0.8413050", "l0.6185920,0.8444473", "l0.6206461,0.8452197", "l0.6210724,0.8439031", "l0.6218864,0.8441489", "l0.6219380,0.8429552", "l0.6229716,0.8416737", "l0.6257104,0.8423232", "l0.6271445,0.8420423", "l0.6281263,0.8427796", "l0.6281263,0.8427796", "l0.6270928,0.8433589", "l0.6265760,0.8454304", "l0.6278033,0.8474141", "l0.6275449,0.8493626", "l0.6287593,0.8520660", "l0.6274287,0.8544183", "l0.6270153,0.8542252", "l0.6256587,0.8555769", "l0.6257363,0.8585086", "l0.6265889,0.8614577", "l0.6253616,0.8618966", "l0.6255166,0.8626163", "l0.6246898,0.8633712", "l0.6245735,0.8651442", "l0.6228682,0.8644947", "l0.6219768,0.8650213", "l0.6214859,0.8671454", "l0.6222868,0.8675667", "l0.6214859,0.8692344", "l0.6193930,0.8695504", "l0.6192638,0.8715868", "l0.6179848,0.8734300", "l0.6173130,0.8766074", "l0.6176876,0.8772393", "l0.6172484,0.8778362", "l0.6179202,0.8807151", "l0.6175972,0.8824531", "l0.6184499,0.8838048", "l0.6173001,0.8855778", "l0.6175843,0.8863326", "l0.6172613,0.8872981", "l0.6149746,0.8907037", "l0.6123908,0.8911601", "l0.6129075,0.8919852", "l0.6123520,0.8930034", "l0.6107500,0.8932667", "l0.6105692,0.8939864", "l0.6085021,0.8946535", "l0.6082308,0.8952504", "l0.6076624,0.8947062", "l0.6072489,0.8974447", "l0.6062929,0.8973569", "l0.6067193,0.8980064", "l0.6067322,0.8998672", "l0.6072102,0.8999199", "l0.6079595,0.9018333", "l0.6070035,0.9015349", "l0.6064996,0.9020089", "l0.6057503,0.9030622", "l0.6061767,0.9041506", "l0.6055436,0.9050283", "l0.6044455,0.9039575", "l0.6034120,0.9050810", "l0.6019909,0.9036415", "l0.6012803,0.9046070", "l0.6006989,0.9040101", "l0.6004406,0.9046947", "l0.6011123,0.9055374", "l0.6009056,0.9088903", "l0.6013707,0.9095749", "l0.6012932,0.9112777", "l0.6004793,0.9112953", "l0.6000013,0.9106282", "l0.5991357,0.9115059", "l0.5971074,0.9109969", "l0.5960868,0.9118219", "l0.5948336,0.9114533", "l0.5941231,0.9126997", "l0.5935288,0.9167372", "l0.5918622,0.9171585", "l0.5913971,0.9163335", "l0.5910742,0.9187735", "l0.5910742,0.9187735", "l0.5911258,0.9214770", "l0.5894593,0.9200375", "l0.5896660,0.9181416", "l0.5892138,0.9190895", "l0.5887746,0.9186507", "l0.5879736,0.9160175", "l0.5882578,0.9148589", "l0.5876893,0.9150344", "l0.5873664,0.9155611", "l0.5882578,0.9187384", "l0.5877023,0.9203535", "l0.5861907,0.9214243", "l0.5829997,0.9223196", "l0.5827930,0.9212136", "l0.5825217,0.9226005", "l0.5814106,0.9227760", "l0.5795374,0.9216876", "l0.5814623,0.9200726", "l0.5811135,0.9187033", "l0.5800024,0.9184927", "l0.5796665,0.9177378", "l0.5783100,0.9182469", "l0.5774057,0.9178783", "l0.5764238,0.9161579", "l0.5766435,0.9138934", "l0.5761267,0.9159999", "l0.5766822,0.9175798", "l0.5754807,0.9172814", "l0.5746410,0.9180714", "l0.5729873,0.9143322", "l0.5724060,0.9154382", "l0.5717988,0.9145780", "l0.5719409,0.9118746", "l0.5713983,0.9112251", "l0.5703131,0.9125592", "l0.5715016,0.9144551", "l0.5711787,0.9149642", "l0.5719280,0.9154733", "l0.5719021,0.9165266", "l0.5704423,0.9190369", "l0.5690470,0.9192300", "l0.5693571,0.9165266", "l0.5689049,0.9166845", "l0.5685044,0.9181240", "l0.5681943,0.9176325", "l0.5686077,0.9168250", "l0.5677680,0.9168250", "l0.5678068,0.9187033", "l0.5660885,0.9205641", "l0.5666957,0.9189140", "l0.5665665,0.9177729", "l0.5650291,0.9189491", "l0.5656880,0.9197566", "l0.5646674,0.9201077", "l0.5641119,0.9192300", "l0.5638535,0.9197215", "l0.5632592,0.9191597", "l0.5618898,0.9195986", "l0.5603136,0.9168601", "l0.5590863,0.9168250", "l0.5573939,0.9179134", "l0.5557144,0.9177378", "l0.5549005,0.9183873", "l0.5539316,0.9165968", "l0.5522262,0.9181591", "l0.5521617,0.9164914", "l0.5512573,0.9147887", "l0.5501204,0.9156137", "l0.5477175,0.9131736", "l0.5467356,0.9129279", "l0.5473040,0.9102771", "l0.5463480,0.9099962", "l0.5457021,0.9105755", "l0.5447590,0.9093292", "l0.5432604,0.9092765", "l0.5425627,0.9083461", "l0.5414904,0.9094345", "l0.5411933,0.9091185", "l0.5416455,0.9063624", "l0.5415292,0.9048176", "l0.5409478,0.9042208", "l0.5414904,0.9033957", "l0.5413096,0.9020616", "l0.5406636,0.9005519", "l0.5391521,0.9003237", "l0.5396172,0.8995688", "l0.5391262,0.8979713", "l0.5399401,0.8943200", "l0.5411287,0.8950397", "l0.5419814,0.8945833", "l0.5424981,0.8909846", "l0.5436608,0.8894573", "l0.5426273,0.8891940", "l0.5416196,0.8875088", "l0.5409349,0.8873683", "l0.5405861,0.8879828", "l0.5397463,0.8864028", "l0.5392296,0.8867539", "l0.5385449,0.8860518", "l0.5381056,0.8870875", "l0.5360256,0.8875614", "l0.5357156,0.8882461", "l0.5345270,0.8879301", "l0.5331963,0.8850336", "l0.5300311,0.8849809", "l0.5299536,0.8861922", "l0.5286746,0.8858411", "l0.5278736,0.8865784", "l0.5271502,0.8848756", "l0.5257161,0.8839979", "l0.5256386,0.8832781", "l0.5230031,0.8830499", "l0.5228739,0.8819440", "l0.5233261,0.8812593", "l0.5224605,0.8801534", "l0.5224605,0.8801534", "l0.5222280,0.8788544", "l0.5232486,0.8772393", "l0.5242950,0.8762914", "l0.5249151,0.8768180", "l0.5242304,0.8751503", "l0.5250314,0.8750801", "l0.5259874,0.8736933", "l0.5267626,0.8735002", "l0.5270856,0.8723416", "l0.5279770,0.8720081", "l0.5284421,0.8727278", "l0.5296952,0.8729736", "l0.5299149,0.8739742", "l0.5322274,0.8710426", "l0.5318786,0.8703053", "l0.5325116,0.8676721", "l0.5321628,0.8656006", "l0.5330671,0.8648984", "l0.5327442,0.8640032", "l0.5331447,0.8637749", "l0.5323049,0.8629323", "l0.5315039,0.8599656", "l0.5299536,0.8575431", "l0.5286100,0.8577011", "l0.5282870,0.8594039", "l0.5276023,0.8592108", "l0.5273439,0.8599656", "l0.5265430,0.8598076", "l0.5267367,0.8592634", "l0.5262200,0.8588772", "l0.5244371,0.8596145", "l0.5235199,0.8572797", "l0.5223313,0.8575255", "l0.5215432,0.8600885", "l0.5203547,0.8597023", "l0.5188690,0.8577713", "l0.5178742,0.8589299", "l0.5165823,0.8572446", "l0.5174350,0.8560334", "l0.5165823,0.8537864", "l0.5168148,0.8524873", "l0.5154325,0.8516272", "l0.5152645,0.8503983", "l0.5144119,0.8499419", "l0.5126936,0.8507494", "l0.5097093,0.8495031", "l0.5089729,0.8498366", "l0.5090633,0.8524171", "l0.5086370,0.8528384", "l0.5072159,0.8514165", "l0.5073193,0.8507494", "l0.5055622,0.8467470", "l0.5051876,0.8448686", "l0.5059886,0.8429376", "l0.5059886,0.8429376", "l0.5092571,0.8456235", "l0.5097868,0.8446755", "l0.5110916,0.8442016", "l0.5115826,0.8426743", "l0.5141922,0.8413928", "l0.5143085,0.8393565", "l0.5148382,0.8384261", "l0.5170603,0.8364951", "l0.5180680,0.8380399", "l0.5205743,0.8380223", "l0.5219308,0.8410944", "l0.5233778,0.8411119", "l0.5268530,0.8436223", "l0.5288426,0.8430430", "l0.5303283,0.8451846", "l0.5308450,0.8438505", "l0.5328088,0.8420599", "l0.5332480,0.8396900", "l0.5324083,0.8373377", "l0.5349146,0.8369515", "l0.5371883,0.8358105", "l0.5395396,0.8342305", "l0.5406894,0.8322469", "l0.5445135,0.8318607", "l0.5450174,0.8303159", "l0.5460896,0.8305441", "l0.5464772,0.8279635", "l0.5459605,0.8275071", "l0.5456633,0.8258394", "l0.5474074,0.8238382", "l0.5472782,0.8227849", "l0.5499783,0.8216614", "l0.5500429,0.8228376", "l0.5517999,0.8245579", "l0.5513219,0.8260150", "l0.5531177,0.8268225", "l0.5533115,0.8293679", "l0.5541124,0.8290870", "l0.5540091,0.8311936", "l0.5571097,0.8287184", "l0.5575877,0.8315798", "l0.5585437,0.8305265", "l0.5591380,0.8326331", "l0.5589313,0.8334406", "l0.5601328,0.8334581", "l0.5626003,0.8316149", "l0.5643186,0.8315447", "l0.5650421,0.8286657", "l0.5647966,0.8272087", "l0.5656105,0.8265592", "l0.5650162,0.8257166", "l0.5657139,0.8253303", "l0.5664890,0.8260676", "l0.5665407,0.8251899", "l0.5678068,0.8234871", "l0.5690470,0.8246282", "l0.5693571,0.8257341", "l0.5705844,0.8254708", "l0.5723543,0.8285955", "l0.5727936,0.8279109", "l0.5723414,0.8251197", "l0.5729873,0.8246808", "l0.5728969,0.8239084", "l0.5737108,0.8237680", "l0.5734008,0.8225041", "l0.5741888,0.8213279", "l0.5753645,0.8211172", "l0.5751319,0.8219072", "l0.5757650,0.8236276", "l0.5778708,0.8228903", "l0.5795244,0.8237855", "l0.5800929,0.8231536", "l0.5795503,0.8224865", "l0.5794469,0.8207135", "l0.5800800,0.8185367", "l0.5789689,0.8186420", "l0.5779354,0.8200815", "l0.5773411,0.8200113", "l0.5772119,0.8191336", "l0.5783488,0.8186772", "l0.5787493,0.8173781", "l0.5800283,0.8175010", "l0.5807259,0.8167813", "l0.5810747,0.8182032", "l0.5818240,0.8178170", "l0.5816432,0.8167988", "l0.5827542,0.8188176", "l0.5843304,0.8184841", "l0.5839686,0.8175537", "l0.5843433,0.8162020", "l0.5859065,0.8138145", "l0.5854931,0.8128841", "l0.5867462,0.8111989", "c"]}, {"n": "Guizhou", "u": "CN-52", "i": ["m0.5879348,0.7941885", "l0.5878185,0.7942236", "l0.5878185,0.7942236", "l0.5877023,0.7935214", "l0.5883870,0.7930825", "l0.5883353,0.7939778", "l0.5883353,0.7939778", "l0.5879348,0.7941885", "c", "m0.5360644,0.7491784", "l0.5364907,0.7480374", "l0.5380669,0.7489151", "l0.5375630,0.7477741", "l0.5384415,0.7455271", "l0.5373305,0.7427535", "l0.5371883,0.7417177", "l0.5376405,0.7414369", "l0.5396172,0.7444036", "l0.5393846,0.7451233", "l0.5406378,0.7458431", "l0.5392296,0.7501615", "l0.5396947,0.7495998", "l0.5407282,0.7503546", "l0.5411287,0.7500562", "l0.5414129,0.7510392", "l0.5418005,0.7509339", "l0.5421622,0.7501615", "l0.5417876,0.7490029", "l0.5426402,0.7482305", "l0.5425756,0.7467735", "l0.5433766,0.7475634", "l0.5443456,0.7452989", "l0.5433249,0.7438770", "l0.5435575,0.7430870", "l0.5445781,0.7419811", "l0.5454695,0.7430870", "l0.5460638,0.7429114", "l0.5459346,0.7410331", "l0.5464901,0.7401905", "l0.5473945,0.7406469", "l0.5483376,0.7401027", "l0.5497199,0.7415773", "l0.5501463,0.7430694", "l0.5515803,0.7419459", "l0.5518774,0.7411384", "l0.5525880,0.7409629", "l0.5534277,0.7386983", "l0.5522521,0.7371009", "l0.5526267,0.7363460", "l0.5523684,0.7347661", "l0.5531435,0.7344326", "l0.5529368,0.7326947", "l0.5536344,0.7322207", "l0.5541770,0.7329755", "l0.5554560,0.7318345", "l0.5558824,0.7331335", "l0.5567996,0.7329580", "l0.5573939,0.7337655", "l0.5586212,0.7326420", "l0.5593447,0.7338533", "l0.5591122,0.7358369", "l0.5600553,0.7383121", "l0.5617477,0.7364689", "l0.5627683,0.7367322", "l0.5636468,0.7352050", "l0.5650162,0.7360476", "l0.5657526,0.7355912", "l0.5664373,0.7365742", "l0.5670187,0.7353454", "l0.5675613,0.7352576", "l0.5677034,0.7381015", "l0.5683881,0.7400852", "l0.5681556,0.7411033", "l0.5688661,0.7426130", "l0.5681168,0.7455095", "l0.5702872,0.7466857", "l0.5719538,0.7458255", "l0.5729227,0.7464048", "l0.5725481,0.7488274", "l0.5719150,0.7490556", "l0.5724318,0.7519170", "l0.5719796,0.7534442", "l0.5726773,0.7542166", "l0.5735299,0.7539182", "l0.5732199,0.7533213", "l0.5738012,0.7523734", "l0.5730519,0.7508286", "l0.5742405,0.7499508", "l0.5752094,0.7515834", "l0.5751578,0.7546028", "l0.5743826,0.7557790", "l0.5749640,0.7574993", "l0.5757908,0.7563583", "l0.5764109,0.7574467", "l0.5775607,0.7571131", "l0.5788010,0.7584297", "l0.5793306,0.7571833", "l0.5803900,0.7576749", "l0.5802608,0.7563232", "l0.5810231,0.7547784", "l0.5813977,0.7521978", "l0.5820437,0.7508286", "l0.5833614,0.7499157", "l0.5833614,0.7499157", "l0.5833356,0.7545502", "l0.5837619,0.7555332", "l0.5845500,0.7551119", "l0.5846404,0.7559019", "l0.5851313,0.7557614", "l0.5837748,0.7610805", "l0.5839040,0.7614842", "l0.5846146,0.7609751", "l0.5850409,0.7617124", "l0.5838265,0.7635908", "l0.5845112,0.7666277", "l0.5840203,0.7678917", "l0.5850926,0.7690678", "l0.5859969,0.7689274", "l0.5863457,0.7730001", "l0.5838653,0.7753875", "l0.5837619,0.7767918", "l0.5828705,0.7769323", "l0.5822504,0.7761248", "l0.5814106,0.7769674", "l0.5811264,0.7762828", "l0.5806484,0.7784244", "l0.5796536,0.7791091", "l0.5798603,0.7800746", "l0.5773023,0.7819529", "l0.5775349,0.7831817", "l0.5769018,0.7845334", "l0.5753903,0.7852532", "l0.5768760,0.7873071", "l0.5779483,0.7867980", "l0.5780904,0.7859905", "l0.5792144,0.7849899", "l0.5807776,0.7841999", "l0.5805709,0.7854287", "l0.5816173,0.7854287", "l0.5829093,0.7834275", "l0.5833097,0.7840770", "l0.5852864,0.7832168", "l0.5860486,0.7843228", "l0.5865654,0.7839015", "l0.5863587,0.7855692", "l0.5872113,0.7854287", "l0.5879219,0.7885359", "l0.5859711,0.7902211", "l0.5867204,0.7897823", "l0.5872372,0.7903440", "l0.5869529,0.7916957", "l0.5872888,0.7931703", "l0.5860744,0.7932230", "l0.5847438,0.7947853", "l0.5834648,0.7946800", "l0.5839040,0.7956982", "l0.5846533,0.7956982", "l0.5855060,0.7986649", "l0.5847438,0.8002624", "l0.5850409,0.8007012", "l0.5840849,0.8014561", "l0.5832581,0.8038260", "l0.5843433,0.8056516", "l0.5861778,0.8048617", "l0.5862166,0.8042648", "l0.5866429,0.8046510", "l0.5859969,0.8060203", "l0.5865008,0.8069507", "l0.5861390,0.8072842", "l0.5871338,0.8088992", "l0.5864620,0.8099876", "l0.5866946,0.8111638", "l0.5866946,0.8111638", "l0.5854414,0.8127788", "l0.5858548,0.8137092", "l0.5842916,0.8160966", "l0.5839169,0.8174483", "l0.5842787,0.8183787", "l0.5827025,0.8187123", "l0.5815915,0.8166935", "l0.5817724,0.8177116", "l0.5810231,0.8180978", "l0.5806742,0.8166759", "l0.5799766,0.8173957", "l0.5786976,0.8172728", "l0.5782971,0.8185718", "l0.5771602,0.8190282", "l0.5772894,0.8199060", "l0.5778837,0.8199762", "l0.5789172,0.8185367", "l0.5800283,0.8184314", "l0.5793952,0.8206082", "l0.5794986,0.8223812", "l0.5800412,0.8230483", "l0.5794728,0.8236802", "l0.5778191,0.8227849", "l0.5757133,0.8235222", "l0.5750802,0.8218019", "l0.5753128,0.8210119", "l0.5741371,0.8212226", "l0.5733491,0.8223987", "l0.5736591,0.8236627", "l0.5728452,0.8238031", "l0.5729357,0.8245755", "l0.5722897,0.8250144", "l0.5727419,0.8278055", "l0.5723026,0.8284902", "l0.5705327,0.8253655", "l0.5693054,0.8256288", "l0.5689953,0.8245228", "l0.5677551,0.8233818", "l0.5664890,0.8250846", "l0.5664373,0.8259623", "l0.5656622,0.8252250", "l0.5649645,0.8256112", "l0.5655588,0.8264538", "l0.5647449,0.8271034", "l0.5649904,0.8285604", "l0.5642669,0.8314394", "l0.5625487,0.8315096", "l0.5600811,0.8333528", "l0.5588796,0.8333353", "l0.5590863,0.8325277", "l0.5584920,0.8304212", "l0.5575360,0.8314745", "l0.5570580,0.8286131", "l0.5539574,0.8310883", "l0.5540608,0.8289817", "l0.5532598,0.8292626", "l0.5530660,0.8267172", "l0.5512702,0.8259097", "l0.5517482,0.8244526", "l0.5499912,0.8227323", "l0.5499266,0.8215561", "l0.5472265,0.8226796", "l0.5473557,0.8237329", "l0.5456116,0.8257341", "l0.5459088,0.8274018", "l0.5464255,0.8278582", "l0.5460380,0.8304387", "l0.5449657,0.8302105", "l0.5444618,0.8317553", "l0.5406378,0.8321415", "l0.5394880,0.8341252", "l0.5371367,0.8357051", "l0.5348629,0.8368462", "l0.5323566,0.8372324", "l0.5331963,0.8395847", "l0.5327571,0.8419546", "l0.5307934,0.8437451", "l0.5302766,0.8450793", "l0.5287909,0.8429376", "l0.5268013,0.8435169", "l0.5233261,0.8410066", "l0.5218791,0.8409891", "l0.5205226,0.8379170", "l0.5180163,0.8379346", "l0.5170086,0.8363898", "l0.5147865,0.8383208", "l0.5142568,0.8392512", "l0.5141406,0.8412875", "l0.5115309,0.8425690", "l0.5110400,0.8440962", "l0.5097351,0.8445702", "l0.5092054,0.8455182", "l0.5059369,0.8428323", "l0.5059369,0.8428323", "l0.5061824,0.8405853", "l0.5088566,0.8364249", "l0.5083269,0.8349152", "l0.5074097,0.8346518", "l0.5082236,0.8344939", "l0.5093605,0.8310707", "l0.5105232,0.8322469", "l0.5106266,0.8302105", "l0.5078877,0.8290870", "l0.5077068,0.8274896", "l0.5061049,0.8264363", "l0.5064020,0.8235749", "l0.5043091,0.8246106", "l0.5042057,0.8221354", "l0.5025908,0.8215737", "l0.5023195,0.8203097", "l0.5025133,0.8179750", "l0.5033789,0.8183963", "l0.5043995,0.8150082", "l0.5040895,0.8142183", "l0.5048905,0.8116026", "l0.5046579,0.8101807", "l0.5057173,0.8096190", "l0.5060790,0.8057394", "l0.5083657,0.8026849", "l0.5080686,0.8012103", "l0.5065699,0.7989458", "l0.5064795,0.7975063", "l0.5051618,0.7975590", "l0.5046837,0.7969972", "l0.5047742,0.7957859", "l0.5038957,0.7943465", "l0.5028363,0.7966461", "l0.4993869,0.7960844", "l0.4982758,0.7987878", "l0.4974361,0.7992266", "l0.4942321,0.7987351", "l0.4931469,0.7965759", "l0.4934958,0.7938725", "l0.4929144,0.7939954", "l0.4924105,0.7920644", "l0.4927206,0.7909233", "l0.4935991,0.7904142", "l0.4936249,0.7884481", "l0.4923847,0.7860431", "l0.4910153,0.7871140", "l0.4907827,0.7856218", "l0.4917258,0.7855165", "l0.4912220,0.7843754", "l0.4924622,0.7838664", "l0.4931857,0.7820056", "l0.4951623,0.7796533", "l0.4961959,0.7763003", "l0.4975265,0.7764759", "l0.4975007,0.7778978", "l0.4992448,0.7790564", "l0.5002266,0.7805485", "l0.5014410,0.7797586", "l0.5012731,0.7790037", "l0.5022033,0.7782313", "l0.5031464,0.7756859", "l0.5056398,0.7772834", "l0.5060015,0.7789335", "l0.5073193,0.7796006", "l0.5092830,0.7787755", "l0.5098902,0.7794426", "l0.5105749,0.7785298", "l0.5111821,0.7788457", "l0.5113888,0.7800395", "l0.5147994,0.7768972", "l0.5163497,0.7771956", "l0.5167244,0.7779856", "l0.5178354,0.7744220", "l0.5173187,0.7736847", "l0.5185848,0.7717888", "l0.5185331,0.7697173", "l0.5185331,0.7697173", "l0.5200963,0.7682779", "l0.5215045,0.7680321", "l0.5233390,0.7694540", "l0.5239333,0.7709111", "l0.5251864,0.7704020", "l0.5254965,0.7696822", "l0.5274215,0.7696120", "l0.5279124,0.7688747", "l0.5302766,0.7686816", "l0.5311680,0.7678566", "l0.5330801,0.7684885", "l0.5353797,0.7668033", "l0.5353926,0.7654691", "l0.5348758,0.7646967", "l0.5351471,0.7630466", "l0.5341265,0.7619933", "l0.5339456,0.7600272", "l0.5323437,0.7582542", "l0.5305867,0.7588335", "l0.5303929,0.7596937", "l0.5291397,0.7588335", "l0.5280157,0.7592372", "l0.5276928,0.7582191", "l0.5280674,0.7562178", "l0.5269435,0.7546906", "l0.5262846,0.7540235", "l0.5254448,0.7556210", "l0.5240366,0.7544799", "l0.5237266,0.7501966", "l0.5249022,0.7475108", "l0.5256515,0.7470192", "l0.5260908,0.7475108", "l0.5281708,0.7473352", "l0.5281191,0.7458782", "l0.5294627,0.7434907", "l0.5317235,0.7465804", "l0.5325633,0.7463873", "l0.5329638,0.7477565", "l0.5346174,0.7488800", "l0.5351471,0.7500211", "l0.5360385,0.7503370", "l0.5360644,0.7491784", "c"]}, {"n": "Hainan", "u": "CN-46", "i": ["m0.6064996,0.9520395", "l0.6070035,0.9541285", "l0.6080112,0.9555329", "l0.6105950,0.9557085", "l0.6121453,0.9640293", "l0.6112926,0.9642224", "l0.6093160,0.9670136", "l0.6086442,0.9652757", "l0.6096648,0.9648368", "l0.6082437,0.9647842", "l0.6089026,0.9665396", "l0.6076624,0.9692957", "l0.6063058,0.9701032", "l0.6063963,0.9715954", "l0.6056082,0.9721571", "l0.6048331,0.9755101", "l0.6042905,0.9755627", "l0.6046522,0.9761420", "l0.6045359,0.9781432", "l0.6040062,0.9783363", "l0.6036057,0.9805833", "l0.6039546,0.9840416", "l0.6028306,0.9846033", "l0.6020167,0.9871312", "l0.5998850,0.9869030", "l0.5984898,0.9880792", "l0.5968749,0.9902559", "l0.5960739,0.9935562", "l0.5952600,0.9937493", "l0.5941748,0.9927662", "l0.5923790,0.9936966", "l0.5921465,0.9931524", "l0.5914747,0.9933104", "l0.5907253,0.9954696", "l0.5911258,0.9967511", "l0.5908287,0.9975060", "l0.5903765,0.9978746", "l0.5901440,0.9969793", "l0.5892655,0.9971373", "l0.5883353,0.9987524", "l0.5883224,0.9976464", "l0.5873276,0.9973129", "l0.5868238,0.9981028", "l0.5870563,0.9966458", "l0.5864233,0.9958910", "l0.5841366,0.9953292", "l0.5818240,0.9958207", "l0.5806872,0.9940477", "l0.5787751,0.9941706", "l0.5782971,0.9931173", "l0.5738529,0.9907299", "l0.5740080,0.9854284", "l0.5728065,0.9829357", "l0.5734008,0.9806711", "l0.5726256,0.9768442", "l0.5736979,0.9752818", "l0.5734266,0.9744041", "l0.5728581,0.9743690", "l0.5729873,0.9723853", "l0.5738658,0.9704192", "l0.5747056,0.9704543", "l0.5790723,0.9655741", "l0.5819016,0.9639416", "l0.5828576,0.9622388", "l0.5834519,0.9621861", "l0.5833873,0.9610977", "l0.5820178,0.9620632", "l0.5815657,0.9607993", "l0.5825346,0.9592018", "l0.5831160,0.9590789", "l0.5832064,0.9581485", "l0.5839428,0.9577448", "l0.5843304,0.9586050", "l0.5850668,0.9583241", "l0.5857515,0.9592018", "l0.5864620,0.9588332", "l0.5870563,0.9596231", "l0.5874439,0.9594300", "l0.5876764,0.9570602", "l0.5889425,0.9559367", "l0.5904153,0.9557085", "l0.5920302,0.9566740", "l0.5920948,0.9573761", "l0.5923273,0.9562351", "l0.5928053,0.9572006", "l0.5942910,0.9560069", "l0.5948336,0.9570602", "l0.5955829,0.9570250", "l0.5972883,0.9558489", "l0.5978567,0.9543919", "l0.5997429,0.9552520", "l0.6003630,0.9548834", "l0.6003760,0.9541636", "l0.6013320,0.9538652", "l0.6048589,0.9559191", "l0.6052465,0.9576746", "l0.6051948,0.9553749", "l0.6045101,0.9550589", "l0.6045876,0.9537248", "l0.6057632,0.9534088", "l0.6064996,0.9520395", "c"]}, {"n": "Hebei", "u": "CN-13", "i": ["m0.7127080,0.4393571", "l0.7129793,0.4397082", "l0.7124238,0.4403226", "l0.7124755,0.4423589", "l0.7116874,0.4439915", "l0.7120492,0.4452730", "l0.7137157,0.4461683", "l0.7120492,0.4468880", "l0.7126951,0.4483275", "l0.7121654,0.4493983", "l0.7120233,0.4524704", "l0.7100079,0.4516980", "l0.7091036,0.4520315", "l0.7086902,0.4500830", "l0.7078117,0.4504867", "l0.7078117,0.4504867", "l0.7079021,0.4488015", "l0.7086514,0.4479940", "l0.7081476,0.4460454", "l0.7059384,0.4445357", "l0.7055637,0.4427100", "l0.7059126,0.4409370", "l0.7085998,0.4403753", "l0.7095041,0.4409019", "l0.7104601,0.4399540", "l0.7127080,0.4393571", "c", "m0.6626463,0.4203981", "l0.6611477,0.4178000", "l0.6616515,0.4169048", "l0.6600108,0.4132183", "l0.6575045,0.4098654", "l0.6584605,0.4093387", "l0.6590548,0.4077412", "l0.6601917,0.4074604", "l0.6607084,0.4059331", "l0.6591710,0.4044059", "l0.6589127,0.4035281", "l0.6594553,0.4015269", "l0.6583830,0.4007370", "l0.6583184,0.3998592", "l0.6608635,0.3974367", "l0.6645067,0.3978229", "l0.6640674,0.3966116", "l0.6643904,0.3955408", "l0.6638865,0.3891860", "l0.6659278,0.3855522", "l0.6685374,0.3842356", "l0.6682274,0.3817078", "l0.6687183,0.3799874", "l0.6697777,0.3792501", "l0.6728266,0.3801103", "l0.6733563,0.3784075", "l0.6738731,0.3783197", "l0.6746740,0.3796012", "l0.6738860,0.3817604", "l0.6751650,0.3834106", "l0.6759143,0.3882732", "l0.6747257,0.3892036", "l0.6751908,0.3924336", "l0.6745448,0.3953301", "l0.6758884,0.3946806", "l0.6777488,0.3950317", "l0.6786402,0.3942242", "l0.6807331,0.3957339", "l0.6813403,0.3943295", "l0.6817667,0.3952073", "l0.6827485,0.3946280", "l0.6818700,0.3929252", "l0.6822317,0.3918543", "l0.6837691,0.3912750", "l0.6873477,0.3884136", "l0.6879162,0.3872199", "l0.6885492,0.3871848", "l0.6887172,0.3864299", "l0.6892598,0.3865177", "l0.6902933,0.3850958", "l0.6917919,0.3849378", "l0.6930709,0.3885365", "l0.6929934,0.3897127", "l0.6939494,0.3899760", "l0.6947892,0.3895371", "l0.6948796,0.3875710", "l0.6962878,0.3872550", "l0.6966495,0.3852538", "l0.6979027,0.3842707", "l0.6984324,0.3830595", "l0.6997630,0.3834106", "l0.6995563,0.3849554", "l0.7004865,0.3848325", "l0.7011842,0.3838319", "l0.7021143,0.3853416", "l0.7039489,0.3847798", "l0.7050082,0.3851660", "l0.7052408,0.3837441", "l0.7062614,0.3838319", "l0.7074499,0.3826557", "l0.7075275,0.3799172", "l0.7059126,0.3773367", "l0.7080184,0.3773367", "l0.7076954,0.3734746", "l0.7081347,0.3710872", "l0.7109252,0.3687700", "l0.7155632,0.3694020", "l0.7170230,0.3674183", "l0.7171522,0.3656980", "l0.7181599,0.3657682", "l0.7184054,0.3649782", "l0.7193097,0.3663124", "l0.7224878,0.3648904", "l0.7225137,0.3658735", "l0.7260535,0.3714208", "l0.7258856,0.3728778", "l0.7267124,0.3743348", "l0.7252267,0.3760025", "l0.7274617,0.3781091", "l0.7272292,0.3799699", "l0.7282627,0.3808125", "l0.7276297,0.3821291", "l0.7289991,0.3822520", "l0.7292058,0.3808300", "l0.7300068,0.3806896", "l0.7304460,0.3821642", "l0.7296192,0.3825679", "l0.7307432,0.3838494", "l0.7300197,0.3856049", "l0.7312341,0.3877290", "l0.7303427,0.3902042", "l0.7297613,0.3899584", "l0.7294900,0.3888349", "l0.7285340,0.3887647", "l0.7278493,0.3909064", "l0.7283144,0.3928725", "l0.7292058,0.3938731", "l0.7293221,0.3954530", "l0.7308078,0.3961201", "l0.7308595,0.3977176", "l0.7301102,0.3988059", "l0.7314021,0.4001928", "l0.7316734,0.4033175", "l0.7322289,0.4036510", "l0.7327327,0.4028435", "l0.7343347,0.4023520", "l0.7367635,0.4024924", "l0.7380296,0.4032297", "l0.7382751,0.4024222", "l0.7394765,0.4017902", "l0.7402388,0.4039670", "l0.7411948,0.4034579", "l0.7452902,0.4045112", "l0.7459232,0.4035632", "l0.7459232,0.4035632", "l0.7458586,0.4053363", "l0.7447217,0.4063369", "l0.7450189,0.4074253", "l0.7433394,0.4089350", "l0.7431714,0.4103569", "l0.7410914,0.4109011", "l0.7409622,0.4119017", "l0.7423317,0.4128321", "l0.7418278,0.4140609", "l0.7402904,0.4139907", "l0.7395282,0.4186778", "l0.7428614,0.4225924", "l0.7448767,0.4218200", "l0.7444504,0.4243830", "l0.7457682,0.4243304", "l0.7456002,0.4253485", "l0.7465175,0.4263316", "l0.7513622,0.4262263", "l0.7510004,0.4270689", "l0.7518789,0.4286488", "l0.7517497,0.4318964", "l0.7526024,0.4340381", "l0.7522536,0.4350913", "l0.7542044,0.4363202", "l0.7546695,0.4404806", "l0.7557805,0.4403928", "l0.7557805,0.4420605", "l0.7557805,0.4420605", "l0.7548374,0.4431665", "l0.7513234,0.4444830", "l0.7507291,0.4450624", "l0.7507420,0.4472216", "l0.7496956,0.4471513", "l0.7479773,0.4491175", "l0.7462979,0.4555073", "l0.7470988,0.4583863", "l0.7464141,0.4599487", "l0.7459361,0.4602295", "l0.7456261,0.4599838", "l0.7462333,0.4594747", "l0.7453806,0.4596327", "l0.7434556,0.4633191", "l0.7420604,0.4648288", "l0.7379392,0.4665141", "l0.7356396,0.4655837", "l0.7312212,0.4697090", "l0.7293867,0.4687611", "l0.7284177,0.4661454", "l0.7268674,0.4641091", "l0.7268674,0.4641091", "l0.7259373,0.4600891", "l0.7248133,0.4588603", "l0.7236635,0.4591411", "l0.7236377,0.4576139", "l0.7246712,0.4539625", "l0.7237281,0.4533306", "l0.7219323,0.4533481", "l0.7210667,0.4549983", "l0.7207696,0.4538397", "l0.7195940,0.4534535", "l0.7203174,0.4513820", "l0.7183925,0.4483100", "l0.7186509,0.4474322", "l0.7178111,0.4450624", "l0.7183020,0.4422712", "l0.7190384,0.4419025", "l0.7199557,0.4426047", "l0.7210409,0.4421307", "l0.7219452,0.4429031", "l0.7225266,0.4423414", "l0.7223974,0.4414812", "l0.7214931,0.4411828", "l0.7215706,0.4396029", "l0.7198911,0.4389007", "l0.7199169,0.4379176", "l0.7189738,0.4370574", "l0.7182762,0.4351264", "l0.7167001,0.4346525", "l0.7156407,0.4351791", "l0.7156407,0.4351791", "l0.7150464,0.4350387", "l0.7129793,0.4308782", "l0.7131861,0.4291052", "l0.7126176,0.4273322", "l0.7134574,0.4268231", "l0.7132765,0.4258927", "l0.7143229,0.4249974", "l0.7165709,0.4249799", "l0.7163512,0.4233824", "l0.7166355,0.4228207", "l0.7175011,0.4232771", "l0.7175140,0.4224520", "l0.7159766,0.4220307", "l0.7144134,0.4227855", "l0.7117133,0.4213987", "l0.7093232,0.4216621", "l0.7069073,0.4175718", "l0.7060159,0.4172910", "l0.7047757,0.4155882", "l0.7039747,0.4133763", "l0.7043106,0.4117437", "l0.7034708,0.4109888", "l0.7029024,0.4114277", "l0.7026828,0.4133412", "l0.7003573,0.4134114", "l0.7006803,0.4157988", "l0.6995047,0.4155355", "l0.6990008,0.4144647", "l0.6984970,0.4147455", "l0.6984324,0.4156057", "l0.7005124,0.4188182", "l0.7004348,0.4194677", "l0.6996985,0.4189586", "l0.6977993,0.4198013", "l0.6968821,0.4188884", "l0.6946729,0.4239090", "l0.6927479,0.4249448", "l0.6915206,0.4238564", "l0.6890401,0.4260507", "l0.6886655,0.4271918", "l0.6893373,0.4275077", "l0.6892727,0.4288419", "l0.6909134,0.4313522", "l0.6915594,0.4314575", "l0.6923604,0.4341434", "l0.6910555,0.4353547", "l0.6904096,0.4376719", "l0.6894536,0.4365484", "l0.6889368,0.4377772", "l0.6866759,0.4382863", "l0.6839758,0.4409546", "l0.6835753,0.4430787", "l0.6850740,0.4442548", "l0.6851515,0.4462385", "l0.6859783,0.4470636", "l0.6836012,0.4482222", "l0.6846993,0.4492052", "l0.6845572,0.4516980", "l0.6859525,0.4533130", "l0.6879162,0.4532428", "l0.6890401,0.4557707", "l0.6899057,0.4557707", "l0.6903708,0.4547525", "l0.6915077,0.4542785", "l0.6918048,0.4532955", "l0.6924250,0.4541907", "l0.6928255,0.4535061", "l0.6951380,0.4542610", "l0.6960940,0.4538397", "l0.6969079,0.4545243", "l0.6971146,0.4559813", "l0.6986262,0.4574910", "l0.7004478,0.4577719", "l0.6996209,0.4557180", "l0.7009516,0.4548578", "l0.7024115,0.4526811", "l0.7029153,0.4524177", "l0.7046982,0.4536114", "l0.7045302,0.4527513", "l0.7058351,0.4534183", "l0.7061709,0.4529795", "l0.7061709,0.4529795", "l0.7060676,0.4546823", "l0.7064939,0.4553318", "l0.7061322,0.4573330", "l0.7071011,0.4582108", "l0.7065973,0.4606508", "l0.7071528,0.4601242", "l0.7076179,0.4609317", "l0.7071528,0.4622308", "l0.7075662,0.4637053", "l0.7070624,0.4646533", "l0.7072303,0.4656890", "l0.7081088,0.4658470", "l0.7083026,0.4664965", "l0.7078375,0.4685504", "l0.7054604,0.4696037", "l0.7046594,0.4722896", "l0.7053829,0.4777666", "l0.7067781,0.4777666", "l0.7080830,0.4791710", "l0.7097625,0.4788550", "l0.7111190,0.4821201", "l0.7131473,0.4809615", "l0.7135478,0.4814882", "l0.7132119,0.4823308", "l0.7136253,0.4826292", "l0.7168034,0.4812775", "l0.7183925,0.4815057", "l0.7186638,0.4801891", "l0.7186638,0.4801891", "l0.7196069,0.4847533", "l0.7209246,0.4878780", "l0.7235731,0.4913539", "l0.7235731,0.4913539", "l0.7227721,0.4923896", "l0.7224620,0.4942328", "l0.7219840,0.4943206", "l0.7208730,0.4964974", "l0.7188188,0.4967607", "l0.7164804,0.5029224", "l0.7060805,0.5034139", "l0.7052537,0.5055731", "l0.7041168,0.5065210", "l0.7030187,0.5091191", "l0.7004994,0.5122965", "l0.7002152,0.5134551", "l0.6990267,0.5109448", "l0.6984065,0.5105762", "l0.6977347,0.5114012", "l0.6975539,0.5122614", "l0.6979802,0.5127178", "l0.6975797,0.5136482", "l0.6968046,0.5134200", "l0.6968175,0.5147191", "l0.6976831,0.5154388", "l0.6970242,0.5165272", "l0.6957064,0.5160181", "l0.6927738,0.5172820", "l0.6924508,0.5201610", "l0.6915206,0.5210387", "l0.6908876,0.5245321", "l0.6894406,0.5267264", "l0.6896473,0.5275690", "l0.6882262,0.5299213", "l0.6879162,0.5316241", "l0.6846347,0.5330987", "l0.6840533,0.5348893", "l0.6822834,0.5372065", "l0.6813403,0.5404717", "l0.6815858,0.5427362", "l0.6822447,0.5431224", "l0.6827098,0.5446497", "l0.6825935,0.5455274", "l0.6835883,0.5451763", "l0.6843763,0.5469844", "l0.6845184,0.5494070", "l0.6845184,0.5494070", "l0.6820767,0.5516715", "l0.6807202,0.5488803", "l0.6787694,0.5482659", "l0.6784981,0.5493543", "l0.6776584,0.5494070", "l0.6768961,0.5520753", "l0.6754621,0.5527950", "l0.6750875,0.5524088", "l0.6753975,0.5513731", "l0.6750099,0.5503198", "l0.6731108,0.5505831", "l0.6725682,0.5500740", "l0.6701653,0.5507762", "l0.6670647,0.5479148", "l0.6646875,0.5468440", "l0.6635636,0.5471600", "l0.6626592,0.5464227", "l0.6614965,0.5465807", "l0.6606826,0.5443688", "l0.6599462,0.5442986", "l0.6600366,0.5453167", "l0.6596620,0.5442810", "l0.6591581,0.5448603", "l0.6579566,0.5442986", "l0.6578404,0.5449481", "l0.6563805,0.5438070", "l0.6560059,0.5441932", "l0.6560059,0.5441932", "l0.6556441,0.5424553", "l0.6537838,0.5415074", "l0.6531378,0.5404541", "l0.6536804,0.5386284", "l0.6528923,0.5377683", "l0.6529699,0.5369607", "l0.6518976,0.5364868", "l0.6523497,0.5347138", "l0.6516650,0.5346435", "l0.6520784,0.5338185", "l0.6528277,0.5339589", "l0.6551919,0.5323614", "l0.6554503,0.5298160", "l0.6559929,0.5297107", "l0.6563159,0.5306411", "l0.6569877,0.5300091", "l0.6565097,0.5277797", "l0.6570523,0.5267089", "l0.6566777,0.5261120", "l0.6569490,0.5249183", "l0.6564580,0.5244794", "l0.6566131,0.5225660", "l0.6576724,0.5219340", "l0.6585638,0.5199503", "l0.6588481,0.5178262", "l0.6597524,0.5168958", "l0.6599850,0.5153861", "l0.6606438,0.5147893", "l0.6610056,0.5128583", "l0.6623362,0.5101724", "l0.6626851,0.5078025", "l0.6615094,0.5065210", "l0.6602950,0.5069248", "l0.6611348,0.5050991", "l0.6599591,0.5036948", "l0.6596878,0.5011844", "l0.6583830,0.4985864", "l0.6584217,0.4969011", "l0.6573882,0.4954616", "l0.6576853,0.4942328", "l0.6560059,0.4938115", "l0.6560834,0.4931620", "l0.6545589,0.4921965", "l0.6535771,0.4922667", "l0.6529569,0.4911081", "l0.6531636,0.4890542", "l0.6526469,0.4879483", "l0.6536029,0.4856135", "l0.6532541,0.4830154", "l0.6539775,0.4820499", "l0.6540809,0.4805402", "l0.6556570,0.4802769", "l0.6557216,0.4787497", "l0.6565355,0.4789779", "l0.6571815,0.4772224", "l0.6577758,0.4773628", "l0.6580342,0.4753616", "l0.6567293,0.4737641", "l0.6566131,0.4713592", "l0.6585638,0.4686733", "l0.6592486,0.4687084", "l0.6595586,0.4678307", "l0.6603079,0.4677956", "l0.6610960,0.4666019", "l0.6621683,0.4690244", "l0.6636152,0.4690771", "l0.6649718,0.4670232", "l0.6661216,0.4680062", "l0.6665866,0.4657066", "l0.6674781,0.4654608", "l0.6678915,0.4644953", "l0.6671551,0.4636351", "l0.6672197,0.4620377", "l0.6680465,0.4604929", "l0.6680853,0.4588954", "l0.6694030,0.4548929", "l0.6684858,0.4531901", "l0.6674393,0.4530146", "l0.6670517,0.4519438", "l0.6670905,0.4486610", "l0.6675427,0.4478711", "l0.6668063,0.4457119", "l0.6640028,0.4457294", "l0.6635894,0.4450097", "l0.6613544,0.4442373", "l0.6607472,0.4420781", "l0.6589385,0.4415690", "l0.6599204,0.4406561", "l0.6603079,0.4382161", "l0.6609539,0.4402173", "l0.6616903,0.4397784", "l0.6616774,0.4365308", "l0.6624913,0.4368819", "l0.6642095,0.4362499", "l0.6645583,0.4350738", "l0.6677494,0.4344067", "l0.6690284,0.4323177", "l0.6676719,0.4311064", "l0.6667675,0.4317384", "l0.6655144,0.4311942", "l0.6647780,0.4277886", "l0.6649976,0.4247692", "l0.6636669,0.4237335", "l0.6637444,0.4229786", "l0.6626463,0.4203981", "c"]}, {"n": "Henan", "u": "CN-41", "i": ["m0.6560575,0.5440704", "l0.6564322,0.5436842", "l0.6578921,0.5448077", "l0.6580083,0.5441581", "l0.6592227,0.5447199", "l0.6597266,0.5441581", "l0.6601012,0.5451763", "l0.6600237,0.5441757", "l0.6607472,0.5442459", "l0.6615740,0.5464578", "l0.6627238,0.5462998", "l0.6636282,0.5470371", "l0.6647521,0.5467036", "l0.6671293,0.5477919", "l0.6702298,0.5506358", "l0.6726328,0.5499336", "l0.6731883,0.5504427", "l0.6750875,0.5501969", "l0.6754750,0.5512326", "l0.6751650,0.5522684", "l0.6755525,0.5526546", "l0.6769866,0.5519348", "l0.6777488,0.5492665", "l0.6785756,0.5492314", "l0.6788598,0.5481430", "l0.6808106,0.5487574", "l0.6821672,0.5515486", "l0.6846089,0.5492841", "l0.6846089,0.5492841", "l0.6840792,0.5535674", "l0.6825806,0.5548313", "l0.6827744,0.5563937", "l0.6822317,0.5588338", "l0.6826839,0.5597993", "l0.6847897,0.5571485", "l0.6847768,0.5561128", "l0.6851644,0.5568150", "l0.6857458,0.5567097", "l0.6899962,0.5536376", "l0.6931743,0.5524966", "l0.6941303,0.5510571", "l0.6947633,0.5508816", "l0.6948667,0.5517417", "l0.6937556,0.5548664", "l0.6918694,0.5547436", "l0.6909134,0.5565868", "l0.6911718,0.5576050", "l0.6894794,0.5575874", "l0.6890014,0.5585529", "l0.6885751,0.5581843", "l0.6883813,0.5596413", "l0.6875157,0.5610281", "l0.6849448,0.5613265", "l0.6828389,0.5658030", "l0.6821284,0.5653817", "l0.6825160,0.5678393", "l0.6811724,0.5684537", "l0.6803585,0.5697879", "l0.6796479,0.5689804", "l0.6772062,0.5709289", "l0.6769478,0.5729828", "l0.6757205,0.5754405", "l0.6742994,0.5763182", "l0.6742994,0.5784598", "l0.6736405,0.5804084", "l0.6739376,0.5811106", "l0.6746482,0.5804962", "l0.6754750,0.5817250", "l0.6786661,0.5807419", "l0.6792991,0.5817426", "l0.6803068,0.5820059", "l0.6800226,0.5831469", "l0.6809657,0.5834629", "l0.6808236,0.5849551", "l0.6816633,0.5845689", "l0.6838208,0.5865350", "l0.6840663,0.5898352", "l0.6855649,0.5923631", "l0.6878516,0.5928371", "l0.6882133,0.5916960", "l0.6903450,0.5927669", "l0.6926963,0.5920647", "l0.6931743,0.5911343", "l0.6937298,0.5919593", "l0.6947763,0.5916258", "l0.6953189,0.5928546", "l0.6962490,0.5923455", "l0.6962490,0.5923455", "l0.6963911,0.5940483", "l0.6957323,0.5954527", "l0.6966108,0.5975944", "l0.6990525,0.5993498", "l0.6991171,0.6005787", "l0.7003961,0.5999994", "l0.7005770,0.6006313", "l0.7013392,0.5998940", "l0.7025794,0.6003856", "l0.7019722,0.6017197", "l0.7024115,0.6031592", "l0.7017397,0.6047215", "l0.7037034,0.6084958", "l0.7035871,0.6107252", "l0.7023340,0.6102512", "l0.7016363,0.6112343", "l0.7003315,0.6117083", "l0.7002411,0.6130073", "l0.6957581,0.6155703", "l0.6943370,0.6135866", "l0.6938719,0.6122700", "l0.6940915,0.6114450", "l0.6928642,0.6102864", "l0.6931226,0.6087240", "l0.6925929,0.6077409", "l0.6912881,0.6069159", "l0.6907196,0.6076883", "l0.6899832,0.6058801", "l0.6874123,0.6060381", "l0.6865855,0.6069334", "l0.6857328,0.6109710", "l0.6871152,0.6112343", "l0.6868568,0.6135691", "l0.6860429,0.6137797", "l0.6872056,0.6188179", "l0.6858879,0.6195376", "l0.6835366,0.6195376", "l0.6832911,0.6209771", "l0.6828906,0.6205382", "l0.6824255,0.6210122", "l0.6819217,0.6242598", "l0.6827356,0.6256466", "l0.6815470,0.6307375", "l0.6798417,0.6310710", "l0.6791699,0.6320365", "l0.6773095,0.6319839", "l0.6757592,0.6300880", "l0.6752296,0.6308955", "l0.6750875,0.6320541", "l0.6756430,0.6337393", "l0.6748549,0.6347048", "l0.6758109,0.6359863", "l0.6769736,0.6358810", "l0.6773095,0.6367236", "l0.6790149,0.6368816", "l0.6800097,0.6380753", "l0.6800097,0.6450620", "l0.6817279,0.6451498", "l0.6817408,0.6460275", "l0.6834461,0.6454482", "l0.6860041,0.6495209", "l0.6857845,0.6499247", "l0.6864563,0.6492751", "l0.6875803,0.6497316", "l0.6880712,0.6475197", "l0.6890789,0.6480112", "l0.6892727,0.6472739", "l0.6895182,0.6482921", "l0.6914043,0.6453605", "l0.6918953,0.6455711", "l0.6905517,0.6471862", "l0.6911718,0.6476952", "l0.6916111,0.6547171", "l0.6920891,0.6561741", "l0.6918307,0.6626518", "l0.6913527,0.6636875", "l0.6916757,0.6657589", "l0.6900866,0.6666893", "l0.6893114,0.6660222", "l0.6886267,0.6666367", "l0.6878387,0.6661627", "l0.6849189,0.6689188", "l0.6847381,0.6705689", "l0.6829423,0.6734303", "l0.6828389,0.6759230", "l0.6828389,0.6759230", "l0.6818442,0.6764672", "l0.6803972,0.6754140", "l0.6806427,0.6720259", "l0.6793637,0.6707093", "l0.6788340,0.6709551", "l0.6785110,0.6729388", "l0.6771674,0.6727808", "l0.6768186,0.6742027", "l0.6763664,0.6734654", "l0.6741185,0.6744485", "l0.6732917,0.6737814", "l0.6731108,0.6728510", "l0.6718447,0.6726228", "l0.6707337,0.6711131", "l0.6695710,0.6719206", "l0.6698810,0.6665313", "l0.6691963,0.6672160", "l0.6688087,0.6664436", "l0.6686925,0.6672862", "l0.6678656,0.6674266", "l0.6653206,0.6669351", "l0.6643775,0.6647934", "l0.6633698,0.6642668", "l0.6625817,0.6646003", "l0.6619228,0.6659345", "l0.6601012,0.6667420", "l0.6596103,0.6656360", "l0.6596749,0.6641088", "l0.6590806,0.6635822", "l0.6586543,0.6643721", "l0.6579825,0.6644248", "l0.6574011,0.6612649", "l0.6564839,0.6605803", "l0.6570135,0.6594042", "l0.6561092,0.6572098", "l0.6566777,0.6571396", "l0.6569360,0.6552613", "l0.6562384,0.6539622", "l0.6567422,0.6509955", "l0.6562772,0.6510482", "l0.6560963,0.6496087", "l0.6550240,0.6495034", "l0.6543522,0.6510833", "l0.6538742,0.6509253", "l0.6540292,0.6513115", "l0.6510449,0.6533127", "l0.6499209,0.6527334", "l0.6493396,0.6519083", "l0.6495592,0.6514519", "l0.6476084,0.6492751", "l0.6467945,0.6495034", "l0.6464328,0.6505742", "l0.6445724,0.6493454", "l0.6440040,0.6497316", "l0.6439523,0.6507146", "l0.6426991,0.6502407", "l0.6421694,0.6506620", "l0.6420273,0.6500476", "l0.6402832,0.6514344", "l0.6367951,0.6499422", "l0.6350510,0.6512413", "l0.6336945,0.6508200", "l0.6331002,0.6519259", "l0.6315757,0.6502231", "l0.6302451,0.6503811", "l0.6287723,0.6481165", "l0.6279067,0.6485379", "l0.6270411,0.6469404", "l0.6260205,0.6472915", "l0.6232687,0.6446583", "l0.6220414,0.6446056", "l0.6219510,0.6438508", "l0.6208399,0.6449216", "l0.6198322,0.6427624", "l0.6183853,0.6413580", "l0.6191475,0.6402170", "l0.6182819,0.6405681", "l0.6177005,0.6387775", "l0.6162407,0.6378998", "l0.6161632,0.6368640", "l0.6155818,0.6373029", "l0.6154655,0.6359161", "l0.6159565,0.6350032", "l0.6153880,0.6331951", "l0.6139152,0.6331600", "l0.6146129,0.6319839", "l0.6130238,0.6295087", "l0.6121453,0.6301406", "l0.6124166,0.6291927", "l0.6112280,0.6274723", "l0.6112280,0.6274723", "l0.6114994,0.6257344", "l0.6119903,0.6253131", "l0.6114477,0.6227677", "l0.6119386,0.6218724", "l0.6116285,0.6191514", "l0.6087734,0.6164831", "l0.6078691,0.6131126", "l0.6051044,0.6115678", "l0.6049106,0.6104443", "l0.6062154,0.6090575", "l0.6053240,0.6070388", "l0.6047426,0.6069510", "l0.6047685,0.6051077", "l0.6056857,0.6033698", "l0.6023913,0.6012457", "l0.6021588,0.6001222", "l0.6033474,0.5988583", "l0.6030244,0.5967518", "l0.6021976,0.5968746", "l0.6011253,0.5942414", "l0.6017712,0.5927669", "l0.6012028,0.5923455", "l0.6014741,0.5916785", "l0.6014741,0.5916785", "l0.6064092,0.5919593", "l0.6075461,0.5902917", "l0.6098845,0.5901337", "l0.6103366,0.5882202", "l0.6109438,0.5889926", "l0.6131142,0.5876760", "l0.6140444,0.5862014", "l0.6151942,0.5866403", "l0.6170288,0.5856221", "l0.6178039,0.5860434", "l0.6208399,0.5851130", "l0.6225065,0.5824623", "l0.6224806,0.5812861", "l0.6246123,0.5801978", "l0.6250128,0.5790918", "l0.6270928,0.5788460", "l0.6280488,0.5792498", "l0.6283589,0.5801451", "l0.6288239,0.5793025", "l0.6288369,0.5734392", "l0.6312269,0.5741063", "l0.6313561,0.5747909", "l0.6325059,0.5741765", "l0.6324801,0.5750543", "l0.6332681,0.5751947", "l0.6343275,0.5743521", "l0.6352060,0.5749314", "l0.6379190,0.5750543", "l0.6384746,0.5738254", "l0.6388750,0.5750016", "l0.6401670,0.5755458", "l0.6411359,0.5741063", "l0.6429575,0.5742994", "l0.6431900,0.5732461", "l0.6441331,0.5728248", "l0.6440169,0.5715433", "l0.6446241,0.5712273", "l0.6460581,0.5720173", "l0.6475438,0.5691032", "l0.6490295,0.5695421", "l0.6490424,0.5681553", "l0.6498563,0.5682255", "l0.6506056,0.5672424", "l0.6522464,0.5666983", "l0.6531249,0.5635209", "l0.6543393,0.5638193", "l0.6535254,0.5588865", "l0.6548560,0.5583598", "l0.6545460,0.5542345", "l0.6553470,0.5542871", "l0.6555537,0.5533041", "l0.6549206,0.5529705", "l0.6553082,0.5521630", "l0.6548044,0.5505480", "l0.6556570,0.5501618", "l0.6548690,0.5493894", "l0.6555149,0.5489505", "l0.6551015,0.5484415", "l0.6556054,0.5482132", "l0.6553082,0.5478973", "c"]}, {"n": "Hong Kong", "u": "CN-91", "i": ["m0.6644033,0.9018333", "l0.6648167,0.9037468", "l0.6641191,0.9031499", "l0.6640416,0.9039750", "l0.6636152,0.9027637", "l0.6633569,0.9031148", "l0.6624525,0.9020264", "l0.6644033,0.9018333", "c", "m0.6613156,0.9003412", "l0.6606309,0.9034835", "l0.6601271,0.9028691", "l0.6591194,0.9036941", "l0.6579825,0.9036590", "l0.6588868,0.9016578", "l0.6601400,0.9014296", "l0.6613156,0.9003412", "c", "m0.6591840,0.8990597", "l0.6612510,0.8965494", "l0.6612510,0.8965494", "l0.6632018,0.8951977", "l0.6642612,0.8956015", "l0.6642612,0.8956015", "l0.6639770,0.8960930", "l0.6647650,0.8955137", "l0.6650493,0.8964967", "l0.6656177,0.8960754", "l0.6660570,0.8965143", "l0.6645971,0.8979011", "l0.6643387,0.8973745", "l0.6634990,0.8980240", "l0.6649459,0.8986209", "l0.6658115,0.8971638", "l0.6661474,0.8980064", "l0.6671422,0.8982171", "l0.6665479,0.9003061", "l0.6652818,0.8992177", "l0.6647134,0.9001657", "l0.6656823,0.9014471", "l0.6654885,0.9024126", "l0.6638736,0.9009556", "l0.6636023,0.9015525", "l0.6622975,0.8997795", "l0.6592873,0.8998321", "l0.6591840,0.8990597", "c"]}, {"n": "Heilongjiang", "u": "CN-23", "i": ["m0.8149503,0.0024755", "l0.8155187,0.0025984", "l0.8152474,0.0013871", "l0.8157642,0.0007025", "l0.8162939,0.0013520", "l0.8160484,0.0028792", "l0.8166685,0.0023877", "l0.8169527,0.0009482", "l0.8180896,0.0017557", "l0.8185547,0.0031250", "l0.8214744,0.0032654", "l0.8241100,0.0065657", "l0.8248334,0.0067412", "l0.8256861,0.0085318", "l0.8278178,0.0077243", "l0.8290322,0.0094622", "l0.8299365,0.0121305", "l0.8311897,0.0135349", "l0.8353109,0.0142546", "l0.8355951,0.0157117", "l0.8374038,0.0163261", "l0.8381014,0.0177480", "l0.8385019,0.0172916", "l0.8383339,0.0152728", "l0.8398455,0.0141142", "l0.8434112,0.0142371", "l0.8476874,0.0175022", "l0.8484367,0.0195034", "l0.8495995,0.0182395", "l0.8499354,0.0184677", "l0.8510593,0.0209429", "l0.8521574,0.0217855", "l0.8519249,0.0236288", "l0.8508655,0.0245767", "l0.8511110,0.0264726", "l0.8527776,0.0250683", "l0.8537207,0.0250683", "l0.8559298,0.0299836", "l0.8572605,0.0286845", "l0.8581261,0.0295622", "l0.8579969,0.0304751", "l0.8571442,0.0307911", "l0.8573639,0.0332487", "l0.8559815,0.0337929", "l0.8560332,0.0355659", "l0.8565500,0.0365490", "l0.8575964,0.0358468", "l0.8596247,0.0382167", "l0.8595472,0.0407445", "l0.8606841,0.0406216", "l0.8620664,0.0432724", "l0.8618210,0.0465200", "l0.8636297,0.0472924", "l0.8620148,0.0485037", "l0.8613300,0.0501187", "l0.8640689,0.0515055", "l0.8655417,0.0532083", "l0.8648828,0.0563681", "l0.8637201,0.0567719", "l0.8640043,0.0596157", "l0.8671308,0.0662865", "l0.8671824,0.0673573", "l0.8682676,0.0678313", "l0.8684485,0.0707103", "l0.8674925,0.0720444", "l0.8700505,0.0744845", "l0.8693528,0.0780130", "l0.8714070,0.0794876", "l0.8713941,0.0809973", "l0.8698179,0.0817345", "l0.8701926,0.0840869", "l0.8712003,0.0845257", "l0.8713941,0.0837884", "l0.8707094,0.0821734", "l0.8723630,0.0818223", "l0.8711615,0.0859652", "l0.8714845,0.0909332", "l0.8746109,0.0954271", "l0.8765876,0.1009217", "l0.8775953,0.1019750", "l0.8773498,0.1040816", "l0.8786546,0.1076978", "l0.8774790,0.1113667", "l0.8786288,0.1131924", "l0.8783575,0.1169315", "l0.8792877,0.1182130", "l0.8824787,0.1201089", "l0.8823754,0.1224788", "l0.8807217,0.1272712", "l0.8815615,0.1304310", "l0.8813160,0.1341526", "l0.8822203,0.1353112", "l0.8833960,0.1355219", "l0.8839644,0.1390855", "l0.8858894,0.1418942", "l0.8875559,0.1423682", "l0.8883182,0.1411042", "l0.8901785,0.1435619", "l0.8928786,0.1442290", "l0.8931241,0.1450014", "l0.8953462,0.1420171", "l0.8978525,0.1415256", "l0.9006689,0.1428246", "l0.9012244,0.1418942", "l0.9021288,0.1428597", "l0.9011598,0.1450014", "l0.9013536,0.1457562", "l0.9034853,0.1456684", "l0.9053585,0.1466866", "l0.9068184,0.1500044", "l0.9075806,0.1500395", "l0.9087950,0.1484421", "l0.9109913,0.1500571", "l0.9114564,0.1495305", "l0.9117018,0.1473361", "l0.9131230,0.1473361", "l0.9139369,0.1480032", "l0.9144149,0.1521110", "l0.9148670,0.1526201", "l0.9163398,0.1521285", "l0.9171021,0.1525499", "l0.9175801,0.1535329", "l0.9175801,0.1552708", "l0.9192208,0.1562890", "l0.9191820,0.1579040", "l0.9203318,0.1586764", "l0.9204869,0.1606776", "l0.9253962,0.1664180", "l0.9286776,0.1652594", "l0.9301762,0.1669095", "l0.9326309,0.1662776", "l0.9327859,0.1670149", "l0.9316490,0.1696129", "l0.9303184,0.1749144", "l0.9315586,0.1760730", "l0.9318816,0.1791802", "l0.9335481,0.1785307", "l0.9341037,0.1789520", "l0.9337032,0.1813219", "l0.9352276,0.1853770", "l0.9342845,0.1871324", "l0.9339228,0.1892565", "l0.9323854,0.1919600", "l0.9328247,0.1938910", "l0.9363645,0.1987536", "l0.9372947,0.2013166", "l0.9373335,0.2045466", "l0.9377856,0.2052488", "l0.9396460,0.2058281", "l0.9422169,0.2041078", "l0.9439610,0.2044237", "l0.9453563,0.2038444", "l0.9462606,0.2043009", "l0.9475396,0.2065127", "l0.9481597,0.2065303", "l0.9494646,0.2049679", "l0.9512086,0.2062143", "l0.9525393,0.2058632", "l0.9538571,0.2063899", "l0.9543997,0.2050381", "l0.9584046,0.2050381", "l0.9595932,0.2035109", "l0.9605363,0.2034407", "l0.9626421,0.2048450", "l0.9635852,0.2047046", "l0.9652776,0.1991222", "l0.9653422,0.1970859", "l0.9675514,0.1977354", "l0.9687141,0.1953304", "l0.9708587,0.1947336", "l0.9712463,0.1934521", "l0.9733521,0.1918371", "l0.9754450,0.1923988", "l0.9763881,0.1918195", "l0.9785456,0.1930483", "l0.9794499,0.1924339", "l0.9797858,0.1914509", "l0.9834807,0.1887475", "l0.9849406,0.1891512", "l0.9853540,0.1866585", "l0.9872402,0.1860792", "l0.9872273,0.1850259", "l0.9878603,0.1842710", "l0.9934155,0.1825331", "l0.9954051,0.1838146", "l0.9963611,0.1831827", "l0.9973430,0.1853945", "l0.9986736,0.1861845", "l0.9979760,0.1877469", "l0.9978985,0.1904327", "l0.9960381,0.1945229", "l0.9960510,0.1955411", "l0.9966712,0.1984025", "l0.9977822,0.1988414", "l0.9980793,0.2011761", "l0.9996555,0.2034582", "l0.9993583,0.2059159", "l0.9951079,0.2136048", "l0.9925112,0.2138506", "l0.9900178,0.2175370", "l0.9894881,0.2200473", "l0.9905733,0.2216799", "l0.9906767,0.2242078", "l0.9889197,0.2260335", "l0.9873952,0.2338102", "l0.9878603,0.2353725", "l0.9872918,0.2392345", "l0.9856382,0.2415693", "l0.9846047,0.2451329", "l0.9861162,0.2476256", "l0.9849018,0.2492933", "l0.9857545,0.2498902", "l0.9852894,0.2506099", "l0.9855865,0.2517159", "l0.9847726,0.2523829", "l0.9850181,0.2529096", "l0.9845917,0.2537697", "l0.9839975,0.2530325", "l0.9833127,0.2546475", "l0.9819692,0.2555077", "l0.9827185,0.2586850", "l0.9815557,0.2621609", "l0.9806514,0.2621784", "l0.9802509,0.2644605", "l0.9792432,0.2636179", "l0.9785714,0.2646712", "l0.9782743,0.2665846", "l0.9788815,0.2671113", "l0.9783130,0.2673395", "l0.9785714,0.2684805", "l0.9776671,0.2699200", "l0.9785197,0.2702360", "l0.9785068,0.2711488", "l0.9779901,0.2713244", "l0.9783518,0.2724654", "l0.9773441,0.2726410", "l0.9774862,0.2737469", "l0.9768015,0.2737469", "l0.9763235,0.2745193", "l0.9759230,0.2762397", "l0.9750832,0.2753444", "l0.9732746,0.2771174", "l0.9721248,0.2843323", "l0.9726544,0.2854032", "l0.9728741,0.2879310", "l0.9702902,0.2911084", "l0.9683136,0.2899849", "l0.9657814,0.3013954", "l0.9635594,0.3055910", "l0.9595673,0.3037126", "l0.9562342,0.2998155", "l0.9574098,0.2930745", "l0.9553686,0.2843499", "l0.9533015,0.2829631", "l0.9526297,0.2811901", "l0.9515833,0.2820502", "l0.9507565,0.2850872", "l0.9491545,0.2849292", "l0.9486377,0.2868426", "l0.9492449,0.2872113", "l0.9492966,0.2881592", "l0.9458730,0.2919335", "l0.9461056,0.2927410", "l0.9437026,0.2923021", "l0.9426045,0.2940927", "l0.9414288,0.2944438", "l0.9404857,0.2936714", "l0.9397235,0.2939171", "l0.9394522,0.2951635", "l0.9373335,0.2962870", "l0.9372818,0.2970945", "l0.9380828,0.2974632", "l0.9380828,0.2982707", "l0.9397623,0.3013427", "l0.9428629,0.3202666", "l0.9428758,0.3213550", "l0.9421652,0.3221450", "l0.9419198,0.3237775", "l0.9423073,0.3247606", "l0.9414030,0.3281311", "l0.9418164,0.3350125", "l0.9412867,0.3356971", "l0.9412350,0.3372419", "l0.9425916,0.3386638", "l0.9425916,0.3386638", "l0.9409250,0.3396469", "l0.9404211,0.3408406", "l0.9384058,0.3379441", "l0.9358478,0.3399804", "l0.9350468,0.3378914", "l0.9319333,0.3352583", "l0.9319978,0.3343454", "l0.9301762,0.3341172", "l0.9294399,0.3328182", "l0.9291944,0.3303254", "l0.9286518,0.3302025", "l0.9278637,0.3257612", "l0.9271402,0.3243217", "l0.9275537,0.3229700", "l0.9273599,0.3213023", "l0.9258096,0.3234089", "l0.9257321,0.3243744", "l0.9244918,0.3250239", "l0.9232128,0.3276220", "l0.9221018,0.3271480", "l0.9217271,0.3228647", "l0.9207453,0.3218114", "l0.9194533,0.3228998", "l0.9193629,0.3224258", "l0.9180581,0.3239531", "l0.9181614,0.3257085", "l0.9173863,0.3264985", "l0.9134589,0.3265336", "l0.9111851,0.3289386", "l0.9094668,0.3284646", "l0.9088984,0.3293599", "l0.9087950,0.3323793", "l0.9091955,0.3340470", "l0.9087304,0.3357498", "l0.9054877,0.3374350", "l0.9045446,0.3364695", "l0.9033819,0.3366977", "l0.9026584,0.3353636", "l0.9016766,0.3311329", "l0.9009273,0.3307994", "l0.9014053,0.3301499", "l0.9003072,0.3262352", "l0.8996741,0.3260772", "l0.8975166,0.3190553", "l0.8966639,0.3178967", "l0.8967285,0.3111909", "l0.8961213,0.3084699", "l0.8950491,0.3070480", "l0.8924265,0.3096285", "l0.8917676,0.3122617", "l0.8901915,0.3114191", "l0.8899072,0.3119282", "l0.8900493,0.3133150", "l0.8906307,0.3139996", "l0.8900493,0.3151056", "l0.8905790,0.3152636", "l0.8907211,0.3160360", "l0.8903594,0.3172297", "l0.8898039,0.3170892", "l0.8906824,0.3186867", "l0.8897005,0.3194591", "l0.8893259,0.3190202", "l0.8890546,0.3197751", "l0.8874913,0.3207406", "l0.8862253,0.3201086", "l0.8855018,0.3205650", "l0.8847396,0.3197224", "l0.8844295,0.3166679", "l0.8839515,0.3175983", "l0.8825175,0.3163870", "l0.8827629,0.3140874", "l0.8805279,0.3104360", "l0.8809026,0.3092423", "l0.8801403,0.3071182", "l0.8815098,0.3066442", "l0.8816002,0.3051345", "l0.8793652,0.3032562", "l0.8787322,0.3036424", "l0.8772465,0.3031158", "l0.8769235,0.3042041", "l0.8755540,0.3028349", "l0.8753344,0.3035897", "l0.8742492,0.3037126", "l0.8734999,0.3052574", "l0.8731769,0.3043446", "l0.8733707,0.3008863", "l0.8725568,0.2990782", "l0.8725051,0.2973227", "l0.8727247,0.2954971", "l0.8739133,0.2942682", "l0.8740942,0.2932676", "l0.8721821,0.2894583", "l0.8720530,0.2876150", "l0.8693399,0.2875273", "l0.8688490,0.2863511", "l0.8676088,0.2860527", "l0.8655417,0.2839988", "l0.8649733,0.2845956", "l0.8633842,0.2845605", "l0.8622086,0.2860878", "l0.8611104,0.2859298", "l0.8611233,0.2867022", "l0.8603353,0.2874219", "l0.8594309,0.2871586", "l0.8590692,0.2876501", "l0.8573251,0.2865793", "l0.8566921,0.2869831", "l0.8562916,0.2863160", "l0.8558136,0.2865091", "l0.8556198,0.2856840", "l0.8548446,0.2857543", "l0.8538886,0.2843323", "l0.8533718,0.2845079", "l0.8531522,0.2833493", "l0.8523383,0.2828753", "l0.8519378,0.2813832", "l0.8514856,0.2812427", "l0.8517440,0.2782760", "l0.8513565,0.2758008", "l0.8499999,0.2756603", "l0.8482429,0.2770296", "l0.8473128,0.2765732", "l0.8476099,0.2775211", "l0.8459304,0.2794697", "l0.8449873,0.2784515", "l0.8448064,0.2794346", "l0.8442251,0.2786095", "l0.8422097,0.2790133", "l0.8415250,0.2797857", "l0.8406723,0.2781355", "l0.8407111,0.2762221", "l0.8392254,0.2763099", "l0.8386569,0.2749231", "l0.8379980,0.2766259", "l0.8381143,0.2777669", "l0.8375459,0.2781355", "l0.8365253,0.2781180", "l0.8362152,0.2772227", "l0.8340577,0.2782233", "l0.8332438,0.2776265", "l0.8326108,0.2789606", "l0.8313964,0.2773983", "l0.8301561,0.2779951", "l0.8294068,0.2762923", "l0.8294585,0.2746773", "l0.8280632,0.2744491", "l0.8280761,0.2733080", "l0.8274689,0.2730798", "l0.8273914,0.2719739", "l0.8262029,0.2723250", "l0.8258540,0.2700955", "l0.8246138,0.2692178", "l0.8249626,0.2684805", "l0.8238516,0.2679714", "l0.8237870,0.2673395", "l0.8247172,0.2666197", "l0.8242908,0.2656718", "l0.8248593,0.2649169", "l0.8245750,0.2637583", "l0.8236190,0.2632317", "l0.8229989,0.2619678", "l0.8238774,0.2607038", "l0.8236061,0.2597208", "l0.8244200,0.2594399", "l0.8237224,0.2582111", "l0.8237482,0.2551917", "l0.8231410,0.2549810", "l0.8230506,0.2511014", "l0.8221721,0.2520670", "l0.8221204,0.2506801", "l0.8212161,0.2506450", "l0.8201309,0.2518036", "l0.8173791,0.2522952", "l0.8167460,0.2529447", "l0.8156867,0.2520845", "l0.8134775,0.2531904", "l0.8113975,0.2515579", "l0.8102735,0.2523127", "l0.8102735,0.2523127", "l0.8076768,0.2468006", "l0.8072117,0.2442200", "l0.8074572,0.2419555", "l0.8082065,0.2416395", "l0.8082323,0.2404282", "l0.8087620,0.2409198", "l0.8103381,0.2406565", "l0.8110358,0.2413762", "l0.8117722,0.2406038", "l0.8119143,0.2390941", "l0.8171594,0.2381461", "l0.8177537,0.2342490", "l0.8168235,0.2338102", "l0.8174437,0.2332835", "l0.8172370,0.2317563", "l0.8167719,0.2316334", "l0.8165264,0.2338102", "l0.8155962,0.2338277", "l0.8152087,0.2328973", "l0.8160484,0.2295619", "l0.8140847,0.2298253", "l0.8125861,0.2278591", "l0.8125344,0.2291933", "l0.8136196,0.2301939", "l0.8133225,0.2324409", "l0.8109066,0.2329500", "l0.8100539,0.2363731", "l0.8075993,0.2371982", "l0.8073796,0.2359869", "l0.8056743,0.2340208", "l0.8056356,0.2294215", "l0.8041240,0.2300359", "l0.8036589,0.2288598", "l0.8048992,0.2263494", "l0.8010363,0.2240849", "l0.7974965,0.2168700", "l0.7992406,0.2148512", "l0.8004291,0.2106556", "l0.8035556,0.2080224", "l0.8048087,0.2062143", "l0.8103769,0.2019134", "l0.8124956,0.1965768", "l0.8168623,0.1939436", "l0.8192007,0.1895199", "l0.8237353,0.1828667", "l0.8281666,0.1777232", "l0.8289546,0.1792855", "l0.8286187,0.1799526", "l0.8291613,0.1811990", "l0.8287350,0.1822698", "l0.8291484,0.1829544", "l0.8287867,0.1832529", "l0.8295489,0.1849030", "l0.8294972,0.1858510", "l0.8306987,0.1873080", "l0.8304662,0.1890634", "l0.8315514,0.1898885", "l0.8306470,0.1924690", "l0.8320036,0.1912227", "l0.8331663,0.1854472", "l0.8321327,0.1829018", "l0.8323265,0.1803213", "l0.8327399,0.1799877", "l0.8326108,0.1775652", "l0.8321844,0.1771088", "l0.8325462,0.1762486", "l0.8329467,0.1763890", "l0.8335022,0.1743351", "l0.8337089,0.1704731", "l0.8343419,0.1696129", "l0.8343032,0.1679452", "l0.8350912,0.1673308", "l0.8351817,0.1646625", "l0.8358793,0.1646801", "l0.8363573,0.1616782", "l0.8370937,0.1605021", "l0.8368224,0.1581849", "l0.8383339,0.1559028", "l0.8397809,0.1565523", "l0.8406077,0.1560432", "l0.8405690,0.1567630", "l0.8418867,0.1577460", "l0.8430882,0.1556921", "l0.8436179,0.1556219", "l0.8435016,0.1534276", "l0.8438246,0.1532345", "l0.8434887,0.1524796", "l0.8442509,0.1513561", "l0.8443930,0.1466691", "l0.8433595,0.1438252", "l0.8438892,0.1438077", "l0.8438246,0.1418942", "l0.8434112,0.1419118", "l0.8428557,0.1405601", "l0.8423518,0.1409814", "l0.8420934,0.1400861", "l0.8425585,0.1390679", "l0.8431657,0.1406127", "l0.8436050,0.1393137", "l0.8436825,0.1373300", "l0.8432820,0.1369087", "l0.8437083,0.1348197", "l0.8428815,0.1337313", "l0.8437083,0.1335207", "l0.8439409,0.1330993", "l0.8435533,0.1326254", "l0.8440184,0.1323445", "l0.8436696,0.1304661", "l0.8429461,0.1293778", "l0.8438633,0.1292724", "l0.8439279,0.1282543", "l0.8447548,0.1277803", "l0.8448452,0.1269026", "l0.8440442,0.1262179", "l0.8454912,0.1259195", "l0.8444576,0.1252700", "l0.8445739,0.1235672", "l0.8450519,0.1230405", "l0.8453749,0.1239007", "l0.8454653,0.1231459", "l0.8461371,0.1231283", "l0.8454653,0.1222155", "l0.8463955,0.1218819", "l0.8463309,0.1210920", "l0.8470285,0.1210744", "l0.8470802,0.1200212", "l0.8475970,0.1200738", "l0.8472094,0.1190381", "l0.8476487,0.1186870", "l0.8475195,0.1177917", "l0.8485272,0.1172124", "l0.8484109,0.1159660", "l0.8489664,0.1155623", "l0.8484884,0.1152287", "l0.8487597,0.1146846", "l0.8483075,0.1138595", "l0.8486564,0.1133680", "l0.8493927,0.1140877", "l0.8491860,0.1127009", "l0.8496511,0.1128764", "l0.8497545,0.1122445", "l0.8503358,0.1126131", "l0.8507880,0.1114896", "l0.8514986,0.1112263", "l0.8510852,0.1107699", "l0.8520541,0.1098395", "l0.8522866,0.1104714", "l0.8525321,0.1094884", "l0.8535010,0.1089618", "l0.8529068,0.1043976", "l0.8534881,0.1035549", "l0.8527001,0.1028001", "l0.8529972,0.1021681", "l0.8523642,0.1018697", "l0.8529197,0.1010973", "l0.8538111,0.1015888", "l0.8535915,0.1004653", "l0.8541212,0.1004829", "l0.8551289,0.0989205", "l0.8546767,0.0980428", "l0.8556456,0.0981130", "l0.8557619,0.0966735", "l0.8563691,0.0975513", "l0.8563303,0.0964980", "l0.8568213,0.0965857", "l0.8566792,0.0957256", "l0.8570796,0.0958133", "l0.8576998,0.0942861", "l0.8569117,0.0930046", "l0.8569892,0.0920567", "l0.8573639,0.0920040", "l0.8560203,0.0902485", "l0.8563303,0.0888617", "l0.8553743,0.0893006", "l0.8553485,0.0885808", "l0.8541470,0.0880718", "l0.8544183,0.0877207", "l0.8539661,0.0857370", "l0.8522996,0.0850173", "l0.8524546,0.0839991", "l0.8514081,0.0814537", "l0.8457366,0.0710789", "l0.8451682,0.0715880", "l0.8446127,0.0706049", "l0.8422097,0.0707278", "l0.8419771,0.0697623", "l0.8412149,0.0708507", "l0.8409824,0.0741158", "l0.8388378,0.0755553", "l0.8390703,0.0773459", "l0.8379980,0.0796280", "l0.8362927,0.0793822", "l0.8355951,0.0809446", "l0.8340060,0.0816292", "l0.8330758,0.0800844", "l0.8316935,0.0797333", "l0.8308150,0.0806813", "l0.8303111,0.0835778", "l0.8293680,0.0835778", "l0.8292259,0.0828229", "l0.8281278,0.0822963", "l0.8273527,0.0808217", "l0.8252985,0.0810675", "l0.8248593,0.0818574", "l0.8235932,0.0817697", "l0.8224821,0.0825596", "l0.8211127,0.0801897", "l0.8203376,0.0804180", "l0.8190844,0.0790662", "l0.8181671,0.0818925", "l0.8164876,0.0829809", "l0.8151053,0.0829458", "l0.8147177,0.0835778", "l0.8129090,0.0835602", "l0.8121081,0.0843151", "l0.8084907,0.0818399", "l0.8073926,0.0821207", "l0.8068241,0.0809446", "l0.8067595,0.0792418", "l0.8057906,0.0784518", "l0.8057518,0.0774337", "l0.8050025,0.0762751", "l0.8055064,0.0739754", "l0.8046279,0.0724657", "l0.8050284,0.0716933", "l0.8032843,0.0667956", "l0.8036460,0.0655141", "l0.8025737,0.0615643", "l0.8028967,0.0583694", "l0.8020957,0.0583343", "l0.8016694,0.0554904", "l0.8012430,0.0552095", "l0.8013464,0.0526992", "l0.8030905,0.0520848", "l0.8036202,0.0511895", "l0.8038915,0.0485037", "l0.8035039,0.0479946", "l0.8026512,0.0483808", "l0.8021345,0.0476435", "l0.8006100,0.0480121", "l0.7988530,0.0469413", "l0.7989176,0.0450630", "l0.7983362,0.0433953", "l0.7977032,0.0439921", "l0.7966438,0.0427106", "l0.7961141,0.0404461", "l0.7944346,0.0406568", "l0.7937499,0.0390066", "l0.7923547,0.0417276", "l0.7925355,0.0422016", "l0.7917087,0.0427106", "l0.7916183,0.0439921", "l0.7901972,0.0468535", "l0.7895641,0.0474679", "l0.7883497,0.0473802", "l0.7863731,0.0461338", "l0.7853008,0.0416223", "l0.7831821,0.0411132", "l0.7813217,0.0386731", "l0.7806241,0.0384975", "l0.7799910,0.0369703", "l0.7783632,0.0367947", "l0.7778464,0.0360574", "l0.7795389,0.0336174", "l0.7809987,0.0326694", "l0.7826136,0.0295447", "l0.7845386,0.0272801", "l0.7846161,0.0252614", "l0.7854171,0.0245943", "l0.7863343,0.0214871", "l0.7875487,0.0205216", "l0.7880397,0.0188539", "l0.7873420,0.0178007", "l0.7869674,0.0157994", "l0.7865152,0.0159048", "l0.7853783,0.0145706", "l0.7857530,0.0139562", "l0.7856109,0.0121130", "l0.7846548,0.0116214", "l0.7828203,0.0089882", "l0.7828203,0.0089882", "l0.7888536,0.0055826", "l0.7924063,0.0056529", "l0.7934140,0.0039325", "l0.7950677,0.0040729", "l0.7963338,0.0027739", "l0.7982070,0.0048980", "l0.8016435,0.0041081", "l0.8047700,0.0044767", "l0.8081031,0.0022999", "l0.8097309,0.0025984", "l0.8108161,0.0008078", "l0.8116817,0.0004567", "l0.8147048,0.0015977", "c"]}, {"n": "Hunan", "u": "CN-43", "i": ["m0.5826767,0.7342570", "l0.5833614,0.7339235", "l0.5830901,0.7316063", "l0.5846017,0.7299561", "l0.5844337,0.7283236", "l0.5851572,0.7275336", "l0.5849376,0.7265154", "l0.5856740,0.7258484", "l0.5855577,0.7247424", "l0.5860615,0.7249180", "l0.5859323,0.7238647", "l0.5864491,0.7242685", "l0.5873276,0.7216177", "l0.5880640,0.7218986", "l0.5887487,0.7212315", "l0.5896401,0.7221970", "l0.5905962,0.7218986", "l0.5902473,0.7203889", "l0.5913196,0.7198271", "l0.5915005,0.7181594", "l0.5930379,0.7176679", "l0.5970170,0.7172993", "l0.5991745,0.7187563", "l0.6000142,0.7204767", "l0.6007894,0.7204064", "l0.6011769,0.7212491", "l0.6023913,0.7204591", "l0.6027272,0.7193180", "l0.6038512,0.7196691", "l0.6056470,0.7176855", "l0.6051948,0.7161933", "l0.6041096,0.7155965", "l0.6034378,0.7141745", "l0.6042259,0.7122260", "l0.6033086,0.7112078", "l0.6037220,0.7104881", "l0.6058149,0.7099614", "l0.6067709,0.7109972", "l0.6073394,0.7108216", "l0.6074944,0.7089433", "l0.6086571,0.7087326", "l0.6102591,0.7090837", "l0.6103495,0.7102774", "l0.6155947,0.7108918", "l0.6172096,0.7133846", "l0.6176618,0.7130862", "l0.6178943,0.7140517", "l0.6200777,0.7137708", "l0.6204782,0.7146836", "l0.6222739,0.7147363", "l0.6236821,0.7139814", "l0.6271832,0.7160704", "l0.6274028,0.7172642", "l0.6288110,0.7184579", "l0.6289015,0.7177557", "l0.6289144,0.7200202", "l0.6307231,0.7205469", "l0.6310460,0.7214246", "l0.6318212,0.7205293", "l0.6316532,0.7215826", "l0.6327772,0.7225305", "l0.6325059,0.7247424", "l0.6330873,0.7235312", "l0.6338366,0.7236891", "l0.6343663,0.7230396", "l0.6351543,0.7212491", "l0.6365754,0.7220741", "l0.6371180,0.7215124", "l0.6389784,0.7222146", "l0.6423374,0.7170360", "l0.6431125,0.7198622", "l0.6445724,0.7177381", "l0.6443528,0.7194585", "l0.6427120,0.7211964", "l0.6431771,0.7252515", "l0.6447920,0.7244264", "l0.6453992,0.7263223", "l0.6456189,0.7256728", "l0.6462906,0.7260941", "l0.6502697,0.7195112", "l0.6534479,0.7157896", "l0.6530990,0.7200378", "l0.6549852,0.7200553", "l0.6550498,0.7211262", "l0.6555924,0.7212666", "l0.6561609,0.7226534", "l0.6544168,0.7240753", "l0.6553341,0.7243387", "l0.6563805,0.7259010", "l0.6560704,0.7272176", "l0.6549465,0.7276565", "l0.6539646,0.7306232", "l0.6554632,0.7313605", "l0.6548173,0.7331335", "l0.6553341,0.7350821", "l0.6559671,0.7345379", "l0.6562126,0.7357141", "l0.6574657,0.7346257", "l0.6579954,0.7357667", "l0.6584734,0.7355385", "l0.6584605,0.7363636", "l0.6595845,0.7361003", "l0.6595845,0.7361003", "l0.6598816,0.7385930", "l0.6605663,0.7384175", "l0.6608635,0.7396990", "l0.6615094,0.7399096", "l0.6615482,0.7411735", "l0.6629047,0.7417177", "l0.6625559,0.7472123", "l0.6618324,0.7485991", "l0.6639511,0.7502317", "l0.6633310,0.7514781", "l0.6646746,0.7525138", "l0.6646229,0.7541991", "l0.6619616,0.7577802", "l0.6603596,0.7580084", "l0.6610572,0.7610980", "l0.6598041,0.7613438", "l0.6591323,0.7625199", "l0.6581634,0.7621337", "l0.6579566,0.7628710", "l0.6565743,0.7638365", "l0.6560963,0.7653111", "l0.6566001,0.7673475", "l0.6541197,0.7714904", "l0.6535771,0.7738602", "l0.6543780,0.7745624", "l0.6537967,0.7756157", "l0.6544426,0.7770552", "l0.6539905,0.7776871", "l0.6542230,0.7786877", "l0.6555795,0.7790213", "l0.6584605,0.7777749", "l0.6581117,0.7796884", "l0.6583959,0.7801974", "l0.6567681,0.7847265", "l0.6573494,0.7848494", "l0.6575691,0.7863416", "l0.6593261,0.7884832", "l0.6578791,0.7921346", "l0.6583055,0.7958210", "l0.6590548,0.7967866", "l0.6624913,0.7974361", "l0.6619228,0.8018247", "l0.6610572,0.8025796", "l0.6610960,0.8043350", "l0.6595457,0.8078811", "l0.6600625,0.8082322", "l0.6611606,0.8073193", "l0.6618712,0.8079513", "l0.6633310,0.8068102", "l0.6639511,0.8070560", "l0.6643129,0.8082497", "l0.6622716,0.8094961", "l0.6621166,0.8102860", "l0.6612510,0.8101632", "l0.6606955,0.8116378", "l0.6610185,0.8138496", "l0.6591194,0.8187649", "l0.6603596,0.8227674", "l0.6595715,0.8247510", "l0.6599333,0.8253303", "l0.6599333,0.8253303", "l0.6587060,0.8258394", "l0.6576337,0.8284200", "l0.6567293,0.8284726", "l0.6565226,0.8276300", "l0.6565226,0.8276300", "l0.6536416,0.8288413", "l0.6536416,0.8288413", "l0.6536287,0.8280689", "l0.6530086,0.8275598", "l0.6514325,0.8276651", "l0.6502310,0.8267172", "l0.6500114,0.8257692", "l0.6492104,0.8255761", "l0.6490424,0.8237855", "l0.6487840,0.8242946", "l0.6479960,0.8239084", "l0.6468074,0.8245755", "l0.6462906,0.8264187", "l0.6458385,0.8262959", "l0.6444561,0.8280162", "l0.6432934,0.8281918", "l0.6430350,0.8289993", "l0.6419240,0.8283322", "l0.6420273,0.8304212", "l0.6438489,0.8302632", "l0.6447274,0.8317027", "l0.6436293,0.8326331", "l0.6443786,0.8344061", "l0.6438102,0.8358280", "l0.6444044,0.8369515", "l0.6442882,0.8381452", "l0.6419111,0.8389527", "l0.6405804,0.8389527", "l0.6406062,0.8378819", "l0.6399861,0.8373728", "l0.6399473,0.8364249", "l0.6393401,0.8361791", "l0.6396631,0.8349678", "l0.6385779,0.8332299", "l0.6366917,0.8333353", "l0.6353998,0.8327911", "l0.6351156,0.8320011", "l0.6343404,0.8329666", "l0.6337720,0.8317553", "l0.6321054,0.8325453", "l0.6312657,0.8315096", "l0.6303226,0.8359860", "l0.6297541,0.8368286", "l0.6306843,0.8385139", "l0.6303872,0.8403571", "l0.6295474,0.8405502", "l0.6282167,0.8427796", "l0.6282167,0.8427796", "l0.6272349,0.8420423", "l0.6258009,0.8423232", "l0.6230620,0.8416737", "l0.6220285,0.8429552", "l0.6219768,0.8441489", "l0.6211629,0.8439031", "l0.6207365,0.8452197", "l0.6186824,0.8444473", "l0.6193671,0.8413050", "l0.6188762,0.8398656", "l0.6192121,0.8381101", "l0.6185791,0.8370568", "l0.6191863,0.8359158", "l0.6183723,0.8353891", "l0.6186695,0.8340023", "l0.6179977,0.8332650", "l0.6171579,0.8340901", "l0.6159306,0.8329139", "l0.6145741,0.8348274", "l0.6131659,0.8357051", "l0.6131401,0.8378117", "l0.6123391,0.8382330", "l0.6114994,0.8383383", "l0.6108534,0.8364424", "l0.6106854,0.8352136", "l0.6114994,0.8325453", "l0.6132434,0.8311760", "l0.6131659,0.8295083", "l0.6163957,0.8256288", "l0.6170933,0.8216790", "l0.6166024,0.8208013", "l0.6165249,0.8189931", "l0.6187341,0.8176063", "l0.6184886,0.8160440", "l0.6195867,0.8153242", "l0.6169512,0.8144465", "l0.6161632,0.8156051", "l0.6151684,0.8145518", "l0.6148713,0.8118484", "l0.6159435,0.8087764", "l0.6162665,0.8057745", "l0.6159048,0.8054761", "l0.6148971,0.8054234", "l0.6143028,0.8044930", "l0.6115510,0.8040717", "l0.6111118,0.8024918", "l0.6106079,0.8029307", "l0.6103237,0.8056692", "l0.6099491,0.8052128", "l0.6077140,0.8058096", "l0.6072360,0.8053181", "l0.6073911,0.8042122", "l0.6068872,0.8047563", "l0.6052852,0.8037206", "l0.6046910,0.8054234", "l0.6041354,0.8054761", "l0.6035670,0.8075826", "l0.6029727,0.8075475", "l0.6014353,0.8096190", "l0.6005956,0.8125330", "l0.5994199,0.8128490", "l0.5992907,0.8113744", "l0.5984898,0.8102509", "l0.5978180,0.8114798", "l0.5963969,0.8108478", "l0.5966940,0.8077757", "l0.5957380,0.8080566", "l0.5947432,0.8070911", "l0.5937743,0.8083375", "l0.5931541,0.8111462", "l0.5922627,0.8109005", "l0.5918881,0.8114798", "l0.5924565,0.8139550", "l0.5918235,0.8151662", "l0.5911517,0.8146220", "l0.5897564,0.8148502", "l0.5907512,0.8123048", "l0.5896014,0.8115500", "l0.5894205,0.8107951", "l0.5875860,0.8120240", "l0.5868367,0.8111989", "l0.5868367,0.8111989", "l0.5866041,0.8100227", "l0.5872759,0.8089343", "l0.5862812,0.8073193", "l0.5866429,0.8069858", "l0.5861390,0.8060554", "l0.5867850,0.8046861", "l0.5863587,0.8042999", "l0.5863199,0.8048968", "l0.5844854,0.8056867", "l0.5834002,0.8038611", "l0.5842270,0.8014912", "l0.5851830,0.8007363", "l0.5848859,0.8002975", "l0.5856481,0.7987000", "l0.5847954,0.7957333", "l0.5840461,0.7957333", "l0.5836069,0.7947151", "l0.5848859,0.7948204", "l0.5862166,0.7932581", "l0.5874310,0.7932054", "l0.5870951,0.7917308", "l0.5873793,0.7903791", "l0.5868625,0.7898174", "l0.5861132,0.7902562", "l0.5880640,0.7885710", "l0.5873534,0.7854638", "l0.5865008,0.7856043", "l0.5867075,0.7839366", "l0.5861907,0.7843579", "l0.5854285,0.7832519", "l0.5834519,0.7841121", "l0.5830514,0.7834626", "l0.5817594,0.7854638", "l0.5807130,0.7854638", "l0.5809197,0.7842350", "l0.5793565,0.7850250", "l0.5782325,0.7860256", "l0.5780904,0.7868331", "l0.5770181,0.7873422", "l0.5755324,0.7852883", "l0.5770440,0.7845685", "l0.5776770,0.7832168", "l0.5774444,0.7819880", "l0.5800024,0.7801097", "l0.5797957,0.7791442", "l0.5807905,0.7784595", "l0.5812685,0.7763179", "l0.5815527,0.7769674", "l0.5823925,0.7761248", "l0.5830126,0.7769323", "l0.5839040,0.7767918", "l0.5840074,0.7753875", "l0.5864879,0.7730001", "l0.5861390,0.7689274", "l0.5852347,0.7690678", "l0.5841624,0.7678917", "l0.5846533,0.7666277", "l0.5839686,0.7635908", "l0.5851830,0.7617124", "l0.5847567,0.7609751", "l0.5840461,0.7614842", "l0.5839169,0.7610805", "l0.5852735,0.7557614", "l0.5847825,0.7559019", "l0.5846921,0.7551119", "l0.5839040,0.7555332", "l0.5834777,0.7545502", "l0.5835035,0.7499157", "l0.5835035,0.7499157", "l0.5842528,0.7476512", "l0.5837748,0.7469841", "l0.5823021,0.7474405", "l0.5820307,0.7469139", "l0.5834260,0.7457728", "l0.5831676,0.7451233", "l0.5839945,0.7441403", "l0.5829738,0.7429641", "l0.5828834,0.7404714", "l0.5842528,0.7362231", "l0.5827671,0.7350470", "l0.5826767,0.7342570", "c", "m0.5878315,0.7942236", "l0.5877152,0.7935214", "l0.5883999,0.7930825", "l0.5883482,0.7939778", "l0.5883482,0.7939778", "l0.5878315,0.7942236", "c"]}, {"n": "Hubei", "u": "CN-42", "i": ["m0.5883482,0.6674266", "l0.5885291,0.6659169", "l0.5892784,0.6653376", "l0.5884128,0.6630204", "l0.5891621,0.6618969", "l0.5884516,0.6597728", "l0.5890200,0.6577540", "l0.5884774,0.6565252", "l0.5887229,0.6550682", "l0.5878444,0.6545766", "l0.5869400,0.6526105", "l0.5874568,0.6491172", "l0.5882965,0.6471159", "l0.5892526,0.6463084", "l0.5889683,0.6449392", "l0.5905445,0.6445178", "l0.5921981,0.6453605", "l0.5937226,0.6449567", "l0.5954667,0.6461504", "l0.5965519,0.6452727", "l0.5966552,0.6443247", "l0.5978696,0.6449216", "l0.5985544,0.6439034", "l0.5977017,0.6424113", "l0.5974821,0.6392866", "l0.5956088,0.6376013", "l0.5930120,0.6365656", "l0.5918622,0.6374433", "l0.5913325,0.6366885", "l0.5917718,0.6324227", "l0.5900923,0.6311939", "l0.5882707,0.6313519", "l0.5860228,0.6302635", "l0.5871338,0.6281921", "l0.5886712,0.6281394", "l0.5892396,0.6269983", "l0.5895109,0.6277005", "l0.5905703,0.6281218", "l0.5927666,0.6277356", "l0.5956863,0.6292102", "l0.5978696,0.6287538", "l0.5989807,0.6300704", "l0.6021330,0.6297369", "l0.6043809,0.6275425", "l0.6050010,0.6301933", "l0.6059183,0.6301933", "l0.6067839,0.6317381", "l0.6073523,0.6303864", "l0.6085279,0.6302986", "l0.6087605,0.6288065", "l0.6100912,0.6288240", "l0.6112280,0.6274723", "l0.6112280,0.6274723", "l0.6124166,0.6291927", "l0.6121453,0.6301406", "l0.6130238,0.6295087", "l0.6146129,0.6319839", "l0.6139152,0.6331600", "l0.6153880,0.6331951", "l0.6159565,0.6350032", "l0.6154655,0.6359161", "l0.6155818,0.6373029", "l0.6161632,0.6368640", "l0.6162407,0.6378998", "l0.6177005,0.6387775", "l0.6182819,0.6405681", "l0.6191475,0.6402170", "l0.6183853,0.6413580", "l0.6198322,0.6427624", "l0.6208399,0.6449216", "l0.6219510,0.6438508", "l0.6220414,0.6446056", "l0.6232687,0.6446583", "l0.6260205,0.6472915", "l0.6270411,0.6469404", "l0.6279067,0.6485379", "l0.6287723,0.6481165", "l0.6302451,0.6503811", "l0.6315757,0.6502231", "l0.6331002,0.6519259", "l0.6336945,0.6508200", "l0.6350510,0.6512413", "l0.6367951,0.6499422", "l0.6402832,0.6514344", "l0.6420273,0.6500476", "l0.6421694,0.6506620", "l0.6426991,0.6502407", "l0.6439523,0.6507146", "l0.6440040,0.6497316", "l0.6445724,0.6493454", "l0.6464328,0.6505742", "l0.6467945,0.6495034", "l0.6476084,0.6492751", "l0.6495592,0.6514519", "l0.6493396,0.6519083", "l0.6499209,0.6527334", "l0.6510449,0.6533127", "l0.6540292,0.6513115", "l0.6538742,0.6509253", "l0.6543522,0.6510833", "l0.6550240,0.6495034", "l0.6560963,0.6496087", "l0.6562772,0.6510482", "l0.6567422,0.6509955", "l0.6562384,0.6539622", "l0.6569360,0.6552613", "l0.6566777,0.6571396", "l0.6561092,0.6572098", "l0.6570135,0.6594042", "l0.6564839,0.6605803", "l0.6574011,0.6612649", "l0.6579825,0.6644248", "l0.6586543,0.6643721", "l0.6590806,0.6635822", "l0.6596749,0.6641088", "l0.6596103,0.6656360", "l0.6601012,0.6667420", "l0.6619228,0.6659345", "l0.6625817,0.6646003", "l0.6633698,0.6642668", "l0.6643775,0.6647934", "l0.6653206,0.6669351", "l0.6678656,0.6674266", "l0.6686925,0.6672862", "l0.6688087,0.6664436", "l0.6691963,0.6672160", "l0.6698810,0.6665313", "l0.6695710,0.6719206", "l0.6707337,0.6711131", "l0.6718447,0.6726228", "l0.6731108,0.6728510", "l0.6732917,0.6737814", "l0.6741185,0.6744485", "l0.6763664,0.6734654", "l0.6768186,0.6742027", "l0.6771674,0.6727808", "l0.6785110,0.6729388", "l0.6788340,0.6709551", "l0.6793637,0.6707093", "l0.6806427,0.6720259", "l0.6803972,0.6754140", "l0.6818442,0.6764672", "l0.6828389,0.6759230", "l0.6828389,0.6759230", "l0.6831232,0.6774152", "l0.6838854,0.6772923", "l0.6843247,0.6781876", "l0.6843763,0.6793462", "l0.6854099,0.6797851", "l0.6862496,0.6825411", "l0.6875028,0.6808910", "l0.6882392,0.6811368", "l0.6893760,0.6834189", "l0.6910685,0.6825411", "l0.6921537,0.6851919", "l0.6938719,0.6859292", "l0.6943370,0.6872458", "l0.6909651,0.6897736", "l0.6905517,0.6905812", "l0.6909651,0.6921084", "l0.6895440,0.6926350", "l0.6892081,0.6944432", "l0.6899574,0.6954438", "l0.6900608,0.6967077", "l0.6910168,0.6968833", "l0.6917273,0.6986914", "l0.6914173,0.7003591", "l0.6922183,0.7010788", "l0.6912364,0.7021672", "l0.6917661,0.7033785", "l0.6915723,0.7040104", "l0.6928255,0.7043791", "l0.6930451,0.7054324", "l0.6941949,0.7067138", "l0.6946212,0.7110147", "l0.6943370,0.7128755", "l0.6952930,0.7147714", "l0.6953318,0.7164566", "l0.6953318,0.7164566", "l0.6939107,0.7183525", "l0.6919599,0.7190021", "l0.6903191,0.7181594", "l0.6878645,0.7156667", "l0.6851386,0.7160178", "l0.6845830,0.7168604", "l0.6844797,0.7185632", "l0.6815083,0.7214948", "l0.6811465,0.7205820", "l0.6793379,0.7206171", "l0.6785885,0.7200378", "l0.6791311,0.7208804", "l0.6789890,0.7221443", "l0.6796221,0.7223023", "l0.6793766,0.7242685", "l0.6780201,0.7239700", "l0.6783818,0.7230747", "l0.6768186,0.7227939", "l0.6759660,0.7236189", "l0.6760951,0.7245669", "l0.6752037,0.7238647", "l0.6746611,0.7251286", "l0.6750875,0.7260064", "l0.6754750,0.7250760", "l0.6758755,0.7254095", "l0.6749453,0.7273405", "l0.6744286,0.7270947", "l0.6727749,0.7280954", "l0.6724390,0.7273230", "l0.6714701,0.7272703", "l0.6688346,0.7291135", "l0.6661732,0.7290784", "l0.6654627,0.7281129", "l0.6648426,0.7283762", "l0.6645325,0.7313254", "l0.6615611,0.7320100", "l0.6597524,0.7348012", "l0.6595845,0.7361354", "l0.6595845,0.7361354", "l0.6584605,0.7363987", "l0.6584863,0.7355736", "l0.6580083,0.7358018", "l0.6574786,0.7346608", "l0.6562255,0.7357667", "l0.6559800,0.7345906", "l0.6553599,0.7351348", "l0.6548302,0.7331862", "l0.6554891,0.7314132", "l0.6539905,0.7306759", "l0.6549723,0.7277092", "l0.6560834,0.7272703", "l0.6564063,0.7259712", "l0.6553599,0.7243913", "l0.6544426,0.7241280", "l0.6561867,0.7227061", "l0.6556183,0.7213193", "l0.6550757,0.7211613", "l0.6550111,0.7200905", "l0.6531120,0.7200729", "l0.6534608,0.7158422", "l0.6502827,0.7195463", "l0.6463036,0.7261292", "l0.6456318,0.7257079", "l0.6454251,0.7263750", "l0.6448049,0.7244616", "l0.6432030,0.7252866", "l0.6427379,0.7212315", "l0.6443786,0.7194936", "l0.6445853,0.7177732", "l0.6431255,0.7198974", "l0.6423503,0.7170711", "l0.6389784,0.7222497", "l0.6371180,0.7215475", "l0.6365754,0.7221092", "l0.6351543,0.7212842", "l0.6343533,0.7230572", "l0.6338237,0.7237067", "l0.6330873,0.7235487", "l0.6324930,0.7247600", "l0.6327643,0.7225481", "l0.6316532,0.7216001", "l0.6318083,0.7205293", "l0.6310331,0.7214246", "l0.6307231,0.7205644", "l0.6289144,0.7200378", "l0.6288885,0.7177732", "l0.6287981,0.7184754", "l0.6273899,0.7172817", "l0.6271703,0.7160880", "l0.6236821,0.7139990", "l0.6222610,0.7147539", "l0.6204652,0.7147012", "l0.6200777,0.7137883", "l0.6178943,0.7140692", "l0.6176618,0.7130862", "l0.6172096,0.7133846", "l0.6155818,0.7108918", "l0.6103366,0.7102774", "l0.6102591,0.7090837", "l0.6086571,0.7087326", "l0.6074815,0.7089433", "l0.6073394,0.7108216", "l0.6067709,0.7109972", "l0.6058149,0.7099439", "l0.6037220,0.7104705", "l0.6033086,0.7112078", "l0.6042259,0.7122260", "l0.6034507,0.7141745", "l0.6041096,0.7155789", "l0.6052077,0.7161758", "l0.6056599,0.7176679", "l0.6038641,0.7196691", "l0.6027402,0.7193180", "l0.6023913,0.7204591", "l0.6011899,0.7212315", "l0.6008023,0.7203889", "l0.6000271,0.7204767", "l0.5992003,0.7187387", "l0.5970299,0.7172993", "l0.5930637,0.7176679", "l0.5915263,0.7181594", "l0.5913455,0.7198271", "l0.5902732,0.7203889", "l0.5906091,0.7218986", "l0.5896660,0.7221970", "l0.5887746,0.7212315", "l0.5880769,0.7218986", "l0.5873534,0.7216177", "l0.5864620,0.7242685", "l0.5859453,0.7238647", "l0.5860744,0.7249355", "l0.5855706,0.7247424", "l0.5856869,0.7258659", "l0.5849505,0.7265330", "l0.5851572,0.7275512", "l0.5844337,0.7283411", "l0.5846017,0.7299737", "l0.5830772,0.7316238", "l0.5833485,0.7339410", "l0.5826767,0.7342570", "l0.5826767,0.7342570", "l0.5807001,0.7322207", "l0.5810747,0.7306232", "l0.5806355,0.7298859", "l0.5806484,0.7281480", "l0.5800024,0.7273581", "l0.5784651,0.7289906", "l0.5774574,0.7291311", "l0.5778449,0.7267612", "l0.5766435,0.7253919", "l0.5772894,0.7222497", "l0.5767339,0.7222848", "l0.5769535,0.7214948", "l0.5764109,0.7208629", "l0.5754549,0.7212842", "l0.5754032,0.7203011", "l0.5749252,0.7209506", "l0.5743051,0.7198096", "l0.5736333,0.7197920", "l0.5732845,0.7157194", "l0.5722122,0.7155965", "l0.5712045,0.7173870", "l0.5713337,0.7186685", "l0.5708428,0.7193180", "l0.5696930,0.7187036", "l0.5694087,0.7167024", "l0.5690599,0.7161582", "l0.5687886,0.7166322", "l0.5689049,0.7154034", "l0.5696542,0.7149294", "l0.5710495,0.7152980", "l0.5713337,0.7122260", "l0.5711657,0.7104881", "l0.5707523,0.7106285", "l0.5717342,0.7083289", "l0.5719150,0.7056430", "l0.5690987,0.7020268", "l0.5694862,0.6994989", "l0.5709203,0.6990951", "l0.5719021,0.6998324", "l0.5731036,0.6981296", "l0.5728840,0.6970237", "l0.5738271,0.6969359", "l0.5745118,0.6992005", "l0.5759975,0.6992707", "l0.5782196,0.6960757", "l0.5795244,0.6951980", "l0.5807776,0.6953911", "l0.5802996,0.6975152", "l0.5811393,0.6983227", "l0.5838524,0.6957598", "l0.5845758,0.6975328", "l0.5845112,0.6993409", "l0.5863328,0.6960582", "l0.5876764,0.6947065", "l0.5883353,0.6951980", "l0.5884774,0.6940921", "l0.5894334,0.6936181", "l0.5897047,0.6923717", "l0.5915651,0.6901774", "l0.5935288,0.6891768", "l0.5946657,0.6896332", "l0.5952600,0.6889135", "l0.5955442,0.6906338", "l0.5965002,0.6914238", "l0.5979472,0.6867191", "l0.5972237,0.6854025", "l0.5971591,0.6838402", "l0.5983735,0.6825060", "l0.5975208,0.6761688", "l0.5943298,0.6739569", "l0.5948207,0.6729914", "l0.5932575,0.6726754", "l0.5922110,0.6716748", "l0.5907512,0.6720259", "l0.5911517,0.6704811", "l0.5908287,0.6682517", "c"]}, {"n": "Jilin", "u": "CN-22", "i": ["m0.8102735,0.2523127", "l0.8113975,0.2515579", "l0.8134775,0.2531904", "l0.8156867,0.2520845", "l0.8167460,0.2529447", "l0.8173791,0.2522952", "l0.8201309,0.2518036", "l0.8212161,0.2506450", "l0.8221204,0.2506801", "l0.8221721,0.2520670", "l0.8230506,0.2511014", "l0.8231410,0.2549810", "l0.8237482,0.2551917", "l0.8237224,0.2582111", "l0.8244200,0.2594399", "l0.8236061,0.2597208", "l0.8238774,0.2607038", "l0.8229989,0.2619678", "l0.8236190,0.2632317", "l0.8245750,0.2637583", "l0.8248593,0.2649169", "l0.8242908,0.2656718", "l0.8247172,0.2666197", "l0.8237870,0.2673395", "l0.8238516,0.2679714", "l0.8249626,0.2684805", "l0.8246138,0.2692178", "l0.8258540,0.2700955", "l0.8262029,0.2723250", "l0.8273914,0.2719739", "l0.8274689,0.2730798", "l0.8280761,0.2733080", "l0.8280632,0.2744491", "l0.8294585,0.2746773", "l0.8294068,0.2762923", "l0.8301561,0.2779951", "l0.8313964,0.2773983", "l0.8326108,0.2789606", "l0.8332438,0.2776265", "l0.8340577,0.2782233", "l0.8362152,0.2772227", "l0.8365253,0.2781180", "l0.8375459,0.2781355", "l0.8381143,0.2777669", "l0.8379980,0.2766259", "l0.8386569,0.2749231", "l0.8392254,0.2763099", "l0.8407111,0.2762221", "l0.8406723,0.2781355", "l0.8415250,0.2797857", "l0.8422097,0.2790133", "l0.8442251,0.2786095", "l0.8448064,0.2794346", "l0.8449873,0.2784515", "l0.8459304,0.2794697", "l0.8476099,0.2775211", "l0.8473128,0.2765732", "l0.8482429,0.2770296", "l0.8499999,0.2756603", "l0.8513565,0.2758008", "l0.8517440,0.2782760", "l0.8514856,0.2812427", "l0.8519378,0.2813832", "l0.8523383,0.2828753", "l0.8531522,0.2833493", "l0.8533718,0.2845079", "l0.8538886,0.2843323", "l0.8548446,0.2857543", "l0.8556198,0.2856840", "l0.8558136,0.2865091", "l0.8562916,0.2863160", "l0.8566921,0.2869831", "l0.8573251,0.2865793", "l0.8590692,0.2876501", "l0.8594309,0.2871586", "l0.8603353,0.2874219", "l0.8611233,0.2867022", "l0.8611104,0.2859298", "l0.8622086,0.2860878", "l0.8633842,0.2845605", "l0.8649733,0.2845956", "l0.8655417,0.2839988", "l0.8676088,0.2860527", "l0.8688490,0.2863511", "l0.8693399,0.2875273", "l0.8720530,0.2876150", "l0.8721821,0.2894583", "l0.8740942,0.2932676", "l0.8739133,0.2942682", "l0.8727247,0.2954971", "l0.8725051,0.2973227", "l0.8725568,0.2990782", "l0.8733707,0.3008863", "l0.8731769,0.3043446", "l0.8734999,0.3052574", "l0.8742492,0.3037126", "l0.8753344,0.3035897", "l0.8755540,0.3028349", "l0.8769235,0.3042041", "l0.8772465,0.3031158", "l0.8787322,0.3036424", "l0.8793652,0.3032562", "l0.8816002,0.3051345", "l0.8815098,0.3066442", "l0.8801403,0.3071182", "l0.8809026,0.3092423", "l0.8805279,0.3104360", "l0.8827629,0.3140874", "l0.8825175,0.3163870", "l0.8839515,0.3175983", "l0.8844295,0.3166679", "l0.8847396,0.3197224", "l0.8855018,0.3205650", "l0.8862253,0.3201086", "l0.8874913,0.3207406", "l0.8890546,0.3197751", "l0.8893259,0.3190202", "l0.8897005,0.3194591", "l0.8906824,0.3186867", "l0.8898039,0.3170892", "l0.8903594,0.3172297", "l0.8907211,0.3160360", "l0.8905790,0.3152636", "l0.8900493,0.3151056", "l0.8906307,0.3139996", "l0.8900493,0.3133150", "l0.8899072,0.3119282", "l0.8901915,0.3114191", "l0.8917676,0.3122617", "l0.8924265,0.3096285", "l0.8950491,0.3070480", "l0.8961213,0.3084699", "l0.8967285,0.3111909", "l0.8966639,0.3178967", "l0.8975166,0.3190553", "l0.8996741,0.3260772", "l0.9003072,0.3262352", "l0.9014053,0.3301499", "l0.9009273,0.3307994", "l0.9016766,0.3311329", "l0.9026584,0.3353636", "l0.9033819,0.3366977", "l0.9045446,0.3364695", "l0.9054877,0.3374350", "l0.9087304,0.3357498", "l0.9091955,0.3340470", "l0.9087950,0.3323793", "l0.9088984,0.3293599", "l0.9094668,0.3284646", "l0.9111851,0.3289386", "l0.9134589,0.3265336", "l0.9173863,0.3264985", "l0.9181614,0.3257085", "l0.9180581,0.3239531", "l0.9193629,0.3224258", "l0.9194533,0.3228998", "l0.9207453,0.3218114", "l0.9217271,0.3228647", "l0.9221018,0.3271480", "l0.9232128,0.3276220", "l0.9244918,0.3250239", "l0.9257321,0.3243744", "l0.9258096,0.3234089", "l0.9273599,0.3213023", "l0.9275537,0.3229700", "l0.9271402,0.3243217", "l0.9278637,0.3257612", "l0.9286518,0.3302025", "l0.9291944,0.3303254", "l0.9294399,0.3328182", "l0.9301762,0.3341172", "l0.9319978,0.3343454", "l0.9319333,0.3352583", "l0.9350468,0.3378914", "l0.9358478,0.3399804", "l0.9384058,0.3379441", "l0.9404211,0.3408406", "l0.9409250,0.3396469", "l0.9425916,0.3386638", "l0.9425916,0.3386638", "l0.9429921,0.3389798", "l0.9430696,0.3412970", "l0.9424236,0.3421748", "l0.9423073,0.3444569", "l0.9411963,0.3468970", "l0.9413772,0.3490737", "l0.9396589,0.3525847", "l0.9401498,0.3552881", "l0.9396460,0.3558849", "l0.9382507,0.3557094", "l0.9383670,0.3575351", "l0.9351630,0.3570611", "l0.9343491,0.3583426", "l0.9338324,0.3579739", "l0.9333931,0.3584655", "l0.9329280,0.3579037", "l0.9297112,0.3598698", "l0.9283676,0.3615726", "l0.9292590,0.3628541", "l0.9304217,0.3623099", "l0.9319333,0.3645569", "l0.9318428,0.3669092", "l0.9311710,0.3665757", "l0.9309256,0.3671901", "l0.9317911,0.3705255", "l0.9310031,0.3702446", "l0.9301892,0.3649782", "l0.9295045,0.3648378", "l0.9295045,0.3665581", "l0.9288843,0.3668741", "l0.9285355,0.3661368", "l0.9288327,0.3652064", "l0.9280058,0.3652415", "l0.9258096,0.3619062", "l0.9255641,0.3596592", "l0.9259904,0.3563413", "l0.9235229,0.3560254", "l0.9233549,0.3556567", "l0.9240009,0.3552354", "l0.9236521,0.3545508", "l0.9241430,0.3541295", "l0.9234841,0.3536028", "l0.9219597,0.3542348", "l0.9210682,0.3539188", "l0.9209390,0.3530586", "l0.9200735,0.3531288", "l0.9193242,0.3543050", "l0.9195309,0.3556216", "l0.9191174,0.3558849", "l0.9178901,0.3617131", "l0.9180452,0.3630648", "l0.9176317,0.3638547", "l0.9180968,0.3651362", "l0.9175801,0.3660842", "l0.9175284,0.3693142", "l0.9170891,0.3704377", "l0.9159523,0.3704026", "l0.9155518,0.3693844", "l0.9151125,0.3697706", "l0.9151900,0.3708239", "l0.9141565,0.3721580", "l0.9127095,0.3700164", "l0.9119473,0.3698057", "l0.9113401,0.3704201", "l0.9110171,0.3698057", "l0.9105650,0.3716665", "l0.9092730,0.3720176", "l0.9095444,0.3735800", "l0.9084204,0.3756514", "l0.9089501,0.3772138", "l0.9046997,0.3809178", "l0.9045317,0.3826557", "l0.9012503,0.3819009", "l0.9003847,0.3828488", "l0.8993770,0.3821291", "l0.8984597,0.3832350", "l0.8975941,0.3832877", "l0.8942093,0.3820764", "l0.8902431,0.3838143", "l0.8905144,0.3886769", "l0.8914575,0.3913628", "l0.8939638,0.3940311", "l0.8941318,0.3949615", "l0.8937701,0.3970329", "l0.8914317,0.4015796", "l0.8907857,0.4020184", "l0.8892871,0.4003332", "l0.8879048,0.3997715", "l0.8869358,0.4001401", "l0.8868712,0.4007896", "l0.8852305,0.4002103", "l0.8833572,0.4001928", "l0.8831893,0.4007018", "l0.8817811,0.3997363", "l0.8814969,0.3987533", "l0.8794556,0.3992975", "l0.8791456,0.3985251", "l0.8785384,0.3990868", "l0.8769106,0.3985953", "l0.8773369,0.3981038", "l0.8771302,0.3976298", "l0.8766522,0.3979282", "l0.8761096,0.3970505", "l0.8744301,0.3968749", "l0.8756574,0.3952248", "l0.8747531,0.3950142", "l0.8733578,0.3928725", "l0.8739908,0.3920474", "l0.8735903,0.3909590", "l0.8716008,0.3898882", "l0.8719108,0.3893440", "l0.8715749,0.3888525", "l0.8708385,0.3893440", "l0.8701668,0.3912750", "l0.8695854,0.3908010", "l0.8692753,0.3922756", "l0.8683710,0.3908362", "l0.8675183,0.3906782", "l0.8683452,0.3918543", "l0.8676217,0.3931534", "l0.8664073,0.3931007", "l0.8655934,0.3947333", "l0.8660197,0.3964185", "l0.8646890,0.4000172", "l0.8649862,0.4023169", "l0.8645211,0.4018253", "l0.8637589,0.4022818", "l0.8623507,0.4044059", "l0.8622473,0.4055820", "l0.8614851,0.4061262", "l0.8611492,0.4080046", "l0.8590692,0.4102164", "l0.8582811,0.4103920", "l0.8586170,0.4112171", "l0.8575318,0.4129023", "l0.8576223,0.4136747", "l0.8569375,0.4148509", "l0.8561365,0.4150791", "l0.8568213,0.4156233", "l0.8554389,0.4163781", "l0.8550772,0.4152897", "l0.8550772,0.4152897", "l0.8533718,0.4165537", "l0.8528938,0.4154828", "l0.8516536,0.4165888", "l0.8508009,0.4152546", "l0.8493798,0.4156057", "l0.8510335,0.4134641", "l0.8510981,0.4121299", "l0.8520153,0.4105675", "l0.8515632,0.4096547", "l0.8529843,0.4076710", "l0.8520670,0.4072673", "l0.8523125,0.4057049", "l0.8505167,0.4047921", "l0.8504263,0.4027382", "l0.8486176,0.4001577", "l0.8487080,0.3986831", "l0.8472998,0.3950317", "l0.8474161,0.3929603", "l0.8452845,0.3925214", "l0.8456204,0.3903095", "l0.8447677,0.3879221", "l0.8449098,0.3861140", "l0.8455558,0.3853065", "l0.8448323,0.3841654", "l0.8458917,0.3831297", "l0.8467314,0.3815498", "l0.8467056,0.3803736", "l0.8473386,0.3802507", "l0.8479587,0.3790395", "l0.8460338,0.3779511", "l0.8450777,0.3790395", "l0.8444189,0.3752828", "l0.8447806,0.3747386", "l0.8442638,0.3738608", "l0.8428298,0.3739311", "l0.8429719,0.3706132", "l0.8412537,0.3681380", "l0.8415896,0.3649431", "l0.8403623,0.3647500", "l0.8401943,0.3634861", "l0.8396388,0.3629770", "l0.8396000,0.3594134", "l0.8387474,0.3588165", "l0.8382435,0.3597118", "l0.8378043,0.3592379", "l0.8378947,0.3538661", "l0.8373650,0.3526022", "l0.8382306,0.3509345", "l0.8382177,0.3493371", "l0.8365899,0.3498461", "l0.8350137,0.3514963", "l0.8343161,0.3541997", "l0.8322361,0.3572542", "l0.8314093,0.3575351", "l0.8312026,0.3586234", "l0.8309442,0.3573771", "l0.8296264,0.3564818", "l0.8308150,0.3550072", "l0.8307116,0.3543226", "l0.8297815,0.3541646", "l0.8292259,0.3533571", "l0.8305049,0.3508643", "l0.8284508,0.3483891", "l0.8282570,0.3465634", "l0.8272751,0.3455628", "l0.8256732,0.3457208", "l0.8251176,0.3443691", "l0.8240583,0.3445973", "l0.8221204,0.3420694", "l0.8213065,0.3406124", "l0.8214486,0.3394187", "l0.8203763,0.3383128", "l0.8190456,0.3404544", "l0.8188260,0.3417535", "l0.8188260,0.3417535", "l0.8188648,0.3419466", "l0.8188648,0.3419466", "l0.8170690,0.3419641", "l0.8152991,0.3389798", "l0.8145110,0.3404193", "l0.8126636,0.3381548", "l0.8127411,0.3362940", "l0.8144464,0.3366100", "l0.8147436,0.3360131", "l0.8141880,0.3349774", "l0.8156996,0.3351705", "l0.8162293,0.3342576", "l0.8156221,0.3310803", "l0.8150019,0.3303079", "l0.8151957,0.3270954", "l0.8127411,0.3206353", "l0.8136842,0.3178616", "l0.8123406,0.3169663", "l0.8109066,0.3126479", "l0.8095888,0.3115244", "l0.8097180,0.3067671", "l0.8077672,0.3072762", "l0.8053126,0.3103658", "l0.8035556,0.3112260", "l0.8021345,0.3131219", "l0.7989822,0.3155269", "l0.7968376,0.3155795", "l0.7954423,0.3146843", "l0.7959203,0.3122617", "l0.7958816,0.3083646", "l0.7948997,0.3082768", "l0.7944992,0.3059772", "l0.7930135,0.3049239", "l0.7926906,0.3030455", "l0.7931427,0.3003421", "l0.7924451,0.2996751", "l0.7927293,0.2992011", "l0.7934915,0.2995346", "l0.7938145,0.2987622", "l0.7927552,0.2985516", "l0.7916183,0.2949704", "l0.7924839,0.2944438", "l0.7930135,0.2869480", "l0.7949514,0.2847712", "l0.7949772,0.2834195", "l0.7934528,0.2823311", "l0.7937241,0.2780478", "l0.7914891,0.2765205", "l0.7905847,0.2741331", "l0.7911144,0.2716403", "l0.7906106,0.2699200", "l0.7886727,0.2692003", "l0.7876908,0.2701658", "l0.7866315,0.2701833", "l0.7850424,0.2679890", "l0.7869803,0.2668128", "l0.7882205,0.2625646", "l0.7874583,0.2603352", "l0.7885177,0.2594574", "l0.7904039,0.2608794", "l0.7910240,0.2605107", "l0.7926130,0.2640216", "l0.7936466,0.2645132", "l0.7951840,0.2664442", "l0.7959591,0.2658122", "l0.7963725,0.2645132", "l0.7970443,0.2643376", "l0.7971606,0.2630561", "l0.7979357,0.2630386", "l0.7989563,0.2643552", "l0.7999382,0.2673746", "l0.8022507,0.2689896", "l0.8027675,0.2700429", "l0.8042274,0.2672517", "l0.8045503,0.2642499", "l0.8038915,0.2580355", "l0.8081160,0.2570876", "l0.8085036,0.2560870", "l0.8092658,0.2559290", "l0.8090721,0.2547177", "c"]}, {"n": "Jiangsu", "u": "CN-32", "i": ["m0.6992334,0.5907130", "l0.6995434,0.5889399", "l0.6991171,0.5878867", "l0.6997114,0.5876058", "l0.6998922,0.5848322", "l0.7004478,0.5837262", "l0.7033029,0.5827256", "l0.7056929,0.5832698", "l0.7059384,0.5825676", "l0.7090519,0.5845689", "l0.7092457,0.5859732", "l0.7103180,0.5872020", "l0.7108606,0.5889224", "l0.7105118,0.5903268", "l0.7115453,0.5907656", "l0.7118812,0.5937148", "l0.7128502,0.5956107", "l0.7135995,0.5955054", "l0.7138191,0.5935217", "l0.7152919,0.5919769", "l0.7160283,0.5924333", "l0.7170618,0.5946979", "l0.7186250,0.5954000", "l0.7201624,0.5944521", "l0.7206275,0.5933286", "l0.7225266,0.5939255", "l0.7226687,0.5904672", "l0.7241673,0.5905374", "l0.7242578,0.5898352", "l0.7249942,0.5897299", "l0.7273713,0.5904672", "l0.7276297,0.5914678", "l0.7270871,0.5929248", "l0.7286115,0.5931706", "l0.7280172,0.5948910", "l0.7287020,0.5957862", "l0.7285211,0.5973837", "l0.7291025,0.5975593", "l0.7323839,0.5961900", "l0.7329653,0.5938377", "l0.7327715,0.5915907", "l0.7334175,0.5908885", "l0.7333787,0.5897650", "l0.7343347,0.5887117", "l0.7354974,0.5886591", "l0.7370090,0.5895719", "l0.7383913,0.5883782", "l0.7375387,0.5874303", "l0.7377841,0.5865876", "l0.7383913,0.5865525", "l0.7382363,0.5851657", "l0.7387014,0.5851482", "l0.7398383,0.5823745", "l0.7397995,0.5801626", "l0.7407426,0.5793200", "l0.7411819,0.5798818", "l0.7438949,0.5795131", "l0.7444375,0.5783019", "l0.7452772,0.5778805", "l0.7463237,0.5777050", "l0.7469567,0.5784774", "l0.7469567,0.5784774", "l0.7458069,0.5795482", "l0.7449543,0.5849375", "l0.7459878,0.5868509", "l0.7471505,0.5879744", "l0.7478352,0.5873600", "l0.7499669,0.5884484", "l0.7500703,0.5890453", "l0.7494501,0.5898177", "l0.7526153,0.5928897", "l0.7527445,0.5939079", "l0.7538426,0.5938026", "l0.7550183,0.5946979", "l0.7549925,0.5953825", "l0.7587002,0.5965235", "l0.7630282,0.5999642", "l0.7640488,0.6053711", "l0.7696945,0.6223464", "l0.7686609,0.6219602", "l0.7687126,0.6236630", "l0.7693069,0.6240843", "l0.7693715,0.6254711", "l0.7701854,0.6248391", "l0.7701725,0.6270335", "l0.7706376,0.6269808", "l0.7704954,0.6280165", "l0.7708443,0.6287187", "l0.7711414,0.6281218", "l0.7718520,0.6300353", "l0.7723687,0.6327036", "l0.7718907,0.6332478", "l0.7730664,0.6338622", "l0.7734410,0.6375662", "l0.7724979,0.6404803", "l0.7732731,0.6443950", "l0.7749009,0.6454307", "l0.7747458,0.6465893", "l0.7760507,0.6468351", "l0.7809212,0.6501002", "l0.7816834,0.6539447", "l0.7809858,0.6551559", "l0.7819289,0.6563145", "l0.7819160,0.6573152", "l0.7867219,0.6597377", "l0.7887115,0.6627571", "l0.7899905,0.6672686", "l0.7890474,0.6687432", "l0.7851070,0.6673915", "l0.7797843,0.6635295", "l0.7764253,0.6660925", "l0.7762186,0.6677953", "l0.7789833,0.6709024", "l0.7801590,0.6733952", "l0.7801590,0.6733952", "l0.7773168,0.6750629", "l0.7772780,0.6763619", "l0.7765545,0.6767306", "l0.7772005,0.6791707", "l0.7761282,0.6790829", "l0.7758052,0.6796095", "l0.7760248,0.6822954", "l0.7756114,0.6828571", "l0.7728338,0.6830678", "l0.7725367,0.6836471", "l0.7731439,0.6842615", "l0.7731310,0.6861574", "l0.7731310,0.6861574", "l0.7722137,0.6868771", "l0.7719165,0.6862627", "l0.7705859,0.6873511", "l0.7699658,0.6871580", "l0.7696686,0.6876495", "l0.7700304,0.6890188", "l0.7690873,0.6901247", "l0.7680150,0.6900896", "l0.7668006,0.6924595", "l0.7659091,0.6911253", "l0.7655345,0.6883868", "l0.7655345,0.6883868", "l0.7652761,0.6890715", "l0.7652761,0.6890715", "l0.7643847,0.6892997", "l0.7645268,0.6876144", "l0.7629894,0.6882464", "l0.7609869,0.6880884", "l0.7583902,0.6857712", "l0.7570337,0.6819443", "l0.7551604,0.6822252", "l0.7549149,0.6817512", "l0.7530804,0.6821549", "l0.7524991,0.6828747", "l0.7524991,0.6828747", "l0.7484683,0.6817863", "l0.7487008,0.6812245", "l0.7480290,0.6810314", "l0.7483778,0.6795569", "l0.7479128,0.6786791", "l0.7476802,0.6796446", "l0.7466596,0.6799079", "l0.7453418,0.6793989", "l0.7450189,0.6785914", "l0.7435461,0.6803819", "l0.7386368,0.6804697", "l0.7381717,0.6792584", "l0.7372415,0.6786089", "l0.7379650,0.6769939", "l0.7390244,0.6768359", "l0.7399933,0.6753789", "l0.7402775,0.6729212", "l0.7398900,0.6703231", "l0.7388435,0.6702705", "l0.7384172,0.6687432", "l0.7376420,0.6700071", "l0.7365310,0.6697614", "l0.7363372,0.6688837", "l0.7370736,0.6681112", "l0.7368281,0.6675144", "l0.7360400,0.6666191", "l0.7344251,0.6671809", "l0.7337146,0.6657589", "l0.7340505,0.6645652", "l0.7334045,0.6644072", "l0.7318026,0.6622129", "l0.7321901,0.6584035", "l0.7339084,0.6572976", "l0.7340376,0.6554544", "l0.7365697,0.6548224", "l0.7364535,0.6527159", "l0.7372674,0.6516626", "l0.7368410,0.6503986", "l0.7369961,0.6481165", "l0.7354974,0.6480288", "l0.7357817,0.6470633", "l0.7349678,0.6458871", "l0.7350969,0.6451674", "l0.7374612,0.6445881", "l0.7386110,0.6452727", "l0.7391406,0.6446934", "l0.7394507,0.6456589", "l0.7405101,0.6450972", "l0.7402904,0.6459749", "l0.7410268,0.6459573", "l0.7417632,0.6472915", "l0.7426417,0.6470633", "l0.7434815,0.6487134", "l0.7445021,0.6476601", "l0.7450318,0.6448865", "l0.7456002,0.6455360", "l0.7458586,0.6446407", "l0.7452256,0.6429204", "l0.7455098,0.6415687", "l0.7450835,0.6387775", "l0.7438303,0.6389179", "l0.7428097,0.6366885", "l0.7423834,0.6368114", "l0.7423834,0.6353895", "l0.7410139,0.6359512", "l0.7396832,0.6354246", "l0.7394765,0.6364076", "l0.7389598,0.6364954", "l0.7389856,0.6380753", "l0.7378746,0.6382684", "l0.7380425,0.6410947", "l0.7373836,0.6416916", "l0.7361822,0.6410069", "l0.7353424,0.6416038", "l0.7331203,0.6411649", "l0.7317896,0.6416740", "l0.7317380,0.6403399", "l0.7306528,0.6401468", "l0.7304202,0.6380402", "l0.7297743,0.6383386", "l0.7295675,0.6363023", "l0.7308724,0.6353719", "l0.7297355,0.6345117", "l0.7291283,0.6290698", "l0.7285857,0.6286485", "l0.7282498,0.6297895", "l0.7264024,0.6306673", "l0.7255497,0.6296491", "l0.7254593,0.6284378", "l0.7247358,0.6284203", "l0.7255238,0.6261206", "l0.7252138,0.6251902", "l0.7261698,0.6244880", "l0.7264153,0.6218197", "l0.7266995,0.6213282", "l0.7276168,0.6217846", "l0.7276038,0.6180982", "l0.7284048,0.6169044", "l0.7282498,0.6152368", "l0.7287795,0.6147803", "l0.7275780,0.6141835", "l0.7251880,0.6142010", "l0.7247745,0.6150788", "l0.7213768,0.6151490", "l0.7218161,0.6109534", "l0.7209246,0.6109008", "l0.7203562,0.6080745", "l0.7196198,0.6071616", "l0.7188446,0.6083553", "l0.7177724,0.6062488", "l0.7162221,0.6072143", "l0.7152014,0.6055115", "l0.7144780,0.6061084", "l0.7125789,0.6060732", "l0.7115841,0.6053008", "l0.7115195,0.6045636", "l0.7098529,0.6032118", "l0.7103438,0.6015091", "l0.7089744,0.6004207", "l0.7088323,0.5974364", "l0.7079796,0.5970151", "l0.7066619,0.5975417", "l0.7055767,0.5955756", "l0.7025019,0.5948383", "l0.7028120,0.5942941", "l0.7012229,0.5927317", "l0.7001506,0.5904672", "l0.6992334,0.5907130", "c"]}, {"n": "Jiangxi", "u": "CN-36", "i": ["m0.6953318,0.7164566", "l0.6964687,0.7162284", "l0.6973988,0.7174748", "l0.7008095,0.7145256", "l0.7019076,0.7145432", "l0.7027732,0.7105583", "l0.7040264,0.7100492", "l0.7059255,0.7110323", "l0.7061580,0.7118222", "l0.7066231,0.7116993", "l0.7066748,0.7126649", "l0.7073078,0.7124366", "l0.7078246,0.7132090", "l0.7063906,0.7167200", "l0.7054087,0.7170886", "l0.7038067,0.7197043", "l0.7042589,0.7201782", "l0.7037809,0.7211613", "l0.7049049,0.7229870", "l0.7055508,0.7221268", "l0.7061193,0.7229519", "l0.7068557,0.7228465", "l0.7093878,0.7199851", "l0.7112869,0.7192654", "l0.7116616,0.7175099", "l0.7106410,0.7162109", "l0.7115712,0.7154034", "l0.7116487,0.7143852", "l0.7129147,0.7137883", "l0.7135865,0.7142623", "l0.7136641,0.7162284", "l0.7142196,0.7164566", "l0.7149431,0.7157545", "l0.7153048,0.7167024", "l0.7163125,0.7157896", "l0.7161316,0.7171588", "l0.7168809,0.7183174", "l0.7168551,0.7198798", "l0.7181083,0.7207400", "l0.7178369,0.7214773", "l0.7182762,0.7221795", "l0.7190772,0.7224954", "l0.7201753,0.7217581", "l0.7210021,0.7234083", "l0.7227075,0.7227588", "l0.7246970,0.7233907", "l0.7260019,0.7226885", "l0.7280172,0.7244967", "l0.7279268,0.7266032", "l0.7289603,0.7273581", "l0.7289603,0.7273581", "l0.7292446,0.7283938", "l0.7285728,0.7297982", "l0.7270612,0.7299386", "l0.7270741,0.7315712", "l0.7263248,0.7328351", "l0.7265186,0.7348714", "l0.7274359,0.7375222", "l0.7288182,0.7378031", "l0.7293867,0.7387686", "l0.7290249,0.7395761", "l0.7300714,0.7392601", "l0.7307044,0.7414895", "l0.7320480,0.7427008", "l0.7329136,0.7455622", "l0.7326681,0.7500211", "l0.7334950,0.7506004", "l0.7330299,0.7522329", "l0.7337146,0.7540586", "l0.7327844,0.7551470", "l0.7327844,0.7551470", "l0.7310016,0.7567620", "l0.7318930,0.7576924", "l0.7314408,0.7599570", "l0.7278364,0.7609927", "l0.7273196,0.7632924", "l0.7262602,0.7626779", "l0.7234439,0.7637137", "l0.7223328,0.7649776", "l0.7222295,0.7662240", "l0.7214156,0.7672948", "l0.7193097,0.7656096", "l0.7189480,0.7640121", "l0.7179920,0.7626604", "l0.7173848,0.7638541", "l0.7167647,0.7639243", "l0.7150464,0.7659431", "l0.7147622,0.7648723", "l0.7141292,0.7655920", "l0.7143488,0.7679794", "l0.7127726,0.7695593", "l0.7127726,0.7702440", "l0.7111965,0.7702791", "l0.7110802,0.7716835", "l0.7103955,0.7705775", "l0.7097366,0.7711042", "l0.7097883,0.7732985", "l0.7103697,0.7737022", "l0.7107573,0.7732107", "l0.7112869,0.7750013", "l0.7115970,0.7770025", "l0.7111448,0.7775994", "l0.7111448,0.7790037", "l0.7121784,0.7798288", "l0.7121913,0.7804608", "l0.7104989,0.7829886", "l0.7102276,0.7848319", "l0.7084835,0.7867102", "l0.7078892,0.7864118", "l0.7044785,0.7875879", "l0.7020885,0.7912217", "l0.7022564,0.7930299", "l0.7014942,0.7944693", "l0.7024244,0.7961019", "l0.7019464,0.7980154", "l0.7035354,0.8004028", "l0.7029412,0.8026673", "l0.7015846,0.8020529", "l0.6996468,0.8053181", "l0.6995951,0.8074422", "l0.7007578,0.8076002", "l0.7010937,0.8091977", "l0.6995047,0.8109356", "l0.6991042,0.8127788", "l0.6952672,0.8153944", "l0.6960552,0.8174483", "l0.6959390,0.8180276", "l0.6952026,0.8178170", "l0.6948667,0.8191336", "l0.6940399,0.8195900", "l0.6941045,0.8225041", "l0.6930063,0.8251197", "l0.6934585,0.8256288", "l0.6930192,0.8271385", "l0.6933293,0.8285077", "l0.6919599,0.8305792", "l0.6907842,0.8312463", "l0.6910814,0.8335635", "l0.6920116,0.8351083", "l0.6910685,0.8358982", "l0.6915723,0.8367584", "l0.6910168,0.8370919", "l0.6912106,0.8380048", "l0.6912106,0.8380048", "l0.6915077,0.8394091", "l0.6901383,0.8388123", "l0.6891564,0.8426041", "l0.6899057,0.8440085", "l0.6893244,0.8445702", "l0.6904613,0.8469927", "l0.6885363,0.8476072", "l0.6878257,0.8461852", "l0.6861463,0.8456235", "l0.6846218,0.8422881", "l0.6836012,0.8417615", "l0.6828389,0.8419195", "l0.6826581,0.8427621", "l0.6814437,0.8424110", "l0.6786531,0.8446229", "l0.6779297,0.8435871", "l0.6759014,0.8449389", "l0.6753458,0.8446229", "l0.6746870,0.8471156", "l0.6726587,0.8458341", "l0.6720644,0.8478529", "l0.6712375,0.8466943", "l0.6701523,0.8477300", "l0.6691705,0.8472736", "l0.6675168,0.8489062", "l0.6663153,0.8464485", "l0.6655144,0.8468172", "l0.6650493,0.8454655", "l0.6633310,0.8443771", "l0.6658890,0.8425690", "l0.6659278,0.8411295", "l0.6670130,0.8394091", "l0.6669355,0.8376010", "l0.6691963,0.8358807", "l0.6696614,0.8343534", "l0.6710696,0.8345465", "l0.6714959,0.8337215", "l0.6724132,0.8335108", "l0.6722065,0.8325102", "l0.6716122,0.8322293", "l0.6725941,0.8305265", "l0.6725165,0.8296137", "l0.6719481,0.8286482", "l0.6707983,0.8284200", "l0.6692092,0.8262256", "l0.6685891,0.8271560", "l0.6676331,0.8271034", "l0.6667934,0.8287008", "l0.6654498,0.8283146", "l0.6655273,0.8290870", "l0.6643129,0.8293504", "l0.6624913,0.8288237", "l0.6610314,0.8302281", "l0.6607601,0.8294908", "l0.6611218,0.8275773", "l0.6602433,0.8266821", "l0.6604242,0.8258219", "l0.6598945,0.8252777", "l0.6598945,0.8252777", "l0.6595457,0.8247159", "l0.6603338,0.8227323", "l0.6590935,0.8187298", "l0.6609797,0.8138145", "l0.6606697,0.8115851", "l0.6612123,0.8101281", "l0.6620908,0.8102334", "l0.6622329,0.8094434", "l0.6642870,0.8082146", "l0.6639253,0.8070209", "l0.6633052,0.8067751", "l0.6618453,0.8079162", "l0.6611348,0.8073018", "l0.6600496,0.8081970", "l0.6595199,0.8078460", "l0.6610702,0.8042999", "l0.6610314,0.8025445", "l0.6618970,0.8017896", "l0.6624784,0.7974010", "l0.6590419,0.7967690", "l0.6582925,0.7958035", "l0.6578662,0.7920995", "l0.6593132,0.7884657", "l0.6575562,0.7863240", "l0.6573365,0.7848319", "l0.6567552,0.7847265", "l0.6583830,0.7801974", "l0.6580988,0.7796884", "l0.6584605,0.7777749", "l0.6555666,0.7790213", "l0.6542230,0.7786877", "l0.6539905,0.7776871", "l0.6544556,0.7770903", "l0.6538096,0.7756508", "l0.6543910,0.7745975", "l0.6535900,0.7738953", "l0.6541326,0.7715255", "l0.6566131,0.7674001", "l0.6561092,0.7653638", "l0.6565872,0.7638892", "l0.6579566,0.7629062", "l0.6581634,0.7621689", "l0.6591323,0.7625551", "l0.6598041,0.7613789", "l0.6610572,0.7611331", "l0.6603596,0.7580260", "l0.6619616,0.7578153", "l0.6646229,0.7542166", "l0.6646746,0.7525489", "l0.6633439,0.7515132", "l0.6639641,0.7502668", "l0.6618324,0.7486167", "l0.6625688,0.7472299", "l0.6629176,0.7417528", "l0.6615611,0.7412087", "l0.6615223,0.7399272", "l0.6608635,0.7397341", "l0.6605663,0.7384526", "l0.6598816,0.7386281", "l0.6595845,0.7361354", "l0.6595845,0.7361354", "l0.6597524,0.7348012", "l0.6615611,0.7320100", "l0.6645325,0.7313254", "l0.6648426,0.7283762", "l0.6654627,0.7281129", "l0.6661732,0.7290784", "l0.6688346,0.7291135", "l0.6714701,0.7272703", "l0.6724390,0.7273230", "l0.6727749,0.7280954", "l0.6744286,0.7270947", "l0.6749453,0.7273405", "l0.6758755,0.7254095", "l0.6754750,0.7250760", "l0.6750875,0.7260064", "l0.6746611,0.7251286", "l0.6752037,0.7238647", "l0.6760951,0.7245669", "l0.6759660,0.7236189", "l0.6768186,0.7227939", "l0.6783818,0.7230747", "l0.6780201,0.7239700", "l0.6793766,0.7242685", "l0.6796221,0.7223023", "l0.6789890,0.7221443", "l0.6791311,0.7208804", "l0.6785885,0.7200378", "l0.6793379,0.7206171", "l0.6811465,0.7205820", "l0.6815083,0.7214948", "l0.6844797,0.7185632", "l0.6845830,0.7168604", "l0.6851386,0.7160178", "l0.6878645,0.7156667", "l0.6903191,0.7181594", "l0.6919599,0.7190021", "l0.6939107,0.7183525", "c"]}, {"n": "Liaoning", "u": "CN-21", "i": ["m0.7866573,0.4571399", "l0.7861276,0.4570697", "l0.7861018,0.4584741", "l0.7845127,0.4580352", "l0.7835438,0.4594571", "l0.7825103,0.4579299", "l0.7826782,0.4568239", "l0.7820193,0.4557882", "l0.7809341,0.4551914", "l0.7797326,0.4564026", "l0.7794613,0.4557004", "l0.7784536,0.4556829", "l0.7796939,0.4531901", "l0.7815801,0.4530497", "l0.7823036,0.4523300", "l0.7836988,0.4533306", "l0.7833242,0.4503287", "l0.7829495,0.4508027", "l0.7822390,0.4491701", "l0.7828591,0.4481871", "l0.7825361,0.4472742", "l0.7835696,0.4456065", "l0.7847324,0.4456417", "l0.7861793,0.4438160", "l0.7873808,0.4442724", "l0.7877684,0.4430260", "l0.7894091,0.4417621", "l0.7893316,0.4412530", "l0.7882851,0.4409897", "l0.7892282,0.4406737", "l0.7899259,0.4390236", "l0.7911403,0.4380405", "l0.7911273,0.4365484", "l0.7927035,0.4350387", "l0.7929619,0.4338274", "l0.7924839,0.4333534", "l0.7942409,0.4314049", "l0.7943700,0.4297196", "l0.7965405,0.4279993", "l0.7964113,0.4265598", "l0.7955457,0.4266300", "l0.7935432,0.4242952", "l0.7936983,0.4220131", "l0.7902747,0.4191166", "l0.7897708,0.4175718", "l0.7896546,0.4180634", "l0.7887761,0.4178351", "l0.7880009,0.4138151", "l0.7867607,0.4172207", "l0.7839055,0.4173436", "l0.7827816,0.4160270", "l0.7776914,0.4149035", "l0.7760378,0.4166414", "l0.7759732,0.4178176", "l0.7750171,0.4177123", "l0.7744745,0.4168345", "l0.7739190,0.4185022", "l0.7745133,0.4189411", "l0.7737252,0.4192571", "l0.7735573,0.4203630", "l0.7748750,0.4208545", "l0.7719811,0.4221009", "l0.7714127,0.4244006", "l0.7692940,0.4263316", "l0.7692810,0.4278237", "l0.7680150,0.4286137", "l0.7682733,0.4293159", "l0.7677695,0.4303867", "l0.7681183,0.4312469", "l0.7666068,0.4323528", "l0.7666585,0.4344067", "l0.7657412,0.4360568", "l0.7633899,0.4364606", "l0.7609740,0.4385496", "l0.7574988,0.4401997", "l0.7570208,0.4415690", "l0.7558322,0.4420078", "l0.7558322,0.4420078", "l0.7558322,0.4403402", "l0.7547211,0.4404279", "l0.7542561,0.4362675", "l0.7523053,0.4350387", "l0.7526541,0.4339854", "l0.7518014,0.4318437", "l0.7519306,0.4285961", "l0.7510521,0.4270162", "l0.7514138,0.4261736", "l0.7465692,0.4262789", "l0.7456519,0.4252959", "l0.7458198,0.4242777", "l0.7445021,0.4243304", "l0.7449284,0.4217674", "l0.7429130,0.4225398", "l0.7395799,0.4186251", "l0.7403421,0.4139380", "l0.7418795,0.4140082", "l0.7423834,0.4127794", "l0.7410139,0.4118490", "l0.7411431,0.4108484", "l0.7432231,0.4103042", "l0.7433910,0.4088823", "l0.7450705,0.4073726", "l0.7447734,0.4062842", "l0.7459103,0.4052836", "l0.7459749,0.4035106", "l0.7459749,0.4035106", "l0.7471247,0.4024924", "l0.7473831,0.4030717", "l0.7474477,0.4014391", "l0.7470342,0.4009301", "l0.7479128,0.4005263", "l0.7486362,0.3988059", "l0.7479257,0.3966116", "l0.7487783,0.3955583", "l0.7478352,0.3949790", "l0.7469567,0.3920650", "l0.7472410,0.3910117", "l0.7467629,0.3896249", "l0.7474089,0.3873955", "l0.7474347,0.3851660", "l0.7474347,0.3851660", "l0.7472926,0.3842532", "l0.7478998,0.3833403", "l0.7478998,0.3833403", "l0.7482616,0.3805667", "l0.7471118,0.3794959", "l0.7459620,0.3768802", "l0.7466854,0.3752477", "l0.7495793,0.3733342", "l0.7502382,0.3717016", "l0.7509229,0.3726320", "l0.7509617,0.3742646", "l0.7519564,0.3756339", "l0.7543077,0.3771084", "l0.7558839,0.3768978", "l0.7558064,0.3802332", "l0.7590361,0.3887823", "l0.7588424,0.3915559", "l0.7599534,0.3922932", "l0.7606510,0.3913628", "l0.7604573,0.3900462", "l0.7631186,0.3848851", "l0.7644105,0.3835861", "l0.7652632,0.3838319", "l0.7661417,0.3826382", "l0.7660125,0.3801630", "l0.7679374,0.3783197", "l0.7685963,0.3786884", "l0.7704438,0.3767222", "l0.7718003,0.3765116", "l0.7728338,0.3753354", "l0.7753660,0.3757919", "l0.7791513,0.3720527", "l0.7801202,0.3696828", "l0.7825749,0.3684716", "l0.7828591,0.3689104", "l0.7828591,0.3689104", "l0.7833758,0.3685067", "l0.7833758,0.3685067", "l0.7843706,0.3678572", "l0.7854946,0.3702270", "l0.7863860,0.3698759", "l0.7882334,0.3674183", "l0.7887631,0.3674885", "l0.7895900,0.3656980", "l0.7893962,0.3644165", "l0.7899775,0.3627839", "l0.7919412,0.3616604", "l0.7936983,0.3627663", "l0.7942538,0.3625908", "l0.7943313,0.3615726", "l0.7965146,0.3631525", "l0.7973285,0.3629945", "l0.7984137,0.3604667", "l0.7969668,0.3600454", "l0.7966051,0.3586059", "l0.7971347,0.3579388", "l0.7999899,0.3585357", "l0.8012043,0.3601331", "l0.8028450,0.3598347", "l0.8046020,0.3616428", "l0.8051317,0.3615200", "l0.8054805,0.3603613", "l0.8084390,0.3601331", "l0.8091625,0.3591325", "l0.8112166,0.3584479", "l0.8102735,0.3576579", "l0.8103381,0.3554812", "l0.8114104,0.3536028", "l0.8152216,0.3521107", "l0.8168752,0.3533571", "l0.8183092,0.3475114", "l0.8179992,0.3470198", "l0.8184901,0.3458437", "l0.8181155,0.3455101", "l0.8188777,0.3448782", "l0.8185547,0.3447026", "l0.8190456,0.3437371", "l0.8188519,0.3421046", "l0.8188519,0.3421046", "l0.8188131,0.3418237", "l0.8188131,0.3418237", "l0.8190327,0.3405071", "l0.8203634,0.3383654", "l0.8214486,0.3394714", "l0.8212936,0.3406826", "l0.8221075,0.3421221", "l0.8240454,0.3446675", "l0.8251047,0.3444393", "l0.8256603,0.3457735", "l0.8272622,0.3456155", "l0.8282570,0.3466161", "l0.8284379,0.3484418", "l0.8304920,0.3509345", "l0.8292001,0.3534097", "l0.8297685,0.3542172", "l0.8306987,0.3543752", "l0.8308021,0.3550599", "l0.8296135,0.3565344", "l0.8309313,0.3574473", "l0.8311897,0.3586937", "l0.8313964,0.3576053", "l0.8322232,0.3573068", "l0.8343032,0.3542699", "l0.8350008,0.3515489", "l0.8365640,0.3498988", "l0.8381918,0.3493897", "l0.8382048,0.3509872", "l0.8373392,0.3526724", "l0.8378689,0.3539364", "l0.8377655,0.3593081", "l0.8382048,0.3597820", "l0.8387086,0.3588868", "l0.8395613,0.3594661", "l0.8396000,0.3630297", "l0.8401555,0.3635387", "l0.8403235,0.3648027", "l0.8415637,0.3649958", "l0.8412149,0.3681907", "l0.8429332,0.3706659", "l0.8428040,0.3739662", "l0.8442251,0.3738960", "l0.8447418,0.3747737", "l0.8443930,0.3753179", "l0.8450390,0.3790746", "l0.8459950,0.3779862", "l0.8479200,0.3790746", "l0.8472998,0.3802858", "l0.8466797,0.3804263", "l0.8466926,0.3816024", "l0.8458658,0.3831823", "l0.8447935,0.3842181", "l0.8455170,0.3853591", "l0.8448710,0.3861666", "l0.8447289,0.3879923", "l0.8455945,0.3903622", "l0.8452586,0.3925916", "l0.8473903,0.3930305", "l0.8472740,0.3951019", "l0.8486951,0.3987357", "l0.8485918,0.4002103", "l0.8504004,0.4027908", "l0.8504909,0.4048447", "l0.8522866,0.4057576", "l0.8520412,0.4073024", "l0.8529714,0.4077061", "l0.8515502,0.4097074", "l0.8520024,0.4106202", "l0.8510852,0.4121826", "l0.8510206,0.4135343", "l0.8493669,0.4156759", "l0.8507880,0.4153073", "l0.8516278,0.4166590", "l0.8528680,0.4155530", "l0.8533460,0.4166239", "l0.8550513,0.4153599", "l0.8550513,0.4153599", "l0.8532943,0.4167994", "l0.8527517,0.4160621", "l0.8517053,0.4168872", "l0.8505684,0.4183091", "l0.8513306,0.4196608", "l0.8492377,0.4196257", "l0.8489147,0.4208897", "l0.8477262,0.4211881", "l0.8475195,0.4224345", "l0.8468864,0.4225047", "l0.8469898,0.4236106", "l0.8445610,0.4229260", "l0.8439925,0.4242075", "l0.8429202,0.4242777", "l0.8403235,0.4263842", "l0.8400651,0.4273146", "l0.8408532,0.4278588", "l0.8406594,0.4285961", "l0.8388249,0.4288068", "l0.8384244,0.4279817", "l0.8374167,0.4299303", "l0.8358922,0.4311064", "l0.8357372,0.4325459", "l0.8336443,0.4338976", "l0.8300657,0.4382687", "l0.8291355,0.4400066", "l0.8297169,0.4418323", "l0.8285025,0.4429207", "l0.8283733,0.4437809", "l0.8273527,0.4442899", "l0.8263191,0.4471689", "l0.8252339,0.4467827", "l0.8237611,0.4476078", "l0.8231669,0.4465369", "l0.8217457,0.4468003", "l0.8216424,0.4459752", "l0.8191748,0.4467827", "l0.8173274,0.4462736", "l0.8163972,0.4476078", "l0.8152216,0.4478184", "l0.8148598,0.4490648", "l0.8141493,0.4495739", "l0.8140588,0.4471865", "l0.8123923,0.4476955", "l0.8119659,0.4471689", "l0.8117851,0.4488893", "l0.8112683,0.4492930", "l0.8119530,0.4506447", "l0.8110099,0.4504341", "l0.8096405,0.4513996", "l0.8075476,0.4509783", "l0.8068500,0.4524880", "l0.8042790,0.4535939", "l0.8034005,0.4531199", "l0.8038269,0.4541381", "l0.8022378,0.4555425", "l0.8018502,0.4544892", "l0.8014110,0.4562446", "l0.8004679,0.4571926", "l0.7996152,0.4568942", "l0.7986721,0.4577368", "l0.7980908,0.4570873", "l0.7974577,0.4576490", "l0.7965792,0.4596151", "l0.7951194,0.4607913", "l0.7954553,0.4613004", "l0.7950677,0.4624063", "l0.7930006,0.4641793", "l0.7929231,0.4650922", "l0.7934399,0.4660401", "l0.7924709,0.4671987", "l0.7916441,0.4668125", "l0.7921996,0.4686557", "l0.7911532,0.4682520", "l0.7905201,0.4695335", "l0.7895770,0.4682344", "l0.7882851,0.4691824", "l0.7884918,0.4699548", "l0.7894866,0.4704814", "l0.7890603,0.4717980", "l0.7882980,0.4715874", "l0.7872903,0.4693755", "l0.7865669,0.4694457", "l0.7870836,0.4700075", "l0.7867219,0.4704112", "l0.7857659,0.4696564", "l0.7853396,0.4702708", "l0.7856367,0.4710958", "l0.7843189,0.4719560", "l0.7865023,0.4731322", "l0.7861793,0.4742206", "l0.7843706,0.4738344", "l0.7825103,0.4755723", "l0.7805982,0.4753792", "l0.7790738,0.4763622", "l0.7785312,0.4759760", "l0.7780273,0.4782932", "l0.7769679,0.4781879", "l0.7765933,0.4766958", "l0.7771746,0.4762218", "l0.7765416,0.4746419", "l0.7770584,0.4739046", "l0.7774201,0.4743786", "l0.7776268,0.4736237", "l0.7770196,0.4731146", "l0.7762574,0.4733955", "l0.7763995,0.4723598", "l0.7771617,0.4716751", "l0.7784278,0.4723598", "l0.7793063,0.4712889", "l0.7803786,0.4711309", "l0.7800944,0.4700777", "l0.7808695,0.4687260", "l0.7819935,0.4700250", "l0.7856109,0.4681642", "l0.7860243,0.4666545", "l0.7851845,0.4651799", "l0.7846161,0.4654959", "l0.7843319,0.4648464", "l0.7856884,0.4639511", "l0.7851587,0.4639687", "l0.7854687,0.4633367", "l0.7848615,0.4634947", "l0.7844611,0.4626696", "l0.7866831,0.4626170", "l0.7871870,0.4616164", "l0.7870190,0.4603875", "l0.7889311,0.4602998", "l0.7903134,0.4590534", "l0.7903005,0.4580177", "l0.7898742,0.4578421", "l0.7891765,0.4581581", "l0.7894737,0.4589832", "l0.7872128,0.4594045", "l0.7866315,0.4588427", "l0.7866573,0.4571399", "c"]}, {"n": "Macau", "u": "CN-92", "i": ["m0.6534220,0.9046596", "l0.6538742,0.9055549", "l0.6533187,0.9060113", "l0.6530732,0.9048001", "l0.6534220,0.9046596", "c", "m0.6533962,0.9036415", "l0.6535771,0.9042208", "l0.6529182,0.9043437", "l0.6533962,0.9036415", "c"]}, {"n": "Nei Mongol", "u": "CN-15", "i": ["m0.7828203,0.0089882", "l0.7846419,0.0116214", "l0.7855979,0.0121130", "l0.7857400,0.0139562", "l0.7853783,0.0145706", "l0.7865152,0.0159223", "l0.7869674,0.0157994", "l0.7873420,0.0178007", "l0.7880397,0.0188539", "l0.7875487,0.0205216", "l0.7863343,0.0214871", "l0.7854171,0.0245943", "l0.7846290,0.0252614", "l0.7845515,0.0272801", "l0.7826265,0.0295447", "l0.7810116,0.0326694", "l0.7795518,0.0336174", "l0.7778594,0.0360574", "l0.7783761,0.0367947", "l0.7799910,0.0369703", "l0.7806241,0.0384975", "l0.7813217,0.0386555", "l0.7831950,0.0410956", "l0.7853008,0.0416047", "l0.7863731,0.0461162", "l0.7883497,0.0473626", "l0.7895512,0.0474328", "l0.7901842,0.0468184", "l0.7916183,0.0439570", "l0.7916958,0.0426755", "l0.7925226,0.0421665", "l0.7923547,0.0416925", "l0.7937499,0.0389715", "l0.7944346,0.0406216", "l0.7961141,0.0404110", "l0.7966567,0.0426755", "l0.7977032,0.0439570", "l0.7983491,0.0433602", "l0.7989176,0.0450279", "l0.7988530,0.0469062", "l0.8006229,0.0479770", "l0.8021345,0.0476084", "l0.8026512,0.0483457", "l0.8035039,0.0479595", "l0.8039044,0.0484686", "l0.8036202,0.0511544", "l0.8030905,0.0520497", "l0.8013464,0.0526641", "l0.8012430,0.0551744", "l0.8016694,0.0554553", "l0.8021086,0.0582991", "l0.8029096,0.0583518", "l0.8025866,0.0615292", "l0.8036589,0.0654965", "l0.8032972,0.0667780", "l0.8050413,0.0716582", "l0.8046408,0.0724306", "l0.8055064,0.0739403", "l0.8050025,0.0762400", "l0.8057518,0.0773810", "l0.8057906,0.0783992", "l0.8067595,0.0791891", "l0.8068241,0.0809095", "l0.8073926,0.0820856", "l0.8085036,0.0818048", "l0.8121081,0.0842800", "l0.8129090,0.0835251", "l0.8147177,0.0835427", "l0.8151053,0.0829283", "l0.8164876,0.0829458", "l0.8181801,0.0818750", "l0.8190973,0.0790487", "l0.8203376,0.0804004", "l0.8211256,0.0801722", "l0.8224951,0.0825421", "l0.8236061,0.0817697", "l0.8248593,0.0818399", "l0.8253114,0.0810675", "l0.8273656,0.0808042", "l0.8281278,0.0822787", "l0.8292389,0.0828054", "l0.8293810,0.0835778", "l0.8303370,0.0835778", "l0.8308408,0.0806813", "l0.8317064,0.0797333", "l0.8331017,0.0800844", "l0.8340319,0.0816292", "l0.8356209,0.0809446", "l0.8363186,0.0793998", "l0.8380239,0.0796455", "l0.8390962,0.0773634", "l0.8388636,0.0755729", "l0.8409953,0.0741334", "l0.8412278,0.0708682", "l0.8419901,0.0697799", "l0.8422226,0.0707278", "l0.8446256,0.0706049", "l0.8451682,0.0715880", "l0.8457495,0.0710965", "l0.8514211,0.0814537", "l0.8524546,0.0839991", "l0.8522996,0.0850173", "l0.8539661,0.0857370", "l0.8544312,0.0877207", "l0.8541599,0.0880718", "l0.8553614,0.0885808", "l0.8553743,0.0893006", "l0.8563303,0.0888617", "l0.8560203,0.0902310", "l0.8573639,0.0920040", "l0.8569892,0.0920391", "l0.8569117,0.0930046", "l0.8576998,0.0942861", "l0.8570796,0.0958133", "l0.8566792,0.0957256", "l0.8568083,0.0966033", "l0.8563174,0.0964980", "l0.8563562,0.0975513", "l0.8557490,0.0966735", "l0.8556327,0.0981130", "l0.8546638,0.0980428", "l0.8551159,0.0989381", "l0.8540953,0.1005004", "l0.8535786,0.1004829", "l0.8537853,0.1016064", "l0.8529068,0.1011324", "l0.8523383,0.1018872", "l0.8529843,0.1021857", "l0.8526742,0.1028176", "l0.8534623,0.1035725", "l0.8528809,0.1044151", "l0.8534881,0.1089793", "l0.8525192,0.1095059", "l0.8522737,0.1104714", "l0.8520412,0.1098395", "l0.8510722,0.1107699", "l0.8514856,0.1112263", "l0.8507751,0.1114896", "l0.8503100,0.1125956", "l0.8497286,0.1122269", "l0.8496253,0.1128764", "l0.8491731,0.1127009", "l0.8493669,0.1140701", "l0.8486305,0.1133504", "l0.8482817,0.1138419", "l0.8487339,0.1146670", "l0.8484626,0.1152112", "l0.8489406,0.1155447", "l0.8483851,0.1159660", "l0.8485013,0.1171949", "l0.8474936,0.1177742", "l0.8476228,0.1186695", "l0.8471836,0.1190205", "l0.8475711,0.1200387", "l0.8470544,0.1199860", "l0.8470027,0.1210393", "l0.8463180,0.1210569", "l0.8463697,0.1218468", "l0.8454395,0.1221804", "l0.8461242,0.1230932", "l0.8454524,0.1231108", "l0.8453620,0.1238481", "l0.8450390,0.1229879", "l0.8445610,0.1235145", "l0.8444447,0.1252173", "l0.8454782,0.1258844", "l0.8440313,0.1261653", "l0.8448323,0.1268499", "l0.8447289,0.1277276", "l0.8439021,0.1282016", "l0.8438375,0.1292373", "l0.8429202,0.1293427", "l0.8436437,0.1304486", "l0.8439925,0.1323094", "l0.8435274,0.1326078", "l0.8439279,0.1330818", "l0.8436954,0.1335031", "l0.8428686,0.1337138", "l0.8436954,0.1347846", "l0.8432691,0.1368911", "l0.8436696,0.1373124", "l0.8435920,0.1392786", "l0.8431528,0.1405776", "l0.8425456,0.1390328", "l0.8420805,0.1400510", "l0.8423389,0.1409463", "l0.8428298,0.1405249", "l0.8433853,0.1418766", "l0.8437988,0.1418591", "l0.8438633,0.1437550", "l0.8433337,0.1437901", "l0.8443672,0.1466164", "l0.8442380,0.1513035", "l0.8434758,0.1524445", "l0.8438117,0.1531818", "l0.8434887,0.1533749", "l0.8436050,0.1555692", "l0.8430753,0.1556219", "l0.8418738,0.1576758", "l0.8405560,0.1566927", "l0.8405948,0.1559554", "l0.8397680,0.1564645", "l0.8383210,0.1558150", "l0.8368224,0.1581147", "l0.8370937,0.1604143", "l0.8363573,0.1615905", "l0.8358922,0.1645923", "l0.8351946,0.1645572", "l0.8351042,0.1672255", "l0.8343161,0.1678399", "l0.8343548,0.1695076", "l0.8337218,0.1703678", "l0.8335022,0.1742298", "l0.8329596,0.1762837", "l0.8325591,0.1761608", "l0.8321844,0.1770210", "l0.8326108,0.1774774", "l0.8327529,0.1798999", "l0.8323265,0.1802510", "l0.8321327,0.1828140", "l0.8331663,0.1853594", "l0.8320165,0.1911349", "l0.8306470,0.1923813", "l0.8315514,0.1898007", "l0.8304662,0.1889757", "l0.8306987,0.1872202", "l0.8294843,0.1857632", "l0.8295360,0.1848152", "l0.8287738,0.1831651", "l0.8291355,0.1828667", "l0.8287221,0.1821820", "l0.8291484,0.1811112", "l0.8286058,0.1798648", "l0.8289417,0.1791802", "l0.8281536,0.1776354", "l0.8237224,0.1827613", "l0.8191878,0.1894321", "l0.8168494,0.1938559", "l0.8124827,0.1964715", "l0.8103769,0.2018257", "l0.8048087,0.2061265", "l0.8035427,0.2079347", "l0.8004162,0.2105678", "l0.7992277,0.2147634", "l0.7974836,0.2167822", "l0.8010234,0.2239971", "l0.8048992,0.2262617", "l0.8036589,0.2287720", "l0.8041111,0.2299481", "l0.8056226,0.2293513", "l0.8056614,0.2339506", "l0.8073667,0.2359167", "l0.8075863,0.2371280", "l0.8100281,0.2363029", "l0.8108937,0.2328798", "l0.8133095,0.2323707", "l0.8136067,0.2301412", "l0.8125215,0.2291406", "l0.8125731,0.2278065", "l0.8140718,0.2297726", "l0.8160355,0.2295093", "l0.8151957,0.2328447", "l0.8155833,0.2337750", "l0.8165135,0.2337575", "l0.8167590,0.2315807", "l0.8172240,0.2317036", "l0.8174307,0.2332309", "l0.8168106,0.2337399", "l0.8177408,0.2341964", "l0.8171465,0.2380759", "l0.8118884,0.2390239", "l0.8117463,0.2405511", "l0.8110099,0.2413235", "l0.8103123,0.2406038", "l0.8087362,0.2408671", "l0.8082065,0.2403931", "l0.8081806,0.2415868", "l0.8074313,0.2419204", "l0.8071988,0.2441849", "l0.8076639,0.2467655", "l0.8102606,0.2522776", "l0.8102606,0.2522776", "l0.8090591,0.2546826", "l0.8092400,0.2558939", "l0.8084778,0.2560343", "l0.8080902,0.2570349", "l0.8038785,0.2579829", "l0.8045245,0.2641972", "l0.8042015,0.2671990", "l0.8027417,0.2699902", "l0.8022249,0.2689194", "l0.7999124,0.2673044", "l0.7989434,0.2642850", "l0.7979099,0.2629859", "l0.7971347,0.2629859", "l0.7970185,0.2642674", "l0.7963467,0.2644430", "l0.7959333,0.2657420", "l0.7951452,0.2663740", "l0.7936207,0.2644430", "l0.7925743,0.2639690", "l0.7909852,0.2604581", "l0.7903651,0.2608267", "l0.7884789,0.2594048", "l0.7874195,0.2603001", "l0.7881818,0.2625295", "l0.7869415,0.2667777", "l0.7850037,0.2679539", "l0.7865927,0.2701658", "l0.7876392,0.2701306", "l0.7886210,0.2691651", "l0.7905589,0.2698849", "l0.7910627,0.2716052", "l0.7905331,0.2740980", "l0.7914374,0.2764854", "l0.7936724,0.2780127", "l0.7934011,0.2822960", "l0.7949256,0.2833844", "l0.7948997,0.2847361", "l0.7929619,0.2869129", "l0.7924322,0.2944087", "l0.7915537,0.2949529", "l0.7926906,0.2985165", "l0.7937499,0.2987447", "l0.7934269,0.2994995", "l0.7926776,0.2991835", "l0.7923805,0.2996575", "l0.7930781,0.3003246", "l0.7926260,0.3030455", "l0.7929489,0.3049063", "l0.7944346,0.3059596", "l0.7948351,0.3082593", "l0.7958170,0.3083470", "l0.7958558,0.3122442", "l0.7953777,0.3146491", "l0.7967730,0.3155620", "l0.7989176,0.3155093", "l0.8020699,0.3131043", "l0.8034910,0.3112084", "l0.8052480,0.3103483", "l0.8077026,0.3072411", "l0.8096534,0.3067320", "l0.8095113,0.3115069", "l0.8108291,0.3126128", "l0.8122760,0.3169312", "l0.8136196,0.3178265", "l0.8126765,0.3206002", "l0.8151311,0.3270603", "l0.8149373,0.3302727", "l0.8155704,0.3310451", "l0.8161647,0.3342225", "l0.8156350,0.3351354", "l0.8141234,0.3349423", "l0.8146790,0.3359955", "l0.8143818,0.3365749", "l0.8126765,0.3362589", "l0.8125990,0.3381197", "l0.8144593,0.3403842", "l0.8152345,0.3389447", "l0.8170044,0.3419290", "l0.8188002,0.3419290", "l0.8188002,0.3419290", "l0.8188131,0.3420168", "l0.8188131,0.3420168", "l0.8190069,0.3436494", "l0.8185160,0.3446149", "l0.8188389,0.3447904", "l0.8180767,0.3454224", "l0.8184514,0.3457559", "l0.8179604,0.3469321", "l0.8182705,0.3474236", "l0.8168365,0.3532693", "l0.8151828,0.3520229", "l0.8113717,0.3535151", "l0.8102994,0.3553934", "l0.8102348,0.3575702", "l0.8111779,0.3583601", "l0.8091237,0.3590448", "l0.8084003,0.3600454", "l0.8054418,0.3602736", "l0.8050929,0.3614322", "l0.8045633,0.3615551", "l0.8028063,0.3597469", "l0.8011655,0.3600454", "l0.7999511,0.3584479", "l0.7970960,0.3578510", "l0.7965663,0.3585181", "l0.7969280,0.3599576", "l0.7983750,0.3603789", "l0.7972898,0.3629068", "l0.7964759,0.3630648", "l0.7942925,0.3614848", "l0.7942150,0.3625030", "l0.7936595,0.3626786", "l0.7919025,0.3615726", "l0.7899388,0.3626961", "l0.7893574,0.3643287", "l0.7895512,0.3656102", "l0.7887244,0.3674007", "l0.7881947,0.3673305", "l0.7863472,0.3697882", "l0.7854558,0.3701393", "l0.7843319,0.3677694", "l0.7833371,0.3684189", "l0.7833371,0.3684189", "l0.7828203,0.3688227", "l0.7828203,0.3688227", "l0.7825361,0.3683838", "l0.7800815,0.3695951", "l0.7791125,0.3719649", "l0.7753272,0.3757041", "l0.7727951,0.3752477", "l0.7717615,0.3764238", "l0.7704050,0.3766345", "l0.7685576,0.3786006", "l0.7678987,0.3782319", "l0.7659737,0.3800752", "l0.7661029,0.3825504", "l0.7652244,0.3837441", "l0.7643718,0.3834983", "l0.7630798,0.3847974", "l0.7604185,0.3899584", "l0.7606123,0.3912750", "l0.7599147,0.3922054", "l0.7588036,0.3914681", "l0.7589974,0.3886945", "l0.7557676,0.3801454", "l0.7558451,0.3768100", "l0.7542690,0.3770207", "l0.7519177,0.3755461", "l0.7509229,0.3741768", "l0.7508842,0.3725443", "l0.7501994,0.3716139", "l0.7495406,0.3732464", "l0.7466467,0.3751599", "l0.7459232,0.3767925", "l0.7470730,0.3794081", "l0.7482228,0.3804789", "l0.7478611,0.3832526", "l0.7478611,0.3832526", "l0.7472539,0.3841654", "l0.7473960,0.3850782", "l0.7473960,0.3850782", "l0.7473701,0.3873077", "l0.7467242,0.3895371", "l0.7472022,0.3909239", "l0.7469180,0.3919772", "l0.7477965,0.3948913", "l0.7487396,0.3954706", "l0.7478869,0.3965238", "l0.7485975,0.3987182", "l0.7478740,0.4004385", "l0.7469955,0.4008423", "l0.7474089,0.4013514", "l0.7473443,0.4029839", "l0.7470859,0.4024046", "l0.7459361,0.4034228", "l0.7459361,0.4034228", "l0.7453031,0.4043708", "l0.7412077,0.4033175", "l0.7402517,0.4038266", "l0.7394895,0.4016498", "l0.7382880,0.4022818", "l0.7380425,0.4030893", "l0.7367764,0.4023520", "l0.7343476,0.4022115", "l0.7327457,0.4027031", "l0.7322418,0.4035106", "l0.7316863,0.4031770", "l0.7314150,0.4000523", "l0.7301231,0.3986655", "l0.7308724,0.3975771", "l0.7308207,0.3959797", "l0.7293350,0.3953126", "l0.7292187,0.3937327", "l0.7283273,0.3927321", "l0.7278622,0.3907659", "l0.7285469,0.3886243", "l0.7295029,0.3886945", "l0.7297743,0.3898180", "l0.7303556,0.3900638", "l0.7312470,0.3875886", "l0.7300326,0.3854644", "l0.7307561,0.3837090", "l0.7296321,0.3824275", "l0.7304590,0.3820237", "l0.7300197,0.3805492", "l0.7292187,0.3806896", "l0.7290120,0.3821115", "l0.7276426,0.3819886", "l0.7282756,0.3806720", "l0.7272421,0.3798294", "l0.7274746,0.3779686", "l0.7252396,0.3758621", "l0.7267253,0.3741944", "l0.7258985,0.3727374", "l0.7260665,0.3712803", "l0.7225266,0.3657331", "l0.7225008,0.3647500", "l0.7193227,0.3661719", "l0.7184183,0.3648378", "l0.7181728,0.3656277", "l0.7171652,0.3655575", "l0.7170360,0.3672779", "l0.7155761,0.3692615", "l0.7109381,0.3686296", "l0.7081476,0.3709468", "l0.7077083,0.3733342", "l0.7080313,0.3771962", "l0.7059255,0.3771962", "l0.7075404,0.3797768", "l0.7074629,0.3825153", "l0.7062743,0.3836914", "l0.7052537,0.3836037", "l0.7050211,0.3850256", "l0.7039618,0.3846394", "l0.7021273,0.3852011", "l0.7011971,0.3836914", "l0.7004994,0.3846920", "l0.6995693,0.3848149", "l0.6997760,0.3832701", "l0.6984453,0.3829190", "l0.6979156,0.3841303", "l0.6966624,0.3851134", "l0.6963007,0.3871146", "l0.6948925,0.3874306", "l0.6948021,0.3893967", "l0.6939623,0.3898355", "l0.6930063,0.3895722", "l0.6930838,0.3883961", "l0.6918048,0.3847974", "l0.6903062,0.3849554", "l0.6892727,0.3863773", "l0.6887301,0.3862895", "l0.6885621,0.3870444", "l0.6879291,0.3870795", "l0.6873607,0.3882732", "l0.6837820,0.3911346", "l0.6822447,0.3917139", "l0.6818829,0.3927847", "l0.6827614,0.3944875", "l0.6817796,0.3950668", "l0.6813532,0.3941891", "l0.6807460,0.3955935", "l0.6786531,0.3940838", "l0.6777617,0.3948913", "l0.6759014,0.3945402", "l0.6745578,0.3951897", "l0.6752037,0.3922932", "l0.6747386,0.3890631", "l0.6759272,0.3881327", "l0.6751779,0.3832701", "l0.6738989,0.3816200", "l0.6746870,0.3794608", "l0.6738860,0.3781793", "l0.6733692,0.3782671", "l0.6728395,0.3799699", "l0.6697906,0.3791097", "l0.6687312,0.3798470", "l0.6682403,0.3815673", "l0.6685504,0.3840952", "l0.6659407,0.3854118", "l0.6638995,0.3890456", "l0.6644033,0.3954004", "l0.6640803,0.3964712", "l0.6645196,0.3976825", "l0.6608764,0.3972963", "l0.6583313,0.3997188", "l0.6583959,0.4005965", "l0.6594682,0.4013865", "l0.6589256,0.4033877", "l0.6591840,0.4042654", "l0.6607213,0.4057927", "l0.6602046,0.4073199", "l0.6590677,0.4076008", "l0.6584734,0.4091983", "l0.6575174,0.4097249", "l0.6600237,0.4130778", "l0.6616644,0.4167643", "l0.6611606,0.4176596", "l0.6626592,0.4202577", "l0.6626592,0.4202577", "l0.6626592,0.4202577", "l0.6626592,0.4202577", "l0.6615482,0.4208897", "l0.6611348,0.4239968", "l0.6617936,0.4252607", "l0.6614707,0.4263316", "l0.6598299,0.4265949", "l0.6582409,0.4284206", "l0.6571169,0.4266300", "l0.6566906,0.4278237", "l0.6552436,0.4287892", "l0.6532799,0.4315453", "l0.6493137,0.4323353", "l0.6482414,0.4296670", "l0.6439781,0.4312820", "l0.6424020,0.4321773", "l0.6416785,0.4356355", "l0.6400765,0.4367766", "l0.6353610,0.4329848", "l0.6328676,0.4343189", "l0.6275062,0.4472040", "l0.6267698,0.4526811", "l0.6240051,0.4533832", "l0.6222223,0.4520491", "l0.6197159,0.4513996", "l0.6187212,0.4518033", "l0.6190054,0.4527337", "l0.6184628,0.4526108", "l0.6185791,0.4555073", "l0.6175326,0.4565080", "l0.6172742,0.4580001", "l0.6141995,0.4582985", "l0.6135406,0.4590358", "l0.6137731,0.4597380", "l0.6137731,0.4597380", "l0.6130884,0.4598609", "l0.6124812,0.4582283", "l0.6139411,0.4546121", "l0.6136310,0.4535939", "l0.6130238,0.4543663", "l0.6119644,0.4540679", "l0.6094840,0.4560515", "l0.6072102,0.4602295", "l0.6069130,0.4620728", "l0.6052982,0.4631260", "l0.6036833,0.4592816", "l0.6020167,0.4599136", "l0.6021459,0.4606333", "l0.6015387,0.4613004", "l0.5991616,0.4575963", "l0.5975983,0.4570697", "l0.5971332,0.4577719", "l0.5973141,0.4587549", "l0.5987094,0.4621430", "l0.5944848,0.4648991", "l0.5929991,0.4675323", "l0.5905703,0.4683749", "l0.5899244,0.4721842", "l0.5885549,0.4739397", "l0.5881803,0.4755547", "l0.5872630,0.4750456", "l0.5858031,0.4758180", "l0.5853768,0.4783810", "l0.5842270,0.4785741", "l0.5844983,0.4810493", "l0.5832968,0.4808386", "l0.5824312,0.4822781", "l0.5814494,0.4827345", "l0.5810360,0.4849464", "l0.5797182,0.4859470", "l0.5784392,0.4889664", "l0.5777803,0.4933902", "l0.5797828,0.4960585", "l0.5797828,0.4975682", "l0.5779225,0.5006929", "l0.5763592,0.4980246", "l0.5755066,0.4979368", "l0.5760363,0.4988497", "l0.5752999,0.5000609", "l0.5753257,0.5073110", "l0.5742405,0.5071530", "l0.5738012,0.5079956", "l0.5719150,0.5082414", "l0.5719409,0.5072759", "l0.5711657,0.5071355", "l0.5685690,0.5076270", "l0.5677680,0.5086978", "l0.5667345,0.5077850", "l0.5648483,0.5091542", "l0.5628458,0.5078025", "l0.5620577,0.5042916", "l0.5585696,0.5031330", "l0.5574585,0.5016760", "l0.5569288,0.5019920", "l0.5569288,0.5019920", "l0.5548230,0.5013600", "l0.5529626,0.4999205", "l0.5532856,0.4985688", "l0.5516578,0.4959356", "l0.5505080,0.4957250", "l0.5490223,0.4940573", "l0.5463610,0.4950754", "l0.5431958,0.4940573", "l0.5390745,0.4911081", "l0.5379893,0.4895633", "l0.5381056,0.4884925", "l0.5400176,0.4861577", "l0.5409091,0.4833139", "l0.5413612,0.4781001", "l0.5420330,0.4778017", "l0.5431441,0.4752212", "l0.5456375,0.4716751", "l0.5457925,0.4706394", "l0.5455729,0.4685504", "l0.5437384,0.4676376", "l0.5439063,0.4663210", "l0.5428340,0.4635825", "l0.5427694,0.4598784", "l0.5422139,0.4594220", "l0.5397463,0.4598609", "l0.5378601,0.4619850", "l0.5346045,0.4625467", "l0.5345658,0.4661279", "l0.5340102,0.4665492", "l0.5326925,0.4656539", "l0.5322920,0.4659348", "l0.5314781,0.4678833", "l0.5312068,0.4708325", "l0.5293981,0.4729742", "l0.5297211,0.4742206", "l0.5283904,0.4765378", "l0.5274731,0.4807158", "l0.5278090,0.4817339", "l0.5270726,0.4868248", "l0.5276669,0.4909150", "l0.5263621,0.4927933", "l0.5261166,0.4947068", "l0.5272923,0.4983582", "l0.5266205,0.5002541", "l0.5267367,0.5022377", "l0.5260004,0.5040810", "l0.5240366,0.5046778", "l0.5233648,0.5068897", "l0.5201092,0.5065913", "l0.5172153,0.5075041", "l0.5153937,0.5087154", "l0.5134042,0.5111906", "l0.5104199,0.5113486", "l0.5089471,0.5122614", "l0.5067121,0.5113486", "l0.5040119,0.5119981", "l0.5037794,0.5133498", "l0.5018803,0.5144206", "l0.5018803,0.5144206", "l0.5002266,0.5149824", "l0.4955499,0.5098740", "l0.4919196,0.5044496", "l0.4876951,0.5027293", "l0.4869070,0.4959181", "l0.4898784,0.4941099", "l0.4888965,0.4892824", "l0.4877209,0.4870179", "l0.4952915,0.4803120", "l0.4978366,0.4733428", "l0.5001620,0.4719209", "l0.5006788,0.4676200", "l0.4981725,0.4617919", "l0.4988055,0.4583512", "l0.4963638,0.4570170", "l0.4946714,0.4571926", "l0.4868941,0.4604226", "l0.4851500,0.4632138", "l0.4830183,0.4645129", "l0.4810288,0.4673918", "l0.4745950,0.4651273", "l0.4721145,0.4630558", "l0.4679546,0.4654433", "l0.4616629,0.4673918", "l0.4659909,0.4732199", "l0.4624510,0.4781001", "l0.4622831,0.4793641", "l0.4610299,0.4797854", "l0.4605390,0.4790305", "l0.4593763,0.4789954", "l0.4584073,0.4798556", "l0.4569991,0.4780650", "l0.4536918,0.4764500", "l0.4537564,0.4745717", "l0.4523095,0.4739046", "l0.4518961,0.4720087", "l0.4512113,0.4715698", "l0.4519219,0.4696037", "l0.4485888,0.4714996", "l0.4473485,0.4689542", "l0.4459274,0.4699548", "l0.4456819,0.4681642", "l0.4460824,0.4669178", "l0.4455398,0.4642495", "l0.4458499,0.4589656", "l0.4401655,0.4589305", "l0.4401913,0.4565957", "l0.4372328,0.4554898", "l0.4369357,0.4523475", "l0.4360959,0.4506447", "l0.4322202,0.4491350", "l0.4281636,0.4449395", "l0.4230734,0.4452203", "l0.4257864,0.4397960", "l0.4304761,0.4355126", "l0.4323235,0.4301585", "l0.4359151,0.4242426", "l0.4356954,0.4207141", "l0.4335250,0.4160095", "l0.4322460,0.4153248", "l0.4267295,0.4145524", "l0.4249467,0.4170101", "l0.4185905,0.4165361", "l0.4135262,0.4198013", "l0.4099217,0.4259454", "l0.4035267,0.4264369", "l0.4053742,0.4173612", "l0.4051029,0.4160270", "l0.4047799,0.4150966", "l0.4031004,0.4140434", "l0.3994055,0.4094967", "l0.3989017,0.4097776", "l0.3930105,0.3991219", "l0.3931526,0.3981038", "l0.3967313,0.3932060", "l0.3860342,0.3599927", "l0.3860342,0.3599927", "l0.3996639,0.3626434", "l0.4033846,0.3640127", "l0.4237581,0.3660490", "l0.4318972,0.3637143", "l0.4365869,0.3642234", "l0.4372974,0.3626434", "l0.4468447,0.3637845", "l0.4616242,0.3689280", "l0.4656420,0.3765467", "l0.4713782,0.3788815", "l0.4766750,0.3790746", "l0.4805378,0.3822871", "l0.4861835,0.3858155", "l0.4950073,0.3887647", "l0.4976557,0.3886769", "l0.5061307,0.3865177", "l0.5059757,0.3930656", "l0.5126807,0.3935747", "l0.5141406,0.3958743", "l0.5179130,0.3908186", "l0.5185718,0.3909415", "l0.5266722,0.3843234", "l0.5410641,0.3753354", "l0.5505726,0.3724214", "l0.5510377,0.3709117", "l0.5536215,0.3692791", "l0.5547196,0.3691562", "l0.5552752,0.3703324", "l0.5611276,0.3707712", "l0.5664502,0.3692791", "l0.5673287,0.3699462", "l0.5711399,0.3694722", "l0.5753386,0.3708415", "l0.5758166,0.3715085", "l0.5783746,0.3694371", "l0.5833227,0.3704553", "l0.5878315,0.3689982", "l0.5925211,0.3643989", "l0.5977275,0.3640127", "l0.6006731,0.3613620", "l0.6025593,0.3592203", "l0.6026110,0.3573771", "l0.6053757,0.3552178", "l0.6067063,0.3513734", "l0.6123133,0.3426839", "l0.6184757,0.3388043", "l0.6209174,0.3382250", "l0.6239534,0.3319580", "l0.6271186,0.3308696", "l0.6279454,0.3296583", "l0.6279067,0.3281486", "l0.6254650,0.3228823", "l0.6224806,0.3215657", "l0.6218476,0.3206704", "l0.6178556,0.3119106", "l0.6179977,0.3097163", "l0.6199743,0.3044324", "l0.6206720,0.3002544", "l0.6236175,0.2927936", "l0.6260334,0.2892652", "l0.6274674,0.2887912", "l0.6346376,0.2896865", "l0.6357874,0.2905467", "l0.6371439,0.2930394", "l0.6399732,0.2955322", "l0.6425570,0.2958306", "l0.6461615,0.2978669", "l0.6517296,0.2981127", "l0.6543780,0.2996048", "l0.6571169,0.2963748", "l0.6613156,0.2931272", "l0.6667158,0.2864564", "l0.6685116,0.2826646", "l0.6688992,0.2798910", "l0.6710308,0.2781004", "l0.6728008,0.2773983", "l0.6768445,0.2790133", "l0.6768445,0.2801719", "l0.6799451,0.2794170", "l0.6823868,0.2796101", "l0.6863142,0.2781004", "l0.6886267,0.2778722", "l0.6893502,0.2758359", "l0.6921149,0.2723952", "l0.6942466,0.2703764", "l0.6959131,0.2702886", "l0.6968304,0.2694811", "l0.6976443,0.2676730", "l0.6978252,0.2655489", "l0.6973472,0.2638285", "l0.6974634,0.2616693", "l0.6993238,0.2569647", "l0.7022435,0.2525760", "l0.7027345,0.2509259", "l0.7056671,0.2500131", "l0.7072562,0.2479241", "l0.7092199,0.2489949", "l0.7154857,0.2489598", "l0.7156407,0.2462564", "l0.7166742,0.2435354", "l0.7166871,0.2415517", "l0.7193227,0.2413586", "l0.7205112,0.2436583", "l0.7228625,0.2435003", "l0.7238831,0.2416220", "l0.7265186,0.2399192", "l0.7286761,0.2370051", "l0.7300585,0.2364785", "l0.7302523,0.2348459", "l0.7332107,0.2350916", "l0.7342314,0.2341788", "l0.7355620,0.2356358", "l0.7363113,0.2354603", "l0.7367894,0.2343017", "l0.7389210,0.2350390", "l0.7418020,0.2338453", "l0.7417116,0.2349336", "l0.7436882,0.2350741", "l0.7435978,0.2362854", "l0.7442179,0.2370051", "l0.7456131,0.2365662", "l0.7487396,0.2398138", "l0.7496310,0.2421661", "l0.7487654,0.2429386", "l0.7484941,0.2449047", "l0.7505095,0.2466952", "l0.7504707,0.2453611", "l0.7514268,0.2443254", "l0.7518919,0.2424821", "l0.7547728,0.2401825", "l0.7558193,0.2374966", "l0.7572275,0.2360045", "l0.7552638,0.2304748", "l0.7554705,0.2284033", "l0.7550441,0.2268410", "l0.7557934,0.2269463", "l0.7558839,0.2240147", "l0.7550829,0.2239269", "l0.7535972,0.2217150", "l0.7546049,0.2208900", "l0.7554188,0.2229614", "l0.7563748,0.2227332", "l0.7557288,0.2196611", "l0.7538426,0.2175370", "l0.7526670,0.2177126", "l0.7512847,0.2166769", "l0.7499023,0.2170455", "l0.7474089,0.2139032", "l0.7477060,0.2127446", "l0.7473185,0.2101816", "l0.7455485,0.2110594", "l0.7446313,0.2103923", "l0.7441791,0.2050206", "l0.7384947,0.2016150", "l0.7336500,0.1952251", "l0.7299680,0.1951725", "l0.7289474,0.1941894", "l0.7276297,0.1945932", "l0.7277976,0.1939787", "l0.7232630,0.1943825", "l0.7219194,0.1955411", "l0.7185992,0.2021767", "l0.7171910,0.2034407", "l0.7156278,0.2071271", "l0.7112869,0.2014746", "l0.7063260,0.1985078", "l0.7036776,0.1988238", "l0.7012746,0.2004037", "l0.6973730,0.1992802", "l0.6966495,0.1996313", "l0.6954351,0.2006319", "l0.6921278,0.2058983", "l0.6862625,0.1973317", "l0.6846347,0.1962433", "l0.6842988,0.1953656", "l0.6858233,0.1952076", "l0.6851773,0.1892390", "l0.6903321,0.1862372", "l0.6902933,0.1776705", "l0.6950217,0.1689283", "l0.6941174,0.1658738", "l0.7046336,0.1333978", "l0.7086773,0.1374704", "l0.7140000,0.1405249", "l0.7173331,0.1406303", "l0.7234697,0.1448258", "l0.7237798,0.1437023", "l0.7261440,0.1411394", "l0.7269320,0.1411745", "l0.7268287,0.1406127", "l0.7276684,0.1395068", "l0.7284436,0.1395243", "l0.7297355,0.1370667", "l0.7320351,0.1355921", "l0.7321514,0.1339420", "l0.7326423,0.1342579", "l0.7335079,0.1335382", "l0.7350324,0.1304486", "l0.7410785,0.1285176", "l0.7419958,0.1289213", "l0.7433781,0.1284474", "l0.7440887,0.1274292", "l0.7453935,0.1274643", "l0.7470988,0.1245678", "l0.7481065,0.1218468", "l0.7480419,0.1199860", "l0.7473314,0.1183184", "l0.7481711,0.1169491", "l0.7477577,0.1158783", "l0.7450705,0.1159485", "l0.7447605,0.1149128", "l0.7440628,0.1145968", "l0.7447476,0.1134557", "l0.7454969,0.1137366", "l0.7462849,0.1112614", "l0.7459361,0.1105066", "l0.7464012,0.1100150", "l0.7466596,0.1069781", "l0.7477965,0.1060126", "l0.7482486,0.1042747", "l0.7491659,0.1038358", "l0.7500186,0.1022208", "l0.7505741,0.0963751", "l0.7522278,0.0929168", "l0.7533905,0.0924253", "l0.7537264,0.0906347", "l0.7543465,0.0899150", "l0.7547857,0.0873520", "l0.7545790,0.0854035", "l0.7553929,0.0853332", "l0.7550312,0.0845082", "l0.7553413,0.0831214", "l0.7563490,0.0825947", "l0.7565427,0.0810324", "l0.7573308,0.0805584", "l0.7568916,0.0794876", "l0.7577701,0.0787503", "l0.7583127,0.0770826", "l0.7580414,0.0757309", "l0.7592170,0.0735365", "l0.7591137,0.0719742", "l0.7600955,0.0701309", "l0.7600180,0.0690952", "l0.7613616,0.0689372", "l0.7637129,0.0652508", "l0.7659221,0.0631442", "l0.7662450,0.0617398", "l0.7672915,0.0618803", "l0.7676015,0.0607041", "l0.7690614,0.0601248", "l0.7700691,0.0576145", "l0.7696040,0.0559819", "l0.7705988,0.0547180", "l0.7712060,0.0518390", "l0.7705213,0.0500836", "l0.7708055,0.0485388", "l0.7700304,0.0482403", "l0.7686351,0.0462567", "l0.7684671,0.0451156", "l0.7690227,0.0443783", "l0.7698236,0.0400950", "l0.7696169,0.0390417", "l0.7702758,0.0379007", "l0.7696299,0.0379182", "l0.7658833,0.0343195", "l0.7645655,0.0352675", "l0.7629119,0.0351095", "l0.7614779,0.0366719", "l0.7595012,0.0364085", "l0.7588940,0.0346706", "l0.7594108,0.0320023", "l0.7589457,0.0295447", "l0.7606381,0.0280877", "l0.7612066,0.0282808", "l0.7630798,0.0260864", "l0.7631961,0.0250507", "l0.7638550,0.0248752", "l0.7640488,0.0235586", "l0.7649402,0.0228739", "l0.7671365,0.0185204", "l0.7685963,0.0174847", "l0.7696040,0.0147462", "l0.7719682,0.0122885", "l0.7717486,0.0116214", "l0.7721103,0.0110421", "l0.7754822,0.0105857", "l0.7759732,0.0100240", "l0.7768258,0.0110772", "l0.7784020,0.0107788", "l0.7800298,0.0092691", "l0.7828203,0.0089882", "c"]}, {"n": "Ningxia Hui", "u": "CN-64", "i": ["m0.5018674,0.5145611", "l0.5037665,0.5134902", "l0.5039990,0.5121385", "l0.5066991,0.5114890", "l0.5089471,0.5124018", "l0.5104199,0.5114890", "l0.5134042,0.5113310", "l0.5153937,0.5088558", "l0.5172024,0.5076445", "l0.5200963,0.5067317", "l0.5233519,0.5070126", "l0.5240237,0.5048182", "l0.5259874,0.5042214", "l0.5267367,0.5023782", "l0.5266205,0.5003945", "l0.5272923,0.4984986", "l0.5261037,0.4948472", "l0.5263621,0.4929162", "l0.5276669,0.4910554", "l0.5270726,0.4869477", "l0.5277961,0.4818568", "l0.5274602,0.4808211", "l0.5283775,0.4766431", "l0.5297082,0.4743259", "l0.5293852,0.4730795", "l0.5311939,0.4709378", "l0.5314652,0.4679887", "l0.5322791,0.4660401", "l0.5326796,0.4657417", "l0.5339973,0.4666545", "l0.5345399,0.4662332", "l0.5345787,0.4626345", "l0.5378343,0.4620903", "l0.5397334,0.4599662", "l0.5422010,0.4595098", "l0.5427565,0.4599838", "l0.5428211,0.4636702", "l0.5438934,0.4664088", "l0.5437125,0.4677429", "l0.5455470,0.4686557", "l0.5457796,0.4707447", "l0.5456246,0.4717805", "l0.5431312,0.4753265", "l0.5420201,0.4779070", "l0.5413483,0.4782055", "l0.5408961,0.4834192", "l0.5400176,0.4862630", "l0.5381056,0.4885978", "l0.5379764,0.4896686", "l0.5390616,0.4912134", "l0.5431828,0.4941626", "l0.5463610,0.4951983", "l0.5490223,0.4941802", "l0.5505080,0.4958478", "l0.5516578,0.4960585", "l0.5532856,0.4986917", "l0.5529626,0.5000434", "l0.5548230,0.5014829", "l0.5569288,0.5021148", "l0.5569288,0.5021148", "l0.5564896,0.5047129", "l0.5543579,0.5051693", "l0.5539703,0.5070652", "l0.5524200,0.5072934", "l0.5524459,0.5083818", "l0.5511927,0.5094702", "l0.5521746,0.5110326", "l0.5508568,0.5130865", "l0.5504563,0.5162990", "l0.5506501,0.5190024", "l0.5511927,0.5199152", "l0.5507405,0.5201610", "l0.5516707,0.5217760", "l0.5511927,0.5235841", "l0.5506889,0.5228293", "l0.5507147,0.5241634", "l0.5507147,0.5241634", "l0.5489060,0.5223202", "l0.5477950,0.5229873", "l0.5467356,0.5227064", "l0.5464901,0.5233735", "l0.5445523,0.5223378", "l0.5444618,0.5235666", "l0.5427177,0.5221271", "l0.5421881,0.5239352", "l0.5416842,0.5231102", "l0.5398368,0.5227240", "l0.5404698,0.5249007", "l0.5403019,0.5274988", "l0.5397076,0.5273233", "l0.5393588,0.5280606", "l0.5386741,0.5270248", "l0.5396301,0.5293245", "l0.5403923,0.5295527", "l0.5400435,0.5303251", "l0.5406248,0.5314661", "l0.5401339,0.5333796", "l0.5404569,0.5341345", "l0.5394104,0.5333445", "l0.5383898,0.5339414", "l0.5377180,0.5365921", "l0.5370333,0.5369607", "l0.5372529,0.5385231", "l0.5357414,0.5383124", "l0.5383252,0.5408403", "l0.5377955,0.5425607", "l0.5383382,0.5433682", "l0.5382348,0.5458609", "l0.5376018,0.5454923", "l0.5379506,0.5465456", "l0.5388549,0.5468967", "l0.5391779,0.5459136", "l0.5400564,0.5466684", "l0.5409866,0.5465631", "l0.5423431,0.5479675", "l0.5434154,0.5476164", "l0.5448236,0.5506358", "l0.5453533,0.5502847", "l0.5453662,0.5542345", "l0.5445264,0.5552878", "l0.5452241,0.5557617", "l0.5437900,0.5569379", "l0.5450432,0.5591673", "l0.5445781,0.5591147", "l0.5447719,0.5601504", "l0.5442293,0.5599748", "l0.5441259,0.5609228", "l0.5435446,0.5607999", "l0.5432345,0.5617127", "l0.5422656,0.5613617", "l0.5419943,0.5625729", "l0.5411029,0.5615021", "l0.5404311,0.5618707", "l0.5387903,0.5608877", "l0.5371367,0.5622569", "l0.5377697,0.5652412", "l0.5372013,0.5668036", "l0.5378214,0.5681026", "l0.5376534,0.5687346", "l0.5382219,0.5689979", "l0.5381056,0.5713502", "l0.5358706,0.5746856", "l0.5340361,0.5718769", "l0.5338035,0.5699634", "l0.5330930,0.5699810", "l0.5328217,0.5692437", "l0.5317494,0.5712976", "l0.5308838,0.5694368", "l0.5312585,0.5685942", "l0.5283646,0.5698581", "l0.5283516,0.5684888", "l0.5308580,0.5677866", "l0.5307675,0.5687170", "l0.5313876,0.5674531", "l0.5302508,0.5675760", "l0.5302766,0.5668036", "l0.5281966,0.5661014", "l0.5273698,0.5677164", "l0.5269822,0.5655572", "l0.5265688,0.5656274", "l0.5249281,0.5623974", "l0.5251864,0.5616250", "l0.5258582,0.5619234", "l0.5258582,0.5611686", "l0.5241400,0.5609052", "l0.5228352,0.5624149", "l0.5226414,0.5613792", "l0.5216208,0.5614143", "l0.5210136,0.5606419", "l0.5204968,0.5588162", "l0.5196700,0.5592551", "l0.5200446,0.5578332", "l0.5190240,0.5568677", "l0.5189336,0.5534796", "l0.5205356,0.5511800", "l0.5216078,0.5511273", "l0.5218791,0.5498809", "l0.5211298,0.5474057", "l0.5213365,0.5458785", "l0.5201997,0.5440177", "l0.5192953,0.5400152", "l0.5176287,0.5390673", "l0.5179517,0.5381896", "l0.5169182,0.5343276", "l0.5184685,0.5332743", "l0.5190369,0.5321859", "l0.5180938,0.5299916", "l0.5173058,0.5292367", "l0.5166986,0.5295176", "l0.5163885,0.5267791", "l0.5131846,0.5251640", "l0.5121769,0.5236895", "l0.5111692,0.5203716", "l0.5101356,0.5195466", "l0.5088825,0.5209334", "l0.5083011,0.5210738", "l0.5075389,0.5201785", "l0.5070092,0.5188619", "l0.5088954,0.5170714", "l0.5082882,0.5163516", "l0.5093217,0.5147542", "l0.5081590,0.5151228", "l0.5050584,0.5141924", "l0.5041282,0.5151228", "c"]}, {"n": "Quinghai", "u": "CN-63", "i": ["m0.3169425,0.4654959", "l0.3173430,0.4661805", "l0.3184153,0.4660752", "l0.3196039,0.4651624", "l0.3201594,0.4657241", "l0.3226657,0.4642847", "l0.3249007,0.4640389", "l0.3258180,0.4621254", "l0.3292028,0.4631085", "l0.3314120,0.4623010", "l0.3320967,0.4630383", "l0.3341250,0.4628101", "l0.3361533,0.4623010", "l0.3364634,0.4613530", "l0.3382075,0.4607035", "l0.3386467,0.4616339", "l0.3443570,0.4616164", "l0.3460365,0.4635649", "l0.3488012,0.4641091", "l0.3491371,0.4634947", "l0.3529611,0.4653555", "l0.3551574,0.4646006", "l0.3572115,0.4683573", "l0.3586197,0.4698144", "l0.3597049,0.4700075", "l0.3599762,0.4712889", "l0.3616299,0.4737641", "l0.3628185,0.4745365", "l0.3630122,0.4739046", "l0.3650793,0.4769240", "l0.3674306,0.4776964", "l0.3675727,0.4794518", "l0.3682574,0.4803822", "l0.3690067,0.4796800", "l0.3704278,0.4811897", "l0.3719265,0.4806631", "l0.3752725,0.4835596", "l0.3751175,0.4853853", "l0.3755955,0.4860348", "l0.3769391,0.4868072", "l0.3781535,0.4866668", "l0.3799363,0.4885627", "l0.3823910,0.4890893", "l0.3829207,0.4819797", "l0.3820551,0.4811020", "l0.3820163,0.4795396", "l0.3828432,0.4787497", "l0.3825331,0.4754669", "l0.3829207,0.4746243", "l0.3823522,0.4737993", "l0.3829336,0.4723773", "l0.3830111,0.4688313", "l0.3821326,0.4673743", "l0.3834633,0.4646006", "l0.3886955,0.4656364", "l0.3912019,0.4681642", "l0.3941216,0.4700952", "l0.3944833,0.4714294", "l0.3996122,0.4744137", "l0.4008008,0.4761691", "l0.4037722,0.4716751", "l0.4040952,0.4693404", "l0.4056196,0.4695510", "l0.4068211,0.4717278", "l0.4082681,0.4716927", "l0.4088623,0.4722720", "l0.4117821,0.4679887", "l0.4127252,0.4679887", "l0.4156061,0.4715172", "l0.4160454,0.4708676", "l0.4174277,0.4717629", "l0.4167947,0.4733077", "l0.4215748,0.4783810", "l0.4229830,0.4815759", "l0.4239519,0.4813477", "l0.4243524,0.4832261", "l0.4267554,0.4863332", "l0.4333571,0.4907219", "l0.4348428,0.4925125", "l0.4346361,0.4893702", "l0.4340289,0.4890367", "l0.4333441,0.4870881", "l0.4339255,0.4863157", "l0.4338351,0.4847884", "l0.4355662,0.4857715", "l0.4362380,0.4881589", "l0.4369357,0.4878254", "l0.4374266,0.4896335", "l0.4390415,0.4902304", "l0.4394162,0.4910905", "l0.4399975,0.4905990", "l0.4417028,0.4916698", "l0.4423100,0.4957074", "l0.4454236,0.4972171", "l0.4469222,0.4988672", "l0.4475423,0.4984108", "l0.4499194,0.5001663", "l0.4515472,0.5027293", "l0.4539890,0.5042565", "l0.4588078,0.5096282", "l0.4600480,0.5100320", "l0.4606682,0.5117874", "l0.4619730,0.5122087", "l0.4624769,0.5077674", "l0.4642726,0.5050816", "l0.4646085,0.5094527", "l0.4659004,0.5105059", "l0.4648669,0.5132796", "l0.4664172,0.5136833", "l0.4679158,0.5151579", "l0.4680579,0.5147015", "l0.4703188,0.5172645", "l0.4705384,0.5186513", "l0.4716624,0.5184055", "l0.4725021,0.5202663", "l0.4742979,0.5218287", "l0.4726184,0.5239879", "l0.4727347,0.5256556", "l0.4720887,0.5271302", "l0.4736261,0.5285345", "l0.4738586,0.5295527", "l0.4749180,0.5302373", "l0.4764812,0.5328881", "l0.4744658,0.5338887", "l0.4743883,0.5345733", "l0.4749955,0.5361883", "l0.4764037,0.5370485", "l0.4782641,0.5445268", "l0.4813517,0.5468967", "l0.4819848,0.5481781", "l0.4808350,0.5484590", "l0.4798919,0.5509869", "l0.4790263,0.5515135", "l0.4804474,0.5528126", "l0.4799694,0.5554457", "l0.4801503,0.5583774", "l0.4774502,0.5576752", "l0.4758999,0.5593078", "l0.4759515,0.5611159", "l0.4770238,0.5642757", "l0.4764295,0.5667685", "l0.4741429,0.5664349", "l0.4734065,0.5657503", "l0.4716495,0.5694017", "l0.4695049,0.5694017", "l0.4692723,0.5707358", "l0.4697503,0.5718769", "l0.4691819,0.5727370", "l0.4703317,0.5734041", "l0.4703575,0.5742643", "l0.4709389,0.5746154", "l0.4710423,0.5763708", "l0.4701638,0.5766693", "l0.4692207,0.5794605", "l0.4682388,0.5794605", "l0.4667660,0.5806015", "l0.4655774,0.5824799", "l0.4644147,0.5827432", "l0.4644406,0.5838316", "l0.4633037,0.5842704", "l0.4632649,0.5879569", "l0.4620893,0.5870967", "l0.4617275,0.5881500", "l0.4600739,0.5890102", "l0.4618309,0.5910816", "l0.4632262,0.5897826", "l0.4634975,0.5919945", "l0.4646731,0.5933110", "l0.4659133,0.5933110", "l0.4671536,0.5942239", "l0.4672957,0.5955054", "l0.4687685,0.5982614", "l0.4676316,0.5982614", "l0.4670373,0.6006313", "l0.4657066,0.6001749", "l0.4655129,0.6016846", "l0.4648669,0.6017724", "l0.4645568,0.6034401", "l0.4639496,0.6035629", "l0.4638334,0.6049673", "l0.4622185,0.6037912", "l0.4620376,0.6044582", "l0.4609007,0.6045284", "l0.4603839,0.6057748", "l0.4597767,0.6046338", "l0.4589628,0.6045987", "l0.4590533,0.6038614", "l0.4584202,0.6029310", "l0.4535756,0.6012106", "l0.4536014,0.6005962", "l0.4525679,0.5998414", "l0.4491960,0.5991392", "l0.4480978,0.5977875", "l0.4466638,0.5976997", "l0.4462504,0.5988232", "l0.4453848,0.5993147", "l0.4445321,0.6030363", "l0.4453460,0.6039140", "l0.4481495,0.6104092", "l0.4493510,0.6116381", "l0.4508496,0.6120594", "l0.4515472,0.6134286", "l0.4510951,0.6169220", "l0.4522707,0.6162900", "l0.4548158,0.6171678", "l0.4553713,0.6159741", "l0.4565470,0.6157283", "l0.4579681,0.6165358", "l0.4586269,0.6210824", "l0.4603323,0.6210473", "l0.4609782,0.6198361", "l0.4609782,0.6198361", "l0.4609911,0.6222586", "l0.4599576,0.6224693", "l0.4590662,0.6247865", "l0.4589628,0.6257871", "l0.4603323,0.6269808", "l0.4589112,0.6312992", "l0.4560560,0.6282798", "l0.4548158,0.6284027", "l0.4546737,0.6302811", "l0.4538339,0.6286485", "l0.4508884,0.6302635", "l0.4510305,0.6315450", "l0.4502424,0.6333005", "l0.4503070,0.6366183", "l0.4513793,0.6371976", "l0.4521803,0.6388302", "l0.4520898,0.6411474", "l0.4515214,0.6424464", "l0.4502553,0.6438683", "l0.4501907,0.6429028", "l0.4494156,0.6426746", "l0.4472064,0.6446934", "l0.4431240,0.6426922", "l0.4437182,0.6444827", "l0.4428139,0.6442370", "l0.4428914,0.6468175", "l0.4422713,0.6472213", "l0.4417804,0.6489592", "l0.4404368,0.6497842", "l0.4393386,0.6480814", "l0.4403076,0.6463786", "l0.4413411,0.6457467", "l0.4407210,0.6453078", "l0.4396616,0.6423235", "l0.4385635,0.6406909", "l0.4375558,0.6415687", "l0.4362768,0.6410420", "l0.4354887,0.6446407", "l0.4339513,0.6437806", "l0.4334475,0.6429204", "l0.4342227,0.6413580", "l0.4337963,0.6380226", "l0.4324527,0.6369694", "l0.4324527,0.6357581", "l0.4314321,0.6357581", "l0.4302823,0.6327738", "l0.4297655,0.6358634", "l0.4281894,0.6357230", "l0.4285770,0.6376189", "l0.4278018,0.6416740", "l0.4272334,0.6405681", "l0.4262903,0.6398132", "l0.4257218,0.6400941", "l0.4249596,0.6387599", "l0.4215748,0.6366358", "l0.4208126,0.6374082", "l0.4201149,0.6372502", "l0.4187713,0.6333005", "l0.4156320,0.6319312", "l0.4132807,0.6301231", "l0.4125185,0.6283676", "l0.4125960,0.6273494", "l0.4118208,0.6267877", "l0.4121567,0.6247162", "l0.4113687,0.6233119", "l0.4114720,0.6215740", "l0.4100380,0.6199414", "l0.4100638,0.6185897", "l0.4095083,0.6178524", "l0.4101930,0.6170800", "l0.4069761,0.6117961", "l0.4060847,0.6112519", "l0.4036301,0.6119716", "l0.4036430,0.6101810", "l0.3997543,0.6091278", "l0.3984753,0.6095315", "l0.3980232,0.6105146", "l0.3964729,0.6115678", "l0.3956331,0.6114274", "l0.3951939,0.6106550", "l0.3957882,0.6096544", "l0.3957882,0.6084782", "l0.3939020,0.6074074", "l0.3933981,0.6099177", "l0.3928297,0.6096017", "l0.3893932,0.6106901", "l0.3895094,0.6117434", "l0.3890960,0.6122174", "l0.3900520,0.6161145", "l0.3896645,0.6178524", "l0.3903233,0.6187126", "l0.3915248,0.6189057", "l0.3914344,0.6205207", "l0.3921579,0.6219777", "l0.3956073,0.6232241", "l0.3940699,0.6251200", "l0.3932560,0.6252253", "l0.3928297,0.6275074", "l0.3909951,0.6298773", "l0.3910339,0.6313519", "l0.3919253,0.6331074", "l0.3912277,0.6336164", "l0.3914990,0.6344766", "l0.3893673,0.6352490", "l0.3888635,0.6366358", "l0.3900133,0.6420778", "l0.3949613,0.6466595", "l0.3949613,0.6466595", "l0.3939278,0.6473617", "l0.3940182,0.6480288", "l0.3890702,0.6466946", "l0.3893157,0.6473968", "l0.3885663,0.6488363", "l0.3893673,0.6494331", "l0.3898066,0.6513466", "l0.3888893,0.6516099", "l0.3898453,0.6523999", "l0.3890702,0.6532074", "l0.3883467,0.6525052", "l0.3877266,0.6530143", "l0.3873261,0.6556475", "l0.3880496,0.6582982", "l0.3871194,0.6582982", "l0.3865897,0.6575785", "l0.3868481,0.6589126", "l0.3857500,0.6596324", "l0.3823006,0.6587195", "l0.3819647,0.6593515", "l0.3824297,0.6604925", "l0.3820680,0.6607559", "l0.3813704,0.6599659", "l0.3806857,0.6609841", "l0.3800009,0.6600186", "l0.3785411,0.6597377", "l0.3789545,0.6618969", "l0.3799234,0.6632311", "l0.3791224,0.6643195", "l0.3804144,0.6675846", "l0.3798976,0.6690241", "l0.3787349,0.6688661", "l0.3778305,0.6675144", "l0.3773396,0.6680761", "l0.3766290,0.6673213", "l0.3756601,0.6676373", "l0.3739548,0.6659696", "l0.3719135,0.6619847", "l0.3698077,0.6631960", "l0.3700661,0.6643019", "l0.3691876,0.6642843", "l0.3689292,0.6654078", "l0.3703503,0.6669351", "l0.3708542,0.6686554", "l0.3702728,0.6707269", "l0.3709188,0.6711657", "l0.3707379,0.6720435", "l0.3699628,0.6723770", "l0.3690843,0.6685326", "l0.3683737,0.6679181", "l0.3645884,0.6677075", "l0.3637486,0.6687959", "l0.3626763,0.6666542", "l0.3606480,0.6660925", "l0.3596920,0.6670229", "l0.3589040,0.6669526", "l0.3579092,0.6655658", "l0.3564622,0.6614229", "l0.3567723,0.6604925", "l0.3576120,0.6602117", "l0.3571340,0.6593515", "l0.3577671,0.6586318", "l0.3574699,0.6563321", "l0.3569144,0.6556299", "l0.3562038,0.6559108", "l0.3554158,0.6538393", "l0.3517209,0.6539622", "l0.3506744,0.6522770", "l0.3488270,0.6512939", "l0.3486720,0.6506444", "l0.3492921,0.6503460", "l0.3486978,0.6484325", "l0.3473801,0.6478532", "l0.3464370,0.6465893", "l0.3468504,0.6461329", "l0.3441374,0.6429028", "l0.3428713,0.6447636", "l0.3416052,0.6447285", "l0.3414114,0.6456413", "l0.3404554,0.6447812", "l0.3399903,0.6468351", "l0.3373806,0.6469579", "l0.3370060,0.6484501", "l0.3362825,0.6491172", "l0.3349777,0.6481692", "l0.3342413,0.6488012", "l0.3334532,0.6477303", "l0.3327556,0.6483623", "l0.3317737,0.6480990", "l0.3310115,0.6460100", "l0.3295258,0.6453254", "l0.3284277,0.6454834", "l0.3277171,0.6468526", "l0.3262314,0.6480112", "l0.3255208,0.6472213", "l0.3252625,0.6459047", "l0.3239447,0.6466771", "l0.3217743,0.6431661", "l0.3205599,0.6430784", "l0.3187641,0.6440088", "l0.3179502,0.6410069", "l0.3156377,0.6422006", "l0.3127180,0.6404276", "l0.3119557,0.6415862", "l0.3088681,0.6404452", "l0.3072919,0.6404627", "l0.3057416,0.6416213", "l0.3047468,0.6408314", "l0.3046693,0.6394621", "l0.3051732,0.6385493", "l0.3037521,0.6373029", "l0.3008840,0.6390408", "l0.2997213,0.6367587", "l0.2991141,0.6367938", "l0.2988686,0.6357054", "l0.2980418,0.6357581", "l0.2962460,0.6344591", "l0.2942565,0.6328967", "l0.2938172,0.6316328", "l0.2928612,0.6312466", "l0.2911688,0.6276830", "l0.2911688,0.6269808", "l0.2918664,0.6266824", "l0.2914143,0.6258573", "l0.2887271,0.6256993", "l0.2881328,0.6262611", "l0.2878098,0.6279463", "l0.2852647,0.6284203", "l0.2848126,0.6279287", "l0.2824355,0.6313694", "l0.2801875,0.6305795", "l0.2767769,0.6273143", "l0.2748390,0.6271212", "l0.2726686,0.6235928", "l0.2725265,0.6209771", "l0.2714412,0.6195376", "l0.2685603,0.6175891", "l0.2688962,0.6159389", "l0.2683536,0.6149910", "l0.2673588,0.6147803", "l0.2675913,0.6130424", "l0.2661573,0.6112519", "l0.2653563,0.6112694", "l0.2636768,0.6087942", "l0.2629534,0.6064068", "l0.2637543,0.6044407", "l0.2647491,0.6043705", "l0.2656922,0.6033523", "l0.2659506,0.5998589", "l0.2666482,0.5988407", "l0.2655114,0.5970853", "l0.2658860,0.5958038", "l0.2657051,0.5932408", "l0.2651238,0.5920296", "l0.2654468,0.5910465", "l0.2645295,0.5904848", "l0.2643228,0.5884309", "l0.2655243,0.5877813", "l0.2665836,0.5859206", "l0.2656535,0.5844284", "l0.2655114,0.5832171", "l0.2639611,0.5832523", "l0.2628112,0.5841826", "l0.2620232,0.5837789", "l0.2616485,0.5828309", "l0.2620490,0.5779508", "l0.2609121,0.5773715", "l0.2598269,0.5747909", "l0.2610801,0.5733866", "l0.2605762,0.5732286", "l0.2605633,0.5711571", "l0.2636768,0.5696474", "l0.2648783,0.5680675", "l0.2639740,0.5672249", "l0.2638706,0.5662418", "l0.2640515,0.5654168", "l0.2648783,0.5650130", "l0.2642453,0.5633278", "l0.2654468,0.5579209", "l0.2610801,0.5574996", "l0.2614160,0.5572188", "l0.2593102,0.5560075", "l0.2594135,0.5542520", "l0.2590001,0.5539185", "l0.2594135,0.5527599", "l0.2606408,0.5531812", "l0.2624366,0.5517944", "l0.2643874,0.5516013", "l0.2643874,0.5516013", "l0.2679660,0.5517944", "l0.2677722,0.5504778", "l0.2688316,0.5488979", "l0.2689091,0.5462822", "l0.2709762,0.5472126", "l0.2708599,0.5481430", "l0.2725781,0.5494070", "l0.2760275,0.5502847", "l0.2772549,0.5497229", "l0.2798904,0.5503374", "l0.2814278,0.5514960", "l0.2825388,0.5533392", "l0.2839599,0.5528301", "l0.2846705,0.5510044", "l0.2867117,0.5513380", "l0.2866213,0.5480377", "l0.2857557,0.5468089", "l0.2862724,0.5457029", "l0.2854585,0.5448603", "l0.2859365,0.5421394", "l0.2854844,0.5416127", "l0.2855490,0.5392077", "l0.2806914,0.5377156", "l0.2802780,0.5351175", "l0.2809756,0.5339414", "l0.2804330,0.5321683", "l0.2806268,0.5312379", "l0.2826034,0.5286750", "l0.2852777,0.5284994", "l0.2858978,0.5272530", "l0.2868538,0.5272004", "l0.2879003,0.5256731", "l0.2901482,0.5256205", "l0.2896185,0.5222149", "l0.2881199,0.5205472", "l0.2880553,0.5187742", "l0.2872026,0.5169836", "l0.2864921,0.5134025", "l0.2851356,0.5126827", "l0.2840762,0.5131216", "l0.2827972,0.5115241", "l0.2830427,0.5103480", "l0.2817895,0.5088031", "l0.2795674,0.5068721", "l0.2772549,0.5061173", "l0.2767639,0.5049938", "l0.2756917,0.5047656", "l0.2760534,0.5039932", "l0.2753687,0.5017989", "l0.2766347,0.4998503", "l0.2743481,0.4952861", "l0.2727461,0.4901777", "l0.2712345,0.4877376", "l0.2712216,0.4864210", "l0.2756271,0.4846480", "l0.2763764,0.4837703", "l0.2762084,0.4829452", "l0.2786372,0.4816988", "l0.2791798,0.4805753", "l0.2788956,0.4796274", "l0.2812727,0.4799083", "l0.2869701,0.4785039", "l0.2899286,0.4773804", "l0.2922153,0.4756074", "l0.2963752,0.4740275", "l0.2991916,0.4736939", "l0.3023568,0.4715347", "l0.3077182,0.4702357", "l0.3080283,0.4691999", "l0.3088551,0.4690595", "l0.3095786,0.4672514", "l0.3155085,0.4663561", "c"]}, {"n": "Shaanxi", "u": "CN-61", "i": ["m0.5569288,0.5021148", "l0.5574585,0.5017989", "l0.5585696,0.5032734", "l0.5620577,0.5044320", "l0.5628458,0.5079430", "l0.5648483,0.5092947", "l0.5667345,0.5079254", "l0.5677680,0.5088383", "l0.5685561,0.5077674", "l0.5711657,0.5072583", "l0.5719409,0.5073988", "l0.5719150,0.5083643", "l0.5738012,0.5081361", "l0.5742405,0.5072759", "l0.5753257,0.5074339", "l0.5752999,0.5002014", "l0.5760363,0.4989901", "l0.5755066,0.4980597", "l0.5763592,0.4981475", "l0.5779225,0.5007982", "l0.5797828,0.4976911", "l0.5797828,0.4961814", "l0.5777933,0.4935131", "l0.5784392,0.4890893", "l0.5797311,0.4860699", "l0.5810360,0.4850693", "l0.5814494,0.4828750", "l0.5824442,0.4824186", "l0.5833097,0.4809791", "l0.5845112,0.4811897", "l0.5842399,0.4787145", "l0.5853768,0.4785214", "l0.5858161,0.4759409", "l0.5872630,0.4751861", "l0.5881932,0.4756951", "l0.5885678,0.4740801", "l0.5899373,0.4723247", "l0.5905832,0.4684978", "l0.5930120,0.4676727", "l0.5944977,0.4650395", "l0.5987094,0.4622834", "l0.5973141,0.4589129", "l0.5971332,0.4579299", "l0.5975983,0.4572101", "l0.5991616,0.4577368", "l0.6015387,0.4614584", "l0.6021459,0.4607913", "l0.6020167,0.4600715", "l0.6036962,0.4594396", "l0.6053111,0.4632840", "l0.6069260,0.4622308", "l0.6072231,0.4604051", "l0.6094969,0.4562095", "l0.6119774,0.4542259", "l0.6130367,0.4545243", "l0.6136439,0.4537519", "l0.6139411,0.4547701", "l0.6124941,0.4583863", "l0.6130884,0.4600189", "l0.6137731,0.4598960", "l0.6137731,0.4598960", "l0.6140315,0.4606333", "l0.6145483,0.4602998", "l0.6145870,0.4614584", "l0.6156206,0.4618270", "l0.6149358,0.4625116", "l0.6143416,0.4668476", "l0.6135535,0.4688840", "l0.6116156,0.4701479", "l0.6111764,0.4710607", "l0.6118094,0.4738168", "l0.6096777,0.4802769", "l0.6102333,0.4822430", "l0.6100007,0.4839283", "l0.6095098,0.4840687", "l0.6095227,0.4855959", "l0.6090705,0.4862279", "l0.6080241,0.4859822", "l0.6073006,0.4883696", "l0.6059700,0.4900548", "l0.6047168,0.4901075", "l0.6044067,0.4924247", "l0.6037091,0.4927056", "l0.6034636,0.4935482", "l0.6036445,0.4996923", "l0.6049364,0.5009738", "l0.6061379,0.5043618", "l0.6074557,0.5054502", "l0.6066676,0.5067141", "l0.6082179,0.5083116", "l0.6076107,0.5087329", "l0.6080887,0.5111379", "l0.6074040,0.5137184", "l0.6056728,0.5145259", "l0.6055695,0.5162287", "l0.6067063,0.5169309", "l0.6062413,0.5177736", "l0.6064609,0.5186864", "l0.6059829,0.5187566", "l0.6038383,0.5236017", "l0.6019779,0.5254976", "l0.6025851,0.5262349", "l0.6012932,0.5260067", "l0.6022105,0.5274286", "l0.6019263,0.5293947", "l0.6014095,0.5299213", "l0.6021200,0.5303251", "l0.6021330,0.5319401", "l0.6014612,0.5327827", "l0.6022363,0.5329934", "l0.6021071,0.5340642", "l0.6026110,0.5338887", "l0.6023397,0.5351526", "l0.6017454,0.5347840", "l0.6016033,0.5352931", "l0.6034249,0.5379965", "l0.6025205,0.5494070", "l0.6051948,0.5639773", "l0.6042000,0.5665929", "l0.6036962,0.5700863", "l0.6018229,0.5735446", "l0.6011382,0.5782141", "l0.5996783,0.5818830", "l0.5998334,0.5868685", "l0.5992262,0.5892735", "l0.6000401,0.5913274", "l0.6014741,0.5916785", "l0.6014741,0.5916785", "l0.6012028,0.5923455", "l0.6017712,0.5927669", "l0.6011253,0.5942414", "l0.6021976,0.5968746", "l0.6030244,0.5967518", "l0.6033474,0.5988583", "l0.6021588,0.6001222", "l0.6023913,0.6012457", "l0.6056857,0.6033698", "l0.6047685,0.6051077", "l0.6047426,0.6069510", "l0.6053240,0.6070388", "l0.6062154,0.6090575", "l0.6049106,0.6104443", "l0.6051044,0.6115678", "l0.6078691,0.6131126", "l0.6087734,0.6164831", "l0.6116285,0.6191514", "l0.6119386,0.6218724", "l0.6114477,0.6227677", "l0.6119903,0.6253131", "l0.6114994,0.6257344", "l0.6112280,0.6274723", "l0.6112280,0.6274723", "l0.6100912,0.6288240", "l0.6087605,0.6288065", "l0.6085279,0.6302986", "l0.6073523,0.6303864", "l0.6067839,0.6317381", "l0.6059183,0.6301933", "l0.6050010,0.6301933", "l0.6043809,0.6275425", "l0.6021330,0.6297369", "l0.5989807,0.6300704", "l0.5978696,0.6287538", "l0.5956863,0.6292102", "l0.5927666,0.6277356", "l0.5905703,0.6281218", "l0.5895109,0.6277005", "l0.5892396,0.6269983", "l0.5886712,0.6281394", "l0.5871338,0.6281921", "l0.5860228,0.6302635", "l0.5882707,0.6313519", "l0.5900923,0.6311939", "l0.5917718,0.6324227", "l0.5913325,0.6366885", "l0.5918622,0.6374433", "l0.5930120,0.6365656", "l0.5956088,0.6376013", "l0.5974821,0.6392866", "l0.5977017,0.6424113", "l0.5985544,0.6439034", "l0.5978696,0.6449216", "l0.5966552,0.6443247", "l0.5965519,0.6452727", "l0.5954667,0.6461504", "l0.5937226,0.6449567", "l0.5921981,0.6453605", "l0.5905445,0.6445178", "l0.5889683,0.6449392", "l0.5892526,0.6463084", "l0.5882965,0.6471159", "l0.5874568,0.6491172", "l0.5869400,0.6526105", "l0.5878444,0.6545766", "l0.5887229,0.6550682", "l0.5884774,0.6565252", "l0.5890200,0.6577540", "l0.5884516,0.6597728", "l0.5891621,0.6618969", "l0.5884128,0.6630204", "l0.5892784,0.6653376", "l0.5885291,0.6659169", "l0.5883482,0.6674266", "l0.5883482,0.6674266", "l0.5835810,0.6677953", "l0.5831160,0.6664260", "l0.5833614,0.6655834", "l0.5820824,0.6650041", "l0.5819145,0.6640035", "l0.5794340,0.6613527", "l0.5770440,0.6605803", "l0.5748994,0.6586669", "l0.5747056,0.6576311", "l0.5734524,0.6575785", "l0.5710107,0.6549628", "l0.5710107,0.6549628", "l0.5703906,0.6534005", "l0.5682718,0.6536111", "l0.5678843,0.6542080", "l0.5664373,0.6532249", "l0.5656234,0.6545415", "l0.5651325,0.6541378", "l0.5647320,0.6546995", "l0.5637889,0.6542255", "l0.5629621,0.6546995", "l0.5628458,0.6558581", "l0.5621740,0.6566130", "l0.5609984,0.6551384", "l0.5601069,0.6550506", "l0.5586212,0.6519610", "l0.5578332,0.6519434", "l0.5569676,0.6499773", "l0.5559857,0.6496965", "l0.5547842,0.6504513", "l0.5542029,0.6493454", "l0.5536344,0.6495209", "l0.5532210,0.6465191", "l0.5523813,0.6463611", "l0.5511410,0.6478532", "l0.5506372,0.6498193", "l0.5499783,0.6495736", "l0.5476012,0.6466068", "l0.5478337,0.6434646", "l0.5472136,0.6427273", "l0.5472395,0.6419198", "l0.5465289,0.6415687", "l0.5449528,0.6421831", "l0.5438934,0.6416213", "l0.5426661,0.6424991", "l0.5426273,0.6413229", "l0.5420072,0.6413054", "l0.5398755,0.6431661", "l0.5373563,0.6433944", "l0.5367103,0.6443950", "l0.5355476,0.6430433", "l0.5343720,0.6430433", "l0.5317752,0.6414985", "l0.5309484,0.6403750", "l0.5314652,0.6391637", "l0.5306513,0.6377769", "l0.5300570,0.6387775", "l0.5292947,0.6383211", "l0.5270726,0.6390057", "l0.5265300,0.6408665", "l0.5258712,0.6403750", "l0.5233132,0.6422006", "l0.5226931,0.6412527", "l0.5217241,0.6366709", "l0.5217241,0.6366709", "l0.5239979,0.6374258", "l0.5270856,0.6355474", "l0.5276540,0.6358634", "l0.5285584,0.6344239", "l0.5287909,0.6305093", "l0.5282225,0.6304039", "l0.5288167,0.6291927", "l0.5292947,0.6304215", "l0.5293335,0.6288767", "l0.5285584,0.6279990", "l0.5265688,0.6274197", "l0.5251477,0.6242247", "l0.5270856,0.6242423", "l0.5273569,0.6212404", "l0.5292431,0.6182035", "l0.5315944,0.6181859", "l0.5316719,0.6192568", "l0.5329509,0.6198361", "l0.5346045,0.6183966", "l0.5356380,0.6187652", "l0.5369429,0.6179226", "l0.5373563,0.6202047", "l0.5381185,0.6203276", "l0.5384544,0.6210824", "l0.5395009,0.6188881", "l0.5387128,0.6160092", "l0.5377697,0.6155878", "l0.5378343,0.6139026", "l0.5374080,0.6133057", "l0.5379506,0.6118838", "l0.5375630,0.6112343", "l0.5368525,0.6113396", "l0.5367491,0.6106199", "l0.5376664,0.6084958", "l0.5380927,0.6050024", "l0.5395784,0.6040369", "l0.5388937,0.6013159", "l0.5380927,0.6014915", "l0.5380023,0.6010000", "l0.5384932,0.5999994", "l0.5393200,0.6002978", "l0.5395784,0.6010702", "l0.5408832,0.6011931", "l0.5416196,0.5978401", "l0.5404311,0.5973311", "l0.5392296,0.5947330", "l0.5387645,0.5948910", "l0.5375113,0.5936446", "l0.5364261,0.5941888", "l0.5354959,0.5938903", "l0.5350179,0.5923104", "l0.5367749,0.5905550", "l0.5374080,0.5907130", "l0.5372013,0.5892208", "l0.5381573,0.5878340", "l0.5389195,0.5876936", "l0.5386353,0.5868685", "l0.5392037,0.5859908", "l0.5379506,0.5826027", "l0.5378989,0.5809526", "l0.5388808,0.5786705", "l0.5449269,0.5784774", "l0.5465289,0.5801100", "l0.5476658,0.5804611", "l0.5477433,0.5818303", "l0.5490223,0.5827081", "l0.5495003,0.5842002", "l0.5506760,0.5836560", "l0.5510377,0.5827432", "l0.5549005,0.5834102", "l0.5555594,0.5817952", "l0.5564250,0.5820234", "l0.5566704,0.5829714", "l0.5593835,0.5821990", "l0.5602232,0.5810930", "l0.5584791,0.5786003", "l0.5568771,0.5744398", "l0.5579107,0.5742292", "l0.5581691,0.5728073", "l0.5590605,0.5728599", "l0.5603912,0.5740185", "l0.5618769,0.5738430", "l0.5619156,0.5744925", "l0.5654296,0.5726668", "l0.5662823,0.5730881", "l0.5664632,0.5738781", "l0.5681943,0.5727019", "l0.5686207,0.5732461", "l0.5705585,0.5733339", "l0.5721476,0.5726142", "l0.5724835,0.5717891", "l0.5727031,0.5661014", "l0.5711270,0.5635560", "l0.5711528,0.5587109", "l0.5707265,0.5570432", "l0.5720184,0.5553404", "l0.5731940,0.5553229", "l0.5737754,0.5533392", "l0.5741630,0.5501443", "l0.5731424,0.5467562", "l0.5738271,0.5459311", "l0.5741888,0.5438070", "l0.5709461,0.5408930", "l0.5695896,0.5419814", "l0.5682202,0.5386811", "l0.5674579,0.5389971", "l0.5660756,0.5382598", "l0.5661014,0.5365745", "l0.5650162,0.5385582", "l0.5640344,0.5374172", "l0.5632075,0.5375400", "l0.5624711,0.5364341", "l0.5629233,0.5359777", "l0.5627812,0.5352579", "l0.5617477,0.5359250", "l0.5609079,0.5330636", "l0.5578202,0.5318699", "l0.5573422,0.5310799", "l0.5568771,0.5315188", "l0.5550555,0.5312028", "l0.5541383,0.5290436", "l0.5512573,0.5287627", "l0.5507147,0.5241634", "l0.5507147,0.5241634", "l0.5506889,0.5228293", "l0.5511927,0.5235841", "l0.5516707,0.5217760", "l0.5507405,0.5201610", "l0.5511927,0.5199152", "l0.5506501,0.5190024", "l0.5504563,0.5162990", "l0.5508568,0.5130865", "l0.5521746,0.5110326", "l0.5511927,0.5094702", "l0.5524459,0.5083818", "l0.5524200,0.5072934", "l0.5539703,0.5070652", "l0.5543579,0.5051693", "l0.5564896,0.5047129", "c"]}, {"n": "Sichuan", "u": "CN-51", "i": ["m0.4609782,0.6198361", "l0.4614950,0.6193621", "l0.4613916,0.6179051", "l0.4619988,0.6180806", "l0.4631228,0.6199238", "l0.4630453,0.6214686", "l0.4636654,0.6225570", "l0.4627352,0.6242598", "l0.4625285,0.6260153", "l0.4609007,0.6275425", "l0.4619859,0.6290171", "l0.4617792,0.6310535", "l0.4625931,0.6314046", "l0.4643372,0.6290347", "l0.4657712,0.6291751", "l0.4663784,0.6272266", "l0.4679158,0.6284554", "l0.4682000,0.6261382", "l0.4675799,0.6254535", "l0.4689235,0.6232417", "l0.4704609,0.6239438", "l0.4721404,0.6223464", "l0.4721145,0.6218373", "l0.4724504,0.6220655", "l0.4719208,0.6190461", "l0.4701379,0.6179226", "l0.4697891,0.6165534", "l0.4702025,0.6148857", "l0.4694403,0.6154299", "l0.4698408,0.6141308", "l0.4685101,0.6133760", "l0.4688072,0.6117434", "l0.4676833,0.6091102", "l0.4685876,0.6089171", "l0.4690527,0.6080745", "l0.4709647,0.6085484", "l0.4716236,0.6054237", "l0.4753831,0.6056168", "l0.4745692,0.6035103", "l0.4759645,0.6024570", "l0.4765975,0.6007191", "l0.4775148,0.6001222", "l0.4784320,0.6005260", "l0.4792072,0.5993849", "l0.4801373,0.5999994", "l0.4806670,0.6025799", "l0.4827341,0.6030890", "l0.4830312,0.6046864", "l0.4837289,0.6053360", "l0.4829925,0.6062488", "l0.4834834,0.6076707", "l0.4828891,0.6088118", "l0.4839097,0.6104443", "l0.4834446,0.6128493", "l0.4866615,0.6146223", "l0.4880051,0.6144292", "l0.4885348,0.6130600", "l0.4892195,0.6128493", "l0.4896200,0.6136744", "l0.4888449,0.6149032", "l0.4891549,0.6162900", "l0.4897880,0.6165358", "l0.4905631,0.6154299", "l0.4934958,0.6168693", "l0.4980304,0.6161320", "l0.5000458,0.6181859", "l0.4998132,0.6200116", "l0.5008597,0.6236805", "l0.5016348,0.6239263", "l0.5020999,0.6254887", "l0.5033789,0.6251727", "l0.5042962,0.6258397", "l0.5038311,0.6267877", "l0.5022679,0.6263313", "l0.5034435,0.6313870", "l0.5027588,0.6331600", "l0.5042445,0.6338798", "l0.5035339,0.6344239", "l0.5032626,0.6357581", "l0.5019707,0.6358459", "l0.5017640,0.6372853", "l0.5022162,0.6387424", "l0.5030947,0.6390057", "l0.5047096,0.6408840", "l0.5065829,0.6413756", "l0.5076552,0.6431310", "l0.5086499,0.6428326", "l0.5093088,0.6437981", "l0.5108462,0.6431837", "l0.5117247,0.6448514", "l0.5142827,0.6435875", "l0.5154971,0.6449743", "l0.5168019,0.6443072", "l0.5172928,0.6430959", "l0.5182747,0.6434119", "l0.5210394,0.6411649", "l0.5197992,0.6376013", "l0.5207552,0.6361970", "l0.5217241,0.6366709", "l0.5217241,0.6366709", "l0.5226931,0.6412527", "l0.5233132,0.6422006", "l0.5258712,0.6403750", "l0.5265300,0.6408665", "l0.5270726,0.6390057", "l0.5292947,0.6383211", "l0.5300570,0.6387775", "l0.5306513,0.6377769", "l0.5314652,0.6391637", "l0.5309484,0.6403750", "l0.5317752,0.6414985", "l0.5343720,0.6430433", "l0.5355476,0.6430433", "l0.5367103,0.6443950", "l0.5373563,0.6433944", "l0.5398755,0.6431661", "l0.5420072,0.6413054", "l0.5426273,0.6413229", "l0.5426661,0.6424991", "l0.5438934,0.6416213", "l0.5449528,0.6421831", "l0.5465289,0.6415687", "l0.5472395,0.6419198", "l0.5472136,0.6427273", "l0.5478337,0.6434646", "l0.5476012,0.6466068", "l0.5499783,0.6495736", "l0.5506372,0.6498193", "l0.5511410,0.6478532", "l0.5523813,0.6463611", "l0.5532210,0.6465191", "l0.5536344,0.6495209", "l0.5542029,0.6493454", "l0.5547842,0.6504513", "l0.5559857,0.6496965", "l0.5569676,0.6499773", "l0.5578332,0.6519434", "l0.5586212,0.6519610", "l0.5601069,0.6550506", "l0.5609984,0.6551384", "l0.5621740,0.6566130", "l0.5628458,0.6558581", "l0.5629621,0.6546995", "l0.5637889,0.6542255", "l0.5647320,0.6546995", "l0.5651325,0.6541378", "l0.5656234,0.6545415", "l0.5664373,0.6532249", "l0.5678843,0.6542080", "l0.5682718,0.6536111", "l0.5703906,0.6534005", "l0.5710107,0.6549628", "l0.5710107,0.6549628", "l0.5704810,0.6555421", "l0.5692279,0.6551384", "l0.5687111,0.6555773", "l0.5686594,0.6564901", "l0.5693183,0.6568236", "l0.5698609,0.6586493", "l0.5681943,0.6584562", "l0.5683881,0.6591760", "l0.5679747,0.6598606", "l0.5685173,0.6607559", "l0.5674579,0.6605452", "l0.5668766,0.6612474", "l0.5682977,0.6640210", "l0.5700547,0.6653376", "l0.5699513,0.6660047", "l0.5706748,0.6659169", "l0.5712174,0.6666542", "l0.5708944,0.6673915", "l0.5713337,0.6688837", "l0.5703647,0.6696561", "l0.5704035,0.6702354", "l0.5696025,0.6699720", "l0.5679230,0.6731494", "l0.5657526,0.6735356", "l0.5662565,0.6743431", "l0.5660110,0.6757826", "l0.5651067,0.6766428", "l0.5655330,0.6777487", "l0.5630008,0.6799079", "l0.5629879,0.6806452", "l0.5639956,0.6809086", "l0.5627554,0.6834891", "l0.5634788,0.6849988", "l0.5616572,0.6868245", "l0.5615280,0.6882815", "l0.5622515,0.6887555", "l0.5604816,0.6913009", "l0.5587246,0.6911253", "l0.5579753,0.6892997", "l0.5566575,0.6911605", "l0.5557532,0.6901598", "l0.5545775,0.6904583", "l0.5531435,0.6929510", "l0.5545517,0.6956369", "l0.5524976,0.6993058", "l0.5521100,0.7015001", "l0.5508051,0.7035716", "l0.5500042,0.7061872", "l0.5474074,0.7104705", "l0.5465547,0.7110323", "l0.5458054,0.7098386", "l0.5450044,0.7111025", "l0.5421364,0.7112254", "l0.5399789,0.7062925", "l0.5403794,0.7050988", "l0.5391133,0.7041684", "l0.5372013,0.7044317", "l0.5369170,0.7056079", "l0.5348500,0.7059590", "l0.5346820,0.7067841", "l0.5338164,0.7072229", "l0.5322403,0.7038349", "l0.5281449,0.7015177", "l0.5273956,0.7019565", "l0.5270985,0.7009033", "l0.5256903,0.7027816", "l0.5252510,0.7042211", "l0.5254836,0.7054324", "l0.5237266,0.7049408", "l0.5242950,0.7066436", "l0.5223701,0.7075565", "l0.5248635,0.7109094", "l0.5257161,0.7112780", "l0.5252123,0.7138410", "l0.5254707,0.7156491", "l0.5235457,0.7161933", "l0.5228222,0.7187739", "l0.5220988,0.7195112", "l0.5214399,0.7191249", "l0.5212978,0.7202133", "l0.5203676,0.7200729", "l0.5191532,0.7223726", "l0.5187140,0.7220215", "l0.5183393,0.7236716", "l0.5188561,0.7260766", "l0.5198767,0.7259537", "l0.5198121,0.7266032", "l0.5206777,0.7270772", "l0.5204064,0.7286220", "l0.5205485,0.7292891", "l0.5211428,0.7292364", "l0.5210394,0.7299913", "l0.5239850,0.7304126", "l0.5242563,0.7309568", "l0.5249281,0.7300439", "l0.5256774,0.7339937", "l0.5253415,0.7347310", "l0.5260133,0.7355561", "l0.5257807,0.7361705", "l0.5266980,0.7388388", "l0.5279899,0.7391021", "l0.5283258,0.7398043", "l0.5296823,0.7377855", "l0.5306642,0.7385755", "l0.5307029,0.7396463", "l0.5334547,0.7399623", "l0.5341394,0.7411735", "l0.5340361,0.7425779", "l0.5349017,0.7462819", "l0.5354184,0.7464750", "l0.5353409,0.7484938", "l0.5360644,0.7491784", "l0.5360644,0.7491784", "l0.5360515,0.7503897", "l0.5351471,0.7500737", "l0.5346174,0.7489327", "l0.5329638,0.7478092", "l0.5325762,0.7464399", "l0.5317235,0.7466155", "l0.5294627,0.7435259", "l0.5281191,0.7459133", "l0.5281708,0.7473703", "l0.5260908,0.7475459", "l0.5256515,0.7470543", "l0.5249022,0.7475459", "l0.5237266,0.7502493", "l0.5240366,0.7545326", "l0.5254578,0.7556561", "l0.5262846,0.7540586", "l0.5269435,0.7547257", "l0.5280674,0.7562530", "l0.5276928,0.7582542", "l0.5280028,0.7592723", "l0.5291397,0.7588686", "l0.5303929,0.7597288", "l0.5305867,0.7588686", "l0.5323437,0.7582717", "l0.5339456,0.7600447", "l0.5341136,0.7620109", "l0.5351471,0.7630641", "l0.5348758,0.7646967", "l0.5353926,0.7654867", "l0.5353797,0.7668208", "l0.5330801,0.7685061", "l0.5311680,0.7678741", "l0.5302766,0.7686816", "l0.5279124,0.7688747", "l0.5274215,0.7696120", "l0.5254965,0.7696822", "l0.5251864,0.7704020", "l0.5239462,0.7709286", "l0.5233519,0.7694716", "l0.5215174,0.7680321", "l0.5201092,0.7682954", "l0.5185460,0.7697173", "l0.5185460,0.7697173", "l0.5182101,0.7677863", "l0.5186881,0.7670315", "l0.5177450,0.7667331", "l0.5174479,0.7652585", "l0.5181972,0.7641701", "l0.5179646,0.7624673", "l0.5168019,0.7626428", "l0.5166081,0.7608347", "l0.5143731,0.7599921", "l0.5132104,0.7608874", "l0.5116084,0.7646616", "l0.5091667,0.7649600", "l0.5067637,0.7662942", "l0.5055235,0.7653111", "l0.5022808,0.7612560", "l0.5035985,0.7609225", "l0.5036760,0.7599570", "l0.5044770,0.7594303", "l0.5047483,0.7579382", "l0.5040636,0.7581137", "l0.5037923,0.7575169", "l0.5047613,0.7561827", "l0.5045546,0.7556034", "l0.5037665,0.7556210", "l0.5033660,0.7540411", "l0.5021387,0.7543571", "l0.5014540,0.7525314", "l0.5013248,0.7491433", "l0.5030688,0.7483885", "l0.5041411,0.7466330", "l0.5031980,0.7462117", "l0.5022808,0.7468261", "l0.5012989,0.7456675", "l0.5010922,0.7462644", "l0.4994256,0.7464048", "l0.4988830,0.7471772", "l0.4980433,0.7466681", "l0.4964930,0.7472825", "l0.4953303,0.7467910", "l0.4950848,0.7455446", "l0.4947489,0.7456851", "l0.4945939,0.7476336", "l0.4937671,0.7493364", "l0.4948910,0.7525489", "l0.4950977,0.7547959", "l0.4925527,0.7573062", "l0.4913124,0.7558668", "l0.4883023,0.7592548", "l0.4881860,0.7617475", "l0.4889482,0.7616773", "l0.4892324,0.7631870", "l0.4901368,0.7630115", "l0.4892195,0.7644685", "l0.4890128,0.7670666", "l0.4854730,0.7716308", "l0.4856797,0.7731580", "l0.4846332,0.7731054", "l0.4832250,0.7767918", "l0.4818298,0.7770727", "l0.4807575,0.7780733", "l0.4800211,0.7769498", "l0.4790651,0.7798288", "l0.4794785,0.7842526", "l0.4788325,0.7865522", "l0.4792718,0.7894312", "l0.4806541,0.7923101", "l0.4813517,0.7956631", "l0.4812613,0.7974536", "l0.4819073,0.7987527", "l0.4813517,0.7999815", "l0.4808479,0.8000342", "l0.4806929,0.8033169", "l0.4792459,0.8035451", "l0.4789229,0.8029833", "l0.4784320,0.8039839", "l0.4767913,0.8051425", "l0.4762874,0.8065645", "l0.4755510,0.8068102", "l0.4744400,0.8057745", "l0.4748922,0.8036504", "l0.4736778,0.8029658", "l0.4733031,0.8036855", "l0.4709131,0.8047037", "l0.4699958,0.8061256", "l0.4687685,0.8065294", "l0.4662234,0.8102334", "l0.4648927,0.8095312", "l0.4639109,0.8098296", "l0.4634200,0.8092152", "l0.4619859,0.8108302", "l0.4613787,0.8080039", "l0.4604098,0.8066347", "l0.4595830,0.8059852", "l0.4584202,0.8067927", "l0.4579551,0.8050021", "l0.4583556,0.8042297", "l0.4590533,0.8043526", "l0.4587045,0.8021583", "l0.4547900,0.7982436", "l0.4547900,0.7972430", "l0.4559268,0.7969972", "l0.4562627,0.7953295", "l0.4557589,0.7945571", "l0.4567407,0.7931001", "l0.4557201,0.7926437", "l0.4558622,0.7938549", "l0.4547512,0.7941358", "l0.4542473,0.7928894", "l0.4548804,0.7912568", "l0.4543249,0.7901334", "l0.4527487,0.7896594", "l0.4526970,0.7884832", "l0.4506817,0.7866575", "l0.4510563,0.7822338", "l0.4494414,0.7824620", "l0.4491055,0.7818125", "l0.4492735,0.7801448", "l0.4485112,0.7794777", "l0.4486921,0.7788984", "l0.4473098,0.7755806", "l0.4467542,0.7760019", "l0.4464054,0.7755455", "l0.4463667,0.7721574", "l0.4455528,0.7719292", "l0.4457595,0.7704371", "l0.4448680,0.7702966", "l0.4445838,0.7686290", "l0.4436278,0.7673124", "l0.4437828,0.7658904", "l0.4432661,0.7645738", "l0.4424392,0.7645212", "l0.4409665,0.7670841", "l0.4390544,0.7656798", "l0.4381888,0.7684710", "l0.4373362,0.7694014", "l0.4367290,0.7670315", "l0.4370390,0.7658202", "l0.4348299,0.7648020", "l0.4350624,0.7635732", "l0.4333312,0.7614140", "l0.4324010,0.7586755", "l0.4325948,0.7578329", "l0.4348299,0.7568674", "l0.4351916,0.7559721", "l0.4344681,0.7551295", "l0.4349074,0.7543044", "l0.4329824,0.7530405", "l0.4332150,0.7515132", "l0.4318843,0.7504599", "l0.4310833,0.7477565", "l0.4301790,0.7472123", "l0.4292875,0.7479847", "l0.4292746,0.7457202", "l0.4277889,0.7444738", "l0.4274013,0.7412613", "l0.4258510,0.7420688", "l0.4255668,0.7440701", "l0.4244816,0.7452111", "l0.4241715,0.7477916", "l0.4218849,0.7490205", "l0.4220140,0.7528298", "l0.4224016,0.7535144", "l0.4221691,0.7546906", "l0.4225696,0.7555683", "l0.4220657,0.7567094", "l0.4221691,0.7584648", "l0.4207867,0.7569902", "l0.4203216,0.7549188", "l0.4197274,0.7546730", "l0.4185259,0.7520574", "l0.4186551,0.7476863", "l0.4174536,0.7421566", "l0.4178412,0.7387510", "l0.4175311,0.7310094", "l0.4175311,0.7310094", "l0.4167559,0.7286922", "l0.4165492,0.7231801", "l0.4155932,0.7203187", "l0.4160196,0.7159651", "l0.4168593,0.7137532", "l0.4163942,0.7098912", "l0.4154511,0.7079427", "l0.4152832,0.7020268", "l0.4141204,0.6943203", "l0.4150377,0.6933372", "l0.4150635,0.6924770", "l0.4121180,0.6890890", "l0.4124151,0.6861223", "l0.4114203,0.6851919", "l0.4103480,0.6823480", "l0.4091982,0.6814176", "l0.4097279,0.6776083", "l0.4106064,0.6776610", "l0.4121051,0.6798026", "l0.4137845,0.6765726", "l0.4095083,0.6710604", "l0.4085006,0.6694630", "l0.4082422,0.6677250", "l0.4061364,0.6648110", "l0.4058651,0.6629151", "l0.4063560,0.6622129", "l0.4064206,0.6601415", "l0.4044569,0.6574907", "l0.4030487,0.6544187", "l0.4025578,0.6510306", "l0.4006458,0.6499773", "l0.3988629,0.6480990", "l0.3949613,0.6466595", "l0.3949613,0.6466595", "l0.3900133,0.6420778", "l0.3888635,0.6366358", "l0.3893673,0.6352490", "l0.3914990,0.6344766", "l0.3912277,0.6336164", "l0.3919253,0.6331074", "l0.3910339,0.6313519", "l0.3909951,0.6298773", "l0.3928297,0.6275074", "l0.3932560,0.6252253", "l0.3940699,0.6251200", "l0.3956073,0.6232241", "l0.3921579,0.6219777", "l0.3914344,0.6205207", "l0.3915248,0.6189057", "l0.3903233,0.6187126", "l0.3896645,0.6178524", "l0.3900520,0.6161145", "l0.3890960,0.6122174", "l0.3895094,0.6117434", "l0.3893932,0.6106901", "l0.3928297,0.6096017", "l0.3933981,0.6099177", "l0.3939020,0.6074074", "l0.3957882,0.6084782", "l0.3957882,0.6096544", "l0.3951939,0.6106550", "l0.3956331,0.6114274", "l0.3964729,0.6115678", "l0.3980232,0.6105146", "l0.3984753,0.6095315", "l0.3997543,0.6091278", "l0.4036430,0.6101810", "l0.4036301,0.6119716", "l0.4060847,0.6112519", "l0.4069761,0.6117961", "l0.4101930,0.6170800", "l0.4095083,0.6178524", "l0.4100638,0.6185897", "l0.4100380,0.6199414", "l0.4114720,0.6215740", "l0.4113687,0.6233119", "l0.4121567,0.6247162", "l0.4118208,0.6267877", "l0.4125960,0.6273494", "l0.4125185,0.6283676", "l0.4132807,0.6301231", "l0.4156320,0.6319312", "l0.4187713,0.6333005", "l0.4201149,0.6372502", "l0.4208126,0.6374082", "l0.4215748,0.6366358", "l0.4249596,0.6387599", "l0.4257218,0.6400941", "l0.4262903,0.6398132", "l0.4272334,0.6405681", "l0.4278018,0.6416740", "l0.4285770,0.6376189", "l0.4281894,0.6357230", "l0.4297655,0.6358634", "l0.4302823,0.6327738", "l0.4314321,0.6357581", "l0.4324527,0.6357581", "l0.4324527,0.6369694", "l0.4337963,0.6380226", "l0.4342227,0.6413580", "l0.4334475,0.6429204", "l0.4339513,0.6437806", "l0.4354887,0.6446407", "l0.4362768,0.6410420", "l0.4375558,0.6415687", "l0.4385635,0.6406909", "l0.4396616,0.6423235", "l0.4407210,0.6453078", "l0.4413411,0.6457467", "l0.4403076,0.6463786", "l0.4393386,0.6480814", "l0.4404368,0.6497842", "l0.4417804,0.6489592", "l0.4422713,0.6472213", "l0.4428914,0.6468175", "l0.4428139,0.6442370", "l0.4437182,0.6444827", "l0.4431240,0.6426922", "l0.4472064,0.6446934", "l0.4494156,0.6426746", "l0.4501907,0.6429028", "l0.4502553,0.6438683", "l0.4515214,0.6424464", "l0.4520898,0.6411474", "l0.4521803,0.6388302", "l0.4513793,0.6371976", "l0.4503070,0.6366183", "l0.4502424,0.6333005", "l0.4510305,0.6315450", "l0.4508884,0.6302635", "l0.4538339,0.6286485", "l0.4546737,0.6302811", "l0.4548158,0.6284027", "l0.4560560,0.6282798", "l0.4589112,0.6312992", "l0.4603323,0.6269808", "l0.4589628,0.6257871", "l0.4590662,0.6247865", "l0.4599576,0.6224693", "l0.4609911,0.6222586", "c"]}, {"n": "Shandong", "u": "CN-37", "i": ["m0.7237539,0.4914241", "l0.7264669,0.4935306", "l0.7266866,0.4948823", "l0.7278751,0.4945488", "l0.7336112,0.4954616", "l0.7344897,0.4967607", "l0.7349161,0.4967607", "l0.7358721,0.4947243", "l0.7379908,0.4951105", "l0.7396574,0.4945488", "l0.7413498,0.4958830", "l0.7421766,0.4997625", "l0.7436494,0.5010440", "l0.7435978,0.5031330", "l0.7452126,0.5043092", "l0.7449801,0.5050991", "l0.7465046,0.5037474", "l0.7466208,0.5045023", "l0.7455485,0.5051342", "l0.7472022,0.5084872", "l0.7468921,0.5088909", "l0.7454839,0.5075568", "l0.7442050,0.5075568", "l0.7440628,0.5069248", "l0.7430164,0.5072759", "l0.7417762,0.5090665", "l0.7410139,0.5117348", "l0.7410656,0.5169836", "l0.7416599,0.5186162", "l0.7441145,0.5208281", "l0.7444892,0.5228995", "l0.7445925,0.5219867", "l0.7450705,0.5221095", "l0.7453677,0.5231628", "l0.7463366,0.5229171", "l0.7461557,0.5248481", "l0.7471505,0.5249534", "l0.7491788,0.5239177", "l0.7492176,0.5232857", "l0.7499281,0.5237948", "l0.7508454,0.5230399", "l0.7511942,0.5232330", "l0.7510779,0.5249534", "l0.7515172,0.5250763", "l0.7517756,0.5234788", "l0.7544240,0.5230926", "l0.7550441,0.5215127", "l0.7567882,0.5195641", "l0.7569562,0.5181422", "l0.7558839,0.5161936", "l0.7599017,0.5141924", "l0.7633124,0.5103480", "l0.7637516,0.5082063", "l0.7621109,0.5073812", "l0.7644105,0.5072057", "l0.7657670,0.5058013", "l0.7680666,0.5053800", "l0.7706117,0.5033437", "l0.7718520,0.5039581", "l0.7728209,0.5033437", "l0.7739319,0.5038879", "l0.7737382,0.5048709", "l0.7749009,0.5056784", "l0.7749267,0.5065386", "l0.7770971,0.5066966", "l0.7768775,0.5079605", "l0.7773684,0.5086100", "l0.7770067,0.5095053", "l0.7777043,0.5103128", "l0.7803269,0.5102953", "l0.7808824,0.5096282", "l0.7804561,0.5089787", "l0.7818772,0.5098389", "l0.7809470,0.5099091", "l0.7808954,0.5105235", "l0.7822260,0.5120859", "l0.7822648,0.5131040", "l0.7842027,0.5145084", "l0.7857400,0.5145786", "l0.7858822,0.5138062", "l0.7869028,0.5139642", "l0.7874325,0.5149473", "l0.7872903,0.5139115", "l0.7901972,0.5134200", "l0.7904685,0.5139818", "l0.7899905,0.5140520", "l0.7901326,0.5148419", "l0.7909594,0.5149122", "l0.7905589,0.5130865", "l0.7923805,0.5116294", "l0.7923417,0.5110852", "l0.7927422,0.5115066", "l0.7935432,0.5111028", "l0.7937758,0.5120859", "l0.7931556,0.5124545", "l0.7939308,0.5146488", "l0.7951452,0.5137009", "l0.7965017,0.5151930", "l0.7990339,0.5145786", "l0.7987109,0.5158250", "l0.7993827,0.5162112", "l0.7997703,0.5159479", "l0.7993052,0.5152984", "l0.8004162,0.5154739", "l0.8014368,0.5147542", "l0.8026900,0.5155266", "l0.8002095,0.5168256", "l0.8007780,0.5173874", "l0.8006229,0.5178964", "l0.8000932,0.5172469", "l0.8004421,0.5181071", "l0.8000932,0.5188093", "l0.8013335,0.5211616", "l0.8002870,0.5214776", "l0.8005454,0.5224606", "l0.7991631,0.5222149", "l0.7985946,0.5244970", "l0.7977936,0.5256731", "l0.7978453,0.5264455", "l0.7988142,0.5255678", "l0.7998994,0.5258487", "l0.7996411,0.5279377", "l0.7999899,0.5287978", "l0.7995635,0.5294649", "l0.7990985,0.5294649", "l0.7993698,0.5283941", "l0.7981683,0.5285872", "l0.7980520,0.5302900", "l0.7973285,0.5302198", "l0.7970443,0.5309746", "l0.7939954,0.5309395", "l0.7944346,0.5292016", "l0.7937112,0.5288154", "l0.7934786,0.5279552", "l0.7927293,0.5278675", "l0.7917862,0.5292192", "l0.7913211,0.5274637", "l0.7905977,0.5276392", "l0.7872645,0.5297634", "l0.7870836,0.5307991", "l0.7851587,0.5317470", "l0.7853266,0.5338536", "l0.7845773,0.5336254", "l0.7846161,0.5328003", "l0.7839830,0.5326248", "l0.7832983,0.5333972", "l0.7826653,0.5328003", "l0.7846032,0.5309220", "l0.7828203,0.5318172", "l0.7829366,0.5309395", "l0.7824715,0.5313784", "l0.7822131,0.5332216", "l0.7815413,0.5330812", "l0.7807145,0.5343100", "l0.7775751,0.5354335", "l0.7750947,0.5380316", "l0.7746554,0.5374698", "l0.7736477,0.5378560", "l0.7731180,0.5362410", "l0.7724592,0.5362234", "l0.7716840,0.5373996", "l0.7727821,0.5375225", "l0.7730405,0.5386109", "l0.7741128,0.5386109", "l0.7743712,0.5392253", "l0.7738544,0.5405945", "l0.7741645,0.5409456", "l0.7733247,0.5416478", "l0.7729501,0.5437368", "l0.7723429,0.5435086", "l0.7725237,0.5425958", "l0.7717615,0.5411036", "l0.7705859,0.5413670", "l0.7696815,0.5431049", "l0.7696557,0.5439475", "l0.7703792,0.5448779", "l0.7692035,0.5446672", "l0.7689581,0.5461067", "l0.7695911,0.5464227", "l0.7696299,0.5492490", "l0.7701079,0.5503549", "l0.7684413,0.5505831", "l0.7680408,0.5512678", "l0.7673948,0.5508289", "l0.7653795,0.5524790", "l0.7639842,0.5528477", "l0.7631444,0.5523737", "l0.7644364,0.5493543", "l0.7643718,0.5484415", "l0.7637516,0.5475286", "l0.7630798,0.5479148", "l0.7635062,0.5488452", "l0.7612582,0.5484239", "l0.7602893,0.5497756", "l0.7601989,0.5512502", "l0.7613358,0.5523035", "l0.7612582,0.5531812", "l0.7622789,0.5523561", "l0.7620205,0.5534094", "l0.7612712,0.5539185", "l0.7614004,0.5546909", "l0.7622918,0.5539009", "l0.7622789,0.5549191", "l0.7632090,0.5535674", "l0.7633382,0.5548489", "l0.7624210,0.5552000", "l0.7613487,0.5569730", "l0.7618784,0.5553580", "l0.7593074,0.5573065", "l0.7587002,0.5615548", "l0.7571241,0.5604664", "l0.7569949,0.5611686", "l0.7576150,0.5617303", "l0.7568399,0.5627660", "l0.7570983,0.5638544", "l0.7564265,0.5645039", "l0.7556772,0.5643108", "l0.7561164,0.5632576", "l0.7555867,0.5629767", "l0.7546049,0.5653290", "l0.7541656,0.5632576", "l0.7540235,0.5641879", "l0.7531967,0.5650130", "l0.7524086,0.5649077", "l0.7526024,0.5657679", "l0.7513105,0.5703496", "l0.7487267,0.5740361", "l0.7481324,0.5784247", "l0.7469697,0.5784950", "l0.7469697,0.5784950", "l0.7463366,0.5777226", "l0.7452902,0.5778981", "l0.7444504,0.5783194", "l0.7439078,0.5795307", "l0.7411948,0.5798993", "l0.7407555,0.5793376", "l0.7398124,0.5801802", "l0.7398512,0.5823921", "l0.7387143,0.5851657", "l0.7382492,0.5851833", "l0.7384043,0.5865701", "l0.7377971,0.5866052", "l0.7375516,0.5874478", "l0.7384043,0.5883958", "l0.7370219,0.5895895", "l0.7355104,0.5886766", "l0.7343476,0.5887293", "l0.7333916,0.5897826", "l0.7334304,0.5909061", "l0.7327844,0.5916082", "l0.7329782,0.5938552", "l0.7323968,0.5962076", "l0.7291154,0.5975768", "l0.7285340,0.5974013", "l0.7287149,0.5958038", "l0.7280302,0.5949085", "l0.7286244,0.5931882", "l0.7271000,0.5929424", "l0.7276426,0.5914854", "l0.7273842,0.5904848", "l0.7250071,0.5897475", "l0.7242707,0.5898528", "l0.7241803,0.5905550", "l0.7226816,0.5904848", "l0.7225395,0.5939430", "l0.7206404,0.5933462", "l0.7201753,0.5944697", "l0.7186379,0.5954176", "l0.7170747,0.5947154", "l0.7160412,0.5924509", "l0.7153048,0.5919945", "l0.7138320,0.5935393", "l0.7136124,0.5955229", "l0.7128631,0.5956283", "l0.7118941,0.5937324", "l0.7115582,0.5907832", "l0.7105247,0.5903443", "l0.7108735,0.5889399", "l0.7103309,0.5872196", "l0.7092586,0.5859908", "l0.7090648,0.5845864", "l0.7059513,0.5825852", "l0.7057059,0.5832874", "l0.7033158,0.5827432", "l0.7004607,0.5837438", "l0.6999052,0.5848497", "l0.6997243,0.5876234", "l0.6991300,0.5879042", "l0.6995563,0.5889575", "l0.6992463,0.5907305", "l0.6992463,0.5907305", "l0.6992463,0.5907305", "l0.6992463,0.5907305", "l0.6983290,0.5917662", "l0.6977218,0.5915907", "l0.6970242,0.5930828", "l0.6962620,0.5923631", "l0.6962620,0.5923631", "l0.6953318,0.5928722", "l0.6947892,0.5916434", "l0.6937556,0.5919769", "l0.6932001,0.5911518", "l0.6927092,0.5920822", "l0.6903708,0.5927844", "l0.6882392,0.5917311", "l0.6878774,0.5928722", "l0.6855907,0.5923982", "l0.6840921,0.5898703", "l0.6838466,0.5865701", "l0.6816891,0.5846040", "l0.6808494,0.5849902", "l0.6809786,0.5834980", "l0.6800355,0.5831820", "l0.6803197,0.5820410", "l0.6793120,0.5817777", "l0.6786790,0.5807771", "l0.6755009,0.5817426", "l0.6746740,0.5805137", "l0.6739764,0.5811281", "l0.6736793,0.5804260", "l0.6743381,0.5784774", "l0.6743252,0.5763357", "l0.6757463,0.5754580", "l0.6769736,0.5729828", "l0.6772320,0.5709289", "l0.6796738,0.5689804", "l0.6803843,0.5697879", "l0.6811982,0.5684537", "l0.6825418,0.5678393", "l0.6821542,0.5653817", "l0.6828648,0.5657854", "l0.6849706,0.5613090", "l0.6875415,0.5610106", "l0.6884071,0.5596237", "l0.6886009,0.5581667", "l0.6890272,0.5585354", "l0.6895052,0.5575699", "l0.6911976,0.5575874", "l0.6909393,0.5565692", "l0.6918953,0.5547260", "l0.6937815,0.5548489", "l0.6948925,0.5517242", "l0.6947763,0.5508640", "l0.6941432,0.5510395", "l0.6931872,0.5524790", "l0.6900091,0.5536201", "l0.6857587,0.5566921", "l0.6851773,0.5567975", "l0.6847897,0.5561128", "l0.6848027,0.5571485", "l0.6827098,0.5597993", "l0.6822576,0.5588338", "l0.6828002,0.5563937", "l0.6825935,0.5548313", "l0.6840921,0.5535499", "l0.6846218,0.5492841", "l0.6846218,0.5492841", "l0.6844797,0.5468615", "l0.6836916,0.5450534", "l0.6826968,0.5454045", "l0.6828131,0.5445268", "l0.6823480,0.5429995", "l0.6816891,0.5426133", "l0.6814437,0.5403488", "l0.6823868,0.5370836", "l0.6841567,0.5347664", "l0.6847381,0.5329758", "l0.6880195,0.5315013", "l0.6883296,0.5297985", "l0.6897507,0.5274461", "l0.6895440,0.5266035", "l0.6909909,0.5244092", "l0.6916240,0.5209158", "l0.6925542,0.5200381", "l0.6928771,0.5171591", "l0.6958098,0.5158952", "l0.6971275,0.5164043", "l0.6977864,0.5153159", "l0.6969208,0.5145962", "l0.6969079,0.5132971", "l0.6976831,0.5135253", "l0.6980836,0.5125949", "l0.6976572,0.5121385", "l0.6978381,0.5112783", "l0.6985099,0.5104533", "l0.6991300,0.5108219", "l0.7003186,0.5133322", "l0.7006028,0.5121736", "l0.7031220,0.5089962", "l0.7042202,0.5063982", "l0.7053570,0.5054502", "l0.7061839,0.5032910", "l0.7165838,0.5027995", "l0.7189222,0.4966378", "l0.7209763,0.4963745", "l0.7220874,0.4941977", "l0.7225654,0.4941099", "l0.7228754,0.4922667", "l0.7236764,0.4912310", "l0.7236764,0.4912310", "l0.7237539,0.4914241", "c"]}, {"n": "Shanghai", "u": "CN-31", "i": ["m0.7984783,0.6925648", "l0.7987884,0.6936532", "l0.7997315,0.6934074", "l0.7997961,0.6940921", "l0.7980778,0.6941272", "l0.7984783,0.6925648", "c", "m0.7878846,0.6765024", "l0.7891636,0.6771343", "l0.7889311,0.6786791", "l0.7879751,0.6780296", "l0.7878846,0.6765024", "c", "m0.7832208,0.6735707", "l0.7873291,0.6763795", "l0.7876650,0.6780823", "l0.7829495,0.6738516", "l0.7832208,0.6735707", "c", "m0.7802365,0.6734654", "l0.7816318,0.6739745", "l0.7832596,0.6763444", "l0.7846032,0.6769061", "l0.7870061,0.6796446", "l0.7889182,0.6834364", "l0.7900292,0.6881235", "l0.7898096,0.6899843", "l0.7893703,0.6902827", "l0.7881301,0.6900018", "l0.7834792,0.6909322", "l0.7802236,0.6941623", "l0.7791513,0.6943554", "l0.7791513,0.6943554", "l0.7790092,0.6929335", "l0.7782728,0.6919504", "l0.7768904,0.6919680", "l0.7764641,0.6902476", "l0.7745779,0.6908620", "l0.7750171,0.6896508", "l0.7745262,0.6890012", "l0.7747458,0.6863680", "l0.7741386,0.6857361", "l0.7731180,0.6861047", "l0.7731180,0.6861047", "l0.7731310,0.6842088", "l0.7725237,0.6835944", "l0.7728209,0.6830151", "l0.7755985,0.6828045", "l0.7760119,0.6822427", "l0.7757923,0.6795569", "l0.7761153,0.6790302", "l0.7771876,0.6791180", "l0.7765416,0.6766779", "l0.7772651,0.6763093", "l0.7773038,0.6750102", "l0.7801461,0.6733425", "l0.7801461,0.6733425", "l0.7802365,0.6734654", "c", "m0.7796680,0.6638981", "l0.7857788,0.6696385", "l0.7894995,0.6711482", "l0.7906364,0.6723946", "l0.7905589,0.6737638", "l0.7896804,0.6747996", "l0.7883756,0.6750453", "l0.7810116,0.6703056", "l0.7774589,0.6659871", "l0.7796680,0.6638981", "c"]}, {"n": "Shanxi", "u": "CN-14", "i": ["m0.6626463,0.4203981", "l0.6638349,0.4228733", "l0.6637444,0.4236282", "l0.6650751,0.4246639", "l0.6648555,0.4276833", "l0.6655919,0.4310889", "l0.6668450,0.4316331", "l0.6677494,0.4310011", "l0.6691059,0.4321948", "l0.6678269,0.4342838", "l0.6646229,0.4349509", "l0.6642741,0.4361271", "l0.6625559,0.4367590", "l0.6617420,0.4364079", "l0.6617549,0.4396555", "l0.6610185,0.4400944", "l0.6603725,0.4380756", "l0.6599720,0.4405157", "l0.6590031,0.4414285", "l0.6608118,0.4419376", "l0.6614190,0.4440968", "l0.6636540,0.4448693", "l0.6640545,0.4455890", "l0.6668709,0.4455714", "l0.6676073,0.4477131", "l0.6671551,0.4485031", "l0.6671163,0.4517858", "l0.6675168,0.4528742", "l0.6685504,0.4530497", "l0.6694676,0.4547525", "l0.6681499,0.4587549", "l0.6681111,0.4603524", "l0.6672843,0.4619148", "l0.6672197,0.4635122", "l0.6679561,0.4643724", "l0.6675427,0.4653379", "l0.6666512,0.4656012", "l0.6661862,0.4679009", "l0.6650363,0.4669003", "l0.6636798,0.4689717", "l0.6622329,0.4689191", "l0.6611606,0.4664965", "l0.6603725,0.4676902", "l0.6596232,0.4677078", "l0.6593261,0.4685855", "l0.6586284,0.4685504", "l0.6566777,0.4712363", "l0.6568068,0.4736413", "l0.6580988,0.4752387", "l0.6578404,0.4772400", "l0.6572332,0.4771171", "l0.6565872,0.4788550", "l0.6557733,0.4786443", "l0.6557216,0.4801716", "l0.6541326,0.4804173", "l0.6540292,0.4819270", "l0.6533057,0.4829101", "l0.6536546,0.4855082", "l0.6527115,0.4878429", "l0.6532282,0.4889664", "l0.6530215,0.4910203", "l0.6536416,0.4921789", "l0.6546364,0.4921087", "l0.6561480,0.4930742", "l0.6560704,0.4937237", "l0.6577499,0.4941626", "l0.6574528,0.4953914", "l0.6584863,0.4968309", "l0.6584476,0.4984986", "l0.6597524,0.5010967", "l0.6600366,0.5036070", "l0.6611994,0.5049938", "l0.6603596,0.5068195", "l0.6615740,0.5064157", "l0.6627367,0.5076972", "l0.6623879,0.5100671", "l0.6610572,0.5127529", "l0.6606955,0.5146839", "l0.6600366,0.5152808", "l0.6598041,0.5167905", "l0.6588997,0.5177033", "l0.6586155,0.5198274", "l0.6577112,0.5218111", "l0.6566647,0.5224606", "l0.6565097,0.5243565", "l0.6570006,0.5247954", "l0.6567293,0.5259891", "l0.6571169,0.5265860", "l0.6565743,0.5276744", "l0.6570523,0.5299038", "l0.6563805,0.5305358", "l0.6560575,0.5296054", "l0.6555149,0.5297107", "l0.6552565,0.5322386", "l0.6528923,0.5338360", "l0.6521301,0.5336956", "l0.6517296,0.5345207", "l0.6524143,0.5345909", "l0.6519492,0.5363639", "l0.6530215,0.5368379", "l0.6529440,0.5376454", "l0.6537321,0.5385055", "l0.6531895,0.5403312", "l0.6538354,0.5413845", "l0.6556958,0.5423325", "l0.6560575,0.5440704", "l0.6560575,0.5440704", "l0.6553082,0.5478973", "l0.6556054,0.5482132", "l0.6551015,0.5484415", "l0.6555149,0.5489505", "l0.6548690,0.5493894", "l0.6556570,0.5501618", "l0.6548044,0.5505480", "l0.6553082,0.5521630", "l0.6549206,0.5529705", "l0.6555537,0.5533041", "l0.6553470,0.5542871", "l0.6545460,0.5542345", "l0.6548560,0.5583598", "l0.6535254,0.5588865", "l0.6543393,0.5638193", "l0.6531249,0.5635209", "l0.6522464,0.5666983", "l0.6506056,0.5672424", "l0.6498563,0.5682255", "l0.6490424,0.5681553", "l0.6490295,0.5695421", "l0.6475438,0.5691032", "l0.6460581,0.5720173", "l0.6446241,0.5712273", "l0.6440169,0.5715433", "l0.6441331,0.5728248", "l0.6431900,0.5732461", "l0.6429575,0.5742994", "l0.6411359,0.5741063", "l0.6401670,0.5755458", "l0.6388750,0.5750016", "l0.6384746,0.5738254", "l0.6379190,0.5750543", "l0.6352060,0.5749314", "l0.6343275,0.5743521", "l0.6332681,0.5751947", "l0.6324801,0.5750543", "l0.6325059,0.5741765", "l0.6313561,0.5747909", "l0.6312269,0.5741063", "l0.6288369,0.5734392", "l0.6288239,0.5793025", "l0.6283589,0.5801451", "l0.6280488,0.5792498", "l0.6270928,0.5788460", "l0.6250128,0.5790918", "l0.6246123,0.5801978", "l0.6224806,0.5812861", "l0.6225065,0.5824623", "l0.6208399,0.5851130", "l0.6178039,0.5860434", "l0.6170288,0.5856221", "l0.6151942,0.5866403", "l0.6140444,0.5862014", "l0.6131142,0.5876760", "l0.6109438,0.5889926", "l0.6103366,0.5882202", "l0.6098845,0.5901337", "l0.6075461,0.5902917", "l0.6064092,0.5919593", "l0.6014741,0.5916785", "l0.6014741,0.5916785", "l0.6000401,0.5913274", "l0.5992262,0.5892735", "l0.5998334,0.5868685", "l0.5996783,0.5818830", "l0.6011382,0.5782141", "l0.6018229,0.5735446", "l0.6036962,0.5700863", "l0.6042000,0.5665929", "l0.6051948,0.5639773", "l0.6025205,0.5494070", "l0.6034249,0.5379965", "l0.6016033,0.5352931", "l0.6017454,0.5347840", "l0.6023397,0.5351526", "l0.6026110,0.5338887", "l0.6021071,0.5340642", "l0.6022363,0.5329934", "l0.6014612,0.5327827", "l0.6021330,0.5319401", "l0.6021200,0.5303251", "l0.6014095,0.5299213", "l0.6019263,0.5293947", "l0.6022105,0.5274286", "l0.6012932,0.5260067", "l0.6025851,0.5262349", "l0.6019779,0.5254976", "l0.6038383,0.5236017", "l0.6059829,0.5187566", "l0.6064609,0.5186864", "l0.6062413,0.5177736", "l0.6067063,0.5169309", "l0.6055695,0.5162287", "l0.6056728,0.5145259", "l0.6074040,0.5137184", "l0.6080887,0.5111379", "l0.6076107,0.5087329", "l0.6082179,0.5083116", "l0.6066676,0.5067141", "l0.6074557,0.5054502", "l0.6061379,0.5043618", "l0.6049364,0.5009738", "l0.6036445,0.4996923", "l0.6034636,0.4935482", "l0.6037091,0.4927056", "l0.6044067,0.4924247", "l0.6047168,0.4901075", "l0.6059700,0.4900548", "l0.6073006,0.4883696", "l0.6080241,0.4859822", "l0.6090705,0.4862279", "l0.6095227,0.4855959", "l0.6095098,0.4840687", "l0.6100007,0.4839283", "l0.6102333,0.4822430", "l0.6096777,0.4802769", "l0.6118094,0.4738168", "l0.6111764,0.4710607", "l0.6116156,0.4701479", "l0.6135535,0.4688840", "l0.6143416,0.4668476", "l0.6149358,0.4625116", "l0.6156206,0.4618270", "l0.6145870,0.4614584", "l0.6145483,0.4602998", "l0.6140315,0.4606333", "l0.6137731,0.4598960", "l0.6137731,0.4598960", "l0.6135406,0.4591938", "l0.6141995,0.4584390", "l0.6172742,0.4581405", "l0.6175326,0.4566484", "l0.6185791,0.4556478", "l0.6184499,0.4527513", "l0.6190054,0.4528742", "l0.6187212,0.4519613", "l0.6197159,0.4515576", "l0.6222223,0.4522071", "l0.6240051,0.4535237", "l0.6267698,0.4528390", "l0.6274933,0.4473620", "l0.6328547,0.4344769", "l0.6353481,0.4331252", "l0.6400636,0.4369170", "l0.6416656,0.4357935", "l0.6423761,0.4323353", "l0.6439652,0.4314400", "l0.6482285,0.4298074", "l0.6493008,0.4324757", "l0.6532670,0.4316857", "l0.6552307,0.4289297", "l0.6566777,0.4279642", "l0.6571040,0.4267704", "l0.6582279,0.4285610", "l0.6598170,0.4267353", "l0.6614577,0.4264720", "l0.6617936,0.4254012", "l0.6611348,0.4241373", "l0.6615482,0.4210301", "c"]}, {"n": "Tianjin", "u": "CN-12", "i": ["m0.7157311,0.4351791", "l0.7168034,0.4346700", "l0.7183796,0.4351440", "l0.7190772,0.4370574", "l0.7200203,0.4379352", "l0.7199944,0.4389007", "l0.7216739,0.4396029", "l0.7215964,0.4411828", "l0.7225008,0.4414812", "l0.7226300,0.4423414", "l0.7220486,0.4429031", "l0.7211443,0.4421307", "l0.7200590,0.4425872", "l0.7191418,0.4418850", "l0.7184054,0.4422536", "l0.7179145,0.4450448", "l0.7187542,0.4474147", "l0.7184958,0.4482924", "l0.7204208,0.4513469", "l0.7196844,0.4534183", "l0.7208600,0.4538045", "l0.7211572,0.4549632", "l0.7220228,0.4533130", "l0.7238314,0.4532955", "l0.7247616,0.4539274", "l0.7237281,0.4575788", "l0.7237539,0.4591236", "l0.7249037,0.4588252", "l0.7260277,0.4600540", "l0.7269579,0.4640740", "l0.7269579,0.4640740", "l0.7244903,0.4644602", "l0.7231338,0.4653555", "l0.7214802,0.4677254", "l0.7224233,0.4710256", "l0.7212347,0.4712714", "l0.7198523,0.4742381", "l0.7188705,0.4773628", "l0.7187542,0.4801365", "l0.7187542,0.4801365", "l0.7184700,0.4814531", "l0.7168809,0.4812249", "l0.7137157,0.4825766", "l0.7133023,0.4822781", "l0.7136382,0.4814531", "l0.7132377,0.4809264", "l0.7112094,0.4820850", "l0.7098529,0.4788199", "l0.7081734,0.4791359", "l0.7068686,0.4777315", "l0.7054733,0.4777490", "l0.7047498,0.4722720", "l0.7055508,0.4695861", "l0.7079280,0.4685504", "l0.7084060,0.4664790", "l0.7081993,0.4658295", "l0.7073208,0.4656890", "l0.7071528,0.4646533", "l0.7076696,0.4636878", "l0.7072432,0.4622132", "l0.7077083,0.4609142", "l0.7072432,0.4601067", "l0.7066877,0.4606333", "l0.7071916,0.4581932", "l0.7062226,0.4573155", "l0.7065844,0.4553142", "l0.7061580,0.4546647", "l0.7062614,0.4529619", "l0.7062614,0.4529619", "l0.7070495,0.4514522", "l0.7078892,0.4510134", "l0.7078117,0.4504867", "l0.7078117,0.4504867", "l0.7086902,0.4500830", "l0.7091036,0.4520315", "l0.7100079,0.4516980", "l0.7120233,0.4524704", "l0.7121654,0.4493983", "l0.7126951,0.4483275", "l0.7120492,0.4468880", "l0.7137157,0.4461683", "l0.7120492,0.4452730", "l0.7116874,0.4439915", "l0.7124755,0.4423589", "l0.7124238,0.4403226", "l0.7129793,0.4397082", "l0.7127080,0.4393571", "l0.7127080,0.4393571", "l0.7157311,0.4368117", "c"]}, {"n": "Taiwan", "u": "CN-71", "i": ["m0.7841252,0.9065380", "l0.7844740,0.9085743", "l0.7836213,0.9080477", "l0.7829883,0.9066784", "l0.7841252,0.9065380", "c", "m0.7528220,0.8700771", "l0.7535455,0.8714463", "l0.7527316,0.8712532", "l0.7515172,0.8725523", "l0.7510004,0.8718325", "l0.7513363,0.8706915", "l0.7528220,0.8700771", "c", "m0.7517110,0.8684445", "l0.7521502,0.8694451", "l0.7517756,0.8697962", "l0.7515172,0.8688307", "l0.7506516,0.8696382", "l0.7506258,0.8711830", "l0.7498248,0.8712883", "l0.7505741,0.8690062", "l0.7517110,0.8684445", "c", "m0.7328361,0.8479582", "l0.7334562,0.8491168", "l0.7333916,0.8503983", "l0.7321385,0.8501526", "l0.7312600,0.8512936", "l0.7306786,0.8511005", "l0.7303685,0.8506441", "l0.7307561,0.8503808", "l0.7306269,0.8490642", "l0.7320480,0.8494679", "l0.7322547,0.8483093", "l0.7328361,0.8479582", "c", "m0.7624080,0.8906686", "l0.7611678,0.8854549", "l0.7590232,0.8828919", "l0.7598888,0.8816104", "l0.7596433,0.8803114", "l0.7603281,0.8785910", "l0.7601214,0.8776431", "l0.7606640,0.8755014", "l0.7611420,0.8753785", "l0.7610386,0.8729209", "l0.7604443,0.8726751", "l0.7609740,0.8719905", "l0.7608319,0.8693222", "l0.7614262,0.8678827", "l0.7614391,0.8653724", "l0.7629765,0.8647580", "l0.7626148,0.8640207", "l0.7631832,0.8636872", "l0.7638938,0.8609311", "l0.7653795,0.8586314", "l0.7647077,0.8583330", "l0.7664001,0.8559280", "l0.7664647,0.8544535", "l0.7670719,0.8532246", "l0.7674207,0.8534002", "l0.7702112,0.8461852", "l0.7732601,0.8425514", "l0.7735056,0.8401464", "l0.7756502,0.8355120", "l0.7783115,0.8337566", "l0.7811925,0.8328437", "l0.7822002,0.8303510", "l0.7846032,0.8293152", "l0.7866702,0.8324049", "l0.7898871,0.8336512", "l0.7901713,0.8358280", "l0.7912565,0.8361791", "l0.7899775,0.8371622", "l0.7883368,0.8402869", "l0.7881818,0.8421477", "l0.7885564,0.8447458", "l0.7892928,0.8460623", "l0.7891507,0.8477651", "l0.7885952,0.8480811", "l0.7886856,0.8490993", "l0.7878846,0.8502403", "l0.7874454,0.8532597", "l0.7857917,0.8557349", "l0.7856496,0.8574728", "l0.7849132,0.8586490", "l0.7854042,0.8605449", "l0.7847582,0.8616333", "l0.7830658,0.8722714", "l0.7832854,0.8732018", "l0.7813217,0.8798550", "l0.7814251,0.8820317", "l0.7806887,0.8826637", "l0.7788929,0.8875966", "l0.7779369,0.8884041", "l0.7781177,0.8896680", "l0.7776785,0.8905984", "l0.7753660,0.8927752", "l0.7731180,0.9007450", "l0.7732214,0.9078195", "l0.7722912,0.9089079", "l0.7726529,0.9110495", "l0.7710122,0.9096100", "l0.7705988,0.9105755", "l0.7701466,0.9102245", "l0.7697203,0.9079775", "l0.7702112,0.9061342", "l0.7690097,0.9014120", "l0.7681183,0.8998321", "l0.7643588,0.8965670", "l0.7625889,0.8931263", "l0.7624080,0.8906686", "c"]}, {"n": "Xinjiang Uygur", "u": "CN-65", "i": ["m0.2333814,0.1560432", "l0.2339369,0.1579567", "l0.2333814,0.1603265", "l0.2347250,0.1624155", "l0.2340790,0.1634688", "l0.2323091,0.1640832", "l0.2320378,0.1658387", "l0.2332135,0.1669973", "l0.2329163,0.1682437", "l0.2348929,0.1699465", "l0.2361203,0.1699465", "l0.2375026,0.1717897", "l0.2363528,0.1735452", "l0.2356164,0.1771088", "l0.2357714,0.1784078", "l0.2361203,0.1763539", "l0.2416238,0.1794435", "l0.2428511,0.1823225", "l0.2445565,0.1816027", "l0.2446082,0.1825682", "l0.2460422,0.1842535", "l0.2455125,0.1860089", "l0.2457192,0.1876942", "l0.2486260,0.1908014", "l0.2496983,0.1915035", "l0.2507964,0.1913631", "l0.2522175,0.1926797", "l0.2530702,0.1943474", "l0.2528118,0.1965593", "l0.2531219,0.1970684", "l0.2558220,0.1969104", "l0.2571914,0.1946458", "l0.2584187,0.1945054", "l0.2584704,0.1938910", "l0.2616873,0.1937154", "l0.2622428,0.1944878", "l0.2618811,0.1953304", "l0.2625270,0.1971210", "l0.2642840,0.1988940", "l0.2654468,0.2013341", "l0.2670100,0.2009304", "l0.2678626,0.2013692", "l0.2681856,0.1991398", "l0.2698909,0.1998771", "l0.2700718,0.2030369", "l0.2711183,0.2044764", "l0.2742835,0.2066181", "l0.2741414,0.2079873", "l0.2762343,0.2122004", "l0.2762472,0.2143596", "l0.2767898,0.2156762", "l0.2765572,0.2178003", "l0.2772290,0.2201176", "l0.2807560,0.2280171", "l0.2828101,0.2285964", "l0.2836886,0.2295795", "l0.2845154,0.2322653", "l0.2844379,0.2340208", "l0.2861174,0.2377073", "l0.2855490,0.2412182", "l0.2863629,0.2421486", "l0.2847480,0.2483980", "l0.2836499,0.2504519", "l0.2842571,0.2525234", "l0.2840633,0.2538049", "l0.2854456,0.2565785", "l0.2854585,0.2594574", "l0.2828747,0.2633897", "l0.2802650,0.2694109", "l0.2796062,0.2755024", "l0.2817637,0.2798383", "l0.2820479,0.2827524", "l0.2827843,0.2825769", "l0.2833915,0.2835073", "l0.2831202,0.2857191", "l0.2872543,0.2854032", "l0.2890371,0.2874395", "l0.2912076,0.2884577", "l0.2926157,0.2872113", "l0.2936880,0.2890896", "l0.2947732,0.2898094", "l0.3016850,0.2895636", "l0.3042301,0.2907749", "l0.3075503,0.2902131", "l0.3098241,0.2914244", "l0.3188804,0.2911611", "l0.3260376,0.2928112", "l0.3294612,0.2951284", "l0.3301588,0.2965152", "l0.3372902,0.3022556", "l0.3391376,0.3046079", "l0.3393831,0.3064511", "l0.3411143,0.3070304", "l0.3434785,0.3088912", "l0.3454293,0.3119984", "l0.3492663,0.3138241", "l0.3502352,0.3148774", "l0.3573149,0.3138065", "l0.3573795,0.3146843", "l0.3564493,0.3162642", "l0.3560230,0.3213374", "l0.3565139,0.3220747", "l0.3593820,0.3230754", "l0.3612036,0.3293424", "l0.3616557,0.3325373", "l0.3647822,0.3409986", "l0.3649889,0.3451415", "l0.3679215,0.3494073", "l0.3692393,0.3528831", "l0.3720169,0.3567451", "l0.3726758,0.3617306", "l0.3726758,0.3617306", "l0.3682962,0.3652591", "l0.3671335,0.3798645", "l0.3676115,0.3828839", "l0.3665521,0.3863071", "l0.3644334,0.3879045", "l0.3616041,0.3884487", "l0.3592011,0.3875008", "l0.3517209,0.3897302", "l0.3451709,0.3943822", "l0.3408817,0.4011758", "l0.3341121,0.4100585", "l0.3309211,0.4162903", "l0.3281822,0.4239617", "l0.3235184,0.4280695", "l0.3163353,0.4273146", "l0.3164128,0.4387427", "l0.3138936,0.4452028", "l0.3157023,0.4547174", "l0.3168263,0.4573681", "l0.3169167,0.4610195", "l0.3165420,0.4620201", "l0.3169425,0.4654959", "l0.3169425,0.4654959", "l0.3155085,0.4663561", "l0.3095786,0.4672514", "l0.3088551,0.4690595", "l0.3080283,0.4691999", "l0.3077182,0.4702357", "l0.3023568,0.4715347", "l0.2991916,0.4736939", "l0.2963752,0.4740275", "l0.2922153,0.4756074", "l0.2899286,0.4773804", "l0.2869701,0.4785039", "l0.2812727,0.4799083", "l0.2788956,0.4796274", "l0.2791798,0.4805753", "l0.2786372,0.4816988", "l0.2762084,0.4829452", "l0.2763764,0.4837703", "l0.2756271,0.4846480", "l0.2712216,0.4864210", "l0.2712345,0.4877376", "l0.2727461,0.4901777", "l0.2743481,0.4952861", "l0.2766347,0.4998503", "l0.2753687,0.5017989", "l0.2760534,0.5039932", "l0.2756917,0.5047656", "l0.2767639,0.5049938", "l0.2772549,0.5061173", "l0.2795674,0.5068721", "l0.2817895,0.5088031", "l0.2830427,0.5103480", "l0.2827972,0.5115241", "l0.2840762,0.5131216", "l0.2851356,0.5126827", "l0.2864921,0.5134025", "l0.2872026,0.5169836", "l0.2880553,0.5187742", "l0.2881199,0.5205472", "l0.2896185,0.5222149", "l0.2901482,0.5256205", "l0.2879003,0.5256731", "l0.2868538,0.5272004", "l0.2858978,0.5272530", "l0.2852777,0.5284994", "l0.2826034,0.5286750", "l0.2806268,0.5312379", "l0.2804330,0.5321683", "l0.2809756,0.5339414", "l0.2802780,0.5351175", "l0.2806914,0.5377156", "l0.2855490,0.5392077", "l0.2854844,0.5416127", "l0.2859365,0.5421394", "l0.2854585,0.5448603", "l0.2862724,0.5457029", "l0.2857557,0.5468089", "l0.2866213,0.5480377", "l0.2867117,0.5513380", "l0.2846705,0.5510044", "l0.2839599,0.5528301", "l0.2825388,0.5533392", "l0.2814278,0.5514960", "l0.2798904,0.5503374", "l0.2772549,0.5497229", "l0.2760275,0.5502847", "l0.2725781,0.5494070", "l0.2708599,0.5481430", "l0.2709762,0.5472126", "l0.2689091,0.5462822", "l0.2688316,0.5488979", "l0.2677722,0.5504778", "l0.2679660,0.5517944", "l0.2643874,0.5516013", "l0.2643874,0.5516013", "l0.2604083,0.5497756", "l0.2562742,0.5458434", "l0.2554086,0.5470371", "l0.2545430,0.5469844", "l0.2530444,0.5452816", "l0.2518300,0.5451763", "l0.2511969,0.5439299", "l0.2497758,0.5442284", "l0.2486260,0.5456678", "l0.2473470,0.5438246", "l0.2462618,0.5432453", "l0.2456934,0.5414723", "l0.2442206,0.5417005", "l0.2437555,0.5406999", "l0.2422569,0.5406823", "l0.2414171,0.5413670", "l0.2401510,0.5410334", "l0.2382778,0.5422271", "l0.2357973,0.5419287", "l0.2343245,0.5437719", "l0.2317019,0.5433682", "l0.2290664,0.5445443", "l0.2274515,0.5440001", "l0.2272319,0.5425431", "l0.2259400,0.5425080", "l0.2247514,0.5439475", "l0.2229169,0.5443512", "l0.2221934,0.5457732", "l0.2196871,0.5454572", "l0.2181368,0.5466158", "l0.2175684,0.5454923", "l0.2158113,0.5458434", "l0.2144548,0.5474408", "l0.2121294,0.5476866", "l0.2117289,0.5483712", "l0.2108633,0.5478622", "l0.2098427,0.5482484", "l0.2092743,0.5493016", "l0.2075560,0.5495474", "l0.2066646,0.5503900", "l0.2063674,0.5530232", "l0.2055923,0.5539185", "l0.2055019,0.5555511", "l0.2043262,0.5581141", "l0.2027113,0.5597993", "l0.2003342,0.5598695", "l0.1985255,0.5606946", "l0.1968848,0.5635384", "l0.1957091,0.5632049", "l0.1957091,0.5617830", "l0.1934354,0.5613441", "l0.1914975,0.5599046", "l0.1906319,0.5599222", "l0.1906707,0.5604488", "l0.1896113,0.5608701", "l0.1876734,0.5608175", "l0.1849604,0.5627660", "l0.1844824,0.5637140", "l0.1781908,0.5662067", "l0.1785654,0.5671196", "l0.1781649,0.5681026", "l0.1737336,0.5713502", "l0.1723513,0.5711922", "l0.1717441,0.5699283", "l0.1706718,0.5696299", "l0.1693799,0.5699985", "l0.1686823,0.5712625", "l0.1656333,0.5712273", "l0.1646127,0.5719471", "l0.1632950,0.5717891", "l0.1625715,0.5703672", "l0.1609308,0.5707183", "l0.1584115,0.5696825", "l0.1575976,0.5704374", "l0.1565253,0.5702618", "l0.1555564,0.5685239", "l0.1544324,0.5679271", "l0.1538123,0.5628538", "l0.1511251,0.5623974", "l0.1500657,0.5637666", "l0.1483992,0.5622745", "l0.1455957,0.5615723", "l0.1449110,0.5618707", "l0.1445363,0.5632751", "l0.1436191,0.5633980", "l0.1438516,0.5644864", "l0.1433478,0.5660487", "l0.1389165,0.5688926", "l0.1389553,0.5712273", "l0.1383868,0.5721753", "l0.1369528,0.5723859", "l0.1371983,0.5730881", "l0.1359063,0.5740010", "l0.1338264,0.5739308", "l0.1328187,0.5747032", "l0.1308808,0.5744398", "l0.1289688,0.5713502", "l0.1281290,0.5719120", "l0.1270696,0.5714029", "l0.1253902,0.5724035", "l0.1249380,0.5711571", "l0.1241241,0.5711571", "l0.1234264,0.5700161", "l0.1223283,0.5707358", "l0.1226771,0.5717189", "l0.1222379,0.5726844", "l0.1192794,0.5716838", "l0.1172382,0.5719646", "l0.1167472,0.5718593", "l0.1162046,0.5703672", "l0.1152874,0.5699459", "l0.1146414,0.5703496", "l0.1142668,0.5688926", "l0.1131040,0.5685942", "l0.1113987,0.5707885", "l0.1103135,0.5712976", "l0.1099388,0.5728950", "l0.1103393,0.5738605", "l0.1099130,0.5748260", "l0.1092154,0.5754229", "l0.1079493,0.5783721", "l0.1063473,0.5794253", "l0.1053913,0.5847620", "l0.1036472,0.5850428", "l0.1033501,0.5877813", "l0.1042027,0.5890979", "l0.1032596,0.5900108", "l0.1036472,0.5910114", "l0.1029367,0.5928897", "l0.1032209,0.5936797", "l0.1022519,0.5949963", "l0.1007533,0.5949612", "l0.0997198,0.5958565", "l0.0980661,0.5950665", "l0.0975623,0.5958389", "l0.0939062,0.5960496", "l0.0929114,0.5967342", "l0.0916711,0.5959793", "l0.0904697,0.5967518", "l0.0898108,0.5988583", "l0.0884930,0.5974715", "l0.0880150,0.5979104", "l0.0880150,0.5979104", "l0.0863485,0.5967869", "l0.0821756,0.5914854", "l0.0796951,0.5916609", "l0.0793850,0.5905023", "l0.0775117,0.5899932", "l0.0766591,0.5886591", "l0.0758839,0.5842353", "l0.0742303,0.5788109", "l0.0749021,0.5773890", "l0.0735714,0.5755809", "l0.0727446,0.5716311", "l0.0728221,0.5704023", "l0.0744628,0.5687346", "l0.0745791,0.5679446", "l0.0722537,0.5680675", "l0.0712976,0.5694894", "l0.0698636,0.5670318", "l0.0679128,0.5680500", "l0.0653031,0.5676287", "l0.0631069,0.5683835", "l0.0616470,0.5666983", "l0.0595929,0.5667509", "l0.0574741,0.5648199", "l0.0557946,0.5646268", "l0.0541410,0.5628714", "l0.0525132,0.5628011", "l0.0511050,0.5605190", "l0.0499552,0.5597817", "l0.0494901,0.5561655", "l0.0466479,0.5574294", "l0.0459244,0.5584651", "l0.0438444,0.5579912", "l0.0430822,0.5584651", "l0.0428755,0.5558846", "l0.0417257,0.5535323", "l0.0402529,0.5534270", "l0.0393486,0.5520226", "l0.0391935,0.5502671", "l0.0405371,0.5493719", "l0.0403304,0.5478797", "l0.0411314,0.5477042", "l0.0400333,0.5458960", "l0.0400074,0.5443863", "l0.0406792,0.5430346", "l0.0403692,0.5415074", "l0.0391289,0.5388742", "l0.0388964,0.5369081", "l0.0378112,0.5353984", "l0.0345555,0.5328354", "l0.0328244,0.5328881", "l0.0325660,0.5340993", "l0.0313258,0.5341345", "l0.0302535,0.5289207", "l0.0304602,0.5280254", "l0.0277730,0.5276217", "l0.0263002,0.5259013", "l0.0243107,0.5261295", "l0.0226312,0.5282537", "l0.0214684,0.5267791", "l0.0211584,0.5247252", "l0.0196856,0.5258311", "l0.0187296,0.5238123", "l0.0180965,0.5238474", "l0.0168692,0.5254976", "l0.0146471,0.5232330", "l0.0155515,0.5217584", "l0.0152414,0.5210212", "l0.0155644,0.5197397", "l0.0183678,0.5199854", "l0.0196985,0.5188093", "l0.0207320,0.5205296", "l0.0221144,0.5203190", "l0.0228379,0.5184231", "l0.0257964,0.5175629", "l0.0255509,0.5160356", "l0.0261323,0.5144908", "l0.0248016,0.5118050", "l0.0241039,0.5111730", "l0.0238972,0.5120683", "l0.0227216,0.5109975", "l0.0222177,0.5081712", "l0.0238456,0.5051167", "l0.0223986,0.5031857", "l0.0227604,0.5019393", "l0.0225020,0.4983406", "l0.0216235,0.4977437", "l0.0204091,0.4933902", "l0.0206674,0.4922667", "l0.0202928,0.4889138", "l0.0216622,0.4876849", "l0.0216493,0.4844198", "l0.0209646,0.4849815", "l0.0203186,0.4838054", "l0.0193109,0.4839107", "l0.0178769,0.4821904", "l0.0135490,0.4801540", "l0.0096086,0.4798731", "l0.0087172,0.4836649", "l0.0063401,0.4835245", "l0.0058104,0.4824712", "l0.0040017,0.4813653", "l0.0043505,0.4803471", "l0.0036142,0.4782757", "l0.0032912,0.4750807", "l0.0027098,0.4741503", "l0.0034462,0.4722720", "l0.0048932,0.4720262", "l0.0050482,0.4710256", "l0.0046348,0.4694282", "l0.0034075,0.4695159", "l0.0023868,0.4655837", "l0.0013145,0.4636000", "l0.0004748,0.4635298", "l0.0003585,0.4629856", "l0.0021543,0.4601067", "l0.0019993,0.4571048", "l0.0050094,0.4571399", "l0.0065597,0.4534183", "l0.0061076,0.4496090", "l0.0048286,0.4483275", "l0.0053195,0.4463965", "l0.0062497,0.4454486", "l0.0061463,0.4441495", "l0.0072703,0.4417445", "l0.0066760,0.4410775", "l0.0082134,0.4391816", "l0.0093761,0.4394800", "l0.0095957,0.4387954", "l0.0113140,0.4381634", "l0.0131356,0.4393220", "l0.0161199,0.4358462", "l0.0171405,0.4338098", "l0.0187554,0.4340556", "l0.0190655,0.4317384", "l0.0206674,0.4315980", "l0.0215847,0.4325635", "l0.0222565,0.4319842", "l0.0204607,0.4288243", "l0.0209904,0.4282450", "l0.0210938,0.4265422", "l0.0237035,0.4287015", "l0.0274758,0.4289648", "l0.0307315,0.4255416", "l0.0314162,0.4241021", "l0.0335866,0.4226451", "l0.0343618,0.4270689", "l0.0356795,0.4278939", "l0.0355762,0.4290877", "l0.0344005,0.4306500", "l0.0351627,0.4320368", "l0.0353307,0.4337221", "l0.0366226,0.4330901", "l0.0373719,0.4319139", "l0.0375786,0.4327566", "l0.0388964,0.4334763", "l0.0396845,0.4308431", "l0.0417128,0.4299478", "l0.0432889,0.4306676", "l0.0450071,0.4283855", "l0.0456402,0.4313346", "l0.0476168,0.4299303", "l0.0487408,0.4283504", "l0.0490121,0.4262438", "l0.0507820,0.4234702", "l0.0505753,0.4197662", "l0.0530816,0.4170276", "l0.0530558,0.4138327", "l0.0543348,0.4120597", "l0.0573191,0.4109362", "l0.0590503,0.4122001", "l0.0603034,0.4118666", "l0.0610269,0.4124634", "l0.0624222,0.4117261", "l0.0655228,0.4128847", "l0.0667630,0.4123054", "l0.0673831,0.4127268", "l0.0708713,0.4105324", "l0.0726025,0.4104095", "l0.0738427,0.4117261", "l0.0747987,0.4106378", "l0.0759744,0.4103569", "l0.0773180,0.4064247", "l0.0791654,0.4047219", "l0.0795530,0.4034228", "l0.0790879,0.4022467", "l0.0792817,0.4006316", "l0.0806511,0.4003156", "l0.0822918,0.3988937", "l0.0833254,0.3988762", "l0.0844364,0.3964887", "l0.0865293,0.3957514", "l0.0881701,0.3936800", "l0.0893715,0.3933289", "l0.0916066,0.3912399", "l0.0927564,0.3910644", "l0.0935057,0.3895898", "l0.0951206,0.3890456", "l0.0959215,0.3878870", "l0.0969938,0.3878168", "l0.0972651,0.3884663", "l0.0967225,0.3892913", "l0.0971101,0.3896951", "l0.1001461,0.3894142", "l0.1016447,0.3872726", "l0.1029883,0.3826557", "l0.1035955,0.3820413", "l0.1060373,0.3816375", "l0.1075876,0.3821466", "l0.1101326,0.3813918", "l0.1096029,0.3803912", "l0.1099388,0.3791799", "l0.1095383,0.3765994", "l0.1100680,0.3761781", "l0.1102231,0.3750721", "l0.1089311,0.3704026", "l0.1090603,0.3687349", "l0.1100551,0.3677694", "l0.1086469,0.3661544", "l0.1083239,0.3634510", "l0.1090991,0.3620993", "l0.1097450,0.3583777", "l0.1120188,0.3584128", "l0.1151711,0.3563413", "l0.1148094,0.3554987", "l0.1134012,0.3549896", "l0.1121222,0.3536204", "l0.1119671,0.3517771", "l0.1137242,0.3508819", "l0.1152099,0.3492142", "l0.1182071,0.3486875", "l0.1185818,0.3477571", "l0.1179100,0.3443164", "l0.1165405,0.3442638", "l0.1163080,0.3437196", "l0.1177033,0.3392783", "l0.1140084,0.3278151", "l0.1122514,0.3181074", "l0.1111274,0.3078731", "l0.1121222,0.3039057", "l0.1114245,0.3024487", "l0.1134787,0.3008863", "l0.1134012,0.3000613", "l0.1114762,0.2983760", "l0.1110886,0.2973403", "l0.1102489,0.2975158", "l0.1100939,0.2967259", "l0.1060243,0.2979372", "l0.1053525,0.2974456", "l0.1048745,0.2955146", "l0.1039056,0.2949353", "l0.1031046,0.2953742", "l0.1030012,0.2948651", "l0.1063861,0.2913015", "l0.1068770,0.2914068", "l0.1068641,0.2901780", "l0.1090862,0.2907573", "l0.1105460,0.2896338", "l0.1117475,0.2903360", "l0.1131945,0.2880363", "l0.1154166,0.2882821", "l0.1168893,0.2874395", "l0.1174190,0.2862809", "l0.1200675,0.2876501", "l0.1210622,0.2864915", "l0.1230776,0.2862633", "l0.1235685,0.2848590", "l0.1245375,0.2851223", "l0.1247700,0.2845254", "l0.1271342,0.2833493", "l0.1278190,0.2837179", "l0.1286070,0.2826997", "l0.1289558,0.2832790", "l0.1297697,0.2831035", "l0.1320694,0.2806283", "l0.1331029,0.2802245", "l0.1347178,0.2821029", "l0.1352087,0.2853154", "l0.1365006,0.2851749", "l0.1374308,0.2868251", "l0.1423013,0.2843323", "l0.1431798,0.2846308", "l0.1461125,0.2879486", "l0.1478437,0.2844728", "l0.1484767,0.2804528", "l0.1480245,0.2781882", "l0.1449756,0.2769243", "l0.1429344,0.2750108", "l0.1426114,0.2737996", "l0.1432057,0.2706046", "l0.1464096,0.2607214", "l0.1468101,0.2543139", "l0.1502337,0.2436232", "l0.1513577,0.2361625", "l0.1527013,0.2320547", "l0.1534635,0.2276485", "l0.1543937,0.2262441", "l0.1550009,0.2211708", "l0.1573522,0.2207846", "l0.1584890,0.2222768", "l0.1602331,0.2224172", "l0.1611762,0.2240849", "l0.1619772,0.2237689", "l0.1639797,0.2261739", "l0.1704393,0.2282102", "l0.1714470,0.2291757", "l0.1743279,0.2280698", "l0.1778290,0.2277187", "l0.1790951,0.2287720", "l0.1820277,0.2279118", "l0.1836556,0.2310365", "l0.1821699,0.2332484", "l0.1839785,0.2336697", "l0.1865365,0.2322127", "l0.1867562,0.2308259", "l0.1882935,0.2302290", "l0.1902573,0.2278416", "l0.1907869,0.2263143", "l0.1957996,0.2261388", "l0.1965618,0.2218730", "l0.1985255,0.2205564", "l0.1986935,0.2158342", "l0.1970011,0.2111296", "l0.1972853,0.2082506", "l0.1959934,0.1973317", "l0.1971432,0.1925744", "l0.1971173,0.1901343", "l0.1991586,0.1830247", "l0.2010318,0.1811288", "l0.2037190,0.1804090", "l0.2069746,0.1808654", "l0.2086671,0.1786887", "l0.2098298,0.1783902", "l0.2105533,0.1788993", "l0.2130854,0.1772843", "l0.2138218,0.1745458", "l0.2146615,0.1740718", "l0.2159276,0.1715264", "l0.2156692,0.1693145", "l0.2167286,0.1672431", "l0.2154496,0.1648205", "l0.2152817,0.1622576", "l0.2170128,0.1602388", "l0.2175942,0.1581498", "l0.2192866,0.1585535", "l0.2219996,0.1568507", "l0.2234207,0.1580796", "l0.2266247,0.1591328", "l0.2280587,0.1583780", "l0.2281621,0.1571667", "l0.2290922,0.1576582", "l0.2312627,0.1562188", "c"]}, {"n": "Xizang (Tibet) ", "u": "CN-54", "i": ["m0.0880150,0.5979104", "l0.0884930,0.5974715", "l0.0898108,0.5988583", "l0.0904697,0.5967518", "l0.0916711,0.5959793", "l0.0929114,0.5967342", "l0.0939062,0.5960496", "l0.0975623,0.5958389", "l0.0980661,0.5950665", "l0.0997198,0.5958565", "l0.1007533,0.5949612", "l0.1022519,0.5949963", "l0.1032209,0.5936797", "l0.1029367,0.5928897", "l0.1036472,0.5910114", "l0.1032596,0.5900108", "l0.1042027,0.5890979", "l0.1033501,0.5877813", "l0.1036472,0.5850428", "l0.1053913,0.5847620", "l0.1063473,0.5794253", "l0.1079493,0.5783721", "l0.1092154,0.5754229", "l0.1099130,0.5748260", "l0.1103393,0.5738605", "l0.1099388,0.5728950", "l0.1103135,0.5712976", "l0.1113987,0.5707885", "l0.1131040,0.5685942", "l0.1142668,0.5688926", "l0.1146414,0.5703496", "l0.1152874,0.5699459", "l0.1162046,0.5703672", "l0.1167472,0.5718593", "l0.1172382,0.5719646", "l0.1192794,0.5716838", "l0.1222379,0.5726844", "l0.1226771,0.5717189", "l0.1223283,0.5707358", "l0.1234264,0.5700161", "l0.1241241,0.5711571", "l0.1249380,0.5711571", "l0.1253902,0.5724035", "l0.1270696,0.5714029", "l0.1281290,0.5719120", "l0.1289688,0.5713502", "l0.1308808,0.5744398", "l0.1328187,0.5747032", "l0.1338264,0.5739308", "l0.1359063,0.5740010", "l0.1371983,0.5730881", "l0.1369528,0.5723859", "l0.1383868,0.5721753", "l0.1389553,0.5712273", "l0.1389165,0.5688926", "l0.1433478,0.5660487", "l0.1438516,0.5644864", "l0.1436191,0.5633980", "l0.1445363,0.5632751", "l0.1449110,0.5618707", "l0.1455957,0.5615723", "l0.1483992,0.5622745", "l0.1500657,0.5637666", "l0.1511251,0.5623974", "l0.1538123,0.5628538", "l0.1544324,0.5679271", "l0.1555564,0.5685239", "l0.1565253,0.5702618", "l0.1575976,0.5704374", "l0.1584115,0.5696825", "l0.1609308,0.5707183", "l0.1625715,0.5703672", "l0.1632950,0.5717891", "l0.1646127,0.5719471", "l0.1656333,0.5712273", "l0.1686823,0.5712625", "l0.1693799,0.5699985", "l0.1706718,0.5696299", "l0.1717441,0.5699283", "l0.1723513,0.5711922", "l0.1737336,0.5713502", "l0.1781649,0.5681026", "l0.1785654,0.5671196", "l0.1781908,0.5662067", "l0.1844824,0.5637140", "l0.1849604,0.5627660", "l0.1876734,0.5608175", "l0.1896113,0.5608701", "l0.1906707,0.5604488", "l0.1906319,0.5599222", "l0.1914975,0.5599046", "l0.1934354,0.5613441", "l0.1957091,0.5617830", "l0.1957091,0.5632049", "l0.1968848,0.5635384", "l0.1985255,0.5606946", "l0.2003342,0.5598695", "l0.2027113,0.5597993", "l0.2043262,0.5581141", "l0.2055019,0.5555511", "l0.2055923,0.5539185", "l0.2063674,0.5530232", "l0.2066646,0.5503900", "l0.2075560,0.5495474", "l0.2092743,0.5493016", "l0.2098427,0.5482484", "l0.2108633,0.5478622", "l0.2117289,0.5483712", "l0.2121294,0.5476866", "l0.2144548,0.5474408", "l0.2158113,0.5458434", "l0.2175684,0.5454923", "l0.2181368,0.5466158", "l0.2196871,0.5454572", "l0.2221934,0.5457732", "l0.2229169,0.5443512", "l0.2247514,0.5439475", "l0.2259400,0.5425080", "l0.2272319,0.5425431", "l0.2274515,0.5440001", "l0.2290664,0.5445443", "l0.2317019,0.5433682", "l0.2343245,0.5437719", "l0.2357973,0.5419287", "l0.2382778,0.5422271", "l0.2401510,0.5410334", "l0.2414171,0.5413670", "l0.2422569,0.5406823", "l0.2437555,0.5406999", "l0.2442206,0.5417005", "l0.2456934,0.5414723", "l0.2462618,0.5432453", "l0.2473470,0.5438246", "l0.2486260,0.5456678", "l0.2497758,0.5442284", "l0.2511969,0.5439299", "l0.2518300,0.5451763", "l0.2530444,0.5452816", "l0.2545430,0.5469844", "l0.2554086,0.5470371", "l0.2562742,0.5458434", "l0.2604083,0.5497756", "l0.2643874,0.5516013", "l0.2643874,0.5516013", "l0.2624366,0.5517944", "l0.2606408,0.5531812", "l0.2594135,0.5527599", "l0.2590001,0.5539185", "l0.2594135,0.5542520", "l0.2593102,0.5560075", "l0.2614160,0.5572188", "l0.2610801,0.5574996", "l0.2654468,0.5579209", "l0.2642453,0.5633278", "l0.2648783,0.5650130", "l0.2640515,0.5654168", "l0.2638706,0.5662418", "l0.2639740,0.5672249", "l0.2648783,0.5680675", "l0.2636768,0.5696474", "l0.2605633,0.5711571", "l0.2605762,0.5732286", "l0.2610801,0.5733866", "l0.2598269,0.5747909", "l0.2609121,0.5773715", "l0.2620490,0.5779508", "l0.2616485,0.5828309", "l0.2620232,0.5837789", "l0.2628112,0.5841826", "l0.2639611,0.5832523", "l0.2655114,0.5832171", "l0.2656535,0.5844284", "l0.2665836,0.5859206", "l0.2655243,0.5877813", "l0.2643228,0.5884309", "l0.2645295,0.5904848", "l0.2654468,0.5910465", "l0.2651238,0.5920296", "l0.2657051,0.5932408", "l0.2658860,0.5958038", "l0.2655114,0.5970853", "l0.2666482,0.5988407", "l0.2659506,0.5998589", "l0.2656922,0.6033523", "l0.2647491,0.6043705", "l0.2637543,0.6044407", "l0.2629534,0.6064068", "l0.2636768,0.6087942", "l0.2653563,0.6112694", "l0.2661573,0.6112519", "l0.2675913,0.6130424", "l0.2673588,0.6147803", "l0.2683536,0.6149910", "l0.2688962,0.6159389", "l0.2685603,0.6175891", "l0.2714412,0.6195376", "l0.2725265,0.6209771", "l0.2726686,0.6235928", "l0.2748390,0.6271212", "l0.2767769,0.6273143", "l0.2801875,0.6305795", "l0.2824355,0.6313694", "l0.2848126,0.6279287", "l0.2852647,0.6284203", "l0.2878098,0.6279463", "l0.2881328,0.6262611", "l0.2887271,0.6256993", "l0.2914143,0.6258573", "l0.2918664,0.6266824", "l0.2911688,0.6269808", "l0.2911688,0.6276830", "l0.2928612,0.6312466", "l0.2938172,0.6316328", "l0.2942565,0.6328967", "l0.2962460,0.6344591", "l0.2980418,0.6357581", "l0.2988686,0.6357054", "l0.2991141,0.6367938", "l0.2997213,0.6367587", "l0.3008840,0.6390408", "l0.3037521,0.6373029", "l0.3051732,0.6385493", "l0.3046693,0.6394621", "l0.3047468,0.6408314", "l0.3057416,0.6416213", "l0.3072919,0.6404627", "l0.3088681,0.6404452", "l0.3119557,0.6415862", "l0.3127180,0.6404276", "l0.3156377,0.6422006", "l0.3179502,0.6410069", "l0.3187641,0.6440088", "l0.3205599,0.6430784", "l0.3217743,0.6431661", "l0.3239447,0.6466771", "l0.3252625,0.6459047", "l0.3255208,0.6472213", "l0.3262314,0.6480112", "l0.3277171,0.6468526", "l0.3284277,0.6454834", "l0.3295258,0.6453254", "l0.3310115,0.6460100", "l0.3317737,0.6480990", "l0.3327556,0.6483623", "l0.3334532,0.6477303", "l0.3342413,0.6488012", "l0.3349777,0.6481692", "l0.3362825,0.6491172", "l0.3370060,0.6484501", "l0.3373806,0.6469579", "l0.3399903,0.6468351", "l0.3404554,0.6447812", "l0.3414114,0.6456413", "l0.3416052,0.6447285", "l0.3428713,0.6447636", "l0.3441374,0.6429028", "l0.3468504,0.6461329", "l0.3464370,0.6465893", "l0.3473801,0.6478532", "l0.3486978,0.6484325", "l0.3492921,0.6503460", "l0.3486720,0.6506444", "l0.3488270,0.6512939", "l0.3506744,0.6522770", "l0.3517209,0.6539622", "l0.3554158,0.6538393", "l0.3562038,0.6559108", "l0.3569144,0.6556299", "l0.3574699,0.6563321", "l0.3577671,0.6586318", "l0.3571340,0.6593515", "l0.3576120,0.6602117", "l0.3567723,0.6604925", "l0.3564622,0.6614229", "l0.3579092,0.6655658", "l0.3589040,0.6669526", "l0.3596920,0.6670229", "l0.3606480,0.6660925", "l0.3626763,0.6666542", "l0.3637486,0.6687959", "l0.3645884,0.6677075", "l0.3683737,0.6679181", "l0.3690843,0.6685326", "l0.3699628,0.6723770", "l0.3707379,0.6720435", "l0.3709188,0.6711657", "l0.3702728,0.6707269", "l0.3708542,0.6686554", "l0.3703503,0.6669351", "l0.3689292,0.6654078", "l0.3691876,0.6642843", "l0.3700661,0.6643019", "l0.3698077,0.6631960", "l0.3719135,0.6619847", "l0.3739548,0.6659696", "l0.3756601,0.6676373", "l0.3766290,0.6673213", "l0.3773396,0.6680761", "l0.3778305,0.6675144", "l0.3787349,0.6688661", "l0.3798976,0.6690241", "l0.3804144,0.6675846", "l0.3791224,0.6643195", "l0.3799234,0.6632311", "l0.3789545,0.6618969", "l0.3785411,0.6597377", "l0.3800009,0.6600186", "l0.3806857,0.6609841", "l0.3813704,0.6599659", "l0.3820680,0.6607559", "l0.3824297,0.6604925", "l0.3819647,0.6593515", "l0.3823006,0.6587195", "l0.3857500,0.6596324", "l0.3868481,0.6589126", "l0.3865897,0.6575785", "l0.3871194,0.6582982", "l0.3880496,0.6582982", "l0.3873261,0.6556475", "l0.3877266,0.6530143", "l0.3883467,0.6525052", "l0.3890702,0.6532074", "l0.3898453,0.6523999", "l0.3888893,0.6516099", "l0.3898066,0.6513466", "l0.3893673,0.6494331", "l0.3885663,0.6488363", "l0.3893157,0.6473968", "l0.3890702,0.6466946", "l0.3940182,0.6480288", "l0.3939278,0.6473617", "l0.3949613,0.6466595", "l0.3949613,0.6466595", "l0.3988629,0.6480990", "l0.4006458,0.6499773", "l0.4025578,0.6510306", "l0.4030487,0.6544187", "l0.4044569,0.6574907", "l0.4064206,0.6601415", "l0.4063560,0.6622129", "l0.4058651,0.6629151", "l0.4061364,0.6648110", "l0.4082422,0.6677250", "l0.4085006,0.6694630", "l0.4095083,0.6710604", "l0.4137845,0.6765726", "l0.4121051,0.6798026", "l0.4106064,0.6776610", "l0.4097279,0.6776083", "l0.4091982,0.6814176", "l0.4103480,0.6823480", "l0.4114203,0.6851919", "l0.4124151,0.6861223", "l0.4121180,0.6890890", "l0.4150635,0.6924770", "l0.4150377,0.6933372", "l0.4141204,0.6943203", "l0.4152832,0.7020268", "l0.4154511,0.7079427", "l0.4163942,0.7098912", "l0.4168593,0.7137532", "l0.4160196,0.7159651", "l0.4155932,0.7203187", "l0.4165492,0.7231801", "l0.4167559,0.7286922", "l0.4175311,0.7310094", "l0.4175311,0.7310094", "l0.4160454,0.7324665", "l0.4154124,0.7321505", "l0.4150894,0.7326244", "l0.4160066,0.7359598", "l0.4144047,0.7379084", "l0.4143142,0.7397341", "l0.4152444,0.7405591", "l0.4150635,0.7416475", "l0.4141334,0.7422970", "l0.4130998,0.7421215", "l0.4120792,0.7372764", "l0.4108906,0.7381366", "l0.4096762,0.7379786", "l0.4106064,0.7439998", "l0.4090432,0.7455973", "l0.4095212,0.7498104", "l0.4105031,0.7505828", "l0.4116658,0.7539884", "l0.4110198,0.7548135", "l0.4109165,0.7566918", "l0.4095600,0.7583946", "l0.4083327,0.7579206", "l0.4059684,0.7597990", "l0.4052321,0.7551295", "l0.4040177,0.7525665", "l0.4026870,0.7535671", "l0.4037076,0.7563232", "l0.4020927,0.7572711", "l0.4022348,0.7581840", "l0.4016147,0.7587808", "l0.4016147,0.7587808", "l0.4004778,0.7572536", "l0.3996122,0.7573764", "l0.3997156,0.7558492", "l0.3977002,0.7530756", "l0.3961111,0.7540762", "l0.3946513,0.7496349", "l0.3934110,0.7506881", "l0.3924679,0.7488625", "l0.3908789,0.7529527", "l0.3907626,0.7556210", "l0.3899487,0.7551119", "l0.3896516,0.7562705", "l0.3888764,0.7566392", "l0.3867060,0.7549539", "l0.3858792,0.7549890", "l0.3845485,0.7532160", "l0.3829853,0.7545502", "l0.3818355,0.7538304", "l0.3813962,0.7528122", "l0.3794971,0.7531985", "l0.3789803,0.7518994", "l0.3775721,0.7507935", "l0.3761769,0.7508637", "l0.3750529,0.7519872", "l0.3742002,0.7519696", "l0.3732442,0.7538480", "l0.3727791,0.7526016", "l0.3710867,0.7521978", "l0.3728050,0.7502668", "l0.3720298,0.7490907", "l0.3733605,0.7483358", "l0.3732701,0.7475634", "l0.3737093,0.7477565", "l0.3747816,0.7464750", "l0.3744328,0.7452111", "l0.3762802,0.7443685", "l0.3767712,0.7429290", "l0.3754922,0.7402783", "l0.3751950,0.7380839", "l0.3746782,0.7382244", "l0.3745103,0.7375046", "l0.3752984,0.7353630", "l0.3738385,0.7364162", "l0.3723786,0.7365391", "l0.3707767,0.7388037", "l0.3694331,0.7397341", "l0.3690972,0.7389266", "l0.3697431,0.7376626", "l0.3685933,0.7353981", "l0.3697431,0.7349592", "l0.3709704,0.7333091", "l0.3723786,0.7330458", "l0.3731279,0.7308690", "l0.3726499,0.7301317", "l0.3715001,0.7313956", "l0.3706991,0.7314132", "l0.3697044,0.7295348", "l0.3695752,0.7281480", "l0.3680378,0.7256377", "l0.3660224,0.7276740", "l0.3647693,0.7274634", "l0.3633998,0.7288502", "l0.3630898,0.7283411", "l0.3608160,0.7310445", "l0.3601700,0.7307461", "l0.3599633,0.7318520", "l0.3591753,0.7319574", "l0.3593174,0.7340990", "l0.3585035,0.7338182", "l0.3583226,0.7354332", "l0.3577025,0.7364514", "l0.3547440,0.7359072", "l0.3544856,0.7345906", "l0.3523798,0.7344150", "l0.3503515,0.7329931", "l0.3507649,0.7340639", "l0.3482973,0.7326947", "l0.3470958,0.7332037", "l0.3467599,0.7312727", "l0.3443311,0.7285518", "l0.3431813,0.7315712", "l0.3411143,0.7316238", "l0.3398999,0.7335022", "l0.3387630,0.7336075", "l0.3375744,0.7352401", "l0.3366055,0.7385052", "l0.3339829,0.7413491", "l0.3340992,0.7430168", "l0.3328589,0.7456149", "l0.3315283,0.7447196", "l0.3304043,0.7457026", "l0.3296937,0.7451760", "l0.3264639,0.7459484", "l0.3257663,0.7453164", "l0.3254821,0.7460713", "l0.3250170,0.7455095", "l0.3232471,0.7464224", "l0.3222523,0.7498104", "l0.3207278,0.7514430", "l0.3215288,0.7524260", "l0.3213221,0.7541113", "l0.3181311,0.7548837", "l0.3182990,0.7558843", "l0.3177564,0.7566918", "l0.3171622,0.7559194", "l0.3160382,0.7573413", "l0.3149142,0.7581664", "l0.3144750,0.7574116", "l0.3126404,0.7593250", "l0.3122400,0.7609049", "l0.3134931,0.7627306", "l0.3105734,0.7669262", "l0.3096044,0.7664171", "l0.3088422,0.7673826", "l0.3079120,0.7669437", "l0.3065814,0.7679970", "l0.3057287,0.7660133", "l0.3048502,0.7659958", "l0.3023310,0.7684710", "l0.3011553,0.7682076", "l0.3000959,0.7695769", "l0.2991399,0.7690327", "l0.2985456,0.7672070", "l0.2972796,0.7673826", "l0.2955096,0.7661011", "l0.2960781,0.7653814", "l0.2960264,0.7639594", "l0.2953417,0.7633450", "l0.2930033,0.7630290", "l0.2903291,0.7602203", "l0.2884041,0.7613613", "l0.2867634,0.7632397", "l0.2854585,0.7631168", "l0.2839987,0.7613965", "l0.2812598,0.7612911", "l0.2806268,0.7601852", "l0.2762343,0.7615369", "l0.2761309,0.7609400", "l0.2772419,0.7589037", "l0.2788827,0.7570429", "l0.2769061,0.7568674", "l0.2749165,0.7558316", "l0.2745031,0.7561652", "l0.2721906,0.7544448", "l0.2710020,0.7553752", "l0.2687799,0.7543395", "l0.2678497,0.7552348", "l0.2672167,0.7548837", "l0.2656018,0.7568147", "l0.2655243,0.7580786", "l0.2640773,0.7586930", "l0.2623978,0.7585351", "l0.2601628,0.7611507", "l0.2596331,0.7629413", "l0.2582249,0.7633801", "l0.2584058,0.7659255", "l0.2568038,0.7667155", "l0.2545947,0.7719819", "l0.2538066,0.7721048", "l0.2520754,0.7748784", "l0.2516879,0.7774589", "l0.2524113,0.7797761", "l0.2520108,0.7804959", "l0.2493753,0.7773536", "l0.2489102,0.7760370", "l0.2486519,0.7732634", "l0.2499438,0.7707355", "l0.2500730,0.7670490", "l0.2505768,0.7659782", "l0.2497758,0.7641701", "l0.2497241,0.7621689", "l0.2483805,0.7606241", "l0.2470111,0.7606065", "l0.2462618,0.7591846", "l0.2461843,0.7598692", "l0.2451766,0.7603432", "l0.2449053,0.7615018", "l0.2441172,0.7612560", "l0.2425540,0.7629764", "l0.2416367,0.7627657", "l0.2400994,0.7637488", "l0.2398668,0.7632748", "l0.2392079,0.7638717", "l0.2383165,0.7633977", "l0.2379806,0.7657851", "l0.2361203,0.7645563", "l0.2347896,0.7670490", "l0.2340661,0.7672948", "l0.2331101,0.7665400", "l0.2327871,0.7671544", "l0.2320637,0.7666277", "l0.2316502,0.7671017", "l0.2311593,0.7663644", "l0.2295832,0.7671544", "l0.2292731,0.7657676", "l0.2273740,0.7669086", "l0.2266376,0.7661713", "l0.2254103,0.7667331", "l0.2242088,0.7663995", "l0.2236145,0.7670315", "l0.2220513,0.7668559", "l0.2222322,0.7659255", "l0.2205268,0.7639945", "l0.2187569,0.7634855", "l0.2173875,0.7617651", "l0.2165090,0.7619933", "l0.2149458,0.7597639", "l0.2138476,0.7605714", "l0.2129950,0.7604310", "l0.2118710,0.7618529", "l0.2116385,0.7629413", "l0.2120390,0.7643983", "l0.2112121,0.7640823", "l0.2103207,0.7647143", "l0.2104370,0.7633099", "l0.2092613,0.7638541", "l0.2087058,0.7630641", "l0.2070005,0.7627657", "l0.2066129,0.7605363", "l0.2069359,0.7599745", "l0.2061995,0.7582191", "l0.2047267,0.7602378", "l0.2047655,0.7621513", "l0.2055406,0.7639945", "l0.2045329,0.7647494", "l0.2035381,0.7644861", "l0.2026984,0.7638892", "l0.2028793,0.7628886", "l0.2017553,0.7595883", "l0.1997141,0.7572009", "l0.1990810,0.7575169", "l0.1974274,0.7561125", "l0.1963551,0.7546204", "l0.1943655,0.7542166", "l0.1933578,0.7553752", "l0.1927377,0.7549364", "l0.1912779,0.7554103", "l0.1904898,0.7539357", "l0.1890170,0.7541288", "l0.1902960,0.7469666", "l0.1892883,0.7454744", "l0.1880352,0.7458957", "l0.1871308,0.7473177", "l0.1861360,0.7470719", "l0.1848312,0.7482305", "l0.1820923,0.7471070", "l0.1822990,0.7460186", "l0.1815627,0.7442456", "l0.1776611,0.7439823", "l0.1779324,0.7421390", "l0.1773510,0.7410858", "l0.1755165,0.7403134", "l0.1750772,0.7395410", "l0.1732944,0.7402607", "l0.1735528,0.7376802", "l0.1727518,0.7361003", "l0.1740437,0.7320100", "l0.1723901,0.7303775", "l0.1712015,0.7304301", "l0.1708527,0.7296226", "l0.1694832,0.7294295", "l0.1673257,0.7313605", "l0.1661243,0.7312376", "l0.1648194,0.7330633", "l0.1632045,0.7320978", "l0.1617188,0.7300615", "l0.1609308,0.7272352", "l0.1598456,0.7258308", "l0.1597939,0.7246898", "l0.1586570,0.7241631", "l0.1583857,0.7226008", "l0.1531793,0.7195814", "l0.1519261,0.7193883", "l0.1504146,0.7180717", "l0.1496136,0.7160880", "l0.1463063,0.7118047", "l0.1413970,0.7096455", "l0.1415908,0.7075038", "l0.1407769,0.7061170", "l0.1405960,0.7036067", "l0.1382835,0.7034311", "l0.1322115,0.7009208", "l0.1314105,0.7010964", "l0.1312555,0.7025183", "l0.1297310,0.7012017", "l0.1284907,0.7014299", "l0.1281419,0.7068016", "l0.1273797,0.7081182", "l0.1261653,0.7083113", "l0.1260232,0.7105232", "l0.1250930,0.7112429", "l0.1234135,0.7099790", "l0.1235298,0.7081533", "l0.1227546,0.7067841", "l0.1223283,0.7068367", "l0.1220312,0.7052919", "l0.1187626,0.7038349", "l0.1175611,0.7018337", "l0.1150677,0.6995516", "l0.1141246,0.7003942", "l0.1120576,0.6984281", "l0.1089699,0.6971115", "l0.1084790,0.6947416", "l0.1093962,0.6930564", "l0.1081948,0.6912658", "l0.1072129,0.6920557", "l0.1062440,0.6903880", "l0.1041381,0.6891592", "l0.1031046,0.6868947", "l0.1013218,0.6862101", "l0.0985958,0.6875618", "l0.0978723,0.6870527", "l0.0973814,0.6853674", "l0.0959474,0.6854201", "l0.0954306,0.6833311", "l0.0940870,0.6825411", "l0.0936478,0.6804346", "l0.0930147,0.6798377", "l0.0932473,0.6787318", "l0.0913094,0.6750629", "l0.0899787,0.6742378", "l0.0890356,0.6770465", "l0.0879763,0.6778189", "l0.0877954,0.6796271", "l0.0872399,0.6793989", "l0.0864130,0.6778716", "l0.0864906,0.6767657", "l0.0855475,0.6760284", "l0.0858575,0.6746942", "l0.0851082,0.6737112", "l0.0845785,0.6738692", "l0.0844106,0.6729914", "l0.0864389,0.6704811", "l0.0855991,0.6685501", "l0.0848627,0.6684974", "l0.0847077,0.6666367", "l0.0841651,0.6658643", "l0.0854570,0.6604925", "l0.0848111,0.6602994", "l0.0834546,0.6577014", "l0.0826277,0.6573152", "l0.0822531,0.6563672", "l0.0825502,0.6547873", "l0.0816846,0.6539798", "l0.0800439,0.6540676", "l0.0804573,0.6513115", "l0.0813487,0.6495736", "l0.0800310,0.6485730", "l0.0801989,0.6476952", "l0.0794884,0.6467824", "l0.0796047,0.6459749", "l0.0817751,0.6445003", "l0.0830928,0.6446407", "l0.0835579,0.6435348", "l0.0850565,0.6423060", "l0.0856121,0.6448689", "l0.0856250,0.6480814", "l0.0888289,0.6515572", "l0.0900046,0.6504864", "l0.0909089,0.6508024", "l0.0912707,0.6483799", "l0.0925109,0.6471510", "l0.0934152,0.6468351", "l0.0942937,0.6477830", "l0.0965158,0.6451849", "l0.0981049,0.6446232", "l0.0984149,0.6429730", "l0.0979111,0.6406207", "l0.0968905,0.6394972", "l0.0965287,0.6372327", "l0.0949526,0.6348628", "l0.0958957,0.6296140", "l0.0922267,0.6292804", "l0.0904180,0.6282974", "l0.0902888,0.6265068", "l0.0863097,0.6215564", "l0.0844881,0.6170098", "l0.0856767,0.6139377", "l0.0844881,0.6099002", "l0.0845656,0.6087767", "l0.0854570,0.6073196", "l0.0844106,0.6059153", "l0.0873820,0.6034049", "l0.0887902,0.6013686", "l0.0890356,0.5993498", "c"]}, {"n": "Yunnan", "u": "CN-53", "i": ["m0.4175311,0.7310094", "l0.4178412,0.7387510", "l0.4174536,0.7421566", "l0.4186551,0.7476863", "l0.4185259,0.7520574", "l0.4197274,0.7546730", "l0.4203216,0.7549188", "l0.4207867,0.7569902", "l0.4221691,0.7584648", "l0.4220657,0.7567094", "l0.4225696,0.7555683", "l0.4221691,0.7546906", "l0.4224016,0.7535144", "l0.4220140,0.7528298", "l0.4218849,0.7490205", "l0.4241715,0.7477916", "l0.4244816,0.7452111", "l0.4255668,0.7440701", "l0.4258510,0.7420688", "l0.4274013,0.7412613", "l0.4277889,0.7444738", "l0.4292746,0.7457202", "l0.4292875,0.7479847", "l0.4301790,0.7472123", "l0.4310833,0.7477565", "l0.4318843,0.7504599", "l0.4332150,0.7515132", "l0.4329824,0.7530405", "l0.4349074,0.7543044", "l0.4344681,0.7551295", "l0.4351916,0.7559721", "l0.4348299,0.7568674", "l0.4325948,0.7578329", "l0.4324010,0.7586755", "l0.4333312,0.7614140", "l0.4350624,0.7635732", "l0.4348299,0.7648020", "l0.4370390,0.7658202", "l0.4367290,0.7670315", "l0.4373362,0.7694014", "l0.4381888,0.7684710", "l0.4390544,0.7656798", "l0.4409665,0.7670841", "l0.4424392,0.7645212", "l0.4432661,0.7645738", "l0.4437828,0.7658904", "l0.4436278,0.7673124", "l0.4445838,0.7686290", "l0.4448680,0.7702966", "l0.4457595,0.7704371", "l0.4455528,0.7719292", "l0.4463667,0.7721574", "l0.4464054,0.7755455", "l0.4467542,0.7760019", "l0.4473098,0.7755806", "l0.4486921,0.7788984", "l0.4485112,0.7794777", "l0.4492735,0.7801448", "l0.4491055,0.7818125", "l0.4494414,0.7824620", "l0.4510563,0.7822338", "l0.4506817,0.7866575", "l0.4526970,0.7884832", "l0.4527487,0.7896594", "l0.4543249,0.7901334", "l0.4548804,0.7912568", "l0.4542473,0.7928894", "l0.4547512,0.7941358", "l0.4558622,0.7938549", "l0.4557201,0.7926437", "l0.4567407,0.7931001", "l0.4557589,0.7945571", "l0.4562627,0.7953295", "l0.4559268,0.7969972", "l0.4547900,0.7972430", "l0.4547900,0.7982436", "l0.4587045,0.8021583", "l0.4590533,0.8043526", "l0.4583556,0.8042297", "l0.4579551,0.8050021", "l0.4584202,0.8067927", "l0.4595830,0.8059852", "l0.4604098,0.8066347", "l0.4613787,0.8080039", "l0.4619859,0.8108302", "l0.4634200,0.8092152", "l0.4639109,0.8098296", "l0.4648927,0.8095312", "l0.4662234,0.8102334", "l0.4687685,0.8065294", "l0.4699958,0.8061256", "l0.4709131,0.8047037", "l0.4733031,0.8036855", "l0.4736778,0.8029658", "l0.4748922,0.8036504", "l0.4744400,0.8057745", "l0.4755510,0.8068102", "l0.4762874,0.8065645", "l0.4767913,0.8051425", "l0.4784320,0.8039839", "l0.4789229,0.8029833", "l0.4792459,0.8035451", "l0.4806929,0.8033169", "l0.4808479,0.8000342", "l0.4813517,0.7999815", "l0.4819073,0.7987527", "l0.4812613,0.7974536", "l0.4813517,0.7956631", "l0.4806541,0.7923101", "l0.4792718,0.7894312", "l0.4788325,0.7865522", "l0.4794785,0.7842526", "l0.4790651,0.7798288", "l0.4800211,0.7769498", "l0.4807575,0.7780733", "l0.4818298,0.7770727", "l0.4832250,0.7767918", "l0.4846332,0.7731054", "l0.4856797,0.7731580", "l0.4854730,0.7716308", "l0.4890128,0.7670666", "l0.4892195,0.7644685", "l0.4901368,0.7630115", "l0.4892324,0.7631870", "l0.4889482,0.7616773", "l0.4881860,0.7617475", "l0.4883023,0.7592548", "l0.4913124,0.7558668", "l0.4925527,0.7573062", "l0.4950977,0.7547959", "l0.4948910,0.7525489", "l0.4937671,0.7493364", "l0.4945939,0.7476336", "l0.4947489,0.7456851", "l0.4950848,0.7455446", "l0.4953303,0.7467910", "l0.4964930,0.7472825", "l0.4980433,0.7466681", "l0.4988830,0.7471772", "l0.4994256,0.7464048", "l0.5010922,0.7462644", "l0.5012989,0.7456675", "l0.5022808,0.7468261", "l0.5031980,0.7462117", "l0.5041411,0.7466330", "l0.5030688,0.7483885", "l0.5013248,0.7491433", "l0.5014540,0.7525314", "l0.5021387,0.7543571", "l0.5033660,0.7540411", "l0.5037665,0.7556210", "l0.5045546,0.7556034", "l0.5047613,0.7561827", "l0.5037923,0.7575169", "l0.5040636,0.7581137", "l0.5047483,0.7579382", "l0.5044770,0.7594303", "l0.5036760,0.7599570", "l0.5035985,0.7609225", "l0.5022808,0.7612560", "l0.5055235,0.7653111", "l0.5067637,0.7662942", "l0.5091667,0.7649600", "l0.5116084,0.7646616", "l0.5132104,0.7608874", "l0.5143731,0.7599921", "l0.5166081,0.7608347", "l0.5168019,0.7626428", "l0.5179646,0.7624673", "l0.5181972,0.7641701", "l0.5174479,0.7652585", "l0.5177450,0.7667331", "l0.5186881,0.7670315", "l0.5182101,0.7677863", "l0.5185460,0.7697173", "l0.5185460,0.7697173", "l0.5185977,0.7718063", "l0.5173316,0.7737022", "l0.5178484,0.7744395", "l0.5167373,0.7780031", "l0.5163756,0.7772132", "l0.5148253,0.7769147", "l0.5114146,0.7800570", "l0.5112079,0.7788633", "l0.5106007,0.7785473", "l0.5099160,0.7794601", "l0.5093088,0.7787931", "l0.5073451,0.7796006", "l0.5060144,0.7789335", "l0.5056527,0.7772834", "l0.5031593,0.7757035", "l0.5022162,0.7782489", "l0.5012860,0.7790213", "l0.5014540,0.7797761", "l0.5002396,0.7805661", "l0.4992577,0.7790564", "l0.4975136,0.7779153", "l0.4975394,0.7764934", "l0.4961959,0.7763179", "l0.4951623,0.7796708", "l0.4931857,0.7820056", "l0.4924622,0.7838664", "l0.4912349,0.7843930", "l0.4917258,0.7855165", "l0.4907827,0.7856394", "l0.4910282,0.7871315", "l0.4923847,0.7860607", "l0.4936379,0.7884657", "l0.4935991,0.7904318", "l0.4927206,0.7909233", "l0.4924105,0.7920644", "l0.4929144,0.7939954", "l0.4934958,0.7938725", "l0.4931469,0.7965759", "l0.4942321,0.7987351", "l0.4974361,0.7992266", "l0.4982888,0.7987878", "l0.4993998,0.7960844", "l0.5028363,0.7966461", "l0.5039215,0.7944167", "l0.5048000,0.7958562", "l0.5047096,0.7970674", "l0.5051876,0.7976292", "l0.5065053,0.7975765", "l0.5065958,0.7989984", "l0.5080944,0.8012630", "l0.5083786,0.8027376", "l0.5061049,0.8057921", "l0.5057431,0.8096716", "l0.5046837,0.8102334", "l0.5049034,0.8116553", "l0.5041024,0.8142709", "l0.5044124,0.8150609", "l0.5034047,0.8184489", "l0.5025392,0.8180276", "l0.5023454,0.8203624", "l0.5026167,0.8216263", "l0.5042445,0.8221881", "l0.5043478,0.8246633", "l0.5064407,0.8236276", "l0.5061436,0.8265065", "l0.5077456,0.8275598", "l0.5079265,0.8291573", "l0.5106653,0.8302808", "l0.5105620,0.8323171", "l0.5093992,0.8311234", "l0.5082624,0.8345641", "l0.5074484,0.8347221", "l0.5083657,0.8349678", "l0.5088954,0.8364775", "l0.5062082,0.8406555", "l0.5059627,0.8429025", "l0.5059627,0.8429025", "l0.5051618,0.8448335", "l0.5055493,0.8467119", "l0.5073063,0.8507143", "l0.5072030,0.8513814", "l0.5086241,0.8528033", "l0.5090504,0.8523820", "l0.5089600,0.8498190", "l0.5096964,0.8494855", "l0.5126807,0.8507319", "l0.5143990,0.8499419", "l0.5152516,0.8503808", "l0.5154196,0.8516096", "l0.5168019,0.8524698", "l0.5165694,0.8537688", "l0.5174091,0.8560158", "l0.5165565,0.8572271", "l0.5178484,0.8589123", "l0.5188431,0.8577537", "l0.5203288,0.8596672", "l0.5215174,0.8600709", "l0.5223055,0.8575080", "l0.5235070,0.8572446", "l0.5244242,0.8595794", "l0.5261941,0.8588421", "l0.5267238,0.8592283", "l0.5265171,0.8597725", "l0.5273181,0.8599305", "l0.5275894,0.8591756", "l0.5282741,0.8593687", "l0.5285971,0.8576484", "l0.5299407,0.8574904", "l0.5314910,0.8599129", "l0.5322920,0.8628797", "l0.5331317,0.8637223", "l0.5327312,0.8639505", "l0.5330413,0.8648458", "l0.5321370,0.8655480", "l0.5324858,0.8676194", "l0.5318657,0.8702526", "l0.5322145,0.8709899", "l0.5299019,0.8739215", "l0.5296823,0.8729209", "l0.5284292,0.8726751", "l0.5279641,0.8719554", "l0.5270726,0.8722889", "l0.5267497,0.8734475", "l0.5259745,0.8736406", "l0.5250185,0.8750275", "l0.5242046,0.8750977", "l0.5248893,0.8767654", "l0.5242692,0.8762563", "l0.5232227,0.8771867", "l0.5222021,0.8788017", "l0.5224347,0.8801007", "l0.5224347,0.8801007", "l0.5218145,0.8799076", "l0.5208327,0.8775202", "l0.5203418,0.8778186", "l0.5196958,0.8770813", "l0.5189594,0.8753259", "l0.5177838,0.8766249", "l0.5173187,0.8782399", "l0.5164660,0.8778186", "l0.5154971,0.8788193", "l0.5150320,0.8782575", "l0.5135980,0.8798374", "l0.5129778,0.8798199", "l0.5128099,0.8805923", "l0.5118539,0.8805220", "l0.5115567,0.8817158", "l0.5103036,0.8816455", "l0.5113759,0.8859991", "l0.5091538,0.8883163", "l0.5092571,0.8889658", "l0.5071642,0.8888429", "l0.5067379,0.8882636", "l0.5032368,0.8921081", "l0.5016994,0.8909495", "l0.5018415,0.8885796", "l0.4991802,0.8892467", "l0.4979529,0.8913532", "l0.4969710,0.8965319", "l0.4944389,0.8939162", "l0.4917646,0.8898084", "l0.4911574,0.8897909", "l0.4902143,0.8918974", "l0.4904598,0.8928103", "l0.4896717,0.8944780", "l0.4879534,0.8915639", "l0.4881343,0.8904580", "l0.4862223,0.8891063", "l0.4855505,0.8924241", "l0.4840131,0.8932667", "l0.4835738,0.8944780", "l0.4839614,0.8953206", "l0.4823336,0.8964441", "l0.4821656,0.8979362", "l0.4798531,0.8970760", "l0.4787421,0.8940391", "l0.4775277,0.8936705", "l0.4761453,0.8919852", "l0.4753702,0.8921432", "l0.4745692,0.8911250", "l0.4739620,0.8918097", "l0.4728251,0.8900015", "l0.4721533,0.8904228", "l0.4717916,0.8918623", "l0.4709260,0.8923187", "l0.4711973,0.8935476", "l0.4691302,0.8967250", "l0.4689494,0.8987437", "l0.4677220,0.8982522", "l0.4670373,0.8990597", "l0.4665981,0.8981469", "l0.4650607,0.8977256", "l0.4633554,0.8982522", "l0.4628515,0.8995337", "l0.4612625,0.8967776", "l0.4595959,0.8973745", "l0.4591695,0.8986911", "l0.4594408,0.8997268", "l0.4586786,0.9017807", "l0.4576580,0.9019211", "l0.4572704,0.9026935", "l0.4582006,0.9048001", "l0.4577614,0.9059060", "l0.4587045,0.9082934", "l0.4585236,0.9093292", "l0.4593633,0.9101718", "l0.4598543,0.9099260", "l0.4599059,0.9111373", "l0.4610945,0.9125943", "l0.4606294,0.9151749", "l0.4618438,0.9180363", "l0.4607844,0.9186507", "l0.4610428,0.9201604", "l0.4605648,0.9208801", "l0.4604227,0.9248650", "l0.4621668,0.9263396", "l0.4620893,0.9272700", "l0.4611203,0.9274982", "l0.4611979,0.9290079", "l0.4598672,0.9287797", "l0.4593504,0.9276035", "l0.4582264,0.9281477", "l0.4583040,0.9268487", "l0.4575417,0.9264274", "l0.4548158,0.9269716", "l0.4529942,0.9280775", "l0.4521157,0.9249177", "l0.4527229,0.9234606", "l0.4515731,0.9225653", "l0.4519090,0.9191949", "l0.4508625,0.9189666", "l0.4511338,0.9171936", "l0.4502553,0.9166494", "l0.4504104,0.9139460", "l0.4456432,0.9169479", "l0.4450877,0.9184576", "l0.4430981,0.9208801", "l0.4414445,0.9216525", "l0.4400492,0.9214770", "l0.4391578,0.9197917", "l0.4382405,0.9195108", "l0.4370519,0.9209503", "l0.4352562,0.9218456", "l0.4342356,0.9204237", "l0.4338738,0.9185804", "l0.4348299,0.9166845", "l0.4342872,0.9158770", "l0.4322331,0.9158068", "l0.4316517,0.9148062", "l0.4311608,0.9128401", "l0.4320135,0.9091887", "l0.4315355,0.9073631", "l0.4300885,0.9070295", "l0.4295588,0.9080301", "l0.4278923,0.9067486", "l0.4271688,0.9075737", "l0.4263420,0.9061167", "l0.4243266,0.9061869", "l0.4234739,0.9053267", "l0.4212131,0.9062220", "l0.4193785,0.9058534", "l0.4184096,0.9048001", "l0.4190039,0.9045368", "l0.4186421,0.9042032", "l0.4202054,0.9003061", "l0.4198049,0.8993757", "l0.4220528,0.8967074", "l0.4216394,0.8960403", "l0.4220011,0.8946535", "l0.4210064,0.8906862", "l0.4218978,0.8903526", "l0.4230088,0.8882987", "l0.4229701,0.8859991", "l0.4240036,0.8869295", "l0.4248950,0.8862097", "l0.4241586,0.8846298", "l0.4240424,0.8827164", "l0.4213681,0.8814876", "l0.4192364,0.8825057", "l0.4181641,0.8820493", "l0.4174923,0.8824882", "l0.4165105,0.8815227", "l0.4166268,0.8805923", "l0.4138104,0.8801358", "l0.4147018,0.8776782", "l0.4145726,0.8769058", "l0.4138233,0.8767829", "l0.4144434,0.8761685", "l0.4144434,0.8745710", "l0.4137070,0.8729911", "l0.4129060,0.8733598", "l0.4125572,0.8717096", "l0.4139267,0.8698840", "l0.4128156,0.8678827", "l0.4128285,0.8664433", "l0.4105031,0.8652144", "l0.4109036,0.8647405", "l0.4106452,0.8628446", "l0.4109552,0.8621424", "l0.4104514,0.8616508", "l0.4130740,0.8594565", "l0.4138621,0.8581575", "l0.4137458,0.8569287", "l0.4093016,0.8583857", "l0.4081130,0.8575431", "l0.4016276,0.8582277", "l0.3974935,0.8604396", "l0.3974676,0.8611242", "l0.3936436,0.8644245", "l0.3932948,0.8633010", "l0.3917832,0.8621775", "l0.3925971,0.8608433", "l0.3933723,0.8606853", "l0.3954135,0.8565776", "l0.3949355,0.8557525", "l0.3954781,0.8539444", "l0.3939666,0.8532597", "l0.3938632,0.8524171", "l0.3947546,0.8521011", "l0.3941474,0.8499068", "l0.3918091,0.8501350", "l0.3923904,0.8455357", "l0.3920933,0.8427270", "l0.3946642,0.8404098", "l0.3954910,0.8407433", "l0.3959044,0.8401640", "l0.3947546,0.8368988", "l0.3949872,0.8347396", "l0.3968346,0.8299121", "l0.3979069,0.8312111", "l0.3985399,0.8309829", "l0.3996897,0.8289290", "l0.4005295,0.8287184", "l0.4011238,0.8268927", "l0.4016405,0.8269454", "l0.4014080,0.8239084", "l0.4023123,0.8229429", "l0.4021444,0.8212226", "l0.4044698,0.8231360", "l0.4052579,0.8227323", "l0.4072474,0.8166935", "l0.4083843,0.8157104", "l0.4097796,0.8167988", "l0.4109294,0.8152716", "l0.4110069,0.8143587", "l0.4093404,0.8122522", "l0.4087202,0.8090748", "l0.4099605,0.8084077", "l0.4102576,0.8097594", "l0.4110844,0.8087061", "l0.4113557,0.8074071", "l0.4109165,0.8060905", "l0.4103480,0.8058447", "l0.4104126,0.8042297", "l0.4114074,0.8025445", "l0.4121180,0.7967339", "l0.4118983,0.7920468", "l0.4114333,0.7907478", "l0.4117433,0.7894838", "l0.4113428,0.7872193", "l0.4118467,0.7860431", "l0.4108131,0.7846388", "l0.4105806,0.7820407", "l0.4113170,0.7794777", "l0.4105677,0.7757561", "l0.4108519,0.7732809", "l0.4102447,0.7720872", "l0.4091207,0.7724208", "l0.4084489,0.7709988", "l0.4079968,0.7715781", "l0.4070020,0.7701913", "l0.4063560,0.7702264", "l0.4062010,0.7730001", "l0.4054517,0.7741762", "l0.4048057,0.7742464", "l0.4041081,0.7712270", "l0.4029841,0.7691556", "l0.4031133,0.7667682", "l0.4020669,0.7660133", "l0.4027516,0.7647143", "l0.4016276,0.7632397", "l0.4019893,0.7601325", "l0.4016147,0.7587808", "l0.4016147,0.7587808", "l0.4022348,0.7581840", "l0.4020927,0.7572711", "l0.4037076,0.7563232", "l0.4026870,0.7535671", "l0.4040177,0.7525665", "l0.4052321,0.7551295", "l0.4059684,0.7597990", "l0.4083327,0.7579206", "l0.4095600,0.7583946", "l0.4109165,0.7566918", "l0.4110198,0.7548135", "l0.4116658,0.7539884", "l0.4105031,0.7505828", "l0.4095212,0.7498104", "l0.4090432,0.7455973", "l0.4106064,0.7439998", "l0.4096762,0.7379786", "l0.4108906,0.7381366", "l0.4120792,0.7372764", "l0.4130998,0.7421215", "l0.4141334,0.7422970", "l0.4150635,0.7416475", "l0.4152444,0.7405591", "l0.4143142,0.7397341", "l0.4144047,0.7379084", "l0.4160066,0.7359598", "l0.4150894,0.7326244", "l0.4154124,0.7321505", "l0.4160454,0.7324665", "c"]}, {"n": "Zhejiang", "u": "CN-33", "i": ["m0.7888923,0.7128053", "l0.7884789,0.7121909", "l0.7885047,0.7106812", "l0.7891119,0.7097683", "l0.7898483,0.7106987", "l0.7900034,0.7119802", "l0.7888923,0.7128053", "c", "m0.7915537,0.7121733", "l0.7921996,0.7117345", "l0.7938533,0.7121733", "l0.7958687,0.7138761", "l0.7966438,0.7114360", "l0.7928068,0.7079778", "l0.7907914,0.7081358", "l0.7903264,0.7072931", "l0.7900938,0.7078900", "l0.7907785,0.7092241", "l0.7907785,0.7105407", "l0.7915537,0.7121733", "c", "m0.7982587,0.7014299", "l0.7981424,0.7005697", "l0.7971993,0.6997271", "l0.7956620,0.6998324", "l0.7956878,0.7011666", "l0.7982587,0.7014299", "c", "m0.7977290,0.7061345", "l0.7978453,0.7052041", "l0.7966955,0.7051339", "l0.7955974,0.7059239", "l0.7972769,0.7056255", "l0.7977290,0.7061345", "c", "m0.7948610,0.7059941", "l0.7947318,0.7034487", "l0.7940212,0.7032731", "l0.7926518,0.7045020", "l0.7919542,0.7042913", "l0.7933882,0.7055377", "l0.7948610,0.7059941", "c", "m0.7931298,0.7172642", "l0.7922771,0.7176504", "l0.7919025,0.7191952", "l0.7928973,0.7191074", "l0.7933494,0.7204942", "l0.7940600,0.7208102", "l0.7945122,0.7198096", "l0.7932590,0.7182121", "l0.7931298,0.7172642", "c", "m0.7965017,0.7135601", "l0.7977549,0.7161933", "l0.7980133,0.7133495", "l0.7967988,0.7130335", "l0.7965017,0.7135601", "c", "m0.7947318,0.7162284", "l0.7962562,0.7178610", "l0.7960108,0.7160880", "l0.7947318,0.7162284", "c", "m0.7791513,0.7577451", "l0.7786862,0.7570078", "l0.7781565,0.7581840", "l0.7769550,0.7590617", "l0.7773297,0.7615544", "l0.7795905,0.7602378", "l0.7790350,0.7589213", "l0.7791513,0.7577451", "c", "m0.7907139,0.7304126", "l0.7910886,0.7302370", "l0.7911273,0.7307285", "l0.7900938,0.7324665", "l0.7880397,0.7333968", "l0.7876004,0.7324138", "l0.7882593,0.7287800", "l0.7879751,0.7278145", "l0.7873549,0.7283587", "l0.7876262,0.7306408", "l0.7872128,0.7327122", "l0.7859726,0.7330633", "l0.7850295,0.7326244", "l0.7845256,0.7310445", "l0.7843319,0.7313254", "l0.7835825,0.7317818", "l0.7834017,0.7326069", "l0.7846807,0.7338533", "l0.7823552,0.7334671", "l0.7822906,0.7347486", "l0.7854042,0.7347134", "l0.7852362,0.7360300", "l0.7864248,0.7370307", "l0.7856625,0.7379084", "l0.7867090,0.7386106", "l0.7852750,0.7397165", "l0.7839055,0.7385755", "l0.7831950,0.7387159", "l0.7838409,0.7397867", "l0.7853396,0.7403485", "l0.7852491,0.7411384", "l0.7858822,0.7417704", "l0.7855333,0.7423673", "l0.7859468,0.7427359", "l0.7854429,0.7427710", "l0.7849261,0.7448425", "l0.7822648,0.7453515", "l0.7831562,0.7458255", "l0.7838668,0.7490380", "l0.7845127,0.7495295", "l0.7846290,0.7489327", "l0.7850037,0.7491082", "l0.7841898,0.7515308", "l0.7849132,0.7537953", "l0.7846936,0.7543571", "l0.7857659,0.7537426", "l0.7852879,0.7554103", "l0.7843965,0.7563056", "l0.7843706,0.7547433", "l0.7823940,0.7542517", "l0.7821744,0.7551295", "l0.7816447,0.7549012", "l0.7820323,0.7558843", "l0.7808049,0.7569025", "l0.7812571,0.7579382", "l0.7804044,0.7589739", "l0.7794097,0.7576398", "l0.7793063,0.7564285", "l0.7785570,0.7559194", "l0.7778723,0.7527596", "l0.7768129,0.7554630", "l0.7770325,0.7563583", "l0.7764512,0.7583068", "l0.7752109,0.7589388", "l0.7742937,0.7628886", "l0.7717357,0.7627306", "l0.7701854,0.7615193", "l0.7706505,0.7628535", "l0.7727046,0.7641525", "l0.7726529,0.7658378", "l0.7695653,0.7701913", "l0.7692940,0.7720697", "l0.7683638,0.7726665", "l0.7687772,0.7749135", "l0.7697720,0.7755104", "l0.7689451,0.7767743", "l0.7690873,0.7783191", "l0.7674207,0.7773536", "l0.7676920,0.7779680", "l0.7668652,0.7790388", "l0.7675628,0.7794777", "l0.7675111,0.7803379", "l0.7669814,0.7805310", "l0.7673690,0.7812683", "l0.7669943,0.7825322", "l0.7662580,0.7833397", "l0.7657929,0.7819353", "l0.7655732,0.7829886", "l0.7650565,0.7813209", "l0.7654182,0.7808821", "l0.7642684,0.7787931", "l0.7642684,0.7787931", "l0.7641780,0.7775818", "l0.7629894,0.7775818", "l0.7629894,0.7775818", "l0.7624985,0.7766163", "l0.7607156,0.7769323", "l0.7590361,0.7788633", "l0.7585194,0.7779153", "l0.7585194,0.7779153", "l0.7574858,0.7789160", "l0.7574858,0.7789160", "l0.7574858,0.7795304", "l0.7564136,0.7798288", "l0.7560260,0.7793373", "l0.7557934,0.7798815", "l0.7557934,0.7798815", "l0.7546824,0.7797410", "l0.7546824,0.7797410", "l0.7548762,0.7791968", "l0.7548762,0.7791968", "l0.7533130,0.7764934", "l0.7536489,0.7747731", "l0.7536489,0.7747731", "l0.7523957,0.7726314", "l0.7525249,0.7707004", "l0.7511813,0.7705600", "l0.7508842,0.7713499", "l0.7501607,0.7710339", "l0.7494631,0.7746151", "l0.7482357,0.7740884", "l0.7460782,0.7769147", "l0.7442308,0.7765987", "l0.7441145,0.7753699", "l0.7430293,0.7756859", "l0.7422671,0.7750364", "l0.7414403,0.7759317", "l0.7414403,0.7759317", "l0.7407168,0.7759843", "l0.7401483,0.7745449", "l0.7401483,0.7745449", "l0.7397866,0.7743869", "l0.7406005,0.7731229", "l0.7400062,0.7702615", "l0.7403809,0.7696120", "l0.7390760,0.7647494", "l0.7376420,0.7630817", "l0.7374612,0.7611331", "l0.7387789,0.7594654", "l0.7388306,0.7583595", "l0.7382751,0.7579909", "l0.7388693,0.7563758", "l0.7381717,0.7562003", "l0.7373320,0.7547257", "l0.7356783,0.7561125", "l0.7351874,0.7552348", "l0.7339213,0.7554805", "l0.7337663,0.7564987", "l0.7327715,0.7552172", "l0.7327715,0.7552172", "l0.7337017,0.7541288", "l0.7330170,0.7522856", "l0.7334821,0.7506706", "l0.7326552,0.7500737", "l0.7329136,0.7456149", "l0.7320480,0.7427535", "l0.7307044,0.7415422", "l0.7300714,0.7393128", "l0.7290249,0.7396287", "l0.7293738,0.7388212", "l0.7288053,0.7378557", "l0.7274230,0.7375748", "l0.7265057,0.7349241", "l0.7263119,0.7328878", "l0.7270612,0.7316238", "l0.7270483,0.7299737", "l0.7285599,0.7298333", "l0.7292316,0.7284289", "l0.7289474,0.7273932", "l0.7289474,0.7273932", "l0.7297743,0.7263926", "l0.7307949,0.7266383", "l0.7309370,0.7248302", "l0.7323322,0.7252515", "l0.7326294,0.7244791", "l0.7337017,0.7244791", "l0.7347740,0.7218459", "l0.7364018,0.7209155", "l0.7378616,0.7187914", "l0.7381200,0.7159827", "l0.7392828,0.7149996", "l0.7395024,0.7136128", "l0.7403809,0.7133144", "l0.7404842,0.7113834", "l0.7399545,0.7093119", "l0.7403809,0.7081007", "l0.7396445,0.7079251", "l0.7408589,0.7065910", "l0.7403550,0.7060819", "l0.7401871,0.7038875", "l0.7413757,0.7027641", "l0.7428355,0.7041333", "l0.7435332,0.7036418", "l0.7458198,0.7045195", "l0.7461945,0.7032205", "l0.7474089,0.7024481", "l0.7479903,0.7029923", "l0.7486104,0.7025710", "l0.7477836,0.7013246", "l0.7474089,0.6984105", "l0.7465433,0.6988845", "l0.7460395,0.6982525", "l0.7464400,0.6971641", "l0.7460266,0.6962513", "l0.7472151,0.6960757", "l0.7483520,0.6944432", "l0.7488300,0.6954613", "l0.7493080,0.6953560", "l0.7500444,0.6938112", "l0.7500573,0.6920206", "l0.7507291,0.6920733", "l0.7514526,0.6905812", "l0.7512717,0.6885799", "l0.7523828,0.6859994", "l0.7524732,0.6828396", "l0.7524732,0.6828396", "l0.7530546,0.6821198", "l0.7548891,0.6817161", "l0.7551346,0.6821900", "l0.7570078,0.6819092", "l0.7583644,0.6857361", "l0.7609611,0.6880533", "l0.7629636,0.6882113", "l0.7645010,0.6875793", "l0.7643588,0.6892646", "l0.7652503,0.6890363", "l0.7652503,0.6890363", "l0.7655086,0.6883517", "l0.7655086,0.6883517", "l0.7658833,0.6910902", "l0.7667747,0.6924244", "l0.7679891,0.6900545", "l0.7690614,0.6900896", "l0.7700045,0.6889837", "l0.7696428,0.6876144", "l0.7699399,0.6871229", "l0.7705600,0.6873160", "l0.7718907,0.6862276", "l0.7721879,0.6868420", "l0.7731051,0.6861223", "l0.7731051,0.6861223", "l0.7741257,0.6857536", "l0.7747329,0.6863856", "l0.7745133,0.6890188", "l0.7750042,0.6896683", "l0.7745650,0.6908796", "l0.7764512,0.6902652", "l0.7768775,0.6919855", "l0.7782599,0.6919680", "l0.7789962,0.6929510", "l0.7791384,0.6943729", "l0.7791384,0.6943729", "l0.7775493,0.6954438", "l0.7769292,0.6965497", "l0.7746296,0.6977434", "l0.7737382,0.6997622", "l0.7741903,0.7008682", "l0.7732860,0.7015352", "l0.7733118,0.7024832", "l0.7709218,0.7037998", "l0.7703663,0.7022725", "l0.7690227,0.7016581", "l0.7697203,0.7052393", "l0.7704050,0.7062223", "l0.7717228,0.7062223", "l0.7726400,0.7079778", "l0.7776785,0.7036067", "l0.7802106,0.7035365", "l0.7818126,0.7046424", "l0.7831175,0.7066436", "l0.7859726,0.7124191", "l0.7878200,0.7127877", "l0.7897967,0.7140166", "l0.7900421,0.7147187", "l0.7932590,0.7143852", "l0.7934011,0.7150172", "l0.7908948,0.7166322", "l0.7896287,0.7182648", "l0.7889440,0.7181946", "l0.7887502,0.7196867", "l0.7874971,0.7207926", "l0.7862439,0.7231450", "l0.7841252,0.7234609", "l0.7833371,0.7242509", "l0.7832079,0.7233732", "l0.7827816,0.7235487", "l0.7817480,0.7253217", "l0.7821098,0.7268490", "l0.7831433,0.7249355", "l0.7833242,0.7257781", "l0.7827816,0.7275687", "l0.7840347,0.7253217", "l0.7865669,0.7236365", "l0.7878846,0.7252691", "l0.7883368,0.7235136", "l0.7869803,0.7236540", "l0.7869286,0.7231976", "l0.7877296,0.7220215", "l0.7897321,0.7210208", "l0.7910369,0.7221092", "l0.7898613,0.7236716", "l0.7908690,0.7257606", "l0.7897967,0.7266910", "l0.7901196,0.7272878", "l0.7897192,0.7285693", "l0.7903393,0.7287449", "l0.7897579,0.7289906", "l0.7895770,0.7297982", "l0.7907139,0.7304126", "c", "m0.7890086,0.7337304", "l0.7875746,0.7337128", "l0.7876133,0.7344677", "l0.7884402,0.7349592", "l0.7896416,0.7345028", "l0.7900034,0.7359247", "l0.7903780,0.7358896", "l0.7908819,0.7351348", "l0.7902359,0.7326596", "l0.7890086,0.7337304", "c"]}]} """;
}
