import 'package:flutter/material.dart';

class SMapColombiaColors {
  /// Amazonas
  final Color? coAMA;

  /// Antioquia
  final Color? coANT;

  /// Arauca
  final Color? coARA;

  /// Atlántico
  final Color? coATL;

  /// Bolívar
  final Color? coBOL;

  /// Boyacá
  final Color? coBOY;

  /// Cauca
  final Color? coCAU;

  /// Cesar
  final Color? coCES;

  /// Chocó
  final Color? coCHO;

  /// Caldas
  final Color? coCAL;

  /// Córdoba
  final Color? coCOR;

  /// Caquetá
  final Color? coCAQ;

  /// Casanare
  final Color? coCAS;

  /// Cundinamarca
  final Color? coCUN;

  /// Distrito Capital de Bogotá
  final Color? coDC;

  /// Guainía
  final Color? coGUA;

  /// Guaviar
  final Color? coGUV;

  /// Huila
  final Color? coHUI;

  /// La Guajira
  final Color? coLAG;

  /// Magdalena
  final Color? coMAG;

  /// Meta
  final Color? coMET;

  /// Nariño
  final Color? coNAR;

  /// Norte de Santander
  final Color? coNSA;

  /// Putumayo
  final Color? coPUT;

  /// Quindío
  final Color? coQUI;

  /// Risaralda
  final Color? coRIS;

  /// Santander
  final Color? coSAN;

  /// Sucre
  final Color? coSUC;

  /// San Andrés, Providencia y Santa Catalina
  final Color? coSAP;

  /// Tolima
  final Color? coTOL;

  /// Valle del Cauca
  final Color? coVAC;

  /// Vichada
  final Color? coVID;

  /// Vaupés
  final Color? coVAU;
  SMapColombiaColors({
    this.coAMA,
    this.coANT,
    this.coARA,
    this.coATL,
    this.coBOL,
    this.coBOY,
    this.coCAU,
    this.coCES,
    this.coCHO,
    this.coCAL,
    this.coCOR,
    this.coCAQ,
    this.coCAS,
    this.coCUN,
    this.coDC,
    this.coGUA,
    this.coGUV,
    this.coHUI,
    this.coLAG,
    this.coMAG,
    this.coMET,
    this.coNAR,
    this.coNSA,
    this.coPUT,
    this.coQUI,
    this.coRIS,
    this.coSAN,
    this.coSUC,
    this.coSAP,
    this.coTOL,
    this.coVAC,
    this.coVID,
    this.coVAU,
  });
  Map<String, Color?> toMap() {
    return {
      "CO-AMA": coAMA,
      "CO-ANT": coANT,
      "CO-ARA": coARA,
      "CO-ATL": coATL,
      "CO-BOL": coBOL,
      "CO-BOY": coBOY,
      "CO-CAU": coCAU,
      "CO-CES": coCES,
      "CO-CHO": coCHO,
      "CO-CAL": coCAL,
      "CO-COR": coCOR,
      "CO-CAQ": coCAQ,
      "CO-CAS": coCAS,
      "CO-CUN": coCUN,
      "CO-DC": coDC,
      "CO-GUA": coGUA,
      "CO-GUV": coGUV,
      "CO-HUI": coHUI,
      "CO-LAG": coLAG,
      "CO-MAG": coMAG,
      "CO-MET": coMET,
      "CO-NAR": coNAR,
      "CO-NSA": coNSA,
      "CO-PUT": coPUT,
      "CO-QUI": coQUI,
      "CO-RIS": coRIS,
      "CO-SAN": coSAN,
      "CO-SUC": coSUC,
      "CO-SAP": coSAP,
      "CO-TOL": coTOL,
      "CO-VAC": coVAC,
      "CO-VID": coVID,
      "CO-VAU": coVAU,
    };
  }

  static SMapColombiaColors fromMap(Map<String, Color?> map) {
    return SMapColombiaColors(
      coAMA: map["CO-AMA"],
      coANT: map["CO-ANT"],
      coARA: map["CO-ARA"],
      coATL: map["CO-ATL"],
      coBOL: map["CO-BOL"],
      coBOY: map["CO-BOY"],
      coCAU: map["CO-CAU"],
      coCES: map["CO-CES"],
      coCHO: map["CO-CHO"],
      coCAL: map["CO-CAL"],
      coCOR: map["CO-COR"],
      coCAQ: map["CO-CAQ"],
      coCAS: map["CO-CAS"],
      coCUN: map["CO-CUN"],
      coDC: map["CO-DC"],
      coGUA: map["CO-GUA"],
      coGUV: map["CO-GUV"],
      coHUI: map["CO-HUI"],
      coLAG: map["CO-LAG"],
      coMAG: map["CO-MAG"],
      coMET: map["CO-MET"],
      coNAR: map["CO-NAR"],
      coNSA: map["CO-NSA"],
      coPUT: map["CO-PUT"],
      coQUI: map["CO-QUI"],
      coRIS: map["CO-RIS"],
      coSAN: map["CO-SAN"],
      coSUC: map["CO-SUC"],
      coSAP: map["CO-SAP"],
      coTOL: map["CO-TOL"],
      coVAC: map["CO-VAC"],
      coVID: map["CO-VID"],
      coVAU: map["CO-VAU"],
    );
  }
}

class SMapColombia {
  static const String instructions =
      """{"n": "Colombia", "w": 612.82184, "h": 693.68036, "g": {"a": "-81.721283,12.590653","b": "-66.868938,-4.237159"}, "i":[{"n": "Amazonas", "u": "CO-AMA", "i": ["m0.4946952,0.7836450", "l0.4969960,0.7831405", "l0.4983341,0.7827512", "l0.5070479,0.7799690", "l0.5177198,0.7767687", "l0.5259767,0.7743468", "l0.5306599,0.7731070", "l0.5362244,0.7733953", "l0.5398633,0.7733377", "l0.5413808,0.7740296", "l0.5459499,0.7765668", "l0.5489034,0.7804879", "l0.5550390,0.7811078", "l0.5616641,0.7809493", "l0.5659394,0.7809204", "l0.5705084,0.7839766", "l0.5717486,0.7847839", "l0.5741636,0.7857642", "l0.5816862,0.7852163", "l0.5827632,0.7835153", "l0.5833833,0.7822323", "l0.5854720,0.7803150", "l0.5879196,0.7803150", "l0.5894372,0.7811078", "l0.5911016,0.7828954", "l0.5919339,0.7843946", "l0.5937941,0.7848415", "l0.5955891,0.7849136", "l0.5976451,0.7848415", "l0.5993096,0.7844091", "l0.6013004,0.7826215", "l0.6046456,0.7822034", "l0.6066527,0.7843370", "l0.6091656,0.7868742", "l0.6151543,0.7900457", "l0.6171451,0.7901466", "l0.6183853,0.7880419", "l0.6239334,0.7828377", "l0.6266748,0.7826503", "l0.6274581,0.7846685", "l0.6324677,0.7868165", "l0.6339363,0.7868165", "l0.6355844,0.7861245", "l0.6377057,0.7845532", "l0.6374936,0.7812087", "l0.6379668,0.7799978", "l0.6391743,0.7771291", "l0.6403003,0.7751108", "l0.6410999,0.7740152", "l0.6424706,0.7726745", "l0.6514618,0.7650197", "l0.6532241,0.7642845", "l0.6550680,0.7642557", "l0.6568956,0.7645873", "l0.6608120,0.7655243", "l0.6637492,0.7656829", "l0.6662458,0.7640827", "l0.6675513,0.7623528", "l0.6684651,0.7609545", "l0.6690852,0.7598156", "l0.6699337,0.7583596", "l0.6706843,0.7571487", "l0.6718919,0.7557503", "l0.6775052,0.7516851", "l0.6841793,0.7454286", "l0.6868065,0.7426896", "l0.6876224,0.7409885", "l0.6872634,0.7386243", "l0.6885035,0.7377305", "l0.6934642,0.7379323", "l0.6965483,0.7392730", "l0.6981474,0.7403542", "l0.7120503,0.7478216", "l0.7187570,0.7496957", "l0.7213353,0.7487586", "l0.7247294,0.7519301", "l0.7264265,0.7547556", "l0.7291842,0.7656829", "l0.7318277,0.7694886", "l0.7367394,0.7677299", "l0.7378817,0.7658126", "l0.7548687,0.7706563", "l0.7574958,0.7730494", "l0.7584749,0.7744045", "l0.7606289,0.7761920", "l0.7651163,0.7774894", "l0.7674988,0.7770137", "l0.7663239,0.7752694", "l0.7703381,0.7726025", "l0.7736343,0.7741306", "l0.7747929,0.7754568", "l0.7723452,0.7834432", "l0.7724431,0.7903916", "l0.7702728,0.7934478", "l0.7703707,0.7957111", "l0.7720678,0.7970085", "l0.7736180,0.7984213", "l0.7741728,0.8009585", "l0.7724105,0.8021694", "l0.7700933,0.8033659", "l0.7696527,0.8046489", "l0.7701749,0.8060617", "l0.7710071,0.8073014", "l0.7792803,0.8130966", "l0.7811569,0.8132264", "l0.7825276,0.8127074", "l0.7836535,0.8115974", "l0.7841757,0.8102279", "l0.7831966,0.8093485", "l0.7812548,0.8089160", "l0.7802920,0.8079646", "l0.7803899,0.8067536", "l0.7814506,0.8054851", "l0.7836699,0.8042165", "l0.7931832,0.8036542", "l0.7935096,0.8058454", "l0.7916820,0.8104297", "l0.7921552,0.8116406", "l0.7943744,0.8119722", "l0.7957125,0.8115397", "l0.8003631,0.8096368", "l0.8072656,0.8081664", "l0.8125690,0.8122173", "l0.8124710,0.8135291", "l0.8137438,0.8186323", "l0.8247095,0.8173349", "l0.8244811,0.8127795", "l0.8261292,0.8096224", "l0.8268472,0.8109919", "l0.8281526,0.8163546", "l0.8296212,0.8231012", "l0.8303882,0.8285216", "l0.8295559,0.8310876", "l0.8254112,0.8396218", "l0.8207116,0.8625430", "l0.8158978,0.8859832", "l0.8149840,0.8904233", "l0.8137602,0.8960887", "l0.8131238,0.8991737", "l0.8025171,0.9514601", "l0.7965447,0.9810991", "l0.7924163,0.9983693", "l0.7915025,0.9998253", "l0.7915188,0.9981963", "l0.7893648,0.9962213", "l0.7871782,0.9949095", "l0.7858565,0.9941310", "l0.7803247,0.9900946", "l0.7794435,0.9888116", "l0.7789050,0.9876871", "l0.7783502,0.9861590", "l0.7776648,0.9843282", "l0.7763757,0.9821082", "l0.7728347,0.9781871", "l0.7668787,0.9739344", "l0.7656222,0.9733866", "l0.7642352,0.9732568", "l0.7612653,0.9741218", "l0.7600904,0.9749291", "l0.7563536,0.9769329", "l0.7549176,0.9774807", "l0.7530900,0.9774807", "l0.7477377,0.9757220", "l0.7399051,0.9727811", "l0.7433971,0.9679374", "l0.7463996,0.9638721", "l0.7505444,0.9582211", "l0.7585239,0.9473371", "l0.7608737,0.9441080", "l0.7840615,0.9122345", "l0.7819728,0.9088612", "l0.7804878,0.9090486", "l0.7755109,0.9056465", "l0.7745481,0.9035994", "l0.7738791,0.9012929", "l0.7687389,0.8972132", "l0.7660301,0.8966942", "l0.7646757,0.8970258", "l0.7631908,0.8978331", "l0.7506423,0.8967519", "l0.7494348,0.8961897", "l0.7449147,0.8913027", "l0.7443762,0.8887655", "l0.7308323,0.8809233", "l0.7229344,0.8840515", "l0.7145470,0.8860265", "l0.7087052,0.8889096", "l0.6970215,0.8881024", "l0.6936274,0.8842245", "l0.6863659,0.8814566", "l0.6825638,0.8815864", "l0.6760040,0.8808944", "l0.6753349,0.8791934", "l0.6754002,0.8774490", "l0.6747312,0.8763390", "l0.6728057,0.8770021", "l0.6669801,0.8812404", "l0.6627538,0.8865310", "l0.6615136,0.8899188", "l0.6587069,0.8899908", "l0.6552965,0.8894286", "l0.6493894,0.8916919", "l0.6387990,0.8970690", "l0.6339526,0.8966365", "l0.6320597,0.8961320", "l0.6237865,0.8936813", "l0.6144037,0.8916631", "l0.6081376,0.8935948", "l0.5993096,0.8965500", "l0.5947895,0.8975159", "l0.5934025,0.8944021", "l0.5912485,0.8912306", "l0.5885234,0.8913315", "l0.5866468,0.8918505", "l0.5818820,0.8895439", "l0.5798096,0.8881024", "l0.5790916,0.8870212", "l0.5779820,0.8821486", "l0.5800381,0.8813125", "l0.5816209,0.8794384", "l0.5829264,0.8762093", "l0.5807724,0.8631052", "l0.5779167,0.8587084", "l0.5735925,0.8561856", "l0.5707858,0.8584922", "l0.5668858,0.8601500", "l0.5588410,0.8567767", "l0.5538641,0.8538503", "l0.5527218,0.8527547", "l0.5540925,0.8472046", "l0.5547779,0.8461522", "l0.5567850,0.8445953", "l0.5547779,0.8411931", "l0.5518733,0.8377045", "l0.5503394,0.8362053", "l0.5500294,0.8343456", "l0.5494745,0.8307272", "l0.5428984,0.8253645", "l0.5389005,0.8250474", "l0.5362570,0.8256817", "l0.5302846,0.8242257", "l0.5284733,0.8208812", "l0.5143583,0.8128660", "l0.5051060,0.8106315", "l0.5034090,0.8093341", "l0.5024299,0.8077916", "l0.5005859,0.8044615", "l0.5018261,0.8026019", "l0.5029357,0.7999349", "l0.5000801,0.7973401", "l0.4983341,0.7956823", "l0.4968002,0.7912422", "l0.4955111,0.7869174", "c"]}, {"n": "Antioquia", "u": "CO-ANT", "i": ["m0.4750973,0.4085155", "l0.4731555,0.4082272", "l0.4628425,0.4108797", "l0.4541777,0.4117446", "l0.4509957,0.4124078", "l0.4492986,0.4143683", "l0.4481400,0.4158243", "l0.4416292,0.4198463", "l0.4395568,0.4190102", "l0.4373049,0.4174821", "l0.4351020,0.4156802", "l0.4337313,0.4151756", "l0.4265024,0.4146855", "l0.4159773,0.4119320", "l0.4133991,0.4111968", "l0.4111799,0.4109085", "l0.4110820,0.4126096", "l0.4120774,0.4181164", "l0.4123548,0.4224556", "l0.4112125,0.4232052", "l0.4069535,0.4228304", "l0.4039347,0.4225709", "l0.4001652,0.4229890", "l0.3983376,0.4234071", "l0.3933443,0.4257424", "l0.3919736,0.4259010", "l0.3862460,0.4260163", "l0.3852833,0.4255262", "l0.3827377,0.4234359", "l0.3813180,0.4220231", "l0.3781686,0.4184480", "l0.3775812,0.4169776", "l0.3787887,0.4146134", "l0.3789682,0.4127970", "l0.3785766,0.4110959", "l0.3775486,0.4088759", "l0.3765368,0.4072325", "l0.3758352,0.4056755", "l0.3755414,0.4042484", "l0.3758352,0.4028356", "l0.3768632,0.4011057", "l0.3772059,0.3965647", "l0.3733385,0.3958872", "l0.3719678,0.3954835", "l0.3707603,0.3945321", "l0.3697649,0.3921535", "l0.3695201,0.3903515", "l0.3694385,0.3884486", "l0.3690959,0.3843401", "l0.3681168,0.3833310", "l0.3650490,0.3818750", "l0.3634825,0.3816731", "l0.3478662,0.3841094", "l0.3459244,0.3846428", "l0.3444557,0.3848014", "l0.3374064,0.3845275", "l0.3318746,0.3776655", "l0.3314014,0.3762816", "l0.3314177,0.3747103", "l0.3314014,0.3698521", "l0.3309445,0.3676177", "l0.3249558,0.3564165", "l0.3235198,0.3552344", "l0.3200930,0.3533027", "l0.3194566,0.3454893", "l0.3231608,0.3443937", "l0.3257227,0.3445523", "l0.3281378,0.3453163", "l0.3312871,0.3429954", "l0.3314177,0.3408186", "l0.3305855,0.3387860", "l0.3293616,0.3363064", "l0.3304549,0.3348504", "l0.3400173,0.3345333", "l0.3448147,0.3353982", "l0.3470992,0.3364073", "l0.3484536,0.3367389", "l0.3497101,0.3361334", "l0.3516193,0.3260135", "l0.3509503,0.3236205", "l0.3500365,0.3216599", "l0.3490574,0.3203481", "l0.3456796,0.3162972", "l0.3431503,0.3156773", "l0.3416817,0.3150142", "l0.3376022,0.3121310", "l0.3252332,0.3010020", "l0.3237972,0.2996757", "l0.3224755,0.2984215", "l0.3184286,0.2943707", "l0.3163236,0.2920641", "l0.3113303,0.2910839", "l0.3104002,0.2856058", "l0.3128479,0.2849571", "l0.3143981,0.2841066", "l0.3158504,0.2827227", "l0.3168294,0.2805170", "l0.3172048,0.2784123", "l0.3179227,0.2752697", "l0.3187876,0.2741885", "l0.3226223,0.2717954", "l0.3244173,0.2713053", "l0.3266855,0.2707143", "l0.3286926,0.2679320", "l0.3290026,0.2681771", "l0.3291005,0.2707287", "l0.3288231,0.2743038", "l0.3265549,0.2738137", "l0.3250374,0.2730929", "l0.3234382,0.2740011", "l0.3227202,0.2767401", "l0.3229650,0.2796953", "l0.3264570,0.2812811", "l0.3301612,0.2815406", "l0.3341265,0.2806900", "l0.3350240,0.2797097", "l0.3358725,0.2735398", "l0.3353993,0.2704836", "l0.3344365,0.2641118", "l0.3336206,0.2555632", "l0.3330495,0.2513538", "l0.3298185,0.2471155", "l0.3261307,0.2447801", "l0.3226713,0.2438431", "l0.3226549,0.2419834", "l0.3255922,0.2387687", "l0.3300796,0.2380623", "l0.3397725,0.2355107", "l0.3560089,0.2235744", "l0.3564005,0.2217868", "l0.3575427,0.2225797", "l0.3582281,0.2236320", "l0.3587013,0.2247997", "l0.3588319,0.2260107", "l0.3588645,0.2281730", "l0.3590603,0.2297444", "l0.3594193,0.2315896", "l0.3603331,0.2345016", "l0.3612796,0.2360441", "l0.3622423,0.2371397", "l0.3635314,0.2382065", "l0.3650490,0.2390426", "l0.3670072,0.2399364", "l0.3687532,0.2405419", "l0.3711519,0.2416086", "l0.3721473,0.2426610", "l0.3724574,0.2441747", "l0.3724084,0.2467263", "l0.3722942,0.2486724", "l0.3719678,0.2506474", "l0.3714130,0.2522043", "l0.3703850,0.2537612", "l0.3691611,0.2550154", "l0.3672193,0.2567165", "l0.3658975,0.2575382", "l0.3626992,0.2604213", "l0.3610185,0.2621368", "l0.3594030,0.2651065", "l0.3586360,0.2671535", "l0.3581302,0.2692006", "l0.3575427,0.2723144", "l0.3573143,0.2739434", "l0.3571674,0.2769419", "l0.3564005,0.2792629", "l0.3538386,0.2815117", "l0.3522394,0.2828957", "l0.3509666,0.2848130", "l0.3503465,0.2909685", "l0.3503139,0.2930733", "l0.3504118,0.2944139", "l0.3509503,0.2975278", "l0.3515051,0.2996757", "l0.3520599,0.3013335", "l0.3530553,0.3029481", "l0.3556009,0.3063935", "l0.3619323,0.3136591", "l0.3642331,0.3139907", "l0.3662402,0.3139186", "l0.3677251,0.3137744", "l0.3723268,0.3136159", "l0.3854628,0.3135438", "l0.3887427,0.3135870", "l0.3936217,0.3138033", "l0.3957104,0.3133420", "l0.4069861,0.3009876", "l0.4078510,0.2965763", "l0.4098092,0.2936355", "l0.4106414,0.2925831", "l0.4123548,0.2911127", "l0.4144435,0.2907811", "l0.4159121,0.2914731", "l0.4180171,0.2931165", "l0.4194367,0.2935201", "l0.4205627,0.2926264", "l0.4212644,0.2898009", "l0.4226188,0.2864708", "l0.4242669,0.2859662", "l0.4264861,0.2853175", "l0.4282811,0.2845679", "l0.4297987,0.2827227", "l0.4302719,0.2815406", "l0.4310551,0.2798539", "l0.4385124,0.2735830", "l0.4403727,0.2731505", "l0.4443706,0.2732947", "l0.4479116,0.2735398", "l0.4517300,0.2735398", "l0.4535739,0.2734677", "l0.4552383,0.2730496", "l0.4566254,0.2724586", "l0.4579634,0.2715648", "l0.4590078,0.2704692", "l0.4597911,0.2694168", "l0.4618961,0.2667499", "l0.4639521,0.2648037", "l0.4673463,0.2673554", "l0.4709852,0.2700655", "l0.4722906,0.2709161", "l0.4750647,0.2725307", "l0.4785893,0.2743903", "l0.4804006,0.2753994", "l0.4817224,0.2762932", "l0.4832889,0.2778069", "l0.4838927,0.2789313", "l0.4842354,0.2803873", "l0.4842680,0.2816703", "l0.4842354,0.2861248", "l0.4845454,0.2889936", "l0.4859814,0.2905505", "l0.4844149,0.2971241", "l0.4799111,0.3070566", "l0.4799111,0.3084550", "l0.4805964,0.3095362", "l0.4815918,0.3105885", "l0.4870257,0.3155187", "l0.4905830,0.3130825", "l0.4914153,0.3119148", "l0.4929655,0.3091037", "l0.4944014,0.3074459", "l0.4957232,0.3066818", "l0.4969960,0.3071576", "l0.4978282,0.3086568", "l0.4980077,0.3107327", "l0.4972244,0.3118860", "l0.4957069,0.3134717", "l0.4944178,0.3156197", "l0.4940751,0.3170612", "l0.4936345,0.3227555", "l0.4938466,0.3244998", "l0.4977466,0.3347495", "l0.5001290,0.3350667", "l0.5021035,0.3350378", "l0.5046654,0.3344756", "l0.5117801,0.3290408", "l0.5138361,0.3273830", "l0.5169855,0.3246296", "l0.5207713,0.3212707", "l0.5244265,0.3180271", "l0.5240675,0.3191083", "l0.5237248,0.3208670", "l0.5237411,0.3220924", "l0.5245407,0.3283777", "l0.5254056,0.3298769", "l0.5266620,0.3312176", "l0.5274127,0.3335818", "l0.5272984,0.3350955", "l0.5242633,0.3375462", "l0.5212118,0.3387571", "l0.5189273,0.3398383", "l0.5154679,0.3431107", "l0.5137056,0.3457056", "l0.5124328,0.3476661", "l0.5113884,0.3485743", "l0.5093161,0.3500303", "l0.5013692,0.3554939", "l0.4969470,0.3573103", "l0.4948257,0.3573680", "l0.4923943,0.3600349", "l0.4917579,0.3620676", "l0.4922964,0.3671564", "l0.4940098,0.3696503", "l0.4934387,0.3708901", "l0.4870910,0.3771321", "l0.4855082,0.3781701", "l0.4828320,0.3791792", "l0.4820161,0.3800009", "l0.4810207,0.3811830", "l0.4791931,0.3861421", "l0.4791931,0.3886216", "l0.4794705,0.3959881", "l0.4783283,0.3970116", "l0.4760274,0.4042772", "c"]}, {"n": "Arauca", "u": "CO-ARA", "i": ["m0.7991393,0.3927157", "l0.7950271,0.3904956", "l0.7838493,0.3825525", "l0.7798025,0.3793234", "l0.7745155,0.3772619", "l0.7625544,0.3770601", "l0.7590950,0.3780259", "l0.7555377,0.3798135", "l0.7542649,0.3803180", "l0.7524699,0.3809668", "l0.7426139,0.3815434", "l0.7385181,0.3815434", "l0.7292331,0.3812839", "l0.7246968,0.3810533", "l0.7221022,0.3808082", "l0.7084930,0.3781845", "l0.7066001,0.3775214", "l0.7028633,0.3783719", "l0.7006930,0.3791504", "l0.6989470,0.3800586", "l0.6878345,0.3828697", "l0.6864801,0.3829706", "l0.6814052,0.3829562", "l0.6794797,0.3816155", "l0.6704885,0.3820480", "l0.6559329,0.3847437", "l0.6534036,0.3863150", "l0.6521798,0.3872665", "l0.6473007,0.3898613", "l0.6458973,0.3898181", "l0.6431722,0.3893135", "l0.6374610,0.3870358", "l0.6320108,0.3806929", "l0.6314070,0.3785881", "l0.6312765,0.3771466", "l0.6316355,0.3745661", "l0.6372651,0.3689583", "l0.6439718,0.3659310", "l0.6456363,0.3646624", "l0.6461911,0.3628604", "l0.6463379,0.3612170", "l0.6501727,0.3533748", "l0.6532567,0.3485743", "l0.6537300,0.3473201", "l0.6539421,0.3461525", "l0.6542848,0.3441631", "l0.6544480,0.3422169", "l0.6549864,0.3404582", "l0.6559329,0.3389445", "l0.6590170,0.3348360", "l0.6623785,0.3362055", "l0.6653483,0.3361767", "l0.6672412,0.3352252", "l0.6741437,0.3326592", "l0.6779458,0.3318087", "l0.6808994,0.3319672", "l0.6841630,0.3327313", "l0.6885198,0.3336972", "l0.6901516,0.3340287", "l0.6989960,0.3340864", "l0.7036955,0.3361623", "l0.7091621,0.3375894", "l0.7196708,0.3363353", "l0.7209926,0.3358451", "l0.7233097,0.3349225", "l0.7275198,0.3325439", "l0.7289884,0.3309437", "l0.7309302,0.3305112", "l0.7334921,0.3302085", "l0.7401988,0.3295742", "l0.7514419,0.3319384", "l0.7588992,0.3347495", "l0.7626360,0.3364217", "l0.7643331,0.3375606", "l0.7654753,0.3382381", "l0.7668297,0.3386850", "l0.7687879,0.3390743", "l0.7709582,0.3386418", "l0.7722310,0.3377336", "l0.7736833,0.3369551", "l0.7779422,0.3364506", "l0.7805858,0.3368542", "l0.8071188,0.3659166", "l0.8269777,0.3877710", "l0.8243179,0.3896739", "l0.8224740,0.3904956", "l0.8189166,0.3915913", "l0.8162405,0.3917787", "l0.8123079,0.3918219", "l0.8084568,0.3914471", "l0.8042794,0.3910723", "l0.8022397,0.3913894", "l0.7999878,0.3922400", "c"]}, {"n": "Atlántico", "u": "CO-ATL", "i": ["m0.4359342,0.1083196", "l0.4373702,0.1080024", "l0.4496902,0.1019766", "l0.4502124,0.1001746", "l0.4507999,0.0983294", "l0.4576534,0.0921738", "l0.4612270,0.0891176", "l0.4617003,0.0887717", "l0.4616513,0.0891176", "l0.4629731,0.0920152", "l0.4651270,0.0932262", "l0.4667099,0.0945524", "l0.4675747,0.0958354", "l0.4711810,0.1017027", "l0.4713605,0.1099486", "l0.4712463,0.1138697", "l0.4708873,0.1200541", "l0.4702672,0.1226489", "l0.4671668,0.1244653", "l0.4657145,0.1256763", "l0.4645069,0.1270458", "l0.4608517,0.1344123", "l0.4580287,0.1404814", "l0.4528886,0.1366323", "l0.4448764,0.1323508", "l0.4366196,0.1270746", "l0.4360647,0.1245230", "l0.4365706,0.1225769", "l0.4369459,0.1210632", "l0.4370765,0.1193189", "l0.4366848,0.1173583", "l0.4354120,0.1139706", "l0.4371091,0.1126011", "l0.4365053,0.1106261", "l0.4354773,0.1115776", "l0.4356078,0.1095017", "c"]}, {"n": "Bolívar", "u": "CO-BOL", "i": ["m0.5338909,0.2666201", "l0.5320959,0.2675716", "l0.5295340,0.2696475", "l0.5285060,0.2718243", "l0.5281633,0.2731649", "l0.5281796,0.2751688", "l0.5282286,0.2769852", "l0.5302030,0.2828092", "l0.5314106,0.2850436", "l0.5324549,0.2896999", "l0.5311821,0.2993153", "l0.5283917,0.3032220", "l0.5256177,0.3088442", "l0.5244102,0.3180415", "l0.5207549,0.3212851", "l0.5169692,0.3246440", "l0.5138361,0.3273974", "l0.5117801,0.3290552", "l0.5046491,0.3345044", "l0.5020872,0.3350667", "l0.5001127,0.3350955", "l0.4977140,0.3347783", "l0.4938303,0.3245287", "l0.4936019,0.3227699", "l0.4940424,0.3170757", "l0.4943851,0.3156485", "l0.4956579,0.3134861", "l0.4971755,0.3119004", "l0.4979751,0.3107471", "l0.4977956,0.3086712", "l0.4969634,0.3071720", "l0.4956906,0.3067107", "l0.4943688,0.3074747", "l0.4929165,0.3091325", "l0.4913663,0.3119436", "l0.4905504,0.3130969", "l0.4869931,0.3155332", "l0.4815592,0.3106174", "l0.4805475,0.3095650", "l0.4798785,0.3084838", "l0.4798621,0.3070855", "l0.4843822,0.2971674", "l0.4859487,0.2905937", "l0.4845128,0.2890368", "l0.4842027,0.2861681", "l0.4842354,0.2817136", "l0.4842027,0.2804161", "l0.4838600,0.2789601", "l0.4832400,0.2778501", "l0.4816898,0.2763364", "l0.4803680,0.2754427", "l0.4785567,0.2744335", "l0.4750320,0.2725739", "l0.4722743,0.2709449", "l0.4709689,0.2700944", "l0.4673300,0.2673842", "l0.4639358,0.2648326", "l0.4668730,0.2636072", "l0.4679337,0.2625405", "l0.4685212,0.2604357", "l0.4690923,0.2600321", "l0.4709852,0.2594555", "l0.4734818,0.2590518", "l0.4767291,0.2586770", "l0.4782303,0.2570913", "l0.4809718,0.2522043", "l0.4827831,0.2478651", "l0.4818203,0.2464524", "l0.4808249,0.2437133", "l0.4802211,0.2414068", "l0.4802375,0.2306237", "l0.4827341,0.2287064", "l0.4791278,0.2215562", "l0.4769575,0.2185144", "l0.4750157,0.2169431", "l0.4711484,0.2145501", "l0.4693860,0.2136707", "l0.4680969,0.2131950", "l0.4667099,0.2127481", "l0.4627609,0.2105424", "l0.4599869,0.2075439", "l0.4577187,0.2035652", "l0.4566091,0.2012586", "l0.4563316,0.1995864", "l0.4565111,0.1981736", "l0.4570496,0.1949445", "l0.4569680,0.1933011", "l0.4567070,0.1919316", "l0.4556300,0.1905332", "l0.4539655,0.1887601", "l0.4527254,0.1875491", "l0.4353794,0.1749064", "l0.4302392,0.1716485", "l0.4303698,0.1703943", "l0.4301413,0.1660983", "l0.4295212,0.1645414", "l0.4265514,0.1634026", "l0.4203832,0.1566704", "l0.4171033,0.1499958", "l0.4142803,0.1506013", "l0.4131380,0.1510626", "l0.4138723,0.1483092", "l0.4164016,0.1454404", "l0.4165648,0.1421680", "l0.4155368,0.1313129", "l0.4196978,0.1295830", "l0.4195999,0.1269160", "l0.4184250,0.1233697", "l0.4203016,0.1208037", "l0.4248217,0.1168538", "l0.4329480,0.1129038", "l0.4347430,0.1130912", "l0.4353794,0.1139850", "l0.4366685,0.1173727", "l0.4370438,0.1193477", "l0.4369296,0.1210776", "l0.4365543,0.1225913", "l0.4360484,0.1245374", "l0.4366032,0.1270746", "l0.4448601,0.1323508", "l0.4528722,0.1366323", "l0.4580124,0.1404814", "l0.4557768,0.1469973", "l0.4564296,0.1488714", "l0.4595626,0.1501832", "l0.4620429,0.1507887", "l0.4656329,0.1552432", "l0.4651597,0.1575642", "l0.4630220,0.1586886", "l0.4610149,0.1594815", "l0.4603785,0.1610528", "l0.4605906,0.1647577", "l0.4607701,0.1660551", "l0.4639195,0.1752236", "l0.4645722,0.1762904", "l0.4662366,0.1826045", "l0.4654860,0.1867130", "l0.4653881,0.1895385", "l0.4693860,0.1910954", "l0.4708057,0.1909513", "l0.4722906,0.1907639", "l0.4765333,0.1933155", "l0.4811186,0.1976835", "l0.4878579,0.2001342", "l0.4901098,0.2001054", "l0.4963106,0.2025561", "l0.4991826,0.2041418", "l0.5042575,0.2081638", "l0.5059872,0.2106289", "l0.5096587,0.2138581", "l0.5191231,0.2165971", "l0.5245244,0.2175630", "l0.5279512,0.2176062", "l0.5275269,0.2216571", "l0.5286365,0.2237330", "l0.5303499,0.2251169", "l0.5312963,0.2326275", "l0.5308884,0.2373704", "l0.5328139,0.2408158", "l0.5336788,0.2420555", "l0.5353595,0.2471587", "l0.5360938,0.2529972", "l0.5357185,0.2595996", "l0.5338909,0.2666201", "c", "m0.4354773,0.1115776", "l0.4343024,0.1111595", "l0.4345798,0.1083917", "l0.4359342,0.1083052", "l0.4356078,0.1094728", "l0.4354773,0.1115776", "c"]}, {"n": "Boyacá", "u": "CO-BOY", "i": ["m0.6196744,0.3420439", "l0.6237865,0.3420439", "l0.6282576,0.3419142", "l0.6298568,0.3414529", "l0.6318313,0.3399104", "l0.6327940,0.3382958", "l0.6338710,0.3363208", "l0.6406266,0.3329187", "l0.6420137,0.3324718", "l0.6437597,0.3326160", "l0.6459953,0.3331493", "l0.6478718,0.3331926", "l0.6491773,0.3326592", "l0.6504827,0.3317222", "l0.6546111,0.3344468", "l0.6590170,0.3348360", "l0.6559329,0.3389445", "l0.6549864,0.3404582", "l0.6544480,0.3422169", "l0.6542848,0.3441631", "l0.6539421,0.3461525", "l0.6537300,0.3473201", "l0.6532567,0.3485743", "l0.6501727,0.3533748", "l0.6463379,0.3612170", "l0.6461911,0.3628604", "l0.6456363,0.3646624", "l0.6439718,0.3659310", "l0.6372651,0.3689583", "l0.6316355,0.3745661", "l0.6310970,0.3748977", "l0.6291062,0.3766276", "l0.6280781,0.3781268", "l0.6275886,0.3796549", "l0.6274254,0.3813272", "l0.6270338,0.3888234", "l0.6304116,0.3920381", "l0.6285187,0.3991163", "l0.6275886,0.4000101", "l0.6264790,0.4040610", "l0.6337731,0.4068288", "l0.6369388,0.4116005", "l0.6370204,0.4129844", "l0.6340505,0.4193850", "l0.6286493,0.4213600", "l0.6273928,0.4206825", "l0.6260058,0.4211582", "l0.6249777,0.4220231", "l0.6237212,0.4235800", "l0.6224974,0.4251946", "l0.6206861,0.4274723", "l0.6194623,0.4287842", "l0.6106832,0.4343919", "l0.6041234,0.4351848", "l0.6020673,0.4331378", "l0.5986895,0.4309466", "l0.5902042,0.4402736", "l0.5883766,0.4448002", "l0.5890456,0.4459967", "l0.5924560,0.4487357", "l0.5931740,0.4500764", "l0.5929456,0.4512441", "l0.5910364,0.4531326", "l0.5889966,0.4541561", "l0.5867121,0.4546030", "l0.5849824,0.4558716", "l0.5838075,0.4575871", "l0.5816209,0.4640310", "l0.5812130,0.4655302", "l0.5814251,0.4667267", "l0.5835628,0.4698982", "l0.5807234,0.4741076", "l0.5778025,0.4744392", "l0.5744084,0.4739347", "l0.5728908,0.4731994", "l0.5719607,0.4720750", "l0.5698067,0.4696531", "l0.5656293,0.4670583", "l0.5640465,0.4663807", "l0.5626595,0.4659627", "l0.5606197,0.4652707", "l0.5590042,0.4646653", "l0.5569971,0.4635552", "l0.5530645,0.4612487", "l0.5508126,0.4593458", "l0.5503068,0.4576447", "l0.5514653,0.4537236", "l0.5525260,0.4522244", "l0.5549737,0.4499178", "l0.5538151,0.4440506", "l0.5525097,0.4417152", "l0.5512369,0.4396826", "l0.5483160,0.4314799", "l0.5436653,0.4265785", "l0.5389168,0.4254974", "l0.5336788,0.4209275", "l0.5308884,0.4214753", "l0.5276411,0.4234936", "l0.5267273,0.4256415", "l0.5266131,0.4273714", "l0.5236759,0.4301104", "l0.5222888,0.4312781", "l0.5210323,0.4318259", "l0.5187152,0.4326332", "l0.5171324,0.4325323", "l0.5084022,0.4267804", "l0.5038985,0.4253964", "l0.4982035,0.4189814", "l0.4975182,0.4167758", "l0.4994111,0.4148585", "l0.5006839,0.4133592", "l0.4995742,0.4076794", "l0.4978119,0.4058918", "l0.4951031,0.4077082", "l0.4913010,0.4093083", "l0.4887391,0.4089335", "l0.4857529,0.4081407", "l0.4775613,0.4096687", "l0.4763538,0.4105481", "l0.4763211,0.4096976", "l0.4750973,0.4085155", "l0.4760274,0.4042772", "l0.4783283,0.3970116", "l0.4794705,0.3959881", "l0.4791931,0.3886216", "l0.4791931,0.3861421", "l0.4810207,0.3811830", "l0.4820161,0.3800009", "l0.4828320,0.3791792", "l0.4851002,0.3815290", "l0.4886412,0.3865889", "l0.4912358,0.3900199", "l0.4935529,0.3918940", "l0.4954621,0.3923841", "l0.4967349,0.3918940", "l0.4979588,0.3913029", "l0.4997211,0.3908272", "l0.5014345,0.3913750", "l0.5045349,0.3972134", "l0.5106052,0.4021869", "l0.5178993,0.4057909", "l0.5190252,0.4067567", "l0.5202817,0.4096832", "l0.5216035,0.4106490", "l0.5296156,0.4089047", "l0.5384436,0.4080109", "l0.5405813,0.4095102", "l0.5426210,0.4107067", "l0.5442528,0.4097408", "l0.5453787,0.4063098", "l0.5456561,0.4050701", "l0.5469453,0.3982370", "l0.5509268,0.3897172", "l0.5529992,0.3872521", "l0.5608645,0.3909137", "l0.5621536,0.3919805", "l0.5628063,0.3933500", "l0.5629369,0.3949646", "l0.5627737,0.3962620", "l0.5622678,0.3978766", "l0.5604728,0.4008606", "l0.5602118,0.4023311", "l0.5606523,0.4047673", "l0.5616641,0.4064828", "l0.5631164,0.4074775", "l0.5653682,0.4080397", "l0.5673917,0.4078379", "l0.5711448,0.4062810", "l0.5722870,0.4051998", "l0.5725645,0.4037727", "l0.5717322,0.4017112", "l0.5720096,0.3999525", "l0.5730866,0.3989001", "l0.5749142,0.3981072", "l0.5763502,0.3977757", "l0.5782594,0.3975882", "l0.5800870,0.3979054", "l0.5843134,0.3984964", "l0.5892251,0.3942149", "l0.6016920,0.3805919", "l0.6034870,0.3776799", "l0.6044987,0.3752004", "l0.6043192,0.3722019", "l0.6032748,0.3704864", "l0.6022142,0.3690016", "l0.6017410,0.3669257", "l0.6017899,0.3609575", "l0.6037644,0.3606836", "l0.6076317,0.3628028", "l0.6084966,0.3645038", "l0.6097368,0.3684394", "l0.6132614,0.3683385", "l0.6148280,0.3680357", "l0.6161171,0.3673582", "l0.6172104,0.3662049", "l0.6179773,0.3648354", "l0.6210941,0.3568923", "l0.6215020,0.3553209", "l0.6216162,0.3535766", "l0.6208493,0.3448694", "l0.6201802,0.3430242", "c"]}, {"n": "Cauca", "u": "CO-CAU", "i": ["m0.3806326,0.6881255", "l0.3798983,0.6896248", "l0.3729306,0.6918881", "l0.3710540,0.6922485", "l0.3624708,0.6921908", "l0.3602515,0.6919169", "l0.3587503,0.6914844", "l0.3511624,0.6887022", "l0.3495143,0.6871020", "l0.3477520,0.6838728", "l0.3485842,0.6781209", "l0.3490084,0.6769532", "l0.3496775,0.6759153", "l0.3504118,0.6746323", "l0.3503465,0.6734358", "l0.3496122,0.6717779", "l0.3470340,0.6673234", "l0.3452227,0.6658818", "l0.3423181,0.6656512", "l0.3403599,0.6666891", "l0.3385650,0.6692840", "l0.3361336,0.6709851", "l0.3341917,0.6714031", "l0.3294922,0.6722104", "l0.3313035,0.6693705", "l0.3327558,0.6590343", "l0.3325763,0.6574630", "l0.3311729,0.6557042", "l0.3184612,0.6487702", "l0.3171068,0.6489000", "l0.3145123,0.6497361", "l0.3130274,0.6500244", "l0.3036935,0.6506299", "l0.3011316,0.6506443", "l0.2990755,0.6504136", "l0.2997282,0.6424849", "l0.3004952,0.6414470", "l0.3025023,0.6396161", "l0.3040362,0.6389386", "l0.3055700,0.6369204", "l0.3061575,0.6354788", "l0.3043952,0.6340660", "l0.3015558,0.6318460", "l0.2960567,0.6259067", "l0.2931031,0.6215098", "l0.2920425,0.6201836", "l0.2908023,0.6196069", "l0.2836550,0.6203133", "l0.2805220,0.6203854", "l0.2791350,0.6203854", "l0.2755287,0.6199529", "l0.2736032,0.6195637", "l0.2722161,0.6191600", "l0.2704375,0.6183095", "l0.2676798,0.6162769", "l0.2668475,0.6150083", "l0.2642693,0.6100348", "l0.2619522,0.6063876", "l0.2580522,0.6012555", "l0.2562409,0.5992229", "l0.2554087,0.5979399", "l0.2547233,0.5965127", "l0.2545438,0.5954315", "l0.2548049,0.5930529", "l0.2570731,0.5958063", "l0.2574974,0.5973633", "l0.2599287,0.5984300", "l0.2648731,0.5978678", "l0.2677124,0.5954459", "l0.2664233,0.5935431", "l0.2653137,0.5868253", "l0.2698174,0.5803093", "l0.2797714,0.5694542", "l0.2810115,0.5689063", "l0.2897579,0.5570277", "l0.2903780,0.5553987", "l0.2926625,0.5576908", "l0.2956487,0.5614966", "l0.3063044,0.5683585", "l0.3183470,0.5693388", "l0.3198646,0.5674359", "l0.3237972,0.5690938", "l0.3277788,0.5730293", "l0.3367537,0.5690217", "l0.3427913,0.5658214", "l0.3458101,0.5655186", "l0.3539854,0.5623183", "l0.3555193,0.5597955", "l0.3553561,0.5574457", "l0.3542302,0.5561195", "l0.3557478,0.5538129", "l0.3589298,0.5534814", "l0.3646411,0.5544184", "l0.3670887,0.5555573", "l0.3687858,0.5564799", "l0.3708582,0.5575178", "l0.3737138,0.5586278", "l0.3761126,0.5593919", "l0.3789682,0.5597234", "l0.3790661,0.5607326", "l0.3787561,0.5627075", "l0.3786255,0.5641491", "l0.3793925,0.5653168", "l0.3812690,0.5676954", "l0.3832598,0.5707804", "l0.3842389,0.5726545", "l0.3851527,0.5737933", "l0.3893791,0.5847926", "l0.3927569,0.5912942", "l0.3945519,0.5937737", "l0.3955473,0.5953162", "l0.3983703,0.6016448", "l0.3991046,0.6034323", "l0.3993493,0.6046865", "l0.3943071,0.6058398", "l0.3930017,0.6055226", "l0.3897707,0.6031584", "l0.3868335,0.6014862", "l0.3838962,0.6006501", "l0.3817260,0.6018033", "l0.3803552,0.6034756", "l0.3783481,0.6058974", "l0.3770917,0.6068777", "l0.3753946,0.6075120", "l0.3734201,0.6077571", "l0.3701239,0.6069642", "l0.3686716,0.6068489", "l0.3671214,0.6075985", "l0.3605616,0.6141433", "l0.3603657,0.6153254", "l0.3615896,0.6185978", "l0.3622423,0.6199673", "l0.3629766,0.6212936", "l0.3635314,0.6232686", "l0.3635314,0.6250273", "l0.3625197,0.6258058", "l0.3606921,0.6262382", "l0.3580160,0.6260941", "l0.3552745,0.6252724", "l0.3532674,0.6243065", "l0.3510319,0.6234127", "l0.3488453,0.6229947", "l0.3459244,0.6235713", "l0.3439662,0.6247966", "l0.3439009,0.6278096", "l0.3448474,0.6370357", "l0.3461691,0.6383908", "l0.3476867,0.6384485", "l0.3499386,0.6383764", "l0.3530390,0.6395729", "l0.3559762,0.6432345", "l0.3563515,0.6450509", "l0.3561068,0.6472277", "l0.3558130,0.6493180", "l0.3565310,0.6507164", "l0.3614590,0.6548393", "l0.3685084,0.6587316", "l0.3698954,0.6591641", "l0.3715762,0.6590920", "l0.3748235,0.6584288", "l0.3748561,0.6609660", "l0.3716415,0.6669630", "l0.3693406,0.6706391", "l0.3670724,0.6725996", "l0.3666808,0.6744449", "l0.3679046,0.6805572", "l0.3718373,0.6828205", "l0.3758352,0.6840602", "l0.3775975,0.6848964", "c"]}, {"n": "Cesar", "u": "CO-CES", "i": ["m0.5338909,0.2666201", "l0.5357185,0.2595852", "l0.5360938,0.2529827", "l0.5353595,0.2471443", "l0.5336788,0.2420411", "l0.5328302,0.2408013", "l0.5309047,0.2373559", "l0.5313127,0.2326131", "l0.5303825,0.2251025", "l0.5286691,0.2237041", "l0.5275595,0.2216427", "l0.5279838,0.2175918", "l0.5286202,0.2166259", "l0.5309210,0.2136995", "l0.5323244,0.2114795", "l0.5309210,0.2095045", "l0.5288813,0.2076160", "l0.5269068,0.2060735", "l0.5233821,0.1993269", "l0.5228110,0.1975538", "l0.5214566,0.1955500", "l0.5182909,0.1911819", "l0.5174098,0.1900287", "l0.5154190,0.1884573", "l0.5132487,0.1876789", "l0.5118290,0.1865545", "l0.5160880,0.1814512", "l0.5179809,0.1805286", "l0.5251445,0.1808746", "l0.5340704,0.1804133", "l0.5303989,0.1711727", "l0.5223867,0.1612690", "l0.5146520,0.1522159", "l0.5162838,0.1466946", "l0.5169039,0.1451233", "l0.5232516,0.1354935", "l0.5269068,0.1337203", "l0.5282775,0.1333167", "l0.5372687,0.1303182", "l0.5505189,0.1246960", "l0.5497030,0.1226201", "l0.5471737,0.1204145", "l0.5466679,0.1187855", "l0.5466189,0.1175746", "l0.5467984,0.1163204", "l0.5477285,0.1149509", "l0.5490829,0.1120965", "l0.5466679,0.1096170", "l0.5440896,0.1071375", "l0.5431758,0.1059410", "l0.5428658,0.1041246", "l0.5433227,0.1027983", "l0.5445792,0.1013135", "l0.5457377,0.1029280", "l0.5468963,0.1039804", "l0.5488381,0.1044417", "l0.5505515,0.1045859", "l0.5565239,0.1046724", "l0.5618762,0.1046435", "l0.5650092,0.1045138", "l0.5670327,0.1048165", "l0.5693661,0.1060851", "l0.5805929,0.1167384", "l0.5815883,0.1190161", "l0.5808377,0.1230814", "l0.5800218,0.1246239", "l0.5779004,0.1254456", "l0.5741962,0.1295830", "l0.5779167,0.1318174", "l0.5802176,0.1317021", "l0.5825674,0.1313273", "l0.5840523,0.1309669", "l0.5866958,0.1304623", "l0.5887682,0.1303038", "l0.5922113,0.1305921", "l0.5929945,0.1307651", "l0.5925703,0.1353349", "l0.5909548,0.1493759", "l0.5897636,0.1514374", "l0.5883602,0.1562379", "l0.5877565,0.1620475", "l0.5865326,0.1702357", "l0.5813598,0.1797502", "l0.5789448,0.1826189", "l0.5703615,0.1917730", "l0.5623820,0.2027002", "l0.5614193,0.2059582", "l0.5610113,0.2065204", "l0.5603423,0.2077314", "l0.5595101,0.2095910", "l0.5592000,0.2107731", "l0.5576009,0.2204317", "l0.5573561,0.2249295", "l0.5579436,0.2279568", "l0.5580904,0.2314743", "l0.5571277,0.2336511", "l0.5560670,0.2348476", "l0.5538151,0.2367793", "l0.5528850,0.2382065", "l0.5523791,0.2397202", "l0.5518406,0.2440305", "l0.5546800,0.2538765", "l0.5554469,0.2553614", "l0.5573235,0.2558659", "l0.5592164,0.2544820", "l0.5592980,0.2528386", "l0.5592000,0.2515412", "l0.5589553,0.2496094", "l0.5598364,0.2485282", "l0.5621862,0.2483697", "l0.5637038,0.2489895", "l0.5644218,0.2500852", "l0.5647318,0.2514114", "l0.5647808,0.2533576", "l0.5646013,0.2561398", "l0.5640465,0.2585761", "l0.5621373,0.2596140", "l0.5606360,0.2597870", "l0.5595917,0.2608394", "l0.5595917,0.2622521", "l0.5605708,0.2643713", "l0.5631000,0.2674707", "l0.5646502,0.2703539", "l0.5653519,0.2720405", "l0.5669348,0.2777059", "l0.5665431,0.2797386", "l0.5624473,0.2872781", "l0.5608155,0.2895414", "l0.5590532,0.2909974", "l0.5561649,0.2923380", "l0.5542720,0.2927561", "l0.5469453,0.2935490", "l0.5466189,0.2927994", "l0.5448892,0.2914154", "l0.5420336,0.2912136", "l0.5379051,0.2909685", "l0.5370239,0.2893972", "l0.5376440,0.2872492", "l0.5392105,0.2851734", "l0.5405323,0.2832849", "l0.5410382,0.2808486", "l0.5387373,0.2750678", "l0.5374156,0.2724874", "l0.5347884,0.2680473", "c"]}, {"n": "Chocó", "u": "CO-CHO", "i": ["m0.2931847,0.2356116", "l0.2945065,0.2363757", "l0.2976395,0.2413780", "l0.2986839,0.2450684", "l0.3016211,0.2481678", "l0.3030244,0.2489751", "l0.3044115,0.2494220", "l0.3068102,0.2499842", "l0.3087847,0.2514114", "l0.3098290,0.2528386", "l0.3123257,0.2564281", "l0.3199299,0.2616611", "l0.3208110,0.2645443", "l0.3212842,0.2663895", "l0.3253800,0.2686240", "l0.3286926,0.2679320", "l0.3266692,0.2706998", "l0.3244010,0.2713053", "l0.3226060,0.2717810", "l0.3187550,0.2741885", "l0.3178901,0.2752697", "l0.3171721,0.2784123", "l0.3167968,0.2805170", "l0.3158014,0.2827227", "l0.3143654,0.2841066", "l0.3127989,0.2849571", "l0.3103675,0.2856058", "l0.3112813,0.2910839", "l0.3162909,0.2920641", "l0.3183796,0.2943707", "l0.3224265,0.2984215", "l0.3237483,0.2996757", "l0.3251842,0.3010020", "l0.3375532,0.3121310", "l0.3416164,0.3150142", "l0.3430850,0.3156773", "l0.3456143,0.3162828", "l0.3489921,0.3203336", "l0.3499712,0.3216599", "l0.3508850,0.3236060", "l0.3515541,0.3260135", "l0.3496448,0.3361334", "l0.3484047,0.3367389", "l0.3470503,0.3364073", "l0.3447495,0.3353838", "l0.3399520,0.3345189", "l0.3303897,0.3348360", "l0.3292964,0.3362920", "l0.3305202,0.3387571", "l0.3313687,0.3408042", "l0.3312219,0.3429810", "l0.3280725,0.3453019", "l0.3256575,0.3445379", "l0.3231119,0.3443793", "l0.3194077,0.3454749", "l0.3200441,0.3532883", "l0.3234708,0.3552200", "l0.3249068,0.3564021", "l0.3308792,0.3676033", "l0.3313524,0.3698233", "l0.3313687,0.3746959", "l0.3313361,0.3762672", "l0.3318093,0.3776511", "l0.3373411,0.3845131", "l0.3444068,0.3847870", "l0.3458754,0.3846284", "l0.3478172,0.3840950", "l0.3634335,0.3816587", "l0.3650000,0.3818605", "l0.3680678,0.3833165", "l0.3690469,0.3843257", "l0.3693896,0.3884342", "l0.3694712,0.3903227", "l0.3697159,0.3921246", "l0.3707113,0.3945177", "l0.3719189,0.3954691", "l0.3733059,0.3958872", "l0.3771732,0.3965503", "l0.3768142,0.4011057", "l0.3757862,0.4028356", "l0.3755088,0.4042340", "l0.3757862,0.4056611", "l0.3764879,0.4072180", "l0.3774996,0.4088615", "l0.3785276,0.4110815", "l0.3789193,0.4127826", "l0.3787398,0.4145990", "l0.3775322,0.4169632", "l0.3781034,0.4184336", "l0.3812690,0.4219943", "l0.3826887,0.4234071", "l0.3852343,0.4254974", "l0.3839452,0.4258578", "l0.3823460,0.4263911", "l0.3801268,0.4271263", "l0.3690632,0.4317683", "l0.3678067,0.4324891", "l0.3621607,0.4376788", "l0.3625850,0.4394807", "l0.3689653,0.4517919", "l0.3697159,0.4528587", "l0.3709071,0.4539543", "l0.3722289,0.4547039", "l0.3737302,0.4553959", "l0.3748398,0.4557563", "l0.3746929,0.4566933", "l0.3742686,0.4581637", "l0.3733875,0.4598792", "l0.3721147,0.4606865", "l0.3705482,0.4612919", "l0.3691611,0.4620127", "l0.3616222,0.4674763", "l0.3606758,0.4684422", "l0.3599252,0.4698550", "l0.3550135,0.4797298", "l0.3499712,0.4879901", "l0.3491227,0.4891001", "l0.3487637,0.4904841", "l0.3486331,0.4917815", "l0.3489105,0.4944052", "l0.3493185,0.4960630", "l0.3497264,0.4972307", "l0.3502812,0.4983695", "l0.3519130,0.5000850", "l0.3549319,0.5027231", "l0.3540181,0.5048423", "l0.3464955,0.5101617", "l0.3360683,0.5130881", "l0.3342570,0.5133044", "l0.3323968,0.5132035", "l0.3309282,0.5126845", "l0.3261307,0.5100608", "l0.3168294,0.5073218", "l0.3101064,0.5022474", "l0.3079362,0.5014545", "l0.3063859,0.5015266", "l0.3038077,0.5020888", "l0.3025839,0.5012239", "l0.3010826,0.4987299", "l0.3014742,0.4978073", "l0.2982759,0.4972019", "l0.2950776,0.4973028", "l0.2920425,0.4929924", "l0.2944412,0.4870243", "l0.2947186,0.4866350", "l0.2952734,0.4853520", "l0.2966931,0.4808831", "l0.2964483,0.4748717", "l0.2961056,0.4706478", "l0.2948981,0.4649103", "l0.2943596,0.4633678", "l0.2939843,0.4618830", "l0.2934295,0.4575582", "l0.2927278,0.4491394", "l0.2927931,0.4448723", "l0.2939680,0.4420324", "l0.2943596,0.4397979", "l0.2935437,0.4363669", "l0.2910634,0.4270110", "l0.2854174,0.4241711", "l0.2819580,0.4233061", "l0.2838182,0.4194283", "l0.2894642,0.4170641", "l0.2920261,0.4174389", "l0.2935927,0.4182462", "l0.2957630,0.4175254", "l0.3009031,0.4120329", "l0.3015558,0.4091209", "l0.3012784,0.4073334", "l0.2949634,0.3955124", "l0.2903128,0.3899911", "l0.2871960,0.3870214", "l0.2857601,0.3853780", "l0.2848789,0.3837779", "l0.2857601,0.3779827", "l0.2903617,0.3805487", "l0.2918466,0.3780692", "l0.2938211,0.3715532", "l0.2948655,0.3611017", "l0.2903128,0.3537784", "l0.2879140,0.3525099", "l0.2863801,0.3523657", "l0.2729341,0.3427215", "l0.2738479,0.3367389", "l0.2736195,0.3353406", "l0.2719714,0.3320682", "l0.2643998,0.3263595", "l0.2579216,0.3217752", "l0.2634534,0.3069125", "l0.2655911,0.3070999", "l0.2674187,0.3065665", "l0.2685283,0.3052835", "l0.2692789,0.3034671", "l0.2687078,0.3015354", "l0.2670107,0.2989549", "l0.2667007,0.2977007", "l0.2666844,0.2956825", "l0.2667170,0.2941400", "l0.2677124,0.2925399", "l0.2730973,0.2949617", "l0.2757735,0.2994883", "l0.2767036,0.3019246", "l0.2773889,0.3033085", "l0.2789228,0.3040870", "l0.2955019,0.2936355", "l0.2955671,0.2921795", "l0.2928747,0.2890656", "l0.2968236,0.2826073", "l0.2979169,0.2815406", "l0.3032692,0.2796088", "l0.3044278,0.2759040", "l0.3032855,0.2706278", "l0.3013763,0.2672112", "l0.2993855,0.2640253", "l0.2978680,0.2630018", "l0.2943107,0.2599024", "l0.2933969,0.2588788", "l0.2930215,0.2557650", "l0.2929889,0.2541504", "l0.2925646,0.2520890", "l0.2904923,0.2489463", "l0.2889257,0.2476777", "l0.2862659,0.2477210", "l0.2857764,0.2447657", "l0.2873592,0.2426322", "l0.2882730,0.2420555", "l0.2927605,0.2373127", "l0.2931847,0.2356116", "c", "m0.2909818,0.4942322", "l0.2925320,0.4950106", "l0.2938864,0.4977352", "l0.2963341,0.4983984", "l0.2954366,0.4991192", "l0.2841935,0.5008779", "l0.2809463,0.5016708", "l0.2816153,0.4995228", "l0.2886973,0.4936556", "l0.2893826,0.4934970", "l0.2902312,0.4937709", "l0.2909818,0.4942322", "c"]}, {"n": "Caldas", "u": "CO-CAL", "i": ["m0.4255233,0.4652419", "l0.4201221,0.4611190", "l0.4173807,0.4596197", "l0.4159937,0.4595476", "l0.4107882,0.4593026", "l0.4037878,0.4570537", "l0.3962816,0.4586106", "l0.3938991,0.4586250", "l0.3924468,0.4575726", "l0.3897707,0.4511864", "l0.3907498,0.4491538", "l0.3980929,0.4431280", "l0.4047506,0.4397979", "l0.4071004,0.4373904", "l0.4086832,0.4346658", "l0.4030209,0.4311051", "l0.3984355,0.4320277", "l0.3958410,0.4331666", "l0.3940623,0.4336712", "l0.3929201,0.4323737", "l0.3933443,0.4257424", "l0.3983376,0.4234071", "l0.4001652,0.4229890", "l0.4039347,0.4225709", "l0.4069535,0.4228304", "l0.4112125,0.4232052", "l0.4123548,0.4224556", "l0.4120774,0.4181164", "l0.4110820,0.4126096", "l0.4111799,0.4109085", "l0.4133991,0.4111968", "l0.4159773,0.4119320", "l0.4265024,0.4146855", "l0.4337313,0.4151756", "l0.4351020,0.4156802", "l0.4373049,0.4174821", "l0.4395568,0.4190102", "l0.4416292,0.4198463", "l0.4481400,0.4158243", "l0.4492986,0.4143683", "l0.4509957,0.4124078", "l0.4541777,0.4117446", "l0.4628425,0.4108797", "l0.4731555,0.4082272", "l0.4750973,0.4085155", "l0.4763211,0.4096976", "l0.4763538,0.4105481", "l0.4758479,0.4113266", "l0.4746730,0.4241711", "l0.4751463,0.4268236", "l0.4730739,0.4314799", "l0.4721274,0.4331522", "l0.4710994,0.4346803", "l0.4692881,0.4369436", "l0.4692392,0.4369003", "l0.4677705,0.4364390", "l0.4651433,0.4358479", "l0.4623367,0.4356894", "l0.4582735,0.4356894", "l0.4567559,0.4359633", "l0.4520074,0.4369724", "l0.4502124,0.4378229", "l0.4481564,0.4392645", "l0.4465572,0.4407061", "l0.4458882,0.4417440", "l0.4450559,0.4434595", "l0.4439137,0.4441082", "l0.4378597,0.4446560", "l0.4355752,0.4446560", "l0.4334049,0.4449444", "l0.4315284,0.4468040", "l0.4310551,0.4480149", "l0.4281832,0.4572843", "l0.4290154,0.4589277", "l0.4302229,0.4603261", "l0.4301903,0.4616379", "l0.4291296,0.4627479", "c"]}, {"n": "Córdoba", "u": "CO-COR", "i": ["m0.4639521,0.2648037", "l0.4618961,0.2667499", "l0.4597911,0.2694168", "l0.4590078,0.2704692", "l0.4579634,0.2715648", "l0.4566254,0.2724586", "l0.4552383,0.2730496", "l0.4535739,0.2734677", "l0.4517300,0.2735398", "l0.4479116,0.2735398", "l0.4443706,0.2732947", "l0.4403727,0.2731505", "l0.4385124,0.2735830", "l0.4310551,0.2798539", "l0.4302719,0.2815406", "l0.4297987,0.2827227", "l0.4282811,0.2845679", "l0.4264861,0.2853175", "l0.4242669,0.2859662", "l0.4226188,0.2864708", "l0.4212644,0.2898009", "l0.4205627,0.2926264", "l0.4194367,0.2935201", "l0.4180171,0.2931165", "l0.4159121,0.2914731", "l0.4144435,0.2907811", "l0.4123548,0.2911127", "l0.4106414,0.2925831", "l0.4098092,0.2936355", "l0.4078510,0.2965763", "l0.4069861,0.3009876", "l0.3957104,0.3133420", "l0.3936217,0.3138033", "l0.3887427,0.3135870", "l0.3854628,0.3135438", "l0.3723268,0.3136159", "l0.3677251,0.3137744", "l0.3662402,0.3139186", "l0.3642331,0.3139907", "l0.3619323,0.3136591", "l0.3556009,0.3063935", "l0.3530553,0.3029481", "l0.3520599,0.3013335", "l0.3515051,0.2996757", "l0.3509503,0.2975278", "l0.3504118,0.2944139", "l0.3503139,0.2930733", "l0.3503465,0.2909685", "l0.3509666,0.2848130", "l0.3522394,0.2828957", "l0.3538386,0.2815117", "l0.3564005,0.2792629", "l0.3571674,0.2769419", "l0.3573143,0.2739434", "l0.3575427,0.2723144", "l0.3581302,0.2692006", "l0.3586360,0.2671535", "l0.3594030,0.2651065", "l0.3610185,0.2621368", "l0.3626992,0.2604213", "l0.3658975,0.2575382", "l0.3672193,0.2567165", "l0.3691611,0.2550154", "l0.3703850,0.2537612", "l0.3714130,0.2522043", "l0.3719678,0.2506474", "l0.3722942,0.2486724", "l0.3724084,0.2467263", "l0.3724574,0.2441747", "l0.3721473,0.2426610", "l0.3711519,0.2416086", "l0.3687532,0.2405419", "l0.3670072,0.2399364", "l0.3650490,0.2390426", "l0.3635314,0.2382065", "l0.3622423,0.2371397", "l0.3612796,0.2360441", "l0.3603331,0.2345016", "l0.3594193,0.2315896", "l0.3590603,0.2297444", "l0.3588645,0.2281730", "l0.3588319,0.2260107", "l0.3587013,0.2247997", "l0.3582281,0.2236320", "l0.3575427,0.2225797", "l0.3564005,0.2217868", "l0.3569227,0.2217724", "l0.3582607,0.2215417", "l0.3599741,0.2212102", "l0.3637436,0.2198695", "l0.3673335,0.2164818", "l0.3729469,0.2047329", "l0.3734854,0.2021092", "l0.3776628,0.1973375", "l0.3790661,0.1961266", "l0.3802900,0.1955355", "l0.3905703,0.1909513", "l0.3974728,0.1899710", "l0.4035757,0.1910090", "l0.4046853,0.1930416", "l0.4057949,0.1943390", "l0.4070188,0.1955211", "l0.4082753,0.1964581", "l0.4169401,0.2014749", "l0.4231899,0.2072268", "l0.4244627,0.2081782", "l0.4295702,0.2092883", "l0.4309572,0.2097928", "l0.4322790,0.2104415", "l0.4362442,0.2134545", "l0.4387898,0.2195812", "l0.4388714,0.2210804", "l0.4379903,0.2247277", "l0.4359505,0.2240069", "l0.4337639,0.2241943", "l0.4308756,0.2245547", "l0.4257028,0.2262846", "l0.4256049,0.2279568", "l0.4295212,0.2369667", "l0.4314468,0.2471155", "l0.4334049,0.2476200", "l0.4360811,0.2468272", "l0.4375334,0.2466398", "l0.4391815,0.2474903", "l0.4394426,0.2507050", "l0.4398342,0.2531701", "l0.4448928,0.2519736", "l0.4487275,0.2496383", "l0.4500492,0.2484850", "l0.4518768,0.2467263", "l0.4613902,0.2502437", "l0.4662530,0.2540783", "l0.4665467,0.2563561", "l0.4670036,0.2585905", "l0.4685212,0.2603925", "l0.4679337,0.2625116", "l0.4668730,0.2635784", "c"]}, {"n": "Caquetá", "u": "CO-CAQ", "i": ["m0.6518208,0.7098358", "l0.6531262,0.7108305", "l0.6576463,0.7154436", "l0.6621174,0.7223344", "l0.6644672,0.7286918", "l0.6686935,0.7296432", "l0.6735889,0.7335787", "l0.6789249,0.7365628", "l0.6851420,0.7395901", "l0.6866270,0.7392298", "l0.6872634,0.7386243", "l0.6876224,0.7409885", "l0.6868065,0.7426896", "l0.6841793,0.7454286", "l0.6775052,0.7516851", "l0.6718919,0.7557503", "l0.6706843,0.7571487", "l0.6699337,0.7583596", "l0.6690852,0.7598156", "l0.6684651,0.7609545", "l0.6675513,0.7623528", "l0.6662458,0.7640827", "l0.6637492,0.7656829", "l0.6608120,0.7655243", "l0.6568956,0.7645873", "l0.6550680,0.7642557", "l0.6532241,0.7642845", "l0.6514618,0.7650197", "l0.6424706,0.7726745", "l0.6410999,0.7740152", "l0.6403003,0.7751108", "l0.6391743,0.7771291", "l0.6379668,0.7799978", "l0.6374936,0.7812087", "l0.6377057,0.7845532", "l0.6355844,0.7861245", "l0.6339363,0.7868165", "l0.6324677,0.7868165", "l0.6274581,0.7846685", "l0.6266748,0.7826503", "l0.6239334,0.7828377", "l0.6183853,0.7880419", "l0.6171451,0.7901466", "l0.6151543,0.7900457", "l0.6091656,0.7868742", "l0.6066527,0.7843370", "l0.6046456,0.7822034", "l0.6013004,0.7826215", "l0.5993096,0.7844091", "l0.5976451,0.7848415", "l0.5955891,0.7849136", "l0.5937941,0.7848415", "l0.5919339,0.7843946", "l0.5911016,0.7828954", "l0.5894372,0.7811078", "l0.5879196,0.7803150", "l0.5854720,0.7803150", "l0.5833833,0.7822323", "l0.5827632,0.7835153", "l0.5816862,0.7852163", "l0.5741636,0.7857642", "l0.5717486,0.7847839", "l0.5705084,0.7839766", "l0.5659394,0.7809204", "l0.5616641,0.7809493", "l0.5550390,0.7811078", "l0.5489034,0.7804879", "l0.5459499,0.7765668", "l0.5413808,0.7740296", "l0.5398633,0.7733377", "l0.5362244,0.7733953", "l0.5306599,0.7731070", "l0.5249323,0.7718817", "l0.5225173,0.7711321", "l0.5180298,0.7689841", "l0.5147989,0.7661442", "l0.5124654,0.7639818", "l0.5074558,0.7627564", "l0.5016303,0.7598300", "l0.5003412,0.7582587", "l0.4973060,0.7561828", "l0.4901914,0.7542655", "l0.4890981,0.7551304", "l0.4893429,0.7563270", "l0.4880538,0.7573793", "l0.4800906,0.7560675", "l0.4748036,0.7532708", "l0.4733350,0.7486289", "l0.4748036,0.7475765", "l0.4758316,0.7466107", "l0.4732860,0.7401091", "l0.4722090,0.7385955", "l0.4708873,0.7377161", "l0.4636584,0.7368079", "l0.4616187,0.7363898", "l0.4545367,0.7337661", "l0.4528396,0.7269186", "l0.4537371,0.7253184", "l0.4539166,0.7241363", "l0.4530681,0.7225794", "l0.4520074,0.7216712", "l0.4456271,0.7190620", "l0.4437505,0.7201432", "l0.4417108,0.7211667", "l0.4398179,0.7207919", "l0.4377455,0.7170149", "l0.4375007,0.7151985", "l0.4381208,0.7131515", "l0.4354610,0.7068085", "l0.4335518,0.7055111", "l0.4308593,0.7049344", "l0.4289501,0.7054534", "l0.4276284,0.7056985", "l0.4240221,0.7059147", "l0.4184087,0.7045884", "l0.4168748,0.7032189", "l0.4159937,0.7013160", "l0.4097765,0.6982310", "l0.4069209,0.6991537", "l0.4023029,0.6997591", "l0.3961673,0.6977986", "l0.3916473,0.6934017", "l0.3908803,0.6921908", "l0.3911088,0.6901005", "l0.3894933,0.6882985", "l0.3815791,0.6877940", "l0.3806326,0.6881255", "l0.3775975,0.6848964", "l0.3758352,0.6840602", "l0.3718373,0.6828205", "l0.3679046,0.6805572", "l0.3666808,0.6744449", "l0.3670724,0.6725996", "l0.3693406,0.6706391", "l0.3716415,0.6669630", "l0.3748561,0.6609660", "l0.3748235,0.6584288", "l0.3757046,0.6579964", "l0.3827377,0.6575062", "l0.3854301,0.6573332", "l0.3876331,0.6573332", "l0.3898033,0.6559637", "l0.4026129,0.6413316", "l0.4096297,0.6340516", "l0.4152757,0.6273771", "l0.4165322,0.6239749", "l0.4272530,0.6128171", "l0.4302229,0.6105682", "l0.4330133,0.6059695", "l0.4336986,0.6026683", "l0.4342698,0.6006789", "l0.4351346,0.5995112", "l0.4373049,0.5977237", "l0.4397200,0.5982859", "l0.4410580,0.5987616", "l0.4430325,0.5983147", "l0.4501635,0.5931682", "l0.4531986,0.5898238", "l0.4528070,0.5879353", "l0.4519911,0.5866523", "l0.4507020,0.5849224", "l0.4505388,0.5827023", "l0.4514036,0.5810157", "l0.4564785,0.5754079", "l0.4568865,0.5749610", "l0.4629404,0.5762873", "l0.4656492,0.5769792", "l0.4670689,0.5774982", "l0.4684722,0.5781613", "l0.4750973,0.5822410", "l0.4764843,0.5831348", "l0.4779040,0.5843457", "l0.4787199,0.5853116", "l0.4795195,0.5869694", "l0.4796990,0.5882236", "l0.4795521,0.5896219", "l0.4790626,0.5911789", "l0.4782140,0.5927646", "l0.4766638,0.5943792", "l0.4757174,0.5952153", "l0.4736776,0.5977813", "l0.4731228,0.5994247", "l0.4741345,0.6110007", "l0.4744609,0.6124999", "l0.4758479,0.6160174", "l0.4769902,0.6183095", "l0.4774960,0.6198520", "l0.4781488,0.6238884", "l0.4780835,0.6258202", "l0.4780508,0.6282564", "l0.4781488,0.6294674", "l0.4785893,0.6311540", "l0.4809065,0.6348157", "l0.4831094,0.6372375", "l0.4851492,0.6393422", "l0.4871726,0.6405532", "l0.4902893,0.6416776", "l0.4931613,0.6422110", "l0.4952500,0.6425714", "l0.4968655,0.6427444", "l0.4985952,0.6428741", "l0.5007165,0.6431769", "l0.5048286,0.6440706", "l0.5091202,0.6478044", "l0.5107683,0.6501253", "l0.5190416,0.6554015", "l0.5211792,0.6557475", "l0.5245081,0.6554015", "l0.5263030,0.6551276", "l0.5294198,0.6540753", "l0.5317696,0.6534121", "l0.5368118,0.6521147", "l0.5389821,0.6518408", "l0.5407771,0.6519561", "l0.5429963,0.6526481", "l0.5428984,0.6531671", "l0.5428005,0.6553439", "l0.5434043,0.6584433", "l0.5446771,0.6602597", "l0.5498988,0.6659539", "l0.5527545,0.6680875", "l0.5551695,0.6705093", "l0.5575846,0.6750503", "l0.5580088,0.6767947", "l0.5581067,0.6787264", "l0.5592000,0.6804707", "l0.5604892,0.6816816", "l0.5618272,0.6828205", "l0.5641607,0.6842765", "l0.5659230,0.6852712", "l0.5679628,0.6864965", "l0.5739515,0.6909799", "l0.5752080,0.6928683", "l0.5803644,0.6947857", "l0.5827958,0.6949442", "l0.5843950,0.6946271", "l0.5947569,0.6877507", "l0.5955891,0.6865398", "l0.5948221,0.6852423", "l0.5945611,0.6838440", "l0.5970087,0.6806437", "l0.6000765,0.6793463", "l0.6059020,0.6783660", "l0.6103079,0.6793463", "l0.6117275,0.6813789", "l0.6173409,0.6846369", "l0.6187116,0.6849829", "l0.6212735,0.6845504", "l0.6253857,0.6880823", "l0.6335283,0.6976256", "l0.6352417,0.7016188", "l0.6382279,0.7067220", "l0.6396639,0.7063328", "l0.6411651,0.7057417", "l0.6474802,0.7076878", "l0.6506459,0.7098646", "c"]}, {"n": "Casanare", "u": "CO-CAS", "i": ["m0.5835628,0.4698982", "l0.5814251,0.4667267", "l0.5812130,0.4655302", "l0.5816209,0.4640310", "l0.5838075,0.4575871", "l0.5849824,0.4558716", "l0.5867121,0.4546030", "l0.5889966,0.4541561", "l0.5910364,0.4531326", "l0.5929456,0.4512441", "l0.5931740,0.4500764", "l0.5924560,0.4487357", "l0.5890456,0.4459967", "l0.5883766,0.4448002", "l0.5902042,0.4402736", "l0.5986895,0.4309466", "l0.6020673,0.4331378", "l0.6041234,0.4351848", "l0.6106832,0.4343919", "l0.6194623,0.4287842", "l0.6206861,0.4274723", "l0.6224974,0.4251946", "l0.6237212,0.4235800", "l0.6249777,0.4220231", "l0.6260058,0.4211582", "l0.6273928,0.4206825", "l0.6286493,0.4213600", "l0.6340505,0.4193850", "l0.6370204,0.4129844", "l0.6369388,0.4116005", "l0.6337731,0.4068288", "l0.6264790,0.4040610", "l0.6275886,0.4000101", "l0.6285187,0.3991163", "l0.6304116,0.3920381", "l0.6270338,0.3888234", "l0.6274254,0.3813272", "l0.6275886,0.3796549", "l0.6280781,0.3781268", "l0.6291062,0.3766276", "l0.6310970,0.3748977", "l0.6316355,0.3745661", "l0.6312765,0.3771466", "l0.6314070,0.3785881", "l0.6320108,0.3806929", "l0.6374610,0.3870358", "l0.6431722,0.3893135", "l0.6458973,0.3898181", "l0.6473007,0.3898613", "l0.6521798,0.3872665", "l0.6534036,0.3863150", "l0.6559329,0.3847437", "l0.6704885,0.3820480", "l0.6794797,0.3816155", "l0.6814052,0.3829562", "l0.6864801,0.3829706", "l0.6878345,0.3828697", "l0.6989470,0.3800586", "l0.7006930,0.3791504", "l0.7028633,0.3783719", "l0.7066001,0.3775214", "l0.7084930,0.3781845", "l0.7221022,0.3808082", "l0.7246968,0.3810533", "l0.7292331,0.3812839", "l0.7385181,0.3815434", "l0.7426139,0.3815434", "l0.7524699,0.3809668", "l0.7542649,0.3803180", "l0.7555377,0.3798135", "l0.7590950,0.3780259", "l0.7625544,0.3770601", "l0.7745155,0.3772619", "l0.7798025,0.3793234", "l0.7838493,0.3825525", "l0.7950271,0.3904956", "l0.7991393,0.3927157", "l0.7983234,0.3932202", "l0.7961205,0.3955700", "l0.7951087,0.3969251", "l0.7934606,0.4000101", "l0.7925468,0.4025185", "l0.7908987,0.4064396", "l0.7839473,0.4145125", "l0.7822012,0.4162424", "l0.7774201,0.4189381", "l0.7756904,0.4194283", "l0.7716435,0.4202932", "l0.7700933,0.4205383", "l0.7667808,0.4204518", "l0.7649695,0.4206392", "l0.7586871,0.4228160", "l0.7464975,0.4292166", "l0.7450779,0.4300095", "l0.7432013,0.4311051", "l0.7424996,0.4326332", "l0.7424996,0.4338441", "l0.7423691,0.4350695", "l0.7317298,0.4437190", "l0.7298043,0.4447281", "l0.7269976,0.4459246", "l0.7196545,0.4568807", "l0.7184307,0.4582790", "l0.7169457,0.4593890", "l0.7158035,0.4600233", "l0.7151508,0.4606576", "l0.7097495,0.4635985", "l0.7072529,0.4648527", "l0.7046746,0.4656023", "l0.7027981,0.4657464", "l0.6986043,0.4671015", "l0.6970052,0.4677070", "l0.6837224,0.4730409", "l0.6792023,0.4759961", "l0.6778969,0.4766737", "l0.6759387,0.4773800", "l0.6700479,0.4791388", "l0.6629333,0.4831464", "l0.6614973,0.4845447", "l0.6556881,0.4885523", "l0.6514455,0.4902678", "l0.6495036,0.4901237", "l0.6480350,0.4886965", "l0.6466317,0.4874856", "l0.6445593,0.4868801", "l0.6384400,0.4875144", "l0.6328103,0.4893885", "l0.6309011,0.4916085", "l0.6297915,0.4925023", "l0.6273438,0.4938141", "l0.6211430,0.4946070", "l0.6141752,0.4952845", "l0.6054778,0.4959621", "l0.6041560,0.4949097", "l0.5925703,0.4838095", "l0.5892740,0.4798163", "l0.5885234,0.4776684", "l0.5878217,0.4760682", "l0.5857983,0.4735743", "l0.5835628,0.4710803", "c"]}, {"n": "Cundinamarca", "u": "CO-CUN", "i": ["m0.4692392,0.4369003", "l0.4692881,0.4369436", "l0.4710994,0.4346803", "l0.4721274,0.4331522", "l0.4730739,0.4314799", "l0.4751463,0.4268236", "l0.4746730,0.4241711", "l0.4758479,0.4113266", "l0.4763538,0.4105481", "l0.4775613,0.4096687", "l0.4857529,0.4081407", "l0.4887391,0.4089335", "l0.4913010,0.4093083", "l0.4951031,0.4077082", "l0.4978119,0.4058918", "l0.4995742,0.4076794", "l0.5006839,0.4133592", "l0.4994111,0.4148585", "l0.4975182,0.4167758", "l0.4982035,0.4189814", "l0.5038985,0.4253964", "l0.5084022,0.4267804", "l0.5171324,0.4325323", "l0.5187152,0.4326332", "l0.5210323,0.4318259", "l0.5222888,0.4312781", "l0.5236759,0.4301104", "l0.5266131,0.4273714", "l0.5267273,0.4256415", "l0.5276411,0.4234936", "l0.5308884,0.4214753", "l0.5336788,0.4209275", "l0.5389168,0.4254974", "l0.5436653,0.4265785", "l0.5483160,0.4314799", "l0.5512369,0.4396826", "l0.5525097,0.4417152", "l0.5538151,0.4440506", "l0.5549737,0.4499178", "l0.5525260,0.4522244", "l0.5514653,0.4537236", "l0.5503068,0.4576447", "l0.5508126,0.4593458", "l0.5530645,0.4612487", "l0.5569971,0.4635552", "l0.5590042,0.4646653", "l0.5606197,0.4652707", "l0.5626595,0.4659627", "l0.5640465,0.4663807", "l0.5656293,0.4670583", "l0.5698067,0.4696531", "l0.5719607,0.4720750", "l0.5728908,0.4731994", "l0.5744084,0.4739347", "l0.5778025,0.4744392", "l0.5807234,0.4741076", "l0.5835628,0.4698982", "l0.5835628,0.4710803", "l0.5830569,0.4723777", "l0.5818820,0.4779423", "l0.5783247,0.4951260", "l0.5729724,0.4975911", "l0.5620067,0.4951548", "l0.5585800,0.4959188", "l0.5568992,0.4968991", "l0.5554469,0.4971730", "l0.5520854,0.4965243", "l0.5505842,0.4954143", "l0.5492461,0.4921275", "l0.5489197,0.4907724", "l0.5485444,0.4886965", "l0.5476959,0.4866206", "l0.5463904,0.4856980", "l0.5445465,0.4848619", "l0.5360285,0.4829446", "l0.5339072,0.4843717", "l0.5315085,0.4876153", "l0.5305294,0.4897777", "l0.5317206,0.4911760", "l0.5336951,0.4916085", "l0.5365834,0.4969568", "l0.5368608,0.4982830", "l0.5368608,0.5012527", "l0.5350658,0.5020600", "l0.5335482,0.5020456", "l0.5307252,0.5021321", "l0.5198411,0.5070335", "l0.5185683,0.5079128", "l0.5171650,0.5091670", "l0.5157127,0.5101761", "l0.5128244,0.5117907", "l0.5112253,0.5122953", "l0.5094955,0.5124106", "l0.5093813,0.5086769", "l0.5113232,0.5017140", "l0.5127428,0.4954864", "l0.5131997,0.4895903", "l0.5135750,0.4880910", "l0.5144073,0.4863611", "l0.5150110,0.4852655", "l0.5162675,0.4835068", "l0.5178993,0.4821084", "l0.5191558,0.4807678", "l0.5203959,0.4789946", "l0.5205918,0.4690909", "l0.5200533,0.4662510", "l0.5165939,0.4646364", "l0.5149294,0.4648815", "l0.5078638,0.4756790", "l0.5055956,0.4895038", "l0.5059382,0.4936267", "l0.5066236,0.4974181", "l0.5062972,0.4995805", "l0.5027073,0.5073074", "l0.5009939,0.5078696", "l0.4976161,0.5079705", "l0.4938303,0.5126701", "l0.4940098,0.5167209", "l0.4926554,0.5212908", "l0.4920680,0.5223864", "l0.4900282,0.5255002", "l0.4879069,0.5280950", "l0.4862588,0.5292916", "l0.4864383,0.5289744", "l0.4871726,0.5272013", "l0.4869441,0.5258318", "l0.4842843,0.5245343", "l0.4833052,0.5234387", "l0.4832236,0.5230639", "l0.4849044,0.5193590", "l0.4850839,0.5175570", "l0.4853287,0.5107383", "l0.4875642,0.5067163", "l0.4874989,0.5049288", "l0.4868136,0.5035448", "l0.4845943,0.5005896", "l0.4829952,0.4989606", "l0.4811186,0.4984704", "l0.4787362,0.4991768", "l0.4771370,0.5014401", "l0.4752278,0.5022042", "l0.4735797,0.5020456", "l0.4605090,0.4975911", "l0.4591710,0.4966540", "l0.4602643,0.4940304", "l0.4649802,0.4861449", "l0.4661551,0.4829734", "l0.4653228,0.4813156", "l0.4648823,0.4791532", "l0.4646049,0.4772503", "l0.4639195,0.4708064", "l0.4675094,0.4639156", "l0.4704630,0.4472653", "l0.4695166,0.4375490", "c"]}, {"n": "Distrito Capital de Bogotá", "u": "CO-DC", "i": ["m0.4862588,0.5292916", "l0.4879069,0.5280950", "l0.4900282,0.5255002", "l0.4920680,0.5223864", "l0.4926554,0.5212908", "l0.4940098,0.5167209", "l0.4938303,0.5126701", "l0.4976161,0.5079705", "l0.5009939,0.5078696", "l0.5027073,0.5073074", "l0.5062972,0.4995805", "l0.5066236,0.4974181", "l0.5059382,0.4936267", "l0.5055956,0.4895038", "l0.5078638,0.4756790", "l0.5149294,0.4648815", "l0.5165939,0.4646364", "l0.5200533,0.4662510", "l0.5205918,0.4690909", "l0.5203959,0.4789946", "l0.5191558,0.4807678", "l0.5178993,0.4821084", "l0.5162675,0.4835068", "l0.5150110,0.4852655", "l0.5144073,0.4863611", "l0.5135750,0.4880910", "l0.5131997,0.4895903", "l0.5127428,0.4954864", "l0.5113232,0.5017140", "l0.5093813,0.5086769", "l0.5094955,0.5124106", "l0.5070479,0.5123097", "l0.5050407,0.5126845", "l0.5033437,0.5138089", "l0.4937487,0.5230495", "l0.4925249,0.5249236", "l0.4915621,0.5270715", "l0.4901588,0.5298105", "l0.4890492,0.5308917", "l0.4876948,0.5311368", "l0.4864383,0.5305313", "c"]}, {"n": "Guainía", "u": "CO-GUA", "i": ["m0.9427047,0.5105221", "l0.9437653,0.5150919", "l0.9445812,0.5179607", "l0.9476327,0.5252695", "l0.9489218,0.5275617", "l0.9500151,0.5286428", "l0.9515490,0.5291330", "l0.9539151,0.5288879", "l0.9559385,0.5288014", "l0.9573255,0.5296087", "l0.9609644,0.5341065", "l0.9615519,0.5364851", "l0.9637548,0.5421361", "l0.9647176,0.5437074", "l0.9659414,0.5444715", "l0.9673774,0.5448607", "l0.9697435,0.5456680", "l0.9706573,0.5490269", "l0.9670510,0.5538850", "l0.9654845,0.5544184", "l0.9610624,0.5574313", "l0.9567218,0.5611650", "l0.9461967,0.5699010", "l0.9343335,0.5797182", "l0.9349699,0.5826447", "l0.9388536,0.5823275", "l0.9476816,0.5836970", "l0.9496071,0.5846485", "l0.9507005,0.5863640", "l0.9543557,0.5913374", "l0.9577009,0.5929088", "l0.9684870,0.6035044", "l0.9714243,0.6055803", "l0.9730071,0.6061713", "l0.9755853,0.6071084", "l0.9774129,0.6083193", "l0.9786368,0.6116350", "l0.9779351,0.6128315", "l0.9764012,0.6140857", "l0.9757648,0.6152533", "l0.9761238,0.6171130", "l0.9769887,0.6192465", "l0.9785715,0.6224469", "l0.9795506,0.6236722", "l0.9827326,0.6299287", "l0.9909079,0.6494622", "l0.9952974,0.6634023", "l0.9971414,0.6737673", "l0.9976472,0.6756990", "l0.9987568,0.6771983", "l0.9990669,0.6775010", "l0.9980715,0.6774866", "l0.9881502,0.6797643", "l0.9852945,0.6803554", "l0.9846908,0.6791012", "l0.9844460,0.6748197", "l0.9844460,0.6736376", "l0.9849518,0.6677992", "l0.9853924,0.6660693", "l0.9860778,0.6646709", "l0.9865347,0.6598416", "l0.9855719,0.6539167", "l0.9827163,0.6471556", "l0.9795343,0.6422110", "l0.9764665,0.6388377", "l0.9750142,0.6378862", "l0.9725502,0.6346427", "l0.9695803,0.6295683", "l0.9688460,0.6277807", "l0.9684707,0.6262815", "l0.9675079,0.6248255", "l0.9619435,0.6230667", "l0.9563301,0.6251859", "l0.9522996,0.6275357", "l0.9509452,0.6283718", "l0.9455440,0.6330713", "l0.9448260,0.6352337", "l0.9441406,0.6362573", "l0.9384946,0.6421966", "l0.9357695,0.6442436", "l0.9316737,0.6459591", "l0.9288344,0.6465502", "l0.9270231,0.6467088", "l0.9252771,0.6465069", "l0.9237269,0.6460456", "l0.9224214,0.6451807", "l0.9207244,0.6432345", "l0.9187009,0.6401640", "l0.9180482,0.6390539", "l0.9171507,0.6358104", "l0.9160574,0.6343544", "l0.9147683,0.6336480", "l0.9113742,0.6328263", "l0.9098892,0.6328263", "l0.9078658,0.6354211", "l0.9071641,0.6368339", "l0.9058098,0.6401928", "l0.9074415,0.6447626", "l0.9088775,0.6449788", "l0.9108194,0.6452960", "l0.9128102,0.6477899", "l0.8673646,0.6476746", "l0.8489254,0.6475881", "l0.8397057,0.6475593", "l0.8307961,0.6475593", "l0.8289359,0.6465934", "l0.8249706,0.6456564", "l0.8186066,0.6442581", "l0.8087342,0.6465502", "l0.8030556,0.6487702", "l0.7989598,0.6485972", "l0.7967242,0.6469827", "l0.7905560,0.6456564", "l0.7886958,0.6454113", "l0.7866071,0.6452960", "l0.7846652,0.6447049", "l0.7820217,0.6428741", "l0.7786439,0.6403081", "l0.7770611,0.6383331", "l0.7766042,0.6329704", "l0.7782197,0.6322641", "l0.7792477,0.6309234", "l0.7784155,0.6275068", "l0.7782360,0.6271753", "l0.7793130,0.6252435", "l0.7831314,0.6227640", "l0.7848121,0.6219279", "l0.7884673,0.6180789", "l0.7862970,0.6148353", "l0.7832782,0.6135811", "l0.7804063,0.6150659", "l0.7678414,0.6171562", "l0.7557825,0.6172571", "l0.7456816,0.6130621", "l0.7438214,0.6097032", "l0.7418469,0.6057821", "l0.7367557,0.6002032", "l0.7324804,0.6001744", "l0.7310444,0.5984877", "l0.7341775,0.5961091", "l0.7377022,0.5941774", "l0.7426628,0.5915825", "l0.7447842,0.5904004", "l0.7535469,0.5851963", "l0.7549013,0.5834808", "l0.7581159,0.5829762", "l0.7612653,0.5822410", "l0.7629624,0.5815779", "l0.7679883,0.5754944", "l0.7678251,0.5736636", "l0.7673193,0.5711552", "l0.7677925,0.5664557", "l0.7711540,0.5614533", "l0.7739117,0.5608190", "l0.7765879,0.5608046", "l0.7795251,0.5603433", "l0.7790845,0.5559753", "l0.7780075,0.5545914", "l0.7770284,0.5526453", "l0.7792314,0.5500792", "l0.7847632,0.5483349", "l0.7866397,0.5493152", "l0.7899686,0.5493152", "l0.7979154,0.5431452", "l0.8053075,0.5405936", "l0.8084405,0.5401323", "l0.8126179,0.5383303", "l0.8151146,0.5361679", "l0.8152777,0.5347119", "l0.8148371,0.5326649", "l0.8161915,0.5313819", "l0.8223434,0.5310791", "l0.8256886,0.5326072", "l0.8301597,0.5320738", "l0.8320363,0.5306611", "l0.8376333,0.5299547", "l0.8405869,0.5310503", "l0.8423655,0.5323333", "l0.8427735,0.5343227", "l0.8529885,0.5325495", "l0.8609517,0.5310503", "l0.8645090,0.5323910", "l0.8676910,0.5299547", "l0.8712973,0.5268553", "l0.8754910,0.5257885", "l0.8787546,0.5260336", "l0.8835521,0.5263219", "l0.8868646,0.5253849", "l0.8880232,0.5234531", "l0.8888554,0.5225017", "l0.8982056,0.5152217", "l0.8996742,0.5145730", "l0.9113415,0.5133764", "l0.9201859,0.5133764", "l0.9256687,0.5157551", "l0.9266315,0.5168939", "l0.9267783,0.5184364", "l0.9279859,0.5193446", "l0.9312494,0.5172111", "l0.9334850,0.5150631", "l0.9350515,0.5133476", "l0.9363080,0.5125547", "l0.9412034,0.5109402", "c"]}, {"n": "Guaviar", "u": "CO-GUV", "i": ["m0.7782360,0.6271753", "l0.7765389,0.6271176", "l0.7643331,0.6312549", "l0.7439519,0.6361996", "l0.7404109,0.6365023", "l0.7366415,0.6364447", "l0.7290210,0.6358969", "l0.7202256,0.6419371", "l0.7187733,0.6425570", "l0.7157219,0.6424561", "l0.7136821,0.6428309", "l0.7071060,0.6464204", "l0.7025696,0.6517976", "l0.6942801,0.6600434", "l0.6896295,0.6628833", "l0.6885035,0.6645844", "l0.6844404,0.6735223", "l0.6845546,0.6750648", "l0.6848320,0.6767082", "l0.6847994,0.6798796", "l0.6797734,0.6859631", "l0.6754981,0.6896392", "l0.6738663,0.6898122", "l0.6716471,0.6902735", "l0.6695094,0.6917295", "l0.6686119,0.6929260", "l0.6680245,0.6947280", "l0.6676165,0.6963426", "l0.6617584,0.7012151", "l0.6531262,0.7084951", "l0.6519350,0.7096628", "l0.6518208,0.7098358", "l0.6506459,0.7098646", "l0.6474802,0.7076878", "l0.6411651,0.7057417", "l0.6396639,0.7063328", "l0.6382279,0.7067220", "l0.6352417,0.7016188", "l0.6335283,0.6976256", "l0.6253857,0.6880823", "l0.6212735,0.6845504", "l0.6187116,0.6849829", "l0.6173409,0.6846369", "l0.6117275,0.6813789", "l0.6103079,0.6793463", "l0.6059020,0.6783660", "l0.6000765,0.6793463", "l0.5970087,0.6806437", "l0.5945611,0.6838440", "l0.5948221,0.6852423", "l0.5955891,0.6865398", "l0.5947569,0.6877507", "l0.5843950,0.6946271", "l0.5827958,0.6949442", "l0.5803644,0.6947857", "l0.5752080,0.6928683", "l0.5739515,0.6909799", "l0.5679628,0.6864965", "l0.5659230,0.6852712", "l0.5641607,0.6842765", "l0.5618272,0.6828205", "l0.5604892,0.6816816", "l0.5592000,0.6804707", "l0.5581067,0.6787264", "l0.5580088,0.6767947", "l0.5575846,0.6750503", "l0.5551695,0.6705093", "l0.5527545,0.6680875", "l0.5498988,0.6659539", "l0.5446771,0.6602597", "l0.5434043,0.6584433", "l0.5428005,0.6553439", "l0.5428984,0.6531671", "l0.5429963,0.6526481", "l0.5429800,0.6509038", "l0.5431758,0.6367186", "l0.5432084,0.6348157", "l0.5439591,0.6145181", "l0.5457540,0.6092131", "l0.5603913,0.6108565", "l0.5654172,0.6103375", "l0.5752895,0.6084058", "l0.5878217,0.6046433", "l0.5904979,0.6017601", "l0.5925703,0.5976948", "l0.5936636,0.5968155", "l0.5960786,0.5958640", "l0.5980531,0.5954171", "l0.6008598,0.5968443", "l0.6136531,0.5940909", "l0.6156602,0.5914528", "l0.6187769,0.5889300", "l0.6302158,0.5837691", "l0.6482308,0.5823131", "l0.6540074,0.5833366", "l0.6673718,0.5815346", "l0.6716634,0.5804535", "l0.6807688,0.5809003", "l0.6930236,0.5807418", "l0.7011336,0.5791272", "l0.7086073,0.5790839", "l0.7118708,0.5790839", "l0.7151344,0.5793723", "l0.7160156,0.5799201", "l0.7165051,0.5830051", "l0.7225754,0.5820392", "l0.7300001,0.5839853", "l0.7338348,0.5858162", "l0.7406884,0.5861189", "l0.7425323,0.5846629", "l0.7432176,0.5821113", "l0.7442457,0.5806841", "l0.7486026,0.5821113", "l0.7520293,0.5834664", "l0.7537754,0.5839421", "l0.7549013,0.5834808", "l0.7535469,0.5851963", "l0.7447842,0.5904004", "l0.7426628,0.5915825", "l0.7377022,0.5941774", "l0.7341775,0.5961091", "l0.7310444,0.5984877", "l0.7324804,0.6001744", "l0.7367557,0.6002032", "l0.7418469,0.6057821", "l0.7438214,0.6097032", "l0.7456816,0.6130621", "l0.7557825,0.6172571", "l0.7678414,0.6171562", "l0.7804063,0.6150659", "l0.7832782,0.6135811", "l0.7862970,0.6148353", "l0.7884673,0.6180789", "l0.7848121,0.6219279", "l0.7831314,0.6227640", "l0.7793130,0.6252435", "c"]}, {"n": "Huila", "u": "CO-HUI", "i": ["m0.3748235,0.6584288", "l0.3715762,0.6590920", "l0.3698954,0.6591641", "l0.3685084,0.6587316", "l0.3614590,0.6548393", "l0.3565310,0.6507164", "l0.3558130,0.6493180", "l0.3561068,0.6472277", "l0.3563515,0.6450509", "l0.3559762,0.6432345", "l0.3530390,0.6395729", "l0.3499386,0.6383764", "l0.3476867,0.6384485", "l0.3461691,0.6383908", "l0.3448474,0.6370357", "l0.3439009,0.6278096", "l0.3439662,0.6247966", "l0.3459244,0.6235713", "l0.3488453,0.6229947", "l0.3510319,0.6234127", "l0.3532674,0.6243065", "l0.3552745,0.6252724", "l0.3580160,0.6260941", "l0.3606921,0.6262382", "l0.3625197,0.6258058", "l0.3635314,0.6250273", "l0.3635314,0.6232686", "l0.3629766,0.6212936", "l0.3622423,0.6199673", "l0.3615896,0.6185978", "l0.3603657,0.6153254", "l0.3605616,0.6141433", "l0.3671214,0.6075985", "l0.3686716,0.6068489", "l0.3701239,0.6069642", "l0.3734201,0.6077571", "l0.3753946,0.6075120", "l0.3770917,0.6068777", "l0.3783481,0.6058974", "l0.3803552,0.6034756", "l0.3817260,0.6018033", "l0.3838962,0.6006501", "l0.3868335,0.6014862", "l0.3897707,0.6031584", "l0.3930017,0.6055226", "l0.3943071,0.6058398", "l0.3993493,0.6046865", "l0.3991046,0.6034323", "l0.3983703,0.6016448", "l0.3955473,0.5953162", "l0.3945519,0.5937737", "l0.3927569,0.5912942", "l0.3893791,0.5847926", "l0.3851527,0.5737933", "l0.3842389,0.5726545", "l0.3846305,0.5727410", "l0.3859686,0.5727698", "l0.3876657,0.5726689", "l0.3917125,0.5717895", "l0.3943397,0.5708669", "l0.3986150,0.5681567", "l0.4002142,0.5667151", "l0.4038531,0.5635869", "l0.4056481,0.5629526", "l0.4082753,0.5628805", "l0.4104945,0.5627940", "l0.4125016,0.5625634", "l0.4138234,0.5620876", "l0.4141824,0.5607902", "l0.4139539,0.5588297", "l0.4175439,0.5534093", "l0.4185556,0.5522704", "l0.4286074,0.5485512", "l0.4304514,0.5480322", "l0.4487438,0.5455959", "l0.4506856,0.5461005", "l0.4514199,0.5473835", "l0.4510446,0.5497909", "l0.4501145,0.5509442", "l0.4487601,0.5519100", "l0.4479279,0.5536255", "l0.4493802,0.5550815", "l0.4523337,0.5557447", "l0.4543572,0.5556726", "l0.4562337,0.5552834", "l0.4607212,0.5524002", "l0.4664814,0.5462879", "l0.4663672,0.5445147", "l0.4657797,0.5430875", "l0.4662530,0.5418622", "l0.4699082,0.5364995", "l0.4725191,0.5331550", "l0.4773981,0.5276770", "l0.4790626,0.5258750", "l0.4811023,0.5243758", "l0.4827015,0.5233090", "l0.4832236,0.5230639", "l0.4833052,0.5234387", "l0.4842843,0.5245343", "l0.4869441,0.5258318", "l0.4871726,0.5272013", "l0.4864383,0.5289744", "l0.4862588,0.5292916", "l0.4836153,0.5351732", "l0.4828646,0.5365139", "l0.4818529,0.5376816", "l0.4801722,0.5394259", "l0.4793726,0.5407666", "l0.4782303,0.5442696", "l0.4771207,0.5481908", "l0.4774960,0.5494449", "l0.4777245,0.5508577", "l0.4779040,0.5542166", "l0.4741835,0.5599253", "l0.4729923,0.5613669", "l0.4715073,0.5629093", "l0.4696961,0.5641203", "l0.4685375,0.5647690", "l0.4668078,0.5656195", "l0.4640337,0.5672774", "l0.4603622,0.5696560", "l0.4586325,0.5709822", "l0.4568865,0.5749610", "l0.4564785,0.5754079", "l0.4514036,0.5810157", "l0.4505388,0.5827023", "l0.4507020,0.5849224", "l0.4519911,0.5866523", "l0.4528070,0.5879353", "l0.4531986,0.5898238", "l0.4501635,0.5931682", "l0.4430325,0.5983147", "l0.4410580,0.5987616", "l0.4397200,0.5982859", "l0.4373049,0.5977237", "l0.4351346,0.5995112", "l0.4342698,0.6006789", "l0.4336986,0.6026683", "l0.4330133,0.6059695", "l0.4302229,0.6105682", "l0.4272530,0.6128171", "l0.4165322,0.6239749", "l0.4152757,0.6273771", "l0.4096297,0.6340516", "l0.4026129,0.6413316", "l0.3898033,0.6559637", "l0.3876331,0.6573332", "l0.3854301,0.6573332", "l0.3827377,0.6575062", "l0.3757046,0.6579964", "c"]}, {"n": "La Guajira", "u": "CO-LAG", "i": ["m0.5929945,0.1307651", "l0.5922113,0.1305921", "l0.5887682,0.1303038", "l0.5866958,0.1304623", "l0.5840523,0.1309669", "l0.5825674,0.1313273", "l0.5802176,0.1317021", "l0.5779167,0.1318174", "l0.5741962,0.1295830", "l0.5779004,0.1254456", "l0.5800218,0.1246239", "l0.5808377,0.1230814", "l0.5815883,0.1190161", "l0.5805929,0.1167384", "l0.5693661,0.1060851", "l0.5670327,0.1048165", "l0.5650092,0.1045138", "l0.5618762,0.1046435", "l0.5565239,0.1046724", "l0.5505515,0.1045859", "l0.5488381,0.1044417", "l0.5468963,0.1039804", "l0.5457377,0.1029280", "l0.5445792,0.1013135", "l0.5434859,0.0976086", "l0.5447587,0.0895357", "l0.5467658,0.0869409", "l0.5480059,0.0859462", "l0.5490829,0.0844037", "l0.5502741,0.0825728", "l0.5507310,0.0813187", "l0.5507147,0.0799924", "l0.5526239,0.0800933", "l0.5609950,0.0798482", "l0.5636548,0.0795023", "l0.5655314,0.0791275", "l0.5677180,0.0785364", "l0.5688603,0.0778877", "l0.5729724,0.0753217", "l0.5736741,0.0736638", "l0.5772314,0.0707807", "l0.5845092,0.0660667", "l0.6023937,0.0549088", "l0.6049393,0.0537700", "l0.6192828,0.0488974", "l0.6213225,0.0490992", "l0.6233296,0.0490560", "l0.6261037,0.0482775", "l0.6352907,0.0435779", "l0.6367103,0.0427707", "l0.6384564,0.0411993", "l0.6447714,0.0296522", "l0.6447551,0.0284125", "l0.6442982,0.0235687", "l0.6427480,0.0227038", "l0.6434823,0.0215217", "l0.6447714,0.0210171", "l0.6521798,0.0205126", "l0.6564714,0.0208730", "l0.6552802,0.0224587", "l0.6533057,0.0244481", "l0.6550354,0.0265961", "l0.6565856,0.0268123", "l0.6582827,0.0262501", "l0.6632270,0.0233525", "l0.6668986,0.0171537", "l0.6747475,0.0139533", "l0.6788923,0.0106233", "l0.6772931,0.0095709", "l0.6739805,0.0098304", "l0.6718103,0.0110702", "l0.6726425,0.0094412", "l0.6748944,0.0083312", "l0.6768525,0.0080573", "l0.6834450,0.0086771", "l0.6857947,0.0091384", "l0.7028144,0.0151787", "l0.7050010,0.0166491", "l0.7065022,0.0178456", "l0.7136332,0.0301279", "l0.7138943,0.0315263", "l0.7136658,0.0331264", "l0.7125236,0.0350293", "l0.7096679,0.0370187", "l0.7057516,0.0390081", "l0.7023575,0.0409975", "l0.6998608,0.0442122", "l0.6995182,0.0449474", "l0.6942311,0.0473693", "l0.6898742,0.0484073", "l0.6792186,0.0508291", "l0.6728220,0.0528473", "l0.6695910,0.0541304", "l0.6562266,0.0562062", "l0.6492099,0.0664992", "l0.6400229,0.0812754", "l0.6327288,0.0864219", "l0.6305748,0.0864940", "l0.6223505,0.0882239", "l0.6210614,0.0889302", "l0.6177815,0.0943939", "l0.6114828,0.1025532", "l0.6067016,0.1101071", "l0.5996196,0.1209190", "l0.5978246,0.1230958", "l0.5933372,0.1296983", "c"]}, {"n": "Magdalena", "u": "CO-MAG", "i": ["m0.5279838,0.2175918", "l0.5245570,0.2175486", "l0.5191558,0.2165827", "l0.5096914,0.2138437", "l0.5060198,0.2106289", "l0.5042901,0.2081494", "l0.4992152,0.2041418", "l0.4963433,0.2025561", "l0.4901261,0.2001054", "l0.4878743,0.2001198", "l0.4811349,0.1976835", "l0.4765496,0.1933011", "l0.4722906,0.1907495", "l0.4708057,0.1909369", "l0.4694023,0.1910810", "l0.4654044,0.1895385", "l0.4655023,0.1866986", "l0.4662530,0.1826045", "l0.4646049,0.1762904", "l0.4639521,0.1752236", "l0.4607864,0.1660551", "l0.4606070,0.1647577", "l0.4604111,0.1610528", "l0.4610475,0.1594815", "l0.4630546,0.1586886", "l0.4651923,0.1575497", "l0.4656655,0.1552288", "l0.4620756,0.1507887", "l0.4595952,0.1501688", "l0.4564622,0.1488714", "l0.4557932,0.1469973", "l0.4580287,0.1404814", "l0.4608517,0.1344123", "l0.4645069,0.1270458", "l0.4657145,0.1256763", "l0.4671668,0.1244653", "l0.4702672,0.1226489", "l0.4708873,0.1200541", "l0.4712463,0.1138697", "l0.4713605,0.1099486", "l0.4711810,0.1017027", "l0.4675747,0.0958354", "l0.4667099,0.0945524", "l0.4651270,0.0932262", "l0.4629731,0.0920152", "l0.4616513,0.0891176", "l0.4617003,0.0887717", "l0.4634626,0.0899682", "l0.4856387,0.0967148", "l0.4875805,0.0970896", "l0.4892776,0.0972914", "l0.4911052,0.0973347", "l0.4940588,0.0973347", "l0.4966207,0.0971185", "l0.4983504,0.0968157", "l0.4999495,0.0963832", "l0.4991010,0.0973203", "l0.4975834,0.0978248", "l0.4957395,0.0980555", "l0.4914153,0.0983726", "l0.4882985,0.0980411", "l0.4797969,0.1036777", "l0.4787362,0.1069212", "l0.4796990,0.1093431", "l0.4846759,0.1075700", "l0.4882985,0.1103810", "l0.4888044,0.1117938", "l0.4930307,0.1118226", "l0.4943525,0.1110153", "l0.4954947,0.1093431", "l0.4972571,0.1045138", "l0.5000638,0.0982717", "l0.5018751,0.0953021", "l0.5041433,0.0891897", "l0.5035395,0.0844902", "l0.5036537,0.0821836", "l0.5051060,0.0801222", "l0.5068847,0.0776859", "l0.5091692,0.0763740", "l0.5170997,0.0748748", "l0.5187315,0.0749469", "l0.5216361,0.0759271", "l0.5228763,0.0771237", "l0.5285386,0.0791851", "l0.5336624,0.0803384", "l0.5416256,0.0803672", "l0.5443833,0.0800068", "l0.5468474,0.0798915", "l0.5493766,0.0798482", "l0.5507147,0.0799924", "l0.5507310,0.0813187", "l0.5502741,0.0825728", "l0.5490829,0.0844037", "l0.5480059,0.0859462", "l0.5467658,0.0869409", "l0.5447587,0.0895357", "l0.5434859,0.0976086", "l0.5445792,0.1013135", "l0.5433227,0.1027983", "l0.5428658,0.1041246", "l0.5431758,0.1059410", "l0.5440896,0.1071375", "l0.5466679,0.1096170", "l0.5490829,0.1120965", "l0.5477285,0.1149509", "l0.5467984,0.1163204", "l0.5466189,0.1175746", "l0.5466679,0.1187855", "l0.5471737,0.1204145", "l0.5497030,0.1226201", "l0.5505189,0.1246960", "l0.5372687,0.1303182", "l0.5282775,0.1333167", "l0.5269068,0.1337203", "l0.5232516,0.1354935", "l0.5169039,0.1451233", "l0.5162838,0.1466946", "l0.5146520,0.1522159", "l0.5223867,0.1612690", "l0.5303989,0.1711727", "l0.5340704,0.1804133", "l0.5251445,0.1808746", "l0.5179809,0.1805286", "l0.5160880,0.1814512", "l0.5118290,0.1865545", "l0.5132487,0.1876789", "l0.5154190,0.1884573", "l0.5174098,0.1900287", "l0.5182909,0.1911819", "l0.5214566,0.1955500", "l0.5228110,0.1975538", "l0.5233821,0.1993269", "l0.5269068,0.2060735", "l0.5288813,0.2076160", "l0.5309210,0.2095045", "l0.5323244,0.2114795", "l0.5309210,0.2136995", "l0.5286202,0.2166259", "c"]}, {"n": "Meta", "u": "CO-MET", "i": ["m0.7158035,0.4600233", "l0.7156729,0.4605567", "l0.7157056,0.4910463", "l0.7157382,0.5042368", "l0.7158035,0.5194311", "l0.7158524,0.5559177", "l0.7159014,0.5710831", "l0.7159340,0.5791560", "l0.7160156,0.5799201", "l0.7151344,0.5793723", "l0.7118708,0.5790839", "l0.7086073,0.5790839", "l0.7011336,0.5791272", "l0.6930236,0.5807418", "l0.6807688,0.5809003", "l0.6716634,0.5804535", "l0.6673718,0.5815346", "l0.6540074,0.5833366", "l0.6482308,0.5823131", "l0.6302158,0.5837691", "l0.6187769,0.5889300", "l0.6156602,0.5914528", "l0.6136531,0.5940909", "l0.6008598,0.5968443", "l0.5980531,0.5954171", "l0.5960786,0.5958640", "l0.5936636,0.5968155", "l0.5925703,0.5976948", "l0.5904979,0.6017601", "l0.5878217,0.6046433", "l0.5752895,0.6084058", "l0.5654172,0.6103375", "l0.5603913,0.6108565", "l0.5457540,0.6092131", "l0.5439591,0.6145181", "l0.5432084,0.6348157", "l0.5431758,0.6367186", "l0.5429800,0.6509038", "l0.5429963,0.6526481", "l0.5407771,0.6519561", "l0.5389821,0.6518408", "l0.5368118,0.6521147", "l0.5317696,0.6534121", "l0.5294198,0.6540753", "l0.5263030,0.6551276", "l0.5245081,0.6554015", "l0.5211792,0.6557475", "l0.5190416,0.6554015", "l0.5107683,0.6501253", "l0.5091202,0.6478044", "l0.5048286,0.6440706", "l0.5007165,0.6431769", "l0.4985952,0.6428741", "l0.4968655,0.6427444", "l0.4952500,0.6425714", "l0.4931613,0.6422110", "l0.4902893,0.6416776", "l0.4871726,0.6405532", "l0.4851492,0.6393422", "l0.4831094,0.6372375", "l0.4809065,0.6348157", "l0.4785893,0.6311540", "l0.4781488,0.6294674", "l0.4780508,0.6282564", "l0.4780835,0.6258202", "l0.4781488,0.6238884", "l0.4774960,0.6198520", "l0.4769902,0.6183095", "l0.4758479,0.6160174", "l0.4744609,0.6124999", "l0.4741345,0.6110007", "l0.4731228,0.5994247", "l0.4736776,0.5977813", "l0.4757174,0.5952153", "l0.4766638,0.5943792", "l0.4782140,0.5927646", "l0.4790626,0.5911789", "l0.4795521,0.5896219", "l0.4796990,0.5882236", "l0.4795195,0.5869694", "l0.4787199,0.5853116", "l0.4779040,0.5843457", "l0.4764843,0.5831348", "l0.4750973,0.5822410", "l0.4684722,0.5781613", "l0.4670689,0.5774982", "l0.4656492,0.5769792", "l0.4629404,0.5762873", "l0.4568865,0.5749610", "l0.4586325,0.5709822", "l0.4603622,0.5696560", "l0.4640337,0.5672774", "l0.4668078,0.5656195", "l0.4685375,0.5647690", "l0.4696961,0.5641203", "l0.4715073,0.5629093", "l0.4729923,0.5613669", "l0.4741835,0.5599253", "l0.4779040,0.5542166", "l0.4777245,0.5508577", "l0.4774960,0.5494449", "l0.4771207,0.5481908", "l0.4782303,0.5442696", "l0.4793726,0.5407666", "l0.4801722,0.5394259", "l0.4818529,0.5376816", "l0.4828646,0.5365139", "l0.4836153,0.5351732", "l0.4862588,0.5292916", "l0.4864383,0.5305313", "l0.4876948,0.5311368", "l0.4890492,0.5308917", "l0.4901588,0.5298105", "l0.4915621,0.5270715", "l0.4925249,0.5249236", "l0.4937487,0.5230495", "l0.5033437,0.5138089", "l0.5050407,0.5126845", "l0.5070479,0.5123097", "l0.5094955,0.5124106", "l0.5112253,0.5122953", "l0.5128244,0.5117907", "l0.5157127,0.5101761", "l0.5171650,0.5091670", "l0.5185683,0.5079128", "l0.5198411,0.5070335", "l0.5307252,0.5021321", "l0.5335482,0.5020456", "l0.5350658,0.5020600", "l0.5368608,0.5012527", "l0.5368608,0.4982830", "l0.5365834,0.4969568", "l0.5336951,0.4916085", "l0.5317206,0.4911760", "l0.5305294,0.4897777", "l0.5315085,0.4876153", "l0.5339072,0.4843717", "l0.5360285,0.4829446", "l0.5445465,0.4848619", "l0.5463904,0.4856980", "l0.5476959,0.4866206", "l0.5485444,0.4886965", "l0.5489197,0.4907724", "l0.5492461,0.4921275", "l0.5505842,0.4954143", "l0.5520854,0.4965243", "l0.5554469,0.4971730", "l0.5568992,0.4968991", "l0.5585800,0.4959188", "l0.5620067,0.4951548", "l0.5729724,0.4975911", "l0.5783247,0.4951260", "l0.5818820,0.4779423", "l0.5830569,0.4723777", "l0.5835628,0.4710803", "l0.5857983,0.4735743", "l0.5878217,0.4760682", "l0.5885234,0.4776684", "l0.5892740,0.4798163", "l0.5925703,0.4838095", "l0.6041560,0.4949097", "l0.6054778,0.4959621", "l0.6141752,0.4952845", "l0.6211430,0.4946070", "l0.6273438,0.4938141", "l0.6297915,0.4925023", "l0.6309011,0.4916085", "l0.6328103,0.4893885", "l0.6384400,0.4875144", "l0.6445593,0.4868801", "l0.6466317,0.4874856", "l0.6480350,0.4886965", "l0.6495036,0.4901237", "l0.6514455,0.4902678", "l0.6556881,0.4885523", "l0.6614973,0.4845447", "l0.6629333,0.4831464", "l0.6700479,0.4791388", "l0.6759387,0.4773800", "l0.6778969,0.4766737", "l0.6792023,0.4759961", "l0.6837224,0.4730409", "l0.6970052,0.4677070", "l0.6986043,0.4671015", "l0.7027981,0.4657464", "l0.7046746,0.4656023", "l0.7072529,0.4648527", "l0.7097495,0.4635985", "l0.7151508,0.4606576", "c"]}, {"n": "Nariño", "u": "CO-NAR", "i": ["m0.3294922,0.6722104", "l0.3281867,0.6723834", "l0.3261959,0.6727726", "l0.3247273,0.6732916", "l0.3186081,0.6764631", "l0.3171395,0.6772271", "l0.3150345,0.6783948", "l0.3131253,0.6796057", "l0.3123746,0.6806293", "l0.3127500,0.6918448", "l0.3131089,0.6933873", "l0.3138269,0.6949298", "l0.3158993,0.7005664", "l0.3181022,0.7090574", "l0.3179880,0.7104557", "l0.3156219,0.7116090", "l0.3136148,0.7121856", "l0.3117219,0.7125460", "l0.3106776,0.7170149", "l0.3114935,0.7191629", "l0.3121299,0.7213541", "l0.3125541,0.7246697", "l0.3126684,0.7266159", "l0.3125215,0.7283458", "l0.3049826,0.7298018", "l0.3031550,0.7297297", "l0.2969215,0.7281440", "l0.2923688,0.7268609", "l0.2894969,0.7252031", "l0.2875387,0.7176204", "l0.2878651,0.7150255", "l0.2880446,0.7128631", "l0.2866739,0.7108738", "l0.2846831,0.7102971", "l0.2833287,0.7107008", "l0.2818274,0.7108593", "l0.2798530,0.7097781", "l0.2788576,0.7090574", "l0.2758551,0.7076014", "l0.2743538,0.7065346", "l0.2735216,0.7052516", "l0.2733584,0.7034352", "l0.2737174,0.7017773", "l0.2722325,0.7001339", "l0.2708618,0.6996582", "l0.2653952,0.7006817", "l0.2630944,0.7018350", "l0.2604183,0.7015179", "l0.2584438,0.7008115", "l0.2553271,0.6978995", "l0.2506438,0.6961840", "l0.2484409,0.6964146", "l0.2458953,0.6961840", "l0.2438719,0.6955064", "l0.2388133,0.6922773", "l0.2351254,0.6894806", "l0.2338853,0.6887887", "l0.2315192,0.6882553", "l0.2297405,0.6879669", "l0.2282556,0.6874480", "l0.2268033,0.6865109", "l0.2208962,0.6814510", "l0.2199334,0.6802545", "l0.2192154,0.6792021", "l0.2142711,0.6782074", "l0.2129167,0.6788417", "l0.2108117,0.6762180", "l0.2081029,0.6750936", "l0.2064385,0.6745169", "l0.2050351,0.6737097", "l0.1961418,0.6647286", "l0.1928456,0.6582270", "l0.1881624,0.6562953", "l0.1867916,0.6560646", "l0.1843113,0.6560070", "l0.1812599,0.6552141", "l0.1799544,0.6532680", "l0.1852088,0.6461465", "l0.1913607,0.6418218", "l0.1937594,0.6411731", "l0.1993891,0.6420957", "l0.2013309,0.6429895", "l0.2088209,0.6454113", "l0.2110891,0.6452672", "l0.2136347,0.6384773", "l0.2138795,0.6364158", "l0.2105016,0.6304621", "l0.2089351,0.6297557", "l0.2066016,0.6277519", "l0.2048230,0.6223892", "l0.2043987,0.6200971", "l0.2073849,0.6144316", "l0.2114154,0.6078148", "l0.2125740,0.6061713", "l0.2131451,0.6084491", "l0.2142058,0.6065750", "l0.2154297,0.6058830", "l0.2192970,0.6053496", "l0.2199497,0.6017457", "l0.2218100,0.6015006", "l0.2244209,0.6032593", "l0.2258079,0.6044703", "l0.2272928,0.6056668", "l0.2327756,0.6008663", "l0.2408857,0.6025386", "l0.2423543,0.6027404", "l0.2514760,0.6006645", "l0.2539400,0.5985742", "l0.2545601,0.5954459", "l0.2547233,0.5965271", "l0.2554087,0.5979399", "l0.2562409,0.5992229", "l0.2580358,0.6012555", "l0.2619358,0.6063876", "l0.2642530,0.6100348", "l0.2668312,0.6150083", "l0.2676798,0.6162769", "l0.2704375,0.6183239", "l0.2722161,0.6191745", "l0.2736032,0.6195637", "l0.2755287,0.6199529", "l0.2791350,0.6203854", "l0.2805220,0.6203854", "l0.2836550,0.6203133", "l0.2908023,0.6195925", "l0.2920425,0.6201692", "l0.2931194,0.6215098", "l0.2960730,0.6259067", "l0.3015722,0.6318316", "l0.3044278,0.6340660", "l0.3061901,0.6354788", "l0.3056027,0.6369204", "l0.3040688,0.6389530", "l0.3025512,0.6396306", "l0.3005278,0.6414470", "l0.2997609,0.6424849", "l0.2991081,0.6504136", "l0.3011642,0.6506443", "l0.3037261,0.6506299", "l0.3130437,0.6500244", "l0.3145449,0.6497505", "l0.3171395,0.6489144", "l0.3184939,0.6487702", "l0.3312056,0.6557042", "l0.3326089,0.6574630", "l0.3327721,0.6590487", "l0.3313198,0.6693705", "l0.3294922,0.6722104", "c", "m0.2421422,0.6020052", "l0.2415710,0.6019043", "l0.2361371,0.5974642", "l0.2360882,0.5966569", "l0.2362677,0.5957054", "l0.2368062,0.5948405", "l0.2377363,0.5937593", "l0.2397597,0.5933124", "l0.2405430,0.5931971", "l0.2416526,0.5933412", "l0.2434965,0.5962965", "l0.2437739,0.5968587", "l0.2444103,0.5998140", "l0.2441982,0.6004338", "l0.2425827,0.6018322", "l0.2421422,0.6020052", "c"]}, {"n": "Norte de Santander", "u": "CO-NSA", "i": ["m0.6504827,0.3317222", "l0.6491773,0.3326592", "l0.6478718,0.3331926", "l0.6459953,0.3331493", "l0.6437597,0.3326160", "l0.6420137,0.3324718", "l0.6406266,0.3329187", "l0.6338710,0.3363208", "l0.6327940,0.3382958", "l0.6318313,0.3399104", "l0.6298568,0.3414529", "l0.6282576,0.3419142", "l0.6237865,0.3420439", "l0.6196744,0.3420439", "l0.6187769,0.3423323", "l0.6173899,0.3423323", "l0.6164924,0.3413952", "l0.6167535,0.3390599", "l0.6166719,0.3368686", "l0.6155786,0.3359604", "l0.6107158,0.3371570", "l0.6092309,0.3380507", "l0.5957686,0.3330196", "l0.5953770,0.3234475", "l0.5960297,0.3165855", "l0.5960297,0.3152160", "l0.5957686,0.3138033", "l0.5939736,0.3095362", "l0.5930761,0.3079648", "l0.5873812,0.2992577", "l0.5857330,0.2988540", "l0.5730377,0.2988108", "l0.5716670,0.2994595", "l0.5708674,0.3006127", "l0.5694477,0.3027030", "l0.5650092,0.3030346", "l0.5557080,0.3005263", "l0.5543862,0.3001514", "l0.5528687,0.2990270", "l0.5520201,0.2969367", "l0.5493603,0.2945869", "l0.5469453,0.2935490", "l0.5542720,0.2927561", "l0.5561649,0.2923380", "l0.5590532,0.2909974", "l0.5608155,0.2895414", "l0.5624473,0.2872781", "l0.5665431,0.2797386", "l0.5669348,0.2777059", "l0.5653519,0.2720405", "l0.5646502,0.2703539", "l0.5631000,0.2674707", "l0.5605708,0.2643713", "l0.5595917,0.2622521", "l0.5595917,0.2608394", "l0.5606360,0.2597870", "l0.5621373,0.2596140", "l0.5640465,0.2585761", "l0.5646013,0.2561398", "l0.5647808,0.2533576", "l0.5647318,0.2514114", "l0.5644218,0.2500852", "l0.5637038,0.2489895", "l0.5621862,0.2483697", "l0.5598364,0.2485282", "l0.5589553,0.2496094", "l0.5592000,0.2515412", "l0.5592980,0.2528386", "l0.5592164,0.2544820", "l0.5573235,0.2558659", "l0.5554469,0.2553614", "l0.5546800,0.2538765", "l0.5518406,0.2440305", "l0.5523791,0.2397202", "l0.5528850,0.2382065", "l0.5538151,0.2367793", "l0.5560670,0.2348476", "l0.5571277,0.2336511", "l0.5580904,0.2314743", "l0.5579436,0.2279568", "l0.5573561,0.2249295", "l0.5576009,0.2204317", "l0.5592000,0.2107731", "l0.5595101,0.2095910", "l0.5603423,0.2077314", "l0.5610113,0.2065204", "l0.5614193,0.2059582", "l0.5636059,0.2062609", "l0.5719281,0.2059726", "l0.5757138,0.2045022", "l0.5771987,0.2028155", "l0.5861736,0.1981448", "l0.5881155,0.2006099", "l0.5896494,0.2041851", "l0.5893719,0.2055546", "l0.5945447,0.2090720", "l0.6016594,0.2114074", "l0.6045313,0.2211525", "l0.6094104,0.2376443", "l0.6256468,0.2526368", "l0.6268380,0.2528674", "l0.6270827,0.2529683", "l0.6279965,0.2538477", "l0.6288124,0.2557938", "l0.6314560,0.2668220", "l0.6322392,0.2705701", "l0.6319944,0.2721991", "l0.6308359,0.2730352", "l0.6279150,0.2730496", "l0.6231828,0.2806179", "l0.6222526,0.2963601", "l0.6223342,0.3057880", "l0.6259078,0.3103867", "l0.6270827,0.3111796", "l0.6273438,0.3112372", "l0.6323208,0.3120301", "l0.6364492,0.3122463", "l0.6436944,0.3160666", "l0.6430743,0.3182001", "l0.6430254,0.3198003", "l0.6443308,0.3235916", "l0.6451630,0.3251053", "l0.6464685,0.3271812", "l0.6478718,0.3292427", "l0.6496505,0.3316933", "c"]}, {"n": "Putumayo", "u": "CO-PUT", "i": ["m0.3806326,0.6881255", "l0.3815791,0.6877940", "l0.3894933,0.6882985", "l0.3911088,0.6901005", "l0.3908803,0.6921908", "l0.3916473,0.6934017", "l0.3961673,0.6977986", "l0.4023029,0.6997591", "l0.4069209,0.6991537", "l0.4097765,0.6982310", "l0.4159937,0.7013160", "l0.4168748,0.7032189", "l0.4184087,0.7045884", "l0.4240221,0.7059147", "l0.4276284,0.7056985", "l0.4289501,0.7054534", "l0.4308593,0.7049344", "l0.4335518,0.7055111", "l0.4354610,0.7068085", "l0.4381208,0.7131515", "l0.4375007,0.7151985", "l0.4377455,0.7170149", "l0.4398179,0.7207919", "l0.4417108,0.7211667", "l0.4437505,0.7201432", "l0.4456271,0.7190620", "l0.4520074,0.7216712", "l0.4530681,0.7225794", "l0.4539166,0.7241363", "l0.4537371,0.7253184", "l0.4528396,0.7269186", "l0.4545367,0.7337661", "l0.4616187,0.7363898", "l0.4636584,0.7368079", "l0.4708873,0.7377161", "l0.4722090,0.7385955", "l0.4732860,0.7401091", "l0.4758316,0.7466107", "l0.4748036,0.7475765", "l0.4733350,0.7486289", "l0.4748036,0.7532708", "l0.4800906,0.7560675", "l0.4880538,0.7573793", "l0.4893429,0.7563270", "l0.4890981,0.7551304", "l0.4901914,0.7542655", "l0.4973060,0.7561828", "l0.5003412,0.7582587", "l0.5016303,0.7598300", "l0.5074558,0.7627564", "l0.5124654,0.7639818", "l0.5147989,0.7661442", "l0.5180298,0.7689841", "l0.5225173,0.7711321", "l0.5249323,0.7718817", "l0.5306599,0.7731070", "l0.5259767,0.7743468", "l0.5177198,0.7767687", "l0.5070479,0.7799690", "l0.4983341,0.7827512", "l0.4969960,0.7831405", "l0.4946952,0.7836450", "l0.4943035,0.7830828", "l0.4931123,0.7816268", "l0.4821467,0.7742170", "l0.4787362,0.7721988", "l0.4770391,0.7735539", "l0.4719316,0.7709014", "l0.4714584,0.7692436", "l0.4713768,0.7679461", "l0.4710994,0.7666487", "l0.4702672,0.7649621", "l0.4692065,0.7634628", "l0.4676563,0.7618194", "l0.4663346,0.7613725", "l0.4649475,0.7616897", "l0.4630220,0.7628573", "l0.4617492,0.7632754", "l0.4565111,0.7613004", "l0.4549936,0.7596282", "l0.4509141,0.7568171", "l0.4431304,0.7522329", "l0.4385614,0.7517283", "l0.4377781,0.7535879", "l0.4371580,0.7552169", "l0.4349225,0.7567883", "l0.4331275,0.7566153", "l0.4321648,0.7555918", "l0.4304514,0.7547700", "l0.4288196,0.7541790", "l0.4255070,0.7538042", "l0.4231246,0.7530690", "l0.4174460,0.7500272", "l0.4136439,0.7476774", "l0.4056644,0.7470143", "l0.4034125,0.7474612", "l0.4011770,0.7467981", "l0.3909619,0.7399217", "l0.3864255,0.7344293", "l0.3834230,0.7306667", "l0.3823950,0.7296288", "l0.3753293,0.7276682", "l0.3687532,0.7262122", "l0.3581302,0.7263996", "l0.3576733,0.7335211", "l0.3549155,0.7349771", "l0.3484373,0.7366205", "l0.3469850,0.7365340", "l0.3457612,0.7359285", "l0.3439336,0.7342851", "l0.3369005,0.7328435", "l0.3361989,0.7340256", "l0.3332943,0.7348617", "l0.3305202,0.7353086", "l0.3268160,0.7354240", "l0.3154750,0.7314884", "l0.3124889,0.7283314", "l0.3126357,0.7266159", "l0.3125215,0.7246697", "l0.3120972,0.7213541", "l0.3114608,0.7191629", "l0.3106449,0.7170149", "l0.3116730,0.7125460", "l0.3135658,0.7121856", "l0.3155566,0.7116090", "l0.3179391,0.7104557", "l0.3180533,0.7090718", "l0.3158504,0.7005664", "l0.3137780,0.6949298", "l0.3130763,0.6933873", "l0.3127173,0.6918448", "l0.3123257,0.6806293", "l0.3130926,0.6796202", "l0.3150018,0.6784092", "l0.3171068,0.6772415", "l0.3185918,0.6764775", "l0.3247110,0.6733060", "l0.3261959,0.6727870", "l0.3281867,0.6723834", "l0.3294922,0.6722104", "l0.3341917,0.6714031", "l0.3361336,0.6709851", "l0.3385650,0.6692840", "l0.3403599,0.6666891", "l0.3423181,0.6656512", "l0.3452227,0.6658818", "l0.3470340,0.6673234", "l0.3496122,0.6717779", "l0.3503465,0.6734358", "l0.3504118,0.6746323", "l0.3496775,0.6759153", "l0.3490084,0.6769532", "l0.3485842,0.6781209", "l0.3477520,0.6838728", "l0.3495143,0.6871020", "l0.3511624,0.6887022", "l0.3587503,0.6914844", "l0.3602515,0.6919169", "l0.3624708,0.6921908", "l0.3710540,0.6922485", "l0.3729306,0.6918881", "l0.3798983,0.6896248", "c"]}, {"n": "Quindío", "u": "CO-QUI", "i": ["m0.4049464,0.4723633", "l0.4059255,0.4719597", "l0.4129422,0.4724066", "l0.4173317,0.4729976", "l0.4193388,0.4734733", "l0.4211828,0.4734157", "l0.4254254,0.4712677", "l0.4258987,0.4720606", "l0.4205627,0.4789658", "l0.4159284,0.4838816", "l0.4139050,0.4861737", "l0.4131380,0.4875000", "l0.4132849,0.4902967", "l0.4131217,0.4926609", "l0.4126158,0.4938718", "l0.4120447,0.4950106", "l0.4114083,0.4960630", "l0.4105761,0.4970000", "l0.4088953,0.4987299", "l0.4048322,0.5041071", "l0.4041468,0.5071632", "l0.4042284,0.5087490", "l0.4027272,0.5078119", "l0.4015033,0.5058946", "l0.4004916,0.5028961", "l0.3992514,0.4990183", "l0.3945519,0.4806957", "l0.3940786,0.4786631", "l0.3942418,0.4772935", "l0.3953188,0.4764430", "l0.3986966,0.4767025", "l0.4019276,0.4766448", "l0.4049627,0.4760970", "l0.4057460,0.4749438", "c"]}, {"n": "Risaralda", "u": "CO-RIS", "i": ["m0.4254254,0.4712677", "l0.4211828,0.4734157", "l0.4193388,0.4734733", "l0.4173317,0.4729976", "l0.4129422,0.4724066", "l0.4059255,0.4719597", "l0.4049464,0.4723633", "l0.4008996,0.4707055", "l0.3921042,0.4687594", "l0.3869314,0.4621713", "l0.3815954,0.4575871", "l0.3791967,0.4558283", "l0.3777770,0.4553814", "l0.3748724,0.4558283", "l0.3737791,0.4554535", "l0.3722779,0.4547616", "l0.3709561,0.4540119", "l0.3697649,0.4529019", "l0.3690143,0.4518351", "l0.3626339,0.4395240", "l0.3622097,0.4377220", "l0.3678557,0.4325179", "l0.3690959,0.4317971", "l0.3801594,0.4271552", "l0.3823787,0.4264200", "l0.3839941,0.4258866", "l0.3852833,0.4255262", "l0.3862460,0.4260163", "l0.3919736,0.4259010", "l0.3933443,0.4257424", "l0.3929201,0.4323737", "l0.3940623,0.4336712", "l0.3958410,0.4331666", "l0.3984355,0.4320277", "l0.4030209,0.4311051", "l0.4086832,0.4346658", "l0.4071004,0.4373904", "l0.4047506,0.4397979", "l0.3980929,0.4431280", "l0.3907498,0.4491538", "l0.3897707,0.4511864", "l0.3924468,0.4575726", "l0.3938991,0.4586250", "l0.3962816,0.4586106", "l0.4037878,0.4570537", "l0.4107882,0.4593026", "l0.4159937,0.4595476", "l0.4173807,0.4596197", "l0.4201221,0.4611190", "l0.4255233,0.4652419", "l0.4229125,0.4682692", "l0.4231899,0.4694369", "c"]}, {"n": "Santander", "u": "CO-SAN", "i": ["m0.5244265,0.3180271", "l0.5256340,0.3088298", "l0.5284081,0.3032220", "l0.5311984,0.2993153", "l0.5324712,0.2896999", "l0.5314269,0.2850436", "l0.5302194,0.2828092", "l0.5282449,0.2769852", "l0.5281959,0.2751688", "l0.5281633,0.2731649", "l0.5285060,0.2718243", "l0.5295340,0.2696475", "l0.5320959,0.2675716", "l0.5338909,0.2666201", "l0.5347884,0.2680473", "l0.5374156,0.2724874", "l0.5387373,0.2750678", "l0.5410382,0.2808486", "l0.5405323,0.2832849", "l0.5392105,0.2851734", "l0.5376440,0.2872492", "l0.5370239,0.2893972", "l0.5379051,0.2909685", "l0.5420336,0.2912136", "l0.5448892,0.2914154", "l0.5466189,0.2927994", "l0.5469453,0.2935490", "l0.5493603,0.2945869", "l0.5520201,0.2969367", "l0.5528687,0.2990270", "l0.5543862,0.3001514", "l0.5557080,0.3005263", "l0.5650092,0.3030346", "l0.5694477,0.3027030", "l0.5708674,0.3006127", "l0.5716670,0.2994595", "l0.5730377,0.2988108", "l0.5857330,0.2988540", "l0.5873812,0.2992577", "l0.5930761,0.3079648", "l0.5939736,0.3095362", "l0.5957686,0.3138033", "l0.5960297,0.3152160", "l0.5960297,0.3165855", "l0.5953770,0.3234475", "l0.5957686,0.3330196", "l0.6092309,0.3380507", "l0.6107158,0.3371570", "l0.6155786,0.3359604", "l0.6166719,0.3368686", "l0.6167535,0.3390599", "l0.6164924,0.3413952", "l0.6173899,0.3423323", "l0.6187769,0.3423323", "l0.6196744,0.3420439", "l0.6201802,0.3430242", "l0.6208493,0.3448694", "l0.6216162,0.3535766", "l0.6215020,0.3553209", "l0.6210941,0.3568923", "l0.6179773,0.3648354", "l0.6172104,0.3662049", "l0.6161171,0.3673582", "l0.6148280,0.3680357", "l0.6132614,0.3683385", "l0.6097368,0.3684394", "l0.6084966,0.3645038", "l0.6076317,0.3628028", "l0.6037644,0.3606836", "l0.6017899,0.3609575", "l0.6017410,0.3669257", "l0.6022142,0.3690016", "l0.6032748,0.3704864", "l0.6043192,0.3722019", "l0.6044987,0.3752004", "l0.6034870,0.3776799", "l0.6016920,0.3805919", "l0.5892251,0.3942149", "l0.5843134,0.3984964", "l0.5800870,0.3979054", "l0.5782594,0.3975882", "l0.5763502,0.3977757", "l0.5749142,0.3981072", "l0.5730866,0.3989001", "l0.5720096,0.3999525", "l0.5717322,0.4017112", "l0.5725645,0.4037727", "l0.5722870,0.4051998", "l0.5711448,0.4062810", "l0.5673917,0.4078379", "l0.5653682,0.4080397", "l0.5631164,0.4074775", "l0.5616641,0.4064828", "l0.5606523,0.4047673", "l0.5602118,0.4023311", "l0.5604728,0.4008606", "l0.5622678,0.3978766", "l0.5627737,0.3962620", "l0.5629369,0.3949646", "l0.5628063,0.3933500", "l0.5621536,0.3919805", "l0.5608645,0.3909137", "l0.5529992,0.3872521", "l0.5509268,0.3897172", "l0.5469453,0.3982370", "l0.5456561,0.4050701", "l0.5453787,0.4063098", "l0.5442528,0.4097408", "l0.5426210,0.4107067", "l0.5405813,0.4095102", "l0.5384436,0.4080109", "l0.5296156,0.4089047", "l0.5216035,0.4106490", "l0.5202817,0.4096832", "l0.5190252,0.4067567", "l0.5178993,0.4057909", "l0.5106052,0.4021869", "l0.5045349,0.3972134", "l0.5014345,0.3913750", "l0.4997211,0.3908272", "l0.4979588,0.3913029", "l0.4967349,0.3918940", "l0.4954621,0.3923841", "l0.4935529,0.3918940", "l0.4912358,0.3900199", "l0.4886412,0.3865889", "l0.4851002,0.3815290", "l0.4828320,0.3791792", "l0.4855082,0.3781701", "l0.4870910,0.3771321", "l0.4934387,0.3708901", "l0.4940098,0.3696503", "l0.4922964,0.3671564", "l0.4917579,0.3620676", "l0.4923943,0.3600349", "l0.4948257,0.3573680", "l0.4969470,0.3573103", "l0.5013692,0.3554939", "l0.5093161,0.3500303", "l0.5113884,0.3485743", "l0.5124328,0.3476661", "l0.5137056,0.3457056", "l0.5154679,0.3431107", "l0.5189273,0.3398383", "l0.5212118,0.3387571", "l0.5242633,0.3375462", "l0.5272984,0.3350955", "l0.5274127,0.3335818", "l0.5266620,0.3312176", "l0.5254056,0.3298769", "l0.5245407,0.3283777", "l0.5237411,0.3220924", "l0.5237248,0.3208670", "l0.5240675,0.3191083", "c"]}, {"n": "Sucre", "u": "CO-SUC", "i": ["m0.4035757,0.1910090", "l0.4060887,0.1916000", "l0.4081774,0.1907351", "l0.4096786,0.1893944", "l0.4106414,0.1879672", "l0.4121263,0.1849399", "l0.4125995,0.1834839", "l0.4129585,0.1813215", "l0.4129912,0.1799376", "l0.4125669,0.1782365", "l0.4118979,0.1763913", "l0.4101845,0.1743875", "l0.4079000,0.1707114", "l0.4096297,0.1668624", "l0.4122568,0.1589048", "l0.4126485,0.1575786", "l0.4133338,0.1536142", "l0.4133338,0.1520429", "l0.4131707,0.1510338", "l0.4143129,0.1505725", "l0.4171359,0.1499814", "l0.4204158,0.1566560", "l0.4265677,0.1633882", "l0.4295376,0.1645126", "l0.4301740,0.1660695", "l0.4304024,0.1703654", "l0.4302719,0.1716196", "l0.4353957,0.1748776", "l0.4527580,0.1875203", "l0.4539819,0.1887312", "l0.4556463,0.1905044", "l0.4567396,0.1919027", "l0.4570007,0.1932578", "l0.4570660,0.1949157", "l0.4565275,0.1981304", "l0.4563480,0.1995431", "l0.4566254,0.2012154", "l0.4577187,0.2035363", "l0.4600032,0.2075151", "l0.4627609,0.2104992", "l0.4667099,0.2127192", "l0.4680969,0.2131661", "l0.4693860,0.2136419", "l0.4711320,0.2145212", "l0.4749994,0.2169143", "l0.4769412,0.2184856", "l0.4791115,0.2215273", "l0.4827178,0.2286776", "l0.4802375,0.2305949", "l0.4802211,0.2413780", "l0.4808086,0.2436845", "l0.4818203,0.2464235", "l0.4827831,0.2478363", "l0.4809718,0.2521755", "l0.4782140,0.2570624", "l0.4767291,0.2586482", "l0.4734818,0.2590230", "l0.4709852,0.2594122", "l0.4691086,0.2600033", "l0.4685212,0.2603925", "l0.4670036,0.2585905", "l0.4665467,0.2563561", "l0.4662530,0.2540783", "l0.4613902,0.2502437", "l0.4518768,0.2467263", "l0.4500492,0.2484850", "l0.4487275,0.2496383", "l0.4448928,0.2519736", "l0.4398342,0.2531701", "l0.4394426,0.2507050", "l0.4391815,0.2474903", "l0.4375334,0.2466398", "l0.4360811,0.2468272", "l0.4334049,0.2476200", "l0.4314468,0.2471155", "l0.4295212,0.2369667", "l0.4256049,0.2279568", "l0.4257028,0.2262846", "l0.4308756,0.2245547", "l0.4337639,0.2241943", "l0.4359505,0.2240069", "l0.4379903,0.2247277", "l0.4388714,0.2210804", "l0.4387898,0.2195812", "l0.4362442,0.2134545", "l0.4322790,0.2104415", "l0.4309572,0.2097928", "l0.4295702,0.2092883", "l0.4244627,0.2081782", "l0.4231899,0.2072268", "l0.4169401,0.2014749", "l0.4082753,0.1964581", "l0.4070188,0.1955211", "l0.4057949,0.1943390", "l0.4046853,0.1930416", "c"]}, {"n": "San Andrés, Providencia y Santa Catalina", "u": "CO-SAP", "i": ["m0.0008812,0.0064715", "l0.0004079,0.0060967", "l0.0004079,0.0031414", "l0.0008322,0.0019449", "l0.0014523,0.0010223", "l0.0022845,0.0004169", "l0.0030188,0.0006908", "l0.0023661,0.0039343", "l0.0015992,0.0054336", "l0.0010770,0.0064283", "c"]}, {"n": "Tolima", "u": "CO-TOL", "i": ["m0.4042284,0.5087490", "l0.4041468,0.5071632", "l0.4048322,0.5041071", "l0.4088953,0.4987299", "l0.4105761,0.4970000", "l0.4114083,0.4960630", "l0.4120447,0.4950106", "l0.4126158,0.4938718", "l0.4131217,0.4926609", "l0.4132849,0.4902967", "l0.4131380,0.4875000", "l0.4139050,0.4861737", "l0.4159284,0.4838816", "l0.4205627,0.4789658", "l0.4258987,0.4720606", "l0.4254254,0.4712677", "l0.4231899,0.4694369", "l0.4229125,0.4682692", "l0.4255233,0.4652419", "l0.4291296,0.4627479", "l0.4301903,0.4616379", "l0.4302229,0.4603261", "l0.4290154,0.4589277", "l0.4281832,0.4572843", "l0.4310551,0.4480149", "l0.4315284,0.4468040", "l0.4334049,0.4449444", "l0.4355752,0.4446560", "l0.4378597,0.4446560", "l0.4439137,0.4441082", "l0.4450559,0.4434595", "l0.4458882,0.4417440", "l0.4465572,0.4407061", "l0.4481564,0.4392645", "l0.4502124,0.4378229", "l0.4520074,0.4369724", "l0.4567559,0.4359633", "l0.4582735,0.4356894", "l0.4623367,0.4356894", "l0.4651433,0.4358479", "l0.4677705,0.4364390", "l0.4692392,0.4369003", "l0.4695166,0.4375490", "l0.4704630,0.4472653", "l0.4675094,0.4639156", "l0.4639195,0.4708064", "l0.4646049,0.4772503", "l0.4648823,0.4791532", "l0.4653228,0.4813156", "l0.4661551,0.4829734", "l0.4649802,0.4861449", "l0.4602643,0.4940304", "l0.4591710,0.4966540", "l0.4605090,0.4975911", "l0.4735797,0.5020456", "l0.4752278,0.5022042", "l0.4771370,0.5014401", "l0.4787362,0.4991768", "l0.4811186,0.4984704", "l0.4829952,0.4989606", "l0.4845943,0.5005896", "l0.4868136,0.5035448", "l0.4874989,0.5049288", "l0.4875642,0.5067163", "l0.4853287,0.5107383", "l0.4850839,0.5175570", "l0.4849044,0.5193590", "l0.4832236,0.5230639", "l0.4827015,0.5233090", "l0.4811023,0.5243758", "l0.4790626,0.5258750", "l0.4773981,0.5276770", "l0.4725191,0.5331550", "l0.4699082,0.5364995", "l0.4662530,0.5418622", "l0.4657797,0.5430875", "l0.4663672,0.5445147", "l0.4664814,0.5462879", "l0.4607212,0.5524002", "l0.4562337,0.5552834", "l0.4543572,0.5556726", "l0.4523337,0.5557447", "l0.4493802,0.5550815", "l0.4479279,0.5536255", "l0.4487601,0.5519100", "l0.4501145,0.5509442", "l0.4510446,0.5497909", "l0.4514199,0.5473835", "l0.4506856,0.5461005", "l0.4487438,0.5455959", "l0.4304514,0.5480322", "l0.4286074,0.5485512", "l0.4185556,0.5522704", "l0.4175439,0.5534093", "l0.4139539,0.5588297", "l0.4141824,0.5607902", "l0.4138234,0.5620876", "l0.4125016,0.5625634", "l0.4104945,0.5627940", "l0.4082753,0.5628805", "l0.4056481,0.5629526", "l0.4038531,0.5635869", "l0.4002142,0.5667151", "l0.3986150,0.5681567", "l0.3943397,0.5708669", "l0.3917125,0.5717895", "l0.3876657,0.5726689", "l0.3859686,0.5727698", "l0.3846305,0.5727410", "l0.3842389,0.5726545", "l0.3832598,0.5707804", "l0.3812690,0.5676954", "l0.3793925,0.5653168", "l0.3786255,0.5641491", "l0.3787561,0.5627075", "l0.3790661,0.5607326", "l0.3789682,0.5597234", "l0.3797841,0.5591468", "l0.3849569,0.5437507", "l0.3886448,0.5310503", "l0.3901460,0.5237847", "l0.3906519,0.5225449", "l0.3924795,0.5196762", "l0.3943234,0.5172543", "l0.3958410,0.5157551", "l0.3971954,0.5154956", "l0.3984519,0.5160001", "l0.3997247,0.5164470", "l0.4038531,0.5135206", "l0.4042284,0.5117907", "l0.4043590,0.5094409", "c"]}, {"n": "Valle del Cauca", "u": "CO-VAC", "i": ["m0.3789682,0.5597234", "l0.3761126,0.5593919", "l0.3737138,0.5586278", "l0.3708582,0.5575178", "l0.3687858,0.5564799", "l0.3670887,0.5555573", "l0.3646411,0.5544184", "l0.3589298,0.5534814", "l0.3557478,0.5538129", "l0.3542302,0.5561195", "l0.3553561,0.5574457", "l0.3555193,0.5597955", "l0.3539854,0.5623183", "l0.3458101,0.5655186", "l0.3427913,0.5658214", "l0.3367537,0.5690217", "l0.3277788,0.5730293", "l0.3237972,0.5690938", "l0.3198646,0.5674359", "l0.3183470,0.5693388", "l0.3063044,0.5683585", "l0.2956487,0.5614966", "l0.2926625,0.5576908", "l0.2903780,0.5553987", "l0.2888115,0.5546346", "l0.2863638,0.5529192", "l0.2875713,0.5513046", "l0.2933642,0.5480466", "l0.3014253,0.5389502", "l0.3036119,0.5384312", "l0.3083604,0.5330685", "l0.3092090,0.5305169", "l0.3093885,0.5269850", "l0.3156382,0.5181337", "l0.3122604,0.5188256", "l0.3102696,0.5195464", "l0.3071039,0.5214349", "l0.3051621,0.5225594", "l0.3018985,0.5228333", "l0.2999893,0.5227612", "l0.2985533,0.5220692", "l0.2978190,0.5182778", "l0.2986186,0.5162164", "l0.3003483,0.5152793", "l0.3034161,0.5149622", "l0.3052437,0.5097437", "l0.3036772,0.5087490", "l0.3003157,0.5076534", "l0.2980148,0.5095562", "l0.2968236,0.5108825", "l0.2957140,0.5141117", "l0.2946860,0.5162020", "l0.2932174,0.5176868", "l0.2894316,0.5133909", "l0.2886320,0.5114447", "l0.2884525,0.5048999", "l0.2892195,0.5027375", "l0.2951592,0.5004598", "l0.2992713,0.5005896", "l0.3011479,0.4987876", "l0.3026491,0.5012671", "l0.3038730,0.5021465", "l0.3064512,0.5015843", "l0.3080014,0.5015266", "l0.3101717,0.5023051", "l0.3168947,0.5073939", "l0.3261959,0.5101329", "l0.3309934,0.5127566", "l0.3324784,0.5132900", "l0.3343386,0.5133909", "l0.3361499,0.5131746", "l0.3465771,0.5102482", "l0.3540997,0.5049288", "l0.3549971,0.5028096", "l0.3519946,0.5001715", "l0.3503465,0.4984416", "l0.3497917,0.4973172", "l0.3493838,0.4961495", "l0.3489595,0.4944917", "l0.3486821,0.4918536", "l0.3488126,0.4905561", "l0.3491716,0.4891722", "l0.3500202,0.4880622", "l0.3550624,0.4798019", "l0.3599741,0.4699270", "l0.3607084,0.4685143", "l0.3616549,0.4675484", "l0.3691938,0.4620848", "l0.3705808,0.4613640", "l0.3721473,0.4607586", "l0.3734201,0.4599513", "l0.3743013,0.4582214", "l0.3747255,0.4567509", "l0.3748724,0.4558283", "l0.3777770,0.4553814", "l0.3791967,0.4558283", "l0.3815954,0.4575871", "l0.3869314,0.4621713", "l0.3921042,0.4687594", "l0.4008996,0.4707055", "l0.4049464,0.4723633", "l0.4057460,0.4749438", "l0.4049627,0.4760970", "l0.4019276,0.4766448", "l0.3986966,0.4767025", "l0.3953188,0.4764430", "l0.3942418,0.4772935", "l0.3940786,0.4786631", "l0.3945519,0.4806957", "l0.3992514,0.4990183", "l0.4004916,0.5028961", "l0.4015033,0.5058946", "l0.4027272,0.5078119", "l0.4042284,0.5087490", "l0.4043590,0.5094409", "l0.4042284,0.5117907", "l0.4038531,0.5135206", "l0.3997247,0.5164470", "l0.3984519,0.5160001", "l0.3971954,0.5154956", "l0.3958410,0.5157551", "l0.3943234,0.5172543", "l0.3924795,0.5196762", "l0.3906519,0.5225449", "l0.3901460,0.5237847", "l0.3886448,0.5310503", "l0.3849569,0.5437507", "l0.3797841,0.5591468", "c"]}, {"n": "Vichada", "u": "CO-VID", "i": ["m0.7158035,0.4600233", "l0.7169457,0.4593890", "l0.7184307,0.4582790", "l0.7196545,0.4568807", "l0.7269976,0.4459246", "l0.7298043,0.4447281", "l0.7317298,0.4437190", "l0.7423691,0.4350695", "l0.7424996,0.4338441", "l0.7424996,0.4326332", "l0.7432013,0.4311051", "l0.7450779,0.4300095", "l0.7464975,0.4292166", "l0.7586871,0.4228160", "l0.7649695,0.4206392", "l0.7667808,0.4204518", "l0.7700933,0.4205383", "l0.7716435,0.4202932", "l0.7756904,0.4194283", "l0.7774201,0.4189381", "l0.7822012,0.4162424", "l0.7839473,0.4145125", "l0.7908987,0.4064396", "l0.7925468,0.4025185", "l0.7934606,0.4000101", "l0.7951087,0.3969251", "l0.7961205,0.3955700", "l0.7983234,0.3932202", "l0.7991393,0.3927157", "l0.7999878,0.3922400", "l0.8022397,0.3913894", "l0.8042794,0.3910723", "l0.8084568,0.3914471", "l0.8123079,0.3918219", "l0.8162405,0.3917787", "l0.8189166,0.3915913", "l0.8224740,0.3904956", "l0.8243179,0.3896739", "l0.8269777,0.3877710", "l0.8286748,0.3870503", "l0.8308777,0.3861565", "l0.8345982,0.3859979", "l0.8356262,0.3875260", "l0.8376497,0.3894145", "l0.8395915,0.3898181", "l0.8427245,0.3888522", "l0.8455475,0.3864448", "l0.8480768,0.3841815", "l0.8499371,0.3827543", "l0.8520584,0.3819903", "l0.8541145,0.3820624", "l0.8674299,0.3837490", "l0.8724232,0.3847581", "l0.8752136,0.3854933", "l0.8769596,0.3864160", "l0.8801742,0.3867764", "l0.8861140,0.3850464", "l0.8910257,0.3837490", "l0.8925759,0.3835040", "l0.8949094,0.3834319", "l0.8979282,0.3841527", "l0.9016160,0.3848446", "l0.9032478,0.3843833", "l0.9076537,0.3830138", "l0.9100524,0.3822930", "l0.9126633,0.3815866", "l0.9142135,0.3815434", "l0.9161390,0.3816587", "l0.9186520,0.3821489", "l0.9207244,0.3826102", "l0.9232373,0.3825093", "l0.9259624,0.3818894", "l0.9286059,0.3806784", "l0.9344641,0.3765555", "l0.9437327,0.3774205", "l0.9476327,0.3778818", "l0.9524465,0.3792369", "l0.9544046,0.3803901", "l0.9569829,0.3826246", "l0.9585657,0.3832733", "l0.9597896,0.3833598", "l0.9574561,0.3856807", "l0.9572276,0.3876125", "l0.9577009,0.3890108", "l0.9587778,0.3906831", "l0.9610950,0.3925139", "l0.9625147,0.3950799", "l0.9616824,0.3961899", "l0.9593000,0.3974585", "l0.9581414,0.3982802", "l0.9545841,0.4012643", "l0.9501946,0.4052142", "l0.9486607,0.4071460", "l0.9471105,0.4107499", "l0.9465231,0.4136043", "l0.9467189,0.4154495", "l0.9471595,0.4178137", "l0.9477306,0.4198319", "l0.9489381,0.4216195", "l0.9466862,0.4257568", "l0.9440590,0.4275156", "l0.9400775,0.4296780", "l0.9386252,0.4299951", "l0.9362917,0.4313934", "l0.9332892,0.4359344", "l0.9345620,0.4463139", "l0.9351821,0.4485772", "l0.9363733,0.4517631", "l0.9364549,0.4556842", "l0.9356390,0.4641030", "l0.9354268,0.4658618", "l0.9348884,0.4696964", "l0.9326038,0.4800902", "l0.9375808,0.4934970", "l0.9364712,0.4955440", "l0.9361775,0.4971586", "l0.9361285,0.4995949", "l0.9374503,0.5034583", "l0.9413176,0.5081291", "l0.9427047,0.5105221", "l0.9412034,0.5109402", "l0.9363080,0.5125547", "l0.9350515,0.5133476", "l0.9334850,0.5150631", "l0.9312494,0.5172111", "l0.9279859,0.5193446", "l0.9267783,0.5184364", "l0.9266315,0.5168939", "l0.9256687,0.5157551", "l0.9201859,0.5133764", "l0.9113415,0.5133764", "l0.8996742,0.5145730", "l0.8982056,0.5152217", "l0.8888554,0.5225017", "l0.8880232,0.5234531", "l0.8868646,0.5253849", "l0.8835521,0.5263219", "l0.8787546,0.5260336", "l0.8754910,0.5257885", "l0.8712973,0.5268553", "l0.8676910,0.5299547", "l0.8645090,0.5323910", "l0.8609517,0.5310503", "l0.8529885,0.5325495", "l0.8427735,0.5343227", "l0.8423655,0.5323333", "l0.8405869,0.5310503", "l0.8376333,0.5299547", "l0.8320363,0.5306611", "l0.8301597,0.5320738", "l0.8256886,0.5326072", "l0.8223434,0.5310791", "l0.8161915,0.5313819", "l0.8148371,0.5326649", "l0.8152777,0.5347119", "l0.8151146,0.5361679", "l0.8126179,0.5383303", "l0.8084405,0.5401323", "l0.8053075,0.5405936", "l0.7979154,0.5431452", "l0.7899686,0.5493152", "l0.7866397,0.5493152", "l0.7847632,0.5483349", "l0.7792314,0.5500792", "l0.7770284,0.5526453", "l0.7780075,0.5545914", "l0.7790845,0.5559753", "l0.7795251,0.5603433", "l0.7765879,0.5608046", "l0.7739117,0.5608190", "l0.7711540,0.5614533", "l0.7677925,0.5664557", "l0.7673193,0.5711552", "l0.7678251,0.5736636", "l0.7679883,0.5754944", "l0.7629624,0.5815779", "l0.7612653,0.5822410", "l0.7581159,0.5829762", "l0.7549013,0.5834808", "l0.7537754,0.5839421", "l0.7520293,0.5834664", "l0.7486026,0.5821113", "l0.7442457,0.5806841", "l0.7432176,0.5821113", "l0.7425323,0.5846629", "l0.7406884,0.5861189", "l0.7338348,0.5858162", "l0.7300001,0.5839853", "l0.7225754,0.5820392", "l0.7165051,0.5830051", "l0.7160156,0.5799201", "l0.7159340,0.5791560", "l0.7159014,0.5710831", "l0.7158524,0.5559177", "l0.7158035,0.5194311", "l0.7157382,0.5042368", "l0.7157056,0.4910463", "l0.7156729,0.4605567", "c"]}, {"n": "Vaupés", "u": "CO-VAU", "i": ["m0.8261292,0.8096224", "l0.8244811,0.8127795", "l0.8247095,0.8173349", "l0.8137438,0.8186323", "l0.8124710,0.8135291", "l0.8125690,0.8122173", "l0.8072656,0.8081664", "l0.8003631,0.8096368", "l0.7957125,0.8115397", "l0.7943744,0.8119722", "l0.7921552,0.8116406", "l0.7916820,0.8104297", "l0.7935096,0.8058454", "l0.7931832,0.8036542", "l0.7836699,0.8042165", "l0.7814506,0.8054851", "l0.7803899,0.8067536", "l0.7802920,0.8079646", "l0.7812548,0.8089160", "l0.7831966,0.8093485", "l0.7841757,0.8102279", "l0.7836535,0.8115974", "l0.7825276,0.8127074", "l0.7811569,0.8132264", "l0.7792803,0.8130966", "l0.7710071,0.8073014", "l0.7701749,0.8060617", "l0.7696527,0.8046489", "l0.7700933,0.8033659", "l0.7724105,0.8021694", "l0.7741728,0.8009585", "l0.7736180,0.7984213", "l0.7720678,0.7970085", "l0.7703707,0.7957111", "l0.7702728,0.7934478", "l0.7724431,0.7903916", "l0.7723452,0.7834432", "l0.7747929,0.7754568", "l0.7736343,0.7741306", "l0.7703381,0.7726025", "l0.7663239,0.7752694", "l0.7674988,0.7770137", "l0.7651163,0.7774894", "l0.7606289,0.7761920", "l0.7584749,0.7744045", "l0.7574958,0.7730494", "l0.7548687,0.7706563", "l0.7378817,0.7658126", "l0.7367394,0.7677299", "l0.7318277,0.7694886", "l0.7291842,0.7656829", "l0.7264265,0.7547556", "l0.7247294,0.7519301", "l0.7213353,0.7487586", "l0.7187570,0.7496957", "l0.7120503,0.7478216", "l0.6981474,0.7403542", "l0.6965483,0.7392730", "l0.6934642,0.7379323", "l0.6885035,0.7377305", "l0.6872634,0.7386243", "l0.6866270,0.7392298", "l0.6851420,0.7395901", "l0.6789249,0.7365628", "l0.6735889,0.7335787", "l0.6686935,0.7296432", "l0.6644672,0.7286918", "l0.6621174,0.7223344", "l0.6576463,0.7154436", "l0.6531262,0.7108305", "l0.6518208,0.7098358", "l0.6519350,0.7096628", "l0.6531262,0.7084951", "l0.6617584,0.7012151", "l0.6676165,0.6963426", "l0.6680245,0.6947280", "l0.6686119,0.6929260", "l0.6695094,0.6917295", "l0.6716471,0.6902735", "l0.6738663,0.6898122", "l0.6754981,0.6896392", "l0.6797734,0.6859631", "l0.6847994,0.6798796", "l0.6848320,0.6767082", "l0.6845546,0.6750648", "l0.6844404,0.6735223", "l0.6885035,0.6645844", "l0.6896295,0.6628833", "l0.6942801,0.6600434", "l0.7025696,0.6517976", "l0.7071060,0.6464204", "l0.7136821,0.6428309", "l0.7157219,0.6424561", "l0.7187733,0.6425570", "l0.7202256,0.6419371", "l0.7290210,0.6358969", "l0.7366415,0.6364447", "l0.7404109,0.6365023", "l0.7439519,0.6361996", "l0.7643331,0.6312549", "l0.7765389,0.6271176", "l0.7782360,0.6271753", "l0.7784155,0.6275068", "l0.7792477,0.6309234", "l0.7782197,0.6322641", "l0.7766042,0.6329704", "l0.7770611,0.6383331", "l0.7786439,0.6403081", "l0.7820217,0.6428741", "l0.7846652,0.6447049", "l0.7866071,0.6452960", "l0.7886958,0.6454113", "l0.7905560,0.6456564", "l0.7967242,0.6469827", "l0.7989598,0.6485972", "l0.7992045,0.6493324", "l0.7992045,0.6862803", "l0.8075430,0.6862659", "l0.8145924,0.6859343", "l0.8265861,0.6882697", "l0.8305187,0.6872029", "l0.8330969,0.6862370", "l0.8380413,0.6885436", "l0.8405216,0.6905906", "l0.8464124,0.6985914", "l0.8451396,0.7051218", "l0.8472609,0.7115513", "l0.8417455,0.7131803", "l0.8365237,0.7127911", "l0.8337333,0.7108161", "l0.8249706,0.7060877", "l0.8098928,0.7095907", "l0.8054217,0.7121423", "l0.8023376,0.7140597", "l0.7938196,0.7142759", "l0.7897075,0.7142759", "l0.7855954,0.7150255", "l0.7854811,0.7193791", "l0.7853506,0.7278124", "l0.7852690,0.7314452", "l0.7850732,0.7410750", "l0.7848611,0.7495515", "l0.7847305,0.7547556", "l0.7846979,0.7588497", "l0.7871456,0.7615743", "l0.7930690,0.7675137", "l0.8061234,0.7764515", "l0.8076246,0.7767542", "l0.8095501,0.7771002", "l0.8134501,0.7787148", "l0.8150656,0.7802429", "l0.8172848,0.7870327", "l0.8166648,0.7889789", "l0.8157510,0.7908962", "l0.8144782,0.7923090", "l0.8146576,0.7941686", "l0.8210380,0.8046489", "l0.8235183,0.8059175", "l0.8266513,0.8086421", "c"]}]} """;
}
