import 'package:flutter/material.dart';

class SMapFranceColors {
  /// Alsace
  final Color? frA;

  /// Aquitaine
  final Color? frB;

  /// Auvergne
  final Color? frC;

  /// Bourgogne
  final Color? frD;

  /// Bretagne
  final Color? frE;

  /// Centre
  final Color? frF;

  /// Champagne-Ardenne
  final Color? frG;

  /// Corse
  final Color? frH;

  /// Franche-Comté
  final Color? frI;

  /// Île-de-France
  final Color? frJ;

  /// Languedoc-Roussillon
  final Color? frK;

  /// Limousin
  final Color? frL;

  /// Lorraine
  final Color? frM;

  /// Midi-Pyrénées
  final Color? frN;

  /// Nord-Pas-de-Calais
  final Color? frO;

  /// Basse-Normandie
  final Color? frP;

  /// Haute-Normandie
  final Color? frQ;

  /// Pays de la Loire
  final Color? frR;

  /// Picardie
  final Color? frS;

  /// Poitou-Charentes
  final Color? frT;

  /// Provence-Alpes-Côte d'Azur
  final Color? frU;

  /// Rhône-Alpes
  final Color? frV;
  SMapFranceColors({
    this.frA,
    this.frB,
    this.frC,
    this.frD,
    this.frE,
    this.frF,
    this.frG,
    this.frH,
    this.frI,
    this.frJ,
    this.frK,
    this.frL,
    this.frM,
    this.frN,
    this.frO,
    this.frP,
    this.frQ,
    this.frR,
    this.frS,
    this.frT,
    this.frU,
    this.frV,
  });
  Map<String, Color?> toMap() {
    return {
      "FR-A": frA,
      "FR-B": frB,
      "FR-C": frC,
      "FR-D": frD,
      "FR-E": frE,
      "FR-F": frF,
      "FR-G": frG,
      "FR-H": frH,
      "FR-I": frI,
      "FR-J": frJ,
      "FR-K": frK,
      "FR-L": frL,
      "FR-M": frM,
      "FR-N": frN,
      "FR-O": frO,
      "FR-P": frP,
      "FR-Q": frQ,
      "FR-R": frR,
      "FR-S": frS,
      "FR-T": frT,
      "FR-U": frU,
      "FR-V": frV,
    };
  }

  static SMapFranceColors fromMap(Map<String, Color?> map) {
    return SMapFranceColors(
      frA: map["FR-A"],
      frB: map["FR-B"],
      frC: map["FR-C"],
      frD: map["FR-D"],
      frE: map["FR-E"],
      frF: map["FR-F"],
      frG: map["FR-G"],
      frH: map["FR-H"],
      frI: map["FR-I"],
      frJ: map["FR-J"],
      frK: map["FR-K"],
      frL: map["FR-L"],
      frM: map["FR-M"],
      frN: map["FR-N"],
      frO: map["FR-O"],
      frP: map["FR-P"],
      frQ: map["FR-Q"],
      frR: map["FR-R"],
      frS: map["FR-S"],
      frT: map["FR-T"],
      frU: map["FR-U"],
      frV: map["FR-V"],
    );
  }
}

class SMapFrance {
  static const String instructions =
      """{"n": "France", "w": 596.41547, "h": 584.5448, "g": {"a": "-4.796120,51.089515","b": "9.560553,41.363289"}, "i":[{"n": "Alsace", "u": "FR-A", "i": ["m0.8100645,0.3566774", "l0.8158658,0.3537521", "l0.8142562,0.3494239", "l0.8165364,0.3474224", "l0.8153292,0.3464130", "l0.8175592,0.3379107", "l0.8214994,0.3356012", "l0.8268313,0.3262606", "l0.8256241,0.3224628", "l0.8353488,0.3049106", "l0.8340075,0.3017800", "l0.8296146,0.3024643", "l0.8267642,0.3004285", "l0.8290110,0.2977427", "l0.8273846,0.2955358", "l0.8296313,0.2874098", "l0.8277199,0.2842963", "l0.8308050,0.2849122", "l0.8260097,0.2820724", "l0.8329847,0.2817302", "l0.8366902,0.2790786", "l0.8426927,0.2675482", "l0.8399765,0.2672916", "l0.8383669,0.2641097", "l0.8433969,0.2560350", "l0.8388196,0.2516726", "l0.8395741,0.2501330", "l0.8321464,0.2476524", "l0.8302685,0.2523056", "l0.8269151,0.2541874", "l0.8276696,0.2512963", "l0.8250875,0.2508173", "l0.8250205,0.2477893", "l0.8280888,0.2458048", "l0.8249869,0.2461812", "l0.8248528,0.2445047", "l0.8183137,0.2424689", "l0.8175592,0.2381750", "l0.8199737,0.2381921", "l0.8207952,0.2351641", "l0.8237127,0.2357115", "l0.8261606,0.2239245", "l0.8283068,0.2226244", "l0.8302685,0.2303398", "l0.8419717,0.2337955", "l0.8417370,0.2357628", "l0.8441850,0.2370801", "l0.8529708,0.2343771", "l0.8588727,0.2382605", "l0.8617734,0.2356089", "l0.8658309,0.2251905", "l0.8658309,0.2251905", "l0.8724706,0.2248655", "l0.8726718,0.2262683", "l0.8767629,0.2238561", "l0.8817930,0.2273460", "l0.8864877,0.2247115", "l0.8975706,0.2320505", "l0.9072786,0.2346337", "l0.9014772,0.2412714", "l0.8973358,0.2522543", "l0.8891536,0.2571128", "l0.8886003,0.2608935", "l0.8799151,0.2695669", "l0.8771989,0.2756742", "l0.8776180,0.2830988", "l0.8750024,0.2857162", "l0.8725041,0.2959464", "l0.8733593,0.3031144", "l0.8697712,0.3058173", "l0.8679100,0.3143368", "l0.8616728,0.3250802", "l0.8611698,0.3342497", "l0.8648417,0.3408360", "l0.8602644,0.3506556", "l0.8583865,0.3611938", "l0.8596607,0.3659838", "l0.8571290,0.3698158", "l0.8626788,0.3795841", "l0.8621087,0.3825950", "l0.8562403,0.3863928", "l0.8584368,0.3876075", "l0.8561397,0.3883773", "l0.8570787,0.3907210", "l0.8555026,0.3923633", "l0.8515288,0.3910118", "l0.8507911,0.3925686", "l0.8532055,0.3935437", "l0.8483934,0.3976153", "l0.8443694,0.3966572", "l0.8384339,0.3987443", "l0.8376627,0.3968625", "l0.8333368,0.3963835", "l0.8355500,0.3911316", "l0.8307212,0.3901907", "l0.8307212,0.3901907", "l0.8314589,0.3879154", "l0.8274852,0.3807645", "l0.8218683,0.3797894", "l0.8246851,0.3724846", "l0.8240312,0.3671129", "l0.8173077,0.3620491", "l0.8121603,0.3608345", "c"]}, {"n": "Aquitaine", "u": "FR-B", "i": ["m0.3781005,0.5750011", "l0.3797269,0.5772080", "l0.3844383,0.5764724", "l0.3881941,0.5793293", "l0.3865677,0.5843589", "l0.3907762,0.5886870", "l0.3947332,0.5838456", "l0.3967117,0.5860354", "l0.4051286,0.5850603", "l0.4098066,0.5931178", "l0.4119359,0.5914242", "l0.4154570,0.5936481", "l0.4122880,0.5986948", "l0.4243099,0.6029716", "l0.4217278,0.6061023", "l0.4264560,0.6084460", "l0.4223314,0.6140743", "l0.4203529,0.6141769", "l0.4196990,0.6191552", "l0.4232200,0.6209856", "l0.4197325,0.6259981", "l0.4239913,0.6275720", "l0.4219793,0.6298301", "l0.4219793,0.6298301", "l0.4216272,0.6298643", "l0.4216272,0.6298643", "l0.4253159,0.6331490", "l0.4325256,0.6339701", "l0.4301615,0.6359546", "l0.4350406,0.6445253", "l0.4350406,0.6445253", "l0.4324083,0.6460650", "l0.4324083,0.6460650", "l0.4326933,0.6472454", "l0.4326933,0.6472454", "l0.4346550,0.6549266", "l0.4326430,0.6555253", "l0.4345879,0.6587073", "l0.4291387,0.6622656", "l0.4294238,0.6655160", "l0.4247123,0.6670215", "l0.4259363,0.6725813", "l0.4195481,0.6781926", "l0.4143001,0.6795611", "l0.4147192,0.6826405", "l0.4106114,0.6871568", "l0.4112820,0.6891584", "l0.4050951,0.6927680", "l0.4027477,0.6920666", "l0.4052124,0.6957618", "l0.4052460,0.7018349", "l0.4078784,0.7036140", "l0.4082808,0.7096529", "l0.4006519,0.7100464", "l0.3999141,0.7116716", "l0.3984554,0.7078224", "l0.3967787,0.7081133", "l0.3949008,0.7151273", "l0.4005680,0.7186514", "l0.3974997,0.7268971", "l0.3937942,0.7275472", "l0.3960242,0.7284368", "l0.3966278,0.7320977", "l0.3943978,0.7332097", "l0.3893175,0.7315332", "l0.3899379,0.7347323", "l0.3870540,0.7350915", "l0.3858300,0.7395908", "l0.3805149,0.7432688", "l0.3755854,0.7377603", "l0.3730034,0.7402408", "l0.3663972,0.7401553", "l0.3650894,0.7428411", "l0.3561862,0.7447743", "l0.3551970,0.7466219", "l0.3503514,0.7435425", "l0.3476184,0.7442268", "l0.3451704,0.7483839", "l0.3431081,0.7455441", "l0.3381451,0.7495130", "l0.3395703,0.7539096", "l0.3383798,0.7559283", "l0.3328132,0.7526950", "l0.3347414,0.7502486", "l0.3317402,0.7472719", "l0.3275988,0.7527634", "l0.3217807,0.7517027", "l0.3176057,0.7557914", "l0.3213112,0.7586654", "l0.3197687,0.7597090", "l0.3208250,0.7643964", "l0.3185279,0.7645675", "l0.3207411,0.7715130", "l0.3169015,0.7744555", "l0.3174381,0.7795877", "l0.3146715,0.7807339", "l0.3148224,0.7831460", "l0.3170692,0.7834026", "l0.3176728,0.7866359", "l0.3219483,0.7853015", "l0.3275652,0.7867043", "l0.3277664,0.7904680", "l0.3296611,0.7900061", "l0.3329977,0.7974135", "l0.3296946,0.7982860", "l0.3295940,0.8033669", "l0.3342217,0.8000138", "l0.3340205,0.8071305", "l0.3363343,0.8096624", "l0.3310527,0.8140247", "l0.3330648,0.8170356", "l0.3308348,0.8220823", "l0.3291748,0.8216717", "l0.3295437,0.8261367", "l0.3260897,0.8258459", "l0.3240945,0.8308070", "l0.3208250,0.8322269", "l0.3217304,0.8382658", "l0.3161135,0.8396857", "l0.3142188,0.8427651", "l0.3146883,0.8496593", "l0.3114691,0.8512674", "l0.3124583,0.8578195", "l0.3124583,0.8578195", "l0.3067911,0.8626951", "l0.3034378,0.8630372", "l0.2990113,0.8599579", "l0.2958256,0.8647309", "l0.2870230,0.8543980", "l0.2832840,0.8532518", "l0.2817415,0.8463405", "l0.2685627,0.8477604", "l0.2566583,0.8409175", "l0.2547133,0.8424742", "l0.2532211,0.8398397", "l0.2486940,0.8379066", "l0.2463467,0.8390357", "l0.2431107,0.8366235", "l0.2457766,0.8317821", "l0.2406795,0.8340916", "l0.2400088,0.8404898", "l0.2340231,0.8387790", "l0.2317260,0.8347075", "l0.2358171,0.8308926", "l0.2380806,0.8249221", "l0.2376279,0.8182503", "l0.2274337,0.8147604", "l0.2255055,0.8153078", "l0.2245666,0.8190543", "l0.2223366,0.8188319", "l0.2212300,0.8134773", "l0.2139196,0.8145037", "l0.2133495,0.8111849", "l0.2099123,0.8092005", "l0.2097950,0.8069252", "l0.2182287,0.8054711", "l0.2229066,0.8011087", "l0.2336039,0.7801693", "l0.2440161,0.7248785", "l0.2467994,0.6919640", "l0.2511923,0.6805534", "l0.2643878,0.6828286", "l0.2634321,0.6785689", "l0.2598440,0.6768411", "l0.2623255,0.6768069", "l0.2530366,0.6689033", "l0.2484928,0.6771319", "l0.2475036,0.6849157", "l0.2464473,0.6831366", "l0.2537241,0.5986435", "l0.2580667,0.5904833", "l0.2603973,0.5887383", "l0.2618728,0.5925191", "l0.2591901,0.5929981", "l0.2609506,0.5931178", "l0.2600116,0.5949996", "l0.2782707,0.6116964", "l0.2862182,0.6389312", "l0.2928411,0.6455176", "l0.2877272,0.6334227", "l0.2844745,0.6135611", "l0.2844745,0.6135611", "l0.2928076,0.6142796", "l0.2933777,0.6116793", "l0.2949370,0.6167259", "l0.3046785,0.6185393", "l0.3062881,0.6277944", "l0.3062881,0.6277944", "l0.3063719,0.6282392", "l0.3063719,0.6282392", "l0.3076127,0.6320883", "l0.3090379,0.6294367", "l0.3107984,0.6297788", "l0.3124583,0.6326357", "l0.3148224,0.6321567", "l0.3163147,0.6349452", "l0.3210429,0.6369981", "l0.3243292,0.6374771", "l0.3282024,0.6342609", "l0.3312539,0.6365704", "l0.3317569,0.6324133", "l0.3346073,0.6311303", "l0.3329977,0.6299328", "l0.3348923,0.6261350", "l0.3382122,0.6236715", "l0.3437117,0.6257757", "l0.3465285,0.6202671", "l0.3528496,0.6166062", "l0.3515418,0.6093184", "l0.3535371,0.6034848", "l0.3563874,0.6025097", "l0.3553646,0.6002345", "l0.3573264,0.6019794", "l0.3608139,0.5975657", "l0.3643684,0.5975486", "l0.3655756,0.5937337", "l0.3694320,0.5909281", "l0.3698847,0.5827166", "l0.3736740,0.5826652", "l0.3781005,0.5750011", "c", "m0.3289904,0.8135115", "l0.3289904,0.8135115", "l0.3285880,0.8074042", "l0.3285880,0.8074042", "l0.3279341,0.8070792", "l0.3279341,0.8070792", "l0.3282024,0.8107572", "l0.3261736,0.8115955", "l0.3278503,0.8132378", "l0.3289904,0.8135115", "c", "m0.3263245,0.8132891", "l0.3263245,0.8132891", "l0.3258382,0.8136655", "l0.3258382,0.8136655", "l0.3244801,0.8169672", "l0.3257879,0.8199610", "l0.3286886,0.8178397", "l0.3269616,0.8135286", "l0.3269616,0.8135286", "l0.3265592,0.8132549", "l0.3263245,0.8132891", "c"]}, {"n": "Auvergne", "u": "FR-C", "i": ["m0.4929701,0.5025687", "l0.4942108,0.4973852", "l0.4959378,0.4973681", "l0.4985534,0.4926294", "l0.5073392,0.4909871", "l0.5107932,0.4923727", "l0.5162257,0.4888486", "l0.5154712,0.4846060", "l0.5128723,0.4831348", "l0.5149178,0.4799870", "l0.5131238,0.4779513", "l0.5155550,0.4766682", "l0.5171478,0.4779855", "l0.5168963,0.4747180", "l0.5222785,0.4717926", "l0.5232677,0.4690384", "l0.5264199,0.4719637", "l0.5290355,0.4701161", "l0.5323554,0.4710570", "l0.5375363,0.4641114", "l0.5452323,0.4639062", "l0.5452323,0.4639062", "l0.5470934,0.4684225", "l0.5569523,0.4761379", "l0.5617812,0.4719466", "l0.5671968,0.4753510", "l0.5694436,0.4723914", "l0.5723275,0.4722545", "l0.5748425,0.4787040", "l0.5820858,0.4748377", "l0.5811636,0.4713478", "l0.5846008,0.4711939", "l0.5840307,0.4673276", "l0.5865625,0.4680461", "l0.5875015,0.4729901", "l0.5943423,0.4838191", "l0.5947280,0.4903541", "l0.5991544,0.4924070", "l0.6014850,0.4911068", "l0.6035809,0.4955547", "l0.6092145,0.4950586", "l0.6126685,0.4982577", "l0.6110253,0.5047585", "l0.6116290,0.5119093", "l0.6130038,0.5120462", "l0.6089630,0.5126449", "l0.6056600,0.5173323", "l0.6056600,0.5173323", "l0.6052073,0.5174521", "l0.6052073,0.5174521", "l0.6046036,0.5175376", "l0.6046036,0.5175376", "l0.5965220,0.5210960", "l0.5993556,0.5288969", "l0.5982658,0.5341146", "l0.6002443,0.5364925", "l0.5991209,0.5400851", "l0.6009149,0.5456108", "l0.5978969,0.5482453", "l0.5918944,0.5486216", "l0.5913411,0.5526419", "l0.5956334,0.5571240", "l0.5929172,0.5587321", "l0.5934034,0.5644801", "l0.5910728,0.5667554", "l0.5974610,0.5734615", "l0.5972095,0.5768658", "l0.6004622,0.5829218", "l0.6081247,0.5883278", "l0.6116793,0.5966419", "l0.6101870,0.6026808", "l0.6050228,0.6068037", "l0.6060791,0.6129452", "l0.6091139,0.6087197", "l0.6117296,0.6091303", "l0.6139931,0.6135611", "l0.6141607,0.6114055", "l0.6176818,0.6127570", "l0.6183860,0.6104989", "l0.6234328,0.6098317", "l0.6228124,0.6079156", "l0.6251598,0.6070261", "l0.6289491,0.6073853", "l0.6316653,0.6105160", "l0.6360079,0.6094895", "l0.6382882,0.6127057", "l0.6357900,0.6145704", "l0.6385230,0.6162127", "l0.6370139,0.6189157", "l0.6395457,0.6207804", "l0.6430332,0.6189157", "l0.6468393,0.6241334", "l0.6438380,0.6303947", "l0.6445255,0.6345860", "l0.6430165,0.6354927", "l0.6421278,0.6328410", "l0.6387074,0.6320883", "l0.6404511,0.6350821", "l0.6404511,0.6350821", "l0.6404511,0.6359888", "l0.6404511,0.6359888", "l0.6385397,0.6358519", "l0.6368295,0.6388457", "l0.6391266,0.6428488", "l0.6333252,0.6445767", "l0.6345325,0.6492127", "l0.6283455,0.6502050", "l0.6235837,0.6592205", "l0.6150997,0.6592890", "l0.6146638,0.6631552", "l0.6127020,0.6645238", "l0.6114781,0.6632236", "l0.6118805,0.6653621", "l0.6091642,0.6638224", "l0.6073702,0.6696389", "l0.6030443,0.6720681", "l0.6030443,0.6720681", "l0.6012503,0.6717089", "l0.6017533,0.6692796", "l0.5994227,0.6700324", "l0.5960526,0.6664227", "l0.5948118,0.6626933", "l0.5894632,0.6636342", "l0.5899327,0.6608457", "l0.5869146,0.6583823", "l0.5843828,0.6589297", "l0.5840307,0.6638908", "l0.5763348,0.6655502", "l0.5720760,0.6566715", "l0.5719586,0.6523263", "l0.5688903,0.6489903", "l0.5629381,0.6538146", "l0.5598865,0.6529421", "l0.5594841,0.6577322", "l0.5564158,0.6602470", "l0.5522073,0.6561412", "l0.5506647,0.6599219", "l0.5506647,0.6599219", "l0.5502623,0.6599219", "l0.5502623,0.6599219", "l0.5499438,0.6631210", "l0.5480994,0.6627275", "l0.5462718,0.6664740", "l0.5457856,0.6748908", "l0.5417951,0.6819904", "l0.5417951,0.6819904", "l0.5386597,0.6784492", "l0.5369159,0.6703403", "l0.5386932,0.6690743", "l0.5375363,0.6671241", "l0.5352896,0.6675518", "l0.5332943,0.6590666", "l0.5272582,0.6609142", "l0.5273588,0.6553029", "l0.5247600,0.6523776", "l0.5155550,0.6619235", "l0.5152532,0.6672952", "l0.5117321,0.6711443", "l0.5124531,0.6744632", "l0.5082279,0.6775596", "l0.5071380,0.6813745", "l0.4979833,0.6823838", "l0.4961893,0.6794072", "l0.4939928,0.6796125", "l0.4885436,0.6814258", "l0.4876717,0.6846420", "l0.4853244,0.6825720", "l0.4845028,0.6768924", "l0.4824740,0.6767898", "l0.4853915,0.6676373", "l0.4797913,0.6591692", "l0.4806129,0.6544818", "l0.4777290,0.6489561", "l0.4777290,0.6489561", "l0.4804955,0.6482205", "l0.4804955,0.6482205", "l0.4810824,0.6483745", "l0.4810824,0.6483745", "l0.4833962,0.6464071", "l0.4803111,0.6405393", "l0.4854921,0.6383154", "l0.4859448,0.6328068", "l0.4896167,0.6299499", "l0.4874202,0.6283589", "l0.4869508,0.6243045", "l0.4984863,0.6127057", "l0.4977151,0.6051272", "l0.5069033,0.6093527", "l0.5102231,0.6071287", "l0.5073895,0.6043915", "l0.5095022,0.5907399", "l0.5055787,0.5865144", "l0.5073057,0.5819809", "l0.5097872,0.5818441", "l0.5099213,0.5749498", "l0.5004984,0.5632655", "l0.5052434,0.5591084", "l0.5052434,0.5591084", "l0.5055452,0.5590400", "l0.5055452,0.5590400", "l0.5077584,0.5593479", "l0.5122184,0.5542842", "l0.5127549,0.5499047", "l0.5160412,0.5483479", "l0.5153538,0.5419327", "l0.5117657,0.5367149", "l0.5128555,0.5296496", "l0.5070374,0.5168876", "l0.5034996,0.5152452", "l0.5027954,0.5165796", "l0.5004481,0.5116185", "l0.4988552,0.5137911", "l0.4944958,0.5104210", "l0.4966923,0.5074443", "l0.4934563,0.5065034", "c"]}, {"n": "Bourgogne", "u": "FR-D", "i": ["m0.6781598,0.3519216", "l0.6781598,0.3519216", "l0.6755609,0.3461564", "l0.6732135,0.3465157", "l0.6725932,0.3487738", "l0.6705811,0.3474566", "l0.6729285,0.3441206", "l0.6715536,0.3419822", "l0.6673116,0.3417940", "l0.6690218,0.3390227", "l0.6678985,0.3371922", "l0.6614265,0.3352933", "l0.6529760,0.3347458", "l0.6500082,0.3371408", "l0.6512993,0.3412124", "l0.6345828,0.3419309", "l0.6330737,0.3457800", "l0.6297204,0.3452326", "l0.6284461,0.3408018", "l0.6262496,0.3412979", "l0.6267694,0.3440351", "l0.6243214,0.3421191", "l0.6243214,0.3421191", "l0.6234496,0.3425981", "l0.6234496,0.3425981", "l0.6203477,0.3456774", "l0.6168602,0.3435903", "l0.6157871,0.3457629", "l0.6129871,0.3439325", "l0.6053582,0.3453353", "l0.6066492,0.3399978", "l0.6053414,0.3376883", "l0.6043354,0.3401004", "l0.6023569,0.3396556", "l0.6014850,0.3374488", "l0.6037653,0.3362684", "l0.6003113,0.3331891", "l0.5981484,0.3253710", "l0.5945603,0.3238142", "l0.5951639,0.3202730", "l0.5927998,0.3193834", "l0.5933866,0.3212995", "l0.5895135,0.3230102", "l0.5869482,0.3177069", "l0.5833601,0.3182715", "l0.5863110,0.3139091", "l0.5848691,0.3131735", "l0.5861434,0.3093243", "l0.5832427,0.3076991", "l0.5839301,0.3059371", "l0.5781120,0.2989060", "l0.5755132,0.2978624", "l0.5728473,0.2997442", "l0.5718748,0.2963741", "l0.5718748,0.2963741", "l0.5691921,0.2953305", "l0.5684208,0.2982730", "l0.5664088,0.2985467", "l0.5528277,0.2982388", "l0.5502456,0.3007707", "l0.5463389,0.2996587", "l0.5441089,0.3054410", "l0.5463389,0.3113259", "l0.5433544,0.3158764", "l0.5386932,0.3183741", "l0.5386765,0.3205296", "l0.5386765,0.3205296", "l0.5451149,0.3236945", "l0.5441760,0.3255250", "l0.5455509,0.3254223", "l0.5465233,0.3300584", "l0.5517378,0.3346603", "l0.5499773,0.3357552", "l0.5519726,0.3406992", "l0.5496587,0.3434535", "l0.5496587,0.3434535", "l0.5492396,0.3438127", "l0.5492396,0.3438127", "l0.5437065,0.3477474", "l0.5427676,0.3518532", "l0.5453329,0.3537007", "l0.5448299,0.3603384", "l0.5327410,0.3634519", "l0.5324727,0.3677116", "l0.5346021,0.3673524", "l0.5379219,0.3714068", "l0.5398166,0.3752731", "l0.5386429,0.3801316", "l0.5414262,0.3832280", "l0.5333614,0.3855717", "l0.5333614,0.3855717", "l0.5333614,0.3851953", "l0.5333614,0.3851953", "l0.5324895,0.3865126", "l0.5382405,0.3969823", "l0.5338476,0.4074006", "l0.5417783,0.4154069", "l0.5451820,0.4300508", "l0.5442933,0.4359699", "l0.5484683,0.4401783", "l0.5485857,0.4472436", "l0.5464898,0.4522390", "l0.5478647,0.4580212", "l0.5452323,0.4639062", "l0.5452323,0.4639062", "l0.5470934,0.4684225", "l0.5569523,0.4761379", "l0.5617812,0.4719466", "l0.5671968,0.4753510", "l0.5694436,0.4723914", "l0.5723275,0.4722545", "l0.5748425,0.4787040", "l0.5820858,0.4748377", "l0.5811636,0.4713478", "l0.5846008,0.4711939", "l0.5840307,0.4673276", "l0.5865625,0.4680461", "l0.5875015,0.4729901", "l0.5943423,0.4838191", "l0.5947280,0.4903541", "l0.5991544,0.4924070", "l0.6014850,0.4911068", "l0.6035809,0.4955547", "l0.6092145,0.4950586", "l0.6126685,0.4982577", "l0.6110253,0.5047585", "l0.6116290,0.5119093", "l0.6130038,0.5120462", "l0.6089630,0.5126449", "l0.6056600,0.5173323", "l0.6056600,0.5173323", "l0.6050564,0.5236278", "l0.6107906,0.5248254", "l0.6119475,0.5282468", "l0.6198447,0.5252188", "l0.6250927,0.5277678", "l0.6271383,0.5256636", "l0.6283958,0.5273743", "l0.6303910,0.5263650", "l0.6300725,0.5293417", "l0.6318498,0.5295641", "l0.6386236,0.5265361", "l0.6409206,0.5152966", "l0.6446093,0.5151597", "l0.6477615,0.5181877", "l0.6522550,0.5154847", "l0.6557257,0.5183930", "l0.6570503,0.5147662", "l0.6600180,0.5142359", "l0.6621474,0.5170586", "l0.6599845,0.5190773", "l0.6639247,0.5216947", "l0.6627678,0.5256465", "l0.6654673,0.5279389", "l0.6669763,0.5275283", "l0.6781933,0.4924241", "l0.6788640,0.4942546", "l0.6811946,0.4928175", "l0.6862581,0.4959653", "l0.6939038,0.4939295", "l0.6939876,0.4923727", "l0.6966368,0.4937584", "l0.6986991,0.4986511", "l0.7041651,0.4998487", "l0.7041651,0.4998487", "l0.7048190,0.4981208", "l0.7113078,0.4967009", "l0.7115761,0.4940835", "l0.7072837,0.4923043", "l0.7071999,0.4879248", "l0.7104024,0.4859233", "l0.7098155,0.4829637", "l0.7129845,0.4801581", "l0.7097652,0.4752825", "l0.7095808,0.4708004", "l0.7073508,0.4706635", "l0.7094802,0.4664723", "l0.7050370,0.4618191", "l0.7146779,0.4592187", "l0.7102850,0.4563276", "l0.7100503,0.4538470", "l0.7051879,0.4543603", "l0.7027399,0.4489543", "l0.7006608,0.4500834", "l0.6999902,0.4449512", "l0.7044334,0.4413416", "l0.7014489,0.4399046", "l0.7020357,0.4375780", "l0.7090778,0.4341394", "l0.7128503,0.4276557", "l0.7128503,0.4276557", "l0.7128168,0.4271254", "l0.7128168,0.4271254", "l0.7162372,0.4126697", "l0.7184169,0.4111472", "l0.7151809,0.4097615", "l0.7151809,0.4097615", "l0.7149462,0.4097615", "l0.7149462,0.4097615", "l0.7167738,0.4071954", "l0.7159690,0.4017381", "l0.7159690,0.4017381", "l0.7157007,0.4015670", "l0.7157007,0.4015670", "l0.7128168,0.4017723", "l0.7128168,0.4017723", "l0.7123809,0.4017723", "l0.7123809,0.4017723", "l0.7128336,0.3957163", "l0.7078371,0.3942451", "l0.7107042,0.3929107", "l0.7092790,0.3925002", "l0.7100838,0.3906355", "l0.7135210,0.3907723", "l0.7169079,0.3847163", "l0.7130180,0.3768812", "l0.7097820,0.3805935", "l0.7082227,0.3794986", "l0.7082227,0.3794986", "l0.7070322,0.3809698", "l0.7036621,0.3790367", "l0.6998393,0.3824753", "l0.7003758,0.3777023", "l0.6944068,0.3745546", "l0.6947589,0.3715950", "l0.6905169,0.3751533", "l0.6860737,0.3728610", "l0.6865767,0.3700211", "l0.6843635,0.3703291", "l0.6843132,0.3684130", "l0.6801215,0.3709791", "l0.6794508,0.3629729", "l0.6764328,0.3624255", "l0.6817646,0.3581144", "l0.6790819,0.3519216", "c"]}, {"n": "Bretagne", "u": "FR-E", "i": ["m0.1081712,0.4023027", "l0.1102503,0.4048517", "l0.1144755,0.4047490", "l0.1156995,0.4083929", "l0.1211320,0.4099667", "l0.1201930,0.4128750", "l0.1088251,0.4111643", "l0.1070981,0.4059978", "l0.1081712,0.4023027", "c", "m0.1097808,0.2452232", "l0.1101329,0.2490381", "l0.1194720,0.2451718", "l0.1194720,0.2503725", "l0.1246027,0.2500474", "l0.1251392,0.2525622", "l0.1223895,0.2546664", "l0.1303873,0.2573009", "l0.1292303,0.2610303", "l0.1381503,0.2687629", "l0.1378150,0.2744938", "l0.1453433,0.2787193", "l0.1434821,0.2820553", "l0.1454439,0.2812170", "l0.1481433,0.2860070", "l0.1475397,0.2812170", "l0.1513793,0.2823461", "l0.1564429,0.2740148", "l0.1620766,0.2715685", "l0.1610370,0.2691563", "l0.1646084,0.2683352", "l0.1658156,0.2708500", "l0.1728744,0.2644860", "l0.1753056,0.2666587", "l0.1715834,0.2718422", "l0.1731930,0.2729199", "l0.1781057,0.2692419", "l0.1803859,0.2753834", "l0.1794302,0.2793352", "l0.1813920,0.2728344", "l0.1825656,0.2765467", "l0.1845609,0.2720646", "l0.1863717,0.2739293", "l0.1844603,0.2704223", "l0.1917371,0.2698406", "l0.1924748,0.2740319", "l0.1952581,0.2758795", "l0.1940006,0.2770428", "l0.1969348,0.2800195", "l0.1960629,0.2852201", "l0.1974881,0.2819355", "l0.1993157,0.2825685", "l0.1959623,0.2757426", "l0.1986953,0.2772310", "l0.1977564,0.2749557", "l0.1941515,0.2741859", "l0.1952078,0.2723725", "l0.1927263,0.2703025", "l0.1956270,0.2650677", "l0.2059386,0.2619712", "l0.2064751,0.2654954", "l0.2041949,0.2699262", "l0.2104824,0.2735700", "l0.2248013,0.2703196", "l0.2248013,0.2703196", "l0.2306026,0.2858702", "l0.2352806,0.2888811", "l0.2399753,0.2880257", "l0.2469503,0.2800024", "l0.2597434,0.2838173", "l0.2597434,0.2838173", "l0.2589721,0.2938251", "l0.2614704,0.3029775", "l0.2575805,0.3096494", "l0.2591398,0.3163383", "l0.2591398,0.3163383", "l0.2594248,0.3166121", "l0.2594248,0.3166121", "l0.2634656,0.3375856", "l0.2538247,0.3416401", "l0.2474533,0.3615188", "l0.2393381,0.3591409", "l0.2376112,0.3560787", "l0.2313068,0.3553259", "l0.2317092,0.3587303", "l0.2213306,0.3628874", "l0.2186982,0.3685670", "l0.2047649,0.3686697", "l0.1981588,0.3725872", "l0.1968845,0.3702264", "l0.1893227,0.3748454", "l0.1881825,0.3871285", "l0.1840579,0.3883089", "l0.1836219,0.3916448", "l0.1821297,0.3892498", "l0.1779548,0.3911487", "l0.1742158,0.3888734", "l0.1729079,0.3946557", "l0.1670396,0.3951518", "l0.1655305,0.3929792", "l0.1631329,0.3960072", "l0.1631329,0.3960072", "l0.1605173,0.3958019", "l0.1600813,0.3913882", "l0.1643066,0.3907381", "l0.1595280,0.3880180", "l0.1382341,0.3920041", "l0.1315609,0.3849900", "l0.1279561,0.3849729", "l0.1261117,0.3822187", "l0.1250554,0.3836044", "l0.1236470,0.3809014", "l0.1239823,0.3835188", "l0.1167893,0.3832964", "l0.1164708,0.3891471", "l0.1198241,0.3938688", "l0.1162360,0.3934069", "l0.1140564,0.3875219", "l0.1159678,0.3858967", "l0.1149618,0.3805592", "l0.1054550,0.3711160", "l0.1002740,0.3710476", "l0.0999051,0.3684302", "l0.0938020,0.3700040", "l0.0886714,0.3628532", "l0.0781083,0.3615530", "l0.0747214,0.3585079", "l0.0658685,0.3600133", "l0.0625822,0.3553944", "l0.0640073,0.3528454", "l0.0619953,0.3537521", "l0.0595138,0.3482264", "l0.0565293,0.3502451", "l0.0575354,0.3532902", "l0.0528909,0.3545219", "l0.0484142,0.3515110", "l0.0455806,0.3530678", "l0.0424620,0.3594317", "l0.0302054,0.3594488", "l0.0308593,0.3497832", "l0.0264832,0.3418967", "l0.0202459,0.3373632", "l0.0161883,0.3379278", "l0.0117787,0.3348827", "l0.0045019,0.3337878", "l0.0065977,0.3333088", "l0.0060612,0.3310849", "l0.0268017,0.3265856", "l0.0345648,0.3284674", "l0.0371972,0.3241564", "l0.0338270,0.3162870", "l0.0235322,0.3125576", "l0.0210843,0.3132761", "l0.0169093,0.3198453", "l0.0159871,0.3130195", "l0.0179992,0.3114627", "l0.0125499,0.3108982", "l0.0120805,0.3082124", "l0.0161548,0.3079386", "l0.0160374,0.3027722", "l0.0187704,0.3016774", "l0.0171440,0.3057147", "l0.0185692,0.3076991", "l0.0210675,0.3047909", "l0.0208495,0.3080413", "l0.0243873,0.3063648", "l0.0281096,0.3086914", "l0.0344474,0.3062279", "l0.0376834,0.3081097", "l0.0403996,0.3045343", "l0.0385888,0.3060739", "l0.0323516,0.3043974", "l0.0347492,0.3027380", "l0.0327372,0.3017629", "l0.0336761,0.2993508", "l0.0298533,0.3031999", "l0.0268185,0.3033710", "l0.0281934,0.3014892", "l0.0239514,0.3031657", "l0.0279922,0.2971268", "l0.0263490,0.2957924", "l0.0135559,0.3019169", "l0.0084253,0.3001035", "l0.0065809,0.3026525", "l0.0020371,0.3028749", "l0.0008131,0.2994705", "l0.0028084,0.2972295", "l0.0004778,0.2939277", "l0.0028587,0.2881797", "l0.0017521,0.2830304", "l0.0050216,0.2786851", "l0.0133380,0.2765125", "l0.0136565,0.2735529", "l0.0165907,0.2742201", "l0.0180830,0.2700459", "l0.0210843,0.2717395", "l0.0278916,0.2700117", "l0.0254269,0.2681641", "l0.0317312,0.2657349", "l0.0352187,0.2670863", "l0.0352355,0.2704052", "l0.0422440,0.2684549", "l0.0403493,0.2677193", "l0.0428644,0.2646913", "l0.0488837,0.2637846", "l0.0517173,0.2658375", "l0.0521364,0.2626555", "l0.0553054,0.2603461", "l0.0557413,0.2620397", "l0.0578875,0.2603632", "l0.0577701,0.2660770", "l0.0605701,0.2672916", "l0.0609893,0.2634254", "l0.0611235,0.2660770", "l0.0665056,0.2675311", "l0.0658852,0.2644176", "l0.0675284,0.2617317", "l0.0682829,0.2632030", "l0.0680817,0.2612185", "l0.0780747,0.2647768", "l0.0805730,0.2637333", "l0.0795502,0.2677193", "l0.0820149,0.2647768", "l0.0848821,0.2664876", "l0.0847647,0.2606540", "l0.0871959,0.2584300", "l0.0846976,0.2571299", "l0.0859216,0.2530412", "l0.0845300,0.2518608", "l0.0867767,0.2534176", "l0.0902810,0.2482854", "l0.0911864,0.2503212", "l0.0919409,0.2484736", "l0.0934164,0.2508344", "l0.0955793,0.2502698", "l0.0946907,0.2527162", "l0.0976584,0.2524938", "l0.1030908,0.2483880", "l0.1070478,0.2488157", "l0.1097808,0.2452232", "c"]}, {"n": "Centre", "u": "FR-F", "i": ["m0.4387629,0.2374393", "l0.4430720,0.2428281", "l0.4418647,0.2450008", "l0.4455199,0.2483196", "l0.4443462,0.2567535", "l0.4474984,0.2582932", "l0.4440277,0.2630148", "l0.4464756,0.2645202", "l0.4457714,0.2670692", "l0.4502146,0.2725265", "l0.4536183,0.2724923", "l0.4531991,0.2764954", "l0.4586316,0.2790101", "l0.4578435,0.2833212", "l0.4596376,0.2882994", "l0.4643826,0.2911050", "l0.4685911,0.2893259", "l0.4684234,0.2947660", "l0.4718774,0.2952450", "l0.4726151,0.2992994", "l0.4705025,0.3049449", "l0.4715253,0.3072715", "l0.4848214,0.3061595", "l0.4839998,0.3042948", "l0.4860621,0.3047909", "l0.4875711,0.3013010", "l0.4905389,0.3026012", "l0.4905053,0.3061595", "l0.4942276,0.3046882", "l0.4942276,0.3046882", "l0.4945964,0.3039868", "l0.4945964,0.3039868", "l0.4962564,0.3024814", "l0.4984360,0.3051673", "l0.5015882,0.3043290", "l0.5029463,0.3102823", "l0.5094519,0.3138749", "l0.5094854,0.3201019", "l0.5070877,0.3203586", "l0.5043380,0.3246867", "l0.5123861,0.3228733", "l0.5225635,0.3247380", "l0.5259504,0.3224114", "l0.5247097,0.3201362", "l0.5265540,0.3215561", "l0.5290691,0.3199309", "l0.5304942,0.3240537", "l0.5337470,0.3212652", "l0.5386765,0.3205296", "l0.5386765,0.3205296", "l0.5451149,0.3236945", "l0.5441760,0.3255250", "l0.5455509,0.3254223", "l0.5465233,0.3300584", "l0.5517378,0.3346603", "l0.5499773,0.3357552", "l0.5519726,0.3406992", "l0.5496587,0.3434535", "l0.5496587,0.3434535", "l0.5492396,0.3438127", "l0.5492396,0.3438127", "l0.5437065,0.3477474", "l0.5427676,0.3518532", "l0.5453329,0.3537007", "l0.5448299,0.3603384", "l0.5327410,0.3634519", "l0.5324727,0.3677116", "l0.5346021,0.3673524", "l0.5379219,0.3714068", "l0.5398166,0.3752731", "l0.5386429,0.3801316", "l0.5414262,0.3832280", "l0.5333614,0.3855717", "l0.5333614,0.3855717", "l0.5333614,0.3851953", "l0.5333614,0.3851953", "l0.5324895,0.3865126", "l0.5382405,0.3969823", "l0.5338476,0.4074006", "l0.5417783,0.4154069", "l0.5451820,0.4300508", "l0.5442933,0.4359699", "l0.5484683,0.4401783", "l0.5485857,0.4472436", "l0.5464898,0.4522390", "l0.5478647,0.4580212", "l0.5452323,0.4639062", "l0.5452323,0.4639062", "l0.5375363,0.4641114", "l0.5323554,0.4710570", "l0.5290355,0.4701161", "l0.5264199,0.4719637", "l0.5232677,0.4690384", "l0.5222785,0.4717926", "l0.5168963,0.4747180", "l0.5171478,0.4779855", "l0.5155550,0.4766682", "l0.5131238,0.4779513", "l0.5149178,0.4799870", "l0.5128723,0.4831348", "l0.5154712,0.4846060", "l0.5162257,0.4888486", "l0.5107932,0.4923727", "l0.5073392,0.4909871", "l0.4985534,0.4926294", "l0.4959378,0.4973681", "l0.4942108,0.4973852", "l0.4929701,0.5025687", "l0.4929701,0.5025687", "l0.4871352,0.5016791", "l0.4796069,0.5035780", "l0.4719780,0.5001737", "l0.4622532,0.5019529", "l0.4583465,0.4987880", "l0.4558818,0.4994381", "l0.4567537,0.5019871", "l0.4545908,0.5055967", "l0.4515727,0.5027056", "l0.4475990,0.5058191", "l0.4462744,0.5023976", "l0.4417809,0.5053572", "l0.4404563,0.5018502", "l0.4327604,0.5101302", "l0.4284848,0.5046216", "l0.4256512,0.5051177", "l0.4249805,0.5075298", "l0.4190618,0.5081115", "l0.4184079,0.5056138", "l0.4162450,0.5061441", "l0.4162450,0.5061441", "l0.4162450,0.5061441", "l0.4162450,0.5061441", "l0.4175193,0.5044163", "l0.4175193,0.5044163", "l0.4185924,0.5011317", "l0.4143336,0.4996091", "l0.4138809,0.4935874", "l0.4103096,0.4905594", "l0.4052124,0.4906107", "l0.4048436,0.4874458", "l0.3976171,0.4839217", "l0.3963596,0.4810135", "l0.3988075,0.4743416", "l0.3977847,0.4709544", "l0.3909942,0.4645220", "l0.3896864,0.4582607", "l0.3832982,0.4527180", "l0.3824095,0.4453960", "l0.3772621,0.4418890", "l0.3737914,0.4420430", "l0.3759208,0.4471239", "l0.3694656,0.4469528", "l0.3648044,0.4499979", "l0.3597073,0.4479279", "l0.3568066,0.4498781", "l0.3545598,0.4436511", "l0.3560521,0.4428299", "l0.3553814,0.4373385", "l0.3529670,0.4382281", "l0.3513574,0.4352172", "l0.3467130,0.4365173", "l0.3482220,0.4331301", "l0.3469477,0.4306666", "l0.3455728,0.4321378", "l0.3436782,0.4314878", "l0.3440470,0.4296402", "l0.3398721,0.4302560", "l0.3380445,0.4255857", "l0.3380445,0.4255857", "l0.3396374,0.4133369", "l0.3469477,0.4028843", "l0.3449021,0.4010367", "l0.3496807,0.3904815", "l0.3499993,0.3876417", "l0.3477693,0.3863928", "l0.3505358,0.3803711", "l0.3505358,0.3803711", "l0.3504520,0.3794815", "l0.3504520,0.3794815", "l0.3609983,0.3831425", "l0.3623396,0.3822700", "l0.3596570,0.3779589", "l0.3609648,0.3754442", "l0.3655589,0.3780103", "l0.3665817,0.3753073", "l0.3757699,0.3724675", "l0.3773627,0.3702435", "l0.3757531,0.3707396", "l0.3750489,0.3676432", "l0.3778993,0.3640678", "l0.3831138,0.3624768", "l0.3824766,0.3607661", "l0.3877749,0.3556168", "l0.3872049,0.3483975", "l0.3892336,0.3472171", "l0.3907259,0.3496976", "l0.3910109,0.3450786", "l0.3933415,0.3442404", "l0.3912289,0.3393819", "l0.3928721,0.3347629", "l0.3897367,0.3339760", "l0.3894852,0.3304348", "l0.3929224,0.3301782", "l0.3930733,0.3278345", "l0.3908600,0.3273383", "l0.3927882,0.3268765", "l0.3934757,0.3237458", "l0.3979859,0.3231642", "l0.3897702,0.3172792", "l0.3897702,0.3172792", "l0.3920337,0.3152264", "l0.3890995,0.3101968", "l0.3903570,0.3072030", "l0.3868192,0.3060739", "l0.3878420,0.3036447", "l0.3978686,0.2982730", "l0.4021776,0.2910537", "l0.3993944,0.2871874", "l0.4015237,0.2821579", "l0.3912624,0.2726975", "l0.3910277,0.2664876", "l0.3910277,0.2664876", "l0.3943811,0.2645887", "l0.3952697,0.2616120", "l0.4030998,0.2605513", "l0.4030998,0.2605513", "l0.4045418,0.2605513", "l0.4045418,0.2605513", "l0.4082808,0.2570101", "l0.4119024,0.2582761", "l0.4123383,0.2536742", "l0.4193637,0.2570443", "l0.4270093,0.2567022", "l0.4297926,0.2545638", "l0.4290717,0.2488328", "l0.4359125,0.2447955", "l0.4350574,0.2392356", "c"]}, {"n": "Champagne-Ardenne", "u": "FR-G", "i": ["m0.6708159,0.1049089", "l0.6750411,0.1068420", "l0.6730459,0.1087238", "l0.6733477,0.1122308", "l0.6718890,0.1107254", "l0.6697260,0.1147627", "l0.6712015,0.1177394", "l0.6676134,0.1253692", "l0.6744878,0.1318871", "l0.6716207,0.1365916", "l0.6735489,0.1417580", "l0.6719393,0.1446834", "l0.6819491,0.1439136", "l0.6888402,0.1480022", "l0.6938535,0.1556150", "l0.7011136,0.1553413", "l0.7053723,0.1599260", "l0.7041484,0.1645963", "l0.7065125,0.1624408", "l0.7098491,0.1640147", "l0.7098491,0.1640147", "l0.7005602,0.1721749", "l0.6986488,0.1691640", "l0.6936858,0.1698654", "l0.6922774,0.1668374", "l0.6901313,0.1666663", "l0.6885720,0.1721064", "l0.6885720,0.1721064", "l0.6884546,0.1727565", "l0.6884546,0.1727565", "l0.6864090,0.1766570", "l0.6900307,0.1813102", "l0.6903157,0.1855015", "l0.6876498,0.1873320", "l0.6893265,0.1899836", "l0.6860402,0.1911640", "l0.6840281,0.1974082", "l0.6862078,0.1991531", "l0.6858054,0.2012916", "l0.6788807,0.2053118", "l0.6817311,0.2083569", "l0.6780592,0.2109743", "l0.6825862,0.2235482", "l0.6798700,0.2286462", "l0.6828880,0.2271236", "l0.6848162,0.2284238", "l0.6846653,0.2317084", "l0.6818988,0.2327177", "l0.6850342,0.2337955", "l0.6834245,0.2375249", "l0.6779921,0.2398173", "l0.6779921,0.2398173", "l0.6776903,0.2401252", "l0.6776903,0.2401252", "l0.6761980,0.2451718", "l0.6779418,0.2479432", "l0.6746890,0.2526649", "l0.6830054,0.2587551", "l0.6822509,0.2723212", "l0.6863084,0.2705078", "l0.6872809,0.2744083", "l0.6906175,0.2744596", "l0.6970727,0.2816447", "l0.7051544,0.2836462", "l0.7149294,0.2928671", "l0.7096646,0.2962714", "l0.7130348,0.2975374", "l0.7119785,0.3026525", "l0.7156336,0.3000008", "l0.7187858,0.3008904", "l0.7232625,0.3087598", "l0.7248386,0.3068609", "l0.7277728,0.3094099", "l0.7269177,0.3121984", "l0.7301202,0.3130195", "l0.7330711,0.3168687", "l0.7296507,0.3188531", "l0.7289633,0.3263974", "l0.7259955,0.3288267", "l0.7307741,0.3297505", "l0.7325514,0.3332233", "l0.7363574,0.3343181", "l0.7371119,0.3428718", "l0.7412534,0.3404255", "l0.7438858,0.3456774", "l0.7438858,0.3456774", "l0.7438522,0.3483975", "l0.7415049,0.3477303", "l0.7395096,0.3514597", "l0.7399288,0.3534441", "l0.7352508,0.3526743", "l0.7339263,0.3568314", "l0.7304052,0.3567458", "l0.7293657,0.3611424", "l0.7316460,0.3645468", "l0.7303884,0.3710818", "l0.7238494,0.3723991", "l0.7218038,0.3686868", "l0.7188864,0.3723135", "l0.7108719,0.3721596", "l0.7082227,0.3794986", "l0.7082227,0.3794986", "l0.7070322,0.3809698", "l0.7036621,0.3790367", "l0.6998393,0.3824753", "l0.7003758,0.3777023", "l0.6944068,0.3745546", "l0.6947589,0.3715950", "l0.6905169,0.3751533", "l0.6860737,0.3728610", "l0.6865767,0.3700211", "l0.6843635,0.3703291", "l0.6843132,0.3684130", "l0.6801215,0.3709791", "l0.6794508,0.3629729", "l0.6764328,0.3624255", "l0.6817646,0.3581144", "l0.6790819,0.3519216", "l0.6790819,0.3519216", "l0.6781598,0.3519216", "l0.6781598,0.3519216", "l0.6755609,0.3461564", "l0.6732135,0.3465157", "l0.6725932,0.3487738", "l0.6705811,0.3474566", "l0.6729285,0.3441206", "l0.6715536,0.3419822", "l0.6673116,0.3417940", "l0.6690218,0.3390227", "l0.6678985,0.3371922", "l0.6614265,0.3352933", "l0.6529760,0.3347458", "l0.6500082,0.3371408", "l0.6512993,0.3412124", "l0.6345828,0.3419309", "l0.6330737,0.3457800", "l0.6297204,0.3452326", "l0.6284461,0.3408018", "l0.6262496,0.3412979", "l0.6267694,0.3440351", "l0.6243214,0.3421191", "l0.6243214,0.3421191", "l0.6234496,0.3425981", "l0.6234496,0.3425981", "l0.6203477,0.3456774", "l0.6168602,0.3435903", "l0.6157871,0.3457629", "l0.6129871,0.3439325", "l0.6053582,0.3453353", "l0.6066492,0.3399978", "l0.6053414,0.3376883", "l0.6043354,0.3401004", "l0.6023569,0.3396556", "l0.6014850,0.3374488", "l0.6037653,0.3362684", "l0.6003113,0.3331891", "l0.5981484,0.3253710", "l0.5945603,0.3238142", "l0.5951639,0.3202730", "l0.5927998,0.3193834", "l0.5933866,0.3212995", "l0.5895135,0.3230102", "l0.5869482,0.3177069", "l0.5833601,0.3182715", "l0.5863110,0.3139091", "l0.5848691,0.3131735", "l0.5861434,0.3093243", "l0.5832427,0.3076991", "l0.5839301,0.3059371", "l0.5781120,0.2989060", "l0.5755132,0.2978624", "l0.5728473,0.2997442", "l0.5718748,0.2963741", "l0.5718748,0.2963741", "l0.5696783,0.2867769", "l0.5734676,0.2856307", "l0.5712879,0.2816276", "l0.5764689,0.2801563", "l0.5753455,0.2770770", "l0.5787660,0.2750070", "l0.5779108,0.2734160", "l0.5819517,0.2721501", "l0.5792187,0.2704052", "l0.5801911,0.2689681", "l0.5744066,0.2701657", "l0.5755970,0.2591485", "l0.5704664,0.2569759", "l0.5738700,0.2535544", "l0.5710867,0.2515871", "l0.5769216,0.2510226", "l0.5767875,0.2469168", "l0.5767875,0.2469168", "l0.5797720,0.2404673", "l0.5827229,0.2401936", "l0.5829577,0.2375249", "l0.5850032,0.2371485", "l0.5840978,0.2352838", "l0.5902009,0.2294673", "l0.5883231,0.2263367", "l0.5837625,0.2270039", "l0.5838798,0.2244891", "l0.5874512,0.2226586", "l0.5848523,0.2180738", "l0.5863446,0.2147379", "l0.5921124,0.2156275", "l0.5951304,0.2138312", "l0.5951807,0.2114191", "l0.5927998,0.2118810", "l0.5916932,0.2086306", "l0.5905363,0.2096913", "l0.5885578,0.2079805", "l0.5902512,0.2056026", "l0.5879542,0.1970489", "l0.5971927,0.1923957", "l0.6023066,0.1936446", "l0.6026084,0.1897954", "l0.6073534,0.1869043", "l0.6098517,0.1901034", "l0.6152171,0.1919681", "l0.6153177,0.1834657", "l0.6174470,0.1826788", "l0.6155524,0.1759898", "l0.6182016,0.1740567", "l0.6161392,0.1718327", "l0.6181010,0.1689587", "l0.6143116,0.1633988", "l0.6155356,0.1616710", "l0.6206830,0.1621842", "l0.6214711,0.1572573", "l0.6255622,0.1549649", "l0.6300725,0.1486010", "l0.6270209,0.1460862", "l0.6303072,0.1363863", "l0.6304749,0.1324688", "l0.6278257,0.1313910", "l0.6288317,0.1264299", "l0.6288317,0.1264299", "l0.6342474,0.1252837", "l0.6437374,0.1287736", "l0.6542838,0.1233506", "l0.6608731,0.1223754", "l0.6599845,0.1145916", "l0.6615271,0.1114096", "l0.6700278,0.1033179", "c"]}, {"n": "Corse", "u": "FR-H", "i": ["m0.9450710,0.9779472", "l0.9470998,0.9733624", "l0.9518448,0.9728663", "l0.9548461,0.9690000", "l0.9476196,0.9664853", "l0.9454902,0.9678538", "l0.9450207,0.9639363", "l0.9402925,0.9658010", "l0.9401248,0.9641244", "l0.9369391,0.9640047", "l0.9419356,0.9605832", "l0.9406446,0.9581369", "l0.9448027,0.9572473", "l0.9456243,0.9552628", "l0.9433440,0.9540653", "l0.9459597,0.9535521", "l0.9452722,0.9504728", "l0.9469824,0.9492753", "l0.9431596,0.9456656", "l0.9411308,0.9480607", "l0.9333845,0.9494121", "l0.9344576,0.9454946", "l0.9323282,0.9426205", "l0.9362181,0.9422955", "l0.9370397,0.9381213", "l0.9431093,0.9345801", "l0.9398062,0.9286096", "l0.9369726,0.9297387", "l0.9336863,0.9264712", "l0.9315066,0.9271042", "l0.9318084,0.9248631", "l0.9298803,0.9254277", "l0.9323785,0.9232721", "l0.9301150,0.9229642", "l0.9315066,0.9196967", "l0.9286563,0.9166516", "l0.9394374,0.9138460", "l0.9370397,0.9104245", "l0.9331498,0.9101166", "l0.9338875,0.9058911", "l0.9295617,0.9074136", "l0.9289916,0.9034619", "l0.9334684,0.9023841", "l0.9332336,0.8995272", "l0.9366876,0.8996298", "l0.9362181,0.8970295", "l0.9384146,0.8944805", "l0.9362517,0.8935567", "l0.9374924,0.8899984", "l0.9412314,0.8890746", "l0.9402589,0.8848320", "l0.9416170,0.8833779", "l0.9417344,0.8856189", "l0.9436626,0.8846438", "l0.9460100,0.8863545", "l0.9469321,0.8816671", "l0.9514424,0.8811026", "l0.9559862,0.8774245", "l0.9617540,0.8779377", "l0.9649062,0.8760046", "l0.9647217,0.8726173", "l0.9693829,0.8692301", "l0.9761400,0.8688708", "l0.9814886,0.8745163", "l0.9846910,0.8688024", "l0.9845234,0.8631228", "l0.9822263,0.8594447", "l0.9843725,0.8562970", "l0.9830982,0.8529952", "l0.9858312,0.8506686", "l0.9843557,0.8439112", "l0.9901403,0.8422347", "l0.9929571,0.8446469", "l0.9950026,0.8619937", "l0.9917331,0.8746873", "l0.9977692,0.8869020", "l0.9995800,0.9206889", "l0.9989261,0.9294650", "l0.9893690,0.9437496", "l0.9876085,0.9729347", "l0.9845401,0.9742007", "l0.9854120,0.9756548", "l0.9821760,0.9745428", "l0.9801305,0.9775879", "l0.9807508,0.9796066", "l0.9828802,0.9767668", "l0.9864348,0.9777761", "l0.9846407,0.9811120", "l0.9797951,0.9838150", "l0.9801305,0.9900763", "l0.9762741,0.9921291", "l0.9753016,0.9948834", "l0.9792251,0.9934806", "l0.9788059,0.9948663", "l0.9761232,0.9993313", "l0.9732561,0.9995537", "l0.9716632,0.9969021", "l0.9672368,0.9967310", "l0.9691314,0.9926253", "l0.9656104,0.9920094", "l0.9662643,0.9885366", "l0.9634810,0.9908461", "l0.9606306,0.9876983", "l0.9595743,0.9892209", "l0.9551814,0.9877839", "l0.9521131,0.9844651", "l0.9497825,0.9850809", "l0.9505538,0.9823266", "l0.9459261,0.9814884", "l0.9471166,0.9796750", "l0.9450710,0.9779472", "c"]}, {"n": "Franche-Comté", "u": "FR-I", "i": ["m0.7438858,0.3456774", "l0.7472559,0.3402373", "l0.7491505,0.3412124", "l0.7469038,0.3443944", "l0.7484128,0.3446339", "l0.7521183,0.3424612", "l0.7547004,0.3374830", "l0.7613400,0.3358065", "l0.7613400,0.3358065", "l0.7615077,0.3359262", "l0.7615077,0.3359262", "l0.7622790,0.3414006", "l0.7661353,0.3444970", "l0.7661353,0.3444970", "l0.7661353,0.3450444", "l0.7661353,0.3450444", "l0.7790123,0.3420164", "l0.7822147,0.3440180", "l0.7851992,0.3499542", "l0.7939012,0.3435732", "l0.7968857,0.3480211", "l0.8100645,0.3566774", "l0.8100645,0.3566774", "l0.8121603,0.3608345", "l0.8173077,0.3620491", "l0.8240312,0.3671129", "l0.8246851,0.3724846", "l0.8218683,0.3797894", "l0.8274852,0.3807645", "l0.8314589,0.3879154", "l0.8307212,0.3901907", "l0.8307212,0.3901907", "l0.8203090,0.3911316", "l0.8216168,0.3953742", "l0.8173245,0.3975468", "l0.8130657,0.4059294", "l0.8226228,0.4038252", "l0.8248863,0.4049372", "l0.8253558,0.4079139", "l0.8222036,0.4088719", "l0.8212479,0.4120025", "l0.8175257,0.4127895", "l0.8183808,0.4174426", "l0.8104501,0.4248330", "l0.8116741,0.4255686", "l0.8102824,0.4272109", "l0.8008092,0.4341736", "l0.8019493,0.4374069", "l0.7951252,0.4434287", "l0.7864567,0.4453618", "l0.7819297,0.4501519", "l0.7841765,0.4542063", "l0.7818626,0.4621441", "l0.7833549,0.4659932", "l0.7595627,0.4864536", "l0.7627820,0.4896869", "l0.7569303,0.4981721", "l0.7563770,0.5029622", "l0.7563770,0.5029622", "l0.7427959,0.5184785", "l0.7327526,0.5188720", "l0.7319478,0.5139109", "l0.7272698,0.5123883", "l0.7270183,0.5102841", "l0.7197750,0.5180851", "l0.7152312,0.5185127", "l0.7153486,0.5132608", "l0.7126827,0.5132779", "l0.7117940,0.5099420", "l0.7103688,0.5137740", "l0.7074179,0.5076496", "l0.7085077,0.5064179", "l0.7030920,0.5032530", "l0.7041651,0.4998487", "l0.7041651,0.4998487", "l0.7048190,0.4981208", "l0.7113078,0.4967009", "l0.7115761,0.4940835", "l0.7072837,0.4923043", "l0.7071999,0.4879248", "l0.7104024,0.4859233", "l0.7098155,0.4829637", "l0.7129845,0.4801581", "l0.7097652,0.4752825", "l0.7095808,0.4708004", "l0.7073508,0.4706635", "l0.7094802,0.4664723", "l0.7050370,0.4618191", "l0.7146779,0.4592187", "l0.7102850,0.4563276", "l0.7100503,0.4538470", "l0.7051879,0.4543603", "l0.7027399,0.4489543", "l0.7006608,0.4500834", "l0.6999902,0.4449512", "l0.7044334,0.4413416", "l0.7014489,0.4399046", "l0.7020357,0.4375780", "l0.7090778,0.4341394", "l0.7128503,0.4276557", "l0.7128503,0.4276557", "l0.7128168,0.4271254", "l0.7128168,0.4271254", "l0.7162372,0.4126697", "l0.7184169,0.4111472", "l0.7151809,0.4097615", "l0.7151809,0.4097615", "l0.7149462,0.4097615", "l0.7149462,0.4097615", "l0.7167738,0.4071954", "l0.7159690,0.4017381", "l0.7159690,0.4017381", "l0.7157007,0.4015670", "l0.7157007,0.4015670", "l0.7128168,0.4017723", "l0.7128168,0.4017723", "l0.7123809,0.4017723", "l0.7123809,0.4017723", "l0.7128336,0.3957163", "l0.7078371,0.3942451", "l0.7107042,0.3929107", "l0.7092790,0.3925002", "l0.7100838,0.3906355", "l0.7135210,0.3907723", "l0.7169079,0.3847163", "l0.7130180,0.3768812", "l0.7097820,0.3805935", "l0.7082227,0.3794986", "l0.7082227,0.3794986", "l0.7108719,0.3721596", "l0.7188864,0.3723135", "l0.7218038,0.3686868", "l0.7238494,0.3723991", "l0.7303884,0.3710818", "l0.7316460,0.3645468", "l0.7293657,0.3611424", "l0.7304052,0.3567458", "l0.7339263,0.3568314", "l0.7352508,0.3526743", "l0.7399288,0.3534441", "l0.7395096,0.3514597", "l0.7415049,0.3477303", "l0.7438522,0.3483975", "c"]}, {"n": "Île-de-France", "u": "FR-J", "i": ["m0.4528303,0.2059790", "l0.4553453,0.2068001", "l0.4544734,0.2099821", "l0.4544734,0.2099821", "l0.4551105,0.2099650", "l0.4551105,0.2099650", "l0.4563681,0.2120692", "l0.4597717,0.2110085", "l0.4653215,0.2134549", "l0.4735876,0.2120350", "l0.4790871,0.2083056", "l0.4853244,0.2133693", "l0.4886610,0.2116586", "l0.4896670,0.2147037", "l0.4933222,0.2137799", "l0.4952839,0.2108888", "l0.4983354,0.2150458", "l0.4995427,0.2137799", "l0.5040697,0.2151998", "l0.5036673,0.2166026", "l0.5054614,0.2157986", "l0.5085129,0.2182962", "l0.5075740,0.2195280", "l0.5104914,0.2202294", "l0.5118998,0.2175606", "l0.5140627,0.2223849", "l0.5174999,0.2192885", "l0.5245420,0.2244207", "l0.5297062,0.2205373", "l0.5327410,0.2233942", "l0.5408897,0.2211018", "l0.5421975,0.2233087", "l0.5436897,0.2211018", "l0.5476970,0.2217861", "l0.5479317,0.2183476", "l0.5526935,0.2195280", "l0.5563152,0.2255840", "l0.5546888,0.2296726", "l0.5605236,0.2339665", "l0.5614458,0.2375933", "l0.5642459,0.2365326", "l0.5659226,0.2409121", "l0.5686053,0.2387224", "l0.5696783,0.2447955", "l0.5740377,0.2460443", "l0.5751108,0.2484907", "l0.5767875,0.2469168", "l0.5767875,0.2469168", "l0.5769216,0.2510226", "l0.5710867,0.2515871", "l0.5738700,0.2535544", "l0.5704664,0.2569759", "l0.5755970,0.2591485", "l0.5744066,0.2701657", "l0.5801911,0.2689681", "l0.5792187,0.2704052", "l0.5819517,0.2721501", "l0.5779108,0.2734160", "l0.5787660,0.2750070", "l0.5753455,0.2770770", "l0.5764689,0.2801563", "l0.5712879,0.2816276", "l0.5734676,0.2856307", "l0.5696783,0.2867769", "l0.5718748,0.2963741", "l0.5718748,0.2963741", "l0.5691921,0.2953305", "l0.5684208,0.2982730", "l0.5664088,0.2985467", "l0.5528277,0.2982388", "l0.5502456,0.3007707", "l0.5463389,0.2996587", "l0.5441089,0.3054410", "l0.5463389,0.3113259", "l0.5433544,0.3158764", "l0.5386932,0.3183741", "l0.5386765,0.3205296", "l0.5386765,0.3205296", "l0.5337470,0.3212652", "l0.5304942,0.3240537", "l0.5290691,0.3199309", "l0.5265540,0.3215561", "l0.5247097,0.3201362", "l0.5259504,0.3224114", "l0.5225635,0.3247380", "l0.5123861,0.3228733", "l0.5043380,0.3246867", "l0.5070877,0.3203586", "l0.5094854,0.3201019", "l0.5094519,0.3138749", "l0.5029463,0.3102823", "l0.5015882,0.3043290", "l0.4984360,0.3051673", "l0.4962564,0.3024814", "l0.4945964,0.3039868", "l0.4945964,0.3039868", "l0.4942276,0.3046882", "l0.4942276,0.3046882", "l0.4905053,0.3061595", "l0.4905389,0.3026012", "l0.4875711,0.3013010", "l0.4860621,0.3047909", "l0.4839998,0.3042948", "l0.4848214,0.3061595", "l0.4715253,0.3072715", "l0.4705025,0.3049449", "l0.4726151,0.2992994", "l0.4718774,0.2952450", "l0.4684234,0.2947660", "l0.4685911,0.2893259", "l0.4643826,0.2911050", "l0.4596376,0.2882994", "l0.4578435,0.2833212", "l0.4586316,0.2790101", "l0.4531991,0.2764954", "l0.4536183,0.2724923", "l0.4502146,0.2725265", "l0.4457714,0.2670692", "l0.4464756,0.2645202", "l0.4440277,0.2630148", "l0.4474984,0.2582932", "l0.4443462,0.2567535", "l0.4455199,0.2483196", "l0.4418647,0.2450008", "l0.4430720,0.2428281", "l0.4387629,0.2374393", "l0.4387629,0.2374393", "l0.4381593,0.2345482", "l0.4400036,0.2333165", "l0.4366167,0.2336073", "l0.4371868,0.2294844", "l0.4350742,0.2252247", "l0.4378742,0.2255326", "l0.4393497,0.2217690", "l0.4401042,0.2235140", "l0.4401042,0.2235140", "l0.4404731,0.2235140", "l0.4404731,0.2235140", "l0.4471798,0.2217690", "c"]}, {"n": "Languedoc-Roussillon", "u": "FR-K", "i": ["m0.5417951,0.6819904", "l0.5457856,0.6749079", "l0.5462718,0.6664911", "l0.5480994,0.6627446", "l0.5499438,0.6631381", "l0.5502623,0.6599390", "l0.5502623,0.6599390", "l0.5506647,0.6599390", "l0.5506647,0.6599390", "l0.5522073,0.6561583", "l0.5563990,0.6602641", "l0.5594841,0.6577493", "l0.5598865,0.6529764", "l0.5629381,0.6538488", "l0.5688735,0.6490246", "l0.5719419,0.6523605", "l0.5720592,0.6567229", "l0.5763180,0.6655845", "l0.5840140,0.6639421", "l0.5843493,0.6589810", "l0.5868811,0.6584336", "l0.5898991,0.6608970", "l0.5894464,0.6636684", "l0.5947951,0.6627446", "l0.5960190,0.6664740", "l0.5993892,0.6700837", "l0.6017198,0.6693310", "l0.6012167,0.6717602", "l0.6030108,0.6721195", "l0.6030108,0.6721195", "l0.6059115,0.6870199", "l0.6093654,0.6893636", "l0.6118469,0.6991490", "l0.6174638,0.7057696", "l0.6154853,0.7071553", "l0.6160219,0.7143061", "l0.6217226,0.7125612", "l0.6305922,0.7196436", "l0.6354043,0.7123901", "l0.6399817,0.7115861", "l0.6402332,0.7171288", "l0.6431841,0.7178473", "l0.6442404,0.7123901", "l0.6478621,0.7118598", "l0.6578887,0.7190962", "l0.6578887,0.7190962", "l0.6595318,0.7245363", "l0.6619127,0.7246561", "l0.6629019,0.7273077", "l0.6628349,0.7377432", "l0.6674290,0.7392999", "l0.6714698,0.7468443", "l0.6693404,0.7469469", "l0.6693572,0.7494104", "l0.6573521,0.7588878", "l0.6591462,0.7610262", "l0.6553401,0.7727105", "l0.6563964,0.7766281", "l0.6502765,0.7745068", "l0.6464704,0.7754819", "l0.6423290,0.7826499", "l0.6455147,0.7837790", "l0.6447938,0.7860372", "l0.6358738,0.7913062", "l0.6344822,0.7894073", "l0.6351696,0.7920589", "l0.6294689,0.7948816", "l0.6287311,0.7987308", "l0.6287311,0.7987308", "l0.6220915,0.7962160", "l0.6209848,0.7939407", "l0.6223765,0.7917339", "l0.6201465,0.7896981", "l0.6107571,0.7904166", "l0.5935208,0.8045815", "l0.5879039,0.8062409", "l0.5783468,0.8175317", "l0.5786821,0.8158381", "l0.5782294,0.8174120", "l0.5662411,0.8154104", "l0.5668615,0.8174633", "l0.5556780,0.8267355", "l0.5488372,0.8380092", "l0.5462048,0.8468537", "l0.5473784,0.8513529", "l0.5451652,0.8720015", "l0.5464395,0.8877402", "l0.5529618,0.8900497", "l0.5521905,0.8932830", "l0.5552589,0.8978335", "l0.5491054,0.8987231", "l0.5459365,0.8941555", "l0.5408058,0.8948911", "l0.5394142,0.8932830", "l0.5373686,0.8957636", "l0.5319194,0.8955241", "l0.5276606,0.9000233", "l0.5245420,0.8988600", "l0.5204509,0.9007247", "l0.5188581,0.9024867", "l0.5202497,0.9068833", "l0.5136268,0.9051897", "l0.5103908,0.9076360", "l0.5070374,0.9069346", "l0.5036170,0.9018367", "l0.4913604,0.8975598", "l0.4875041,0.8996982", "l0.4843016,0.8989455", "l0.4794225,0.9048133", "l0.4746271,0.9061648", "l0.4709384,0.9028973", "l0.4688929,0.8961228", "l0.4651706,0.8964821", "l0.4611466,0.8928382", "l0.4545740,0.8920684", "l0.4552279,0.8862348", "l0.4585813,0.8844556", "l0.4585813,0.8844556", "l0.4643323,0.8838569", "l0.4665288,0.8804867", "l0.4716091,0.8803156", "l0.4733026,0.8760559", "l0.4848549,0.8758677", "l0.4857603,0.8741399", "l0.4793722,0.8673654", "l0.4737553,0.8690932", "l0.4674342,0.8667324", "l0.4683060,0.8650388", "l0.4636449,0.8604369", "l0.4647682,0.8576313", "l0.4725145,0.8558864", "l0.4720786,0.8501725", "l0.4688761,0.8489408", "l0.4705193,0.8468195", "l0.4739229,0.8469735", "l0.4713408,0.8425427", "l0.4724475,0.8401647", "l0.4693959,0.8384198", "l0.4709049,0.8367262", "l0.4701336,0.8324493", "l0.4675515,0.8304649", "l0.4657910,0.8321927", "l0.4630916,0.8278988", "l0.4630748,0.8292503", "l0.4583968,0.8287028", "l0.4531321,0.8249221", "l0.4542387,0.8216375", "l0.4517739,0.8169159", "l0.4550099,0.8129470", "l0.4540710,0.8102782", "l0.4604256,0.8103125", "l0.4595873,0.8053171", "l0.4631083,0.8004415", "l0.4660593,0.8049750", "l0.4676689,0.8025457", "l0.4676689,0.8025457", "l0.4680713,0.8025799", "l0.4680713,0.8025799", "l0.4725984,0.8037261", "l0.4759853,0.8010916", "l0.4784332,0.8049750", "l0.4852405,0.8029563", "l0.4883256,0.8061383", "l0.4887951,0.8014851", "l0.4913437,0.7987308", "l0.5009678,0.8029734", "l0.5034326,0.8010745", "l0.5156556,0.8015364", "l0.5198641,0.7977215", "l0.5203000,0.7932393", "l0.5162089,0.7882953", "l0.5183047,0.7791429", "l0.5234857,0.7806312", "l0.5259337,0.7836250", "l0.5364465,0.7796561", "l0.5375698,0.7762347", "l0.5419292,0.7743700", "l0.5472108,0.7759438", "l0.5474120,0.7620356", "l0.5578409,0.7640884", "l0.5603392,0.7625317", "l0.5593667,0.7592813", "l0.5614123,0.7561678", "l0.5669118,0.7562191", "l0.5679178,0.7507961", "l0.5737024,0.7459205", "l0.5741718,0.7433202", "l0.5700304,0.7401382", "l0.5674316,0.7409422", "l0.5659226,0.7381708", "l0.5634411,0.7391631", "l0.5612446,0.7366996", "l0.5653860,0.7352113", "l0.5662914,0.7302673", "l0.5689238,0.7291553", "l0.5682196,0.7260760", "l0.5572373,0.7270853", "l0.5590482,0.7230822", "l0.5542193,0.7216623", "l0.5535989,0.7186514", "l0.5514192,0.7199173", "l0.5537331,0.7154010", "l0.5513186,0.7099438", "l0.5530624,0.7025192", "l0.5476299,0.6961210", "l0.5489545,0.6905269", "l0.5417951,0.6819904", "c", "m0.4698151,0.8954556", "l0.4735373,0.8964650", "l0.4718606,0.8926500", "l0.4698151,0.8954556", "c"]}, {"n": "Limousin", "u": "FR-L", "i": ["m0.4162450,0.5061441", "l0.4184079,0.5056138", "l0.4190618,0.5081115", "l0.4249805,0.5075298", "l0.4256512,0.5051177", "l0.4284848,0.5046216", "l0.4327604,0.5101302", "l0.4404563,0.5018502", "l0.4417809,0.5053572", "l0.4462744,0.5023976", "l0.4475990,0.5058191", "l0.4515727,0.5027056", "l0.4545908,0.5055967", "l0.4567537,0.5019871", "l0.4558818,0.4994381", "l0.4583465,0.4987880", "l0.4622532,0.5019529", "l0.4719780,0.5001737", "l0.4796069,0.5035780", "l0.4871352,0.5016791", "l0.4929701,0.5025687", "l0.4929701,0.5025687", "l0.4934563,0.5065034", "l0.4966923,0.5074443", "l0.4944958,0.5104210", "l0.4988552,0.5137911", "l0.5004481,0.5116185", "l0.5027954,0.5165796", "l0.5034996,0.5152452", "l0.5070374,0.5168876", "l0.5128555,0.5296496", "l0.5117657,0.5367149", "l0.5153538,0.5419327", "l0.5160412,0.5483479", "l0.5127549,0.5499047", "l0.5122184,0.5542842", "l0.5077584,0.5593479", "l0.5055452,0.5590400", "l0.5055452,0.5590400", "l0.5052434,0.5591084", "l0.5052434,0.5591084", "l0.5004984,0.5632655", "l0.5099213,0.5749498", "l0.5097872,0.5818441", "l0.5073057,0.5819809", "l0.5055787,0.5865144", "l0.5095022,0.5907399", "l0.5073895,0.6043915", "l0.5102231,0.6071287", "l0.5069033,0.6093527", "l0.4977151,0.6051272", "l0.4984863,0.6127057", "l0.4869508,0.6243045", "l0.4874202,0.6283589", "l0.4896167,0.6299499", "l0.4859448,0.6328068", "l0.4854921,0.6383154", "l0.4803111,0.6405393", "l0.4833962,0.6464071", "l0.4810824,0.6483745", "l0.4810824,0.6483745", "l0.4804955,0.6482205", "l0.4804955,0.6482205", "l0.4777290,0.6489561", "l0.4777290,0.6489561", "l0.4724810,0.6491272", "l0.4698486,0.6513169", "l0.4670821,0.6487851", "l0.4597047,0.6542765", "l0.4561166,0.6528224", "l0.4488733,0.6436871", "l0.4418647,0.6435673", "l0.4413282,0.6418224", "l0.4350574,0.6445253", "l0.4350574,0.6445253", "l0.4301783,0.6359546", "l0.4325424,0.6339701", "l0.4253326,0.6331490", "l0.4216272,0.6298815", "l0.4216272,0.6298815", "l0.4219793,0.6298301", "l0.4219793,0.6298301", "l0.4240081,0.6275720", "l0.4197325,0.6259981", "l0.4232200,0.6210028", "l0.4196990,0.6191552", "l0.4203529,0.6141769", "l0.4223314,0.6140743", "l0.4264560,0.6084460", "l0.4217278,0.6061023", "l0.4242931,0.6029716", "l0.4122713,0.5986948", "l0.4154402,0.5936481", "l0.4119192,0.5914242", "l0.4098066,0.5931178", "l0.4051118,0.5850603", "l0.3966949,0.5860354", "l0.3947164,0.5838456", "l0.3907762,0.5886870", "l0.3865510,0.5843589", "l0.3881773,0.5793293", "l0.3844216,0.5764724", "l0.3797101,0.5772080", "l0.3781005,0.5750011", "l0.3781005,0.5750011", "l0.3839856,0.5697150", "l0.3837677,0.5654553", "l0.3886971,0.5667383", "l0.3917487,0.5574661", "l0.3907091,0.5525050", "l0.3955883,0.5534117", "l0.4001153,0.5485703", "l0.3985728,0.5444475", "l0.3957559,0.5421722", "l0.3939451,0.5435921", "l0.3908936,0.5403246", "l0.3923187,0.5356543", "l0.3906085,0.5329000", "l0.3931906,0.5314630", "l0.3894349,0.5237989", "l0.3934757,0.5218829", "l0.3970638,0.5160151", "l0.4042400,0.5168704", "l0.4072245,0.5084194", "l0.4128917,0.5099591", "l0.4148031,0.5056480", "c"]}, {"n": "Lorraine", "u": "FR-M", "i": ["m0.7114252,0.1657425", "l0.7139905,0.1693522", "l0.7151977,0.1769649", "l0.7210326,0.1734579", "l0.7248554,0.1759385", "l0.7270015,0.1712682", "l0.7342113,0.1724999", "l0.7361059,0.1698483", "l0.7405659,0.1720893", "l0.7427624,0.1768794", "l0.7495529,0.1774610", "l0.7506260,0.1820971", "l0.7548010,0.1824735", "l0.7569806,0.1803522", "l0.7588585,0.1818234", "l0.7607364,0.1775124", "l0.7685162,0.1752371", "l0.7772685,0.1811220", "l0.7817285,0.1793257", "l0.7906317,0.1853133", "l0.7894580,0.1873833", "l0.7937168,0.1913693", "l0.7913694,0.1933880", "l0.7985289,0.2006757", "l0.7978917,0.2029681", "l0.7998870,0.2039603", "l0.8003397,0.2076213", "l0.8023014,0.2073647", "l0.8014631,0.2107177", "l0.8033409,0.2132154", "l0.8100812,0.2144129", "l0.8119256,0.2114191", "l0.8102657,0.2079634", "l0.8172407,0.2068685", "l0.8238636,0.2103584", "l0.8250708,0.2186726", "l0.8283906,0.2141734", "l0.8324146,0.2180054", "l0.8386016,0.2169790", "l0.8419382,0.2186042", "l0.8441850,0.2155077", "l0.8467168,0.2155420", "l0.8468844,0.2124969", "l0.8524342,0.2111796", "l0.8518139,0.2132325", "l0.8558714,0.2127706", "l0.8582523,0.2204860", "l0.8654453,0.2231034", "l0.8658309,0.2251905", "l0.8658309,0.2251905", "l0.8617734,0.2356089", "l0.8588727,0.2382605", "l0.8529708,0.2343771", "l0.8441850,0.2370801", "l0.8417370,0.2357628", "l0.8419717,0.2337955", "l0.8302685,0.2303398", "l0.8283068,0.2226244", "l0.8261606,0.2239245", "l0.8237127,0.2357115", "l0.8207952,0.2351641", "l0.8199737,0.2381921", "l0.8175592,0.2381750", "l0.8183137,0.2424689", "l0.8248528,0.2445047", "l0.8249869,0.2461812", "l0.8280888,0.2458048", "l0.8250205,0.2477893", "l0.8250875,0.2508173", "l0.8276696,0.2512963", "l0.8269151,0.2541874", "l0.8302685,0.2523056", "l0.8321464,0.2476524", "l0.8395741,0.2501330", "l0.8388196,0.2516726", "l0.8433969,0.2560350", "l0.8383669,0.2641097", "l0.8399765,0.2672916", "l0.8426927,0.2675482", "l0.8366902,0.2790786", "l0.8329847,0.2817302", "l0.8260097,0.2820724", "l0.8308050,0.2849122", "l0.8277199,0.2842963", "l0.8296313,0.2874098", "l0.8273846,0.2955358", "l0.8290110,0.2977427", "l0.8267642,0.3004285", "l0.8296146,0.3024643", "l0.8340075,0.3017800", "l0.8353488,0.3049106", "l0.8256241,0.3224628", "l0.8268313,0.3262606", "l0.8214994,0.3356012", "l0.8175592,0.3379107", "l0.8153292,0.3464130", "l0.8165364,0.3474224", "l0.8142562,0.3494239", "l0.8158658,0.3537521", "l0.8100645,0.3566774", "l0.8100645,0.3566774", "l0.7968857,0.3480211", "l0.7939012,0.3435732", "l0.7851992,0.3499542", "l0.7822147,0.3440180", "l0.7790123,0.3420164", "l0.7661353,0.3450444", "l0.7661353,0.3450444", "l0.7661353,0.3444970", "l0.7661353,0.3444970", "l0.7622790,0.3414006", "l0.7615077,0.3359262", "l0.7615077,0.3359262", "l0.7613400,0.3358065", "l0.7613400,0.3358065", "l0.7547004,0.3374830", "l0.7521183,0.3424612", "l0.7484128,0.3446339", "l0.7469038,0.3443944", "l0.7491505,0.3412124", "l0.7472559,0.3402373", "l0.7438858,0.3456774", "l0.7438858,0.3456774", "l0.7412534,0.3404255", "l0.7371119,0.3428718", "l0.7363574,0.3343181", "l0.7325514,0.3332233", "l0.7307741,0.3297505", "l0.7259955,0.3288267", "l0.7289633,0.3263974", "l0.7296507,0.3188531", "l0.7330711,0.3168687", "l0.7301202,0.3130195", "l0.7269177,0.3121984", "l0.7277728,0.3094099", "l0.7248386,0.3068609", "l0.7232625,0.3087598", "l0.7187858,0.3008904", "l0.7156336,0.3000008", "l0.7119785,0.3026525", "l0.7130348,0.2975374", "l0.7096646,0.2962714", "l0.7149294,0.2928671", "l0.7051544,0.2836462", "l0.6970727,0.2816447", "l0.6906175,0.2744596", "l0.6872809,0.2744083", "l0.6863084,0.2705078", "l0.6822509,0.2723212", "l0.6830054,0.2587551", "l0.6746890,0.2526649", "l0.6779418,0.2479432", "l0.6761980,0.2451718", "l0.6776903,0.2401252", "l0.6776903,0.2401252", "l0.6779921,0.2398173", "l0.6779921,0.2398173", "l0.6834245,0.2375249", "l0.6850342,0.2337955", "l0.6818988,0.2327177", "l0.6846653,0.2317084", "l0.6848162,0.2284238", "l0.6828880,0.2271236", "l0.6798700,0.2286462", "l0.6825862,0.2235482", "l0.6780592,0.2109743", "l0.6817311,0.2083569", "l0.6788807,0.2053118", "l0.6858054,0.2012916", "l0.6862078,0.1991531", "l0.6840281,0.1974082", "l0.6860402,0.1911640", "l0.6893265,0.1899836", "l0.6876498,0.1873320", "l0.6903157,0.1855015", "l0.6900307,0.1813102", "l0.6864090,0.1766570", "l0.6884546,0.1727565", "l0.6884546,0.1727565", "l0.6885720,0.1721064", "l0.6885720,0.1721064", "l0.6901313,0.1666663", "l0.6922774,0.1668374", "l0.6936858,0.1698654", "l0.6986488,0.1691640", "l0.7005602,0.1721749", "l0.7098491,0.1640147", "l0.7098491,0.1640147", "c"]}, {"n": "Midi-Pyrénées", "u": "FR-N", "i": ["m0.3265425,0.8132549", "l0.3269449,0.8135286", "l0.3269449,0.8135286", "l0.3286718,0.8178397", "l0.3257712,0.8199610", "l0.3244634,0.8169672", "l0.3258215,0.8136655", "l0.3258215,0.8136655", "l0.3263077,0.8132891", "l0.3263077,0.8132891", "l0.3265425,0.8132549", "c", "m0.3285880,0.8074042", "l0.3289904,0.8135115", "l0.3289904,0.8135115", "l0.3278335,0.8132207", "l0.3278335,0.8132207", "l0.3261568,0.8115784", "l0.3281856,0.8107401", "l0.3279173,0.8070621", "l0.3279173,0.8070621", "l0.3285880,0.8074042", "c", "m0.4350574,0.6445253", "l0.4413282,0.6418224", "l0.4418647,0.6435673", "l0.4488733,0.6436871", "l0.4561166,0.6528395", "l0.4597047,0.6542936", "l0.4670821,0.6488022", "l0.4698486,0.6513340", "l0.4724978,0.6491443", "l0.4777290,0.6489732", "l0.4777290,0.6489732", "l0.4806129,0.6544989", "l0.4797913,0.6591863", "l0.4853915,0.6676373", "l0.4824740,0.6768069", "l0.4845196,0.6768924", "l0.4853411,0.6825720", "l0.4876717,0.6846420", "l0.4885604,0.6814258", "l0.4940096,0.6796125", "l0.4962228,0.6794072", "l0.4980001,0.6823838", "l0.5071548,0.6813745", "l0.5082446,0.6775767", "l0.5124699,0.6744803", "l0.5117657,0.6711614", "l0.5152867,0.6672952", "l0.5155718,0.6619406", "l0.5247935,0.6523947", "l0.5273924,0.6553201", "l0.5272918,0.6609313", "l0.5333278,0.6590837", "l0.5353231,0.6675689", "l0.5375698,0.6671241", "l0.5387268,0.6690743", "l0.5369495,0.6703403", "l0.5387100,0.6784492", "l0.5418286,0.6819733", "l0.5418286,0.6819733", "l0.5490551,0.6904414", "l0.5477305,0.6960355", "l0.5531630,0.7024336", "l0.5514192,0.7098582", "l0.5538337,0.7153155", "l0.5515198,0.7198318", "l0.5536995,0.7185658", "l0.5543199,0.7215767", "l0.5591488,0.7229966", "l0.5573379,0.7269998", "l0.5683202,0.7259904", "l0.5690244,0.7290697", "l0.5663920,0.7301817", "l0.5654866,0.7351257", "l0.5613452,0.7366141", "l0.5635417,0.7390775", "l0.5660232,0.7380853", "l0.5675322,0.7408567", "l0.5701310,0.7400527", "l0.5742724,0.7432346", "l0.5738030,0.7458349", "l0.5680184,0.7507105", "l0.5670124,0.7561335", "l0.5615129,0.7560822", "l0.5594673,0.7591958", "l0.5604398,0.7624461", "l0.5579415,0.7640029", "l0.5475126,0.7619500", "l0.5473114,0.7758583", "l0.5420298,0.7742844", "l0.5376704,0.7761491", "l0.5365471,0.7795706", "l0.5260343,0.7835395", "l0.5235863,0.7805457", "l0.5184053,0.7790574", "l0.5163095,0.7882098", "l0.5204006,0.7931538", "l0.5199647,0.7976359", "l0.5157562,0.8014509", "l0.5035332,0.8009890", "l0.5010684,0.8028879", "l0.4914443,0.7986453", "l0.4888957,0.8013995", "l0.4884262,0.8060527", "l0.4853411,0.8028708", "l0.4785338,0.8048894", "l0.4760859,0.8010061", "l0.4726990,0.8036406", "l0.4681719,0.8024944", "l0.4681719,0.8024944", "l0.4677695,0.8024602", "l0.4677695,0.8024602", "l0.4661599,0.8048894", "l0.4632089,0.8003560", "l0.4596879,0.8052316", "l0.4605262,0.8102269", "l0.4541716,0.8101927", "l0.4551105,0.8128614", "l0.4518745,0.8168303", "l0.4543393,0.8215520", "l0.4532327,0.8248366", "l0.4584974,0.8286173", "l0.4631754,0.8291647", "l0.4631922,0.8278132", "l0.4658916,0.8321072", "l0.4676521,0.8303793", "l0.4702342,0.8323638", "l0.4710055,0.8366406", "l0.4694965,0.8383343", "l0.4725481,0.8400792", "l0.4714414,0.8424571", "l0.4740235,0.8468879", "l0.4706199,0.8467340", "l0.4689767,0.8488553", "l0.4721792,0.8500870", "l0.4726151,0.8558008", "l0.4648688,0.8575458", "l0.4637455,0.8603514", "l0.4684066,0.8649533", "l0.4675348,0.8666469", "l0.4738559,0.8690077", "l0.4794728,0.8672799", "l0.4858609,0.8740544", "l0.4849555,0.8757822", "l0.4734032,0.8759704", "l0.4717097,0.8802301", "l0.4666294,0.8804012", "l0.4644329,0.8837713", "l0.4586819,0.8843701", "l0.4586819,0.8843701", "l0.4590843,0.8830528", "l0.4544399,0.8828304", "l0.4551273,0.8802643", "l0.4456205,0.8793234", "l0.4422336,0.8765178", "l0.4373209,0.8769113", "l0.4371700,0.8805038", "l0.4343700,0.8815987", "l0.4287531,0.8704105", "l0.4200176,0.8695893", "l0.4157588,0.8714369", "l0.4094880,0.8637557", "l0.4028483,0.8639268", "l0.4012052,0.8620792", "l0.3988243,0.8636702", "l0.3836503,0.8566733", "l0.3802131,0.8588288", "l0.3809844,0.8621134", "l0.3792238,0.8642176", "l0.3807329,0.8649533", "l0.3790226,0.8669206", "l0.3815209,0.8696578", "l0.3813532,0.8730621", "l0.3758872,0.8716593", "l0.3637145,0.8730963", "l0.3593719,0.8698973", "l0.3547946,0.8747729", "l0.3523801,0.8707013", "l0.3465788,0.8686655", "l0.3341714,0.8736780", "l0.3303653,0.8729766", "l0.3295437,0.8705474", "l0.3265089,0.8697433", "l0.3231723,0.8627977", "l0.3212609,0.8638584", "l0.3125589,0.8578366", "l0.3125589,0.8578366", "l0.3115697,0.8512845", "l0.3147889,0.8496764", "l0.3143194,0.8427822", "l0.3162141,0.8397028", "l0.3218310,0.8382829", "l0.3209256,0.8322440", "l0.3241951,0.8308241", "l0.3261903,0.8258630", "l0.3296443,0.8261538", "l0.3292754,0.8216888", "l0.3309354,0.8220994", "l0.3331654,0.8170527", "l0.3311533,0.8140418", "l0.3364349,0.8096795", "l0.3341211,0.8071476", "l0.3343223,0.8000309", "l0.3296946,0.8033840", "l0.3297952,0.7983031", "l0.3330983,0.7974306", "l0.3297617,0.7900232", "l0.3278670,0.7904851", "l0.3276658,0.7867214", "l0.3220489,0.7853186", "l0.3177734,0.7866530", "l0.3171698,0.7834197", "l0.3149230,0.7831631", "l0.3147721,0.7807510", "l0.3175387,0.7796048", "l0.3170021,0.7744726", "l0.3208417,0.7715301", "l0.3186285,0.7645846", "l0.3209256,0.7644135", "l0.3198693,0.7597261", "l0.3214118,0.7586825", "l0.3177063,0.7558085", "l0.3218813,0.7517199", "l0.3276994,0.7527805", "l0.3318408,0.7472891", "l0.3348420,0.7502657", "l0.3329138,0.7527121", "l0.3384804,0.7559454", "l0.3396709,0.7539267", "l0.3382457,0.7495301", "l0.3432087,0.7455612", "l0.3452710,0.7484010", "l0.3477190,0.7442439", "l0.3504520,0.7435597", "l0.3552976,0.7466390", "l0.3562868,0.7447914", "l0.3651900,0.7428583", "l0.3664978,0.7401724", "l0.3731040,0.7402579", "l0.3756860,0.7377774", "l0.3806155,0.7432859", "l0.3859306,0.7396079", "l0.3871546,0.7351086", "l0.3900385,0.7347494", "l0.3894181,0.7315503", "l0.3944984,0.7332268", "l0.3967284,0.7321149", "l0.3961248,0.7284539", "l0.3938948,0.7275643", "l0.3976003,0.7269142", "l0.4006686,0.7186685", "l0.3950014,0.7151444", "l0.3968793,0.7081304", "l0.3985560,0.7078396", "l0.4000147,0.7116887", "l0.4007525,0.7100635", "l0.4083814,0.7096700", "l0.4079790,0.7036312", "l0.4053466,0.7018520", "l0.4053130,0.6957789", "l0.4028483,0.6920837", "l0.4051957,0.6927851", "l0.4113826,0.6891755", "l0.4107120,0.6871739", "l0.4148198,0.6826576", "l0.4144007,0.6795782", "l0.4196487,0.6782097", "l0.4260536,0.6725813", "l0.4248296,0.6670215", "l0.4295411,0.6655160", "l0.4292561,0.6622656", "l0.4347053,0.6587073", "l0.4327604,0.6555253", "l0.4347724,0.6549266", "l0.4328107,0.6472454", "l0.4328107,0.6472454", "l0.4325256,0.6460650", "l0.4325256,0.6460650", "l0.4350574,0.6445253", "c"]}, {"n": "Nord-Pas-de-Calais", "u": "FR-O", "i": ["m0.5125537,0.0044033", "l0.5134424,0.0103224", "l0.5174832,0.0165324", "l0.5145825,0.0196459", "l0.5152364,0.0275153", "l0.5177179,0.0316895", "l0.5238210,0.0319290", "l0.5287840,0.0415775", "l0.5324224,0.0417486", "l0.5365806,0.0451872", "l0.5397831,0.0384982", "l0.5535989,0.0342385", "l0.5563822,0.0414920", "l0.5612111,0.0441265", "l0.5597188,0.0490021", "l0.5633572,0.0639026", "l0.5692424,0.0675978", "l0.5742054,0.0658870", "l0.5761168,0.0629104", "l0.5791851,0.0639881", "l0.5779108,0.0680255", "l0.5854224,0.0670503", "l0.5890440,0.0714298", "l0.5889267,0.0810612", "l0.5923974,0.0882121", "l0.5951472,0.0830970", "l0.6022898,0.0829944", "l0.6058947,0.0857829", "l0.6144290,0.0822245", "l0.6180339,0.0875620", "l0.6208675,0.0883832", "l0.6223094,0.0934298", "l0.6243717,0.0933956", "l0.6240364,0.0899742", "l0.6272556,0.0918731", "l0.6281443,0.0940115", "l0.6232484,0.0984252", "l0.6235502,0.1039337", "l0.6217058,0.1072012", "l0.6267023,0.1072697", "l0.6287982,0.1143008", "l0.6239190,0.1166274", "l0.6226448,0.1241717", "l0.6226448,0.1241717", "l0.6187549,0.1253350", "l0.6113272,0.1226663", "l0.6114445,0.1170722", "l0.6048552,0.1209042", "l0.6037821,0.1177907", "l0.5928166,0.1142324", "l0.5892788,0.1159944", "l0.5889770,0.1186460", "l0.5858080,0.1191422", "l0.5809289,0.1158747", "l0.5772402,0.1199120", "l0.5683873,0.1178591", "l0.5660064,0.1201515", "l0.5624183,0.1203226", "l0.5610937,0.1183210", "l0.5550912,0.1206305", "l0.5496420,0.1160799", "l0.5440754,0.1153785", "l0.5410573,0.1173117", "l0.5375195,0.1164905", "l0.5335961,0.1196383", "l0.5331602,0.1133599", "l0.5254642,0.1170722", "l0.5277780,0.1096305", "l0.5242234,0.1080224", "l0.5226641,0.1079026", "l0.5224126,0.1129664", "l0.5135094,0.1094252", "l0.5136436,0.1064656", "l0.5118831,0.1061748", "l0.5105417,0.1093568", "l0.5092507,0.1063630", "l0.5069201,0.1066538", "l0.5025775,0.1122821", "l0.4996097,0.1098358", "l0.5004313,0.1049773", "l0.5078758,0.1004610", "l0.5048410,0.0964921", "l0.5017056,0.0960302", "l0.4983857,0.0991437", "l0.4965582,0.0955512", "l0.4961893,0.0984252", "l0.4922156,0.0966802", "l0.4838154,0.1009400", "l0.4824237,0.0988015", "l0.4793386,0.0997938", "l0.4787182,0.0940970", "l0.4696474,0.0901452", "l0.4686414,0.0888622", "l0.4709720,0.0864158", "l0.4697145,0.0853552", "l0.4670150,0.0875278", "l0.4598053,0.0820706", "l0.4500805,0.0854920", "l0.4484541,0.0830286", "l0.4484541,0.0830286", "l0.4423510,0.0776569", "l0.4445977,0.0623287", "l0.4479679,0.0651172", "l0.4438768,0.0588730", "l0.4429211,0.0413722", "l0.4432061,0.0397299", "l0.4438432,0.0424158", "l0.4451007,0.0406537", "l0.4464756,0.0326646", "l0.4442121,0.0251032", "l0.4497955,0.0234267", "l0.4556136,0.0168745", "l0.4643826,0.0139663", "l0.4623371,0.0135728", "l0.4800093,0.0089196", "l0.4808979,0.0100829", "l0.4845866,0.0062167", "l0.4838154,0.0082353", "l0.4859615,0.0103224", "l0.4871184,0.0062167", "l0.4876885,0.0075339", "l0.4980169,0.0039243", "l0.4999451,0.0053442", "l0.5113465,0.0005713", "l0.5125537,0.0044033", "c"]}, {"n": "Basse-Normandie", "u": "FR-P", "i": ["m0.1996343,0.1519882", "l0.2029541,0.1542635", "l0.2054021,0.1529633", "l0.2073135,0.1559571", "l0.2216827,0.1594299", "l0.2213473,0.1619618", "l0.2222192,0.1595497", "l0.2306529,0.1583350", "l0.2316254,0.1551873", "l0.2461119,0.1552728", "l0.2486270,0.1650411", "l0.2468161,0.1643910", "l0.2455922,0.1689416", "l0.2456257,0.1674190", "l0.2438317,0.1677612", "l0.2430268,0.1715419", "l0.2529696,0.1868701", "l0.2505384,0.1947737", "l0.2538079,0.1917286", "l0.2565241,0.1937643", "l0.2593913,0.1887690", "l0.2670034,0.1879478", "l0.2816241,0.1932169", "l0.3067744,0.1949447", "l0.3147721,0.1993413", "l0.3172704,0.1984346", "l0.3187123,0.2006415", "l0.3341211,0.1958514", "l0.3430578,0.1875373", "l0.3497813,0.1846461", "l0.3419344,0.1843040", "l0.3540736,0.1841158", "l0.3540736,0.1841158", "l0.3569072,0.1942091", "l0.3548616,0.1968265", "l0.3568066,0.1989307", "l0.3558341,0.2003506", "l0.3595396,0.1988623", "l0.3609983,0.2001283", "l0.3609983,0.2024377", "l0.3566054,0.2041656", "l0.3617528,0.2082542", "l0.3610989,0.2143787", "l0.3644355,0.2157644", "l0.3621720,0.2194937", "l0.3634966,0.2228297", "l0.3598582,0.2252760", "l0.3654583,0.2292791", "l0.3610151,0.2404673", "l0.3658271,0.2440599", "l0.3726345,0.2445389", "l0.3747136,0.2425373", "l0.3753339,0.2447955", "l0.3771448,0.2441625", "l0.3767759,0.2466431", "l0.3786035,0.2466773", "l0.3767256,0.2490723", "l0.3869869,0.2560521", "l0.3880935,0.2592341", "l0.3848910,0.2625358", "l0.3877917,0.2637846", "l0.3879258,0.2665560", "l0.3910445,0.2665047", "l0.3910445,0.2665047", "l0.3912960,0.2727146", "l0.4015573,0.2821750", "l0.3994279,0.2872046", "l0.4022112,0.2910537", "l0.3979189,0.2982901", "l0.3878755,0.3036618", "l0.3868528,0.3060910", "l0.3903906,0.3072030", "l0.3891330,0.3101968", "l0.3920672,0.3152264", "l0.3898037,0.3172792", "l0.3898037,0.3172792", "l0.3856455,0.3179122", "l0.3797772,0.3098718", "l0.3787544,0.3131393", "l0.3715614,0.3114627", "l0.3683589,0.3049277", "l0.3676547,0.3061595", "l0.3615851,0.3036789", "l0.3608977,0.2926960", "l0.3552305,0.2867084", "l0.3443488,0.2891890", "l0.3452207,0.2908997", "l0.3392517,0.2944067", "l0.3383295,0.2977085", "l0.3342217,0.2956043", "l0.3307342,0.2980335", "l0.3307509,0.2898562", "l0.3240610,0.2892403", "l0.3221831,0.2835094", "l0.3241448,0.2816447", "l0.3198357,0.2778297", "l0.3169183,0.2777613", "l0.3174548,0.2807551", "l0.3153590,0.2838515", "l0.3118882,0.2822434", "l0.3096582,0.2863321", "l0.3066235,0.2835778", "l0.2987430,0.2836804", "l0.2958759,0.2875125", "l0.2889009,0.2906089", "l0.2880626,0.2862123", "l0.2863020,0.2880257", "l0.2834182,0.2874783", "l0.2845918,0.2899931", "l0.2813726,0.2914814", "l0.2800648,0.2883507", "l0.2776336,0.2894285", "l0.2754371,0.2847240", "l0.2710107,0.2850148", "l0.2677579,0.2828080", "l0.2643878,0.2858018", "l0.2598272,0.2837831", "l0.2598272,0.2837831", "l0.2470341,0.2799682", "l0.2400591,0.2879915", "l0.2353644,0.2888469", "l0.2306865,0.2858360", "l0.2248851,0.2702854", "l0.2248851,0.2702854", "l0.2290265,0.2718251", "l0.2291104,0.2699433", "l0.2305356,0.2715342", "l0.2350458,0.2693787", "l0.2400591,0.2705078", "l0.2360183,0.2676338", "l0.2377788,0.2658717", "l0.2335200,0.2680615", "l0.2250528,0.2582076", "l0.2247510,0.2501672", "l0.2219677,0.2487302", "l0.2270816,0.2383118", "l0.2255558,0.2373025", "l0.2259079,0.2281158", "l0.2295966,0.2287659", "l0.2257067,0.2268499", "l0.2244660,0.2309557", "l0.2229569,0.2268328", "l0.2219174,0.2073818", "l0.2251702,0.2070567", "l0.2219006,0.2056539", "l0.2210455,0.2083398", "l0.2154454,0.1953895", "l0.2083027,0.1905995", "l0.2056368,0.1762977", "l0.2028703,0.1729960", "l0.2061566,0.1689758", "l0.2056033,0.1623895", "l0.2037421,0.1593444", "l0.1987289,0.1575994", "l0.1996343,0.1519882", "c"]}, {"n": "Haute-Normandie", "u": "FR-Q", "i": ["m0.4301615,0.1148653", "l0.4351245,0.1142324", "l0.4353760,0.1176025", "l0.4534506,0.1344190", "l0.4549932,0.1423055", "l0.4585980,0.1480706", "l0.4560495,0.1479680", "l0.4518578,0.1554781", "l0.4530482,0.1570178", "l0.4562004,0.1554781", "l0.4524279,0.1610209", "l0.4540878,0.1633133", "l0.4526626,0.1677783", "l0.4526626,0.1677783", "l0.4523608,0.1677783", "l0.4523608,0.1677783", "l0.4559992,0.1726197", "l0.4538363,0.1763662", "l0.4557477,0.1779400", "l0.4567705,0.1755108", "l0.4589166,0.1763662", "l0.4576423,0.1800614", "l0.4576423,0.1800614", "l0.4569717,0.1805061", "l0.4569717,0.1805061", "l0.4536015,0.1868701", "l0.4553956,0.1870583", "l0.4541213,0.1883926", "l0.4568711,0.1913693", "l0.4576591,0.1994782", "l0.4598556,0.2013429", "l0.4588160,0.2044393", "l0.4566531,0.2015824", "l0.4532662,0.2024206", "l0.4528806,0.2059961", "l0.4528806,0.2059961", "l0.4472134,0.2217861", "l0.4405066,0.2235311", "l0.4405066,0.2235311", "l0.4401378,0.2235482", "l0.4401378,0.2235482", "l0.4393833,0.2218032", "l0.4379078,0.2255840", "l0.4351077,0.2252760", "l0.4372203,0.2295358", "l0.4366503,0.2336415", "l0.4400372,0.2333678", "l0.4381760,0.2345995", "l0.4387964,0.2374907", "l0.4387964,0.2374907", "l0.4350909,0.2392869", "l0.4359461,0.2448639", "l0.4291052,0.2488841", "l0.4298262,0.2546151", "l0.4270429,0.2567706", "l0.4193972,0.2571128", "l0.4123551,0.2537426", "l0.4119359,0.2583445", "l0.4083143,0.2570786", "l0.4045753,0.2606198", "l0.4045753,0.2606198", "l0.4031334,0.2606198", "l0.4031334,0.2606198", "l0.3953032,0.2616633", "l0.3944146,0.2646400", "l0.3910612,0.2665560", "l0.3910612,0.2665560", "l0.3879426,0.2666073", "l0.3878085,0.2638359", "l0.3849078,0.2625871", "l0.3881103,0.2592854", "l0.3870037,0.2561034", "l0.3767424,0.2491236", "l0.3786202,0.2467286", "l0.3767927,0.2466944", "l0.3771615,0.2442138", "l0.3753507,0.2448468", "l0.3747303,0.2425886", "l0.3726512,0.2445902", "l0.3658439,0.2441112", "l0.3610318,0.2405187", "l0.3654750,0.2293305", "l0.3598749,0.2253273", "l0.3635133,0.2228810", "l0.3621887,0.2195451", "l0.3644523,0.2158157", "l0.3611157,0.2144300", "l0.3617696,0.2083056", "l0.3566222,0.2042169", "l0.3610151,0.2024891", "l0.3610151,0.2001796", "l0.3595564,0.1989136", "l0.3558509,0.2004020", "l0.3568234,0.1989821", "l0.3548784,0.1968779", "l0.3569240,0.1942604", "l0.3540904,0.1841671", "l0.3540904,0.1841671", "l0.3547778,0.1822340", "l0.3531347,0.1835341", "l0.3421859,0.1800956", "l0.3388661,0.1757503", "l0.3448854,0.1609354", "l0.3428566,0.1581811", "l0.3450530,0.1592075", "l0.3486579,0.1534766", "l0.3576952,0.1497814", "l0.3750824,0.1377378", "l0.3880264,0.1357192", "l0.4010543,0.1300908", "l0.4051621,0.1313055", "l0.4097060,0.1292184", "l0.4104102,0.1311686", "l0.4099575,0.1290131", "l0.4174187,0.1253863", "l0.4301615,0.1148653", "c"]}, {"n": "Pays de la Loire", "u": "FR-R", "i": ["m0.1771667,0.4397164", "l0.1799165,0.4416837", "l0.1789272,0.4451907", "l0.1841417,0.4478766", "l0.1846447,0.4535391", "l0.1805704,0.4469528", "l0.1768649,0.4467988", "l0.1741655,0.4434971", "l0.1736960,0.4400243", "l0.1771667,0.4397164", "c", "m0.2597601,0.2838002", "l0.2643207,0.2858189", "l0.2676909,0.2828251", "l0.2709436,0.2850319", "l0.2753701,0.2847411", "l0.2775665,0.2894456", "l0.2799977,0.2883679", "l0.2813055,0.2914985", "l0.2845248,0.2900102", "l0.2833511,0.2874954", "l0.2862350,0.2880428", "l0.2879955,0.2862294", "l0.2888338,0.2906260", "l0.2958088,0.2875296", "l0.2986760,0.2836976", "l0.3065564,0.2835949", "l0.3095912,0.2863492", "l0.3118212,0.2822605", "l0.3152919,0.2838686", "l0.3173878,0.2807722", "l0.3168512,0.2777784", "l0.3197687,0.2778468", "l0.3240777,0.2816618", "l0.3221160,0.2835265", "l0.3239939,0.2892574", "l0.3306839,0.2898733", "l0.3306671,0.2980506", "l0.3341546,0.2956214", "l0.3382625,0.2977256", "l0.3391846,0.2944238", "l0.3451536,0.2909168", "l0.3442818,0.2892061", "l0.3551634,0.2867256", "l0.3608306,0.2927131", "l0.3615181,0.3036960", "l0.3675877,0.3061766", "l0.3682919,0.3049449", "l0.3714943,0.3114799", "l0.3786873,0.3131564", "l0.3797101,0.3098889", "l0.3855785,0.3179293", "l0.3897367,0.3172963", "l0.3897367,0.3172963", "l0.3979524,0.3231813", "l0.3934421,0.3237629", "l0.3927715,0.3268936", "l0.3908265,0.3273555", "l0.3930397,0.3278516", "l0.3928888,0.3302124", "l0.3894516,0.3304690", "l0.3897031,0.3340102", "l0.3928218,0.3347971", "l0.3911786,0.3394161", "l0.3932912,0.3442746", "l0.3909606,0.3451129", "l0.3906756,0.3497318", "l0.3891833,0.3472513", "l0.3871713,0.3484317", "l0.3877246,0.3556681", "l0.3824263,0.3608174", "l0.3830802,0.3625281", "l0.3778657,0.3641191", "l0.3750154,0.3676945", "l0.3757196,0.3707910", "l0.3773292,0.3702949", "l0.3757531,0.3725188", "l0.3665481,0.3753415", "l0.3655253,0.3780445", "l0.3609312,0.3754784", "l0.3596234,0.3779931", "l0.3623061,0.3823042", "l0.3609480,0.3831938", "l0.3504184,0.3795328", "l0.3504184,0.3795328", "l0.3505023,0.3804224", "l0.3505023,0.3804224", "l0.3477357,0.3864442", "l0.3499657,0.3876759", "l0.3496472,0.3905328", "l0.3448686,0.4010709", "l0.3469142,0.4029356", "l0.3396038,0.4133882", "l0.3380110,0.4256371", "l0.3380110,0.4256371", "l0.3355295,0.4244909", "l0.3336851,0.4260476", "l0.3316563,0.4337117", "l0.3281688,0.4322405", "l0.3251676,0.4370819", "l0.3216968,0.4354053", "l0.3242454,0.4319497", "l0.3213615,0.4314364", "l0.3199363,0.4329077", "l0.3156775,0.4317102", "l0.3065732,0.4332156", "l0.3058019,0.4357646", "l0.3006712,0.4371503", "l0.3021802,0.4342249", "l0.2997323,0.4340197", "l0.2954400,0.4360383", "l0.2963286,0.4393229", "l0.2924890,0.4430181", "l0.2875260,0.4423680", "l0.2844577,0.4443696", "l0.2793941,0.4421456", "l0.2748671,0.4458408", "l0.2718323,0.4453618", "l0.2740958,0.4466620", "l0.2730730,0.4483385", "l0.2751856,0.4484069", "l0.2743808,0.4495360", "l0.2779857,0.4509217", "l0.2763761,0.4546682", "l0.2802492,0.4593214", "l0.2802492,0.4593214", "l0.2805343,0.4593214", "l0.2805343,0.4593214", "l0.2833008,0.4612203", "l0.2833008,0.4612203", "l0.2837870,0.4612203", "l0.2837870,0.4612203", "l0.2856146,0.4624349", "l0.2842230,0.4637522", "l0.2842230,0.4637522", "l0.2842900,0.4641799", "l0.2842900,0.4641799", "l0.2841224,0.4680290", "l0.2885488,0.4737258", "l0.2869224,0.4751628", "l0.2898901,0.4775236", "l0.2883811,0.4803121", "l0.2913656,0.4818175", "l0.2904602,0.4865734", "l0.2920866,0.4910042", "l0.2890518,0.4922359", "l0.2917848,0.4989762", "l0.2895045,0.5048782", "l0.2909632,0.5055283", "l0.2919860,0.5032359", "l0.2966137,0.5062126", "l0.2890853,0.5132095", "l0.2855811,0.5123370", "l0.2839044,0.5147320", "l0.2765605,0.5111053", "l0.2765605,0.5111053", "l0.2762587,0.5106605", "l0.2762587,0.5106605", "l0.2749509,0.5131924", "l0.2724023,0.5122344", "l0.2692837,0.5139280", "l0.2672214,0.5126620", "l0.2694178,0.5076838", "l0.2607997,0.5098564", "l0.2593242,0.5131924", "l0.2564738,0.5132608", "l0.2564738,0.5132608", "l0.2505049,0.5134319", "l0.2502198,0.5180508", "l0.2425909,0.5114816", "l0.2439993,0.5158782", "l0.2406627,0.5106434", "l0.2320110,0.5106263", "l0.2287583,0.5043137", "l0.2194024,0.5026543", "l0.2079506,0.4949731", "l0.2049326,0.4829979", "l0.1985947,0.4739653", "l0.1850807,0.4611177", "l0.1843932,0.4541379", "l0.1872771,0.4538813", "l0.1866567,0.4521192", "l0.1926593,0.4459092", "l0.1929946,0.4417179", "l0.1965156,0.4396480", "l0.1880987,0.4307008", "l0.1778374,0.4288361", "l0.1834710,0.4251238", "l0.1831189,0.4151503", "l0.1803189,0.4145344", "l0.1742158,0.4184349", "l0.1689174,0.4136961", "l0.1650108,0.4157832", "l0.1571304,0.4124644", "l0.1596454,0.4105484", "l0.1598466,0.4074520", "l0.1561076,0.4036884", "l0.1631161,0.3985391", "l0.1631496,0.3959901", "l0.1631496,0.3959901", "l0.1655473,0.3929621", "l0.1670563,0.3951347", "l0.1729247,0.3946386", "l0.1742325,0.3888563", "l0.1779715,0.3911316", "l0.1821465,0.3892327", "l0.1836387,0.3916277", "l0.1840747,0.3882918", "l0.1881993,0.3871114", "l0.1893394,0.3748283", "l0.1969013,0.3702093", "l0.1981756,0.3725701", "l0.2047817,0.3686525", "l0.2187149,0.3685499", "l0.2213473,0.3628703", "l0.2317260,0.3587132", "l0.2313236,0.3553088", "l0.2376279,0.3560616", "l0.2393549,0.3591238", "l0.2474701,0.3615017", "l0.2538415,0.3416230", "l0.2634824,0.3375685", "l0.2594416,0.3165949", "l0.2594416,0.3165949", "l0.2591565,0.3163212", "l0.2591565,0.3163212", "l0.2575972,0.3096323", "l0.2614871,0.3029604", "l0.2589889,0.2938080", "l0.2597601,0.2838002", "c"]}, {"n": "Picardie", "u": "FR-S", "i": ["m0.4475319,0.0822245", "l0.4485212,0.0830286", "l0.4485212,0.0830286", "l0.4501476,0.0854920", "l0.4598723,0.0820706", "l0.4670821,0.0875278", "l0.4697815,0.0853552", "l0.4710390,0.0864158", "l0.4687084,0.0888622", "l0.4697145,0.0901452", "l0.4787853,0.0940970", "l0.4794057,0.0997938", "l0.4824908,0.0988015", "l0.4838824,0.1009400", "l0.4922826,0.0966802", "l0.4962564,0.0984252", "l0.4966252,0.0955512", "l0.4984528,0.0991437", "l0.5017726,0.0960302", "l0.5049080,0.0964921", "l0.5079428,0.1004610", "l0.5004984,0.1049773", "l0.4996768,0.1098358", "l0.5026445,0.1122821", "l0.5069871,0.1066538", "l0.5093177,0.1063630", "l0.5106088,0.1093568", "l0.5119501,0.1061748", "l0.5137106,0.1064656", "l0.5135765,0.1094252", "l0.5224797,0.1129664", "l0.5227312,0.1079026", "l0.5242905,0.1080224", "l0.5278451,0.1096305", "l0.5255313,0.1170722", "l0.5332272,0.1133599", "l0.5336632,0.1196383", "l0.5375866,0.1164905", "l0.5411244,0.1173117", "l0.5441424,0.1153785", "l0.5497090,0.1160799", "l0.5551583,0.1206305", "l0.5611608,0.1183210", "l0.5624854,0.1203226", "l0.5660735,0.1201515", "l0.5684544,0.1178591", "l0.5773072,0.1199120", "l0.5809959,0.1158747", "l0.5858751,0.1191422", "l0.5890440,0.1186460", "l0.5893458,0.1159944", "l0.5928836,0.1142324", "l0.6038491,0.1177907", "l0.6049222,0.1209042", "l0.6115116,0.1170722", "l0.6113942,0.1226663", "l0.6188219,0.1253350", "l0.6227118,0.1241717", "l0.6227118,0.1241717", "l0.6289156,0.1264299", "l0.6289156,0.1264299", "l0.6279096,0.1313739", "l0.6305587,0.1324688", "l0.6303910,0.1363863", "l0.6271047,0.1460862", "l0.6301563,0.1486010", "l0.6256460,0.1549478", "l0.6215382,0.1572402", "l0.6207669,0.1621671", "l0.6156027,0.1616539", "l0.6143787,0.1633817", "l0.6181680,0.1689416", "l0.6162063,0.1718156", "l0.6182519,0.1740396", "l0.6156195,0.1759727", "l0.6175141,0.1826617", "l0.6153847,0.1834486", "l0.6152841,0.1919510", "l0.6099020,0.1900863", "l0.6074205,0.1869043", "l0.6026755,0.1897954", "l0.6023737,0.1936446", "l0.5972598,0.1923957", "l0.5880380,0.1970489", "l0.5903183,0.2056026", "l0.5886416,0.2079805", "l0.5906033,0.2096913", "l0.5917603,0.2086135", "l0.5928836,0.2118810", "l0.5952645,0.2114191", "l0.5952142,0.2138312", "l0.5921794,0.2156275", "l0.5864116,0.2147550", "l0.5849194,0.2180909", "l0.5875182,0.2226757", "l0.5839469,0.2245062", "l0.5838295,0.2270210", "l0.5883901,0.2263538", "l0.5902848,0.2294673", "l0.5841816,0.2353009", "l0.5850871,0.2371485", "l0.5830415,0.2375420", "l0.5828068,0.2402107", "l0.5798558,0.2404844", "l0.5768881,0.2469168", "l0.5768881,0.2469168", "l0.5752114,0.2484907", "l0.5741215,0.2460443", "l0.5697622,0.2447955", "l0.5686891,0.2387224", "l0.5659896,0.2408950", "l0.5643129,0.2365155", "l0.5615129,0.2375762", "l0.5605907,0.2339494", "l0.5547391,0.2296555", "l0.5563655,0.2255669", "l0.5527438,0.2195109", "l0.5479820,0.2183305", "l0.5477473,0.2217690", "l0.5437400,0.2210847", "l0.5422478,0.2233087", "l0.5409400,0.2210847", "l0.5328081,0.2233942", "l0.5297733,0.2205373", "l0.5245923,0.2244036", "l0.5175670,0.2192714", "l0.5141298,0.2223678", "l0.5119669,0.2175435", "l0.5105585,0.2202123", "l0.5076410,0.2195109", "l0.5085800,0.2182791", "l0.5055452,0.2157815", "l0.5037344,0.2165855", "l0.5041535,0.2151827", "l0.4996265,0.2137628", "l0.4984193,0.2150116", "l0.4953677,0.2108717", "l0.4934060,0.2137628", "l0.4897508,0.2146866", "l0.4887448,0.2116415", "l0.4854082,0.2133522", "l0.4791710,0.2082884", "l0.4736714,0.2120350", "l0.4654054,0.2134378", "l0.4598723,0.2110085", "l0.4564687,0.2120692", "l0.4552111,0.2099650", "l0.4552111,0.2099650", "l0.4545740,0.2099821", "l0.4545740,0.2099821", "l0.4554459,0.2068001", "l0.4529309,0.2059790", "l0.4529309,0.2059790", "l0.4533165,0.2024035", "l0.4567034,0.2015653", "l0.4588663,0.2044222", "l0.4599059,0.2013258", "l0.4577094,0.1994611", "l0.4569214,0.1913522", "l0.4541716,0.1883755", "l0.4554459,0.1870411", "l0.4536518,0.1868530", "l0.4570220,0.1804890", "l0.4570220,0.1804890", "l0.4576926,0.1800442", "l0.4576926,0.1800442", "l0.4589669,0.1763491", "l0.4568208,0.1754937", "l0.4557980,0.1779229", "l0.4538866,0.1763491", "l0.4560495,0.1726026", "l0.4524111,0.1677612", "l0.4524111,0.1677612", "l0.4527129,0.1677612", "l0.4527129,0.1677612", "l0.4541381,0.1632962", "l0.4524782,0.1610038", "l0.4562507,0.1554610", "l0.4530985,0.1570007", "l0.4519081,0.1554610", "l0.4560998,0.1479509", "l0.4586483,0.1480535", "l0.4550435,0.1422884", "l0.4535009,0.1344019", "l0.4354263,0.1175854", "l0.4351748,0.1142152", "l0.4302118,0.1148482", "l0.4302118,0.1148482", "l0.4353760,0.1099726", "l0.4402887,0.0990924", "l0.4434911,0.0980146", "l0.4448325,0.1012992", "l0.4497955,0.1026507", "l0.4518242,0.1011452", "l0.4414288,0.0916336", "l0.4425690,0.0819679", "l0.4475319,0.0822245", "c"]}, {"n": "Poitou-Charentes", "u": "FR-T", "i": ["m0.2362866,0.5406496", "l0.2426915,0.5461411", "l0.2480904,0.5471846", "l0.2482078,0.5527958", "l0.2516785,0.5598269", "l0.2485767,0.5659514", "l0.2459275,0.5576885", "l0.2377285,0.5502639", "l0.2362866,0.5406496", "c", "m0.2290936,0.5192313", "l0.2316422,0.5216263", "l0.2283894,0.5221053", "l0.2297307,0.5246885", "l0.2358674,0.5220197", "l0.2340231,0.5237134", "l0.2350123,0.5249793", "l0.2391872,0.5242095", "l0.2471515,0.5289311", "l0.2431274,0.5309669", "l0.2325140,0.5249109", "l0.2275175,0.5249280", "l0.2255558,0.5206683", "l0.2290936,0.5192313", "c", "m0.2565409,0.5131753", "l0.2593913,0.5131068", "l0.2608668,0.5097709", "l0.2694849,0.5075983", "l0.2672885,0.5125765", "l0.2693508,0.5138424", "l0.2724694,0.5121488", "l0.2750180,0.5131068", "l0.2763258,0.5105749", "l0.2763258,0.5105749", "l0.2766276,0.5110197", "l0.2766276,0.5110197", "l0.2839715,0.5146465", "l0.2856481,0.5122515", "l0.2891524,0.5131239", "l0.2966807,0.5061270", "l0.2920531,0.5031504", "l0.2910303,0.5054427", "l0.2895716,0.5047927", "l0.2918519,0.4988906", "l0.2891189,0.4921504", "l0.2921537,0.4909186", "l0.2905273,0.4864878", "l0.2914327,0.4817320", "l0.2884482,0.4802265", "l0.2899572,0.4774381", "l0.2869895,0.4750772", "l0.2886159,0.4736402", "l0.2841894,0.4679435", "l0.2843571,0.4640943", "l0.2843571,0.4640943", "l0.2842900,0.4636667", "l0.2842900,0.4636667", "l0.2856817,0.4623494", "l0.2838541,0.4611348", "l0.2838541,0.4611348", "l0.2833679,0.4611348", "l0.2833679,0.4611348", "l0.2806013,0.4592359", "l0.2806013,0.4592359", "l0.2803163,0.4592359", "l0.2803163,0.4592359", "l0.2764431,0.4545827", "l0.2780528,0.4508362", "l0.2744479,0.4494505", "l0.2752527,0.4483214", "l0.2731401,0.4482529", "l0.2741629,0.4465764", "l0.2718993,0.4452763", "l0.2749341,0.4457553", "l0.2794612,0.4420601", "l0.2845248,0.4442840", "l0.2875931,0.4422825", "l0.2925561,0.4429326", "l0.2963957,0.4392374", "l0.2955070,0.4359528", "l0.2997993,0.4339341", "l0.3022473,0.4341394", "l0.3007383,0.4370648", "l0.3058689,0.4356791", "l0.3066402,0.4331301", "l0.3157446,0.4316246", "l0.3200034,0.4328221", "l0.3214286,0.4313509", "l0.3243125,0.4318641", "l0.3217639,0.4353198", "l0.3252346,0.4369963", "l0.3282359,0.4321550", "l0.3317234,0.4336262", "l0.3337522,0.4259621", "l0.3355965,0.4244053", "l0.3380780,0.4255515", "l0.3380780,0.4255515", "l0.3399056,0.4302218", "l0.3440806,0.4296060", "l0.3437117,0.4314536", "l0.3456063,0.4321036", "l0.3469812,0.4306324", "l0.3482555,0.4330959", "l0.3467465,0.4364831", "l0.3513909,0.4352001", "l0.3530005,0.4382109", "l0.3554149,0.4373214", "l0.3560688,0.4428128", "l0.3545934,0.4436511", "l0.3568401,0.4498610", "l0.3597408,0.4479108", "l0.3648379,0.4499808", "l0.3695159,0.4469357", "l0.3759543,0.4471068", "l0.3738417,0.4420259", "l0.3773124,0.4418890", "l0.3824598,0.4453960", "l0.3833485,0.4527009", "l0.3897367,0.4582436", "l0.3910445,0.4645049", "l0.3978350,0.4709373", "l0.3988410,0.4743245", "l0.3963931,0.4809964", "l0.3976506,0.4839046", "l0.4048771,0.4874116", "l0.4052627,0.4905765", "l0.4103431,0.4905423", "l0.4139312,0.4935532", "l0.4143839,0.4995749", "l0.4186427,0.5011146", "l0.4175696,0.5043821", "l0.4175696,0.5043821", "l0.4162953,0.5061099", "l0.4162953,0.5061099", "l0.4162953,0.5061099", "l0.4162953,0.5061099", "l0.4148534,0.5056138", "l0.4129420,0.5099249", "l0.4072915,0.5084023", "l0.4043070,0.5168533", "l0.3971308,0.5159980", "l0.3935427,0.5218658", "l0.3895019,0.5237818", "l0.3932577,0.5314459", "l0.3906756,0.5328829", "l0.3924026,0.5356372", "l0.3909774,0.5403075", "l0.3940290,0.5435750", "l0.3958398,0.5421551", "l0.3986566,0.5444303", "l0.4001824,0.5485532", "l0.3956553,0.5533946", "l0.3907762,0.5524708", "l0.3918157,0.5574319", "l0.3887642,0.5667041", "l0.3838347,0.5654210", "l0.3840359,0.5696979", "l0.3781508,0.5749840", "l0.3781508,0.5749840", "l0.3736405,0.5827337", "l0.3698512,0.5827850", "l0.3693985,0.5909965", "l0.3655421,0.5938021", "l0.3643349,0.5976170", "l0.3607803,0.5976341", "l0.3572928,0.6020478", "l0.3553311,0.6003029", "l0.3563539,0.6025782", "l0.3535035,0.6035533", "l0.3515083,0.6093869", "l0.3528161,0.6166746", "l0.3464950,0.6203356", "l0.3436782,0.6258441", "l0.3381786,0.6237399", "l0.3348588,0.6262034", "l0.3329641,0.6300012", "l0.3345738,0.6311987", "l0.3317234,0.6324818", "l0.3312204,0.6366389", "l0.3281688,0.6343294", "l0.3242957,0.6375455", "l0.3210094,0.6370665", "l0.3162811,0.6350137", "l0.3147889,0.6322252", "l0.3124248,0.6327042", "l0.3107649,0.6298472", "l0.3090043,0.6295051", "l0.3075792,0.6321567", "l0.3063384,0.6283076", "l0.3063384,0.6283076", "l0.3062546,0.6278628", "l0.3062546,0.6278628", "l0.3046450,0.6186077", "l0.2949034,0.6167944", "l0.2933441,0.6117477", "l0.2927740,0.6143480", "l0.2844409,0.6136295", "l0.2844409,0.6136295", "l0.2816744,0.6037586", "l0.2771809,0.5970525", "l0.2667184,0.5901582", "l0.2629961,0.5838627", "l0.2503204,0.5763697", "l0.2484258,0.5767803", "l0.2492306,0.5788503", "l0.2482078,0.5767974", "l0.2481072,0.5673200", "l0.2553169,0.5656092", "l0.2521648,0.5604941", "l0.2565912,0.5599125", "l0.2593745,0.5549514", "l0.2576140,0.5511364", "l0.2591398,0.5507087", "l0.2587709,0.5476807", "l0.2562559,0.5452515", "l0.2609674,0.5452857", "l0.2575637,0.5358767", "l0.2546630,0.5346963", "l0.2556523,0.5326092", "l0.2525169,0.5314972", "l0.2541600,0.5295299", "l0.2502031,0.5307445", "l0.2480401,0.5288627", "l0.2506390,0.5239529", "l0.2569098,0.5190089", "l0.2553002,0.5146636", "l0.2565409,0.5131753", "c"]}, {"n": "Provence-Alpes-Côte d'Azur", "u": "FR-U", "i": ["m0.6816305,0.7041273", "l0.6823179,0.7049142", "l0.6823179,0.7049142", "l0.6871971,0.7079422", "l0.6871971,0.7079422", "l0.6872474,0.7085238", "l0.6872474,0.7085238", "l0.6839275,0.7101148", "l0.6813958,0.7168209", "l0.6746052,0.7156576", "l0.6735153,0.7111926", "l0.6760471,0.7065223", "l0.6760471,0.7065223", "l0.6766507,0.7054274", "l0.6766507,0.7054274", "l0.6771873,0.7051366", "l0.6771873,0.7051366", "l0.6783442,0.7048629", "l0.6783442,0.7048629", "l0.6804903,0.7031008", "l0.6804903,0.7031008", "l0.6807754,0.7038535", "l0.6807754,0.7038535", "l0.6814964,0.7039391", "l0.6814964,0.7039391", "l0.6816305,0.7041273", "c", "m0.7060430,0.8225100", "l0.7084071,0.8184555", "l0.7063448,0.8160092", "l0.7082730,0.8147090", "l0.7037627,0.8082767", "l0.6981458,0.8114586", "l0.6857216,0.8118350", "l0.6801550,0.8020667", "l0.6766843,0.8013995", "l0.6748567,0.8040512", "l0.6756950,0.8016561", "l0.6740183,0.8026655", "l0.6725764,0.7991927", "l0.6737333,0.8035037", "l0.6702961,0.8016390", "l0.6725932,0.8043762", "l0.6687368,0.8059159", "l0.6719393,0.8056935", "l0.6708159,0.8068568", "l0.6738004,0.8088070", "l0.6764831,0.8064291", "l0.6708830,0.8115784", "l0.6531772,0.8084135", "l0.6515005,0.8064291", "l0.6537640,0.8023918", "l0.6497735,0.7994664", "l0.6286808,0.7986795", "l0.6286808,0.7986795", "l0.6294186,0.7948303", "l0.6351193,0.7920076", "l0.6344318,0.7893560", "l0.6358235,0.7912549", "l0.6447435,0.7859858", "l0.6454644,0.7837277", "l0.6422787,0.7825986", "l0.6464201,0.7754306", "l0.6502262,0.7744555", "l0.6563461,0.7765768", "l0.6552898,0.7726592", "l0.6590959,0.7609749", "l0.6573018,0.7588365", "l0.6693069,0.7493590", "l0.6692901,0.7468956", "l0.6714195,0.7467929", "l0.6673787,0.7392486", "l0.6627846,0.7376918", "l0.6628516,0.7272564", "l0.6618624,0.7246047", "l0.6594815,0.7244850", "l0.6578384,0.7190449", "l0.6578384,0.7190449", "l0.6579222,0.7131599", "l0.6675296,0.7148193", "l0.6696422,0.7233046", "l0.6864090,0.7153839", "l0.6897959,0.7183606", "l0.6927469,0.7151957", "l0.6927469,0.7151957", "l0.6938535,0.7146654", "l0.6938535,0.7146654", "l0.6928307,0.7228769", "l0.6982297,0.7249298", "l0.6995878,0.7229453", "l0.7029914,0.7253404", "l0.7069652,0.7246218", "l0.7090275,0.7260075", "l0.7088934,0.7304554", "l0.7125485,0.7307976", "l0.7139066,0.7339967", "l0.7199259,0.7326794", "l0.7241177,0.7268800", "l0.7267500,0.7292066", "l0.7261632,0.7309173", "l0.7294495,0.7313279", "l0.7297345,0.7296343", "l0.7269848,0.7288474", "l0.7299860,0.7264181", "l0.7300028,0.7194212", "l0.7272531,0.7194212", "l0.7265153,0.7160853", "l0.7245201,0.7155379", "l0.7259955,0.7128349", "l0.7203283,0.7131599", "l0.7184840,0.7111242", "l0.7165223,0.7124243", "l0.7121461,0.7087462", "l0.7113581,0.7037680", "l0.7153821,0.7043497", "l0.7168408,0.7025876", "l0.7145103,0.7015441", "l0.7140576,0.6964461", "l0.7249225,0.6992004", "l0.7259285,0.6963605", "l0.7283932,0.6961381", "l0.7237320,0.6920153", "l0.7272698,0.6852750", "l0.7269345,0.6813061", "l0.7329202,0.6825720", "l0.7343287,0.6802796", "l0.7371287,0.6811350", "l0.7399791,0.6774569", "l0.7377826,0.6758660", "l0.7397443,0.6705798", "l0.7436342,0.6718799", "l0.7483960,0.6704771", "l0.7504248,0.6683729", "l0.7482787,0.6660463", "l0.7530237,0.6629670", "l0.7557231,0.6649173", "l0.7611221,0.6600930", "l0.7690192,0.6613247", "l0.7720876,0.6591350", "l0.7765643,0.6610339", "l0.7767320,0.6525829", "l0.7742673,0.6511288", "l0.7743511,0.6466295", "l0.7660347,0.6448846", "l0.7689019,0.6344149", "l0.7722720,0.6356637", "l0.7750050,0.6341412", "l0.7772015,0.6394616", "l0.7832040,0.6412920", "l0.7856855,0.6409841", "l0.7852495,0.6371863", "l0.7873454,0.6355440", "l0.7895251,0.6365020", "l0.7920569,0.6340899", "l0.7957288,0.6355782", "l0.7957288,0.6355782", "l0.7986798,0.6446451", "l0.8036092,0.6452096", "l0.8040787,0.6561070", "l0.8119088,0.6616156", "l0.8151616,0.6622485", "l0.8169221,0.6604351", "l0.8229581,0.6643014", "l0.8213821,0.6677229", "l0.8266804,0.6782610", "l0.8187497,0.6788597", "l0.8191185,0.6845907", "l0.8113052,0.6935378", "l0.8128813,0.6983279", "l0.8177772,0.7033232", "l0.8139041,0.7041444", "l0.8135352,0.7099951", "l0.8209964,0.7181382", "l0.8218348,0.7225176", "l0.8343931,0.7259220", "l0.8407813,0.7318925", "l0.8452077,0.7313621", "l0.8462137,0.7344072", "l0.8508917,0.7347152", "l0.8513109,0.7329189", "l0.8643890,0.7310200", "l0.8656633,0.7283341", "l0.8689496,0.7285394", "l0.8677256,0.7328334", "l0.8710790,0.7374866", "l0.8704418,0.7415923", "l0.8674741,0.7429438", "l0.8667364,0.7482984", "l0.8608009,0.7514803", "l0.8601973,0.7559796", "l0.8559385,0.7582720", "l0.8583529,0.7671336", "l0.8497012,0.7733777", "l0.8450233,0.7740107", "l0.8446209,0.7775690", "l0.8433802,0.7745923", "l0.8426256,0.7766623", "l0.8382998,0.7762860", "l0.8359860,0.7800496", "l0.8323643,0.7798101", "l0.8299164,0.7862767", "l0.8315428,0.7896810", "l0.8298661,0.7906732", "l0.8282732,0.7878334", "l0.8241151,0.7913233", "l0.8225557,0.7897665", "l0.8188503,0.7906390", "l0.8170562,0.7933762", "l0.8184311,0.7950356", "l0.8138873,0.8016733", "l0.8067949,0.8036406", "l0.8037266,0.8022549", "l0.8017313,0.8095426", "l0.7918724,0.8168988", "l0.8004068,0.8174462", "l0.7981768,0.8197557", "l0.7992834,0.8239641", "l0.7965504,0.8252300", "l0.7969025,0.8270776", "l0.7950917,0.8280014", "l0.7909503,0.8249734", "l0.7864400,0.8286857", "l0.7786434,0.8293187", "l0.7772182,0.8349470", "l0.7709642,0.8315769", "l0.7648946,0.8321756", "l0.7623460,0.8369828", "l0.7626981,0.8407122", "l0.7585232,0.8405069", "l0.7609041,0.8390185", "l0.7605520,0.8356313", "l0.7533758,0.8357339", "l0.7520009,0.8330481", "l0.7468702,0.8334073", "l0.7465349,0.8312347", "l0.7437516,0.8333902", "l0.7483793,0.8367262", "l0.7444391,0.8356655", "l0.7422258,0.8387962", "l0.7400629,0.8384882", "l0.7375982,0.8366577", "l0.7386545,0.8321585", "l0.7357538,0.8320730", "l0.7361395,0.8298661", "l0.7307741,0.8294042", "l0.7301369,0.8258972", "l0.7256434,0.8252471", "l0.7244027,0.8278304", "l0.7196409,0.8225442", "l0.7170923,0.8242549", "l0.7060430,0.8225100", "c"]}, {"n": "Rhône-Alpes", "u": "FR-V", "i": ["m0.6056600,0.5173323", "l0.6050564,0.5236278", "l0.6107906,0.5248254", "l0.6119475,0.5282468", "l0.6198447,0.5252359", "l0.6250927,0.5277849", "l0.6271383,0.5256807", "l0.6283958,0.5273915", "l0.6303743,0.5263821", "l0.6300557,0.5293417", "l0.6318330,0.5295812", "l0.6386068,0.5265532", "l0.6409038,0.5152966", "l0.6445926,0.5151597", "l0.6477447,0.5181877", "l0.6522215,0.5155019", "l0.6556922,0.5184101", "l0.6570168,0.5147662", "l0.6599845,0.5142359", "l0.6621307,0.5170586", "l0.6599677,0.5190773", "l0.6639079,0.5216947", "l0.6627510,0.5256465", "l0.6654673,0.5279389", "l0.6669595,0.5275112", "l0.6781765,0.4924241", "l0.6788472,0.4942374", "l0.6811778,0.4928004", "l0.6862246,0.4959653", "l0.6938703,0.4939124", "l0.6939541,0.4923556", "l0.6966200,0.4937413", "l0.6986656,0.4986340", "l0.7041316,0.4998315", "l0.7041316,0.4998315", "l0.7030585,0.5032359", "l0.7084742,0.5064008", "l0.7073676,0.5076325", "l0.7103185,0.5137569", "l0.7117437,0.5099249", "l0.7126324,0.5132608", "l0.7152983,0.5132437", "l0.7151977,0.5184956", "l0.7197415,0.5180680", "l0.7269848,0.5102670", "l0.7272363,0.5123712", "l0.7319142,0.5138938", "l0.7327190,0.5188549", "l0.7427624,0.5184614", "l0.7563603,0.5029622", "l0.7563603,0.5029622", "l0.7636874,0.5080088", "l0.7589759,0.5164085", "l0.7605352,0.5198984", "l0.7504919,0.5234226", "l0.7494188,0.5254754", "l0.7515147,0.5270151", "l0.7489326,0.5324381", "l0.7555052,0.5300431", "l0.7608203,0.5312748", "l0.7724397,0.5225501", "l0.7734289,0.5193852", "l0.7700252,0.5198642", "l0.7691366,0.5145267", "l0.7672252,0.5136714", "l0.7694552,0.5087274", "l0.7880161,0.4987709", "l0.7993672,0.4990104", "l0.8089746,0.5018331", "l0.8055374,0.5091893", "l0.8120765,0.5168191", "l0.8078512,0.5246543", "l0.8073650,0.5314117", "l0.8144238,0.5327460", "l0.8128310,0.5405299", "l0.8169389,0.5388705", "l0.8240815,0.5501271", "l0.8245342,0.5532919", "l0.8212144,0.5585268", "l0.8154131,0.5617088", "l0.8089578,0.5621022", "l0.8080357,0.5734102", "l0.8155640,0.5809032", "l0.8214491,0.5821007", "l0.8198563,0.5873526", "l0.8214659,0.5957352", "l0.8252552,0.5967788", "l0.8248863,0.5990369", "l0.8284074,0.5992936", "l0.8294301,0.6029716", "l0.8344937,0.6057259", "l0.8291283,0.6136295", "l0.8308553,0.6208317", "l0.8263115,0.6252796", "l0.8215497,0.6244413", "l0.8176431,0.6295222", "l0.8139879,0.6296591", "l0.8139711,0.6328410", "l0.8109028,0.6337990", "l0.8052524,0.6305486", "l0.7957456,0.6355269", "l0.7957456,0.6355269", "l0.7920736,0.6340385", "l0.7895418,0.6364507", "l0.7873622,0.6354927", "l0.7852663,0.6371350", "l0.7857022,0.6409328", "l0.7832207,0.6412407", "l0.7772182,0.6394102", "l0.7750218,0.6340899", "l0.7722888,0.6356124", "l0.7689186,0.6343636", "l0.7660515,0.6448333", "l0.7743679,0.6465782", "l0.7742840,0.6510774", "l0.7767487,0.6525316", "l0.7765811,0.6609826", "l0.7721043,0.6590837", "l0.7690360,0.6612734", "l0.7611388,0.6600417", "l0.7557399,0.6648659", "l0.7530404,0.6629157", "l0.7482954,0.6659950", "l0.7504416,0.6683216", "l0.7484128,0.6704258", "l0.7436510,0.6718286", "l0.7397611,0.6705285", "l0.7377994,0.6758146", "l0.7399958,0.6774056", "l0.7371455,0.6810837", "l0.7343454,0.6802283", "l0.7329370,0.6825207", "l0.7269512,0.6812548", "l0.7272866,0.6852237", "l0.7237488,0.6919640", "l0.7284100,0.6960868", "l0.7259452,0.6963092", "l0.7249392,0.6991490", "l0.7140743,0.6963948", "l0.7145270,0.7014927", "l0.7168576,0.7025363", "l0.7153989,0.7042983", "l0.7113749,0.7037167", "l0.7121629,0.7086949", "l0.7165390,0.7123730", "l0.7185008,0.7110728", "l0.7203451,0.7131086", "l0.7260123,0.7127836", "l0.7245368,0.7154865", "l0.7265321,0.7160340", "l0.7272698,0.7193699", "l0.7300196,0.7193699", "l0.7300028,0.7263668", "l0.7270015,0.7287960", "l0.7297513,0.7295830", "l0.7294663,0.7312766", "l0.7261800,0.7308660", "l0.7267668,0.7291553", "l0.7241344,0.7268287", "l0.7199427,0.7326281", "l0.7139234,0.7339453", "l0.7125653,0.7307463", "l0.7089101,0.7304041", "l0.7090443,0.7259562", "l0.7069819,0.7245705", "l0.7030082,0.7252890", "l0.6996045,0.7228940", "l0.6982464,0.7248785", "l0.6928475,0.7228256", "l0.6938703,0.7146141", "l0.6938703,0.7146141", "l0.6927637,0.7151444", "l0.6927637,0.7151444", "l0.6898127,0.7183092", "l0.6864258,0.7153326", "l0.6696590,0.7232533", "l0.6675463,0.7147680", "l0.6579390,0.7131086", "l0.6578551,0.7189935", "l0.6578551,0.7189935", "l0.6478286,0.7117571", "l0.6442069,0.7122875", "l0.6431506,0.7177447", "l0.6401996,0.7170262", "l0.6399481,0.7114834", "l0.6353708,0.7122875", "l0.6305587,0.7195410", "l0.6216891,0.7124585", "l0.6159883,0.7142035", "l0.6154518,0.7070526", "l0.6174303,0.7056669", "l0.6118134,0.6990464", "l0.6093319,0.6892610", "l0.6058779,0.6869173", "l0.6029773,0.6720168", "l0.6029773,0.6720168", "l0.6073031,0.6695876", "l0.6090972,0.6637711", "l0.6118134,0.6652936", "l0.6114110,0.6631723", "l0.6126350,0.6644725", "l0.6145967,0.6631039", "l0.6150494,0.6592376", "l0.6235334,0.6591521", "l0.6282784,0.6501365", "l0.6344654,0.6491443", "l0.6332582,0.6445082", "l0.6390595,0.6427804", "l0.6367624,0.6387773", "l0.6384727,0.6357835", "l0.6403841,0.6359203", "l0.6403841,0.6359203", "l0.6403841,0.6350137", "l0.6403841,0.6350137", "l0.6386403,0.6320199", "l0.6420440,0.6327726", "l0.6429326,0.6354242", "l0.6444417,0.6345175", "l0.6437542,0.6303262", "l0.6467555,0.6240821", "l0.6429494,0.6188472", "l0.6395960,0.6207119", "l0.6369133,0.6188472", "l0.6384224,0.6161443", "l0.6356894,0.6145020", "l0.6381876,0.6126373", "l0.6359073,0.6094211", "l0.6315647,0.6104475", "l0.6288485,0.6073169", "l0.6250424,0.6069576", "l0.6227118,0.6078301", "l0.6233322,0.6097632", "l0.6182854,0.6104304", "l0.6175812,0.6126886", "l0.6140769,0.6113542", "l0.6139092,0.6134926", "l0.6116290,0.6090789", "l0.6090133,0.6086513", "l0.6059953,0.6128768", "l0.6049390,0.6067352", "l0.6101032,0.6026295", "l0.6115954,0.5965906", "l0.6080409,0.5882593", "l0.6003784,0.5828534", "l0.5971089,0.5768145", "l0.5973604,0.5734102", "l0.5909722,0.5666870", "l0.5933028,0.5644117", "l0.5928166,0.5586636", "l0.5955496,0.5570385", "l0.5912572,0.5525563", "l0.5917938,0.5485532", "l0.5978131,0.5481769", "l0.6008311,0.5455423", "l0.5990371,0.5400167", "l0.6001604,0.5364241", "l0.5981820,0.5340462", "l0.5992718,0.5288285", "l0.5964382,0.5210275", "l0.6045198,0.5174692", "l0.6045198,0.5174692", "l0.6051234,0.5173837", "l0.6051234,0.5173837", "l0.6056600,0.5173323", "c", "m0.6771537,0.7051024", "l0.6771537,0.7051024", "l0.6766172,0.7053932", "l0.6766172,0.7053932", "l0.6760136,0.7064881", "l0.6760136,0.7064881", "l0.6734818,0.7111584", "l0.6745717,0.7156234", "l0.6813622,0.7167867", "l0.6838940,0.7100806", "l0.6872138,0.7084896", "l0.6872138,0.7084896", "l0.6871635,0.7079080", "l0.6871635,0.7079080", "l0.6822844,0.7048800", "l0.6822844,0.7048800", "l0.6814461,0.7038878", "l0.6814461,0.7038878", "l0.6807251,0.7038022", "l0.6807251,0.7038022", "l0.6804400,0.7030495", "l0.6804400,0.7030495", "l0.6782939,0.7048116", "l0.6771537,0.7051024", "c"]}]} """;
}
