import 'package:flutter/material.dart';

class SMapIranColors {
  /// Alborz
  final Color? ir32;

  /// Kerman
  final Color? ir15;

  /// Sistan and Baluchestan
  final Color? ir13;

  /// North Khorasan
  final Color? ir31;

  /// Razavi Khorasan
  final Color? ir30;

  /// South Khorasan
  final Color? ir29;

  /// Kordestan
  final Color? ir16;

  /// Gilan
  final Color? ir19;

  /// Kermanshah
  final Color? ir17;

  /// East Azarbaijan
  final Color? ir01;

  /// West Azarbaijan
  final Color? ir02;

  /// Qazvin
  final Color? ir28;

  /// Zanjan
  final Color? ir11;

  /// Hamadan
  final Color? ir24;

  /// Qom
  final Color? ir26;

  /// Markazi
  final Color? ir22;

  /// Ardebil
  final Color? ir03;

  /// Hormozgan
  final Color? ir23;

  /// Ilam
  final Color? ir05;

  /// Lorestan
  final Color? ir20;

  /// Khuzestan
  final Color? ir10;

  /// Chahar Mahall and Bakhtiari
  final Color? ir08;

  /// Yazd
  final Color? ir25;

  /// Tehran
  final Color? ir07;

  /// Semnan
  final Color? ir12;

  /// Mazandaran
  final Color? ir21;

  /// Golestan
  final Color? ir27;

  /// Fars
  final Color? ir14;

  /// Esfahan
  final Color? ir04;

  /// Bushehr
  final Color? ir06;

  /// Kohgiluyeh and Buyer Ahmad
  final Color? ir18;
  SMapIranColors({
    this.ir32,
    this.ir15,
    this.ir13,
    this.ir31,
    this.ir30,
    this.ir29,
    this.ir16,
    this.ir19,
    this.ir17,
    this.ir01,
    this.ir02,
    this.ir28,
    this.ir11,
    this.ir24,
    this.ir26,
    this.ir22,
    this.ir03,
    this.ir23,
    this.ir05,
    this.ir20,
    this.ir10,
    this.ir08,
    this.ir25,
    this.ir07,
    this.ir12,
    this.ir21,
    this.ir27,
    this.ir14,
    this.ir04,
    this.ir06,
    this.ir18,
  });
  Map<String, Color?> toMap() {
    return {
      "IR-32": ir32,
      "IR-15": ir15,
      "IR-13": ir13,
      "IR-31": ir31,
      "IR-30": ir30,
      "IR-29": ir29,
      "IR-16": ir16,
      "IR-19": ir19,
      "IR-17": ir17,
      "IR-01": ir01,
      "IR-02": ir02,
      "IR-28": ir28,
      "IR-11": ir11,
      "IR-24": ir24,
      "IR-26": ir26,
      "IR-22": ir22,
      "IR-03": ir03,
      "IR-23": ir23,
      "IR-05": ir05,
      "IR-20": ir20,
      "IR-10": ir10,
      "IR-08": ir08,
      "IR-25": ir25,
      "IR-07": ir07,
      "IR-12": ir12,
      "IR-21": ir21,
      "IR-27": ir27,
      "IR-14": ir14,
      "IR-04": ir04,
      "IR-06": ir06,
      "IR-18": ir18,
    };
  }

  static SMapIranColors fromMap(Map<String, Color?> map) {
    return SMapIranColors(
      ir32: map["IR-32"],
      ir15: map["IR-15"],
      ir13: map["IR-13"],
      ir31: map["IR-31"],
      ir30: map["IR-30"],
      ir29: map["IR-29"],
      ir16: map["IR-16"],
      ir19: map["IR-19"],
      ir17: map["IR-17"],
      ir01: map["IR-01"],
      ir02: map["IR-02"],
      ir28: map["IR-28"],
      ir11: map["IR-11"],
      ir24: map["IR-24"],
      ir26: map["IR-26"],
      ir22: map["IR-22"],
      ir03: map["IR-03"],
      ir23: map["IR-23"],
      ir05: map["IR-05"],
      ir20: map["IR-20"],
      ir10: map["IR-10"],
      ir08: map["IR-08"],
      ir25: map["IR-25"],
      ir07: map["IR-07"],
      ir12: map["IR-12"],
      ir21: map["IR-21"],
      ir27: map["IR-27"],
      ir14: map["IR-14"],
      ir04: map["IR-04"],
      ir06: map["IR-06"],
      ir18: map["IR-18"],
    );
  }
}

class SMapIran {
  static const String instructions =
      """{"n": "Iran", "w": 654.51147, "h": 593.71021, "g": {"a": "44.032695,39.782056","b": "63.333337,24.809394"}, "i":[{"n": "Alborz", "u": "IR-32", "i": ["m0.3515453,0.2506347", "l0.3515453,0.2506347", "l0.3600860,0.2525043", "l0.3633862,0.2539529", "l0.3643182,0.2554519", "l0.3662891,0.2574562", "l0.3684587,0.2585005", "l0.3769383,0.2605722", "l0.3802996,0.2649515", "l0.3801315,0.2679327", "l0.3801315,0.2719077", "l0.3772133,0.2738952", "l0.3730270,0.2733394", "l0.3688559,0.2750406", "l0.3657238,0.2790156", "l0.3655252,0.2835633", "l0.3648988,0.2869656", "l0.3602999,0.2872519", "l0.3588332,0.2915133", "l0.3561289,0.2951851", "l0.3527829,0.2974589", "l0.3514231,0.3009455", "l0.3490396,0.3011813", "l0.3476034,0.3044152", "l0.3461367,0.3047520", "l0.3457700,0.3024108", "l0.3457853,0.2985200", "l0.3437838,0.2959093", "l0.3408656,0.2958757", "l0.3402086,0.2977621", "l0.3422101,0.3008276", "l0.3422101,0.3020066", "l0.3416753,0.3030509", "l0.3403767,0.3021919", "l0.3373973,0.2992275", "l0.3323249,0.2975937", "l0.3270996,0.2972231", "l0.3248689,0.2966504", "l0.3237536,0.2946124", "l0.3224396,0.2913785", "l0.3220118,0.2892057", "l0.3226535,0.2864603", "l0.3254953,0.2834285", "l0.3359764,0.2777860", "l0.3377487,0.2759164", "l0.3383599,0.2733226", "l0.3408503,0.2676127", "l0.3424851,0.2615155", "l0.3400864,0.2592416", "l0.3364195,0.2580289", "l0.3345097,0.2562267", "l0.3318665,0.2522180", "l0.3333638,0.2497084", "l0.3392308,0.2491862", "l0.3515453,0.2506347", "c"]}, {"n": "Kerman", "u": "IR-15", "i": ["m0.7154656,0.5728121", "l0.7154656,0.5728121", "l0.7743645,0.6021699", "l0.7817746,0.6082840", "l0.8024312,0.6414820", "l0.7918126,0.6959362", "l0.7913542,0.7013934", "l0.7925765,0.7028250", "l0.7949142,0.7045262", "l0.7969768,0.7102866", "l0.7987644,0.7241149", "l0.7986116,0.7298247", "l0.7970379,0.7362925", "l0.7926988,0.7436025", "l0.7919501,0.7478133", "l0.7926988,0.7521420", "l0.7927599,0.7574813", "l0.7942877,0.7610016", "l0.7948225,0.7635281", "l0.7947308,0.7659366", "l0.7932182,0.7677557", "l0.7908806,0.7697769", "l0.7788411,0.7775079", "l0.7729588,0.7797144", "l0.7699642,0.7814829", "l0.7718893,0.7847674", "l0.7761368,0.7883213", "l0.7779855,0.7916057", "l0.7763812,0.7974672", "l0.7704073,0.8060741", "l0.7707587,0.8284419", "l0.7700712,0.8358192", "l0.7641126,0.8616062", "l0.7641278,0.8679561", "l0.7653807,0.8733459", "l0.7655640,0.8757377", "l0.7654112,0.8798474", "l0.7664807,0.8842098", "l0.7704226,0.8892123", "l0.7731422,0.8953264", "l0.7716754,0.9001772", "l0.7702240,0.9029227", "l0.7710643,0.9043880", "l0.7727144,0.9060555", "l0.7727755,0.9082283", "l0.7711101,0.9104179", "l0.7698267,0.9133486", "l0.7707893,0.9170541", "l0.7725769,0.9193953", "l0.7730200,0.9218376", "l0.7721949,0.9242799", "l0.7712171,0.9255936", "l0.7713088,0.9276654", "l0.7706059,0.9286928", "l0.7699795,0.9303434", "l0.7700101,0.9342679", "l0.7697045,0.9366260", "l0.7686808,0.9394051", "l0.7665724,0.9358849", "l0.7658238,0.9351943", "l0.7644028,0.9352111", "l0.7624014,0.9343353", "l0.7608888,0.9347564", "l0.7593609,0.9365249", "l0.7571455,0.9368281", "l0.7545787,0.9367270", "l0.7524397,0.9361880", "l0.7515688,0.9344869", "l0.7514161,0.9325162", "l0.7508966,0.9311014", "l0.7507744,0.9298718", "l0.7512633,0.9286928", "l0.7513397,0.9280022", "l0.7503618,0.9273285", "l0.7471381,0.9267727", "l0.7451518,0.9257789", "l0.7433337,0.9253242", "l0.7415461,0.9262505", "l0.7387501,0.9265369", "l0.7345027,0.9256947", "l0.7276426,0.9262337", "l0.7275509,0.9249368", "l0.7286052,0.9235051", "l0.7292163,0.9199512", "l0.7292163,0.9181153", "l0.7289260,0.9162793", "l0.7301177,0.9038322", "l0.7308358,0.9018615", "l0.7317831,0.9005814", "l0.7320734,0.8995203", "l0.7319970,0.8979034", "l0.7307442,0.8938105", "l0.7308053,0.8925304", "l0.7319206,0.8925978", "l0.7351597,0.8947705", "l0.7356027,0.8935578", "l0.7341207,0.8900207", "l0.7310803,0.8861300", "l0.7272148,0.8825423", "l0.7236549,0.8801843", "l0.7202478,0.8800832", "l0.7181241,0.8816833", "l0.7168865,0.8835866", "l0.7144419,0.8861131", "l0.7128835,0.8855741", "l0.7093847,0.8827276", "l0.6933880,0.8733628", "l0.6923491,0.8696404", "l0.6907143,0.8456220", "l0.6891559,0.8405858", "l0.6877503,0.8374193", "l0.6863599,0.8366445", "l0.6851835,0.8347749", "l0.6860849,0.8327874", "l0.6875211,0.8314568", "l0.6871697,0.8282229", "l0.6848320,0.8242984", "l0.6824791,0.8214519", "l0.6812721,0.8188918", "l0.6792095,0.8159274", "l0.6765205,0.8143104", "l0.6749315,0.8140914", "l0.6738926,0.8131314", "l0.6731439,0.8117671", "l0.6712647,0.8017117", "l0.6717230,0.7950923", "l0.6713105,0.7940480", "l0.6659172,0.7911341", "l0.6631059,0.7910162", "l0.6607225,0.7930879", "l0.6591488,0.7952270", "l0.6535415,0.8011053", "l0.6474607,0.8044234", "l0.6441452,0.8050803", "l0.6379879,0.8040360", "l0.6326710,0.8004821", "l0.6282249,0.7959681", "l0.6236108,0.7893824", "l0.6225260,0.7830494", "l0.6238094,0.7782322", "l0.6228163,0.7534726", "l0.6213649,0.7510977", "l0.6198064,0.7513167", "l0.6137256,0.7544664", "l0.6033820,0.7631238", "l0.6007235,0.7638818", "l0.5984012,0.7626185", "l0.5961399,0.7608668", "l0.5938787,0.7575992", "l0.5892493,0.7535905", "l0.5798988,0.7506598", "l0.5755139,0.7503061", "l0.5650481,0.7216389", "l0.5620382,0.7202241", "l0.5501820,0.7190114", "l0.5478749,0.7173944", "l0.5466374,0.7159964", "l0.5455068,0.7138068", "l0.5449262,0.7112803", "l0.5407246,0.7016629", "l0.5393037,0.6964583", "l0.5393189,0.6951614", "l0.5415954,0.6940497", "l0.5421149,0.6935613", "l0.5473402,0.6928538", "l0.5489750,0.6915738", "l0.5489139,0.6897042", "l0.5481958,0.6870766", "l0.5476458,0.6833374", "l0.5483027,0.6619465", "l0.5466374,0.6606833", "l0.5449720,0.6584263", "l0.5437344,0.6518237", "l0.5406787,0.6429473", "l0.5377911,0.6369175", "l0.5376536,0.6336330", "l0.5387995,0.6287990", "l0.5411982,0.6237797", "l0.5457512,0.6181709", "l0.5748263,0.6124779", "l0.5814420,0.6127643", "l0.5856894,0.6137075", "l0.5954371,0.6122421", "l0.6042070,0.6079808", "l0.6049862,0.6033489", "l0.6056585,0.5823285", "l0.6079503,0.5768882", "l0.6354211,0.5608871", "l0.6390880,0.5565921", "l0.6498441,0.5498716", "l0.6522276,0.5470251", "l0.6533429,0.5451555", "l0.6599433,0.5464356", "l0.7154656,0.5728121", "c"]}, {"n": "Sistan and Baluchestan", "u": "IR-13", "i": ["m0.9106035,0.5894364", "l0.9106035,0.5894364", "l0.9134453,0.5898912", "l0.9147898,0.5904807", "l0.9157982,0.5913734", "l0.9176469,0.5939672", "l0.9180136,0.5952136", "l0.9176469,0.5980770", "l0.9176775,0.5994076", "l0.9181664,0.6007550", "l0.9195567,0.6032984", "l0.9199998,0.6047974", "l0.9200762,0.6067512", "l0.9202137,0.6074418", "l0.9211151,0.6095640", "l0.9217416,0.6117368", "l0.9220013,0.6130506", "l0.9220013,0.6143644", "l0.9216346,0.6157624", "l0.9206415,0.6179351", "l0.9208707,0.6187099", "l0.9210693,0.6232408", "l0.9207637,0.6234429", "l0.9206262,0.6238976", "l0.9205498,0.6251104", "l0.9206262,0.6251777", "l0.9207485,0.6255314", "l0.9198623,0.6265757", "l0.9155996,0.6322687", "l0.9090604,0.6409935", "l0.9031323,0.6489098", "l0.9031323,0.6489098", "l0.8989154,0.6544850", "l0.8933234,0.6618791", "l0.8904052,0.6657531", "l0.8861272,0.6713956", "l0.8781212,0.6819226", "l0.8781060,0.6819394", "l0.8741794,0.6870261", "l0.8711848,0.6909000", "l0.8753711,0.6963572", "l0.8781060,0.6999448", "l0.8814825,0.7044083", "l0.8853786,0.7095623", "l0.8894274,0.7149185", "l0.8936901,0.7205273", "l0.8946985,0.7214368", "l0.8957833,0.7219253", "l0.8967000,0.7226327", "l0.8971736,0.7243002", "l0.8970820,0.7255802", "l0.8964555,0.7278709", "l0.8964555,0.7291510", "l0.8969597,0.7304816", "l0.8985945,0.7324860", "l0.8992668,0.7336145", "l0.8994196,0.7343387", "l0.8995571,0.7359725", "l0.8998321,0.7367136", "l0.9003821,0.7374042", "l0.9008558,0.7375895", "l0.9013294,0.7376568", "l0.9018947,0.7379937", "l0.9024142,0.7389201", "l0.9026892,0.7400317", "l0.9030864,0.7409750", "l0.9039726,0.7413960", "l0.9044768,0.7418340", "l0.9046296,0.7424066", "l0.9044462,0.7429961", "l0.9039726,0.7435520", "l0.9036059,0.7439731", "l0.9034531,0.7443773", "l0.9035753,0.7447478", "l0.9039726,0.7451016", "l0.9046448,0.7454384", "l0.9052254,0.7459437", "l0.9056838,0.7466174", "l0.9078686,0.7521757", "l0.9081589,0.7534390", "l0.9082811,0.7545338", "l0.9085562,0.7555107", "l0.9100382,0.7573466", "l0.9115202,0.7609342", "l0.9130328,0.7629722", "l0.9183650,0.7683284", "l0.9205193,0.7714107", "l0.9238042,0.7747793", "l0.9254390,0.7768679", "l0.9263863,0.7774406", "l0.9294878,0.7784006", "l0.9319629,0.7799670", "l0.9335213,0.7805229", "l0.9369590,0.7808429", "l0.9386091,0.7812303", "l0.9429177,0.7833694", "l0.9497472,0.7848853", "l0.9511834,0.7857106", "l0.9517945,0.7865022", "l0.9522376,0.7873612", "l0.9527571,0.7881529", "l0.9535974,0.7886750", "l0.9544683,0.7889950", "l0.9550030,0.7893656", "l0.9553697,0.7900225", "l0.9557058,0.7911510", "l0.9564545,0.7925489", "l0.9597241,0.7964566", "l0.9607630,0.7971977", "l0.9692274,0.7952944", "l0.9703885,0.7960692", "l0.9706330,0.7983262", "l0.9698691,0.8049793", "l0.9690440,0.8123229", "l0.9700066,0.8167864", "l0.9713511,0.8230015", "l0.9716719,0.8268249", "l0.9720997,0.8320295", "l0.9723595,0.8352634", "l0.9728637,0.8412090", "l0.9731387,0.8445609", "l0.9728178,0.8472221", "l0.9700982,0.8539931", "l0.9711219,0.8553574", "l0.9713664,0.8560479", "l0.9712747,0.8570922", "l0.9710302,0.8580018", "l0.9707247,0.8587260", "l0.9702205,0.8591471", "l0.9693954,0.8592145", "l0.9716261,0.8614041", "l0.9724053,0.8618757", "l0.9728178,0.8618757", "l0.9735359,0.8614041", "l0.9738873,0.8613367", "l0.9743151,0.8614883", "l0.9755221,0.8622294", "l0.9771569,0.8626336", "l0.9785626,0.8625494", "l0.9815725,0.8618757", "l0.9829170,0.8616567", "l0.9856366,0.8607304", "l0.9870116,0.8606461", "l0.9878672,0.8607472", "l0.9885395,0.8607304", "l0.9913660,0.8597366", "l0.9918855,0.8597534", "l0.9925272,0.8600061", "l0.9938717,0.8613704", "l0.9944523,0.8617578", "l0.9957357,0.8622799", "l0.9962093,0.8626168", "l0.9967594,0.8632737", "l0.9974927,0.8644864", "l0.9992650,0.8687983", "l0.9983636,0.8684109", "l0.9972330,0.8684109", "l0.9962246,0.8688993", "l0.9956593,0.8699436", "l0.9954607,0.8705836", "l0.9949106,0.8714595", "l0.9946967,0.8720995", "l0.9946204,0.8728406", "l0.9948801,0.8800832", "l0.9953537,0.8812791", "l0.9959954,0.8823234", "l0.9964232,0.8833508", "l0.9962552,0.8845130", "l0.9954912,0.8852878", "l0.9933828,0.8856752", "l0.9925272,0.8861636", "l0.9921605,0.8871742", "l0.9917480,0.8964380", "l0.9911980,0.8989982", "l0.9900368,0.9002446", "l0.9895173,0.9002277", "l0.9891048,0.8999919", "l0.9887381,0.8997056", "l0.9882950,0.8994698", "l0.9877908,0.8994193", "l0.9862935,0.8997898", "l0.9842462,0.8997393", "l0.9822294,0.8993856", "l0.9775542,0.8992677", "l0.9734901,0.8991498", "l0.9699760,0.8990487", "l0.9694107,0.8992340", "l0.9690135,0.8998235", "l0.9684787,0.9009015", "l0.9681273,0.9012046", "l0.9677453,0.9014236", "l0.9673023,0.9016089", "l0.9656980,0.9020131", "l0.9652549,0.9019794", "l0.9646896,0.9016763", "l0.9641243,0.9015415", "l0.9636812,0.9018447", "l0.9632687,0.9023163", "l0.9628409,0.9026869", "l0.9617867,0.9031079", "l0.9531238,0.9041185", "l0.9526348,0.9042701", "l0.9522223,0.9046238", "l0.9518098,0.9054491", "l0.9515042,0.9057523", "l0.9509695,0.9059208", "l0.9498847,0.9058534", "l0.9493958,0.9059208", "l0.9489680,0.9061229", "l0.9482957,0.9066619", "l0.9478832,0.9069313", "l0.9468595,0.9073693", "l0.9464165,0.9076893", "l0.9460956,0.9081777", "l0.9459887,0.9087336", "l0.9461567,0.9091547", "l0.9463401,0.9095084", "l0.9464012,0.9098958", "l0.9458664,0.9110074", "l0.9442316,0.9127759", "l0.9438649,0.9135676", "l0.9441552,0.9150329", "l0.9446594,0.9161951", "l0.9447053,0.9171047", "l0.9435746,0.9177615", "l0.9416343,0.9174584", "l0.9393425,0.9165657", "l0.9373868,0.9162793", "l0.9365159,0.9178289", "l0.9363326,0.9193785", "l0.9358590,0.9200354", "l0.9337200,0.9204396", "l0.9326505,0.9207933", "l0.9316879,0.9213323", "l0.9298239,0.9226966", "l0.9235903,0.9246504", "l0.9223374,0.9257284", "l0.9215888,0.9274464", "l0.9211457,0.9294171", "l0.9206721,0.9332742", "l0.9202595,0.9366933", "l0.9197706,0.9406347", "l0.9191137,0.9459234", "l0.9185636,0.9503532", "l0.9182733,0.9514649", "l0.9174941,0.9525260", "l0.9165927,0.9527449", "l0.9155996,0.9527281", "l0.9144995,0.9530144", "l0.9134147,0.9546819", "l0.9136592,0.9570063", "l0.9142398,0.9595159", "l0.9140870,0.9617055", "l0.9137662,0.9621940", "l0.9130022,0.9630362", "l0.9126967,0.9636425", "l0.9125286,0.9645520", "l0.9123147,0.9682407", "l0.9119938,0.9736474", "l0.9116272,0.9799299", "l0.9113216,0.9852524", "l0.9096868,0.9905075", "l0.9096715,0.9905075", "l0.9093506,0.9895979", "l0.9092437,0.9885368", "l0.9083423,0.9878126", "l0.9081742,0.9874252", "l0.9079297,0.9872399", "l0.9074255,0.9876104", "l0.9072728,0.9879641", "l0.9071964,0.9889747", "l0.9070436,0.9893621", "l0.9073339,0.9896653", "l0.9078381,0.9903222", "l0.9081284,0.9906085", "l0.9070283,0.9904738", "l0.9061880,0.9901032", "l0.9053324,0.9900864", "l0.9042170,0.9910465", "l0.9054393,0.9914844", "l0.9059435,0.9917876", "l0.9063560,0.9923434", "l0.9060810,0.9929497", "l0.9052713,0.9940951", "l0.9050421,0.9947688", "l0.9050421,0.9950888", "l0.9049810,0.9953415", "l0.9045685,0.9957794", "l0.9038198,0.9962173", "l0.9010085,0.9971437", "l0.9017572,0.9977164", "l0.9005502,0.9995018", "l0.8918414,0.9962005", "l0.8888162,0.9954762", "l0.8888315,0.9944488", "l0.8880523,0.9928824", "l0.8808256,0.9900359", "l0.8723459,0.9884694", "l0.8651497,0.9865830", "l0.8602759,0.9859261", "l0.8594203,0.9854040", "l0.8602148,0.9845787", "l0.8589619,0.9825912", "l0.8588091,0.9817490", "l0.8587939,0.9782119", "l0.8586258,0.9776561", "l0.8567465,0.9755844", "l0.8559368,0.9750622", "l0.8550353,0.9749443", "l0.8541033,0.9750454", "l0.8505587,0.9762413", "l0.8496726,0.9767971", "l0.8491836,0.9776561", "l0.8483739,0.9787341", "l0.8479461,0.9794246", "l0.8479461,0.9798457", "l0.8480989,0.9802331", "l0.8482975,0.9815132", "l0.8485572,0.9816985", "l0.8489086,0.9817321", "l0.8494892,0.9820522", "l0.8499323,0.9820353", "l0.8501462,0.9822038", "l0.8503601,0.9825912", "l0.8508948,0.9832480", "l0.8503295,0.9831470", "l0.8503295,0.9832986", "l0.8518268,0.9841407", "l0.8516740,0.9849492", "l0.8510782,0.9847976", "l0.8494128,0.9840228", "l0.8473044,0.9830628", "l0.8462654,0.9824059", "l0.8440195,0.9824564", "l0.8425222,0.9811089", "l0.8430111,0.9800984", "l0.8432250,0.9798457", "l0.8424763,0.9794752", "l0.8415291,0.9793236", "l0.8396651,0.9794246", "l0.8382289,0.9797278", "l0.8379233,0.9798457", "l0.8374650,0.9804352", "l0.8374650,0.9807889", "l0.8376025,0.9811089", "l0.8386720,0.9819174", "l0.8383206,0.9830965", "l0.8369149,0.9830796", "l0.8358760,0.9823217", "l0.8353107,0.9821195", "l0.8335384,0.9818332", "l0.8331411,0.9814963", "l0.8325606,0.9806710", "l0.8317508,0.9801826", "l0.8298410,0.9803173", "l0.8272131,0.9807552", "l0.8244324,0.9808731", "l0.8225225,0.9824564", "l0.8203530,0.9816311", "l0.8181834,0.9793404", "l0.8158458,0.9786667", "l0.8098719,0.9790709", "l0.8075343,0.9790541", "l0.8035924,0.9780435", "l0.8011325,0.9752812", "l0.7992533,0.9741358", "l0.7963198,0.9747590", "l0.7902084,0.9758370", "l0.7887569,0.9760897", "l0.7885277,0.9745906", "l0.7898875,0.9739337", "l0.7899181,0.9729737", "l0.7900556,0.9719631", "l0.7890930,0.9714409", "l0.7886652,0.9708177", "l0.7868318,0.9673649", "l0.7859762,0.9664216", "l0.7852734,0.9654111", "l0.7849220,0.9641141", "l0.7840816,0.9629688", "l0.7825232,0.9623119", "l0.7813773,0.9610318", "l0.7811023,0.9587411", "l0.7794370,0.9557094", "l0.7696281,0.9461424", "l0.7677794,0.9448623", "l0.7670766,0.9445254", "l0.7668780,0.9433801", "l0.7671224,0.9413421", "l0.7680544,0.9397757", "l0.7686808,0.9394051", "l0.7697045,0.9366260", "l0.7700101,0.9342679", "l0.7699795,0.9303434", "l0.7706059,0.9286928", "l0.7713088,0.9276654", "l0.7712171,0.9255936", "l0.7721949,0.9242799", "l0.7730200,0.9218376", "l0.7725769,0.9193953", "l0.7707893,0.9170541", "l0.7698267,0.9133486", "l0.7711101,0.9104179", "l0.7727755,0.9082283", "l0.7727144,0.9060555", "l0.7710643,0.9043880", "l0.7702240,0.9029227", "l0.7716754,0.9001772", "l0.7731422,0.8953264", "l0.7704226,0.8892123", "l0.7664807,0.8842098", "l0.7654112,0.8798474", "l0.7655640,0.8757377", "l0.7653807,0.8733459", "l0.7641278,0.8679561", "l0.7641126,0.8616062", "l0.7700712,0.8358192", "l0.7707587,0.8284419", "l0.7704073,0.8060741", "l0.7763812,0.7974672", "l0.7779855,0.7916057", "l0.7761368,0.7883213", "l0.7718893,0.7847674", "l0.7699642,0.7814829", "l0.7729588,0.7797144", "l0.7788411,0.7775079", "l0.7908806,0.7697769", "l0.7932182,0.7677557", "l0.7947308,0.7659366", "l0.7948225,0.7635281", "l0.7942877,0.7610016", "l0.7927599,0.7574813", "l0.7926988,0.7521420", "l0.7919501,0.7478133", "l0.7926988,0.7436025", "l0.7970379,0.7362925", "l0.7986116,0.7298247", "l0.7987644,0.7241149", "l0.7969768,0.7102866", "l0.7949142,0.7045262", "l0.7925765,0.7028250", "l0.7913542,0.7013934", "l0.7918126,0.6959362", "l0.8024312,0.6414820", "l0.8040507,0.6406230", "l0.8428736,0.6284622", "l0.8457001,0.6290180", "l0.8475183,0.6311571", "l0.8486947,0.6322014", "l0.8534922,0.6336499", "l0.8598634,0.6388376", "l0.8680068,0.6516553", "l0.8722543,0.6556640", "l0.8792824,0.6553945", "l0.8810395,0.6546365", "l0.8818492,0.6532554", "l0.8819409,0.6512005", "l0.8793130,0.6383323", "l0.8790991,0.6332793", "l0.8801686,0.6159139", "l0.8826284,0.6061449", "l0.8859439,0.5973527", "l0.8866620,0.5893016", "l0.8857147,0.5854109", "l0.8944999,0.5868425", "l0.9046448,0.5884763", "l0.9106035,0.5894364", "c"]}, {"n": "North Khorasan", "u": "IR-31", "i": ["m0.6979563,0.1359155", "l0.6979563,0.1359155", "l0.6987814,0.1357807", "l0.6995759,0.1355112", "l0.7004620,0.1353596", "l0.7013329,0.1354775", "l0.7039608,0.1363197", "l0.7064818,0.1362692", "l0.7072610,0.1360502", "l0.7080402,0.1360502", "l0.7087430,0.1365387", "l0.7093847,0.1371619", "l0.7100417,0.1376166", "l0.7103014,0.1376503", "l0.7040219,0.1419285", "l0.7020663,0.1441181", "l0.7020816,0.1472678", "l0.7014857,0.1499459", "l0.7006454,0.1524387", "l0.7026163,0.1540051", "l0.7258245,0.1552178", "l0.7268023,0.1565653", "l0.7274593,0.1590244", "l0.7286510,0.1620225", "l0.7333415,0.1668733", "l0.7347624,0.1700904", "l0.7350833,0.1729706", "l0.7339374,0.1752781", "l0.7325776,0.1771309", "l0.7321039,0.1783773", "l0.7320581,0.1798089", "l0.7315386,0.1819312", "l0.7296747,0.1848114", "l0.7265731,0.1949342", "l0.7244647,0.1978144", "l0.7247091,0.2003071", "l0.7272454,0.2022441", "l0.7286815,0.2039958", "l0.7296135,0.2060002", "l0.7309886,0.2057644", "l0.7317373,0.2036084", "l0.7324095,0.2032716", "l0.7328526,0.2051075", "l0.7338915,0.2068592", "l0.7356027,0.2077687", "l0.7358014,0.2094193", "l0.7327304,0.2130743", "l0.7323942,0.2150618", "l0.7330665,0.2161903", "l0.7349152,0.2174030", "l0.7353430,0.2196263", "l0.7336165,0.2251846", "l0.7316761,0.2272058", "l0.7277648,0.2282669", "l0.7134335,0.2258415", "l0.6791637,0.2048380", "l0.6709133,0.2044001", "l0.6584460,0.2155671", "l0.6554666,0.2199632", "l0.6550541,0.2231971", "l0.6554514,0.2257236", "l0.6552833,0.2276606", "l0.6473995,0.2291259", "l0.6448327,0.2280311", "l0.6398978,0.2271047", "l0.6369948,0.2260268", "l0.6311126,0.2204517", "l0.6249859,0.2128554", "l0.6240233,0.2105984", "l0.6242067,0.2091667", "l0.6251845,0.2049054", "l0.6254442,0.2000545", "l0.6251845,0.1981681", "l0.6248637,0.1974101", "l0.6245275,0.1968374", "l0.6248484,0.1957763", "l0.6261776,0.1945973", "l0.6292028,0.1936035", "l0.6297375,0.1919697", "l0.6272166,0.1908076", "l0.6251845,0.1911950", "l0.6215024,0.1883316", "l0.6136797,0.1768277", "l0.6152534,0.1751434", "l0.6190272,0.1677323", "l0.6227858,0.1660143", "l0.6243595,0.1644142", "l0.6259179,0.1636394", "l0.6273082,0.1634036", "l0.6333738,0.1610793", "l0.6362156,0.1567000", "l0.6352531,0.1523039", "l0.6331446,0.1505186", "l0.6307001,0.1491879", "l0.6289430,0.1468804", "l0.6288361,0.1436128", "l0.6298903,0.1389472", "l0.6299361,0.1372292", "l0.6293097,0.1341975", "l0.6291722,0.1315699", "l0.6295083,0.1295150", "l0.6291722,0.1244452", "l0.6307765,0.1251695", "l0.6316168,0.1253042", "l0.6360476,0.1244789", "l0.6368573,0.1238052", "l0.6373768,0.1226767", "l0.6375601,0.1213292", "l0.6373157,0.1200660", "l0.6359101,0.1182806", "l0.6362309,0.1172868", "l0.6395005,0.1139350", "l0.6412423,0.1125876", "l0.6431215,0.1117960", "l0.6478732,0.1116275", "l0.6487441,0.1118633", "l0.6494774,0.1123518", "l0.6501191,0.1129245", "l0.6508219,0.1132782", "l0.6516470,0.1131097", "l0.6558028,0.1111054", "l0.6582779,0.1106338", "l0.6587821,0.1107348", "l0.6607989,0.1125707", "l0.6625712,0.1136992", "l0.6633809,0.1139856", "l0.6711577,0.1156025", "l0.6732203,0.1165289", "l0.6742746,0.1167142", "l0.6752065,0.1161415", "l0.6759246,0.1154341", "l0.6776053,0.1141877", "l0.6782164,0.1134634", "l0.6792554,0.1114591", "l0.6794082,0.1112570", "l0.6798665,0.1107180", "l0.6807679,0.1102464", "l0.6813333,0.1101622", "l0.6818986,0.1102464", "l0.6829986,0.1106506", "l0.6835792,0.1110717", "l0.6837167,0.1115433", "l0.6837473,0.1120823", "l0.6839612,0.1127223", "l0.6851529,0.1149625", "l0.6860849,0.1174721", "l0.6866960,0.1184827", "l0.6883920,0.1205039", "l0.6889878,0.1226767", "l0.6901032,0.1244115", "l0.6903476,0.1256916", "l0.6902254,0.1268875", "l0.6892017,0.1307109", "l0.6905157,0.1326479", "l0.6979563,0.1359155", "c"]}, {"n": "Razavi Khorasan", "u": "IR-30", "i": ["m0.7136780,0.1398568", "l0.7136780,0.1398568", "l0.7145183,0.1397894", "l0.7153892,0.1395704", "l0.7162295,0.1394862", "l0.7180324,0.1400252", "l0.7261453,0.1443371", "l0.7295524,0.1452298", "l0.7312942,0.1453814", "l0.7321345,0.1456003", "l0.7330054,0.1460719", "l0.7333873,0.1465604", "l0.7334026,0.1470657", "l0.7332804,0.1475710", "l0.7333262,0.1481437", "l0.7341513,0.1498280", "l0.7343346,0.1503670", "l0.7344568,0.1516807", "l0.7344721,0.1526745", "l0.7347166,0.1534998", "l0.7356027,0.1543083", "l0.7364889,0.1546788", "l0.7405224,0.1553526", "l0.7411641,0.1556894", "l0.7425392,0.1567674", "l0.7432573,0.1569864", "l0.7479478,0.1564642", "l0.7488340,0.1559926", "l0.7495368,0.1547967", "l0.7500104,0.1535840", "l0.7506369,0.1525734", "l0.7514313,0.1519334", "l0.7524397,0.1518492", "l0.7532953,0.1523376", "l0.7558927,0.1548809", "l0.7581234,0.1558915", "l0.7592998,0.1560937", "l0.7604610,0.1559589", "l0.7609041,0.1556557", "l0.7612402,0.1552178", "l0.7616069,0.1548809", "l0.7621875,0.1548809", "l0.7632875,0.1551168", "l0.7638223,0.1550662", "l0.7643723,0.1548641", "l0.7650598,0.1539209", "l0.7651821,0.1528429", "l0.7654723,0.1523545", "l0.7685739,0.1542577", "l0.7725922,0.1552852", "l0.7746242,0.1563126", "l0.7753576,0.1569021", "l0.7760451,0.1571548", "l0.7775424,0.1574074", "l0.7781230,0.1577443", "l0.7798189,0.1596813", "l0.7867096,0.1651890", "l0.7878249,0.1653069", "l0.7907278,0.1638247", "l0.7919196,0.1641784", "l0.7929585,0.1652732", "l0.7939516,0.1668060", "l0.7941961,0.1677492", "l0.7940433,0.1693493", "l0.7943488,0.1701241", "l0.7944864,0.1707304", "l0.7942725,0.1713705", "l0.7939516,0.1720779", "l0.7937835,0.1728695", "l0.7939058,0.1743854", "l0.7949294,0.1793205", "l0.7955253,0.1803142", "l0.7987644,0.1832955", "l0.7997422,0.1844914", "l0.8000478,0.1849630", "l0.7999866,0.1853167", "l0.7997880,0.1855525", "l0.7997269,0.1857546", "l0.7996505,0.1862430", "l0.7994977,0.1868326", "l0.7996505,0.1873379", "l0.8005061,0.1875905", "l0.8008422,0.1879779", "l0.8012548,0.1883485", "l0.8016978,0.1885843", "l0.8021256,0.1886179", "l0.8037604,0.1878937", "l0.8045244,0.1880453", "l0.8053953,0.1890727", "l0.8057619,0.1901844", "l0.8060064,0.1915487", "l0.8063731,0.1927277", "l0.8070606,0.1933341", "l0.8075495,0.1932161", "l0.8079162,0.1927951", "l0.8085274,0.1917339", "l0.8090163,0.1914476", "l0.8095663,0.1914813", "l0.8170070,0.1941762", "l0.8203988,0.1973427", "l0.8223086,0.1985723", "l0.8265561,0.1994145", "l0.8284965,0.2003408", "l0.8300243,0.2026147", "l0.8319647,0.2071792", "l0.8343634,0.2112216", "l0.8398484,0.2186157", "l0.8409332,0.2205527", "l0.8424305,0.2249151", "l0.8435000,0.2269868", "l0.8452112,0.2280480", "l0.8534311,0.2278795", "l0.8606731,0.2277279", "l0.8717042,0.2275090", "l0.8778462,0.2273911", "l0.8831479,0.2272900", "l0.8857147,0.2277785", "l0.8878231,0.2280985", "l0.8882509,0.2305239", "l0.8886787,0.2316187", "l0.8888621,0.2322756", "l0.8889538,0.2331683", "l0.8888774,0.2340273", "l0.8886787,0.2348189", "l0.8883884,0.2355095", "l0.8880676,0.2360485", "l0.8878537,0.2368064", "l0.8879301,0.2376486", "l0.8882509,0.2387097", "l0.8871356,0.2444196", "l0.8868300,0.2479061", "l0.8875634,0.2499273", "l0.8874106,0.2502137", "l0.8873189,0.2504158", "l0.8871814,0.2509042", "l0.8876856,0.2511400", "l0.8880982,0.2514937", "l0.8884190,0.2519317", "l0.8886329,0.2523527", "l0.8888315,0.2530938", "l0.8889232,0.2538349", "l0.8889538,0.2554687", "l0.8891218,0.2561593", "l0.8898705,0.2575405", "l0.8906497,0.2619365", "l0.8907872,0.2640588", "l0.8908636,0.2644125", "l0.8907719,0.2648504", "l0.8902219,0.2656421", "l0.8899621,0.2661305", "l0.8898094,0.2667537", "l0.8897177,0.2674443", "l0.8896871,0.2681012", "l0.8894885,0.2688591", "l0.8890607,0.2692128", "l0.8885718,0.2694318", "l0.8882509,0.2697518", "l0.8880982,0.2706108", "l0.8882815,0.2720256", "l0.8882509,0.2726825", "l0.8876092,0.2734405", "l0.8865550,0.2743837", "l0.8859592,0.2752259", "l0.8866772,0.2755796", "l0.8879454,0.2757985", "l0.8889843,0.2764217", "l0.8898857,0.2773481", "l0.8907261,0.2784598", "l0.8912608,0.2794367", "l0.8917192,0.2806325", "l0.8920400,0.2818621", "l0.8922692,0.2843886", "l0.8924678,0.2854497", "l0.8924984,0.2865950", "l0.8921623,0.2881615", "l0.8924984,0.2886836", "l0.8924984,0.2893742", "l0.8921623,0.2910417", "l0.8921317,0.2914290", "l0.8921623,0.2926754", "l0.8920095,0.2931639", "l0.8913067,0.2939387", "l0.8910928,0.2943598", "l0.8912303,0.2962294", "l0.8919331,0.2978126", "l0.8932012,0.2999854", "l0.8935679,0.3006255", "l0.8941179,0.3035056", "l0.8942554,0.3049205", "l0.8939346,0.3063690", "l0.8932318,0.3076996", "l0.8920247,0.3093334", "l0.8914594,0.3106809", "l0.8910011,0.3128705", "l0.8907261,0.3135947", "l0.8896413,0.3152117", "l0.8893357,0.3159865", "l0.8890913,0.3174182", "l0.8893357,0.3210226", "l0.8889232,0.3222522", "l0.8879301,0.3228922", "l0.8866925,0.3231112", "l0.8855925,0.3231449", "l0.8848438,0.3238186", "l0.8845382,0.3253176", "l0.8845077,0.3267998", "l0.8845382,0.3274736", "l0.8848285,0.3277767", "l0.8850730,0.3284505", "l0.8850577,0.3291242", "l0.8845382,0.3294274", "l0.8842327,0.3297474", "l0.8844924,0.3304380", "l0.8863411,0.3331834", "l0.8864786,0.3334866", "l0.8863717,0.3342782", "l0.8862342,0.3348846", "l0.8863258,0.3354573", "l0.8868606,0.3360973", "l0.8856077,0.3380511", "l0.8852411,0.3390449", "l0.8849355,0.3419251", "l0.8841716,0.3445358", "l0.8840035,0.3459001", "l0.8838354,0.3465570", "l0.8831173,0.3478707", "l0.8829493,0.3487466", "l0.8829951,0.3494540", "l0.8832243,0.3507509", "l0.8832701,0.3513573", "l0.8830409,0.3537995", "l0.8826284,0.3561071", "l0.8810395,0.3566797", "l0.8807492,0.3578419", "l0.8797408,0.3598294", "l0.8781060,0.3612443", "l0.8771740,0.3624570", "l0.8770976,0.3640908", "l0.8772809,0.3658761", "l0.8770670,0.3675773", "l0.8765323,0.3683689", "l0.8759211,0.3685205", "l0.8752489,0.3684700", "l0.8745308,0.3685879", "l0.8738280,0.3690258", "l0.8734918,0.3694974", "l0.8732321,0.3700533", "l0.8708792,0.3730177", "l0.8698708,0.3737756", "l0.8685874,0.3741799", "l0.8657456,0.3746009", "l0.8644622,0.3753252", "l0.8636983,0.3767906", "l0.8642483,0.3768748", "l0.8646914,0.3771443", "l0.8650275,0.3776327", "l0.8654706,0.3792834", "l0.8659290,0.3797550", "l0.8671971,0.3803950", "l0.8678235,0.3810351", "l0.8683277,0.3818267", "l0.8691527,0.3836289", "l0.8729876,0.3891535", "l0.8735682,0.3904504", "l0.8697180,0.3906862", "l0.8644622,0.3910568", "l0.8608106,0.3912926", "l0.8611620,0.3927579", "l0.8603523,0.3937348", "l0.8578924,0.3951834", "l0.8560896,0.3972719", "l0.8544547,0.3996131", "l0.8530033,0.4028470", "l0.8526824,0.4059294", "l0.8527741,0.4068557", "l0.8527588,0.4068557", "l0.8487253,0.4076137", "l0.8165333,0.4077147", "l0.8097344,0.4050535", "l0.8046619,0.3958908", "l0.8018812,0.3932632", "l0.7964878,0.3954865", "l0.7916904,0.3985352", "l0.7763354,0.4010448", "l0.7748534,0.4028639", "l0.7734478,0.4039924", "l0.7681308,0.4022070", "l0.7598957,0.4010448", "l0.7571150,0.4022238", "l0.7563663,0.4041945", "l0.7566566,0.4059967", "l0.7586734,0.4096012", "l0.7581845,0.4141657", "l0.7570997,0.4192187", "l0.7576497,0.4222504", "l0.7574511,0.4249790", "l0.7561219,0.4284993", "l0.7553427,0.4323901", "l0.7555871,0.4353208", "l0.7570386,0.4368704", "l0.7582456,0.4378473", "l0.7587803,0.4394642", "l0.7592234,0.4414349", "l0.7670613,0.4477511", "l0.7655182,0.4509008", "l0.7652126,0.4528546", "l0.7626305,0.4574191", "l0.7603235,0.4600130", "l0.7440671,0.4719211", "l0.7368861,0.4839472", "l0.7351749,0.4919983", "l0.7329595,0.4961922", "l0.7316609,0.4979103", "l0.7303011,0.4968323", "l0.7261147,0.4895897", "l0.7217298,0.4865579", "l0.7183838,0.4848904", "l0.7171462,0.4838293", "l0.7127460,0.4810502", "l0.7093847,0.4725443", "l0.7055192,0.4437087", "l0.7034719,0.4393463", "l0.7012565,0.4362303", "l0.6880253,0.4396327", "l0.6777581,0.4382684", "l0.6753288,0.4340407", "l0.6721050,0.4142499", "l0.6725328,0.4026112", "l0.6790415,0.3809508", "l0.6825708,0.3739272", "l0.7030747,0.3578924", "l0.7080860,0.3524689", "l0.7087888,0.3480223", "l0.7070165,0.3436262", "l0.6919213,0.3308422", "l0.6861613,0.3291747", "l0.6731439,0.3328802", "l0.6525790,0.3436599", "l0.6314334,0.3497572", "l0.6397450,0.3383880", "l0.6464217,0.3316507", "l0.6523040,0.3277767", "l0.6632281,0.3232459", "l0.6648018,0.3218816", "l0.6670020,0.3162391", "l0.6760010,0.2991432", "l0.6767955,0.2942419", "l0.6734037,0.2899300", "l0.6611350,0.2788640", "l0.6597294,0.2749058", "l0.6580487,0.2663832", "l0.6570709,0.2531275", "l0.6578348,0.2454133", "l0.6599280,0.2410004", "l0.6613183,0.2343810", "l0.6600502,0.2287891", "l0.6579570,0.2274079", "l0.6563070,0.2273405", "l0.6552833,0.2276606", "l0.6554514,0.2257236", "l0.6550541,0.2231971", "l0.6554666,0.2199632", "l0.6584460,0.2155671", "l0.6709133,0.2044001", "l0.6791637,0.2048380", "l0.7134335,0.2258415", "l0.7277648,0.2282669", "l0.7316761,0.2272058", "l0.7336165,0.2251846", "l0.7353430,0.2196263", "l0.7349152,0.2174030", "l0.7330665,0.2161903", "l0.7323942,0.2150618", "l0.7327304,0.2130743", "l0.7358014,0.2094193", "l0.7356027,0.2077687", "l0.7338915,0.2068592", "l0.7328526,0.2051075", "l0.7324095,0.2032716", "l0.7317373,0.2036084", "l0.7309886,0.2057644", "l0.7296135,0.2060002", "l0.7286815,0.2039958", "l0.7272454,0.2022441", "l0.7247091,0.2003071", "l0.7244647,0.1978144", "l0.7265731,0.1949342", "l0.7296747,0.1848114", "l0.7315386,0.1819312", "l0.7320581,0.1798089", "l0.7321039,0.1783773", "l0.7325776,0.1771309", "l0.7339374,0.1752781", "l0.7350833,0.1729706", "l0.7347624,0.1700904", "l0.7333415,0.1668733", "l0.7286510,0.1620225", "l0.7274593,0.1590244", "l0.7268023,0.1565653", "l0.7258245,0.1552178", "l0.7026163,0.1540051", "l0.7006454,0.1524387", "l0.7014857,0.1499459", "l0.7020816,0.1472678", "l0.7020663,0.1441181", "l0.7040219,0.1419285", "l0.7103014,0.1376503", "l0.7104848,0.1376672", "l0.7113251,0.1374482", "l0.7117529,0.1375661", "l0.7121196,0.1379703", "l0.7125932,0.1390652", "l0.7128988,0.1395031", "l0.7136780,0.1398568", "c"]}, {"n": "South Khorasan", "u": "IR-29", "i": ["m0.8165333,0.4077147", "l0.8165333,0.4077147", "l0.8487253,0.4076137", "l0.8527588,0.4068557", "l0.8527741,0.4068557", "l0.8533394,0.4128182", "l0.8548214,0.4233284", "l0.8547145,0.4260233", "l0.8531102,0.4299983", "l0.8526977,0.4322553", "l0.8539811,0.4372578", "l0.8572507,0.4407106", "l0.8614218,0.4426308", "l0.8654706,0.4429676", "l0.8692750,0.4427487", "l0.8712764,0.4429171", "l0.8730182,0.4433887", "l0.8738127,0.4439108", "l0.8746836,0.4447867", "l0.8751419,0.4457636", "l0.8750961,0.4458647", "l0.8746988,0.4466226", "l0.8739349,0.4469258", "l0.8714751,0.4471111", "l0.8705584,0.4477848", "l0.8704056,0.4487617", "l0.8705889,0.4499070", "l0.8706806,0.4510861", "l0.8704056,0.4524504", "l0.8698555,0.4532252", "l0.8681596,0.4544042", "l0.8666776,0.4558695", "l0.8647067,0.4588171", "l0.8621857,0.4625900", "l0.8593744,0.4667840", "l0.8568688,0.4705232", "l0.8565479,0.4714832", "l0.8566243,0.4768731", "l0.8573882,0.4812186", "l0.8588703,0.4867937", "l0.8606120,0.4933626", "l0.8624149,0.5001336", "l0.8643247,0.5072751", "l0.8664331,0.5151072", "l0.8687096,0.5244720", "l0.8704667,0.5316978", "l0.8703597,0.5371887", "l0.8696569,0.5425448", "l0.8693513,0.5436733", "l0.8679916,0.5455934", "l0.8675943,0.5466377", "l0.8677777,0.5470420", "l0.8682055,0.5473283", "l0.8685110,0.5476989", "l0.8680679,0.5491811", "l0.8681749,0.5498716", "l0.8684346,0.5505285", "l0.8686333,0.5512528", "l0.8687249,0.5527181", "l0.8683430,0.5568616", "l0.8684499,0.5601123", "l0.8691680,0.5663275", "l0.8685110,0.5712794", "l0.8686333,0.5728458", "l0.8694125,0.5760797", "l0.8700236,0.5823622", "l0.8717348,0.5831539", "l0.8769601,0.5839960", "l0.8856383,0.5854109", "l0.8857147,0.5854109", "l0.8866620,0.5893016", "l0.8859439,0.5973527", "l0.8826284,0.6061449", "l0.8801686,0.6159139", "l0.8790991,0.6332793", "l0.8793130,0.6383323", "l0.8819409,0.6512005", "l0.8818492,0.6532554", "l0.8810395,0.6546365", "l0.8792824,0.6553945", "l0.8722543,0.6556640", "l0.8680068,0.6516553", "l0.8598634,0.6388376", "l0.8534922,0.6336499", "l0.8486947,0.6322014", "l0.8475183,0.6311571", "l0.8457001,0.6290180", "l0.8428736,0.6284622", "l0.8040507,0.6406230", "l0.8024312,0.6414820", "l0.7817746,0.6082840", "l0.7743645,0.6021699", "l0.7154656,0.5728121", "l0.7161990,0.5714983", "l0.7189033,0.5638010", "l0.7242202,0.5547056", "l0.7261300,0.5488273", "l0.7330207,0.5386372", "l0.7338763,0.5354875", "l0.7343346,0.5321694", "l0.7355111,0.5284133", "l0.7356333,0.5247078", "l0.7335554,0.5209181", "l0.7319817,0.5171284", "l0.7318900,0.5150904", "l0.7303775,0.5131871", "l0.7295830,0.5116206", "l0.7292163,0.5101216", "l0.7301025,0.5076962", "l0.7314928,0.5052034", "l0.7319206,0.5030980", "l0.7316609,0.4979103", "l0.7329595,0.4961922", "l0.7351749,0.4919983", "l0.7368861,0.4839472", "l0.7440671,0.4719211", "l0.7603235,0.4600130", "l0.7626305,0.4574191", "l0.7652126,0.4528546", "l0.7655182,0.4509008", "l0.7670613,0.4477511", "l0.7592234,0.4414349", "l0.7587803,0.4394642", "l0.7582456,0.4378473", "l0.7570386,0.4368704", "l0.7555871,0.4353208", "l0.7553427,0.4323901", "l0.7561219,0.4284993", "l0.7574511,0.4249790", "l0.7576497,0.4222504", "l0.7570997,0.4192187", "l0.7581845,0.4141657", "l0.7586734,0.4096012", "l0.7566566,0.4059967", "l0.7563663,0.4041945", "l0.7571150,0.4022238", "l0.7598957,0.4010448", "l0.7681308,0.4022070", "l0.7734478,0.4039924", "l0.7748534,0.4028639", "l0.7763354,0.4010448", "l0.7916904,0.3985352", "l0.7964878,0.3954865", "l0.8018812,0.3932632", "l0.8046619,0.3958908", "l0.8097344,0.4050535", "l0.8165333,0.4077147", "c"]}, {"n": "Kordestan", "u": "IR-16", "i": ["m0.2183009,0.2949493", "l0.2183009,0.2949493", "l0.2106769,0.2903511", "l0.2088129,0.2909237", "l0.2097296,0.2937366", "l0.2112575,0.2959262", "l0.2118686,0.2974252", "l0.2118533,0.2991938", "l0.2081712,0.3005749", "l0.2066892,0.3021750", "l0.2049932,0.3030172", "l0.2033890,0.3025287", "l0.2009444,0.2969199", "l0.1997527,0.2970547", "l0.1970484,0.3004065", "l0.1962386,0.3021750", "l0.1998444,0.3080702", "l0.2054210,0.3218311", "l0.2079573,0.3252503", "l0.2100810,0.3267156", "l0.2130298,0.3299495", "l0.2144507,0.3364005", "l0.2134270,0.3416050", "l0.2116089,0.3448221", "l0.2098824,0.3464896", "l0.2087671,0.3458327", "l0.2071017,0.3413187", "l0.2061391,0.3415882", "l0.2055586,0.3435420", "l0.2036793,0.3446705", "l0.2005013,0.3456643", "l0.1989277,0.3466075", "l0.1973234,0.3466749", "l0.1950927,0.3463043", "l0.1871479,0.3364005", "l0.1812198,0.3334361", "l0.1791877,0.3314991", "l0.1776752,0.3313644", "l0.1771251,0.3326950", "l0.1780571,0.3347667", "l0.1778891,0.3371247", "l0.1761167,0.3389270", "l0.1687066,0.3394659", "l0.1681719,0.3408134", "l0.1678510,0.3453442", "l0.1668121,0.3460011", "l0.1647800,0.3458495", "l0.1615563,0.3462032", "l0.1584394,0.3497909", "l0.1562699,0.3505993", "l0.1555976,0.3521321", "l0.1555976,0.3541364", "l0.1544976,0.3555344", "l0.1528016,0.3558376", "l0.1517933,0.3573366", "l0.1515488,0.3596273", "l0.1495626,0.3607895", "l0.1460638,0.3613453", "l0.1413886,0.3607390", "l0.1382870,0.3611095", "l0.1365758,0.3590378", "l0.1365147,0.3562923", "l0.1369272,0.3542543", "l0.1367133,0.3527889", "l0.1355369,0.3528900", "l0.1333215,0.3511888", "l0.1208847,0.3324255", "l0.1110453,0.3238691", "l0.1096091,0.3233301", "l0.1097314,0.3230438", "l0.1093494,0.3209889", "l0.1081118,0.3194057", "l0.1052547,0.3165760", "l0.1019393,0.3107145", "l0.1012670,0.3086934", "l0.1012517,0.3080533", "l0.1013740,0.3074806", "l0.1016490,0.3070259", "l0.1020615,0.3066722", "l0.1022601,0.3064027", "l0.1023365,0.3061163", "l0.1022601,0.3058132", "l0.1020615,0.3055268", "l0.1014809,0.3041962", "l0.1010226,0.3027645", "l0.1012670,0.3026972", "l0.1015115,0.3026972", "l0.1031005,0.3032362", "l0.1032380,0.3022592", "l0.1027338,0.2995643", "l0.1027338,0.2984021", "l0.1029171,0.2971726", "l0.1033296,0.2960609", "l0.1039866,0.2952693", "l0.1050561,0.2948482", "l0.1086771,0.2949661", "l0.1097314,0.2946966", "l0.1123287,0.2931807", "l0.1143608,0.2932986", "l0.1154455,0.2931639", "l0.1162553,0.2923049", "l0.1169581,0.2911596", "l0.1185318,0.2900479", "l0.1193416,0.2892394", "l0.1199527,0.2880772", "l0.1200597,0.2869824", "l0.1196777,0.2860392", "l0.1188068,0.2853655", "l0.1176915,0.2852476", "l0.1167748,0.2857529", "l0.1158886,0.2864266", "l0.1148955,0.2868308", "l0.1127107,0.2873530", "l0.1115953,0.2874035", "l0.1105564,0.2869151", "l0.1101286,0.2865277", "l0.1098077,0.2861403", "l0.1095938,0.2856518", "l0.1093341,0.2842201", "l0.1090897,0.2839675", "l0.1087077,0.2839001", "l0.1071187,0.2832264", "l0.1062631,0.2832095", "l0.1054228,0.2835464", "l0.1044297,0.2841865", "l0.1033907,0.2845570", "l0.1000906,0.2843886", "l0.0984252,0.2850286", "l0.0978905,0.2849612", "l0.0973710,0.2847760", "l0.0968362,0.2847591", "l0.0955834,0.2859382", "l0.0945903,0.2864940", "l0.0935208,0.2865782", "l0.0926805,0.2859382", "l0.0920999,0.2858034", "l0.0901442,0.2864603", "l0.0892122,0.2861740", "l0.0885858,0.2852476", "l0.0872566,0.2816094", "l0.0848578,0.2778534", "l0.0833147,0.2762870", "l0.0819091,0.2760006", "l0.0812368,0.2755290", "l0.0793270,0.2735752", "l0.0773408,0.2727667", "l0.0773408,0.2727667", "l0.0773713,0.2727331", "l0.0791131,0.2715540", "l0.0811451,0.2693139", "l0.0820007,0.2670064", "l0.0848731,0.2634019", "l0.0855759,0.2599659", "l0.0867218,0.2586690", "l0.0873177,0.2575405", "l0.0888761,0.2556709", "l0.0972946,0.2526728", "l0.0997850,0.2484956", "l0.0998614,0.2450765", "l0.1010073,0.2434427", "l0.1055297,0.2414552", "l0.1185471,0.2435100", "l0.1453151,0.2407814", "l0.1459263,0.2413373", "l0.1462930,0.2421963", "l0.1470263,0.2432742", "l0.1480653,0.2442343", "l0.1489514,0.2453123", "l0.1509377,0.2468282", "l0.1563004,0.2484620", "l0.1621674,0.2490346", "l0.1660787,0.2471313", "l0.1682636,0.2443354", "l0.1691497,0.2423815", "l0.1694247,0.2412699", "l0.1690580,0.2401077", "l0.1692719,0.2387097", "l0.1707998,0.2376823", "l0.1720679,0.2372444", "l0.1735652,0.2389118", "l0.1996305,0.2446385", "l0.1998138,0.2449417", "l0.2014486,0.2469461", "l0.2018000,0.2477040", "l0.2019986,0.2490683", "l0.2025028,0.2506516", "l0.2030834,0.2520327", "l0.2035723,0.2528244", "l0.2030376,0.2533802", "l0.2029306,0.2540034", "l0.2032515,0.2557214", "l0.2031751,0.2562098", "l0.2029612,0.2566478", "l0.2027931,0.2571194", "l0.2028542,0.2576415", "l0.2030681,0.2577426", "l0.2039696,0.2578605", "l0.2049474,0.2618523", "l0.2049474,0.2690275", "l0.2038015,0.2741984", "l0.2017695,0.2765565", "l0.2009139,0.2790998", "l0.2016320,0.2809694", "l0.2158716,0.2905364", "l0.2168189,0.2915133", "l0.2178425,0.2934334", "l0.2183009,0.2949493", "c"]}, {"n": "Gilan", "u": "IR-19", "i": ["m0.2518526,0.0987761", "l0.2518526,0.0987761", "l0.2520054,0.1051766", "l0.2514095,0.1072988", "l0.2517762,0.1088484", "l0.2518832,0.1126886", "l0.2528610,0.1153667", "l0.2535791,0.1242431", "l0.2557181,0.1326816", "l0.2553056,0.1340796", "l0.2552597,0.1357133", "l0.2554889,0.1372798", "l0.2558862,0.1383914", "l0.2577043,0.1416759", "l0.2577196,0.1424338", "l0.2575668,0.1430738", "l0.2574904,0.1435960", "l0.2580252,0.1464256", "l0.2591099,0.1491374", "l0.2617226,0.1534830", "l0.2652061,0.1574916", "l0.2689952,0.1604897", "l0.2773373,0.1652901", "l0.2812180,0.1667217", "l0.3010955,0.1697030", "l0.3032345,0.1693324", "l0.3050068,0.1685408", "l0.3066721,0.1682039", "l0.3085208,0.1692482", "l0.3080319,0.1693493", "l0.3074513,0.1691640", "l0.3071458,0.1691135", "l0.3067485,0.1697030", "l0.3110571,0.1715557", "l0.3177949,0.1732738", "l0.3202242,0.1743012", "l0.3218590,0.1760192", "l0.3216451,0.1786131", "l0.3221035,0.1796068", "l0.3227757,0.1822007", "l0.3232494,0.1832450", "l0.3239980,0.1845250", "l0.3252203,0.1883990", "l0.3267635,0.1912286", "l0.3285816,0.1931488", "l0.3323096,0.1962648", "l0.3348764,0.1996840", "l0.3356556,0.2002061", "l0.3366640,0.2005261", "l0.3399183,0.2029684", "l0.3399183,0.2029684", "l0.3398877,0.2032042", "l0.3393836,0.2050233", "l0.3376112,0.2077182", "l0.3349222,0.2093183", "l0.3328443,0.2115921", "l0.3317137,0.2175041", "l0.3285358,0.2237529", "l0.3258467,0.2256899", "l0.3188186,0.2249151", "l0.3145253,0.2259762", "l0.3133794,0.2266500", "l0.3123099,0.2270542", "l0.3025928,0.2328820", "l0.3000260,0.2333873", "l0.2952438,0.2323261", "l0.2941284,0.2314840", "l0.2925395,0.2311808", "l0.2898963,0.2312987", "l0.2827917,0.2289575", "l0.2796443,0.2256899", "l0.2767261,0.2215970", "l0.2760692,0.2193232", "l0.2759775,0.2181273", "l0.2710731,0.2155166", "l0.2680174,0.2037937", "l0.2658172,0.1998692", "l0.2600725,0.1931825", "l0.2522804,0.1876916", "l0.2517151,0.1859230", "l0.2512720,0.1821670", "l0.2515012,0.1790341", "l0.2514554,0.1769793", "l0.2497136,0.1745370", "l0.2464135,0.1716568", "l0.2435564,0.1684061", "l0.2349698,0.1534830", "l0.2302182,0.1389472", "l0.2303251,0.1349891", "l0.2319752,0.1321594", "l0.2324336,0.1283192", "l0.2335031,0.1255232", "l0.2451912,0.1101790", "l0.2456495,0.1088484", "l0.2448550,0.1079052", "l0.2428994,0.1074167", "l0.2416465,0.1068609", "l0.2413562,0.1054966", "l0.2402867,0.1039470", "l0.2386367,0.1023301", "l0.2383311,0.1015721", "l0.2407145,0.1017911", "l0.2419674,0.1014037", "l0.2433577,0.1007468", "l0.2446717,0.0998373", "l0.2456954,0.0986919", "l0.2468565,0.0980013", "l0.2485066,0.0980013", "l0.2518526,0.0987761", "c"]}, {"n": "Kermanshah", "u": "IR-17", "i": ["m0.1355369,0.3528900", "l0.1355369,0.3528900", "l0.1367133,0.3527889", "l0.1369272,0.3542543", "l0.1365147,0.3562923", "l0.1365758,0.3590378", "l0.1382870,0.3611095", "l0.1413886,0.3607390", "l0.1460638,0.3613453", "l0.1495626,0.3607895", "l0.1515488,0.3596273", "l0.1517933,0.3573366", "l0.1528016,0.3558376", "l0.1544976,0.3555344", "l0.1555976,0.3541364", "l0.1555976,0.3521321", "l0.1562699,0.3505993", "l0.1584394,0.3497909", "l0.1615563,0.3462032", "l0.1647800,0.3458495", "l0.1668121,0.3460011", "l0.1678510,0.3453442", "l0.1681719,0.3408134", "l0.1687066,0.3394659", "l0.1761167,0.3389270", "l0.1778891,0.3371247", "l0.1780571,0.3347667", "l0.1771251,0.3326950", "l0.1776752,0.3313644", "l0.1791877,0.3314991", "l0.1812198,0.3334361", "l0.1871479,0.3364005", "l0.1950927,0.3463043", "l0.1973234,0.3466749", "l0.1989277,0.3466075", "l0.1989582,0.3476686", "l0.1986832,0.3496056", "l0.1969720,0.3517784", "l0.1949247,0.3568650", "l0.1924954,0.3608232", "l0.1873159,0.3614801", "l0.1856659,0.3622043", "l0.1849172,0.3632823", "l0.1854214,0.3660446", "l0.1880493,0.3684026", "l0.1918537,0.3706933", "l0.1935496,0.3710639", "l0.1949552,0.3718892", "l0.1957192,0.3747525", "l0.1970331,0.3769590", "l0.2014486,0.3718723", "l0.2038321,0.3707101", "l0.2050238,0.3704238", "l0.2060169,0.3720913", "l0.2065364,0.3749041", "l0.2059711,0.3794855", "l0.2060933,0.3827025", "l0.2045196,0.3841342", "l0.1987138,0.3827699", "l0.1935802,0.3831741", "l0.1916856,0.3863744", "l0.1907842,0.3883113", "l0.1872243,0.3877892", "l0.1857270,0.3882271", "l0.1847339,0.3889514", "l0.1845658,0.3905009", "l0.1850394,0.3942233", "l0.1847491,0.3980972", "l0.1822435,0.3995289", "l0.1785460,0.3997310", "l0.1755514,0.4013648", "l0.1752459,0.4023417", "l0.1753681,0.4030155", "l0.1756889,0.4034702", "l0.1760404,0.4038913", "l0.1763001,0.4044471", "l0.1763918,0.4052388", "l0.1762390,0.4065189", "l0.1763001,0.4072600", "l0.1764987,0.4077821", "l0.1757501,0.4091127", "l0.1748486,0.4098201", "l0.1739930,0.4095338", "l0.1722360,0.4093654", "l0.1639397,0.4114876", "l0.1639397,0.4135930", "l0.1653606,0.4159342", "l0.1661246,0.4176691", "l0.1654065,0.4221157", "l0.1643217,0.4244569", "l0.1562088,0.4240527", "l0.1474083,0.4265286", "l0.1413580,0.4259896", "l0.1283712,0.4213578", "l0.1245668,0.4177196", "l0.1210986,0.4153616", "l0.1169123,0.4143004", "l0.1127412,0.4139636", "l0.1049950,0.4104602", "l0.0969737,0.4115718", "l0.0939180,0.4114708", "l0.0929708,0.4127003", "l0.0936889,0.4153279", "l0.0931235,0.4197576", "l0.0911526,0.4265960", "l0.0900526,0.4365335", "l0.0888914,0.4376115", "l0.0887080,0.4370893", "l0.0862635,0.4351524", "l0.0854843,0.4342934", "l0.0847662,0.4331649", "l0.0842620,0.4320532", "l0.0838953,0.4308405", "l0.0836814,0.4294593", "l0.0832994,0.4283140", "l0.0826272,0.4274887", "l0.0818327,0.4267476", "l0.0811299,0.4259054", "l0.0765310,0.4166416", "l0.0764241,0.4165406", "l0.0763171,0.4164901", "l0.0761949,0.4164732", "l0.0746670,0.4167259", "l0.0733225,0.4166416", "l0.0721461,0.4159005", "l0.0710766,0.4142499", "l0.0721766,0.4136941", "l0.0726808,0.4133067", "l0.0731086,0.4128182", "l0.0731239,0.4128182", "l0.0731239,0.4128182", "l0.0739031,0.4108981", "l0.0743462,0.4091464", "l0.0749268,0.4076137", "l0.0761949,0.4064010", "l0.0769435,0.4054914", "l0.0790367,0.4036050", "l0.0795715,0.4028134", "l0.0795715,0.4020554", "l0.0792659,0.4014659", "l0.0788839,0.4008595", "l0.0786395,0.4000679", "l0.0787464,0.3994447", "l0.0794798,0.3981309", "l0.0797242,0.3975077", "l0.0804271,0.3941896", "l0.0805187,0.3924884", "l0.0802437,0.3909220", "l0.0794492,0.3895746", "l0.0783797,0.3888166", "l0.0772186,0.3888166", "l0.0761949,0.3897430", "l0.0752323,0.3889514", "l0.0745754,0.3874523", "l0.0729711,0.3817762", "l0.0734753,0.3808666", "l0.0761949,0.3801929", "l0.0765616,0.3798055", "l0.0768977,0.3793676", "l0.0772033,0.3788791", "l0.0774477,0.3783233", "l0.0775088,0.3762684", "l0.0770810,0.3734724", "l0.0772949,0.3715692", "l0.0793117,0.3722260", "l0.0810840,0.3732703", "l0.0826883,0.3736914", "l0.0862482,0.3739946", "l0.0873788,0.3744493", "l0.0876844,0.3743651", "l0.0878983,0.3739272", "l0.0880358,0.3731861", "l0.0880511,0.3724450", "l0.0878983,0.3719902", "l0.0873177,0.3710975", "l0.0871649,0.3699185", "l0.0871343,0.3686216", "l0.0869663,0.3673078", "l0.0867524,0.3668194", "l0.0864926,0.3664825", "l0.0862329,0.3660614", "l0.0860801,0.3653203", "l0.0858968,0.3647645", "l0.0855148,0.3642592", "l0.0850565,0.3638550", "l0.0846287,0.3635855", "l0.0838495,0.3626254", "l0.0842467,0.3614969", "l0.0856829,0.3596778", "l0.0858509,0.3588694", "l0.0857287,0.3574714", "l0.0858968,0.3566460", "l0.0864010,0.3558544", "l0.0870580,0.3555512", "l0.0885247,0.3553828", "l0.0899609,0.3542712", "l0.0902206,0.3525868", "l0.0901137,0.3508183", "l0.0904651,0.3494708", "l0.0916568,0.3494203", "l0.0925888,0.3499593", "l0.0931999,0.3503130", "l0.0945903,0.3508520", "l0.0953848,0.3496898", "l0.0957820,0.3479886", "l0.0962098,0.3467254", "l0.0963473,0.3454116", "l0.0958737,0.3436094", "l0.0958737,0.3436094", "l0.0957209,0.3426493", "l0.0957362,0.3417229", "l0.0959806,0.3409313", "l0.0965307,0.3403250", "l0.0968821,0.3402071", "l0.0976002,0.3401228", "l0.0979057,0.3399376", "l0.0980127,0.3396175", "l0.0978752,0.3387585", "l0.0979210,0.3384385", "l0.0986391,0.3371247", "l0.0990058,0.3369732", "l0.0997697,0.3372595", "l0.1008545,0.3380343", "l0.1013893,0.3382869", "l0.1020615,0.3382195", "l0.1036046,0.3389775", "l0.1044297,0.3387417", "l0.1051936,0.3379501", "l0.1065840,0.3370237", "l0.1071034,0.3369563", "l0.1080202,0.3372258", "l0.1093341,0.3367542", "l0.1099758,0.3366026", "l0.1105411,0.3362826", "l0.1109536,0.3354404", "l0.1098841,0.3340593", "l0.1105717,0.3320886", "l0.1117023,0.3299664", "l0.1118856,0.3281305", "l0.1111064,0.3274062", "l0.1091049,0.3274230", "l0.1083868,0.3268672", "l0.1082493,0.3257724", "l0.1087077,0.3248797", "l0.1093494,0.3240375", "l0.1096091,0.3233301", "l0.1110453,0.3238691", "l0.1208847,0.3324255", "l0.1333215,0.3511888", "l0.1355369,0.3528900", "c"]}, {"n": "East Azarbaijan", "u": "IR-01", "i": ["m0.1465985,0.0638433", "l0.1465985,0.0638433", "l0.1441998,0.0616705", "l0.1431303,0.0617547", "l0.1429928,0.0628664", "l0.1429622,0.0650055", "l0.1426108,0.0670435", "l0.1419080,0.0677341", "l0.1391426,0.0669930", "l0.1372175,0.0672288", "l0.1366980,0.0682730", "l0.1353077,0.0691657", "l0.1332298,0.0721975", "l0.1324048,0.0767620", "l0.1338715,0.0807539", "l0.1365147,0.0823540", "l0.1400593,0.0809560", "l0.1436039,0.0788337", "l0.1469958,0.0777726", "l0.1547420,0.0801980", "l0.1569116,0.0782611", "l0.1588672,0.0753135", "l0.1621063,0.0726186", "l0.1627480,0.0716922", "l0.1619688,0.0713722", "l0.1612660,0.0701763", "l0.1671941,0.0587735", "l0.1710901,0.0558596", "l0.1731985,0.0560617", "l0.1766821,0.0537542", "l0.1800281,0.0504529", "l0.1820754,0.0512951", "l0.1813573,0.0596493", "l0.1821518,0.0609294", "l0.1822893,0.0664540", "l0.1852839,0.0747072", "l0.1847339,0.0795917", "l0.1828240,0.0824382", "l0.1828546,0.0844762", "l0.1855742,0.0861774", "l0.1865520,0.0897482", "l0.1840310,0.0916514", "l0.1803184,0.0909946", "l0.1768043,0.0921399", "l0.1746347,0.0947338", "l0.1704942,0.0980687", "l0.1688594,0.1014542", "l0.1675455,0.1033407", "l0.1664912,0.1060019", "l0.1662468,0.1097242", "l0.1668579,0.1119812", "l0.1693483,0.1109033", "l0.1726485,0.1104653", "l0.1742833,0.1122170", "l0.1750014,0.1128065", "l0.1765140,0.1131097", "l0.1881410,0.1112233", "l0.1917467,0.1132108", "l0.1932899,0.1185332", "l0.1936107,0.1242936", "l0.1962233,0.1314352", "l0.2003027,0.1375998", "l0.2037710,0.1411200", "l0.2043057,0.1424170", "l0.2037862,0.1444213", "l0.2026098,0.1471667", "l0.2021514,0.1537356", "l0.2036946,0.1616182", "l0.2087518,0.1650711", "l0.2090726,0.1648521", "l0.2102338,0.1651048", "l0.2140382,0.1672944", "l0.2154132,0.1686250", "l0.2158258,0.1738296", "l0.2171703,0.1773330", "l0.2203482,0.1796573", "l0.2214483,0.1809037", "l0.2238012,0.1830260", "l0.2236637,0.1834134", "l0.2234039,0.1844914", "l0.2238012,0.1844914", "l0.2242595,0.1838682", "l0.2250387,0.1835650", "l0.2267958,0.1834639", "l0.2275444,0.1839018", "l0.2282778,0.1855356", "l0.2287361,0.1854683", "l0.2294542,0.1858893", "l0.2301723,0.1861757", "l0.2295765,0.1865631", "l0.2277583,0.1881632", "l0.2239081,0.1898307", "l0.2115325,0.1884158", "l0.2081712,0.1890222", "l0.2032668,0.1881969", "l0.1869951,0.1902854", "l0.1851617,0.1911276", "l0.1833741,0.1923066", "l0.1805475,0.1956921", "l0.1771251,0.1974943", "l0.1755820,0.1987407", "l0.1734124,0.2027326", "l0.1655745,0.2115247", "l0.1645814,0.2137649", "l0.1645967,0.2172178", "l0.1649023,0.2195253", "l0.1526183,0.2210917", "l0.1475764,0.2203338", "l0.1457124,0.2173525", "l0.1457582,0.2126027", "l0.1437109,0.2060002", "l0.1443832,0.2049390", "l0.1441540,0.2034231", "l0.1425192,0.2018736", "l0.1398913,0.2012167", "l0.1378286,0.1998187", "l0.1361938,0.1979828", "l0.1337951,0.1975449", "l0.1316255,0.1991281", "l0.1302046,0.2006103", "l0.1289518,0.2004756", "l0.1263850,0.2010651", "l0.1232834,0.2033052", "l0.1215875,0.2056296", "l0.1208236,0.2076340", "l0.1206555,0.2082740", "l0.1198152,0.2097562", "l0.1182874,0.2109184", "l0.1158886,0.2098067", "l0.1136579,0.2075161", "l0.1072257,0.2035074", "l0.1063548,0.2015872", "l0.0991739,0.1943783", "l0.0936430,0.1942773", "l0.0869204,0.1929635", "l0.0718099,0.1820154", "l0.0698543,0.1787647", "l0.0691515,0.1749076", "l0.0697321,0.1659806", "l0.0684487,0.1626962", "l0.0649804,0.1580812", "l0.0646443,0.1567674", "l0.0639415,0.1553357", "l0.0635442,0.1542072", "l0.0637581,0.1533987", "l0.0642470,0.1529440", "l0.0647360,0.1526408", "l0.0649651,0.1522534", "l0.0645526,0.1479247", "l0.0644762,0.1476215", "l0.0642470,0.1470488", "l0.0632081,0.1454993", "l0.0613900,0.1259948", "l0.0614205,0.1235862", "l0.0615886,0.1232157", "l0.0617872,0.1228620", "l0.0617108,0.1220703", "l0.0613900,0.1207734", "l0.0610538,0.1201839", "l0.0606413,0.1197965", "l0.0603357,0.1192575", "l0.0603357,0.1182638", "l0.0599843,0.1182638", "l0.0566994,0.1133455", "l0.0560119,0.1109201", "l0.0565772,0.1077704", "l0.0594954,0.1023301", "l0.0683723,0.0921736", "l0.0703126,0.0882996", "l0.0703279,0.0846783", "l0.0690140,0.0808212", "l0.0682959,0.0766441", "l0.0698084,0.0688794", "l0.0709391,0.0658308", "l0.0766532,0.0590935", "l0.0769741,0.0587398", "l0.0777991,0.0589756", "l0.0788534,0.0596661", "l0.0790978,0.0597167", "l0.0794951,0.0598177", "l0.0809312,0.0598683", "l0.0838800,0.0606767", "l0.0884789,0.0607273", "l0.0911373,0.0618726", "l0.0923291,0.0623779", "l0.1032227,0.0649212", "l0.1066451,0.0666392", "l0.1096550,0.0674814", "l0.1101592,0.0673972", "l0.1136121,0.0668919", "l0.1145135,0.0664203", "l0.1172026,0.0642643", "l0.1182110,0.0637254", "l0.1188832,0.0635401", "l0.1209000,0.0634559", "l0.1221528,0.0630011", "l0.1227029,0.0629337", "l0.1234057,0.0631022", "l0.1287990,0.0657634", "l0.1297310,0.0660497", "l0.1306630,0.0659824", "l0.1317783,0.0654771", "l0.1326187,0.0649044", "l0.1334131,0.0641801", "l0.1341312,0.0632874", "l0.1347271,0.0622432", "l0.1361938,0.0589082", "l0.1368814,0.0579144", "l0.1378134,0.0570386", "l0.1408232,0.0553543", "l0.1416636,0.0544447", "l0.1425344,0.0522214", "l0.1431609,0.0511266", "l0.1435734,0.0507729", "l0.1444290,0.0502508", "l0.1448415,0.0498802", "l0.1451318,0.0494255", "l0.1464610,0.0468821", "l0.1471639,0.0459726", "l0.1479431,0.0452483", "l0.1479583,0.0452483", "l0.1488139,0.0448104", "l0.1496390,0.0447767", "l0.1510752,0.0455010", "l0.1518544,0.0457368", "l0.1524808,0.0456020", "l0.1555823,0.0436651", "l0.1559796,0.0451136", "l0.1561629,0.0452652", "l0.1562240,0.0460231", "l0.1569421,0.0469158", "l0.1585311,0.0477748", "l0.1592950,0.0492570", "l0.1602576,0.0537373", "l0.1600590,0.0552027", "l0.1597076,0.0565333", "l0.1586533,0.0581503", "l0.1541614,0.0615526", "l0.1509377,0.0620410", "l0.1488598,0.0633717", "l0.1465985,0.0638433", "c"]}, {"n": "West Azarbaijan", "u": "IR-02", "i": ["m0.0414056,0.0102313", "l0.0414056,0.0102313", "l0.0415431,0.0104334", "l0.0422765,0.0109218", "l0.0424904,0.0110397", "l0.0435904,0.0112755", "l0.0447821,0.0113261", "l0.0446294,0.0116629", "l0.0444307,0.0118819", "l0.0455155,0.0127409", "l0.0461419,0.0143410", "l0.0476851,0.0214488", "l0.0483268,0.0229311", "l0.0494116,0.0239922", "l0.0489838,0.0248849", "l0.0491671,0.0254239", "l0.0504811,0.0264681", "l0.0507561,0.0265355", "l0.0513214,0.0265187", "l0.0517186,0.0266366", "l0.0519020,0.0269229", "l0.0520242,0.0272598", "l0.0522075,0.0275293", "l0.0540410,0.0289104", "l0.0540715,0.0289272", "l0.0543465,0.0293146", "l0.0545146,0.0298368", "l0.0549424,0.0306116", "l0.0554619,0.0313021", "l0.0559508,0.0316053", "l0.0563633,0.0323127", "l0.0573106,0.0346539", "l0.0576161,0.0354119", "l0.0580592,0.0361361", "l0.0584259,0.0369278", "l0.0589607,0.0405996", "l0.0592968,0.0417113", "l0.0606566,0.0412396", "l0.0660346,0.0432103", "l0.0661721,0.0430756", "l0.0665388,0.0428061", "l0.0669972,0.0426039", "l0.0674861,0.0426713", "l0.0676389,0.0431261", "l0.0675014,0.0438167", "l0.0674861,0.0444567", "l0.0680056,0.0447262", "l0.0687237,0.0448778", "l0.0694112,0.0453662", "l0.0697015,0.0461410", "l0.0692584,0.0472358", "l0.0696098,0.0479769", "l0.0700529,0.0483475", "l0.0705265,0.0486675", "l0.0710155,0.0492402", "l0.0712294,0.0498129", "l0.0716419,0.0513961", "l0.0719016,0.0520193", "l0.0723905,0.0524236", "l0.0736281,0.0530299", "l0.0738725,0.0535352", "l0.0737656,0.0542932", "l0.0735517,0.0548995", "l0.0733989,0.0555227", "l0.0734906,0.0563143", "l0.0740864,0.0570891", "l0.0751865,0.0579144", "l0.0763630,0.0585545", "l0.0769741,0.0587398", "l0.0766532,0.0590935", "l0.0709391,0.0658308", "l0.0698084,0.0688794", "l0.0682959,0.0766441", "l0.0690140,0.0808212", "l0.0703279,0.0846783", "l0.0703126,0.0882996", "l0.0683723,0.0921736", "l0.0594954,0.1023301", "l0.0565772,0.1077704", "l0.0560119,0.1109201", "l0.0566994,0.1133455", "l0.0599843,0.1182638", "l0.0603357,0.1182638", "l0.0603357,0.1192575", "l0.0606413,0.1197965", "l0.0610538,0.1201839", "l0.0613900,0.1207734", "l0.0617108,0.1220703", "l0.0617872,0.1228620", "l0.0615886,0.1232157", "l0.0614205,0.1235862", "l0.0613900,0.1259948", "l0.0632081,0.1454993", "l0.0642470,0.1470488", "l0.0644762,0.1476215", "l0.0645526,0.1479247", "l0.0649651,0.1522534", "l0.0647360,0.1526408", "l0.0642470,0.1529440", "l0.0637581,0.1533987", "l0.0635442,0.1542072", "l0.0639415,0.1553357", "l0.0646443,0.1567674", "l0.0649804,0.1580812", "l0.0684487,0.1626962", "l0.0697321,0.1659806", "l0.0691515,0.1749076", "l0.0698543,0.1787647", "l0.0718099,0.1820154", "l0.0869204,0.1929635", "l0.0936430,0.1942773", "l0.0991739,0.1943783", "l0.1063548,0.2015872", "l0.1072257,0.2035074", "l0.1136579,0.2075161", "l0.1158886,0.2098067", "l0.1182874,0.2109184", "l0.1198152,0.2097562", "l0.1206555,0.2082740", "l0.1208236,0.2076340", "l0.1215875,0.2056296", "l0.1232834,0.2033052", "l0.1263850,0.2010651", "l0.1289518,0.2004756", "l0.1302046,0.2006103", "l0.1316255,0.1991281", "l0.1337951,0.1975449", "l0.1361938,0.1979828", "l0.1378286,0.1998187", "l0.1398913,0.2012167", "l0.1425192,0.2018736", "l0.1441540,0.2034231", "l0.1443832,0.2049390", "l0.1437109,0.2060002", "l0.1457582,0.2126027", "l0.1457124,0.2173525", "l0.1475764,0.2203338", "l0.1526183,0.2210917", "l0.1649023,0.2195253", "l0.1720679,0.2372444", "l0.1707998,0.2376823", "l0.1692719,0.2387097", "l0.1690580,0.2401077", "l0.1694247,0.2412699", "l0.1691497,0.2423815", "l0.1682636,0.2443354", "l0.1660787,0.2471313", "l0.1621674,0.2490346", "l0.1563004,0.2484620", "l0.1509377,0.2468282", "l0.1489514,0.2453123", "l0.1480653,0.2442343", "l0.1470263,0.2432742", "l0.1462930,0.2421963", "l0.1459263,0.2413373", "l0.1453151,0.2407814", "l0.1185471,0.2435100", "l0.1055297,0.2414552", "l0.1010073,0.2434427", "l0.0998614,0.2450765", "l0.0997850,0.2484956", "l0.0972946,0.2526728", "l0.0888761,0.2556709", "l0.0873177,0.2575405", "l0.0867218,0.2586690", "l0.0855759,0.2599659", "l0.0848731,0.2634019", "l0.0820007,0.2670064", "l0.0811451,0.2693139", "l0.0791131,0.2715540", "l0.0773713,0.2727331", "l0.0773408,0.2727667", "l0.0773408,0.2727667", "l0.0761949,0.2722951", "l0.0748351,0.2723288", "l0.0731239,0.2732720", "l0.0722072,0.2735584", "l0.0721919,0.2735584", "l0.0721919,0.2735752", "l0.0721766,0.2735752", "l0.0721766,0.2735752", "l0.0711530,0.2743500", "l0.0699918,0.2747711", "l0.0688917,0.2746027", "l0.0679750,0.2735752", "l0.0679597,0.2735752", "l0.0679597,0.2735584", "l0.0679597,0.2735584", "l0.0679597,0.2735584", "l0.0676236,0.2724130", "l0.0679292,0.2709645", "l0.0685709,0.2695160", "l0.0691973,0.2683875", "l0.0694112,0.2669727", "l0.0687542,0.2655410", "l0.0671500,0.2632335", "l0.0668902,0.2617513", "l0.0670125,0.2585005", "l0.0667833,0.2571362", "l0.0660194,0.2563109", "l0.0650568,0.2554856", "l0.0647665,0.2546266", "l0.0660194,0.2537339", "l0.0650415,0.2523527", "l0.0646901,0.2511232", "l0.0645526,0.2480746", "l0.0643082,0.2464408", "l0.0637581,0.2446554", "l0.0628414,0.2433921", "l0.0615275,0.2432911", "l0.0586398,0.2445543", "l0.0571272,0.2446891", "l0.0557216,0.2439648", "l0.0551257,0.2432069", "l0.0549424,0.2425668", "l0.0548507,0.2418763", "l0.0546063,0.2409499", "l0.0541937,0.2402761", "l0.0537507,0.2397877", "l0.0534145,0.2392150", "l0.0533687,0.2382044", "l0.0526964,0.2374128", "l0.0518867,0.2366380", "l0.0517033,0.2364527", "l0.0509547,0.2353916", "l0.0510464,0.2342631", "l0.0512755,0.2340778", "l0.0519172,0.2338083", "l0.0520853,0.2336736", "l0.0521311,0.2321745", "l0.0526812,0.2297491", "l0.0536896,0.2271721", "l0.0537659,0.2258415", "l0.0532159,0.2243088", "l0.0519631,0.2217486", "l0.0511991,0.2206032", "l0.0503283,0.2200811", "l0.0496560,0.2200643", "l0.0490449,0.2198453", "l0.0485101,0.2194242", "l0.0480365,0.2188010", "l0.0473948,0.2181778", "l0.0466461,0.2180262", "l0.0450419,0.2181273", "l0.0436974,0.2177904", "l0.0426584,0.2170325", "l0.0422612,0.2157861", "l0.0428112,0.2140344", "l0.0446446,0.2115416", "l0.0453627,0.2102615", "l0.0456377,0.2085435", "l0.0453933,0.2069434", "l0.0449197,0.2057812", "l0.0446294,0.2045180", "l0.0449197,0.2026147", "l0.0454850,0.2018230", "l0.0455614,0.2010483", "l0.0452252,0.2004082", "l0.0440946,0.1997513", "l0.0434987,0.1990439", "l0.0431473,0.1988249", "l0.0426431,0.1988418", "l0.0416195,0.1991955", "l0.0411458,0.1990776", "l0.0409014,0.1987239", "l0.0406417,0.1976291", "l0.0404430,0.1971743", "l0.0400611,0.1968711", "l0.0396791,0.1967364", "l0.0393124,0.1965511", "l0.0390068,0.1960627", "l0.0385943,0.1947994", "l0.0385943,0.1941088", "l0.0392971,0.1920371", "l0.0396180,0.1906560", "l0.0392971,0.1894433", "l0.0388082,0.1882306", "l0.0386402,0.1867820", "l0.0390068,0.1855019", "l0.0396485,0.1848956", "l0.0403666,0.1844408", "l0.0409625,0.1835650", "l0.0411306,0.1812406", "l0.0399541,0.1797247", "l0.0369748,0.1776193", "l0.0365470,0.1766424", "l0.0362414,0.1756318", "l0.0357678,0.1749749", "l0.0338885,0.1752949", "l0.0333996,0.1746886", "l0.0326662,0.1726337", "l0.0318718,0.1719768", "l0.0299467,0.1717747", "l0.0292591,0.1713368", "l0.0289383,0.1701578", "l0.0296258,0.1680187", "l0.0294119,0.1668060", "l0.0294119,0.1667891", "l0.0291369,0.1653238", "l0.0292438,0.1635384", "l0.0295800,0.1617698", "l0.0300536,0.1603213", "l0.0298397,0.1590918", "l0.0286785,0.1581148", "l0.0276396,0.1568011", "l0.0278688,0.1546283", "l0.0282966,0.1539883", "l0.0300842,0.1523881", "l0.0306189,0.1514618", "l0.0304967,0.1507880", "l0.0286021,0.1482110", "l0.0273035,0.1469646", "l0.0258520,0.1462404", "l0.0244464,0.1464088", "l0.0237894,0.1468299", "l0.0229643,0.1471499", "l0.0222310,0.1470657", "l0.0218490,0.1462572", "l0.0218948,0.1458193", "l0.0220935,0.1446739", "l0.0220629,0.1443034", "l0.0216657,0.1439665", "l0.0213295,0.1440507", "l0.0209781,0.1441855", "l0.0205809,0.1440507", "l0.0200003,0.1432254", "l0.0197100,0.1423327", "l0.0195114,0.1415074", "l0.0192058,0.1408337", "l0.0186558,0.1403958", "l0.0167918,0.1394020", "l0.0161654,0.1391999", "l0.0128194,0.1396378", "l0.0110165,0.1393010", "l0.0101151,0.1377345", "l0.0102526,0.1371787", "l0.0103290,0.1369261", "l0.0108637,0.1361850", "l0.0113221,0.1354102", "l0.0112762,0.1344838", "l0.0110165,0.1334732", "l0.0111082,0.1325468", "l0.0114290,0.1316710", "l0.0118721,0.1307446", "l0.0118721,0.1307278", "l0.0118721,0.1307278", "l0.0118721,0.1307278", "l0.0123457,0.1296835", "l0.0135986,0.1281170", "l0.0140569,0.1270054", "l0.0144847,0.1254895", "l0.0149584,0.1245631", "l0.0156459,0.1239736", "l0.0166390,0.1234346", "l0.0169293,0.1229799", "l0.0165015,0.1216156", "l0.0165779,0.1209924", "l0.0170057,0.1205713", "l0.0179224,0.1201502", "l0.0183044,0.1195775", "l0.0186405,0.1185164", "l0.0189614,0.1170847", "l0.0191447,0.1156867", "l0.0189155,0.1122002", "l0.0203823,0.1103643", "l0.0222463,0.1087473", "l0.0234074,0.1068946", "l0.0233921,0.1057492", "l0.0229949,0.1046039", "l0.0223532,0.1036101", "l0.0216198,0.1029196", "l0.0208101,0.1025827", "l0.0201531,0.1027343", "l0.0184572,0.1038291", "l0.0158751,0.1033070", "l0.0151112,0.1029196", "l0.0146375,0.1025490", "l0.0144847,0.1019090", "l0.0146528,0.1007131", "l0.0146834,0.1000562", "l0.0145153,0.0982035", "l0.0145306,0.0973445", "l0.0151876,0.0944137", "l0.0152487,0.0931505", "l0.0147750,0.0894450", "l0.0150042,0.0865648", "l0.0150195,0.0850489", "l0.0146528,0.0838362", "l0.0142708,0.0833646", "l0.0138736,0.0830782", "l0.0129416,0.0827414", "l0.0122999,0.0823708", "l0.0124527,0.0819329", "l0.0128958,0.0814276", "l0.0131249,0.0808886", "l0.0128652,0.0795748", "l0.0126208,0.0786990", "l0.0125138,0.0777895", "l0.0127277,0.0763241", "l0.0141333,0.0710185", "l0.0138736,0.0688794", "l0.0111387,0.0674140", "l0.0102984,0.0665213", "l0.0095956,0.0654097", "l0.0090914,0.0637759", "l0.0088775,0.0632201", "l0.0086942,0.0626642", "l0.0087247,0.0620410", "l0.0086942,0.0613842", "l0.0082969,0.0609294", "l0.0078233,0.0605252", "l0.0075177,0.0600030", "l0.0073038,0.0588745", "l0.0071357,0.0583692", "l0.0068607,0.0578639", "l0.0068607,0.0578471", "l0.0075941,0.0564828", "l0.0084191,0.0557080", "l0.0089233,0.0548321", "l0.0084497,0.0519519", "l0.0087094,0.0507729", "l0.0097331,0.0485496", "l0.0093053,0.0467474", "l0.0073191,0.0451810", "l0.0050120,0.0438335", "l0.0036675,0.0427050", "l0.0036064,0.0420650", "l0.0039731,0.0407344", "l0.0039272,0.0400775", "l0.0033008,0.0386121", "l0.0031328,0.0379889", "l0.0031022,0.0373320", "l0.0032397,0.0368436", "l0.0032397,0.0363046", "l0.0026286,0.0348392", "l0.0023230,0.0332728", "l0.0021091,0.0325654", "l0.0020938,0.0325485", "l0.0007340,0.0307632", "l0.0004285,0.0298705", "l0.0009938,0.0289778", "l0.0020480,0.0282535", "l0.0028272,0.0279335", "l0.0036370,0.0279166", "l0.0047828,0.0280682", "l0.0059746,0.0279335", "l0.0087858,0.0271082", "l0.0100234,0.0272598", "l0.0135986,0.0292304", "l0.0149125,0.0293483", "l0.0160584,0.0290451", "l0.0187322,0.0276977", "l0.0197253,0.0268892", "l0.0205962,0.0254239", "l0.0206114,0.0240932", "l0.0204434,0.0226952", "l0.0206878,0.0210446", "l0.0206878,0.0210446", "l0.0207031,0.0210446", "l0.0212226,0.0201688", "l0.0212531,0.0192761", "l0.0210698,0.0183328", "l0.0209781,0.0172886", "l0.0210698,0.0160759", "l0.0213143,0.0150821", "l0.0230255,0.0112587", "l0.0233310,0.0103155", "l0.0233616,0.0100291", "l0.0234685,0.0091364", "l0.0231935,0.0067279", "l0.0234227,0.0058857", "l0.0289230,0.0008833", "l0.0302064,0.0004622", "l0.0310009,0.0010854", "l0.0323912,0.0034266", "l0.0331093,0.0043193", "l0.0361956,0.0059194", "l0.0372040,0.0068626", "l0.0414056,0.0102313", "c"]}, {"n": "Qazvin", "u": "IR-28", "i": ["m0.2898963,0.2312987", "l0.2898963,0.2312987", "l0.2925395,0.2311808", "l0.2941284,0.2314840", "l0.2952438,0.2323261", "l0.3000260,0.2333873", "l0.3025928,0.2328820", "l0.3123099,0.2270542", "l0.3133794,0.2266500", "l0.3145253,0.2259762", "l0.3188186,0.2249151", "l0.3258467,0.2256899", "l0.3396433,0.2385244", "l0.3425004,0.2402425", "l0.3508883,0.2472998", "l0.3514842,0.2492199", "l0.3515453,0.2506347", "l0.3392308,0.2491862", "l0.3333638,0.2497084", "l0.3318665,0.2522180", "l0.3345097,0.2562267", "l0.3364195,0.2580289", "l0.3400864,0.2592416", "l0.3424851,0.2615155", "l0.3408503,0.2676127", "l0.3383599,0.2733226", "l0.3377487,0.2759164", "l0.3359764,0.2777860", "l0.3254953,0.2834285", "l0.3226535,0.2864603", "l0.3220118,0.2892057", "l0.3224396,0.2913785", "l0.3237536,0.2946124", "l0.3248689,0.2966504", "l0.3233258,0.2963978", "l0.3202395,0.2965999", "l0.3109654,0.3010634", "l0.3085820,0.3012150", "l0.3057249,0.3021245", "l0.3030511,0.3035899", "l0.2939451,0.3066553", "l0.2917755,0.3084407", "l0.2902171,0.3123820", "l0.2811416,0.3126515", "l0.2798735,0.3116746", "l0.2725245,0.3096197", "l0.2710731,0.3100408", "l0.2644422,0.3087944", "l0.2609128,0.3058132", "l0.2624865,0.3031688", "l0.2605156,0.3004402", "l0.2562070,0.2977116", "l0.2505539,0.2975937", "l0.2481399,0.2987727", "l0.2442897,0.2925239", "l0.2377199,0.2859887", "l0.2375672,0.2837991", "l0.2386519,0.2830074", "l0.2402715,0.2826032", "l0.2424869,0.2825190", "l0.2443661,0.2820979", "l0.2472538,0.2797398", "l0.2519443,0.2783082", "l0.2553361,0.2785608", "l0.2600572,0.2809694", "l0.2599808,0.2801946", "l0.2602558,0.2773986", "l0.2634185,0.2734405", "l0.2686438,0.2701729", "l0.2780859,0.2673601", "l0.2792777,0.2654399", "l0.2784526,0.2579447", "l0.2772609,0.2550140", "l0.2756414,0.2520496", "l0.2747858,0.2485462", "l0.2738232,0.2466092", "l0.2724787,0.2457670", "l0.2715009,0.2446049", "l0.2705078,0.2439985", "l0.2689341,0.2438806", "l0.2663673,0.2424658", "l0.2646408,0.2395856", "l0.2629754,0.2349705", "l0.2601947,0.2311471", "l0.2591252,0.2266500", "l0.2612337,0.2212601", "l0.2668562,0.2171167", "l0.2710731,0.2155166", "l0.2759775,0.2181273", "l0.2760692,0.2193232", "l0.2767261,0.2215970", "l0.2796443,0.2256899", "l0.2827917,0.2289575", "l0.2898963,0.2312987", "c"]}, {"n": "Zanjan", "u": "IR-11", "i": ["m0.2522804,0.1876916", "l0.2522804,0.1876916", "l0.2600725,0.1931825", "l0.2658172,0.1998692", "l0.2680174,0.2037937", "l0.2710731,0.2155166", "l0.2668562,0.2171167", "l0.2612337,0.2212601", "l0.2591252,0.2266500", "l0.2601947,0.2311471", "l0.2629754,0.2349705", "l0.2646408,0.2395856", "l0.2663673,0.2424658", "l0.2689341,0.2438806", "l0.2705078,0.2439985", "l0.2715009,0.2446049", "l0.2724787,0.2457670", "l0.2738232,0.2466092", "l0.2747858,0.2485462", "l0.2756414,0.2520496", "l0.2772609,0.2550140", "l0.2784526,0.2579447", "l0.2792777,0.2654399", "l0.2780859,0.2673601", "l0.2686438,0.2701729", "l0.2634185,0.2734405", "l0.2602558,0.2773986", "l0.2599808,0.2801946", "l0.2600572,0.2809694", "l0.2553361,0.2785608", "l0.2519443,0.2783082", "l0.2472538,0.2797398", "l0.2443661,0.2820979", "l0.2424869,0.2825190", "l0.2402715,0.2826032", "l0.2386519,0.2830074", "l0.2375672,0.2837991", "l0.2377199,0.2859887", "l0.2442897,0.2925239", "l0.2481399,0.2987727", "l0.2481705,0.3000023", "l0.2462759,0.3028656", "l0.2423646,0.3043815", "l0.2380102,0.3032025", "l0.2334725,0.3004739", "l0.2223650,0.3000528", "l0.2200426,0.2984527", "l0.2183009,0.2949493", "l0.2178425,0.2934334", "l0.2168189,0.2915133", "l0.2158716,0.2905364", "l0.2016320,0.2809694", "l0.2009139,0.2790998", "l0.2017695,0.2765565", "l0.2038015,0.2741984", "l0.2049474,0.2690275", "l0.2049474,0.2618523", "l0.2039696,0.2578605", "l0.2030681,0.2577426", "l0.2028542,0.2576415", "l0.2027931,0.2571194", "l0.2029612,0.2566478", "l0.2031751,0.2562098", "l0.2032515,0.2557214", "l0.2029306,0.2540034", "l0.2030376,0.2533802", "l0.2035723,0.2528244", "l0.2030834,0.2520327", "l0.2025028,0.2506516", "l0.2019986,0.2490683", "l0.2018000,0.2477040", "l0.2014486,0.2469461", "l0.1998138,0.2449417", "l0.1996305,0.2446385", "l0.1735652,0.2389118", "l0.1720679,0.2372444", "l0.1649023,0.2195253", "l0.1645967,0.2172178", "l0.1645814,0.2137649", "l0.1655745,0.2115247", "l0.1734124,0.2027326", "l0.1755820,0.1987407", "l0.1771251,0.1974943", "l0.1805475,0.1956921", "l0.1833741,0.1923066", "l0.1851617,0.1911276", "l0.1869951,0.1902854", "l0.2032668,0.1881969", "l0.2081712,0.1890222", "l0.2115325,0.1884158", "l0.2239081,0.1898307", "l0.2277583,0.1881632", "l0.2295765,0.1865631", "l0.2301723,0.1861757", "l0.2316849,0.1857209", "l0.2338086,0.1865799", "l0.2376741,0.1911276", "l0.2392784,0.1907570", "l0.2399659,0.1894770", "l0.2399659,0.1882642", "l0.2405923,0.1870347", "l0.2415854,0.1865968", "l0.2430674,0.1875231", "l0.2449314,0.1877926", "l0.2469788,0.1862430", "l0.2487969,0.1856367", "l0.2522804,0.1876916", "c"]}, {"n": "Hamadan", "u": "IR-24", "i": ["m0.2183009,0.2949493", "l0.2183009,0.2949493", "l0.2200426,0.2984527", "l0.2223650,0.3000528", "l0.2334725,0.3004739", "l0.2380102,0.3032025", "l0.2423646,0.3043815", "l0.2462759,0.3028656", "l0.2481705,0.3000023", "l0.2481399,0.2987727", "l0.2505539,0.2975937", "l0.2562070,0.2977116", "l0.2605156,0.3004402", "l0.2624865,0.3031688", "l0.2609128,0.3058132", "l0.2644422,0.3087944", "l0.2710731,0.3100408", "l0.2725245,0.3096197", "l0.2798735,0.3116746", "l0.2811416,0.3126515", "l0.2811111,0.3143190", "l0.2815542,0.3168118", "l0.2827765,0.3185972", "l0.2825778,0.3212753", "l0.2808361,0.3234143", "l0.2790638,0.3230606", "l0.2780554,0.3214605", "l0.2781165,0.3196920", "l0.2779943,0.3183782", "l0.2765886,0.3184961", "l0.2749691,0.3207700", "l0.2759469,0.3254524", "l0.2782540,0.3296969", "l0.2788957,0.3329139", "l0.2764053,0.3361310", "l0.2734260,0.3371584", "l0.2718523,0.3373437", "l0.2709203,0.3385059", "l0.2710578,0.3394996", "l0.2722495,0.3407797", "l0.2745719,0.3420935", "l0.2801333,0.3437778", "l0.2827765,0.3451926", "l0.2852669,0.3484434", "l0.2865655,0.3518963", "l0.2876809,0.3593747", "l0.2864280,0.3621875", "l0.2841515,0.3619517", "l0.2824862,0.3602505", "l0.2804388,0.3575724", "l0.2796596,0.3544059", "l0.2807597,0.3518289", "l0.2795068,0.3498245", "l0.2750302,0.3489655", "l0.2656186,0.3495214", "l0.2643199,0.3516941", "l0.2649005,0.3557365", "l0.2642894,0.3581956", "l0.2629143,0.3606716", "l0.2627310,0.3655393", "l0.2636171,0.3708954", "l0.2624560,0.3711986", "l0.2600572,0.3699185", "l0.2547250,0.3693122", "l0.2529221,0.3701038", "l0.2536708,0.3720576", "l0.2562834,0.3732029", "l0.2571696,0.3775653", "l0.2575821,0.3848585", "l0.2612489,0.3928253", "l0.2620740,0.3965982", "l0.2623643,0.4003711", "l0.2633116,0.4048177", "l0.2631588,0.4064346", "l0.2622421,0.4078158", "l0.2568487,0.4131719", "l0.2427313,0.4065189", "l0.2393395,0.4069399", "l0.2365893,0.4067547", "l0.2352448,0.4071589", "l0.2325252,0.4102581", "l0.2309821,0.4106960", "l0.2290723,0.4099044", "l0.2175828,0.4083716", "l0.1953677,0.3922526", "l0.1942982,0.3905346", "l0.1920829,0.3889514", "l0.1907842,0.3883113", "l0.1916856,0.3863744", "l0.1935802,0.3831741", "l0.1987138,0.3827699", "l0.2045196,0.3841342", "l0.2060933,0.3827025", "l0.2059711,0.3794855", "l0.2065364,0.3749041", "l0.2060169,0.3720913", "l0.2050238,0.3704238", "l0.2038321,0.3707101", "l0.2014486,0.3718723", "l0.1970331,0.3769590", "l0.1957192,0.3747525", "l0.1949552,0.3718892", "l0.1935496,0.3710639", "l0.1918537,0.3706933", "l0.1880493,0.3684026", "l0.1854214,0.3660446", "l0.1849172,0.3632823", "l0.1856659,0.3622043", "l0.1873159,0.3614801", "l0.1924954,0.3608232", "l0.1949247,0.3568650", "l0.1969720,0.3517784", "l0.1986832,0.3496056", "l0.1989582,0.3476686", "l0.1989277,0.3466075", "l0.2005013,0.3456643", "l0.2036793,0.3446705", "l0.2055586,0.3435420", "l0.2061391,0.3415882", "l0.2071017,0.3413187", "l0.2087671,0.3458327", "l0.2098824,0.3464896", "l0.2116089,0.3448221", "l0.2134270,0.3416050", "l0.2144507,0.3364005", "l0.2130298,0.3299495", "l0.2100810,0.3267156", "l0.2079573,0.3252503", "l0.2054210,0.3218311", "l0.1998444,0.3080702", "l0.1962386,0.3021750", "l0.1970484,0.3004065", "l0.1997527,0.2970547", "l0.2009444,0.2969199", "l0.2033890,0.3025287", "l0.2049932,0.3030172", "l0.2066892,0.3021750", "l0.2081712,0.3005749", "l0.2118533,0.2991938", "l0.2118686,0.2974252", "l0.2112575,0.2959262", "l0.2097296,0.2937366", "l0.2088129,0.2909237", "l0.2106769,0.2903511", "l0.2183009,0.2949493", "c"]}, {"n": "Qom", "u": "IR-26", "i": ["m0.4074954,0.3518794", "l0.4074954,0.3518794", "l0.4081830,0.3546585", "l0.4080455,0.3603179", "l0.4066551,0.3663983", "l0.4043786,0.3722934", "l0.4026521,0.3750220", "l0.3852040,0.3800245", "l0.3812010,0.3797887", "l0.3700324,0.3812035", "l0.3650974,0.3835784", "l0.3631570,0.3857343", "l0.3625459,0.3877555", "l0.3609875,0.4012975", "l0.3620722,0.4042787", "l0.3635390,0.4051377", "l0.3516064,0.4015501", "l0.3462742,0.3983162", "l0.3329207,0.3969351", "l0.3294983,0.3938022", "l0.3270996,0.3905178", "l0.3258467,0.3870818", "l0.3260606,0.3842521", "l0.3252814,0.3822141", "l0.3237689,0.3802434", "l0.3222410,0.3792160", "l0.3201631,0.3794181", "l0.3182838,0.3784749", "l0.3159921,0.3762010", "l0.3131961,0.3725797", "l0.3136850,0.3690090", "l0.3185130,0.3660109", "l0.3190631,0.3646129", "l0.3179936,0.3629454", "l0.3180699,0.3584146", "l0.3210187,0.3557702", "l0.3256787,0.3564776", "l0.3301859,0.3550459", "l0.3332568,0.3528058", "l0.3396738,0.3516941", "l0.3450366,0.3496898", "l0.3459839,0.3490666", "l0.3465950,0.3463885", "l0.3475118,0.3356931", "l0.3492382,0.3302527", "l0.3507050,0.3279789", "l0.3507050,0.3281641", "l0.3655710,0.3283494", "l0.3779925,0.3324760", "l0.4074954,0.3518794", "c"]}, {"n": "Markazi", "u": "IR-22", "i": ["m0.3461367,0.3047520", "l0.3461367,0.3047520", "l0.3476034,0.3044152", "l0.3490396,0.3011813", "l0.3514231,0.3009455", "l0.3538218,0.3042467", "l0.3551510,0.3070933", "l0.3551816,0.3119946", "l0.3507050,0.3279789", "l0.3492382,0.3302527", "l0.3475118,0.3356931", "l0.3465950,0.3463885", "l0.3459839,0.3490666", "l0.3450366,0.3496898", "l0.3396738,0.3516941", "l0.3332568,0.3528058", "l0.3301859,0.3550459", "l0.3256787,0.3564776", "l0.3210187,0.3557702", "l0.3180699,0.3584146", "l0.3179936,0.3629454", "l0.3190631,0.3646129", "l0.3185130,0.3660109", "l0.3136850,0.3690090", "l0.3131961,0.3725797", "l0.3159921,0.3762010", "l0.3182838,0.3784749", "l0.3201631,0.3794181", "l0.3222410,0.3792160", "l0.3237689,0.3802434", "l0.3252814,0.3822141", "l0.3260606,0.3842521", "l0.3258467,0.3870818", "l0.3270996,0.3905178", "l0.3294983,0.3938022", "l0.3329207,0.3969351", "l0.3462742,0.3983162", "l0.3516064,0.4015501", "l0.3635390,0.4051377", "l0.3629278,0.4092475", "l0.3579929,0.4224357", "l0.3566025,0.4251475", "l0.3536385,0.4251643", "l0.3503841,0.4263097", "l0.3474812,0.4290214", "l0.3442421,0.4312279", "l0.3226841,0.4374936", "l0.3144642,0.4428834", "l0.3101709,0.4468247", "l0.3097126,0.4462689", "l0.3064124,0.4442982", "l0.3060457,0.4423444", "l0.3061221,0.4403401", "l0.3050068,0.4390600", "l0.3033414,0.4376452", "l0.3025164,0.4360114", "l0.3013552,0.4352366", "l0.2995523,0.4366683", "l0.2985287,0.4388916", "l0.2981925,0.4406601", "l0.2969855,0.4415696", "l0.2953813,0.4401716", "l0.2936090,0.4380999", "l0.2897129,0.4359272", "l0.2880323,0.4343439", "l0.2875434,0.4327438", "l0.2880934,0.4307057", "l0.2889184,0.4287351", "l0.2888573,0.4269160", "l0.2874517,0.4242548", "l0.2851905,0.4212230", "l0.2823487,0.4202124", "l0.2797513,0.4218630", "l0.2768942,0.4229242", "l0.2746024,0.4243895", "l0.2728301,0.4303689", "l0.2718523,0.4315142", "l0.2677118,0.4344113", "l0.2662909,0.4338217", "l0.2604545,0.4332659", "l0.2570321,0.4318679", "l0.2543889,0.4301836", "l0.2537166,0.4287351", "l0.2539916,0.4270845", "l0.2544194,0.4255686", "l0.2564973,0.4202966", "l0.2563140,0.4187302", "l0.2556723,0.4168775", "l0.2560390,0.4146373", "l0.2568487,0.4131719", "l0.2622421,0.4078158", "l0.2631588,0.4064346", "l0.2633116,0.4048177", "l0.2623643,0.4003711", "l0.2620740,0.3965982", "l0.2612489,0.3928253", "l0.2575821,0.3848585", "l0.2571696,0.3775653", "l0.2562834,0.3732029", "l0.2536708,0.3720576", "l0.2529221,0.3701038", "l0.2547250,0.3693122", "l0.2600572,0.3699185", "l0.2624560,0.3711986", "l0.2636171,0.3708954", "l0.2627310,0.3655393", "l0.2629143,0.3606716", "l0.2642894,0.3581956", "l0.2649005,0.3557365", "l0.2643199,0.3516941", "l0.2656186,0.3495214", "l0.2750302,0.3489655", "l0.2795068,0.3498245", "l0.2807597,0.3518289", "l0.2796596,0.3544059", "l0.2804388,0.3575724", "l0.2824862,0.3602505", "l0.2841515,0.3619517", "l0.2864280,0.3621875", "l0.2876809,0.3593747", "l0.2865655,0.3518963", "l0.2852669,0.3484434", "l0.2827765,0.3451926", "l0.2801333,0.3437778", "l0.2745719,0.3420935", "l0.2722495,0.3407797", "l0.2710578,0.3394996", "l0.2709203,0.3385059", "l0.2718523,0.3373437", "l0.2734260,0.3371584", "l0.2764053,0.3361310", "l0.2788957,0.3329139", "l0.2782540,0.3296969", "l0.2759469,0.3254524", "l0.2749691,0.3207700", "l0.2765886,0.3184961", "l0.2779943,0.3183782", "l0.2781165,0.3196920", "l0.2780554,0.3214605", "l0.2790638,0.3230606", "l0.2808361,0.3234143", "l0.2825778,0.3212753", "l0.2827765,0.3185972", "l0.2815542,0.3168118", "l0.2811111,0.3143190", "l0.2811416,0.3126515", "l0.2902171,0.3123820", "l0.2917755,0.3084407", "l0.2939451,0.3066553", "l0.3030511,0.3035899", "l0.3057249,0.3021245", "l0.3085820,0.3012150", "l0.3109654,0.3010634", "l0.3202395,0.2965999", "l0.3233258,0.2963978", "l0.3248689,0.2966504", "l0.3270996,0.2972231", "l0.3323249,0.2975937", "l0.3373973,0.2992275", "l0.3403767,0.3021919", "l0.3416753,0.3030509", "l0.3422101,0.3020066", "l0.3422101,0.3008276", "l0.3402086,0.2977621", "l0.3408656,0.2958757", "l0.3437838,0.2959093", "l0.3457853,0.2985200", "l0.3457700,0.3024108", "l0.3461367,0.3047520", "c"]}, {"n": "Ardebil", "u": "IR-03", "i": ["m0.2044279,0.0052288", "l0.2044279,0.0052288", "l0.2051308,0.0054309", "l0.2061391,0.0061889", "l0.2093018,0.0094733", "l0.2179953,0.0210109", "l0.2215399,0.0246322", "l0.2230067,0.0268387", "l0.2241526,0.0295168", "l0.2236025,0.0297020", "l0.2222580,0.0301905", "l0.2195384,0.0322117", "l0.2162994,0.0329359", "l0.2145576,0.0339297", "l0.2130603,0.0355129", "l0.2121131,0.0376015", "l0.2120061,0.0401448", "l0.2127089,0.0421155", "l0.2139770,0.0440862", "l0.2169105,0.0472527", "l0.2198746,0.0486001", "l0.2206538,0.0494423", "l0.2222122,0.0531478", "l0.2224872,0.0540742", "l0.2224567,0.0551016", "l0.2222122,0.0560954", "l0.2222122,0.0561291", "l0.2218150,0.0570723", "l0.2213413,0.0578471", "l0.2213260,0.0578471", "l0.2213260,0.0578471", "l0.2213260,0.0578639", "l0.2213260,0.0578639", "l0.2192023,0.0593293", "l0.2096379,0.0611989", "l0.2094699,0.0616705", "l0.2094851,0.0622263", "l0.2093324,0.0626979", "l0.2066128,0.0645507", "l0.2061391,0.0653760", "l0.2062614,0.0683909", "l0.2072850,0.0704795", "l0.2106463,0.0734608", "l0.2175064,0.0772000", "l0.2181481,0.0778063", "l0.2182856,0.0784127", "l0.2185301,0.0794738", "l0.2183162,0.0809055", "l0.2184078,0.0821350", "l0.2209288,0.0843583", "l0.2217386,0.0856889", "l0.2226706,0.0866658", "l0.2242595,0.0867164", "l0.2268874,0.0853521", "l0.2280944,0.0853521", "l0.2286903,0.0869353", "l0.2290570,0.0888723", "l0.2297293,0.0898661", "l0.2305543,0.0906914", "l0.2314099,0.0921736", "l0.2322808,0.0932179", "l0.2330447,0.0944306", "l0.2343281,0.0962160", "l0.2350004,0.0971592", "l0.2364060,0.0997699", "l0.2380714,0.1015553", "l0.2383311,0.1015721", "l0.2386367,0.1023301", "l0.2402867,0.1039470", "l0.2413562,0.1054966", "l0.2416465,0.1068609", "l0.2428994,0.1074167", "l0.2448550,0.1079052", "l0.2456495,0.1088484", "l0.2451912,0.1101790", "l0.2335031,0.1255232", "l0.2324336,0.1283192", "l0.2319752,0.1321594", "l0.2303251,0.1349891", "l0.2302182,0.1389472", "l0.2349698,0.1534830", "l0.2435564,0.1684061", "l0.2464135,0.1716568", "l0.2497136,0.1745370", "l0.2514554,0.1769793", "l0.2515012,0.1790341", "l0.2512720,0.1821670", "l0.2517151,0.1859230", "l0.2522804,0.1876916", "l0.2487969,0.1856367", "l0.2469788,0.1862430", "l0.2449314,0.1877926", "l0.2430674,0.1875231", "l0.2415854,0.1865968", "l0.2405923,0.1870347", "l0.2399659,0.1882642", "l0.2399659,0.1894770", "l0.2392784,0.1907570", "l0.2376741,0.1911276", "l0.2338086,0.1865799", "l0.2316849,0.1857209", "l0.2301723,0.1861757", "l0.2294542,0.1858893", "l0.2287361,0.1854683", "l0.2282778,0.1855356", "l0.2275444,0.1839018", "l0.2267958,0.1834639", "l0.2250387,0.1835650", "l0.2242595,0.1838682", "l0.2238012,0.1844914", "l0.2234039,0.1844914", "l0.2236637,0.1834134", "l0.2238012,0.1830260", "l0.2214483,0.1809037", "l0.2203482,0.1796573", "l0.2171703,0.1773330", "l0.2158258,0.1738296", "l0.2154132,0.1686250", "l0.2140382,0.1672944", "l0.2102338,0.1651048", "l0.2090726,0.1648521", "l0.2087518,0.1650711", "l0.2036946,0.1616182", "l0.2021514,0.1537356", "l0.2026098,0.1471667", "l0.2037862,0.1444213", "l0.2043057,0.1424170", "l0.2037710,0.1411200", "l0.2003027,0.1375998", "l0.1962233,0.1314352", "l0.1936107,0.1242936", "l0.1932899,0.1185332", "l0.1917467,0.1132108", "l0.1881410,0.1112233", "l0.1765140,0.1131097", "l0.1750014,0.1128065", "l0.1742833,0.1122170", "l0.1726485,0.1104653", "l0.1693483,0.1109033", "l0.1668579,0.1119812", "l0.1662468,0.1097242", "l0.1664912,0.1060019", "l0.1675455,0.1033407", "l0.1688594,0.1014542", "l0.1704942,0.0980687", "l0.1746347,0.0947338", "l0.1768043,0.0921399", "l0.1803184,0.0909946", "l0.1840310,0.0916514", "l0.1865520,0.0897482", "l0.1855742,0.0861774", "l0.1828546,0.0844762", "l0.1828240,0.0824382", "l0.1847339,0.0795917", "l0.1852839,0.0747072", "l0.1822893,0.0664540", "l0.1821518,0.0609294", "l0.1813573,0.0596493", "l0.1820754,0.0512951", "l0.1800281,0.0504529", "l0.1766821,0.0537542", "l0.1731985,0.0560617", "l0.1710901,0.0558596", "l0.1671941,0.0587735", "l0.1612660,0.0701763", "l0.1619688,0.0713722", "l0.1627480,0.0716922", "l0.1621063,0.0726186", "l0.1588672,0.0753135", "l0.1569116,0.0782611", "l0.1547420,0.0801980", "l0.1469958,0.0777726", "l0.1436039,0.0788337", "l0.1400593,0.0809560", "l0.1365147,0.0823540", "l0.1338715,0.0807539", "l0.1324048,0.0767620", "l0.1332298,0.0721975", "l0.1353077,0.0691657", "l0.1366980,0.0682730", "l0.1372175,0.0672288", "l0.1391426,0.0669930", "l0.1419080,0.0677341", "l0.1426108,0.0670435", "l0.1429622,0.0650055", "l0.1429928,0.0628664", "l0.1431303,0.0617547", "l0.1441998,0.0616705", "l0.1465985,0.0638433", "l0.1488598,0.0633717", "l0.1509377,0.0620410", "l0.1541614,0.0615526", "l0.1586533,0.0581503", "l0.1597076,0.0565333", "l0.1600590,0.0552027", "l0.1602576,0.0537373", "l0.1592950,0.0492570", "l0.1585311,0.0477748", "l0.1569421,0.0469158", "l0.1562240,0.0460231", "l0.1561629,0.0452652", "l0.1559796,0.0451136", "l0.1555823,0.0436651", "l0.1559338,0.0434461", "l0.1564685,0.0427387", "l0.1567435,0.0421829", "l0.1576144,0.0393869", "l0.1594784,0.0360856", "l0.1596617,0.0353445", "l0.1601659,0.0347213", "l0.1626410,0.0330370", "l0.1677899,0.0308137", "l0.1684011,0.0304431", "l0.1699442,0.0294662", "l0.1716554,0.0275293", "l0.1716707,0.0275293", "l0.1742375,0.0238574", "l0.1759334,0.0222910", "l0.1780877,0.0209604", "l0.1817087,0.0195961", "l0.1828699,0.0194613", "l0.1835421,0.0189560", "l0.1862770,0.0158737", "l0.1872090,0.0153011", "l0.1934426,0.0114103", "l0.1956580,0.0089006", "l0.1964678,0.0079911", "l0.1974609,0.0072332", "l0.1986985,0.0068626", "l0.2026251,0.0069468", "l0.2032668,0.0067615", "l0.2038015,0.0062226", "l0.2043974,0.0052288", "l0.2044279,0.0052288", "c"]}, {"n": "Hormozgan", "u": "IR-23", "i": ["m0.5716178,0.9486352", "l0.5716178,0.9486352", "l0.5712053,0.9490226", "l0.5707775,0.9490731", "l0.5704872,0.9492584", "l0.5699983,0.9487531", "l0.5697539,0.9489552", "l0.5697844,0.9485678", "l0.5696011,0.9481804", "l0.5694177,0.9475572", "l0.5701664,0.9471025", "l0.5710678,0.9468498", "l0.5713123,0.9472877", "l0.5713734,0.9479109", "l0.5716178,0.9486352", "c", "m0.5456901,0.9463950", "l0.5456901,0.9463950", "l0.5451706,0.9468330", "l0.5444678,0.9466477", "l0.5436428,0.9462266", "l0.5434289,0.9455192", "l0.5441011,0.9451150", "l0.5453387,0.9447107", "l0.5455984,0.9452665", "l0.5456901,0.9463950", "c", "m0.5442998,0.9240441", "l0.5442998,0.9240441", "l0.5440095,0.9241114", "l0.5434136,0.9238925", "l0.5428025,0.9235388", "l0.5425274,0.9231682", "l0.5424510,0.9223429", "l0.5423288,0.9217029", "l0.5423135,0.9211133", "l0.5423135,0.9211133", "l0.5425274,0.9203722", "l0.5428483,0.9198838", "l0.5432761,0.9196311", "l0.5437803,0.9197490", "l0.5442998,0.9203722", "l0.5446512,0.9205575", "l0.5449415,0.9208102", "l0.5451859,0.9211470", "l0.5453845,0.9215850", "l0.5442998,0.9240441", "c", "m0.5195485,0.9086325", "l0.5195485,0.9086325", "l0.5189679,0.9089862", "l0.5151482,0.9087504", "l0.5147510,0.9087167", "l0.5130856,0.9078240", "l0.5120314,0.9059376", "l0.5125509,0.9050449", "l0.5133148,0.9044217", "l0.5142315,0.9041017", "l0.5152399,0.9041522", "l0.5161108,0.9044891", "l0.5180359,0.9047080", "l0.5187693,0.9050281", "l0.5187693,0.9050281", "l0.5188609,0.9053144", "l0.5189068,0.9054491", "l0.5189068,0.9054491", "l0.5188915,0.9060218", "l0.5188915,0.9060218", "l0.5188915,0.9061060", "l0.5189526,0.9065440", "l0.5189526,0.9065440", "l0.5193193,0.9067629", "l0.5195332,0.9069819", "l0.5196707,0.9071166", "l0.5197165,0.9074872", "l0.5197776,0.9078746", "l0.5196554,0.9082620", "l0.5195485,0.9086325", "c", "m0.6148256,0.9003625", "l0.6148256,0.9003625", "l0.6137714,0.9010362", "l0.6129464,0.9005309", "l0.6130686,0.8990656", "l0.6137256,0.8976339", "l0.6145659,0.8969096", "l0.6150701,0.8968086", "l0.6154673,0.8974823", "l0.6155743,0.8989813", "l0.6148256,0.9003625", "c", "m0.4994266,0.8974823", "l0.4994266,0.8974823", "l0.4987543,0.8982234", "l0.4978529,0.8980886", "l0.4969362,0.8975834", "l0.4964320,0.8967917", "l0.4968445,0.8961011", "l0.4978682,0.8960506", "l0.4984029,0.8962022", "l0.4990141,0.8965222", "l0.4994266,0.8974823", "c", "m0.4850800,0.8889091", "l0.4850800,0.8889091", "l0.4843314,0.8891280", "l0.4823451,0.8889428", "l0.4817340,0.8890944", "l0.4807867,0.8897007", "l0.4797936,0.8897007", "l0.4768449,0.8891280", "l0.4759434,0.8887070", "l0.4758212,0.8886228", "l0.4751337,0.8881343", "l0.4735141,0.8866352", "l0.4730558,0.8860457", "l0.4732544,0.8857594", "l0.4736211,0.8856752", "l0.4740336,0.8855068", "l0.4745378,0.8854731", "l0.4788922,0.8869553", "l0.4827729,0.8872753", "l0.4839800,0.8877974", "l0.4846522,0.8884712", "l0.4850800,0.8889091", "c", "m0.6401575,0.8866352", "l0.6401575,0.8866352", "l0.6381866,0.8873427", "l0.6372087,0.8869047", "l0.6374532,0.8852036", "l0.6381866,0.8840245", "l0.6395005,0.8833677", "l0.6414562,0.8831487", "l0.6417159,0.8851194", "l0.6401575,0.8866352", "c", "m0.6294014,0.8822729", "l0.6294014,0.8822729", "l0.6282402,0.8851362", "l0.6276444,0.8862479", "l0.6255054,0.8886564", "l0.6251692,0.8895154", "l0.6247261,0.8900376", "l0.6227552,0.8911324", "l0.6223121,0.8917219", "l0.6218691,0.8920419", "l0.6193175,0.8947537", "l0.6178050,0.8957306", "l0.6166132,0.8951748", "l0.6154826,0.8939115", "l0.6141534,0.8927493", "l0.6107004,0.8947200", "l0.6097379,0.8956295", "l0.6087753,0.8962359", "l0.6076753,0.8962190", "l0.6053224,0.8958317", "l0.6042681,0.8961011", "l0.6031681,0.8966738", "l0.6003721,0.8988803", "l0.5974845,0.9002277", "l0.5957274,0.9016594", "l0.5948260,0.9021984", "l0.5916328,0.9026026", "l0.5893563,0.9032932", "l0.5883937,0.9039501", "l0.5879201,0.9041522", "l0.5879201,0.9041522", "l0.5877673,0.9041354", "l0.5874770,0.9040680", "l0.5868964,0.9038490", "l0.5863769,0.9038490", "l0.5861478,0.9043880", "l0.5859186,0.9048259", "l0.5853533,0.9051628", "l0.5847116,0.9053818", "l0.5842379,0.9054660", "l0.5842379,0.9054660", "l0.5840240,0.9052976", "l0.5838254,0.9051628", "l0.5835657,0.9044217", "l0.5833212,0.9028553", "l0.5836726,0.9017268", "l0.5837643,0.9010025", "l0.5834893,0.9006657", "l0.5829698,0.8986950", "l0.5835351,0.8980213", "l0.5859644,0.8989813", "l0.5865297,0.8986950", "l0.5868506,0.8987961", "l0.5870034,0.8988466", "l0.5870034,0.8988466", "l0.5897382,0.8971454", "l0.5966594,0.8946695", "l0.5976678,0.8945347", "l0.5983095,0.8942484", "l0.5985081,0.8941642", "l0.5985081,0.8941642", "l0.6009069,0.8925472", "l0.6019305,0.8916208", "l0.6053224,0.8901723", "l0.6058418,0.8901218", "l0.6069266,0.8902229", "l0.6074461,0.8901723", "l0.6078128,0.8899871", "l0.6083475,0.8894986", "l0.6088517,0.8892965", "l0.6086989,0.8888754", "l0.6084697,0.8884375", "l0.6092642,0.8874269", "l0.6094476,0.8862310", "l0.6092031,0.8833677", "l0.6088059,0.8822729", "l0.6079197,0.8813465", "l0.6070641,0.8806054", "l0.6066974,0.8801001", "l0.6080114,0.8792579", "l0.6152534,0.8822729", "l0.6172091,0.8817676", "l0.6226635,0.8778768", "l0.6294931,0.8761588", "l0.6315251,0.8761251", "l0.6325488,0.8763946", "l0.6338780,0.8770346", "l0.6347031,0.8777252", "l0.6349933,0.8779778", "l0.6354059,0.8791737", "l0.6345808,0.8797127", "l0.6337405,0.8802348", "l0.6305473,0.8811444", "l0.6294014,0.8822729", "c", "m0.6454744,0.8733459", "l0.6454744,0.8733459", "l0.6446647,0.8734975", "l0.6430299,0.8728070", "l0.6431368,0.8711900", "l0.6440994,0.8697246", "l0.6450161,0.8695225", "l0.6455661,0.8699268", "l0.6461620,0.8701794", "l0.6466509,0.8706173", "l0.6466815,0.8707352", "l0.6468495,0.8715437", "l0.6466509,0.8723690", "l0.6461620,0.8729585", "l0.6457953,0.8731607", "l0.6454744,0.8733459", "c", "m0.5984012,0.7626185", "l0.5984012,0.7626185", "l0.6007235,0.7638818", "l0.6033820,0.7631238", "l0.6137256,0.7544664", "l0.6198064,0.7513167", "l0.6213649,0.7510977", "l0.6228163,0.7534726", "l0.6238094,0.7782322", "l0.6225260,0.7830494", "l0.6236108,0.7893824", "l0.6282249,0.7959681", "l0.6326710,0.8004821", "l0.6379879,0.8040360", "l0.6441452,0.8050803", "l0.6474607,0.8044234", "l0.6535415,0.8011053", "l0.6591488,0.7952270", "l0.6607225,0.7930879", "l0.6631059,0.7910162", "l0.6659172,0.7911341", "l0.6713105,0.7940480", "l0.6717230,0.7950923", "l0.6712647,0.8017117", "l0.6731439,0.8117671", "l0.6738926,0.8131314", "l0.6749315,0.8140914", "l0.6765205,0.8143104", "l0.6792095,0.8159274", "l0.6812721,0.8188918", "l0.6824791,0.8214519", "l0.6848320,0.8242984", "l0.6871697,0.8282229", "l0.6875211,0.8314568", "l0.6860849,0.8327874", "l0.6851835,0.8347749", "l0.6863599,0.8366445", "l0.6877503,0.8374193", "l0.6891559,0.8405858", "l0.6907143,0.8456220", "l0.6923491,0.8696404", "l0.6933880,0.8733628", "l0.7093847,0.8827276", "l0.7128835,0.8855741", "l0.7144419,0.8861131", "l0.7168865,0.8835866", "l0.7181241,0.8816833", "l0.7202478,0.8800832", "l0.7236549,0.8801843", "l0.7272148,0.8825423", "l0.7310803,0.8861300", "l0.7341207,0.8900207", "l0.7356027,0.8935578", "l0.7351597,0.8947705", "l0.7319206,0.8925978", "l0.7308053,0.8925304", "l0.7307442,0.8938105", "l0.7319970,0.8979034", "l0.7320734,0.8995203", "l0.7317831,0.9005814", "l0.7308358,0.9018615", "l0.7301177,0.9038322", "l0.7289260,0.9162793", "l0.7292163,0.9181153", "l0.7292163,0.9199512", "l0.7286052,0.9235051", "l0.7275509,0.9249368", "l0.7276426,0.9262337", "l0.7345027,0.9256947", "l0.7387501,0.9265369", "l0.7415461,0.9262505", "l0.7433337,0.9253242", "l0.7451518,0.9257789", "l0.7471381,0.9267727", "l0.7503618,0.9273285", "l0.7513397,0.9280022", "l0.7512633,0.9286928", "l0.7507744,0.9298718", "l0.7508966,0.9311014", "l0.7514161,0.9325162", "l0.7515688,0.9344869", "l0.7524397,0.9361880", "l0.7545787,0.9367270", "l0.7571455,0.9368281", "l0.7593609,0.9365249", "l0.7608888,0.9347564", "l0.7624014,0.9343353", "l0.7644028,0.9352111", "l0.7658238,0.9351943", "l0.7665724,0.9358849", "l0.7686808,0.9394051", "l0.7680544,0.9397757", "l0.7671224,0.9413421", "l0.7668780,0.9433801", "l0.7670766,0.9445254", "l0.7677794,0.9448623", "l0.7696281,0.9461424", "l0.7794370,0.9557094", "l0.7811023,0.9587411", "l0.7813773,0.9610318", "l0.7825232,0.9623119", "l0.7840816,0.9629688", "l0.7849220,0.9641141", "l0.7852734,0.9654111", "l0.7859762,0.9664216", "l0.7868318,0.9673649", "l0.7886652,0.9708177", "l0.7890930,0.9714409", "l0.7900556,0.9719631", "l0.7899181,0.9729737", "l0.7898875,0.9739337", "l0.7885277,0.9745906", "l0.7887569,0.9760897", "l0.7887569,0.9760897", "l0.7858692,0.9765781", "l0.7829205,0.9781277", "l0.7818204,0.9783972", "l0.7813926,0.9782961", "l0.7810107,0.9778919", "l0.7806287,0.9776224", "l0.7801856,0.9777403", "l0.7796967,0.9779761", "l0.7792231,0.9781277", "l0.7780313,0.9780603", "l0.7770077,0.9778245", "l0.7761368,0.9774203", "l0.7754645,0.9767971", "l0.7730811,0.9725694", "l0.7717977,0.9708683", "l0.7697809,0.9698408", "l0.7679780,0.9698914", "l0.7675044,0.9696387", "l0.7671835,0.9690323", "l0.7670002,0.9684092", "l0.7667099,0.9678870", "l0.7661293,0.9676849", "l0.7616833,0.9676849", "l0.7522869,0.9657984", "l0.7490632,0.9663543", "l0.7462977,0.9661522", "l0.7453199,0.9656469", "l0.7457019,0.9646363", "l0.7441740,0.9647373", "l0.7425239,0.9651079", "l0.7418211,0.9655121", "l0.7406294,0.9666069", "l0.7398502,0.9668259", "l0.7394835,0.9666575", "l0.7393154,0.9664048", "l0.7390557,0.9664216", "l0.7384598,0.9670448", "l0.7380473,0.9673649", "l0.7375126,0.9675501", "l0.7370542,0.9674828", "l0.7368709,0.9670448", "l0.7365653,0.9671964", "l0.7347471,0.9685944", "l0.7328373,0.9689313", "l0.7311567,0.9685607", "l0.7295219,0.9679881", "l0.7277954,0.9676849", "l0.7264050,0.9669775", "l0.7252744,0.9652763", "l0.7237313,0.9616382", "l0.7221118,0.9594991", "l0.7201561,0.9589769", "l0.7180171,0.9595833", "l0.7159239,0.9607792", "l0.7141669,0.9623624", "l0.7130210,0.9631541", "l0.7122112,0.9631372", "l0.7124251,0.9603412", "l0.7126238,0.9596170", "l0.7127613,0.9593138", "l0.7127918,0.9590780", "l0.7127154,0.9585895", "l0.7121807,0.9571410", "l0.7113709,0.9563494", "l0.7103014,0.9560462", "l0.7090027,0.9559957", "l0.7078416,0.9561304", "l0.7049692,0.9568547", "l0.7043428,0.9567199", "l0.7032580,0.9561304", "l0.7026621,0.9559957", "l0.7020663,0.9560462", "l0.7010426,0.9563494", "l0.7005079,0.9564168", "l0.6992245,0.9562989", "l0.6956951,0.9550862", "l0.6960771,0.9546988", "l0.6891559,0.9541935", "l0.6883920,0.9537387", "l0.6880253,0.9527449", "l0.6877350,0.9496458", "l0.6864821,0.9464287", "l0.6858404,0.9438686", "l0.6853974,0.9426558", "l0.6848932,0.9421337", "l0.6848015,0.9418979", "l0.6836556,0.9403652", "l0.6834264,0.9403146", "l0.6827694,0.9404325", "l0.6825555,0.9403652", "l0.6824639,0.9400957", "l0.6823264,0.9393546", "l0.6816235,0.9370807", "l0.6814096,0.9360196", "l0.6809055,0.9347732", "l0.6807985,0.9340153", "l0.6811194,0.9327015", "l0.6827389,0.9307645", "l0.6832889,0.9294844", "l0.6825861,0.9274632", "l0.6791637,0.9232861", "l0.6794387,0.9215850", "l0.6790567,0.9211976", "l0.6787665,0.9183174", "l0.6783998,0.9168857", "l0.6778192,0.9157404", "l0.6768261,0.9146792", "l0.6765816,0.9142076", "l0.6764288,0.9136350", "l0.6762455,0.9121864", "l0.6762302,0.9115969", "l0.6771164,0.9036469", "l0.6769330,0.9006657", "l0.6735717,0.8858436", "l0.6728689,0.8846983", "l0.6711119,0.8830140", "l0.6704855,0.8820034", "l0.6705466,0.8809591", "l0.6689576,0.8797969", "l0.6684229,0.8791737", "l0.6691868,0.8792411", "l0.6697521,0.8789884", "l0.6702716,0.8786179", "l0.6708980,0.8782978", "l0.6704549,0.8778768", "l0.6703938,0.8772704", "l0.6705771,0.8766472", "l0.6708980,0.8761251", "l0.6693090,0.8768830", "l0.6687743,0.8770009", "l0.6683006,0.8768662", "l0.6679951,0.8765630", "l0.6677812,0.8762598", "l0.6675367,0.8761251", "l0.6672617,0.8759061", "l0.6669867,0.8754850", "l0.6666353,0.8752155", "l0.6656269,0.8757714", "l0.6653213,0.8755524", "l0.6651838,0.8750303", "l0.6652144,0.8743734", "l0.6645421,0.8745418", "l0.6641907,0.8742049", "l0.6642060,0.8737333", "l0.6646949,0.8734975", "l0.6649546,0.8732786", "l0.6658561,0.8721838", "l0.6663144,0.8717795", "l0.6663144,0.8713079", "l0.6647866,0.8710721", "l0.6635490,0.8701457", "l0.6627240,0.8688151", "l0.6623878,0.8673666", "l0.6617920,0.8680235", "l0.6611197,0.8682761", "l0.6597294,0.8682930", "l0.6589501,0.8680066", "l0.6584765,0.8674003", "l0.6580793,0.8667771", "l0.6575904,0.8665076", "l0.6522276,0.8664234", "l0.6510511,0.8660191", "l0.6506997,0.8665076", "l0.6494469,0.8657328", "l0.6478885,0.8653791", "l0.6446647,0.8651770", "l0.6431215,0.8648569", "l0.6404172,0.8636611", "l0.6388130,0.8633916", "l0.6356045,0.8635937", "l0.6339697,0.8640653", "l0.6327780,0.8649580", "l0.6316779,0.8655475", "l0.6283013,0.8657160", "l0.6269415,0.8660191", "l0.6265137,0.8663392", "l0.6256581,0.8672824", "l0.6254901,0.8675856", "l0.6253831,0.8682761", "l0.6250928,0.8684782", "l0.6246956,0.8685793", "l0.6242525,0.8688993", "l0.6233664,0.8697415", "l0.6198828,0.8720659", "l0.6186300,0.8732280", "l0.6186147,0.8734975", "l0.6183397,0.8736996", "l0.6173924,0.8746092", "l0.6168271,0.8748113", "l0.6145201,0.8751145", "l0.6123811,0.8756871", "l0.6118310,0.8757545", "l0.6101046,0.8756871", "l0.6095392,0.8758219", "l0.6087600,0.8764282", "l0.6083170,0.8765630", "l0.6063766,0.8765630", "l0.6047571,0.8761419", "l0.6042376,0.8761251", "l0.6032445,0.8765967", "l0.6015180,0.8783821", "l0.6008610,0.8787863", "l0.6002804,0.8792748", "l0.5974845,0.8827108", "l0.5982331,0.8824413", "l0.5985540,0.8822560", "l0.5989359,0.8818349", "l0.5991345,0.8834013", "l0.5988290,0.8853215", "l0.5982178,0.8871405", "l0.5974845,0.8884375", "l0.5957885,0.8900881", "l0.5938482,0.8911829", "l0.5916786,0.8916714", "l0.5893563,0.8915198", "l0.5851852,0.8899197", "l0.5828170,0.8895828", "l0.5808461,0.8906103", "l0.5802349,0.8918230", "l0.5799599,0.8929683", "l0.5794557,0.8938105", "l0.5782029,0.8941305", "l0.5771792,0.8942652", "l0.5749180,0.8950063", "l0.5741388,0.8954106", "l0.5707622,0.8987455", "l0.5701817,0.8991498", "l0.5652161,0.9036132", "l0.5595936,0.9072345", "l0.5592422,0.9075882", "l0.5589061,0.9080093", "l0.5585241,0.9083630", "l0.5579894,0.9085146", "l0.5573324,0.9083799", "l0.5564615,0.9078072", "l0.5558504,0.9076724", "l0.5514043,0.9081272", "l0.5491278,0.9077230", "l0.5482569,0.9062745", "l0.5476152,0.9044217", "l0.5461026,0.9028553", "l0.5437803,0.9023500", "l0.5390745,0.9025521", "l0.5372105,0.9015415", "l0.5362785,0.8999077", "l0.5355146,0.8978697", "l0.5345367,0.8959159", "l0.5329936,0.8945347", "l0.5318936,0.8942989", "l0.5308699,0.8944842", "l0.5298615,0.8948042", "l0.5259196,0.8950906", "l0.5248349,0.8949727", "l0.5212902,0.8938273", "l0.5203888,0.8936589", "l0.5198388,0.8934736", "l0.5188457,0.8925978", "l0.5184179,0.8923619", "l0.5178831,0.8923283", "l0.5168136,0.8925809", "l0.5134065,0.8943326", "l0.5110230,0.8947032", "l0.5089299,0.8953600", "l0.5077840,0.8954106", "l0.5054769,0.8945853", "l0.5042088,0.8944674", "l0.5030018,0.8951916", "l0.5023601,0.8949390", "l0.4996710,0.8923619", "l0.4957750,0.8898186", "l0.4907484,0.8856247", "l0.4900150,0.8846141", "l0.4897094,0.8833677", "l0.4895872,0.8803359", "l0.4891747,0.8790558", "l0.4882885,0.8778768", "l0.4866384,0.8767146", "l0.4690375,0.8701120", "l0.4679069,0.8699941", "l0.4668068,0.8696404", "l0.4661040,0.8687983", "l0.4655693,0.8677708", "l0.4649123,0.8668950", "l0.4618260,0.8660360", "l0.4613524,0.8653959", "l0.4609093,0.8640148", "l0.4598551,0.8632905", "l0.4574716,0.8625157", "l0.4533006,0.8583723", "l0.4514672,0.8569912", "l0.4487017,0.8556437", "l0.4495421,0.8538415", "l0.4498323,0.8534541", "l0.4500615,0.8534878", "l0.4511157,0.8529825", "l0.4516811,0.8530162", "l0.4550576,0.8526456", "l0.4558979,0.8526793", "l0.4584647,0.8534035", "l0.4608788,0.8535215", "l0.4615816,0.8532351", "l0.4638122,0.8518203", "l0.4652331,0.8548352", "l0.4690222,0.8588102", "l0.4805576,0.8599387", "l0.4824674,0.8607809", "l0.4868370,0.8647390", "l0.4877079,0.8652107", "l0.4886094,0.8653454", "l0.4923832,0.8642843", "l0.4937124,0.8642843", "l0.5095410,0.8673834", "l0.5149343,0.8642169", "l0.5163400,0.8617241", "l0.5157441,0.8598377", "l0.5157594,0.8591302", "l0.5168442,0.8556100", "l0.5176081,0.8505065", "l0.5198999,0.8474242", "l0.5252474,0.8453693", "l0.5390592,0.8439713", "l0.5422066,0.8444261", "l0.5446512,0.8453693", "l0.5472180,0.8441566", "l0.5519390,0.8429439", "l0.5657356,0.8450998", "l0.5721984,0.8429271", "l0.5751930,0.8397774", "l0.5768889,0.8340675", "l0.5789057,0.8305304", "l0.5859644,0.8263365", "l0.5907008,0.8249890", "l0.5936954,0.8251743", "l0.5952538,0.8244163", "l0.5964302,0.8234900", "l0.5973164,0.8219067", "l0.5976372,0.8182517", "l0.5951621,0.8137883", "l0.5907924,0.8098469", "l0.5905480,0.8077584", "l0.5907924,0.8050635", "l0.5934051,0.7945028", "l0.5940162,0.7872265", "l0.5926411,0.7831504", "l0.5770876,0.7664925", "l0.5768125,0.7634270", "l0.5785085,0.7620627", "l0.5784932,0.7602268", "l0.5755139,0.7503061", "l0.5798988,0.7506598", "l0.5892493,0.7535905", "l0.5938787,0.7575992", "l0.5961399,0.7608668", "l0.5984012,0.7626185", "c"]}, {"n": "Ilam", "u": "IR-05", "i": ["m0.1748486,0.4098201", "l0.1748486,0.4098201", "l0.1755667,0.4108981", "l0.1767432,0.4139299", "l0.1772015,0.4172985", "l0.1769418,0.4194713", "l0.1762390,0.4210209", "l0.1750167,0.4224526", "l0.1721290,0.4245917", "l0.1711054,0.4261918", "l0.1529850,0.4318342", "l0.1497765,0.4352029", "l0.1486459,0.4383020", "l0.1477444,0.4384199", "l0.1468430,0.4388410", "l0.1467055,0.4398853", "l0.1459110,0.4425297", "l0.1459721,0.4430518", "l0.1467819,0.4435740", "l0.1479431,0.4458478", "l0.1495626,0.4467910", "l0.1509224,0.4486943", "l0.1520072,0.4491322", "l0.1548337,0.4510355", "l0.1553684,0.4512882", "l0.1555671,0.4518608", "l0.1554907,0.4525514", "l0.1548948,0.4537473", "l0.1550323,0.4543200", "l0.1557199,0.4552295", "l0.1563921,0.4558864", "l0.1573241,0.4563748", "l0.1592798,0.4570486", "l0.1593714,0.4572338", "l0.1594478,0.4575707", "l0.1596159,0.4578907", "l0.1599826,0.4580255", "l0.1602576,0.4579581", "l0.1605173,0.4576381", "l0.1608687,0.4575707", "l0.1612660,0.4576718", "l0.1615563,0.4579244", "l0.1618007,0.4582444", "l0.1643675,0.4604004", "l0.1652842,0.4608720", "l0.1652842,0.4617647", "l0.1662315,0.4628258", "l0.1675455,0.4637185", "l0.1697456,0.4643080", "l0.1761015,0.4678451", "l0.1766515,0.4685525", "l0.1769418,0.4693947", "l0.1776140,0.4696305", "l0.1783780,0.4696810", "l0.1789586,0.4699673", "l0.1801808,0.4715674", "l0.1812045,0.4737234", "l0.1818768,0.4745487", "l0.1828546,0.4748687", "l0.1836185,0.4752898", "l0.1852992,0.4773615", "l0.1913953,0.4862042", "l0.1997221,0.5055739", "l0.2007458,0.5072077", "l0.2013722,0.5078646", "l0.1966206,0.5201096", "l0.1928315,0.5258869", "l0.1929232,0.5293229", "l0.1935343,0.5336348", "l0.1916856,0.5369697", "l0.1862770,0.5408942", "l0.1849019,0.5415005", "l0.1847797,0.5413153", "l0.1837866,0.5408605", "l0.1830074,0.5407426", "l0.1825490,0.5401699", "l0.1821212,0.5394794", "l0.1814642,0.5390246", "l0.1806545,0.5387551", "l0.1803031,0.5384519", "l0.1802420,0.5379298", "l0.1803489,0.5369866", "l0.1805628,0.5362455", "l0.1808684,0.5356559", "l0.1811434,0.5349991", "l0.1812198,0.5340727", "l0.1809448,0.5331968", "l0.1799364,0.5323378", "l0.1796614,0.5314788", "l0.1791572,0.5312093", "l0.1788363,0.5308219", "l0.1779196,0.5294239", "l0.1777210,0.5290534", "l0.1774765,0.5286828", "l0.1759334,0.5270490", "l0.1757042,0.5266617", "l0.1753528,0.5257521", "l0.1753681,0.5254153", "l0.1755667,0.5251626", "l0.1760251,0.5239162", "l0.1763154,0.5235288", "l0.1764987,0.5230909", "l0.1764223,0.5223161", "l0.1761320,0.5218108", "l0.1747417,0.5206486", "l0.1738861,0.5194191", "l0.1733055,0.5183748", "l0.1726332,0.5175326", "l0.1715332,0.5168926", "l0.1685997,0.5157809", "l0.1678816,0.5157304", "l0.1654981,0.5171789", "l0.1645967,0.5175495", "l0.1627633,0.5177684", "l0.1611285,0.5173810", "l0.1595548,0.5164547", "l0.1579047,0.5151240", "l0.1579047,0.5151072", "l0.1578894,0.5151072", "l0.1423205,0.5000999", "l0.1401663,0.4974050", "l0.1367897,0.4951311", "l0.1344062,0.4930089", "l0.1342076,0.4928910", "l0.1293796,0.4897918", "l0.1279281,0.4881917", "l0.1227793,0.4854631", "l0.1172790,0.4835767", "l0.1111828,0.4843346", "l0.1081577,0.4839304", "l0.1070576,0.4812186", "l0.1070576,0.4812018", "l0.1076840,0.4803764", "l0.1085549,0.4796017", "l0.1093188,0.4787258", "l0.1096550,0.4775636", "l0.1093647,0.4766372", "l0.1086160,0.4758961", "l0.1076382,0.4754414", "l0.1053770,0.4751550", "l0.1046436,0.4744645", "l0.1047047,0.4736392", "l0.1057436,0.4729991", "l0.1068743,0.4728812", "l0.1077451,0.4729486", "l0.1085855,0.4727633", "l0.1096702,0.4718538", "l0.1110759,0.4703210", "l0.1117787,0.4693610", "l0.1121454,0.4685020", "l0.1121148,0.4678788", "l0.1115189,0.4674577", "l0.1112898,0.4668176", "l0.1113203,0.4662618", "l0.1116412,0.4649649", "l0.1116259,0.4642575", "l0.1111675,0.4631121", "l0.1104494,0.4622868", "l0.1087994,0.4608215", "l0.1067368,0.4576044", "l0.1050103,0.4557516", "l0.1047353,0.4547579", "l0.1047047,0.4536125", "l0.1045519,0.4522314", "l0.1041394,0.4509345", "l0.1035435,0.4497554", "l0.1018171,0.4473637", "l0.1016490,0.4472290", "l0.1014962,0.4471279", "l0.1012976,0.4469932", "l0.1012365,0.4469595", "l0.1009615,0.4469089", "l0.1007017,0.4469595", "l0.1004573,0.4471111", "l0.0994947,0.4481217", "l0.0979210,0.4483406", "l0.0963932,0.4479532", "l0.0955070,0.4471111", "l0.0963168,0.4459320", "l0.0987613,0.4442814", "l0.0994030,0.4432371", "l0.0990364,0.4417381", "l0.0979516,0.4408959", "l0.0970349,0.4398685", "l0.0972335,0.4377631", "l0.0961181,0.4380662", "l0.0935972,0.4381168", "l0.0926652,0.4385547", "l0.0911526,0.4401548", "l0.0902970,0.4407948", "l0.0893956,0.4410307", "l0.0890442,0.4405590", "l0.0890594,0.4381336", "l0.0888914,0.4376115", "l0.0900526,0.4365335", "l0.0911526,0.4265960", "l0.0931235,0.4197576", "l0.0936889,0.4153279", "l0.0929708,0.4127003", "l0.0939180,0.4114708", "l0.0969737,0.4115718", "l0.1049950,0.4104602", "l0.1127412,0.4139636", "l0.1169123,0.4143004", "l0.1210986,0.4153616", "l0.1245668,0.4177196", "l0.1283712,0.4213578", "l0.1413580,0.4259896", "l0.1474083,0.4265286", "l0.1562088,0.4240527", "l0.1643217,0.4244569", "l0.1654065,0.4221157", "l0.1661246,0.4176691", "l0.1653606,0.4159342", "l0.1639397,0.4135930", "l0.1639397,0.4114876", "l0.1722360,0.4093654", "l0.1739930,0.4095338", "l0.1748486,0.4098201", "c"]}, {"n": "Lorestan", "u": "IR-20", "i": ["m0.1907842,0.3883113", "l0.1907842,0.3883113", "l0.1920829,0.3889514", "l0.1942982,0.3905346", "l0.1953677,0.3922526", "l0.2175828,0.4083716", "l0.2290723,0.4099044", "l0.2309821,0.4106960", "l0.2325252,0.4102581", "l0.2352448,0.4071589", "l0.2365893,0.4067547", "l0.2393395,0.4069399", "l0.2427313,0.4065189", "l0.2568487,0.4131719", "l0.2560390,0.4146373", "l0.2556723,0.4168775", "l0.2563140,0.4187302", "l0.2564973,0.4202966", "l0.2544194,0.4255686", "l0.2539916,0.4270845", "l0.2537166,0.4287351", "l0.2543889,0.4301836", "l0.2570321,0.4318679", "l0.2604545,0.4332659", "l0.2662909,0.4338217", "l0.2677118,0.4344113", "l0.2718523,0.4315142", "l0.2728301,0.4303689", "l0.2746024,0.4243895", "l0.2768942,0.4229242", "l0.2797513,0.4218630", "l0.2823487,0.4202124", "l0.2851905,0.4212230", "l0.2874517,0.4242548", "l0.2888573,0.4269160", "l0.2889184,0.4287351", "l0.2880934,0.4307057", "l0.2875434,0.4327438", "l0.2880323,0.4343439", "l0.2897129,0.4359272", "l0.2936090,0.4380999", "l0.2953813,0.4401716", "l0.2969855,0.4415696", "l0.2981925,0.4406601", "l0.2985287,0.4388916", "l0.2995523,0.4366683", "l0.3013552,0.4352366", "l0.3025164,0.4360114", "l0.3033414,0.4376452", "l0.3050068,0.4390600", "l0.3061221,0.4403401", "l0.3060457,0.4423444", "l0.3064124,0.4442982", "l0.3097126,0.4462689", "l0.3101709,0.4468247", "l0.3090098,0.4495533", "l0.3087959,0.4532588", "l0.3089334,0.4562064", "l0.3036928,0.4678282", "l0.3034025,0.4694283", "l0.3032956,0.4706916", "l0.3020580,0.4715001", "l0.2943729,0.4738918", "l0.2913936,0.4777657", "l0.2904616,0.4858168", "l0.2880934,0.4877875", "l0.2839682,0.4893034", "l0.2827917,0.4901455", "l0.2820889,0.4915267", "l0.2817681,0.4931605", "l0.2817986,0.4938173", "l0.2780095,0.4947100", "l0.2707369,0.4939352", "l0.2586821,0.4847725", "l0.2472232,0.4834924", "l0.2439994,0.4823976", "l0.2413410,0.4795511", "l0.2359782,0.4777826", "l0.2304779,0.4782374", "l0.2268416,0.4794838", "l0.2140687,0.4804270", "l0.2112727,0.4827850", "l0.2042140,0.5033001", "l0.2013722,0.5078646", "l0.2007458,0.5072077", "l0.1997221,0.5055739", "l0.1913953,0.4862042", "l0.1852992,0.4773615", "l0.1836185,0.4752898", "l0.1828546,0.4748687", "l0.1818768,0.4745487", "l0.1812045,0.4737234", "l0.1801808,0.4715674", "l0.1789586,0.4699673", "l0.1783780,0.4696810", "l0.1776140,0.4696305", "l0.1769418,0.4693947", "l0.1766515,0.4685525", "l0.1761015,0.4678451", "l0.1697456,0.4643080", "l0.1675455,0.4637185", "l0.1662315,0.4628258", "l0.1652842,0.4617647", "l0.1652842,0.4608720", "l0.1643675,0.4604004", "l0.1618007,0.4582444", "l0.1615563,0.4579244", "l0.1612660,0.4576718", "l0.1608687,0.4575707", "l0.1605173,0.4576381", "l0.1602576,0.4579581", "l0.1599826,0.4580255", "l0.1596159,0.4578907", "l0.1594478,0.4575707", "l0.1593714,0.4572338", "l0.1592798,0.4570486", "l0.1573241,0.4563748", "l0.1563921,0.4558864", "l0.1557199,0.4552295", "l0.1550323,0.4543200", "l0.1548948,0.4537473", "l0.1554907,0.4525514", "l0.1555671,0.4518608", "l0.1553684,0.4512882", "l0.1548337,0.4510355", "l0.1520072,0.4491322", "l0.1509224,0.4486943", "l0.1495626,0.4467910", "l0.1479431,0.4458478", "l0.1467819,0.4435740", "l0.1459721,0.4430518", "l0.1459110,0.4425297", "l0.1467055,0.4398853", "l0.1468430,0.4388410", "l0.1477444,0.4384199", "l0.1486459,0.4383020", "l0.1497765,0.4352029", "l0.1529850,0.4318342", "l0.1711054,0.4261918", "l0.1721290,0.4245917", "l0.1750167,0.4224526", "l0.1762390,0.4210209", "l0.1769418,0.4194713", "l0.1772015,0.4172985", "l0.1767432,0.4139299", "l0.1755667,0.4108981", "l0.1748486,0.4098201", "l0.1757501,0.4091127", "l0.1764987,0.4077821", "l0.1763001,0.4072600", "l0.1762390,0.4065189", "l0.1763918,0.4052388", "l0.1763001,0.4044471", "l0.1760404,0.4038913", "l0.1756889,0.4034702", "l0.1753681,0.4030155", "l0.1752459,0.4023417", "l0.1755514,0.4013648", "l0.1785460,0.3997310", "l0.1822435,0.3995289", "l0.1847491,0.3980972", "l0.1850394,0.3942233", "l0.1845658,0.3905009", "l0.1847339,0.3889514", "l0.1857270,0.3882271", "l0.1872243,0.3877892", "l0.1907842,0.3883113", "c"]}, {"n": "Khuzestan", "u": "IR-10", "i": ["m0.2780095,0.4947100", "l0.2780095,0.4947100", "l0.2817986,0.4938173", "l0.2843043,0.5006725", "l0.2871003,0.5023232", "l0.2916075,0.5019863", "l0.2967869,0.5041591", "l0.2989412,0.5073761", "l0.2978258,0.5092626", "l0.2964355,0.5143156", "l0.2966341,0.5163031", "l0.2974897,0.5203960", "l0.3052818,0.5340221", "l0.3069013,0.5385530", "l0.3081694,0.5403720", "l0.3094528,0.5413995", "l0.3102015,0.5423427", "l0.3126461,0.5432186", "l0.3135017,0.5441618", "l0.3141892,0.5459472", "l0.3155948,0.5515560", "l0.3171532,0.5555983", "l0.3187422,0.5583775", "l0.3213090,0.5609713", "l0.3223174,0.5629083", "l0.3267176,0.5681465", "l0.3282302,0.5718689", "l0.3280774,0.5749849", "l0.3252662,0.5788757", "l0.3234174,0.5828170", "l0.3199645,0.5879037", "l0.3137767,0.5940346", "l0.3097890,0.5958873", "l0.3080319,0.5973695", "l0.3067180,0.5992897", "l0.3058624,0.6014625", "l0.3059082,0.6053532", "l0.3082611,0.6147686", "l0.3084139,0.6174635", "l0.3081542,0.6184573", "l0.3079250,0.6204448", "l0.3074055,0.6226176", "l0.3077569,0.6242513", "l0.3165879,0.6229544", "l0.3186658,0.6259188", "l0.3227146,0.6303486", "l0.3276496,0.6332456", "l0.3305678,0.6355868", "l0.3314540,0.6390902", "l0.3284594,0.6468550", "l0.3288261,0.6502910", "l0.3304761,0.6523627", "l0.3314540,0.6567588", "l0.3323401,0.6671342", "l0.3243494,0.6666795", "l0.3213701,0.6650793", "l0.3160379,0.6660563", "l0.3127072,0.6678922", "l0.3113474,0.6673027", "l0.3094834,0.6670669", "l0.3075583,0.6673869", "l0.3056790,0.6681111", "l0.2894379,0.6795814", "l0.2875586,0.6804572", "l0.2858933,0.6800530", "l0.2844418,0.6776949", "l0.2843043,0.6766338", "l0.2842890,0.6736526", "l0.2838918,0.6725072", "l0.2835098,0.6719177", "l0.2833723,0.6715472", "l0.2831890,0.6712777", "l0.2826237,0.6709071", "l0.2821195,0.6706713", "l0.2816306,0.6705366", "l0.2805152,0.6704523", "l0.2799652,0.6705197", "l0.2788499,0.6708229", "l0.2782234,0.6709071", "l0.2776429,0.6707724", "l0.2768942,0.6701492", "l0.2764664,0.6700144", "l0.2753969,0.6701997", "l0.2734565,0.6711092", "l0.2723870,0.6713619", "l0.2710425,0.6712440", "l0.2705536,0.6706713", "l0.2706147,0.6679595", "l0.2704619,0.6677574", "l0.2697438,0.6671848", "l0.2695299,0.6667974", "l0.2694994,0.6664437", "l0.2695299,0.6654499", "l0.2696063,0.6649614", "l0.2698202,0.6645404", "l0.2698049,0.6641193", "l0.2691785,0.6636645", "l0.2688730,0.6647762", "l0.2683382,0.6658878", "l0.2675896,0.6666626", "l0.2667034,0.6667974", "l0.2657714,0.6661573", "l0.2653283,0.6653152", "l0.2647783,0.6646583", "l0.2638769,0.6645572", "l0.2626699,0.6641024", "l0.2592475,0.6618791", "l0.2585446,0.6611549", "l0.2582085,0.6590158", "l0.2572918,0.6576852", "l0.2559320,0.6569104", "l0.2542819,0.6564388", "l0.2548319,0.6553440", "l0.2556875,0.6550913", "l0.2578113,0.6554955", "l0.2589113,0.6554282", "l0.2606225,0.6547881", "l0.2615698,0.6546197", "l0.2626240,0.6549060", "l0.2647325,0.6561524", "l0.2654658,0.6564388", "l0.2666117,0.6565567", "l0.2674826,0.6569609", "l0.2681854,0.6576683", "l0.2688577,0.6586958", "l0.2691632,0.6578031", "l0.2701411,0.6558829", "l0.2716689,0.6537102", "l0.2719592,0.6530028", "l0.2720051,0.6518743", "l0.2709356,0.6521101", "l0.2701716,0.6515711", "l0.2696827,0.6505436", "l0.2692855,0.6481182", "l0.2686743,0.6484382", "l0.2678646,0.6493983", "l0.2670548,0.6500720", "l0.2671312,0.6492299", "l0.2672076,0.6489941", "l0.2674062,0.6487077", "l0.2669784,0.6479666", "l0.2665353,0.6480845", "l0.2660159,0.6485225", "l0.2652978,0.6487077", "l0.2649769,0.6484719", "l0.2644116,0.6475624", "l0.2640602,0.6473603", "l0.2637241,0.6474276", "l0.2632352,0.6477308", "l0.2629754,0.6478150", "l0.2619365,0.6476298", "l0.2610045,0.6473266", "l0.2601336,0.6472761", "l0.2592475,0.6478150", "l0.2573987,0.6475119", "l0.2559167,0.6485393", "l0.2555500,0.6498868", "l0.2569404,0.6505605", "l0.2585905,0.6509310", "l0.2598739,0.6518406", "l0.2602864,0.6530196", "l0.2592475,0.6541818", "l0.2583766,0.6541649", "l0.2555806,0.6537270", "l0.2549847,0.6539291", "l0.2521582,0.6568430", "l0.2519443,0.6571462", "l0.2514859,0.6579378", "l0.2512262,0.6587631", "l0.2518221,0.6593526", "l0.2516082,0.6598243", "l0.2512720,0.6603464", "l0.2510887,0.6607001", "l0.2514707,0.6621149", "l0.2523874,0.6631424", "l0.2534263,0.6640182", "l0.2542819,0.6650457", "l0.2547097,0.6662247", "l0.2550458,0.6677069", "l0.2553361,0.6706713", "l0.2552292,0.6715135", "l0.2547708,0.6728609", "l0.2546333,0.6736020", "l0.2546639,0.6743094", "l0.2549542,0.6755558", "l0.2549847,0.6763138", "l0.2546639,0.6776107", "l0.2539763,0.6787897", "l0.2530444,0.6796151", "l0.2519749,0.6799519", "l0.2484608,0.6794972", "l0.2475593,0.6799519", "l0.2465510,0.6794298", "l0.2429299,0.6794635", "l0.2407451,0.6781160", "l0.2399048,0.6779139", "l0.2397673,0.6790592", "l0.2400117,0.6798340", "l0.2407145,0.6810804", "l0.2408521,0.6819900", "l0.2406993,0.6826468", "l0.2403173,0.6832027", "l0.2398437,0.6836743", "l0.2394006,0.6839943", "l0.2382241,0.6843985", "l0.2344198,0.6839943", "l0.2344198,0.6835395", "l0.2341448,0.6839438", "l0.2340836,0.6841122", "l0.2337322,0.6839269", "l0.2321280,0.6834216", "l0.2313488,0.6828995", "l0.2306307,0.6822763", "l0.2302946,0.6819057", "l0.2300654,0.6814678", "l0.2296070,0.6801877", "l0.2295001,0.6793287", "l0.2285528,0.6760443", "l0.2284153,0.6759432", "l0.2281097,0.6752527", "l0.2270861,0.6739726", "l0.2264291,0.6724398", "l0.2263374,0.6719851", "l0.2264444,0.6712440", "l0.2268569,0.6707050", "l0.2273458,0.6701997", "l0.2277278,0.6696439", "l0.2278653,0.6689364", "l0.2277583,0.6682122", "l0.2274986,0.6675553", "l0.2271625,0.6669826", "l0.2251457,0.6649614", "l0.2234803,0.6628560", "l0.2224261,0.6609191", "l0.2219525,0.6604643", "l0.2213260,0.6602285", "l0.2206691,0.6601948", "l0.2187745,0.6605485", "l0.2181481,0.6605822", "l0.2175370,0.6604811", "l0.2169716,0.6601948", "l0.2165591,0.6597064", "l0.2163299,0.6590663", "l0.2159021,0.6561693", "l0.2154285,0.6547208", "l0.2147715,0.6534238", "l0.2139007,0.6523964", "l0.2133659,0.6520258", "l0.2128006,0.6518069", "l0.2073156,0.6509310", "l0.2072392,0.6489098", "l0.2072392,0.6489098", "l0.2074073,0.6169414", "l0.2072545,0.6160824", "l0.2066892,0.6157118", "l0.1896994,0.6157118", "l0.1898675,0.5996097", "l0.1900050,0.5881563", "l0.1978887,0.5644579", "l0.1981943,0.5629420", "l0.1980568,0.5615103", "l0.1973387,0.5603144", "l0.1953066,0.5586133", "l0.1944663,0.5576027", "l0.1942830,0.5570805", "l0.1940232,0.5559183", "l0.1937329,0.5553120", "l0.1933357,0.5548909", "l0.1924037,0.5542172", "l0.1920523,0.5536782", "l0.1901883,0.5500064", "l0.1899439,0.5488273", "l0.1899439,0.5488105", "l0.1894397,0.5476315", "l0.1876368,0.5466546", "l0.1868423,0.5456440", "l0.1856659,0.5427133", "l0.1849019,0.5415005", "l0.1862770,0.5408942", "l0.1916856,0.5369697", "l0.1935343,0.5336348", "l0.1929232,0.5293229", "l0.1928315,0.5258869", "l0.1966206,0.5201096", "l0.2013722,0.5078646", "l0.2042140,0.5033001", "l0.2112727,0.4827850", "l0.2140687,0.4804270", "l0.2268416,0.4794838", "l0.2304779,0.4782374", "l0.2359782,0.4777826", "l0.2413410,0.4795511", "l0.2439994,0.4823976", "l0.2472232,0.4834924", "l0.2586821,0.4847725", "l0.2707369,0.4939352", "l0.2780095,0.4947100", "c"]}, {"n": "Chahar Mahall and Bakhtiari", "u": "IR-08", "i": ["m0.3779161,0.6044437", "l0.3779161,0.6044437", "l0.3761438,0.6042921", "l0.3727978,0.6049995", "l0.3702310,0.6074923", "l0.3674197,0.6091093", "l0.3614916,0.6082503", "l0.3597193,0.6082840", "l0.3404683,0.5893690", "l0.3388794,0.5891501", "l0.3361598,0.5893185", "l0.3270843,0.5852929", "l0.3234174,0.5828170", "l0.3252662,0.5788757", "l0.3280774,0.5749849", "l0.3282302,0.5718689", "l0.3267176,0.5681465", "l0.3223174,0.5629083", "l0.3213090,0.5609713", "l0.3187422,0.5583775", "l0.3171532,0.5555983", "l0.3155948,0.5515560", "l0.3141892,0.5459472", "l0.3135017,0.5441618", "l0.3126461,0.5432186", "l0.3102015,0.5423427", "l0.3094528,0.5413995", "l0.3081694,0.5403720", "l0.3069013,0.5385530", "l0.3052818,0.5340221", "l0.2974897,0.5203960", "l0.2966341,0.5163031", "l0.2964355,0.5143156", "l0.3066416,0.5082352", "l0.3101709,0.5087405", "l0.3120196,0.5083867", "l0.3136392,0.5074941", "l0.3159462,0.5069551", "l0.3191089,0.5088752", "l0.3222716,0.5117722", "l0.3256328,0.5122270", "l0.3281844,0.5115870", "l0.3297733,0.5121933", "l0.3321262,0.5116375", "l0.3378863,0.5074772", "l0.3399183,0.5070730", "l0.3467173,0.5068372", "l0.3488563,0.5060455", "l0.3500022,0.5046644", "l0.3522328,0.5042433", "l0.3542496,0.5061803", "l0.3547691,0.5092626", "l0.3552733,0.5109132", "l0.3566331,0.5113006", "l0.3574275,0.5122775", "l0.3578706,0.5142313", "l0.3589860,0.5162020", "l0.3586957,0.5211034", "l0.3592151,0.5263922", "l0.3657849,0.5320346", "l0.3685198,0.5350833", "l0.3745243,0.5401026", "l0.3772286,0.5455261", "l0.3781758,0.5525160", "l0.3765410,0.5560699", "l0.3744784,0.5576532", "l0.3742493,0.5597249", "l0.3752729,0.5617798", "l0.3768313,0.5639863", "l0.3769536,0.5660243", "l0.3747687,0.5670854", "l0.3729964,0.5684666", "l0.3726908,0.5720542", "l0.3738520,0.5796842", "l0.3785731,0.5969485", "l0.3784356,0.6021362", "l0.3779161,0.6044437", "c"]}, {"n": "Yazd", "u": "IR-25", "i": ["m0.6880253,0.4396327", "l0.6880253,0.4396327", "l0.7012565,0.4362303", "l0.7034719,0.4393463", "l0.7055192,0.4437087", "l0.7093847,0.4725443", "l0.7127460,0.4810502", "l0.7171462,0.4838293", "l0.7183838,0.4848904", "l0.7217298,0.4865579", "l0.7261147,0.4895897", "l0.7303011,0.4968323", "l0.7316609,0.4979103", "l0.7319206,0.5030980", "l0.7314928,0.5052034", "l0.7301025,0.5076962", "l0.7292163,0.5101216", "l0.7295830,0.5116206", "l0.7303775,0.5131871", "l0.7318900,0.5150904", "l0.7319817,0.5171284", "l0.7335554,0.5209181", "l0.7356333,0.5247078", "l0.7355111,0.5284133", "l0.7343346,0.5321694", "l0.7338763,0.5354875", "l0.7330207,0.5386372", "l0.7261300,0.5488273", "l0.7242202,0.5547056", "l0.7189033,0.5638010", "l0.7161990,0.5714983", "l0.7154656,0.5728121", "l0.6599433,0.5464356", "l0.6533429,0.5451555", "l0.6522276,0.5470251", "l0.6498441,0.5498716", "l0.6390880,0.5565921", "l0.6354211,0.5608871", "l0.6079503,0.5768882", "l0.6056585,0.5823285", "l0.6049862,0.6033489", "l0.6042070,0.6079808", "l0.5954371,0.6122421", "l0.5856894,0.6137075", "l0.5814420,0.6127643", "l0.5748263,0.6124779", "l0.5457512,0.6181709", "l0.5411982,0.6237797", "l0.5387995,0.6287990", "l0.5376536,0.6336330", "l0.5377911,0.6369175", "l0.5406787,0.6429473", "l0.5437344,0.6518237", "l0.5449720,0.6584263", "l0.5466374,0.6606833", "l0.5483027,0.6619465", "l0.5476458,0.6833374", "l0.5481958,0.6870766", "l0.5489139,0.6897042", "l0.5489750,0.6915738", "l0.5473402,0.6928538", "l0.5421149,0.6935613", "l0.5415954,0.6940497", "l0.5393189,0.6951614", "l0.5288073,0.6892662", "l0.5207708,0.6825963", "l0.5192887,0.6786550", "l0.5174553,0.6642035", "l0.5151941,0.6597906", "l0.5069436,0.6486067", "l0.4983418,0.6316287", "l0.4862717,0.5979422", "l0.4796256,0.5890153", "l0.4717877,0.5810653", "l0.4586328,0.5754733", "l0.4563716,0.5656201", "l0.4562188,0.5609713", "l0.4567688,0.5593038", "l0.4577619,0.5511686", "l0.4599315,0.5417027", "l0.4604051,0.5373739", "l0.4589078,0.5166231", "l0.4593051,0.5143829", "l0.4613677,0.5128670", "l0.4650804,0.5116543", "l0.4684416,0.5095489", "l0.4707182,0.5074267", "l0.4738350,0.5052371", "l0.4788311,0.5030980", "l0.4826049,0.5029464", "l0.4989835,0.5071067", "l0.5537419,0.4862547", "l0.5592116,0.4828187", "l0.5620687,0.4789785", "l0.5640549,0.4748350", "l0.5657356,0.4697652", "l0.5680885,0.4583455", "l0.5708692,0.4545389", "l0.5760181,0.4514903", "l0.5800363,0.4510187", "l0.5830004,0.4487280", "l0.5874159,0.4402559", "l0.5887909,0.4354050", "l0.5882104,0.3888503", "l0.5882104,0.3886819", "l0.5891271,0.3882271", "l0.5938787,0.3872502", "l0.6071405,0.3875871", "l0.6128241,0.3843363", "l0.6314334,0.3497572", "l0.6525790,0.3436599", "l0.6731439,0.3328802", "l0.6861613,0.3291747", "l0.6919213,0.3308422", "l0.7070165,0.3436262", "l0.7087888,0.3480223", "l0.7080860,0.3524689", "l0.7030747,0.3578924", "l0.6825708,0.3739272", "l0.6790415,0.3809508", "l0.6725328,0.4026112", "l0.6721050,0.4142499", "l0.6753288,0.4340407", "l0.6777581,0.4382684", "l0.6880253,0.4396327", "c"]}, {"n": "Tehran", "u": "IR-07", "i": ["m0.4191683,0.2895426", "l0.4191683,0.2895426", "l0.4227282,0.2879425", "l0.4294507,0.2789651", "l0.4342024,0.2748216", "l0.4376248,0.2753269", "l0.4413069,0.2770281", "l0.4459669,0.2779881", "l0.4518797,0.2815252", "l0.4558215,0.2824348", "l0.4585564,0.2820137", "l0.4602218,0.2809189", "l0.4624677,0.2814915", "l0.4671124,0.2850455", "l0.4687472,0.2929281", "l0.4694195,0.3000023", "l0.4677541,0.3063016", "l0.4595342,0.3145716", "l0.4544006,0.3176034", "l0.4485031,0.3197594", "l0.4443168,0.3195741", "l0.4326592,0.3158349", "l0.4287174,0.3157338", "l0.4249436,0.3143022", "l0.4155014,0.3079354", "l0.4126443,0.3051900", "l0.4095580,0.3050047", "l0.4084427,0.3045668", "l0.4078163,0.3038762", "l0.4068537,0.3033877", "l0.4059981,0.3043983", "l0.4052953,0.3108325", "l0.4043175,0.3150433", "l0.4039966,0.3182435", "l0.4043939,0.3212247", "l0.4102303,0.3297811", "l0.4125679,0.3344804", "l0.4119262,0.3387754", "l0.4092677,0.3433062", "l0.4076940,0.3488982", "l0.4074954,0.3518794", "l0.3779925,0.3324760", "l0.3655710,0.3283494", "l0.3507050,0.3281641", "l0.3507050,0.3279789", "l0.3551816,0.3119946", "l0.3551510,0.3070933", "l0.3538218,0.3042467", "l0.3514231,0.3009455", "l0.3527829,0.2974589", "l0.3561289,0.2951851", "l0.3588332,0.2915133", "l0.3602999,0.2872519", "l0.3648988,0.2869656", "l0.3655252,0.2835633", "l0.3657238,0.2790156", "l0.3688559,0.2750406", "l0.3730270,0.2733394", "l0.3772133,0.2738952", "l0.3801315,0.2719077", "l0.3801315,0.2679327", "l0.3802996,0.2649515", "l0.3858915,0.2685896", "l0.3938211,0.2693307", "l0.4008645,0.2723793", "l0.4061509,0.2786787", "l0.4091455,0.2848939", "l0.4110095,0.2872519", "l0.4125526,0.2882625", "l0.4150889,0.2892731", "l0.4191683,0.2895426", "c"]}, {"n": "Semnan", "u": "IR-12", "i": ["m0.6251845,0.1911950", "l0.6251845,0.1911950", "l0.6272166,0.1908076", "l0.6297375,0.1919697", "l0.6292028,0.1936035", "l0.6261776,0.1945973", "l0.6248484,0.1957763", "l0.6245275,0.1968374", "l0.6248637,0.1974101", "l0.6251845,0.1981681", "l0.6254442,0.2000545", "l0.6251845,0.2049054", "l0.6242067,0.2091667", "l0.6240233,0.2105984", "l0.6249859,0.2128554", "l0.6311126,0.2204517", "l0.6369948,0.2260268", "l0.6398978,0.2271047", "l0.6448327,0.2280311", "l0.6473995,0.2291259", "l0.6552833,0.2276606", "l0.6563070,0.2273405", "l0.6579570,0.2274079", "l0.6600502,0.2287891", "l0.6613183,0.2343810", "l0.6599280,0.2410004", "l0.6578348,0.2454133", "l0.6570709,0.2531275", "l0.6580487,0.2663832", "l0.6597294,0.2749058", "l0.6611350,0.2788640", "l0.6734037,0.2899300", "l0.6767955,0.2942419", "l0.6760010,0.2991432", "l0.6670020,0.3162391", "l0.6648018,0.3218816", "l0.6632281,0.3232459", "l0.6523040,0.3277767", "l0.6464217,0.3316507", "l0.6397450,0.3383880", "l0.6314334,0.3497572", "l0.6128241,0.3843363", "l0.6071405,0.3875871", "l0.5938787,0.3872502", "l0.5891271,0.3882271", "l0.5882104,0.3886819", "l0.5882104,0.3888503", "l0.5877367,0.3881766", "l0.5864686,0.3869639", "l0.5836268,0.3859364", "l0.4601454,0.3900293", "l0.4574564,0.3895577", "l0.4354247,0.3815403", "l0.4318953,0.3809340", "l0.4177168,0.3819277", "l0.4126596,0.3810014", "l0.4026521,0.3750220", "l0.4043786,0.3722934", "l0.4066551,0.3663983", "l0.4080455,0.3603179", "l0.4081830,0.3546585", "l0.4074954,0.3518794", "l0.4076940,0.3488982", "l0.4092677,0.3433062", "l0.4119262,0.3387754", "l0.4125679,0.3344804", "l0.4102303,0.3297811", "l0.4043939,0.3212247", "l0.4039966,0.3182435", "l0.4043175,0.3150433", "l0.4052953,0.3108325", "l0.4059981,0.3043983", "l0.4068537,0.3033877", "l0.4078163,0.3038762", "l0.4084427,0.3045668", "l0.4095580,0.3050047", "l0.4126443,0.3051900", "l0.4155014,0.3079354", "l0.4249436,0.3143022", "l0.4287174,0.3157338", "l0.4326592,0.3158349", "l0.4443168,0.3195741", "l0.4485031,0.3197594", "l0.4544006,0.3176034", "l0.4595342,0.3145716", "l0.4677541,0.3063016", "l0.4694195,0.3000023", "l0.4687472,0.2929281", "l0.4671124,0.2850455", "l0.4678763,0.2846749", "l0.4731169,0.2840349", "l0.4755615,0.2832769", "l0.4788464,0.2811884", "l0.4815354,0.2801778", "l0.4832160,0.2812052", "l0.4857981,0.2808178", "l0.4897553,0.2794030", "l0.4934221,0.2772134", "l0.4956681,0.2750069", "l0.4968903,0.2731205", "l0.4975320,0.2713519", "l0.4987238,0.2694149", "l0.5040254,0.2641935", "l0.5060728,0.2615828", "l0.5068978,0.2558898", "l0.5080437,0.2516116", "l0.5098771,0.2476872", "l0.5137579,0.2433753", "l0.5180664,0.2405793", "l0.5232764,0.2388613", "l0.5334061,0.2386592", "l0.5374550,0.2393835", "l0.5410607,0.2384908", "l0.5483639,0.2346842", "l0.5515571,0.2308439", "l0.5603270,0.2232645", "l0.5693719,0.2175209", "l0.5737721,0.2169483", "l0.5922745,0.2197442", "l0.5948871,0.2183799", "l0.5966136,0.2134617", "l0.5976372,0.2056465", "l0.6019152,0.1951531", "l0.6115407,0.1787647", "l0.6136797,0.1768277", "l0.6215024,0.1883316", "l0.6251845,0.1911950", "c"]}, {"n": "Mazandaran", "u": "IR-21", "i": ["m0.5018100,0.2152976", "l0.5018100,0.2152976", "l0.5018100,0.2152976", "l0.5018864,0.2162240", "l0.5024670,0.2179925", "l0.5042699,0.2214454", "l0.5156983,0.2290754", "l0.5211680,0.2353074", "l0.5232764,0.2388613", "l0.5180664,0.2405793", "l0.5137579,0.2433753", "l0.5098771,0.2476872", "l0.5080437,0.2516116", "l0.5068978,0.2558898", "l0.5060728,0.2615828", "l0.5040254,0.2641935", "l0.4987238,0.2694149", "l0.4975320,0.2713519", "l0.4968903,0.2731205", "l0.4956681,0.2750069", "l0.4934221,0.2772134", "l0.4897553,0.2794030", "l0.4857981,0.2808178", "l0.4832160,0.2812052", "l0.4815354,0.2801778", "l0.4788464,0.2811884", "l0.4755615,0.2832769", "l0.4731169,0.2840349", "l0.4678763,0.2846749", "l0.4671124,0.2850455", "l0.4624677,0.2814915", "l0.4602218,0.2809189", "l0.4585564,0.2820137", "l0.4558215,0.2824348", "l0.4518797,0.2815252", "l0.4459669,0.2779881", "l0.4413069,0.2770281", "l0.4376248,0.2753269", "l0.4342024,0.2748216", "l0.4294507,0.2789651", "l0.4227282,0.2879425", "l0.4191683,0.2895426", "l0.4150889,0.2892731", "l0.4125526,0.2882625", "l0.4110095,0.2872519", "l0.4091455,0.2848939", "l0.4061509,0.2786787", "l0.4008645,0.2723793", "l0.3938211,0.2693307", "l0.3858915,0.2685896", "l0.3802996,0.2649515", "l0.3769383,0.2605722", "l0.3684587,0.2585005", "l0.3662891,0.2574562", "l0.3643182,0.2554519", "l0.3633862,0.2539529", "l0.3600860,0.2525043", "l0.3515453,0.2506347", "l0.3514842,0.2492199", "l0.3508883,0.2472998", "l0.3425004,0.2402425", "l0.3396433,0.2385244", "l0.3258467,0.2256899", "l0.3285358,0.2237529", "l0.3317137,0.2175041", "l0.3328443,0.2115921", "l0.3349222,0.2093183", "l0.3376112,0.2077182", "l0.3393836,0.2050233", "l0.3398877,0.2032042", "l0.3399183,0.2029684", "l0.3399183,0.2029684", "l0.3423782,0.2048043", "l0.3434629,0.2050906", "l0.3441810,0.2054443", "l0.3457089,0.2072802", "l0.3464728,0.2080045", "l0.3546316,0.2129227", "l0.3620875,0.2187505", "l0.3664266,0.2209401", "l0.3808649,0.2241066", "l0.3900931,0.2270542", "l0.3996575,0.2289575", "l0.4088705,0.2319051", "l0.4184502,0.2305071", "l0.4269603,0.2270542", "l0.4358525,0.2246288", "l0.4450654,0.2226918", "l0.4538964,0.2207043", "l0.4627580,0.2177904", "l0.4712987,0.2148765", "l0.4884719,0.2106152", "l0.4907942,0.2101941", "l0.5111605,0.2089140", "l0.5148732,0.2079203", "l0.5173942,0.2055791", "l0.5172720,0.2082908", "l0.5143538,0.2094193", "l0.5106716,0.2099246", "l0.5083034,0.2107331", "l0.5076465,0.2110868", "l0.5069131,0.2109689", "l0.5055227,0.2104805", "l0.5047435,0.2106152", "l0.5033226,0.2112384", "l0.5025129,0.2114237", "l0.4994877,0.2109689", "l0.4968292,0.2109689", "l0.4972418,0.2117774", "l0.4979598,0.2120300", "l0.4996710,0.2119458", "l0.4986321,0.2123332", "l0.4982196,0.2123837", "l0.4994724,0.2142365", "l0.5015961,0.2152639", "l0.5018100,0.2152976", "c"]}, {"n": "Golestan", "u": "IR-27", "i": ["m0.6194245,0.1255232", "l0.6194245,0.1255232", "l0.6268193,0.1240241", "l0.6289125,0.1243273", "l0.6291722,0.1244452", "l0.6295083,0.1295150", "l0.6291722,0.1315699", "l0.6293097,0.1341975", "l0.6299361,0.1372292", "l0.6298903,0.1389472", "l0.6288361,0.1436128", "l0.6289430,0.1468804", "l0.6307001,0.1491879", "l0.6331446,0.1505186", "l0.6352531,0.1523039", "l0.6362156,0.1567000", "l0.6333738,0.1610793", "l0.6273082,0.1634036", "l0.6259179,0.1636394", "l0.6243595,0.1644142", "l0.6227858,0.1660143", "l0.6190272,0.1677323", "l0.6152534,0.1751434", "l0.6136797,0.1768277", "l0.6115407,0.1787647", "l0.6019152,0.1951531", "l0.5976372,0.2056465", "l0.5966136,0.2134617", "l0.5948871,0.2183799", "l0.5922745,0.2197442", "l0.5737721,0.2169483", "l0.5693719,0.2175209", "l0.5603270,0.2232645", "l0.5515571,0.2308439", "l0.5483639,0.2346842", "l0.5410607,0.2384908", "l0.5374550,0.2393835", "l0.5334061,0.2386592", "l0.5232764,0.2388613", "l0.5211680,0.2353074", "l0.5156983,0.2290754", "l0.5042699,0.2214454", "l0.5024670,0.2179925", "l0.5018864,0.2162240", "l0.5018100,0.2152976", "l0.5018100,0.2152976", "l0.5096327,0.2160556", "l0.5104424,0.2165609", "l0.5113286,0.2169146", "l0.5178067,0.2149439", "l0.5184179,0.2143881", "l0.5187693,0.2131922", "l0.5187998,0.2058149", "l0.5185095,0.2046022", "l0.5177456,0.2041137", "l0.5167678,0.2036758", "l0.5169206,0.2026315", "l0.5180970,0.2002061", "l0.5168594,0.1981007", "l0.5160344,0.1954731", "l0.5148885,0.1894264", "l0.5133148,0.1847440", "l0.5130856,0.1837334", "l0.5125967,0.1776530", "l0.5267141,0.1790173", "l0.5277378,0.1789499", "l0.5286698,0.1785120", "l0.5296323,0.1775014", "l0.5305949,0.1767940", "l0.5317102,0.1767266", "l0.5329172,0.1768951", "l0.5340478,0.1768951", "l0.5358965,0.1762213", "l0.5446512,0.1706125", "l0.5458276,0.1704104", "l0.5489750,0.1711684", "l0.5501209,0.1711515", "l0.5509001,0.1707473", "l0.5521682,0.1692314", "l0.5531919,0.1687766", "l0.5538336,0.1681029", "l0.5562934,0.1663175", "l0.5576074,0.1651048", "l0.5578518,0.1645827", "l0.5580046,0.1634878", "l0.5587074,0.1616856", "l0.5588755,0.1606582", "l0.5589366,0.1589233", "l0.5588755,0.1584180", "l0.5586311,0.1579464", "l0.5580352,0.1573401", "l0.5578518,0.1569527", "l0.5577907,0.1554368", "l0.5586463,0.1531966", "l0.5588755,0.1517649", "l0.5591505,0.1506196", "l0.5598228,0.1494237", "l0.5613812,0.1475541", "l0.5691580,0.1416422", "l0.5715720,0.1386441", "l0.5719692,0.1379030", "l0.5722443,0.1369092", "l0.5728707,0.1365387", "l0.5736041,0.1364039", "l0.5741541,0.1361681", "l0.5745360,0.1356123", "l0.5751014,0.1342985", "l0.5755444,0.1337427", "l0.5765375,0.1333721", "l0.5795321,0.1327321", "l0.5801738,0.1324626", "l0.5806322,0.1313173", "l0.5817628,0.1306267", "l0.5841157,0.1297508", "l0.5847116,0.1296498", "l0.5857811,0.1286897", "l0.5868506,0.1280834", "l0.5906855,0.1247989", "l0.5919536,0.1242263", "l0.5952385,0.1240747", "l0.6054599,0.1216998", "l0.6070030,0.1216998", "l0.6102115,0.1224746", "l0.6122283,0.1237715", "l0.6129922,0.1240578", "l0.6156201,0.1240915", "l0.6164910,0.1243947", "l0.6178966,0.1252200", "l0.6186300,0.1254727", "l0.6194245,0.1255232", "c"]}, {"n": "Fars", "u": "IR-14", "i": ["m0.4370289,0.5811327", "l0.4370289,0.5811327", "l0.4408791,0.5811158", "l0.4585411,0.5754733", "l0.4586328,0.5754733", "l0.4717877,0.5810653", "l0.4796256,0.5890153", "l0.4862717,0.5979422", "l0.4983418,0.6316287", "l0.5069436,0.6486067", "l0.5151941,0.6597906", "l0.5174553,0.6642035", "l0.5192887,0.6786550", "l0.5207708,0.6825963", "l0.5288073,0.6892662", "l0.5393189,0.6951614", "l0.5393037,0.6964583", "l0.5407246,0.7016629", "l0.5449262,0.7112803", "l0.5455068,0.7138068", "l0.5466374,0.7159964", "l0.5478749,0.7173944", "l0.5501820,0.7190114", "l0.5620382,0.7202241", "l0.5650481,0.7216389", "l0.5755139,0.7503061", "l0.5784932,0.7602268", "l0.5785085,0.7620627", "l0.5768125,0.7634270", "l0.5770876,0.7664925", "l0.5926411,0.7831504", "l0.5940162,0.7872265", "l0.5934051,0.7945028", "l0.5907924,0.8050635", "l0.5905480,0.8077584", "l0.5907924,0.8098469", "l0.5951621,0.8137883", "l0.5976372,0.8182517", "l0.5973164,0.8219067", "l0.5964302,0.8234900", "l0.5952538,0.8244163", "l0.5936954,0.8251743", "l0.5907008,0.8249890", "l0.5859644,0.8263365", "l0.5789057,0.8305304", "l0.5768889,0.8340675", "l0.5751930,0.8397774", "l0.5721984,0.8429271", "l0.5657356,0.8450998", "l0.5519390,0.8429439", "l0.5472180,0.8441566", "l0.5446512,0.8453693", "l0.5422066,0.8444261", "l0.5390592,0.8439713", "l0.5252474,0.8453693", "l0.5198999,0.8474242", "l0.5176081,0.8505065", "l0.5168442,0.8556100", "l0.5157594,0.8591302", "l0.5157441,0.8598377", "l0.5163400,0.8617241", "l0.5149343,0.8642169", "l0.5095410,0.8673834", "l0.4937124,0.8642843", "l0.4923832,0.8642843", "l0.4886094,0.8653454", "l0.4877079,0.8652107", "l0.4868370,0.8647390", "l0.4824674,0.8607809", "l0.4805576,0.8599387", "l0.4690222,0.8588102", "l0.4652331,0.8548352", "l0.4638122,0.8518203", "l0.4534686,0.8435839", "l0.4468377,0.8366951", "l0.4400082,0.8273976", "l0.4329954,0.8100659", "l0.4290993,0.8050298", "l0.4273728,0.8039013", "l0.4250811,0.8028907", "l0.4237824,0.8005326", "l0.4162042,0.7768847", "l0.4150125,0.7710233", "l0.3917891,0.7227506", "l0.3872055,0.7181018", "l0.3830803,0.7164007", "l0.3797495,0.7125436", "l0.3760980,0.7061600", "l0.3733173,0.6991195", "l0.3698490,0.6948582", "l0.3627445,0.6923149", "l0.3513161,0.6913716", "l0.3483674,0.6901252", "l0.3452047,0.6830342", "l0.3426073,0.6801709", "l0.3412170,0.6754043", "l0.3412170,0.6720188", "l0.3412170,0.6718503", "l0.3464117,0.6704355", "l0.3550899,0.6710250", "l0.3572900,0.6706376", "l0.3711019,0.6617275", "l0.3722019,0.6591842", "l0.3722630,0.6557650", "l0.3709949,0.6534238", "l0.3706130,0.6519753", "l0.3713310,0.6505605", "l0.3712241,0.6490614", "l0.3695893,0.6440085", "l0.3687337,0.6384334", "l0.3695129,0.6374396", "l0.3737298,0.6386018", "l0.3796579,0.6417852", "l0.3809718,0.6421052", "l0.3821330,0.6437221", "l0.3840581,0.6450191", "l0.3895431,0.6465855", "l0.3924155,0.6457265", "l0.3949670,0.6440590", "l0.3962810,0.6426105", "l0.3965712,0.6419536", "l0.3965407,0.6387871", "l0.3950128,0.6305002", "l0.3989394,0.6298433", "l0.4003909,0.6293212", "l0.4003756,0.6271821", "l0.3998409,0.6232408", "l0.4002534,0.6174467", "l0.4046231,0.6053869", "l0.4056773,0.5985823", "l0.4069301,0.5940346", "l0.4054328,0.5895206", "l0.4024535,0.5870110", "l0.4001770,0.5865393", "l0.3981449,0.5856803", "l0.3965560,0.5838950", "l0.3953337,0.5807453", "l0.3955323,0.5787578", "l0.4005590,0.5800884", "l0.4044397,0.5794820", "l0.4114067,0.5742606", "l0.4128735,0.5735364", "l0.4138819,0.5720373", "l0.4209253,0.5677591", "l0.4218267,0.5679107", "l0.4226212,0.5697298", "l0.4231101,0.5759281", "l0.4255089,0.5783199", "l0.4370289,0.5811327", "c"]}, {"n": "Esfahan", "u": "IR-04", "i": ["m0.4177168,0.3819277", "l0.4177168,0.3819277", "l0.4318953,0.3809340", "l0.4354247,0.3815403", "l0.4574564,0.3895577", "l0.4601454,0.3900293", "l0.5836268,0.3859364", "l0.5864686,0.3869639", "l0.5877367,0.3881766", "l0.5882104,0.3888503", "l0.5887909,0.4354050", "l0.5874159,0.4402559", "l0.5830004,0.4487280", "l0.5800363,0.4510187", "l0.5760181,0.4514903", "l0.5708692,0.4545389", "l0.5680885,0.4583455", "l0.5657356,0.4697652", "l0.5640549,0.4748350", "l0.5620687,0.4789785", "l0.5592116,0.4828187", "l0.5537419,0.4862547", "l0.4989835,0.5071067", "l0.4826049,0.5029464", "l0.4788311,0.5030980", "l0.4738350,0.5052371", "l0.4707182,0.5074267", "l0.4684416,0.5095489", "l0.4650804,0.5116543", "l0.4613677,0.5128670", "l0.4593051,0.5143829", "l0.4589078,0.5166231", "l0.4604051,0.5373739", "l0.4599315,0.5417027", "l0.4577619,0.5511686", "l0.4567688,0.5593038", "l0.4562188,0.5609713", "l0.4563716,0.5656201", "l0.4586328,0.5754733", "l0.4585411,0.5754733", "l0.4408791,0.5811158", "l0.4370289,0.5811327", "l0.4255089,0.5783199", "l0.4231101,0.5759281", "l0.4226212,0.5697298", "l0.4218267,0.5679107", "l0.4209253,0.5677591", "l0.4138819,0.5720373", "l0.4128735,0.5735364", "l0.4114067,0.5742606", "l0.4044397,0.5794820", "l0.4005590,0.5800884", "l0.3955323,0.5787578", "l0.3953337,0.5807453", "l0.3965560,0.5838950", "l0.3981449,0.5856803", "l0.4001770,0.5865393", "l0.4024535,0.5870110", "l0.4054328,0.5895206", "l0.4069301,0.5940346", "l0.4056773,0.5985823", "l0.4046231,0.6053869", "l0.4002534,0.6174467", "l0.3998409,0.6232408", "l0.4003756,0.6271821", "l0.4003909,0.6293212", "l0.3989394,0.6298433", "l0.3950128,0.6305002", "l0.3939586,0.6293717", "l0.3867166,0.6236113", "l0.3811399,0.6170593", "l0.3782828,0.6088903", "l0.3779161,0.6044437", "l0.3784356,0.6021362", "l0.3785731,0.5969485", "l0.3738520,0.5796842", "l0.3726908,0.5720542", "l0.3729964,0.5684666", "l0.3747687,0.5670854", "l0.3769536,0.5660243", "l0.3768313,0.5639863", "l0.3752729,0.5617798", "l0.3742493,0.5597249", "l0.3744784,0.5576532", "l0.3765410,0.5560699", "l0.3781758,0.5525160", "l0.3772286,0.5455261", "l0.3745243,0.5401026", "l0.3685198,0.5350833", "l0.3657849,0.5320346", "l0.3592151,0.5263922", "l0.3586957,0.5211034", "l0.3589860,0.5162020", "l0.3578706,0.5142313", "l0.3574275,0.5122775", "l0.3566331,0.5113006", "l0.3552733,0.5109132", "l0.3547691,0.5092626", "l0.3542496,0.5061803", "l0.3522328,0.5042433", "l0.3500022,0.5046644", "l0.3488563,0.5060455", "l0.3467173,0.5068372", "l0.3399183,0.5070730", "l0.3378863,0.5074772", "l0.3321262,0.5116375", "l0.3297733,0.5121933", "l0.3281844,0.5115870", "l0.3256328,0.5122270", "l0.3222716,0.5117722", "l0.3191089,0.5088752", "l0.3159462,0.5069551", "l0.3136392,0.5074941", "l0.3120196,0.5083867", "l0.3101709,0.5087405", "l0.3066416,0.5082352", "l0.2964355,0.5143156", "l0.2978258,0.5092626", "l0.2989412,0.5073761", "l0.2967869,0.5041591", "l0.2916075,0.5019863", "l0.2871003,0.5023232", "l0.2843043,0.5006725", "l0.2817986,0.4938173", "l0.2817681,0.4931605", "l0.2820889,0.4915267", "l0.2827917,0.4901455", "l0.2839682,0.4893034", "l0.2880934,0.4877875", "l0.2904616,0.4858168", "l0.2913936,0.4777657", "l0.2943729,0.4738918", "l0.3020580,0.4715001", "l0.3032956,0.4706916", "l0.3034025,0.4694283", "l0.3036928,0.4678282", "l0.3089334,0.4562064", "l0.3087959,0.4532588", "l0.3090098,0.4495533", "l0.3101709,0.4468247", "l0.3144642,0.4428834", "l0.3226841,0.4374936", "l0.3442421,0.4312279", "l0.3474812,0.4290214", "l0.3503841,0.4263097", "l0.3536385,0.4251643", "l0.3566025,0.4251475", "l0.3579929,0.4224357", "l0.3629278,0.4092475", "l0.3635390,0.4051377", "l0.3620722,0.4042787", "l0.3609875,0.4012975", "l0.3625459,0.3877555", "l0.3631570,0.3857343", "l0.3650974,0.3835784", "l0.3700324,0.3812035", "l0.3812010,0.3797887", "l0.3852040,0.3800245", "l0.4026521,0.3750220", "l0.4126596,0.3810014", "l0.4177168,0.3819277", "c"]}, {"n": "Bushehr", "u": "IR-06", "i": ["m0.3269926,0.7334629", "l0.3269926,0.7334629", "l0.3264732,0.7335471", "l0.3259537,0.7330250", "l0.3254495,0.7315933", "l0.3251286,0.7303132", "l0.3247467,0.7295384", "l0.3253578,0.7291173", "l0.3259231,0.7293868", "l0.3268551,0.7298416", "l0.3274052,0.7302121", "l0.3271760,0.7313406", "l0.3273288,0.7324691", "l0.3269926,0.7334629", "c", "m0.3797495,0.7125436", "l0.3797495,0.7125436", "l0.3830803,0.7164007", "l0.3872055,0.7181018", "l0.3917891,0.7227506", "l0.4150125,0.7710233", "l0.4162042,0.7768847", "l0.4237824,0.8005326", "l0.4250811,0.8028907", "l0.4273728,0.8039013", "l0.4290993,0.8050298", "l0.4329954,0.8100659", "l0.4400082,0.8273976", "l0.4468377,0.8366951", "l0.4534686,0.8435839", "l0.4638122,0.8518203", "l0.4615816,0.8532351", "l0.4608788,0.8535215", "l0.4584647,0.8534035", "l0.4558979,0.8526793", "l0.4550576,0.8526456", "l0.4516811,0.8530162", "l0.4511157,0.8529825", "l0.4500615,0.8534878", "l0.4498323,0.8534541", "l0.4495421,0.8538415", "l0.4487017,0.8556437", "l0.4487017,0.8556437", "l0.4446835,0.8536730", "l0.4436292,0.8524435", "l0.4435376,0.8511297", "l0.4440265,0.8503044", "l0.4448974,0.8498833", "l0.4459669,0.8497654", "l0.4469447,0.8497991", "l0.4480600,0.8496644", "l0.4487017,0.8490412", "l0.4482434,0.8475253", "l0.4474183,0.8467505", "l0.4453252,0.8458578", "l0.4445460,0.8451335", "l0.4441334,0.8443756", "l0.4432931,0.8422702", "l0.4429417,0.8416133", "l0.4390610,0.8371835", "l0.4373650,0.8357013", "l0.4354705,0.8347918", "l0.4262422,0.8325516", "l0.4243019,0.8314737", "l0.4181904,0.8252080", "l0.4162959,0.8237931", "l0.4141569,0.8227994", "l0.4116970,0.8224288", "l0.4081066,0.8229173", "l0.4072815,0.8226310", "l0.4063190,0.8219572", "l0.4044703,0.8221088", "l0.4024688,0.8226310", "l0.3992297,0.8232878", "l0.3971977,0.8229341", "l0.3927210,0.8219067", "l0.3921099,0.8217383", "l0.3918502,0.8213172", "l0.3917891,0.8206940", "l0.3916210,0.8202224", "l0.3913460,0.8199024", "l0.3897264,0.8196497", "l0.3875263,0.8189086", "l0.3864110,0.8175948", "l0.3852345,0.8153884", "l0.3839817,0.8145125", "l0.3835845,0.8163147", "l0.3825302,0.8164158", "l0.3815066,0.8125587", "l0.3804982,0.8109418", "l0.3797037,0.8086005", "l0.3777480,0.8050803", "l0.3768619,0.8041539", "l0.3757924,0.8029244", "l0.3755327,0.8016274", "l0.3766785,0.7981409", "l0.3766022,0.7964229", "l0.3755327,0.7945028", "l0.3737298,0.7927005", "l0.3731034,0.7918584", "l0.3712699,0.7887255", "l0.3695740,0.7867212", "l0.3691768,0.7860643", "l0.3660141,0.7774237", "l0.3655863,0.7753857", "l0.3655405,0.7671157", "l0.3648835,0.7643028", "l0.3637223,0.7619111", "l0.3624084,0.7601931", "l0.3607277,0.7590478", "l0.3585582,0.7584751", "l0.3564497,0.7583572", "l0.3554261,0.7580372", "l0.3549830,0.7573466", "l0.3546010,0.7560665", "l0.3521564,0.7526642", "l0.3517439,0.7514346", "l0.3514231,0.7496324", "l0.3516217,0.7480154", "l0.3526912,0.7473249", "l0.3536996,0.7477123", "l0.3547232,0.7486555", "l0.3555788,0.7498345", "l0.3560830,0.7509125", "l0.3566178,0.7503903", "l0.3565567,0.7499187", "l0.3563275,0.7493797", "l0.3564039,0.7486555", "l0.3567706,0.7481839", "l0.3578095,0.7471564", "l0.3581609,0.7464659", "l0.3583443,0.7450510", "l0.3582068,0.7435351", "l0.3577026,0.7425919", "l0.3567553,0.7428614", "l0.3563122,0.7409750", "l0.3559608,0.7403012", "l0.3553344,0.7397117", "l0.3550288,0.7397791", "l0.3545552,0.7400654", "l0.3541121,0.7402170", "l0.3539288,0.7399307", "l0.3538676,0.7388190", "l0.3537607,0.7382800", "l0.3535773,0.7379263", "l0.3523398,0.7376905", "l0.3482910,0.7379600", "l0.3473590,0.7381453", "l0.3459839,0.7390380", "l0.3445477,0.7388527", "l0.3434018,0.7377411", "l0.3429435,0.7359220", "l0.3428518,0.7343387", "l0.3429893,0.7335303", "l0.3434629,0.7327555", "l0.3438296,0.7318628", "l0.3441657,0.7307848", "l0.3446394,0.7302964", "l0.3454186,0.7312227", "l0.3456478,0.7285615", "l0.3457700,0.7281067", "l0.3452658,0.7279215", "l0.3449450,0.7275341", "l0.3443185,0.7262708", "l0.3446852,0.7246707", "l0.3446699,0.7221274", "l0.3444102,0.7195167", "l0.3439977,0.7177481", "l0.3433254,0.7163838", "l0.3423170,0.7148679", "l0.3415226,0.7144469", "l0.3414920,0.7164007", "l0.3412017,0.7156764", "l0.3397350,0.7132342", "l0.3370001,0.7107414", "l0.3365570,0.7098992", "l0.3362056,0.7087707", "l0.3353806,0.7075075", "l0.3336999,0.7056210", "l0.3306289,0.7042567", "l0.3301706,0.7035830", "l0.3298344,0.7022692", "l0.3290858,0.7010228", "l0.3276954,0.6993048", "l0.3263051,0.6970815", "l0.3239522,0.6923317", "l0.3227146,0.6903274", "l0.3217368,0.6893841", "l0.3196131,0.6879356", "l0.3175963,0.6856449", "l0.3174130,0.6853418", "l0.3172602,0.6845501", "l0.3172143,0.6833374", "l0.3170310,0.6826468", "l0.3178408,0.6825458", "l0.3180241,0.6821584", "l0.3177185,0.6816699", "l0.3170310,0.6812994", "l0.3175810,0.6790592", "l0.3164046,0.6753369", "l0.3167102,0.6736020", "l0.3159768,0.6729788", "l0.3151670,0.6717661", "l0.3144795,0.6704355", "l0.3142045,0.6693407", "l0.3138989,0.6686501", "l0.3131350,0.6680774", "l0.3127224,0.6678922", "l0.3127072,0.6678922", "l0.3160379,0.6660563", "l0.3213701,0.6650793", "l0.3243494,0.6666795", "l0.3323401,0.6671342", "l0.3383904,0.6695428", "l0.3403155,0.6710755", "l0.3412170,0.6720188", "l0.3412170,0.6754043", "l0.3426073,0.6801709", "l0.3452047,0.6830342", "l0.3483674,0.6901252", "l0.3513161,0.6913716", "l0.3627445,0.6923149", "l0.3698490,0.6948582", "l0.3733173,0.6991195", "l0.3760980,0.7061600", "l0.3797495,0.7125436", "c"]}, {"n": "Kohgiluyeh and Buyer Ahmad", "u": "IR-18", "i": ["m0.3361598,0.5893185", "l0.3361598,0.5893185", "l0.3388794,0.5891501", "l0.3404683,0.5893690", "l0.3597193,0.6082840", "l0.3614916,0.6082503", "l0.3674197,0.6091093", "l0.3702310,0.6074923", "l0.3727978,0.6049995", "l0.3761438,0.6042921", "l0.3779161,0.6044437", "l0.3782828,0.6088903", "l0.3811399,0.6170593", "l0.3867166,0.6236113", "l0.3939586,0.6293717", "l0.3950128,0.6305002", "l0.3965407,0.6387871", "l0.3965712,0.6419536", "l0.3962810,0.6426105", "l0.3949670,0.6440590", "l0.3924155,0.6457265", "l0.3895431,0.6465855", "l0.3840581,0.6450191", "l0.3821330,0.6437221", "l0.3809718,0.6421052", "l0.3796579,0.6417852", "l0.3737298,0.6386018", "l0.3695129,0.6374396", "l0.3687337,0.6384334", "l0.3695893,0.6440085", "l0.3712241,0.6490614", "l0.3713310,0.6505605", "l0.3706130,0.6519753", "l0.3709949,0.6534238", "l0.3722630,0.6557650", "l0.3722019,0.6591842", "l0.3711019,0.6617275", "l0.3572900,0.6706376", "l0.3550899,0.6710250", "l0.3464117,0.6704355", "l0.3412170,0.6718503", "l0.3412170,0.6720188", "l0.3403155,0.6710755", "l0.3383904,0.6695428", "l0.3323401,0.6671342", "l0.3314540,0.6567588", "l0.3304761,0.6523627", "l0.3288261,0.6502910", "l0.3284594,0.6468550", "l0.3314540,0.6390902", "l0.3305678,0.6355868", "l0.3276496,0.6332456", "l0.3227146,0.6303486", "l0.3186658,0.6259188", "l0.3165879,0.6229544", "l0.3077569,0.6242513", "l0.3074055,0.6226176", "l0.3079250,0.6204448", "l0.3081542,0.6184573", "l0.3084139,0.6174635", "l0.3082611,0.6147686", "l0.3059082,0.6053532", "l0.3058624,0.6014625", "l0.3067180,0.5992897", "l0.3080319,0.5973695", "l0.3097890,0.5958873", "l0.3137767,0.5940346", "l0.3199645,0.5879037", "l0.3234174,0.5828170", "l0.3270843,0.5852929", "l0.3361598,0.5893185", "c"]}]} """;
}
