import 'package:flutter/material.dart';

class SMapPeruColors {
  /// Amazonas
  final Color? peAMA;

  /// Ancash
  final Color? peANC;

  /// Apurímac
  final Color? peAPU;

  /// Arequipa
  final Color? peARE;

  /// Ayacucho
  final Color? peAYA;

  /// Cajamarca
  final Color? peCAJ;

  /// El Callao
  final Color? peCAL;

  /// Cusco
  final Color? peCUS;

  /// Huánuco
  final Color? peHUC;

  /// Huancavelica
  final Color? peHUV;

  /// Ica
  final Color? peICA;

  /// Junín
  final Color? peJUN;

  /// La Libertad
  final Color? peLAL;

  /// Lambayeque
  final Color? peLAM;

  /// Lima
  final Color? peLIM;

  /// Municipalidad Metropolitana de Lima
  final Color? peLMA;

  /// Loreto
  final Color? peLOR;

  /// Madre de Dios
  final Color? peMDD;

  /// Moquegua
  final Color? peMOQ;

  /// Pasco
  final Color? pePAS;

  /// Piura
  final Color? pePIU;

  /// Puno
  final Color? pePUN;

  /// San Martín
  final Color? peSAM;

  /// Tacna
  final Color? peTAC;

  /// Tumbes
  final Color? peTUM;

  /// Ucayali
  final Color? peUCA;

  /// Lake Titicaca
  final Color? peLKT;
  SMapPeruColors({
    this.peAMA,
    this.peANC,
    this.peAPU,
    this.peARE,
    this.peAYA,
    this.peCAJ,
    this.peCAL,
    this.peCUS,
    this.peHUC,
    this.peHUV,
    this.peICA,
    this.peJUN,
    this.peLAL,
    this.peLAM,
    this.peLIM,
    this.peLMA,
    this.peLOR,
    this.peMDD,
    this.peMOQ,
    this.pePAS,
    this.pePIU,
    this.pePUN,
    this.peSAM,
    this.peTAC,
    this.peTUM,
    this.peUCA,
    this.peLKT,
  });
  Map<String, Color?> toMap() {
    return {
      "PE-AMA": peAMA,
      "PE-ANC": peANC,
      "PE-APU": peAPU,
      "PE-ARE": peARE,
      "PE-AYA": peAYA,
      "PE-CAJ": peCAJ,
      "PE-CAL": peCAL,
      "PE-CUS": peCUS,
      "PE-HUC": peHUC,
      "PE-HUV": peHUV,
      "PE-ICA": peICA,
      "PE-JUN": peJUN,
      "PE-LAL": peLAL,
      "PE-LAM": peLAM,
      "PE-LIM": peLIM,
      "PE-LMA": peLMA,
      "PE-LOR": peLOR,
      "PE-MDD": peMDD,
      "PE-MOQ": peMOQ,
      "PE-PAS": pePAS,
      "PE-PIU": pePIU,
      "PE-PUN": pePUN,
      "PE-SAM": peSAM,
      "PE-TAC": peTAC,
      "PE-TUM": peTUM,
      "PE-UCA": peUCA,
      "PE-LKT": peLKT,
    };
  }

  static SMapPeruColors fromMap(Map<String, Color?> map) {
    return SMapPeruColors(
      peAMA: map["PE-AMA"],
      peANC: map["PE-ANC"],
      peAPU: map["PE-APU"],
      peARE: map["PE-ARE"],
      peAYA: map["PE-AYA"],
      peCAJ: map["PE-CAJ"],
      peCAL: map["PE-CAL"],
      peCUS: map["PE-CUS"],
      peHUC: map["PE-HUC"],
      peHUV: map["PE-HUV"],
      peICA: map["PE-ICA"],
      peJUN: map["PE-JUN"],
      peLAL: map["PE-LAL"],
      peLAM: map["PE-LAM"],
      peLIM: map["PE-LIM"],
      peLMA: map["PE-LMA"],
      peLOR: map["PE-LOR"],
      peMDD: map["PE-MDD"],
      peMOQ: map["PE-MOQ"],
      pePAS: map["PE-PAS"],
      pePIU: map["PE-PIU"],
      pePUN: map["PE-PUN"],
      peSAM: map["PE-SAM"],
      peTAC: map["PE-TAC"],
      peTUM: map["PE-TUM"],
      peUCA: map["PE-UCA"],
      peLKT: map["PE-LKT"],
    );
  }
}

class SMapPeru {
  static const String instructions =
      """{"n": "Peru", "w": 542.76703, "h": 792.0, "g": {"a": "-81.390559,-0.036136","b": "-68.672457,-18.388935"}, "i":[{"n": "Amazonas", "u": "PE-AMA", "i": ["m0.2839966,0.3711553", "l0.2816199,0.3715114", "l0.2763506,0.3728308", "l0.2715511,0.3735821", "l0.2715511,0.3713258", "l0.2703149,0.3656831", "l0.2682569,0.3637083", "l0.2658120,0.3620328", "l0.2657991,0.3615543", "l0.2561394,0.3481174", "l0.2529207,0.3447652", "l0.2453797,0.3416591", "l0.2426216,0.3411199", "l0.2400146,0.3401288", "l0.2386401,0.3387412", "l0.2378553,0.3375215", "l0.2368180,0.3356692", "l0.2350788,0.3327626", "l0.2308081,0.3278636", "l0.2232505,0.3240051", "l0.2219737,0.3234722", "l0.2222611,0.3197298", "l0.2174248,0.3168876", "l0.2132775,0.3145202", "l0.2132775,0.3097841", "l0.2160411,0.3055227", "l0.2181157,0.3017336", "l0.2188066,0.2979457", "l0.2215702,0.2932096", "l0.2250247,0.2898939", "l0.2250247,0.2851591", "l0.2215702,0.2837374", "l0.2185505,0.2831465", "l0.2183865,0.2824520", "l0.2146593,0.2823169", "l0.2091321,0.2785290", "l0.2091321,0.2737929", "l0.2091321,0.2690568", "l0.2118957,0.2652677", "l0.2146593,0.2619533", "l0.2169513,0.2561957", "l0.2162272,0.2554394", "l0.2155492,0.2544167", "l0.2152434,0.2528422", "l0.2126013,0.2466944", "l0.2107774,0.2437437", "l0.2127745,0.2431881", "l0.2140974,0.2421364", "l0.2153963,0.2377727", "l0.2151955,0.2347677", "l0.2138358,0.2319482", "l0.2136497,0.2306136", "l0.2136828,0.2288321", "l0.2146741,0.2284874", "l0.2160853,0.2272955", "l0.2222132,0.2174760", "l0.2226499,0.2162689", "l0.2228470,0.2148674", "l0.2228562,0.2128914", "l0.2229999,0.2111995", "l0.2240040,0.2086957", "l0.2247244,0.2076667", "l0.2298371,0.2033586", "l0.2334298,0.2008561", "l0.2339659,0.2003561", "l0.2351230,0.1987235", "l0.2359742,0.1968611", "l0.2372436,0.1927033", "l0.2376692,0.1894280", "l0.2373855,0.1876515", "l0.2376029,0.1865038", "l0.2388373,0.1831970", "l0.2393181,0.1820341", "l0.2406281,0.1810808", "l0.2428353,0.1805745", "l0.2445616,0.1806932", "l0.2459803,0.1814836", "l0.2466473,0.1829356", "l0.2464170,0.1864293", "l0.2471171,0.1865859", "l0.2522721,0.1840303", "l0.2531252,0.1829432", "l0.2522887,0.1808611", "l0.2505366,0.1797513", "l0.2495730,0.1780417", "l0.2507761,0.1766351", "l0.2527088,0.1755543", "l0.2554190,0.1744811", "l0.2573848,0.1735063", "l0.2612521,0.1702513", "l0.2638296,0.1670833", "l0.2724079,0.1608523", "l0.2775813,0.1579495", "l0.2814633,0.1570025", "l0.2843430,0.1656187", "l0.2846709,0.1710253", "l0.2848662,0.1727172", "l0.2856437,0.1743624", "l0.2887113,0.1777740", "l0.2913552,0.1814167", "l0.2919890,0.1827942", "l0.2953422,0.1931124", "l0.2948945,0.1953851", "l0.2946752,0.1975164", "l0.2948503,0.1988573", "l0.2953311,0.2000051", "l0.2964016,0.2014659", "l0.2993936,0.2041035", "l0.3002688,0.2049975", "l0.3009247,0.2059962", "l0.3013171,0.2072045", "l0.3020154,0.2150985", "l0.3012508,0.2161793", "l0.3000938,0.2255732", "l0.2999740,0.2283914", "l0.3004862,0.2295846", "l0.3009247,0.2313750", "l0.3002688,0.2344318", "l0.2997216,0.2359987", "l0.2946863,0.2432639", "l0.2927647,0.2453447", "l0.2912889,0.2461578", "l0.2896510,0.2473510", "l0.2882323,0.2486199", "l0.2868100,0.2501124", "l0.2854337,0.2524242", "l0.2843430,0.2550366", "l0.2839063,0.2581553", "l0.2840574,0.2597967", "l0.2846894,0.2623056", "l0.2796172,0.2662159", "l0.2796172,0.2700038", "l0.2872190,0.2742664", "l0.2877533,0.2744495", "l0.2885603,0.2774596", "l0.2893249,0.2790278", "l0.2940636,0.2860328", "l0.2948503,0.2867348", "l0.2938664,0.2870631", "l0.2919024,0.2881831", "l0.2901318,0.2897891", "l0.2892143,0.2908725", "l0.2887777,0.2924419", "l0.2880683,0.3037538", "l0.2891480,0.3056957", "l0.2903069,0.3074154", "l0.2984761,0.3181048", "l0.3017317,0.3206010", "l0.3038099,0.3212172", "l0.3060024,0.3215960", "l0.3095674,0.3220934", "l0.3130164,0.3226439", "l0.3160767,0.3231616", "l0.3231257,0.3248624", "l0.3269819,0.3276288", "l0.3289349,0.3298018", "l0.3299003,0.3313573", "l0.3314000,0.3338561", "l0.3326676,0.3373636", "l0.3309744,0.3395644", "l0.3281224,0.3411654", "l0.3252169,0.3424003", "l0.3233597,0.3433573", "l0.3218305,0.3446301", "l0.3205740,0.3463434", "l0.3199199,0.3478712", "l0.3191443,0.3499886", "l0.3183134,0.3512159", "l0.3176243,0.3514861", "l0.3176243,0.3538270", "l0.3134789,0.3571414", "l0.3093316,0.3585619", "l0.3038044,0.3557210", "l0.2955117,0.3552475", "l0.2913644,0.3557210", "l0.2871840,0.3581452", "l0.2861559,0.3635177", "l0.2848883,0.3653826", "l0.2835563,0.3679899", "l0.2834255,0.3699975", "c"]}, {"n": "Ancash", "u": "PE-ANC", "i": ["m0.3162388,0.4503939", "l0.3195791,0.4545581", "l0.3249055,0.4537475", "l0.3242404,0.4566629", "l0.3242404,0.4611414", "l0.3296755,0.4634331", "l0.3293992,0.4704571", "l0.3300882,0.4713030", "l0.3343055,0.4762184", "l0.3364980,0.4781174", "l0.3453176,0.4809242", "l0.3531386,0.4845909", "l0.3634303,0.4885404", "l0.3696042,0.4913624", "l0.3691934,0.4958750", "l0.3667227,0.4978497", "l0.3626068,0.4984141", "l0.3567921,0.4986894", "l0.3563684,0.4990922", "l0.3532879,0.5038258", "l0.3487095,0.5109318", "l0.3449067,0.5113902", "l0.3440832,0.5142121", "l0.3428469,0.5187260", "l0.3453507,0.5184545", "l0.3494335,0.5198548", "l0.3543730,0.5218295", "l0.3580800,0.5260619", "l0.3593125,0.5300114", "l0.3597252,0.5364987", "l0.3568437,0.5390379", "l0.3535513,0.5412942", "l0.3551966,0.5449621", "l0.3539622,0.5483472", "l0.3527278,0.5503220", "l0.3505703,0.5514596", "l0.3505703,0.5517652", "l0.3473258,0.5524533", "l0.3353207,0.5557866", "l0.3338136,0.5566566", "l0.3326768,0.5583624", "l0.3325552,0.5602412", "l0.3320651,0.5618207", "l0.3311365,0.5631149", "l0.3296516,0.5643699", "l0.3261455,0.5668902", "l0.3119018,0.5753270", "l0.3057186,0.5768864", "l0.2989036,0.5769167", "l0.2975273,0.5711944", "l0.2984614,0.5688106", "l0.2979750,0.5675770", "l0.2926431,0.5651111", "l0.2914989,0.5616793", "l0.2922156,0.5599129", "l0.2942736,0.5579394", "l0.2979787,0.5562462", "l0.2983895,0.5525795", "l0.2946844,0.5514508", "l0.2897449,0.5520139", "l0.2872761,0.5539899", "l0.2839819,0.5559634", "l0.2840095,0.5560896", "l0.2835452,0.5561995", "l0.2830957,0.5593030", "l0.2822684,0.5641578", "l0.2809014,0.5665000", "l0.2748288,0.5695013", "l0.2747864,0.5689697", "l0.2731798,0.5663068", "l0.2710058,0.5644154", "l0.2658820,0.5592424", "l0.2610770,0.5536780", "l0.2526425,0.5409672", "l0.2477509,0.5323876", "l0.2464170,0.5292323", "l0.2472700,0.5266212", "l0.2471723,0.5250732", "l0.2398801,0.5188447", "l0.2368272,0.5154684", "l0.2349701,0.5102866", "l0.2346642,0.5050770", "l0.2319559,0.5015505", "l0.2283724,0.4997702", "l0.2261449,0.4947222", "l0.2255977,0.4912260", "l0.2213399,0.4881982", "l0.2162217,0.4856376", "l0.2143332,0.4800644", "l0.2149154,0.4800644", "l0.2174985,0.4796831", "l0.2194662,0.4764482", "l0.2189577,0.4745480", "l0.2192746,0.4725152", "l0.2213381,0.4701439", "l0.2232615,0.4688207", "l0.2248239,0.4684066", "l0.2358231,0.4659457", "l0.2465386,0.4633725", "l0.2488324,0.4604217", "l0.2487771,0.4591616", "l0.2545217,0.4483939", "l0.2573682,0.4441477", "l0.2624533,0.4410442", "l0.2636564,0.4403384", "l0.2662984,0.4391806", "l0.2678718,0.4387753", "l0.2706778,0.4374975", "l0.2770028,0.4312172", "l0.2922304,0.4292045", "l0.2939770,0.4293548", "l0.2943694,0.4309470", "l0.2960534,0.4343876", "l0.2967498,0.4353788", "l0.2984116,0.4365366", "l0.3023452,0.4390758", "l0.3051401,0.4400366", "l0.3067357,0.4404886", "c"]}, {"n": "Apurímac", "u": "PE-APU", "i": ["m0.6740019,0.7932702", "l0.6694898,0.7926515", "l0.6633380,0.7922854", "l0.6576542,0.7900316", "l0.6564327,0.7910177", "l0.6546713,0.7901136", "l0.6493191,0.7906768", "l0.6406745,0.7929343", "l0.6336752,0.7932159", "l0.6246197,0.7957551", "l0.6213255,0.7982942", "l0.6170585,0.7998333", "l0.6166660,0.7995657", "l0.6159236,0.7985568", "l0.6147426,0.7948851", "l0.6130955,0.7929343", "l0.6139172,0.7878548", "l0.6126828,0.7830606", "l0.6093885,0.7788283", "l0.6126828,0.7751616", "l0.6147407,0.7729040", "l0.6172114,0.7698018", "l0.6172114,0.7672348", "l0.6160323,0.7660265", "l0.6124727,0.7627664", "l0.6110946,0.7606503", "l0.6101771,0.7585556", "l0.6054587,0.7495025", "l0.6009798,0.7434583", "l0.6016486,0.7421402", "l0.6044324,0.7418573", "l0.6054863,0.7409962", "l0.6013243,0.7364672", "l0.5988831,0.7358232", "l0.5972673,0.7353965", "l0.5958800,0.7333295", "l0.5951688,0.7318763", "l0.5932472,0.7229255", "l0.5929855,0.7215947", "l0.5927442,0.7198902", "l0.5943065,0.7148977", "l0.5963700,0.7117348", "l0.5979103,0.7113384", "l0.6000199,0.7121629", "l0.6016633,0.7142336", "l0.6215263,0.7241957", "l0.6222615,0.7242879", "l0.6272968,0.7238182", "l0.6342924,0.7224066", "l0.6355766,0.7192702", "l0.6368091,0.7203409", "l0.6410780,0.7225076", "l0.6501427,0.7226894", "l0.6591520,0.7228561", "l0.6617112,0.7221452", "l0.6672716,0.7219621", "l0.6749341,0.7238914", "l0.6776812,0.7248826", "l0.6898282,0.7302841", "l0.7069110,0.7361957", "l0.7165689,0.7385051", "l0.7211768,0.7405253", "l0.7256778,0.7435429", "l0.7265511,0.7444773", "l0.7286717,0.7472146", "l0.7315109,0.7509596", "l0.7320341,0.7521086", "l0.7322976,0.7534419", "l0.7321097,0.7604962", "l0.7315109,0.7625821", "l0.7294235,0.7672475", "l0.7281024,0.7689508", "l0.7263558,0.7696566", "l0.7250440,0.7702929", "l0.7193528,0.7744078", "l0.7185016,0.7753838", "l0.7179876,0.7769646", "l0.7168287,0.7780707", "l0.7126133,0.7793927", "l0.7079612,0.7809129", "l0.7016417,0.7831881", "l0.6994308,0.7849242", "l0.6986773,0.7862765", "l0.6991895,0.7874230", "l0.7004663,0.7890063", "l0.7005768,0.7911667", "l0.7001825,0.7924735", "l0.6956613,0.7931338", "l0.6901764,0.7938106", "l0.6833079,0.7933043", "l0.6804890,0.7921275", "l0.6779981,0.7915354", "l0.6762828,0.7916503", "c"]}, {"n": "Arequipa", "u": "PE-ARE", "i": ["m0.7879218,0.9311932", "l0.7840344,0.9324154", "l0.7790341,0.9348144", "l0.7711356,0.9364066", "l0.7648899,0.9346035", "l0.7631433,0.9342462", "l0.7583161,0.9336540", "l0.7537378,0.9330770", "l0.7513684,0.9323611", "l0.7471511,0.9302184", "l0.7454819,0.9281023", "l0.7442346,0.9270821", "l0.7402937,0.9251995", "l0.7372132,0.9242033", "l0.7347978,0.9235328", "l0.7284746,0.9208106", "l0.7201064,0.9164861", "l0.7149789,0.9129886", "l0.7113918,0.9096149", "l0.7097299,0.9084495", "l0.7023805,0.9055429", "l0.6996261,0.9046667", "l0.6928221,0.9032917", "l0.6900567,0.9028409", "l0.6872728,0.9027790", "l0.6856551,0.9027172", "l0.6831200,0.9025770", "l0.6809551,0.9023977", "l0.6760654,0.9013497", "l0.6741548,0.9002563", "l0.6715754,0.8984545", "l0.6689868,0.8971263", "l0.6672071,0.8963826", "l0.6648138,0.8958699", "l0.6579121,0.8940076", "l0.6412862,0.8890732", "l0.6350662,0.8853737", "l0.6277629,0.8828561", "l0.6240725,0.8818952", "l0.6122535,0.8791515", "l0.6094991,0.8787020", "l0.5940044,0.8748952", "l0.5838748,0.8692854", "l0.5811665,0.8676742", "l0.5774743,0.8642071", "l0.5676100,0.8605480", "l0.5609147,0.8591629", "l0.5540443,0.8579684", "l0.5500997,0.8566578", "l0.5481560,0.8559003", "l0.5463431,0.8547323", "l0.5456006,0.8530543", "l0.5431815,0.8506970", "l0.5404234,0.8496843", "l0.5310934,0.8470896", "l0.5261576,0.8455593", "l0.5176604,0.8423927", "l0.5133344,0.8407096", "l0.5042679,0.8378523", "l0.4984348,0.8363939", "l0.4963584,0.8349962", "l0.4945234,0.8336742", "l0.4963511,0.8304545", "l0.4988218,0.8253763", "l0.5049957,0.8200164", "l0.5124058,0.8171957", "l0.5159728,0.8159722", "l0.5231968,0.8152096", "l0.5233682,0.8155795", "l0.5239762,0.8154129", "l0.5244644,0.8169975", "l0.5259715,0.8180758", "l0.5290631,0.8186616", "l0.5310934,0.8188624", "l0.5374940,0.8198952", "l0.5442132,0.8211048", "l0.5465826,0.8260467", "l0.5485982,0.8304710", "l0.5575818,0.8365644", "l0.5598885,0.8375278", "l0.5623997,0.8379306", "l0.5647709,0.8379520", "l0.5665175,0.8376212", "l0.5688002,0.8366023", "l0.5706574,0.8355833", "l0.5724721,0.8353485", "l0.5736734,0.8387172", "l0.5741082,0.8427778", "l0.5748894,0.8442727", "l0.5775590,0.8442311", "l0.5804074,0.8431124", "l0.5809859,0.8384937", "l0.5842783,0.8336982", "l0.5863363,0.8305947", "l0.5937465,0.8280556", "l0.5982751,0.8266452", "l0.5978624,0.8297487", "l0.5999204,0.8336982", "l0.6032478,0.8349811", "l0.6138269,0.8340972", "l0.6182174,0.8326806", "l0.6200303,0.8319722", "l0.6233927,0.8308535", "l0.6252185,0.8309684", "l0.6283009,0.8321540", "l0.6320299,0.8310177", "l0.6340879,0.8281970", "l0.6373803,0.8253763", "l0.6443796,0.8242475", "l0.6480847,0.8205795", "l0.6530223,0.8160657", "l0.6554930,0.8121162", "l0.6546713,0.8084495", "l0.6542586,0.8042172", "l0.6559057,0.8005505", "l0.6583764,0.7977298", "l0.6612561,0.7968838", "l0.6657847,0.7960366", "l0.6670707,0.7925076", "l0.6694898,0.7926515", "l0.6740019,0.7932702", "l0.6762828,0.7916503", "l0.6779981,0.7915354", "l0.6804890,0.7921275", "l0.6833079,0.7933043", "l0.6901764,0.7938106", "l0.6956613,0.7931338", "l0.7001825,0.7924735", "l0.6995893,0.7948801", "l0.7006192,0.7964268", "l0.7036352,0.7989962", "l0.7053929,0.8004419", "l0.7067157,0.8010581", "l0.7113365,0.8018043", "l0.7133779,0.8017816", "l0.7217793,0.8006414", "l0.7298509,0.8028283", "l0.7312327,0.8039747", "l0.7333036,0.8039129", "l0.7352676,0.8018270", "l0.7366549,0.7987348", "l0.7365130,0.7965328", "l0.7354537,0.7952955", "l0.7346338,0.7940341", "l0.7358148,0.7923737", "l0.7380091,0.7922803", "l0.7397354,0.7930051", "l0.7461028,0.7985038", "l0.7506904,0.8028586", "l0.7502980,0.8111187", "l0.7492717,0.8123283", "l0.7495665,0.8136578", "l0.7520243,0.8146856", "l0.7536622,0.8150871", "l0.7646504,0.8171048", "l0.7722098,0.8146856", "l0.7768619,0.8127765", "l0.7770221,0.8115278", "l0.7852301,0.8130922", "l0.7881042,0.8147551", "l0.7905381,0.8165051", "l0.7922865,0.8172134", "l0.7939686,0.8169747", "l0.7957816,0.8155328", "l0.7970049,0.8148245", "l0.7989155,0.8144937", "l0.8001886,0.8148106", "l0.8008040,0.8187462", "l0.7999823,0.8286212", "l0.8049218,0.8325707", "l0.8098613,0.8334154", "l0.8151121,0.8329659", "l0.8150053,0.8360770", "l0.8159633,0.8417134", "l0.8182406,0.8438295", "l0.8198342,0.8450189", "l0.8217798,0.8459912", "l0.8233201,0.8468409", "l0.8243666,0.8476831", "l0.8249359,0.8488207", "l0.8245858,0.8500480", "l0.8225371,0.8523005", "l0.8219549,0.8544886", "l0.8260984,0.8592210", "l0.8291513,0.8607879", "l0.8300578,0.8620480", "l0.8296211,0.8636503", "l0.8288529,0.8654571", "l0.8283222,0.8678447", "l0.8283001,0.8705694", "l0.8284641,0.8733422", "l0.8283554,0.8756187", "l0.8282025,0.8771061", "l0.8275797,0.8799495", "l0.8263877,0.8812904", "l0.8243574,0.8829646", "l0.8226089,0.8840808", "l0.8208844,0.8851970", "l0.8199448,0.8865076", "l0.8199448,0.8879179", "l0.8206246,0.8893131", "l0.8176842,0.8901199", "l0.8123301,0.8889912", "l0.8061562,0.8858876", "l0.8028638,0.8847588", "l0.7991587,0.8847588", "l0.7975116,0.8867348", "l0.7991587,0.8884268", "l0.8020402,0.8904015", "l0.8040982,0.8912475", "l0.8049936,0.8925518", "l0.8003157,0.8940770", "l0.7927140,0.9011907", "l0.7934767,0.9045265", "l0.7927140,0.9074583", "l0.7908218,0.9080758", "l0.7881356,0.9087374", "l0.7830468,0.9116364", "l0.7821054,0.9125530", "l0.7816134,0.9137260", "l0.7816705,0.9151338", "l0.7823246,0.9169533", "l0.7849685,0.9208813", "l0.7864332,0.9218384", "l0.7901677,0.9253384", "c"]}, {"n": "Ayacucho", "u": "PE-AYA", "i": ["m0.6032478,0.8349811", "l0.5999204,0.8336982", "l0.5978624,0.8297487", "l0.5982751,0.8266452", "l0.5937465,0.8280556", "l0.5863363,0.8305947", "l0.5842783,0.8336982", "l0.5809859,0.8384937", "l0.5804074,0.8431124", "l0.5775590,0.8442311", "l0.5748894,0.8442727", "l0.5741082,0.8427778", "l0.5736734,0.8387172", "l0.5724721,0.8353485", "l0.5706574,0.8355833", "l0.5688002,0.8366023", "l0.5665175,0.8376212", "l0.5647709,0.8379520", "l0.5623997,0.8379306", "l0.5598885,0.8375278", "l0.5575818,0.8365644", "l0.5485982,0.8304710", "l0.5465826,0.8260467", "l0.5442132,0.8211048", "l0.5374940,0.8198952", "l0.5310934,0.8188624", "l0.5290631,0.8186616", "l0.5259715,0.8180758", "l0.5244644,0.8169975", "l0.5239762,0.8154129", "l0.5258518,0.8129306", "l0.5265500,0.8110657", "l0.5268135,0.8096944", "l0.5268135,0.8070467", "l0.5265187,0.8053838", "l0.5263179,0.8050556", "l0.5210910,0.8019609", "l0.5165623,0.7957551", "l0.5120355,0.7898308", "l0.5095648,0.7875745", "l0.5065801,0.7868434", "l0.5056276,0.7877462", "l0.5037870,0.7887828", "l0.4984238,0.7891705", "l0.4983188,0.7888687", "l0.4951572,0.7887020", "l0.4918648,0.7824949", "l0.4906285,0.7765720", "l0.4926884,0.7731856", "l0.4935101,0.7666982", "l0.4942047,0.7569482", "l0.4947574,0.7570657", "l0.4947463,0.7568232", "l0.4980387,0.7568232", "l0.5050362,0.7582336", "l0.5136808,0.7565429", "l0.5153279,0.7542854", "l0.5182094,0.7486427", "l0.5186203,0.7427184", "l0.5188690,0.7387955", "l0.5186092,0.7384306", "l0.5180086,0.7363750", "l0.5181836,0.7345619", "l0.5189851,0.7324722", "l0.5169824,0.7306351", "l0.5130931,0.7271780", "l0.5117389,0.7265354", "l0.5098394,0.7259078", "l0.5080246,0.7248902", "l0.5105800,0.7189040", "l0.5187401,0.7172462", "l0.5208054,0.7178801", "l0.5210099,0.7182033", "l0.5235598,0.7173295", "l0.5285012,0.7136616", "l0.5322044,0.7102765", "l0.5371457,0.7085833", "l0.5429088,0.7060455", "l0.5466139,0.7009672", "l0.5527878,0.6995568", "l0.5567287,0.6976275", "l0.5550153,0.6956540", "l0.5556343,0.6940758", "l0.5540222,0.6885543", "l0.5519643,0.6829116", "l0.5494954,0.6767058", "l0.5473435,0.6711768", "l0.5462933,0.6701288", "l0.5445928,0.6699659", "l0.5437324,0.6679596", "l0.5404381,0.6651389", "l0.5388389,0.6641212", "l0.5411659,0.6596503", "l0.5414773,0.6591957", "l0.5466139,0.6594975", "l0.5507298,0.6575227", "l0.5528652,0.6559369", "l0.5528873,0.6559634", "l0.5564929,0.6556894", "l0.5626668,0.6587929", "l0.5692534,0.6596389", "l0.5741929,0.6590732", "l0.5774853,0.6576629", "l0.5828394,0.6576629", "l0.5853082,0.6579457", "l0.5850798,0.6604634", "l0.5844183,0.6604343", "l0.5860139,0.6628333", "l0.5964953,0.6770278", "l0.6006039,0.6802576", "l0.6019433,0.6795934", "l0.6062012,0.6823523", "l0.6072274,0.6832058", "l0.6098141,0.6869293", "l0.6104203,0.6884621", "l0.6161815,0.6910934", "l0.6211210,0.6973005", "l0.6248261,0.7032235", "l0.6268841,0.7088662", "l0.6322344,0.7136616", "l0.6359414,0.7178927", "l0.6355231,0.7192260", "l0.6355766,0.7192702", "l0.6342924,0.7224066", "l0.6272968,0.7238182", "l0.6222615,0.7242879", "l0.6215263,0.7241957", "l0.6016633,0.7142336", "l0.6000199,0.7121629", "l0.5979103,0.7113384", "l0.5963700,0.7117348", "l0.5943065,0.7148977", "l0.5927442,0.7198902", "l0.5929855,0.7215947", "l0.5932472,0.7229255", "l0.5951688,0.7318763", "l0.5958800,0.7333295", "l0.5972673,0.7353965", "l0.5988831,0.7358232", "l0.6013243,0.7364672", "l0.6054863,0.7409962", "l0.6044324,0.7418573", "l0.6016486,0.7421402", "l0.6009798,0.7434583", "l0.6054587,0.7495025", "l0.6101771,0.7585556", "l0.6110946,0.7606503", "l0.6124727,0.7627664", "l0.6160323,0.7660265", "l0.6172114,0.7672348", "l0.6172114,0.7698018", "l0.6147407,0.7729040", "l0.6126828,0.7751616", "l0.6093885,0.7788283", "l0.6126828,0.7830606", "l0.6139172,0.7878548", "l0.6130955,0.7929343", "l0.6147426,0.7948851", "l0.6159236,0.7985568", "l0.6166660,0.7995657", "l0.6170585,0.7998333", "l0.6213255,0.7982942", "l0.6246197,0.7957551", "l0.6336752,0.7932159", "l0.6406745,0.7929343", "l0.6493191,0.7906768", "l0.6546713,0.7901136", "l0.6564327,0.7910177", "l0.6576542,0.7900316", "l0.6633380,0.7922854", "l0.6670707,0.7925076", "l0.6657847,0.7960366", "l0.6612561,0.7968838", "l0.6583764,0.7977298", "l0.6559057,0.8005505", "l0.6542586,0.8042172", "l0.6546713,0.8084495", "l0.6554930,0.8121162", "l0.6530223,0.8160657", "l0.6480847,0.8205795", "l0.6443796,0.8242475", "l0.6373803,0.8253763", "l0.6340879,0.8281970", "l0.6320299,0.8310177", "l0.6283009,0.8321540", "l0.6252185,0.8309684", "l0.6233927,0.8308535", "l0.6200303,0.8319722", "l0.6182174,0.8326806", "l0.6138269,0.8340972", "c"]}, {"n": "Cajamarca", "u": "PE-CAJ", "i": ["m0.2118957,0.2652677", "l0.2091321,0.2690568", "l0.2091321,0.2737929", "l0.2091321,0.2785290", "l0.2146593,0.2823169", "l0.2183865,0.2824520", "l0.2185505,0.2831465", "l0.2215702,0.2837374", "l0.2250247,0.2851591", "l0.2250247,0.2898939", "l0.2215702,0.2932096", "l0.2188066,0.2979457", "l0.2181157,0.3017336", "l0.2160411,0.3055227", "l0.2132775,0.3097841", "l0.2132775,0.3145202", "l0.2174248,0.3168876", "l0.2222611,0.3197298", "l0.2219737,0.3234722", "l0.2232505,0.3240051", "l0.2308081,0.3278636", "l0.2350788,0.3327626", "l0.2368180,0.3356692", "l0.2378553,0.3375215", "l0.2386401,0.3387412", "l0.2400146,0.3401288", "l0.2426216,0.3411199", "l0.2453797,0.3416591", "l0.2529207,0.3447652", "l0.2561394,0.3481174", "l0.2657991,0.3615543", "l0.2658120,0.3620328", "l0.2682569,0.3637083", "l0.2703149,0.3656831", "l0.2715511,0.3713258", "l0.2715511,0.3735821", "l0.2713282,0.3736174", "l0.2715511,0.3744280", "l0.2740200,0.3780960", "l0.2777250,0.3828914", "l0.2814301,0.3879697", "l0.2847244,0.3938939", "l0.2859569,0.3989722", "l0.2830773,0.4017929", "l0.2797830,0.4043321", "l0.2752544,0.4074343", "l0.2725037,0.4080644", "l0.2713761,0.4098561", "l0.2673707,0.4105341", "l0.2644155,0.4087614", "l0.2595773,0.4078144", "l0.2540482,0.4111301", "l0.2485210,0.4125505", "l0.2433438,0.4143245", "l0.2428353,0.4126591", "l0.2424189,0.4115025", "l0.2392371,0.4101439", "l0.2388465,0.4063939", "l0.2388465,0.4026048", "l0.2346992,0.4007109", "l0.2312447,0.4007109", "l0.2222611,0.4021313", "l0.2174248,0.4011843", "l0.2160411,0.3969217", "l0.2105139,0.3945543", "l0.2063666,0.3959747", "l0.2015303,0.3978687", "l0.1973830,0.4007109", "l0.1960012,0.4026048", "l0.1925467,0.4044987", "l0.1877085,0.4059205", "l0.1833199,0.4057323", "l0.1834784,0.4053056", "l0.1831965,0.4040909", "l0.1800386,0.3996490", "l0.1729066,0.3955543", "l0.1713332,0.3951641", "l0.1662426,0.3944003", "l0.1652882,0.3941944", "l0.1628323,0.3898182", "l0.1628323,0.3865038", "l0.1613418,0.3850442", "l0.1613694,0.3849167", "l0.1606730,0.3757361", "l0.1605440,0.3742904", "l0.1622777,0.3738472", "l0.1629447,0.3720720", "l0.1626370,0.3704167", "l0.1630865,0.3674722", "l0.1681587,0.3658018", "l0.1747674,0.3612260", "l0.1751562,0.3591528", "l0.1742129,0.3579280", "l0.1693010,0.3571010", "l0.1630202,0.3564154", "l0.1524356,0.3477955", "l0.1511919,0.3405732", "l0.1515180,0.3393775", "l0.1528280,0.3378801", "l0.1546852,0.3368030", "l0.1566952,0.3359419", "l0.1603063,0.3348649", "l0.1630110,0.3350896", "l0.1652698,0.3350896", "l0.1671712,0.3331604", "l0.1683724,0.3309470", "l0.1710034,0.3221035", "l0.1703493,0.3210960", "l0.1632395,0.3187184", "l0.1627531,0.3187854", "l0.1615905,0.3179369", "l0.1601332,0.3153043", "l0.1604537,0.3151301", "l0.1596449,0.3134482", "l0.1588803,0.3124987", "l0.1575151,0.3115644", "l0.1564133,0.3101364", "l0.1548491,0.3055884", "l0.1564133,0.2969836", "l0.1611649,0.2930164", "l0.1628784,0.2931806", "l0.1624306,0.2842765", "l0.1596228,0.2816263", "l0.1569200,0.2750821", "l0.1634016,0.2686641", "l0.1679910,0.2651717", "l0.1696529,0.2641098", "l0.1718804,0.2640366", "l0.1734520,0.2641111", "l0.1800072,0.2647109", "l0.1829219,0.2660694", "l0.1850094,0.2658131", "l0.1869974,0.2645593", "l0.1935066,0.2589760", "l0.1943044,0.2543725", "l0.1943099,0.2521376", "l0.1952772,0.2508283", "l0.1976373,0.2487096", "l0.1989583,0.2478662", "l0.2017532,0.2464937", "l0.2043418,0.2453220", "l0.2061990,0.2447702", "l0.2096406,0.2439646", "l0.2107774,0.2437437", "l0.2126013,0.2466944", "l0.2152434,0.2528422", "l0.2155492,0.2544167", "l0.2162272,0.2554394", "l0.2169513,0.2561957", "l0.2146593,0.2619533", "c"]}, {"n": "El Callao", "u": "PE-CAL", "i": ["m0.3440832,0.6521629", "l0.3429906,0.6534937", "l0.3413067,0.6522247", "l0.3399414,0.6510758", "l0.3381267,0.6503977", "l0.3355067,0.6495164", "l0.3313668,0.6491553", "l0.3340881,0.6452727", "l0.3338228,0.6425051", "l0.3331577,0.6394419", "l0.3305691,0.6344482", "l0.3314332,0.6308321", "l0.3305894,0.6291818", "l0.3387310,0.6295947", "l0.3391437,0.6394672", "l0.3420252,0.6428535", "l0.3457284,0.6468030", "l0.3469647,0.6496237", "c"]}, {"n": "Cusco", "u": "PE-CUS", "i": ["m0.6645098,0.6076061", "l0.6666267,0.6088043", "l0.6728320,0.6110947", "l0.6837759,0.6119444", "l0.6893049,0.6135985", "l0.6932145,0.6143043", "l0.6963061,0.6136894", "l0.7018112,0.6112311", "l0.7061796,0.6085152", "l0.7150821,0.6064066", "l0.7160052,0.6065025", "l0.7160052,0.6112563", "l0.7143581,0.6177462", "l0.7106548,0.6219760", "l0.7053026,0.6259268", "l0.7028338,0.6279015", "l0.7081841,0.6321326", "l0.7096378,0.6338169", "l0.7089322,0.6360215", "l0.7114784,0.6380581", "l0.7131255,0.6439811", "l0.7197103,0.6462374", "l0.7271204,0.6499066", "l0.7316472,0.6541376", "l0.7341179,0.6580871", "l0.7402937,0.6600619", "l0.7382099,0.6629167", "l0.7387184,0.6630088", "l0.7391606,0.6632412", "l0.7365886,0.6648573", "l0.7308255,0.6679596", "l0.7328835,0.6702184", "l0.7361759,0.6733207", "l0.7390593,0.6752955", "l0.7398810,0.6803725", "l0.7402937,0.6837588", "l0.7448223,0.6860152", "l0.7479360,0.6858018", "l0.7481147,0.6860152", "l0.7530524,0.6848876", "l0.7596408,0.6846048", "l0.7686981,0.6829116", "l0.7724014,0.6826301", "l0.7773409,0.6865795", "l0.7814568,0.6913750", "l0.7880453,0.6944785", "l0.7954536,0.6961705", "l0.7999823,0.6967348", "l0.8009624,0.6989785", "l0.8018247,0.6992879", "l0.8020402,0.7020960", "l0.8045091,0.7071730", "l0.8057453,0.7111225", "l0.8094504,0.7116869", "l0.8143881,0.7094306", "l0.8176842,0.7074558", "l0.8207868,0.7049407", "l0.8215587,0.7050303", "l0.8226218,0.7026604", "l0.8259142,0.7018131", "l0.8320900,0.7035063", "l0.8415581,0.7040707", "l0.8493810,0.7057626", "l0.8547645,0.7056023", "l0.8549230,0.7054508", "l0.8613161,0.7063270", "l0.8604944,0.7142260", "l0.8600817,0.7201503", "l0.8522607,0.7260745", "l0.8456741,0.7311515", "l0.8399110,0.7359482", "l0.8374422,0.7390518", "l0.8316791,0.7435644", "l0.8250925,0.7455404", "l0.8242689,0.7494899", "l0.8238562,0.7528737", "l0.8255052,0.7579533", "l0.8242689,0.7633131", "l0.8230345,0.7683902", "l0.8205638,0.7726225", "l0.8160352,0.7776995", "l0.8148008,0.7827778", "l0.8127428,0.7864444", "l0.8073924,0.7889848", "l0.8053326,0.7912412", "l0.8071419,0.7924811", "l0.8071308,0.7927109", "l0.8095241,0.7952727", "l0.8114236,0.7967033", "l0.8135000,0.7970644", "l0.8171480,0.8008106", "l0.8185077,0.8065732", "l0.8174539,0.8079697", "l0.8158804,0.8095720", "l0.8154217,0.8107121", "l0.8159910,0.8167121", "l0.8167537,0.8176982", "l0.8181521,0.8190631", "l0.8186441,0.8202348", "l0.8189075,0.8219457", "l0.8189388,0.8230707", "l0.8184469,0.8276856", "l0.8147455,0.8290707", "l0.8151582,0.8315707", "l0.8151121,0.8329659", "l0.8098613,0.8334154", "l0.8049218,0.8325707", "l0.7999823,0.8286212", "l0.8008040,0.8187462", "l0.8001886,0.8148106", "l0.7989155,0.8144937", "l0.7970049,0.8148245", "l0.7957816,0.8155328", "l0.7939686,0.8169747", "l0.7922865,0.8172134", "l0.7905381,0.8165051", "l0.7881042,0.8147551", "l0.7852301,0.8130922", "l0.7770221,0.8115278", "l0.7768619,0.8127765", "l0.7722098,0.8146856", "l0.7646504,0.8171048", "l0.7536622,0.8150871", "l0.7520243,0.8146856", "l0.7495665,0.8136578", "l0.7492717,0.8123283", "l0.7502980,0.8111187", "l0.7506904,0.8028586", "l0.7461028,0.7985038", "l0.7397354,0.7930051", "l0.7380091,0.7922803", "l0.7358148,0.7923737", "l0.7346338,0.7940341", "l0.7354537,0.7952955", "l0.7365130,0.7965328", "l0.7366549,0.7987348", "l0.7352676,0.8018270", "l0.7333036,0.8039129", "l0.7312327,0.8039747", "l0.7298509,0.8028283", "l0.7217793,0.8006414", "l0.7133779,0.8017816", "l0.7113365,0.8018043", "l0.7067157,0.8010581", "l0.7053929,0.8004419", "l0.7036352,0.7989962", "l0.7006192,0.7964268", "l0.6995893,0.7948801", "l0.7001825,0.7924735", "l0.7005768,0.7911667", "l0.7004663,0.7890063", "l0.6991895,0.7874230", "l0.6986773,0.7862765", "l0.6994308,0.7849242", "l0.7016417,0.7831881", "l0.7079612,0.7809129", "l0.7126133,0.7793927", "l0.7168287,0.7780707", "l0.7179876,0.7769646", "l0.7185016,0.7753838", "l0.7193528,0.7744078", "l0.7250440,0.7702929", "l0.7263558,0.7696566", "l0.7281024,0.7689508", "l0.7294235,0.7672475", "l0.7315109,0.7625821", "l0.7321097,0.7604962", "l0.7322976,0.7534419", "l0.7320341,0.7521086", "l0.7315109,0.7509596", "l0.7286717,0.7472146", "l0.7265511,0.7444773", "l0.7256778,0.7435429", "l0.7211768,0.7405253", "l0.7165689,0.7385051", "l0.7069110,0.7361957", "l0.6898282,0.7302841", "l0.6776812,0.7248826", "l0.6749341,0.7238914", "l0.6672716,0.7219621", "l0.6617112,0.7221452", "l0.6591520,0.7228561", "l0.6501427,0.7226894", "l0.6410780,0.7225076", "l0.6368091,0.7203409", "l0.6355231,0.7192260", "l0.6359414,0.7178927", "l0.6322344,0.7136616", "l0.6268841,0.7088662", "l0.6248261,0.7032235", "l0.6211210,0.6973005", "l0.6161815,0.6910934", "l0.6104203,0.6884621", "l0.6098141,0.6869293", "l0.6072274,0.6832058", "l0.6062012,0.6823523", "l0.6019433,0.6795934", "l0.6006039,0.6802576", "l0.5964953,0.6770278", "l0.5860139,0.6628333", "l0.5844183,0.6604343", "l0.5850798,0.6604634", "l0.5852714,0.6583371", "l0.5935401,0.6568169", "l0.5988923,0.6565354", "l0.6025956,0.6570997", "l0.6046756,0.6582866", "l0.6047880,0.6582626", "l0.6067133,0.6610492", "l0.6091840,0.6624596", "l0.6149452,0.6596389", "l0.6207083,0.6565354", "l0.6268841,0.6531503", "l0.6305891,0.6497639", "l0.6272968,0.6444040", "l0.6240025,0.6410202", "l0.6231790,0.6390442", "l0.6210436,0.6369167", "l0.6170051,0.6362235", "l0.6145344,0.6350947", "l0.6133000,0.6305821", "l0.6143170,0.6276566", "l0.6136998,0.6275076", "l0.6153579,0.6235290", "l0.6168835,0.6196957", "l0.6173883,0.6193359", "l0.6188714,0.6180770", "l0.6197889,0.6171806", "l0.6210565,0.6157538", "l0.6239620,0.6116566", "l0.6248795,0.6099874", "l0.6255409,0.6083207", "l0.6272286,0.6087917", "l0.6396041,0.6077866", "l0.6415275,0.6076061", "l0.6472059,0.6069987", "l0.6500247,0.6066654", "l0.6525802,0.6061490", "l0.6545681,0.6056566", "l0.6562558,0.6047083", "l0.6622473,0.6039419", "c"]}, {"n": "Huánuco", "u": "PE-HUC", "i": ["m0.3293992,0.4704571", "l0.3296755,0.4634331", "l0.3242404,0.4611414", "l0.3242404,0.4566629", "l0.3249055,0.4537475", "l0.3279897,0.4532778", "l0.3342078,0.4504369", "l0.3383514,0.4548232", "l0.3393076,0.4545366", "l0.3416125,0.4544621", "l0.3431085,0.4551301", "l0.3438234,0.4563813", "l0.3469647,0.4563813", "l0.3519042,0.4563813", "l0.3550381,0.4563813", "l0.3546623,0.4554040", "l0.3577041,0.4551717", "l0.3646150,0.4542247", "l0.3701422,0.4551717", "l0.3777440,0.4532778", "l0.3832731,0.4546982", "l0.3867276,0.4561199", "l0.3894912,0.4523308", "l0.3922567,0.4499634", "l0.3955178,0.4510808", "l0.3956578,0.4504419", "l0.3992431,0.4524306", "l0.4017488,0.4530442", "l0.4047648,0.4565922", "l0.4098443,0.4653636", "l0.4118894,0.4672449", "l0.4158653,0.4675720", "l0.4172545,0.4668636", "l0.4186069,0.4653674", "l0.4171329,0.4613283", "l0.4150602,0.4494886", "l0.4219711,0.4447538", "l0.4293813,0.4429242", "l0.4320859,0.4458384", "l0.4318262,0.4460783", "l0.4310173,0.4473422", "l0.4302970,0.4506944", "l0.4299469,0.4530101", "l0.4292928,0.4545732", "l0.4290404,0.4551692", "l0.4297055,0.4577904", "l0.4315166,0.4610631", "l0.4316069,0.4610366", "l0.4313527,0.4654078", "l0.4301090,0.4705202", "l0.4325244,0.4767083", "l0.4368946,0.4833939", "l0.4381935,0.4843573", "l0.4393837,0.4861641", "l0.4397743,0.4876667", "l0.4412317,0.4885404", "l0.4424661,0.4902336", "l0.4465839,0.4953119", "l0.4498763,0.4992614", "l0.4531686,0.5023636", "l0.4572901,0.5032462", "l0.4587843,0.5027096", "l0.4624544,0.5007058", "l0.4701225,0.4979646", "l0.4745738,0.4986970", "l0.4807495,0.4975682", "l0.4848655,0.4950290", "l0.4881597,0.4927727", "l0.4877470,0.4871301", "l0.4918648,0.4837449", "l0.4928616,0.4787904", "l0.4934880,0.4781869", "l0.4984496,0.4775379", "l0.5042126,0.4769747", "l0.5062725,0.4797955", "l0.5099757,0.4797955", "l0.5120355,0.4772563", "l0.5124464,0.4735896", "l0.5153279,0.4682285", "l0.5170229,0.4638157", "l0.5178189,0.4634407", "l0.5241918,0.4616591", "l0.5259605,0.4613586", "l0.5286264,0.4612222", "l0.5329948,0.4614331", "l0.5360090,0.4616881", "l0.5374626,0.4622071", "l0.5394064,0.4635051", "l0.5405763,0.4653447", "l0.5410996,0.4671654", "l0.5408619,0.4685619", "l0.5371034,0.4702336", "l0.5324715,0.4764066", "l0.5312187,0.4804848", "l0.5326171,0.4845909", "l0.5326171,0.4902336", "l0.5359113,0.4930543", "l0.5375566,0.4972866", "l0.5342624,0.5001073", "l0.5326171,0.5032109", "l0.5327203,0.5039861", "l0.5309700,0.5051843", "l0.5264413,0.5088523", "l0.5223254,0.5119558", "l0.5206783,0.5159053", "l0.5177967,0.5181616", "l0.5153279,0.5198548", "l0.5103884,0.5201364", "l0.5062725,0.5221124", "l0.5038018,0.5229583", "l0.5026116,0.5245896", "l0.5012132,0.5244899", "l0.4996858,0.5260619", "l0.4955699,0.5280354", "l0.4918648,0.5260619", "l0.4900832,0.5242298", "l0.4893389,0.5243624", "l0.4873362,0.5232399", "l0.4823967,0.5229583", "l0.4782789,0.5252146", "l0.4733394,0.5277525", "l0.4686560,0.5303220", "l0.4670623,0.5305076", "l0.4660711,0.5305568", "l0.4597553,0.5345240", "l0.4544049,0.5376275", "l0.4502871,0.5396023", "l0.4461712,0.5435518", "l0.4424661,0.5477828", "l0.4397467,0.5488081", "l0.4379374,0.5489116", "l0.4358795,0.5511679", "l0.4317635,0.5522967", "l0.4305291,0.5565290", "l0.4292523,0.5590278", "l0.4288414,0.5591528", "l0.4284711,0.5599129", "l0.4227081,0.5596326", "l0.4152979,0.5582210", "l0.4111819,0.5573737", "l0.4033609,0.5568106", "l0.3996540,0.5556831", "l0.3955380,0.5528611", "l0.3897750,0.5525795", "l0.3836010,0.5539899", "l0.3774253,0.5568106", "l0.3720749,0.5593497", "l0.3650590,0.5604798", "l0.3648453,0.5603169", "l0.3637214,0.5604217", "l0.3616782,0.5599078", "l0.3601600,0.5590455", "l0.3593402,0.5581010", "l0.3586253,0.5554419", "l0.3568713,0.5546149", "l0.3534316,0.5551515", "l0.3514215,0.5543169", "l0.3505040,0.5527096", "l0.3505703,0.5517652", "l0.3505703,0.5514596", "l0.3527278,0.5503220", "l0.3539622,0.5483472", "l0.3551966,0.5449621", "l0.3535513,0.5412942", "l0.3568437,0.5390379", "l0.3597252,0.5364987", "l0.3593125,0.5300114", "l0.3580800,0.5260619", "l0.3543730,0.5218295", "l0.3494335,0.5198548", "l0.3453507,0.5184545", "l0.3428469,0.5187260", "l0.3440832,0.5142121", "l0.3449067,0.5113902", "l0.3487095,0.5109318", "l0.3532879,0.5038258", "l0.3563684,0.4990922", "l0.3567921,0.4986894", "l0.3626068,0.4984141", "l0.3667227,0.4978497", "l0.3691934,0.4958750", "l0.3696042,0.4913624", "l0.3634303,0.4885404", "l0.3531386,0.4845909", "l0.3453176,0.4809242", "l0.3364980,0.4781174", "l0.3343055,0.4762184", "l0.3300882,0.4713030", "c"]}, {"n": "Huancavelica", "u": "PE-HUV", "i": ["m0.5567287,0.6976275", "l0.5527878,0.6995568", "l0.5466139,0.7009672", "l0.5429088,0.7060455", "l0.5371457,0.7085833", "l0.5322044,0.7102765", "l0.5285012,0.7136616", "l0.5235598,0.7173295", "l0.5210099,0.7182033", "l0.5208054,0.7178801", "l0.5187401,0.7172462", "l0.5105800,0.7189040", "l0.5080246,0.7248902", "l0.5098394,0.7259078", "l0.5117389,0.7265354", "l0.5130931,0.7271780", "l0.5169824,0.7306351", "l0.5189851,0.7324722", "l0.5181836,0.7345619", "l0.5180086,0.7363750", "l0.5186092,0.7384306", "l0.5188690,0.7387955", "l0.5186203,0.7427184", "l0.5182094,0.7486427", "l0.5153279,0.7542854", "l0.5136808,0.7565429", "l0.5050362,0.7582336", "l0.4980387,0.7568232", "l0.4947463,0.7568232", "l0.4947574,0.7570657", "l0.4922757,0.7565429", "l0.4865126,0.7565429", "l0.4833142,0.7575644", "l0.4827338,0.7571061", "l0.4778680,0.7571061", "l0.4712814,0.7545669", "l0.4694998,0.7525682", "l0.4690521,0.7525227", "l0.4610228,0.7499470", "l0.4586314,0.7470051", "l0.4582482,0.7416515", "l0.4607723,0.7383497", "l0.4588672,0.7317475", "l0.4608589,0.7300859", "l0.4624986,0.7292588", "l0.4633940,0.7283409", "l0.4645732,0.7264583", "l0.4645750,0.7251402", "l0.4639265,0.7249558", "l0.4651075,0.7226894", "l0.4646948,0.7201503", "l0.4622259,0.7184583", "l0.4572864,0.7187399", "l0.4531686,0.7209962", "l0.4501526,0.7225114", "l0.4495004,0.7224823", "l0.4458948,0.7225896", "l0.4433707,0.7227576", "l0.4414270,0.7227727", "l0.4400083,0.7222601", "l0.4396767,0.7214684", "l0.4371139,0.7215619", "l0.4346450,0.7193030", "l0.4379374,0.7162008", "l0.4412317,0.7122513", "l0.4424661,0.7074558", "l0.4424661,0.7040707", "l0.4431165,0.7014861", "l0.4431312,0.7014848", "l0.4428769,0.6998384", "l0.4478183,0.6984280", "l0.4498763,0.6953245", "l0.4519342,0.6933497", "l0.4544049,0.6902475", "l0.4572864,0.6882715", "l0.4560502,0.6857336", "l0.4568737,0.6820657", "l0.4585503,0.6796035", "l0.4573030,0.6790278", "l0.4571998,0.6788220", "l0.4634604,0.6788220", "l0.4716941,0.6728977", "l0.4811604,0.6672551", "l0.4898068,0.6618952", "l0.4968025,0.6545606", "l0.4974123,0.6535177", "l0.4976279,0.6534331", "l0.4984496,0.6469432", "l0.5029782,0.6449684", "l0.5135095,0.6438460", "l0.5247961,0.6441237", "l0.5285012,0.6438409", "l0.5299603,0.6446023", "l0.5305720,0.6446869", "l0.5367330,0.6446869", "l0.5478483,0.6463801", "l0.5523770,0.6492008", "l0.5536114,0.6528674", "l0.5507059,0.6534104", "l0.5528652,0.6559369", "l0.5507298,0.6575227", "l0.5466139,0.6594975", "l0.5414773,0.6591957", "l0.5411659,0.6596503", "l0.5388389,0.6641212", "l0.5404381,0.6651389", "l0.5437324,0.6679596", "l0.5445928,0.6699659", "l0.5462933,0.6701288", "l0.5473435,0.6711768", "l0.5494954,0.6767058", "l0.5519643,0.6829116", "l0.5540222,0.6885543", "l0.5556343,0.6940758", "l0.5550153,0.6956540", "c"]}, {"n": "Ica", "u": "PE-ICA", "i": ["m0.4298290,0.6989924", "l0.4343558,0.7001199", "l0.4421787,0.7001199", "l0.4427646,0.7015253", "l0.4431165,0.7014861", "l0.4424661,0.7040707", "l0.4424661,0.7074558", "l0.4412317,0.7122513", "l0.4379374,0.7162008", "l0.4346450,0.7193030", "l0.4371139,0.7215619", "l0.4396767,0.7214684", "l0.4400083,0.7222601", "l0.4414270,0.7227727", "l0.4433707,0.7227576", "l0.4458948,0.7225896", "l0.4495004,0.7224823", "l0.4501526,0.7225114", "l0.4531686,0.7209962", "l0.4572864,0.7187399", "l0.4622259,0.7184583", "l0.4646948,0.7201503", "l0.4651075,0.7226894", "l0.4639265,0.7249558", "l0.4645750,0.7251402", "l0.4645732,0.7264583", "l0.4633940,0.7283409", "l0.4624986,0.7292588", "l0.4608589,0.7300859", "l0.4588672,0.7317475", "l0.4607723,0.7383497", "l0.4582482,0.7416515", "l0.4586314,0.7470051", "l0.4610228,0.7499470", "l0.4690521,0.7525227", "l0.4694998,0.7525682", "l0.4712814,0.7545669", "l0.4778680,0.7571061", "l0.4827338,0.7571061", "l0.4833142,0.7575644", "l0.4865126,0.7565429", "l0.4922757,0.7565429", "l0.4942047,0.7569482", "l0.4935101,0.7666982", "l0.4926884,0.7731856", "l0.4906285,0.7765720", "l0.4918648,0.7824949", "l0.4951572,0.7887020", "l0.4983188,0.7888687", "l0.4984238,0.7891705", "l0.5037870,0.7887828", "l0.5056276,0.7877462", "l0.5065801,0.7868434", "l0.5095648,0.7875745", "l0.5120355,0.7898308", "l0.5165623,0.7957551", "l0.5210910,0.8019609", "l0.5263179,0.8050556", "l0.5265187,0.8053838", "l0.5268135,0.8070467", "l0.5268135,0.8096944", "l0.5265500,0.8110657", "l0.5258518,0.8129306", "l0.5239762,0.8154129", "l0.5233682,0.8155795", "l0.5231968,0.8152096", "l0.5159728,0.8159722", "l0.5124058,0.8171957", "l0.5049957,0.8200164", "l0.4988218,0.8253763", "l0.4963511,0.8304545", "l0.4945234,0.8336742", "l0.4942397,0.8334684", "l0.4901440,0.8287083", "l0.4843441,0.8228864", "l0.4833179,0.8220227", "l0.4820061,0.8210051", "l0.4792314,0.8192525", "l0.4713661,0.8154255", "l0.4629132,0.8066616", "l0.4614595,0.8055063", "l0.4593849,0.8043977", "l0.4575388,0.8036755", "l0.4545026,0.8026742", "l0.4462651,0.7993801", "l0.4364340,0.7953952", "l0.4290294,0.7912386", "l0.4287880,0.7891679", "l0.4283845,0.7870076", "l0.4249779,0.7812891", "l0.4183029,0.7766894", "l0.4170353,0.7760139", "l0.4145185,0.7725038", "l0.4127756,0.7679217", "l0.4077937,0.7648081", "l0.4057302,0.7639167", "l0.3997793,0.7621831", "l0.4002675,0.7498333", "l0.3968977,0.7483611", "l0.3933437,0.7475492", "l0.3945837,0.7447601", "l0.3979258,0.7439104", "l0.4000390,0.7446439", "l0.4023310,0.7469369", "l0.4050854,0.7421187", "l0.4057855,0.7404495", "l0.4079467,0.7352437", "l0.4085381,0.7321364", "l0.4095532,0.7253194", "l0.4083409,0.7231402", "l0.4045069,0.7183914", "l0.4038657,0.7179381", "l0.4032854,0.7173737", "l0.4034825,0.7148106", "l0.4063659,0.7130972", "l0.4096583,0.7080202", "l0.4150086,0.7057626", "l0.4207717,0.7029407", "l0.4248895,0.7004028", "c"]}, {"n": "Junín", "u": "PE-JUN", "i": ["m0.5017549,0.5732828", "l0.5028364,0.5736301", "l0.5066833,0.5734545", "l0.5161515,0.5768396", "l0.5219145,0.5788144", "l0.5280885,0.5807891", "l0.5314490,0.5824343", "l0.5350491,0.5821869", "l0.5377132,0.5821414", "l0.5411143,0.5823447", "l0.5420834,0.5858359", "l0.5427596,0.5882298", "l0.5431575,0.5890316", "l0.5486719,0.5903813", "l0.5569038,0.5903813", "l0.5680190,0.5898169", "l0.5696901,0.5901452", "l0.5725145,0.5895934", "l0.5790698,0.5889104", "l0.5799560,0.5923561", "l0.5820140,0.5965871", "l0.5898369,0.5977159", "l0.5935401,0.5963043", "l0.5951872,0.5926376", "l0.5955981,0.5875606", "l0.5955981,0.5847386", "l0.5954341,0.5823535", "l0.5961084,0.5817020", "l0.5977482,0.5794609", "l0.5995279,0.5771578", "l0.6095986,0.5792563", "l0.6123622,0.5807639", "l0.6152566,0.5833447", "l0.6155827,0.5836982", "l0.6157706,0.5874192", "l0.6165924,0.5922146", "l0.6210105,0.5930492", "l0.6209736,0.5931843", "l0.6244134,0.5950366", "l0.6260623,0.6032172", "l0.6253917,0.6082525", "l0.6255409,0.6083207", "l0.6248795,0.6099874", "l0.6239620,0.6116566", "l0.6210565,0.6157538", "l0.6197889,0.6171806", "l0.6188714,0.6180770", "l0.6173883,0.6193359", "l0.6168835,0.6196957", "l0.6153579,0.6235290", "l0.6136998,0.6275076", "l0.6143170,0.6276566", "l0.6133000,0.6305821", "l0.6145344,0.6350947", "l0.6170051,0.6362235", "l0.6210436,0.6369167", "l0.6231790,0.6390442", "l0.6240025,0.6410202", "l0.6272968,0.6444040", "l0.6305891,0.6497639", "l0.6268841,0.6531503", "l0.6207083,0.6565354", "l0.6149452,0.6596389", "l0.6091840,0.6624596", "l0.6067133,0.6610492", "l0.6047880,0.6582626", "l0.6046756,0.6582866", "l0.6025956,0.6570997", "l0.5988923,0.6565354", "l0.5935401,0.6568169", "l0.5852714,0.6583371", "l0.5853082,0.6579457", "l0.5828394,0.6576629", "l0.5774853,0.6576629", "l0.5741929,0.6590732", "l0.5692534,0.6596389", "l0.5626668,0.6587929", "l0.5564929,0.6556894", "l0.5528873,0.6559634", "l0.5507059,0.6534104", "l0.5536114,0.6528674", "l0.5523770,0.6492008", "l0.5478483,0.6463801", "l0.5367330,0.6446869", "l0.5305720,0.6446869", "l0.5299603,0.6446023", "l0.5285012,0.6438409", "l0.5247961,0.6441237", "l0.5135095,0.6438460", "l0.5029782,0.6449684", "l0.4984496,0.6469432", "l0.4976279,0.6534331", "l0.4974123,0.6535177", "l0.4968025,0.6545606", "l0.4898068,0.6618952", "l0.4811604,0.6672551", "l0.4716941,0.6728977", "l0.4634604,0.6788220", "l0.4571998,0.6788220", "l0.4565992,0.6776187", "l0.4567466,0.6770480", "l0.4551861,0.6747311", "l0.4547734,0.6676793", "l0.4563321,0.6621288", "l0.4559009,0.6615859", "l0.4513354,0.6557399", "l0.4515307,0.6544773", "l0.4528094,0.6531528", "l0.4522087,0.6515088", "l0.4505303,0.6506061", "l0.4502871,0.6451098", "l0.4383501,0.6451098", "l0.4360840,0.6456490", "l0.4334217,0.6448157", "l0.4310781,0.6443801", "l0.4295950,0.6445859", "l0.4268240,0.6434179", "l0.4193346,0.6417563", "l0.4187948,0.6407942", "l0.4125582,0.6353157", "l0.4077937,0.6321162", "l0.4071729,0.6310909", "l0.4068117,0.6274141", "l0.4065814,0.6240884", "l0.4059219,0.6222891", "l0.4041034,0.6214394", "l0.4023771,0.6216288", "l0.3995361,0.6215669", "l0.3960852,0.6205657", "l0.3934322,0.6174912", "l0.3858506,0.6069293", "l0.3848778,0.6002197", "l0.3849221,0.5986881", "l0.3854250,0.5959545", "l0.3856093,0.5948902", "l0.3848963,0.5937045", "l0.3897750,0.5932020", "l0.3943036,0.5940480", "l0.3958199,0.5958687", "l0.3966324,0.5957917", "l0.3978724,0.5956742", "l0.4008902,0.5971515", "l0.4062424,0.5965871", "l0.4103584,0.5937664", "l0.4161214,0.5943308", "l0.4218845,0.5926376", "l0.4235298,0.5898169", "l0.4227081,0.5872778", "l0.4161214,0.5875606", "l0.4156479,0.5845278", "l0.4156553,0.5845278", "l0.4165323,0.5824823", "l0.4190030,0.5819179", "l0.4218845,0.5802247", "l0.4260005,0.5805076", "l0.4297055,0.5824823", "l0.4354686,0.5816351", "l0.4416425,0.5807891", "l0.4465839,0.5790972", "l0.4552285,0.5768396", "l0.4605788,0.5748649", "l0.4626368,0.5748649", "l0.4659310,0.5774053", "l0.4684035,0.5793106", "l0.4700783,0.5792033", "l0.4737042,0.5794306", "l0.4758119,0.5793927", "l0.4779657,0.5789912", "l0.4797399,0.5785455", "l0.4811604,0.5768396", "l0.4844546,0.5754293", "l0.4910412,0.5731730", "l0.4963916,0.5726086", "l0.4987352,0.5732260", "c"]}, {"n": "La Libertad", "u": "PE-LAL", "i": ["m0.3044824,0.4067298", "l0.3048932,0.4115253", "l0.3057168,0.4171679", "l0.3091326,0.4175366", "l0.3092856,0.4179104", "l0.3123034,0.4180139", "l0.3151850,0.4197071", "l0.3164194,0.4250669", "l0.3173553,0.4291250", "l0.3183152,0.4291250", "l0.3266079,0.4267576", "l0.3328260,0.4262841", "l0.3376642,0.4286515", "l0.3459569,0.4295985", "l0.3501023,0.4338611", "l0.3528659,0.4367020", "l0.3549405,0.4419116", "l0.3532381,0.4424949", "l0.3537908,0.4442904", "l0.3537540,0.4453119", "l0.3514841,0.4457008", "l0.3438823,0.4466477", "l0.3376642,0.4480682", "l0.3342078,0.4504369", "l0.3279897,0.4532778", "l0.3195791,0.4545581", "l0.3162388,0.4503939", "l0.3067357,0.4404886", "l0.3051401,0.4400366", "l0.3023452,0.4390758", "l0.2984116,0.4365366", "l0.2967498,0.4353788", "l0.2960534,0.4343876", "l0.2943694,0.4309470", "l0.2939770,0.4293548", "l0.2922304,0.4292045", "l0.2770028,0.4312172", "l0.2706778,0.4374975", "l0.2678718,0.4387753", "l0.2662984,0.4391806", "l0.2636564,0.4403384", "l0.2624533,0.4410442", "l0.2573682,0.4441477", "l0.2545217,0.4483939", "l0.2487771,0.4591616", "l0.2488324,0.4604217", "l0.2465386,0.4633725", "l0.2358231,0.4659457", "l0.2248239,0.4684066", "l0.2232615,0.4688207", "l0.2213381,0.4701439", "l0.2192746,0.4725152", "l0.2189577,0.4745480", "l0.2194662,0.4764482", "l0.2174985,0.4796831", "l0.2149154,0.4800644", "l0.2143332,0.4800644", "l0.2145009,0.4797033", "l0.2143977,0.4777841", "l0.2094324,0.4725530", "l0.2071607,0.4668043", "l0.2074555,0.4654722", "l0.2073302,0.4628611", "l0.2065269,0.4607412", "l0.2058268,0.4594621", "l0.2001706,0.4550859", "l0.1937424,0.4502891", "l0.1944241,0.4489432", "l0.1943044,0.4478384", "l0.1883184,0.4396124", "l0.1753975,0.4300606", "l0.1739973,0.4291439", "l0.1722065,0.4284836", "l0.1706331,0.4280480", "l0.1646047,0.4246237", "l0.1628581,0.4235960", "l0.1612404,0.4224242", "l0.1585966,0.4197740", "l0.1542043,0.4145644", "l0.1529164,0.4111275", "l0.1520210,0.4091919", "l0.1485039,0.4049154", "l0.1459484,0.4029053", "l0.1446053,0.4019293", "l0.1416998,0.3986894", "l0.1412945,0.3968371", "l0.1419504,0.3952626", "l0.1403107,0.3918359", "l0.1396990,0.3907563", "l0.1377331,0.3876225", "l0.1368598,0.3867235", "l0.1321433,0.3835227", "l0.1342160,0.3818801", "l0.1452281,0.3740795", "l0.1484044,0.3721389", "l0.1501860,0.3714874", "l0.1579517,0.3728144", "l0.1605440,0.3742904", "l0.1606730,0.3757361", "l0.1613694,0.3849167", "l0.1613418,0.3850442", "l0.1628323,0.3865038", "l0.1628323,0.3898182", "l0.1652882,0.3941944", "l0.1662426,0.3944003", "l0.1713332,0.3951641", "l0.1729066,0.3955543", "l0.1800386,0.3996490", "l0.1831965,0.4040909", "l0.1834784,0.4053056", "l0.1833199,0.4057323", "l0.1877085,0.4059205", "l0.1925467,0.4044987", "l0.1960012,0.4026048", "l0.1973830,0.4007109", "l0.2015303,0.3978687", "l0.2063666,0.3959747", "l0.2105139,0.3945543", "l0.2160411,0.3969217", "l0.2174248,0.4011843", "l0.2222611,0.4021313", "l0.2312447,0.4007109", "l0.2346992,0.4007109", "l0.2388465,0.4026048", "l0.2388465,0.4063939", "l0.2392371,0.4101439", "l0.2424189,0.4115025", "l0.2428353,0.4126591", "l0.2433438,0.4143245", "l0.2485210,0.4125505", "l0.2540482,0.4111301", "l0.2595773,0.4078144", "l0.2644155,0.4087614", "l0.2673707,0.4105341", "l0.2713761,0.4098561", "l0.2725037,0.4080644", "l0.2752544,0.4074343", "l0.2797830,0.4043321", "l0.2830773,0.4017929", "l0.2859569,0.3989722", "l0.2847244,0.3938939", "l0.2814301,0.3879697", "l0.2777250,0.3828914", "l0.2740200,0.3780960", "l0.2715511,0.3744280", "l0.2713282,0.3736174", "l0.2763506,0.3728308", "l0.2816199,0.3715114", "l0.2839966,0.3711553", "l0.2843854,0.3719444", "l0.2856106,0.3729040", "l0.2867989,0.3734053", "l0.2900434,0.3773093", "l0.2970354,0.3831098", "l0.2982385,0.3846389", "l0.2977889,0.3861679", "l0.2957236,0.3889646", "l0.2960534,0.3917904", "l0.2981482,0.3955997", "l0.2993844,0.3973472", "l0.3019712,0.3984949", "l0.3027560,0.3987513", "l0.3032480,0.4036263", "c"]}, {"n": "Lambayeque", "u": "PE-LAM", "i": ["m0.1407492,0.3147235", "l0.1429306,0.3164975", "l0.1432548,0.3164495", "l0.1456076,0.3160720", "l0.1512509,0.3175366", "l0.1524135,0.3192563", "l0.1540956,0.3185694", "l0.1601332,0.3153043", "l0.1615905,0.3179369", "l0.1627531,0.3187854", "l0.1632395,0.3187184", "l0.1703493,0.3210960", "l0.1710034,0.3221035", "l0.1683724,0.3309470", "l0.1671712,0.3331604", "l0.1652698,0.3350896", "l0.1630110,0.3350896", "l0.1603063,0.3348649", "l0.1566952,0.3359419", "l0.1546852,0.3368030", "l0.1528280,0.3378801", "l0.1515180,0.3393775", "l0.1511919,0.3405732", "l0.1524356,0.3477955", "l0.1630202,0.3564154", "l0.1693010,0.3571010", "l0.1742129,0.3579280", "l0.1751562,0.3591528", "l0.1747674,0.3612260", "l0.1681587,0.3658018", "l0.1630865,0.3674722", "l0.1626370,0.3704167", "l0.1629447,0.3720720", "l0.1622777,0.3738472", "l0.1605440,0.3742904", "l0.1579517,0.3728144", "l0.1501860,0.3714874", "l0.1484044,0.3721389", "l0.1452281,0.3740795", "l0.1342160,0.3818801", "l0.1321433,0.3835227", "l0.1320106,0.3819558", "l0.1316605,0.3800227", "l0.1304151,0.3786427", "l0.1235779,0.3729785", "l0.1217907,0.3721212", "l0.1189018,0.3708965", "l0.1145648,0.3678245", "l0.1134520,0.3667538", "l0.1121734,0.3635859", "l0.1108192,0.3612487", "l0.1000927,0.3546073", "l0.0980163,0.3537614", "l0.0941067,0.3526086", "l0.0843198,0.3494343", "l0.0736578,0.3454078", "l0.0677215,0.3428409", "l0.0653356,0.3410530", "l0.0634784,0.3400808", "l0.0614039,0.3391970", "l0.0622109,0.3388232", "l0.0642430,0.3369230", "l0.0683498,0.3327790", "l0.0710968,0.3297790", "l0.0719038,0.3276843", "l0.0737978,0.3251490", "l0.0781790,0.3213434", "l0.0815654,0.3187336", "l0.0833359,0.3175821", "l0.0847675,0.3168939", "l0.0875532,0.3160871", "l0.0946723,0.3145808", "l0.0961186,0.3136528", "l0.1004593,0.3112715", "l0.1041073,0.3093687", "l0.1089694,0.3052020", "l0.1105318,0.3032980", "l0.1110532,0.2990139", "l0.1124276,0.2976364", "l0.1123152,0.2964609", "l0.1132438,0.2953775", "l0.1147509,0.2960126", "l0.1166099,0.2969609", "l0.1254221,0.3017879", "l0.1292249,0.3066162", "l0.1307541,0.3096944", "l0.1339765,0.3106768", "l0.1367548,0.3112715", "l0.1388386,0.3123434", "c"]}, {"n": "Lima", "u": "PE-LIM", "i": ["m0.4563321,0.6621288", "l0.4547734,0.6676793", "l0.4551861,0.6747311", "l0.4567466,0.6770480", "l0.4565992,0.6776187", "l0.4573030,0.6790278", "l0.4585503,0.6796035", "l0.4568737,0.6820657", "l0.4560502,0.6857336", "l0.4572864,0.6882715", "l0.4544049,0.6902475", "l0.4519342,0.6933497", "l0.4498763,0.6953245", "l0.4478183,0.6984280", "l0.4428769,0.6998384", "l0.4431312,0.7014848", "l0.4427646,0.7015253", "l0.4421787,0.7001199", "l0.4343558,0.7001199", "l0.4298290,0.6989924", "l0.4248895,0.7004028", "l0.4207717,0.7029407", "l0.4150086,0.7057626", "l0.4096583,0.7080202", "l0.4063659,0.7130972", "l0.4034825,0.7148106", "l0.4034843,0.7147904", "l0.4003099,0.7146098", "l0.3939443,0.7091073", "l0.3919453,0.7074268", "l0.3898487,0.7060758", "l0.3873264,0.7045707", "l0.3862339,0.7037765", "l0.3851173,0.7026616", "l0.3841132,0.7001263", "l0.3835016,0.6982955", "l0.3829341,0.6948308", "l0.3764451,0.6884899", "l0.3737147,0.6863624", "l0.3648011,0.6746086", "l0.3619343,0.6695758", "l0.3650756,0.6679596", "l0.3642539,0.6628826", "l0.3683698,0.6592159", "l0.3716641,0.6549836", "l0.3720749,0.6479306", "l0.3683698,0.6434179", "l0.3630195,0.6391856", "l0.3572546,0.6374937", "l0.3593125,0.6332614", "l0.3626068,0.6326970", "l0.3605488,0.6298763", "l0.3543730,0.6256452", "l0.3481991,0.6214129", "l0.3428469,0.6177462", "l0.3374965,0.6168990", "l0.3333806,0.6197197", "l0.3292628,0.6211313", "l0.3264016,0.6237929", "l0.3212188,0.6185240", "l0.3157358,0.6152449", "l0.3070636,0.6116263", "l0.3020393,0.6096995", "l0.3005304,0.6092134", "l0.2979326,0.6086667", "l0.2942459,0.6068801", "l0.2928457,0.6044040", "l0.2941372,0.6026061", "l0.2967295,0.6024179", "l0.2971385,0.6004621", "l0.2917495,0.5870341", "l0.2885805,0.5825341", "l0.2835784,0.5769924", "l0.2801036,0.5741604", "l0.2748288,0.5695013", "l0.2809014,0.5665000", "l0.2822684,0.5641578", "l0.2830957,0.5593030", "l0.2835452,0.5561995", "l0.2840095,0.5560896", "l0.2839819,0.5559634", "l0.2872761,0.5539899", "l0.2897449,0.5520139", "l0.2946844,0.5514508", "l0.2983895,0.5525795", "l0.2979787,0.5562462", "l0.2942736,0.5579394", "l0.2922156,0.5599129", "l0.2914989,0.5616793", "l0.2926431,0.5651111", "l0.2979750,0.5675770", "l0.2984614,0.5688106", "l0.2975273,0.5711944", "l0.2989036,0.5769167", "l0.3057186,0.5768864", "l0.3119018,0.5753270", "l0.3261455,0.5668902", "l0.3296516,0.5643699", "l0.3311365,0.5631149", "l0.3320651,0.5618207", "l0.3325552,0.5602412", "l0.3326768,0.5583624", "l0.3338136,0.5566566", "l0.3353207,0.5557866", "l0.3473258,0.5524533", "l0.3505703,0.5517652", "l0.3505040,0.5527096", "l0.3514215,0.5543169", "l0.3534316,0.5551515", "l0.3568713,0.5546149", "l0.3586253,0.5554419", "l0.3593402,0.5581010", "l0.3601600,0.5590455", "l0.3616782,0.5599078", "l0.3637214,0.5604217", "l0.3648453,0.5603169", "l0.3662179,0.5613750", "l0.3674505,0.5635126", "l0.3682648,0.5653674", "l0.3685264,0.5673965", "l0.3694882,0.5687955", "l0.3715517,0.5705960", "l0.3723384,0.5719053", "l0.3729501,0.5737222", "l0.3731914,0.5754028", "l0.3739431,0.5770985", "l0.3750707,0.5782045", "l0.3784331,0.5806528", "l0.3790227,0.5822614", "l0.3791111,0.5840644", "l0.3792861,0.5854053", "l0.3791977,0.5875177", "l0.3787187,0.5890795", "l0.3796896,0.5906477", "l0.3809682,0.5913131", "l0.3843546,0.5928030", "l0.3856093,0.5948902", "l0.3854250,0.5959545", "l0.3849221,0.5986881", "l0.3848778,0.6002197", "l0.3858506,0.6069293", "l0.3934322,0.6174912", "l0.3960852,0.6205657", "l0.3995361,0.6215669", "l0.4023771,0.6216288", "l0.4041034,0.6214394", "l0.4059219,0.6222891", "l0.4065814,0.6240884", "l0.4068117,0.6274141", "l0.4071729,0.6310909", "l0.4077937,0.6321162", "l0.4125582,0.6353157", "l0.4187948,0.6407942", "l0.4193346,0.6417563", "l0.4268240,0.6434179", "l0.4295950,0.6445859", "l0.4310781,0.6443801", "l0.4334217,0.6448157", "l0.4360840,0.6456490", "l0.4383501,0.6451098", "l0.4502871,0.6451098", "l0.4505303,0.6506061", "l0.4522087,0.6515088", "l0.4528094,0.6531528", "l0.4515307,0.6544773", "l0.4513354,0.6557399", "l0.4559009,0.6615859", "c"]}, {"n": "Municipalidad Metropolitana de Lima", "u": "PE-LMA", "i": ["m0.3619343,0.6695758", "l0.3617556,0.6692614", "l0.3609357,0.6666553", "l0.3592094,0.6650101", "l0.3563260,0.6627727", "l0.3517826,0.6601225", "l0.3429906,0.6534937", "l0.3440832,0.6521629", "l0.3469647,0.6496237", "l0.3457284,0.6468030", "l0.3420252,0.6428535", "l0.3391437,0.6394672", "l0.3387310,0.6295947", "l0.3305894,0.6291818", "l0.3293881,0.6268295", "l0.3264016,0.6237929", "l0.3292628,0.6211313", "l0.3333806,0.6197197", "l0.3374965,0.6168990", "l0.3428469,0.6177462", "l0.3481991,0.6214129", "l0.3543730,0.6256452", "l0.3605488,0.6298763", "l0.3626068,0.6326970", "l0.3593125,0.6332614", "l0.3572546,0.6374937", "l0.3630195,0.6391856", "l0.3683698,0.6434179", "l0.3720749,0.6479306", "l0.3716641,0.6549836", "l0.3683698,0.6592159", "l0.3642539,0.6628826", "l0.3650756,0.6679596", "c"]}, {"n": "Loreto", "u": "PE-LOR", "i": ["m0.4917008,0.0004533", "l0.5007931,0.0046136", "l0.5055797,0.0071566", "l0.5073484,0.0086742", "l0.5134652,0.0104735", "l0.5149705,0.0100871", "l0.5172109,0.0090379", "l0.5188395,0.0087487", "l0.5203780,0.0091566", "l0.5222038,0.0106364", "l0.5234272,0.0119975", "l0.5244092,0.0135366", "l0.5247389,0.0147109", "l0.5248255,0.0158864", "l0.5253819,0.0173876", "l0.5313458,0.0197904", "l0.5333448,0.0185631", "l0.5373208,0.0203927", "l0.5501458,0.0271149", "l0.5515423,0.0284381", "l0.5520011,0.0289470", "l0.5529628,0.0319179", "l0.5544699,0.0358447", "l0.5562608,0.0398750", "l0.5582929,0.0413775", "l0.5616351,0.0437260", "l0.5603472,0.0461515", "l0.5588825,0.0478321", "l0.5610455,0.0508510", "l0.5621933,0.0522563", "l0.5641794,0.0534318", "l0.5750054,0.0554621", "l0.5915006,0.0627361", "l0.5936285,0.0657614", "l0.6006076,0.0670783", "l0.6036899,0.0665139", "l0.6083641,0.0667955", "l0.6160654,0.0716604", "l0.6167084,0.0749470", "l0.6170824,0.0766288", "l0.6188714,0.0779975", "l0.6222578,0.0811515", "l0.6246032,0.0842500", "l0.6222578,0.0856591", "l0.6214711,0.0866111", "l0.6198553,0.0916402", "l0.6211873,0.0926364", "l0.6270204,0.0953005", "l0.6364149,0.0983472", "l0.6409803,0.0968472", "l0.6442727,0.0947525", "l0.6493265,0.0970404", "l0.6526557,0.1010290", "l0.6551909,0.1129179", "l0.6536506,0.1158497", "l0.6518045,0.1175467", "l0.6494075,0.1183131", "l0.6507028,0.1227336", "l0.6515318,0.1237083", "l0.6539564,0.1250177", "l0.6595279,0.1271162", "l0.6617351,0.1266402", "l0.6649151,0.1265518", "l0.6674374,0.1294230", "l0.6690532,0.1322525", "l0.6743390,0.1313737", "l0.6846731,0.1286944", "l0.6920022,0.1269381", "l0.7029591,0.1287689", "l0.7126354,0.1310013", "l0.7148647,0.1314482", "l0.7205209,0.1318497", "l0.7329093,0.1269684", "l0.7398128,0.1249141", "l0.7438108,0.1254255", "l0.7470811,0.1253611", "l0.7485274,0.1222790", "l0.7534761,0.1174874", "l0.7602820,0.1136465", "l0.7625445,0.1130442", "l0.7633293,0.1140417", "l0.7632538,0.1156263", "l0.7640276,0.1171742", "l0.7717068,0.1177992", "l0.7761544,0.1176869", "l0.7846405,0.1201881", "l0.7886164,0.1237083", "l0.8022705,0.1244369", "l0.8091077,0.1218333", "l0.8189167,0.1200316", "l0.8281527,0.1171932", "l0.8400658,0.1225480", "l0.8473654,0.1225480", "l0.8544292,0.1267841", "l0.8623755,0.1292045", "l0.8670921,0.1320770", "l0.8677240,0.1318119", "l0.8693085,0.1315025", "l0.8724756,0.1319785", "l0.8784966,0.1356793", "l0.8792796,0.1377740", "l0.8932801,0.1358611", "l0.8932801,0.1388864", "l0.8903968,0.1456061", "l0.8632857,0.1745114", "l0.8605331,0.1774470", "l0.8512050,0.1873232", "l0.8463558,0.1924495", "l0.8428386,0.1961301", "l0.8387540,0.2005265", "l0.8479126,0.2031970", "l0.8541823,0.2047929", "l0.8563177,0.2047967", "l0.8579998,0.2042980", "l0.8623682,0.2024798", "l0.8637352,0.2017487", "l0.8672192,0.2009596", "l0.8688350,0.2010783", "l0.8702979,0.2015707", "l0.8772677,0.2054381", "l0.8814021,0.2089899", "l0.8829147,0.2109987", "l0.8837125,0.2126604", "l0.8843573,0.2140543", "l0.8850022,0.2150758", "l0.8860266,0.2162311", "l0.8924934,0.2198914", "l0.8940466,0.2206073", "l0.8966020,0.2217929", "l0.8991132,0.2235896", "l0.8990948,0.2250619", "l0.8996162,0.2264381", "l0.8988092,0.2275480", "l0.8973113,0.2291225", "l0.8943727,0.2304886", "l0.8801493,0.2302045", "l0.8755856,0.2279886", "l0.8720040,0.2257664", "l0.8714236,0.2247083", "l0.8722435,0.2230303", "l0.8721348,0.2216957", "l0.8705282,0.2198460", "l0.8619370,0.2194331", "l0.8591145,0.2206515", "l0.8563822,0.2219937", "l0.8497661,0.2228434", "l0.8464976,0.2209646", "l0.8357435,0.2202753", "l0.8319794,0.2215025", "l0.8302549,0.2223851", "l0.8273697,0.2258258", "l0.8270841,0.2273838", "l0.8205012,0.2328662", "l0.8176031,0.2328586", "l0.8129289,0.2357058", "l0.8040982,0.2357058", "l0.7961519,0.2387311", "l0.7846737,0.2399407", "l0.7731955,0.2429672", "l0.7617172,0.2423611", "l0.7502372,0.2423611", "l0.7431734,0.2465972", "l0.7352270,0.2514381", "l0.7263982,0.2556742", "l0.7149181,0.2586995", "l0.7025556,0.2641465", "l0.6901948,0.2732222", "l0.6787166,0.2762487", "l0.6698859,0.2859306", "l0.6672365,0.2950076", "l0.6645890,0.3065038", "l0.6539933,0.3125556", "l0.6442783,0.3234470", "l0.6522264,0.3367601", "l0.6557583,0.3452311", "l0.6442783,0.3530985", "l0.6319175,0.3573333", "l0.6124911,0.3633851", "l0.6045448,0.3664104", "l0.6010129,0.3791187", "l0.5971586,0.3798725", "l0.5972341,0.3803434", "l0.5987726,0.3811301", "l0.6031428,0.3857626", "l0.6042574,0.3904141", "l0.6017130,0.3917487", "l0.5865389,0.3931098", "l0.5865868,0.3976364", "l0.5840775,0.4021919", "l0.5821337,0.4022715", "l0.5813857,0.4016742", "l0.5799321,0.4009167", "l0.5797018,0.4008308", "l0.5795452,0.3991136", "l0.5741929,0.3962917", "l0.5688426,0.3931881", "l0.5610197,0.3926237", "l0.5552566,0.3923422", "l0.5523770,0.3900859", "l0.5482592,0.3898030", "l0.5453776,0.3903674", "l0.5437324,0.3923422", "l0.5436200,0.3926995", "l0.5434044,0.3925783", "l0.5431870,0.3924798", "l0.5400273,0.3957285", "l0.5371457,0.3977020", "l0.5356258,0.3995240", "l0.5362945,0.4019596", "l0.5368399,0.4042020", "l0.5380412,0.4148952", "l0.5377574,0.4196540", "l0.5373650,0.4210429", "l0.5359666,0.4224621", "l0.5334978,0.4236477", "l0.5321123,0.4241806", "l0.5301483,0.4273232", "l0.5256196,0.4290164", "l0.5153279,0.4295808", "l0.5070942,0.4290164", "l0.5063019,0.4283813", "l0.5053402,0.4285770", "l0.5029782,0.4276061", "l0.4939209,0.4270417", "l0.4898068,0.4304268", "l0.4860999,0.4326843", "l0.4840917,0.4342134", "l0.4814607,0.4340114", "l0.4763701,0.4334104", "l0.4714509,0.4359495", "l0.4696343,0.4383258", "l0.4696343,0.4431212", "l0.4692234,0.4465063", "l0.4692234,0.4497828", "l0.4665003,0.4512336", "l0.4622738,0.4519583", "l0.4620399,0.4518220", "l0.4601827,0.4506199", "l0.4583698,0.4495063", "l0.4558567,0.4484621", "l0.4524262,0.4484621", "l0.4420497,0.4546490", "l0.4372428,0.4581540", "l0.4358021,0.4594167", "l0.4344037,0.4601995", "l0.4315166,0.4610631", "l0.4297055,0.4577904", "l0.4290404,0.4551692", "l0.4292928,0.4545732", "l0.4299469,0.4530101", "l0.4302970,0.4506944", "l0.4310173,0.4473422", "l0.4318262,0.4460783", "l0.4320859,0.4458384", "l0.4288820,0.4423851", "l0.4302638,0.4352816", "l0.4337183,0.4310202", "l0.4381364,0.4282083", "l0.4372428,0.4270720", "l0.4353986,0.4243902", "l0.4299672,0.4243902", "l0.4286222,0.4211629", "l0.4237472,0.4167929", "l0.4214958,0.4116528", "l0.4196202,0.4029141", "l0.4132454,0.3985442", "l0.4109959,0.3939179", "l0.4109959,0.3898068", "l0.4112851,0.3864179", "l0.4164457,0.3852399", "l0.4166631,0.3843384", "l0.4171071,0.3831338", "l0.4247347,0.3794003", "l0.4247347,0.3746641", "l0.4226620,0.3632980", "l0.4264721,0.3606881", "l0.4279368,0.3603737", "l0.4311703,0.3602449", "l0.4334659,0.3606048", "l0.4357781,0.3610543", "l0.4379430,0.3616528", "l0.4400396,0.3627020", "l0.4421160,0.3637803", "l0.4429488,0.3644949", "l0.4516855,0.3642449", "l0.4585964,0.3632980", "l0.4615535,0.3624874", "l0.4616456,0.3623876", "l0.4623678,0.3608750", "l0.4636759,0.3566654", "l0.4634585,0.3545404", "l0.4635469,0.3527134", "l0.4638952,0.3495101", "l0.4643760,0.3456780", "l0.4649656,0.3430290", "l0.4657081,0.3404545", "l0.4658610,0.3390328", "l0.4655883,0.3374015", "l0.4648256,0.3362172", "l0.4682709,0.3334634", "l0.4689618,0.3287273", "l0.4648145,0.3249394", "l0.4579055,0.3225707", "l0.4482310,0.3239912", "l0.4430778,0.3266818", "l0.4359753,0.3256578", "l0.4336833,0.3254482", "l0.4278705,0.3254760", "l0.4243478,0.3256679", "l0.4198984,0.3277803", "l0.4122966,0.3310960", "l0.4067675,0.3292008", "l0.4012403,0.3244659", "l0.3936385,0.3197298", "l0.3865323,0.3192424", "l0.3849958,0.3200896", "l0.3822063,0.3214116", "l0.3794372,0.3222715", "l0.3750652,0.3227235", "l0.3711795,0.3216263", "l0.3672589,0.3197487", "l0.3657094,0.3181427", "l0.3639388,0.3157210", "l0.3633161,0.3137386", "l0.3616782,0.3105391", "l0.3604769,0.3090455", "l0.3592094,0.3074899", "l0.3512133,0.3037235", "l0.3472595,0.3028649", "l0.3450744,0.3030139", "l0.3420160,0.3030960", "l0.3381930,0.3030215", "l0.3313116,0.3026780", "l0.3291044,0.3023030", "l0.3268124,0.3018548", "l0.3247360,0.3011225", "l0.3214823,0.2986578", "l0.3199734,0.2974621", "l0.3183134,0.2956768", "l0.3159330,0.2943687", "l0.3120879,0.2931364", "l0.3071723,0.2920682", "l0.3025626,0.2910518", "l0.3000938,0.2900215", "l0.2956149,0.2877437", "l0.2948503,0.2867348", "l0.2940636,0.2860328", "l0.2893249,0.2790278", "l0.2885603,0.2774596", "l0.2877533,0.2744495", "l0.2872190,0.2742664", "l0.2796172,0.2700038", "l0.2796172,0.2662159", "l0.2846894,0.2623056", "l0.2840593,0.2597967", "l0.2839063,0.2581553", "l0.2843430,0.2550366", "l0.2854337,0.2524242", "l0.2868100,0.2501111", "l0.2882323,0.2486199", "l0.2896510,0.2473510", "l0.2912889,0.2461578", "l0.2927647,0.2453447", "l0.2946863,0.2432639", "l0.2997216,0.2359975", "l0.3002688,0.2344318", "l0.3009247,0.2313750", "l0.3004862,0.2295846", "l0.2999740,0.2283914", "l0.3000938,0.2255732", "l0.3012508,0.2161793", "l0.3020154,0.2150985", "l0.3013171,0.2072045", "l0.3009247,0.2059962", "l0.3002688,0.2049975", "l0.2993955,0.2041035", "l0.2964016,0.2014659", "l0.2953311,0.2000051", "l0.2948503,0.1988573", "l0.2946752,0.1975164", "l0.2948945,0.1953851", "l0.2953422,0.1931124", "l0.2919890,0.1827942", "l0.2913552,0.1814167", "l0.2887113,0.1777740", "l0.2856437,0.1743624", "l0.2848662,0.1727172", "l0.2846709,0.1710253", "l0.2843430,0.1656187", "l0.2814633,0.1570025", "l0.2827051,0.1567437", "l0.3106010,0.1502058", "l0.3275549,0.1462311", "l0.3417765,0.1428813", "l0.3527001,0.1403056", "l0.3718741,0.1357753", "l0.3920651,0.1254949", "l0.4179970,0.1121439", "l0.4255988,0.1059987", "l0.4410235,0.0934407", "l0.4458727,0.0894823", "l0.4531429,0.0835013", "l0.4562197,0.0813232", "l0.4581247,0.0804798", "l0.4589372,0.0790833", "l0.4644424,0.0645202", "l0.4661687,0.0597904", "l0.4675450,0.0561465", "l0.4685067,0.0536023", "l0.4708429,0.0474306", "l0.4728309,0.0489318", "l0.4741961,0.0498396", "l0.4764899,0.0504785", "l0.4854237,0.0499242", "l0.4817666,0.0416439", "l0.4794506,0.0371389", "l0.4801858,0.0331578", "l0.4806740,0.0328409", "l0.4814810,0.0326136", "l0.4828923,0.0317323", "l0.4832571,0.0280593", "l0.4818310,0.0260290", "l0.4757529,0.0229028", "l0.4738589,0.0230101", "l0.4718489,0.0219545", "l0.4699678,0.0204886", "l0.4683096,0.0185934", "l0.4671949,0.0165669", "l0.4663658,0.0138194", "l0.4659273,0.0126742", "l0.4646377,0.0104659", "l0.4575554,0.0076692", "l0.4533621,0.0072348", "l0.4540456,0.0037285", "l0.4616566,0.0042828", "l0.4647371,0.0057222", "l0.4690502,0.0068220", "l0.4749717,0.0061237", "l0.4784668,0.0052374", "l0.4799960,0.0044356", "l0.4820963,0.0045833", "l0.4847089,0.0031641", "l0.4854366,0.0016843", "l0.4863542,0.0000000", "l0.4863542,0.0000000", "c"]}, {"n": "Madre de Dios", "u": "PE-MDD", "i": ["m0.8460075,0.5892765", "l0.8460499,0.5911250", "l0.8499595,0.5890480", "l0.8543058,0.5871162", "l0.8564393,0.5880871", "l0.8586557,0.5895934", "l0.8597685,0.5907159", "l0.8601665,0.5910581", "l0.8685421,0.5905808", "l0.8785445,0.5895530", "l0.8885433,0.5885240", "l0.8946822,0.5881742", "l0.8957066,0.5877298", "l0.8981091,0.5867298", "l0.8996383,0.5862601", "l0.9015268,0.5859356", "l0.9129921,0.5865177", "l0.9163195,0.5885290", "l0.9201959,0.5883662", "l0.9219646,0.5880795", "l0.9282565,0.5879129", "l0.9297193,0.5879280", "l0.9296475,0.5879558", "l0.9349849,0.5940354", "l0.9403371,0.6000972", "l0.9547780,0.6164217", "l0.9574642,0.6194571", "l0.9601541,0.6224937", "l0.9688908,0.6323674", "l0.9712491,0.6350265", "l0.9742873,0.6384457", "l0.9753577,0.6395859", "l0.9777160,0.6422462", "l0.9802290,0.6451806", "l0.9837683,0.6500328", "l0.9872855,0.6549634", "l0.9940563,0.6644634", "l0.9950844,0.6659848", "l0.9980544,0.6701604", "l0.9997144,0.6724444", "l0.9999999,0.6727361", "l0.9945169,0.6773207", "l0.9925713,0.6805821", "l0.9888589,0.6854634", "l0.9838328,0.6868043", "l0.9845550,0.6911604", "l0.9830534,0.6956162", "l0.9764484,0.6988939", "l0.9704035,0.7015303", "l0.9625824,0.7035063", "l0.9559958,0.7057626", "l0.9498200,0.7068902", "l0.9415881,0.7091490", "l0.9370595,0.7105593", "l0.9325309,0.7139432", "l0.9234754,0.7153548", "l0.9146595,0.7158687", "l0.9129755,0.7153056", "l0.8971308,0.7133801", "l0.8880753,0.7099937", "l0.8777836,0.7068902", "l0.8662575,0.7060455", "l0.8612811,0.7066768", "l0.8613161,0.7063270", "l0.8549230,0.7054508", "l0.8547645,0.7056023", "l0.8493810,0.7057626", "l0.8415581,0.7040707", "l0.8320900,0.7035063", "l0.8259142,0.7018131", "l0.8226218,0.7026604", "l0.8215587,0.7050303", "l0.8207868,0.7049407", "l0.8176842,0.7074558", "l0.8143881,0.7094306", "l0.8094504,0.7116869", "l0.8057453,0.7111225", "l0.8045091,0.7071730", "l0.8020402,0.7020960", "l0.8018247,0.6992879", "l0.8009624,0.6989785", "l0.7999823,0.6967348", "l0.7954536,0.6961705", "l0.7880453,0.6944785", "l0.7814568,0.6913750", "l0.7773409,0.6865795", "l0.7724014,0.6826301", "l0.7686981,0.6829116", "l0.7596408,0.6846048", "l0.7530524,0.6848876", "l0.7481147,0.6860152", "l0.7479360,0.6858018", "l0.7448223,0.6860152", "l0.7402937,0.6837588", "l0.7398810,0.6803725", "l0.7390593,0.6752955", "l0.7361759,0.6733207", "l0.7328835,0.6702184", "l0.7308255,0.6679596", "l0.7365886,0.6648573", "l0.7391606,0.6632412", "l0.7387184,0.6630088", "l0.7382099,0.6629167", "l0.7402937,0.6600619", "l0.7341179,0.6580871", "l0.7316472,0.6541376", "l0.7271204,0.6499066", "l0.7197103,0.6462374", "l0.7131255,0.6439811", "l0.7114784,0.6380581", "l0.7089322,0.6360215", "l0.7096378,0.6338169", "l0.7081841,0.6321326", "l0.7028338,0.6279015", "l0.7053026,0.6259268", "l0.7106548,0.6219760", "l0.7143581,0.6177462", "l0.7160052,0.6112563", "l0.7160052,0.6065025", "l0.7168508,0.6065909", "l0.7192404,0.6051881", "l0.7226157,0.6018460", "l0.7244895,0.5972197", "l0.7256152,0.5941364", "l0.7226157,0.5923371", "l0.7233638,0.5897664", "l0.7273415,0.5894255", "l0.7273176,0.5894028", "l0.7331156,0.5900240", "l0.7382744,0.5895682", "l0.7386558,0.5897904", "l0.7416700,0.5901250", "l0.7437445,0.5901250", "l0.7459517,0.5901250", "l0.7514126,0.5898295", "l0.7537709,0.5895644", "l0.7541615,0.5894520", "l0.7627435,0.5897664", "l0.7841210,0.5892525", "l0.7874962,0.5869394", "l0.7923713,0.5838548", "l0.7938728,0.5807715", "l0.7944163,0.5759242", "l0.7948659,0.5758598", "l0.7949967,0.5733169", "l0.7976221,0.5679205", "l0.8002476,0.5656073", "l0.8054984,0.5620076", "l0.8141246,0.5596957", "l0.8235006,0.5530126", "l0.8295124,0.5490720", "l0.8295124,0.5489167", "l0.8340005,0.5476162", "l0.8462581,0.5342816", "l0.8462028,0.5399091", "l0.8462249,0.5463018", "l0.8462028,0.5545846", "l0.8461384,0.5692879", "l0.8460923,0.5787184", "l0.8460075,0.5858826", "c"]}, {"n": "Moquegua", "u": "PE-MOQ", "i": ["m0.8329633,0.8661111", "l0.8333262,0.8664053", "l0.8378530,0.8658586", "l0.8440269,0.8655758", "l0.8489683,0.8658586", "l0.8502911,0.8667664", "l0.8507904,0.8666679", "l0.8626648,0.8688359", "l0.8641940,0.8702134", "l0.8677222,0.8770758", "l0.8685071,0.8819874", "l0.8680925,0.8832285", "l0.8679820,0.8847475", "l0.8707585,0.8905328", "l0.8714899,0.8919444", "l0.8798471,0.8980593", "l0.8852970,0.9016528", "l0.8876976,0.9023447", "l0.8922889,0.9028838", "l0.8944537,0.9045025", "l0.8879519,0.9087942", "l0.8876626,0.9129697", "l0.8872499,0.9174836", "l0.8849358,0.9193876", "l0.8851606,0.9196477", "l0.8827231,0.9197412", "l0.8786072,0.9205859", "l0.8775109,0.9187096", "l0.8761365,0.9185278", "l0.8761365,0.9166376", "l0.8753129,0.9126881", "l0.8716078,0.9112765", "l0.8685458,0.9118497", "l0.8680280,0.9116591", "l0.8640300,0.9117374", "l0.8615188,0.9127083", "l0.8588952,0.9149937", "l0.8569736,0.9190833", "l0.8566456,0.9206389", "l0.8579556,0.9227626", "l0.8585249,0.9238460", "l0.8584586,0.9254949", "l0.8540239,0.9292462", "l0.8490641,0.9332020", "l0.8473378,0.9339495", "l0.8445981,0.9346742", "l0.8419524,0.9351578", "l0.8406645,0.9358119", "l0.8390819,0.9374558", "l0.8363294,0.9409937", "l0.8325266,0.9461389", "l0.8298846,0.9497576", "l0.8283849,0.9512311", "l0.8283849,0.9538763", "l0.8242689,0.9603636", "l0.8197421,0.9631856", "l0.8127428,0.9651591", "l0.8073924,0.9674167", "l0.8039287,0.9674167", "l0.8038200,0.9673636", "l0.8030333,0.9667159", "l0.8023516,0.9657348", "l0.8005000,0.9647626", "l0.7933348,0.9619192", "l0.7890089,0.9568750", "l0.7881798,0.9526288", "l0.7875570,0.9496957", "l0.7856557,0.9443763", "l0.7841596,0.9438460", "l0.7788517,0.9405253", "l0.7782842,0.9399962", "l0.7781902,0.9389205", "l0.7742862,0.9373157", "l0.7711356,0.9364066", "l0.7790341,0.9348144", "l0.7840344,0.9324154", "l0.7879218,0.9311932", "l0.7901677,0.9253384", "l0.7864332,0.9218384", "l0.7849685,0.9208813", "l0.7823246,0.9169533", "l0.7816705,0.9151338", "l0.7816134,0.9137260", "l0.7821054,0.9125530", "l0.7830468,0.9116364", "l0.7881356,0.9087374", "l0.7908218,0.9080758", "l0.7927140,0.9074583", "l0.7934767,0.9045265", "l0.7927140,0.9011907", "l0.8003157,0.8940770", "l0.8049936,0.8925518", "l0.8040982,0.8912475", "l0.8020402,0.8904015", "l0.7991587,0.8884268", "l0.7975116,0.8867348", "l0.7991587,0.8847588", "l0.8028638,0.8847588", "l0.8061562,0.8858876", "l0.8123301,0.8889912", "l0.8176842,0.8901199", "l0.8206246,0.8893131", "l0.8199448,0.8879179", "l0.8199448,0.8865076", "l0.8208844,0.8851970", "l0.8226089,0.8840808", "l0.8243574,0.8829646", "l0.8263877,0.8812904", "l0.8275797,0.8799495", "l0.8282025,0.8771061", "l0.8283554,0.8756187", "l0.8284641,0.8733422", "l0.8283001,0.8705694", "l0.8283222,0.8678447", "l0.8288529,0.8654571", "l0.8309974,0.8652513", "c"]}, {"n": "Pasco", "u": "PE-PAS", "i": ["m0.3958199,0.5958687", "l0.3943036,0.5940480", "l0.3897750,0.5932020", "l0.3848963,0.5937045", "l0.3843546,0.5928030", "l0.3809682,0.5913131", "l0.3796896,0.5906477", "l0.3787187,0.5890795", "l0.3791977,0.5875177", "l0.3792861,0.5854053", "l0.3791111,0.5840644", "l0.3790227,0.5822614", "l0.3784331,0.5806528", "l0.3750707,0.5782045", "l0.3739431,0.5770985", "l0.3731914,0.5754028", "l0.3729501,0.5737222", "l0.3723384,0.5719053", "l0.3715517,0.5705960", "l0.3694882,0.5687955", "l0.3685264,0.5673965", "l0.3682648,0.5653674", "l0.3674505,0.5635126", "l0.3662179,0.5613750", "l0.3650590,0.5604798", "l0.3720749,0.5593497", "l0.3774253,0.5568106", "l0.3836010,0.5539899", "l0.3897750,0.5525795", "l0.3955380,0.5528611", "l0.3996540,0.5556831", "l0.4033609,0.5568106", "l0.4111819,0.5573737", "l0.4152979,0.5582210", "l0.4227081,0.5596326", "l0.4284711,0.5599129", "l0.4288414,0.5591528", "l0.4292523,0.5590278", "l0.4305291,0.5565290", "l0.4317635,0.5522967", "l0.4358795,0.5511679", "l0.4379374,0.5489116", "l0.4397467,0.5488081", "l0.4424661,0.5477828", "l0.4461712,0.5435518", "l0.4502871,0.5396023", "l0.4544049,0.5376275", "l0.4597553,0.5345240", "l0.4660711,0.5305568", "l0.4670623,0.5305076", "l0.4686560,0.5303220", "l0.4733394,0.5277525", "l0.4782789,0.5252146", "l0.4823967,0.5229583", "l0.4873362,0.5232399", "l0.4893389,0.5243624", "l0.4900832,0.5242298", "l0.4918648,0.5260619", "l0.4955699,0.5280354", "l0.4996858,0.5260619", "l0.5012132,0.5244899", "l0.5026116,0.5245896", "l0.5038018,0.5229583", "l0.5062725,0.5221124", "l0.5103884,0.5201364", "l0.5153279,0.5198548", "l0.5177967,0.5181616", "l0.5206783,0.5159053", "l0.5223254,0.5119558", "l0.5264413,0.5088523", "l0.5309700,0.5051843", "l0.5327203,0.5039861", "l0.5330298,0.5063131", "l0.5363222,0.5094167", "l0.5404381,0.5113902", "l0.5420852,0.5150593", "l0.5445541,0.5184432", "l0.5440843,0.5231288", "l0.5445080,0.5239040", "l0.5460243,0.5267929", "l0.5490827,0.5277525", "l0.5507298,0.5319848", "l0.5511407,0.5367816", "l0.5560802,0.5412942", "l0.5597853,0.5432702", "l0.5651375,0.5438333", "l0.5647248,0.5480644", "l0.5626668,0.5511679", "l0.5618433,0.5548359", "l0.5639012,0.5585038", "l0.5676063,0.5610429", "l0.5696643,0.5618889", "l0.5709006,0.5641452", "l0.5704897,0.5666831", "l0.5680688,0.5675139", "l0.5683212,0.5677298", "l0.5679490,0.5688788", "l0.5653917,0.5695152", "l0.5629892,0.5700455", "l0.5585122,0.5716338", "l0.5530292,0.5753573", "l0.5505806,0.5773093", "l0.5495986,0.5782045", "l0.5442446,0.5813687", "l0.5411143,0.5823447", "l0.5377132,0.5821414", "l0.5350491,0.5821869", "l0.5314490,0.5824343", "l0.5280885,0.5807891", "l0.5219145,0.5788144", "l0.5161515,0.5768396", "l0.5066833,0.5734545", "l0.5028364,0.5736301", "l0.5017549,0.5732828", "l0.4987352,0.5732260", "l0.4963916,0.5726086", "l0.4910412,0.5731730", "l0.4844546,0.5754293", "l0.4811604,0.5768396", "l0.4797399,0.5785455", "l0.4779657,0.5789912", "l0.4758119,0.5793927", "l0.4737042,0.5794306", "l0.4700783,0.5792033", "l0.4684035,0.5793106", "l0.4659310,0.5774053", "l0.4626368,0.5748649", "l0.4605788,0.5748649", "l0.4552285,0.5768396", "l0.4465839,0.5790972", "l0.4416425,0.5807891", "l0.4354686,0.5816351", "l0.4297055,0.5824823", "l0.4260005,0.5805076", "l0.4218845,0.5802247", "l0.4190030,0.5819179", "l0.4165323,0.5824823", "l0.4156553,0.5845278", "l0.4156479,0.5845278", "l0.4161214,0.5875606", "l0.4227081,0.5872778", "l0.4235298,0.5898169", "l0.4218845,0.5926376", "l0.4161214,0.5943308", "l0.4103584,0.5937664", "l0.4062424,0.5965871", "l0.4008902,0.5971515", "l0.3978724,0.5956742", "l0.3966324,0.5957917", "c"]}, {"n": "Piura", "u": "PE-PIU", "i": ["m0.0206571,0.3263952", "l0.0193398,0.3247159", "l0.0171897,0.3213510", "l0.0184186,0.3179848", "l0.0214880,0.3154609", "l0.0267057,0.3156705", "l0.0303887,0.3148295", "l0.0318516,0.3128258", "l0.0318995,0.3128346", "l0.0328557,0.3127715", "l0.0334600,0.3114634", "l0.0356083,0.3102008", "l0.0380642,0.3055732", "l0.0374488,0.3001035", "l0.0343794,0.2952652", "l0.0285482,0.2889545", "l0.0230228,0.2866402", "l0.0165762,0.2845366", "l0.0098237,0.2807500", "l0.0104373,0.2778043", "l0.0131990,0.2746490", "l0.0154818,0.2738157", "l0.0165467,0.2700417", "l0.0185512,0.2693965", "l0.0214807,0.2696275", "l0.0229214,0.2693207", "l0.0202592,0.2674962", "l0.0171897,0.2637096", "l0.0171897,0.2637096", "l0.0092102,0.2595025", "l0.0000000,0.2525606", "l0.0003077,0.2477222", "l0.0027636,0.2388876", "l0.0049119,0.2319457", "l0.0078855,0.2291856", "l0.0088638,0.2274217", "l0.0103378,0.2258409", "l0.0213775,0.2189078", "l0.0236897,0.2178649", "l0.0254363,0.2214571", "l0.0305306,0.2243131", "l0.0409513,0.2243131", "l0.0522968,0.2238359", "l0.0585481,0.2222500", "l0.0592298,0.2210038", "l0.0601805,0.2208902", "l0.0647681,0.2181250", "l0.0659583,0.2195518", "l0.0675796,0.2209811", "l0.0722096,0.2247891", "l0.0740631,0.2278030", "l0.0745274,0.2301136", "l0.0714966,0.2332008", "l0.0713971,0.2347033", "l0.0727734,0.2360657", "l0.0770238,0.2376679", "l0.0785309,0.2380417", "l0.0810421,0.2373409", "l0.0829656,0.2366389", "l0.0886255,0.2336856", "l0.0914425,0.2319116", "l0.0929220,0.2308169", "l0.0951347,0.2306604", "l0.0995326,0.2312955", "l0.1037020,0.2331982", "l0.1108800,0.2351035", "l0.1173634,0.2366894", "l0.1212988,0.2390707", "l0.1235576,0.2379785", "l0.1237474,0.2380530", "l0.1262531,0.2382210", "l0.1288932,0.2376490", "l0.1314874,0.2382765", "l0.1395921,0.2384356", "l0.1438905,0.2393359", "l0.1454897,0.2403093", "l0.1470189,0.2435505", "l0.1473671,0.2456578", "l0.1523711,0.2534987", "l0.1528925,0.2551654", "l0.1591419,0.2599318", "l0.1654227,0.2641490", "l0.1696529,0.2641098", "l0.1679910,0.2651717", "l0.1634016,0.2686641", "l0.1569200,0.2750821", "l0.1596228,0.2816263", "l0.1624306,0.2842765", "l0.1628784,0.2931806", "l0.1611649,0.2930164", "l0.1564133,0.2969836", "l0.1548491,0.3055884", "l0.1564133,0.3101364", "l0.1575151,0.3115644", "l0.1588803,0.3124987", "l0.1596449,0.3134482", "l0.1604537,0.3151301", "l0.1540956,0.3185694", "l0.1524135,0.3192563", "l0.1512509,0.3175366", "l0.1456076,0.3160720", "l0.1432548,0.3164495", "l0.1429306,0.3164975", "l0.1407510,0.3147235", "l0.1388386,0.3123434", "l0.1367566,0.3112715", "l0.1339765,0.3106768", "l0.1307541,0.3096944", "l0.1292249,0.3066162", "l0.1254221,0.3017879", "l0.1166099,0.2969609", "l0.1147509,0.2960114", "l0.1132438,0.2953775", "l0.1123152,0.2964609", "l0.1124276,0.2976364", "l0.1110532,0.2990139", "l0.1105318,0.3032980", "l0.1089694,0.3052020", "l0.1041073,0.3093687", "l0.1004593,0.3112715", "l0.0961186,0.3136528", "l0.0946723,0.3145808", "l0.0875532,0.3160871", "l0.0847675,0.3168939", "l0.0833359,0.3175821", "l0.0815654,0.3187336", "l0.0781790,0.3213434", "l0.0737978,0.3251490", "l0.0719038,0.3276843", "l0.0710968,0.3297790", "l0.0683498,0.3327790", "l0.0642430,0.3369230", "l0.0622109,0.3388232", "l0.0614039,0.3391970", "l0.0609230,0.3389886", "l0.0574022,0.3394419", "l0.0512632,0.3413346", "l0.0448166,0.3383902", "l0.0377565,0.3343927", "l0.0337659,0.3322891", "l0.0324246,0.3302967", "l0.0251157,0.3282008", "c"]}, {"n": "Puno", "u": "PE-PUN", "i": ["m0.9214248,0.8650997", "l0.9246803,0.8662816", "l0.9330909,0.8674343", "l0.9342148,0.8697399", "l0.9302886,0.8728144", "l0.9280446,0.8770417", "l0.9325309,0.8801162", "l0.9398213,0.8778106", "l0.9437456,0.8778106", "l0.9476718,0.8820379", "l0.9538420,0.8828068", "l0.9611324,0.8808851", "l0.9644967,0.8766578", "l0.9684966,0.8749710", "l0.9691690,0.8753093", "l0.9719713,0.8777096", "l0.9728244,0.8777184", "l0.9736958,0.8792588", "l0.9757538,0.8823611", "l0.9757538,0.8874407", "l0.9752306,0.8894773", "l0.9750721,0.8895240", "l0.9716655,0.8925025", "l0.9710962,0.8966692", "l0.9718332,0.9000770", "l0.9732260,0.9012361", "l0.9733771,0.9027816", "l0.9703648,0.9042778", "l0.9658877,0.9058359", "l0.9592550,0.9095530", "l0.9491310,0.9178485", "l0.9439206,0.9249419", "l0.9423914,0.9260240", "l0.9377504,0.9274154", "l0.9325493,0.9292551", "l0.9277314,0.9323295", "l0.9256789,0.9340114", "l0.9227458,0.9380795", "l0.9211116,0.9384205", "l0.9183166,0.9388270", "l0.9167009,0.9387803", "l0.9085058,0.9359129", "l0.9018234,0.9335366", "l0.8943524,0.9298068", "l0.8930185,0.9287879", "l0.8849358,0.9193876", "l0.8872499,0.9174836", "l0.8876626,0.9129697", "l0.8879519,0.9087942", "l0.8944537,0.9045025", "l0.8922889,0.9028838", "l0.8876976,0.9023447", "l0.8852970,0.9016528", "l0.8798471,0.8980593", "l0.8714899,0.8919444", "l0.8707585,0.8905328", "l0.8679820,0.8847475", "l0.8680925,0.8832285", "l0.8685071,0.8819874", "l0.8677222,0.8770758", "l0.8641940,0.8702134", "l0.8626648,0.8688359", "l0.8507904,0.8666679", "l0.8502911,0.8667664", "l0.8489683,0.8658586", "l0.8440269,0.8655758", "l0.8378530,0.8658586", "l0.8333262,0.8664053", "l0.8329633,0.8661111", "l0.8309974,0.8652513", "l0.8288529,0.8654571", "l0.8296211,0.8636503", "l0.8300578,0.8620480", "l0.8291513,0.8607879", "l0.8260984,0.8592210", "l0.8219549,0.8544886", "l0.8225371,0.8523005", "l0.8245858,0.8500480", "l0.8249359,0.8488207", "l0.8243666,0.8476831", "l0.8233201,0.8468409", "l0.8217798,0.8459912", "l0.8198342,0.8450189", "l0.8182406,0.8438295", "l0.8159633,0.8417134", "l0.8150053,0.8360770", "l0.8151582,0.8315707", "l0.8147455,0.8290707", "l0.8184469,0.8276856", "l0.8189388,0.8230707", "l0.8189075,0.8219457", "l0.8186441,0.8202348", "l0.8181521,0.8190631", "l0.8167537,0.8176982", "l0.8159910,0.8167121", "l0.8154217,0.8107121", "l0.8158804,0.8095720", "l0.8174539,0.8079697", "l0.8185077,0.8065732", "l0.8171480,0.8008106", "l0.8135000,0.7970644", "l0.8114236,0.7967033", "l0.8095241,0.7952727", "l0.8071308,0.7927109", "l0.8071419,0.7924811", "l0.8053326,0.7912412", "l0.8073924,0.7889848", "l0.8127428,0.7864444", "l0.8148008,0.7827778", "l0.8160352,0.7776995", "l0.8205638,0.7726225", "l0.8230345,0.7683902", "l0.8242689,0.7633131", "l0.8255052,0.7579533", "l0.8238562,0.7528737", "l0.8242689,0.7494899", "l0.8250925,0.7455404", "l0.8316791,0.7435644", "l0.8374422,0.7390518", "l0.8399110,0.7359482", "l0.8456741,0.7311515", "l0.8522607,0.7260745", "l0.8600817,0.7201503", "l0.8604944,0.7142260", "l0.8612811,0.7066768", "l0.8662575,0.7060455", "l0.8777836,0.7068902", "l0.8880753,0.7099937", "l0.8971308,0.7133801", "l0.9129755,0.7153056", "l0.9146595,0.7158687", "l0.9234754,0.7153548", "l0.9325309,0.7139432", "l0.9370595,0.7105593", "l0.9415881,0.7091490", "l0.9498200,0.7068902", "l0.9559958,0.7057626", "l0.9625824,0.7035063", "l0.9704035,0.7015303", "l0.9764484,0.6988939", "l0.9830534,0.6956162", "l0.9820530,0.7010985", "l0.9825542,0.7069242", "l0.9840539,0.7093232", "l0.9815537,0.7168624", "l0.9775115,0.7214268", "l0.9775410,0.7250366", "l0.9773991,0.7280114", "l0.9759896,0.7312790", "l0.9725351,0.7354621", "l0.9694141,0.7390859", "l0.9732371,0.7436806", "l0.9742191,0.7463460", "l0.9763065,0.7533422", "l0.9774230,0.7544924", "l0.9792783,0.7555038", "l0.9807246,0.7561944", "l0.9800540,0.7605556", "l0.9815537,0.7643258", "l0.9760541,0.7656957", "l0.9720543,0.7677525", "l0.9705527,0.7742639", "l0.9655524,0.7783763", "l0.9605502,0.7821452", "l0.9545513,0.7872854", "l0.9495510,0.7920833", "l0.9460505,0.7972235", "l0.9462918,0.7990455", "l0.9456617,0.7994773", "l0.9443573,0.8085745", "l0.9511521,0.8149331", "l0.9587981,0.8193245", "l0.9609169,0.8209444", "l0.9635700,0.8231553", "l0.9630946,0.8246439", "l0.9609943,0.8251376", "l0.9589381,0.8250455", "l0.9532506,0.8286705", "l0.9482006,0.8348876", "l0.9477142,0.8356023", "l0.9448695,0.8347664", "l0.9415052,0.8328447", "l0.9336529,0.8324609", "l0.9308487,0.8286174", "l0.9263625,0.8278485", "l0.9207542,0.8278485", "l0.9190720,0.8232374", "l0.9129036,0.8197790", "l0.9072953,0.8186263", "l0.9005669,0.8174722", "l0.8949586,0.8163182", "l0.8887883,0.8163182", "l0.8826218,0.8167033", "l0.8814979,0.8190088", "l0.8826218,0.8213144", "l0.8876681,0.8213144", "l0.8927145,0.8216995", "l0.8994430,0.8213144", "l0.9028091,0.8224684", "l0.9039311,0.8278485", "l0.8994430,0.8297702", "l0.8966407,0.8316919", "l0.8977609,0.8355354", "l0.9016870,0.8370720", "l0.9016870,0.8420682", "l0.8983228,0.8424533", "l0.8966407,0.8459116", "l0.8927145,0.8470644", "l0.8871062,0.8486023", "l0.8887883,0.8528295", "l0.8899122,0.8570568", "l0.8915943,0.8605152", "l0.8960787,0.8601326", "l0.8994430,0.8601326", "l0.9033692,0.8624381", "l0.9061752,0.8632058", "l0.9084174,0.8601326", "l0.9106596,0.8593624", "l0.9123417,0.8624381", "l0.9145858,0.8655114", "l0.9213161,0.8655114", "c"]}, {"n": "San Martín", "u": "PE-SAM", "i": ["m0.3381930,0.3030215", "l0.3420160,0.3030960", "l0.3450744,0.3030139", "l0.3472595,0.3028649", "l0.3512133,0.3037235", "l0.3592094,0.3074899", "l0.3604769,0.3090455", "l0.3616782,0.3105391", "l0.3633161,0.3137386", "l0.3639388,0.3157197", "l0.3657094,0.3181427", "l0.3672589,0.3197487", "l0.3711795,0.3216263", "l0.3750652,0.3227235", "l0.3794372,0.3222715", "l0.3822063,0.3214116", "l0.3849958,0.3200896", "l0.3865323,0.3192424", "l0.3936385,0.3197298", "l0.4012403,0.3244659", "l0.4067675,0.3292008", "l0.4122966,0.3310960", "l0.4198984,0.3277803", "l0.4243478,0.3256679", "l0.4278705,0.3254760", "l0.4336815,0.3254482", "l0.4359753,0.3256578", "l0.4430778,0.3266818", "l0.4482310,0.3239924", "l0.4579055,0.3225707", "l0.4648145,0.3249394", "l0.4689618,0.3287273", "l0.4682709,0.3334634", "l0.4648256,0.3362172", "l0.4655883,0.3374015", "l0.4658610,0.3390328", "l0.4657081,0.3404545", "l0.4649656,0.3430278", "l0.4643760,0.3456780", "l0.4638952,0.3495101", "l0.4635469,0.3527134", "l0.4634585,0.3545404", "l0.4636759,0.3566654", "l0.4623678,0.3608750", "l0.4616456,0.3623876", "l0.4615535,0.3624874", "l0.4585964,0.3632980", "l0.4516855,0.3642449", "l0.4429469,0.3644949", "l0.4421160,0.3637803", "l0.4400396,0.3627020", "l0.4379430,0.3616528", "l0.4357781,0.3610543", "l0.4334659,0.3606048", "l0.4311703,0.3602449", "l0.4279368,0.3603737", "l0.4264721,0.3606881", "l0.4226620,0.3632980", "l0.4247347,0.3746641", "l0.4247347,0.3794003", "l0.4171071,0.3831338", "l0.4166631,0.3843384", "l0.4164457,0.3852399", "l0.4112851,0.3864179", "l0.4109959,0.3898068", "l0.4109959,0.3939179", "l0.4132454,0.3985442", "l0.4196202,0.4029141", "l0.4214958,0.4116528", "l0.4237472,0.4167929", "l0.4286222,0.4211629", "l0.4299672,0.4243902", "l0.4353986,0.4243902", "l0.4372428,0.4270720", "l0.4381364,0.4282083", "l0.4337183,0.4310202", "l0.4302638,0.4352816", "l0.4288820,0.4423851", "l0.4293813,0.4429242", "l0.4219711,0.4447538", "l0.4150602,0.4494886", "l0.4171329,0.4613283", "l0.4186069,0.4653674", "l0.4172545,0.4668636", "l0.4158653,0.4675720", "l0.4118894,0.4672449", "l0.4098443,0.4653636", "l0.4047648,0.4565922", "l0.4017488,0.4530442", "l0.3992431,0.4524306", "l0.3956578,0.4504419", "l0.3955178,0.4510808", "l0.3922567,0.4499634", "l0.3894912,0.4523308", "l0.3867276,0.4561199", "l0.3832731,0.4546982", "l0.3777440,0.4532778", "l0.3701422,0.4551717", "l0.3646150,0.4542247", "l0.3577041,0.4551717", "l0.3546623,0.4554040", "l0.3550381,0.4563813", "l0.3519042,0.4563813", "l0.3469647,0.4563813", "l0.3438234,0.4563813", "l0.3431085,0.4551301", "l0.3416125,0.4544621", "l0.3393076,0.4545366", "l0.3383514,0.4548232", "l0.3342078,0.4504369", "l0.3376642,0.4480682", "l0.3438823,0.4466477", "l0.3514841,0.4457008", "l0.3537540,0.4453119", "l0.3537908,0.4442904", "l0.3532381,0.4424949", "l0.3549405,0.4419116", "l0.3528659,0.4367020", "l0.3501023,0.4338611", "l0.3459569,0.4295985", "l0.3376642,0.4286515", "l0.3328260,0.4262841", "l0.3266079,0.4267576", "l0.3183152,0.4291250", "l0.3173553,0.4291250", "l0.3164194,0.4250669", "l0.3151850,0.4197071", "l0.3123034,0.4180139", "l0.3092856,0.4179104", "l0.3091326,0.4175366", "l0.3057168,0.4171679", "l0.3048932,0.4115253", "l0.3044824,0.4067298", "l0.3032480,0.4036263", "l0.3027560,0.3987513", "l0.3019712,0.3984949", "l0.2993844,0.3973472", "l0.2981482,0.3955997", "l0.2960534,0.3917904", "l0.2957236,0.3889646", "l0.2977889,0.3861679", "l0.2982385,0.3846389", "l0.2970354,0.3831098", "l0.2900434,0.3773093", "l0.2867989,0.3734053", "l0.2856106,0.3729040", "l0.2843854,0.3719444", "l0.2834255,0.3699975", "l0.2835563,0.3679899", "l0.2848883,0.3653826", "l0.2861559,0.3635177", "l0.2871840,0.3581452", "l0.2913644,0.3557210", "l0.2955117,0.3552475", "l0.3038044,0.3557210", "l0.3093316,0.3585619", "l0.3134789,0.3571414", "l0.3176243,0.3538270", "l0.3176243,0.3514861", "l0.3183134,0.3512159", "l0.3191443,0.3499886", "l0.3199199,0.3478712", "l0.3205740,0.3463434", "l0.3218305,0.3446301", "l0.3233597,0.3433573", "l0.3252169,0.3424003", "l0.3281224,0.3411654", "l0.3309744,0.3395644", "l0.3326676,0.3373636", "l0.3314000,0.3338561", "l0.3299003,0.3313573", "l0.3289349,0.3298018", "l0.3269819,0.3276288", "l0.3231257,0.3248624", "l0.3160767,0.3231616", "l0.3130164,0.3226439", "l0.3095674,0.3220934", "l0.3060024,0.3215960", "l0.3038099,0.3212172", "l0.3017317,0.3206010", "l0.2984761,0.3181048", "l0.2903069,0.3074154", "l0.2891480,0.3056957", "l0.2880683,0.3037538", "l0.2887777,0.2924419", "l0.2892143,0.2908725", "l0.2901318,0.2897891", "l0.2919024,0.2881831", "l0.2938664,0.2870631", "l0.2948503,0.2867348", "l0.2956149,0.2877437", "l0.3000938,0.2900215", "l0.3025626,0.2910518", "l0.3071723,0.2920682", "l0.3120879,0.2931364", "l0.3159330,0.2943687", "l0.3183134,0.2956768", "l0.3199734,0.2974621", "l0.3214823,0.2986578", "l0.3247360,0.3011225", "l0.3268124,0.3018561", "l0.3291044,0.3023030", "l0.3313116,0.3026780", "c"]}, {"n": "Tacna", "u": "PE-TAC", "i": ["m0.8716078,0.9112765", "l0.8753129,0.9126881", "l0.8761365,0.9166376", "l0.8761365,0.9185278", "l0.8775109,0.9187096", "l0.8786072,0.9205859", "l0.8827231,0.9197412", "l0.8851606,0.9196477", "l0.8930185,0.9287879", "l0.8943524,0.9298068", "l0.9018234,0.9335366", "l0.9085058,0.9359129", "l0.9167009,0.9387803", "l0.9183166,0.9388270", "l0.9211116,0.9384205", "l0.9227458,0.9380795", "l0.9278861,0.9385303", "l0.9323853,0.9414760", "l0.9349426,0.9432222", "l0.9349849,0.9459205", "l0.9350513,0.9503194", "l0.9248056,0.9566237", "l0.9205662,0.9592159", "l0.9199564,0.9591856", "l0.9189468,0.9602235", "l0.9135964,0.9607866", "l0.9115384,0.9627626", "l0.9123601,0.9667121", "l0.9140091,0.9695328", "l0.9160671,0.9757386", "l0.9164779,0.9813813", "l0.9131837,0.9864583", "l0.9090677,0.9915366", "l0.9012467,0.9966149", "l0.8888970,0.9983068", "l0.8757238,0.9988712", "l0.8674919,1.0000000", "l0.8654339,0.9985896", "l0.8644943,0.9973826", "l0.8638163,0.9977992", "l0.8630351,0.9972311", "l0.8545711,0.9921768", "l0.8511829,0.9906098", "l0.8491839,0.9900366", "l0.8460610,0.9896212", "l0.8446202,0.9890581", "l0.8385568,0.9853472", "l0.8252307,0.9770505", "l0.8231985,0.9749558", "l0.8204146,0.9733838", "l0.8157938,0.9715000", "l0.8095886,0.9702008", "l0.8039287,0.9674167", "l0.8073924,0.9674167", "l0.8127428,0.9651591", "l0.8197421,0.9631856", "l0.8242689,0.9603636", "l0.8283849,0.9538763", "l0.8283849,0.9512311", "l0.8298846,0.9497576", "l0.8325266,0.9461389", "l0.8363294,0.9409937", "l0.8390819,0.9374558", "l0.8406645,0.9358119", "l0.8419524,0.9351578", "l0.8445981,0.9346742", "l0.8473378,0.9339495", "l0.8490641,0.9332020", "l0.8540239,0.9292462", "l0.8584586,0.9254949", "l0.8585249,0.9238460", "l0.8579556,0.9227626", "l0.8566456,0.9206389", "l0.8569736,0.9190833", "l0.8588952,0.9149937", "l0.8615188,0.9127083", "l0.8640300,0.9117374", "l0.8680280,0.9116591", "l0.8685458,0.9118497", "c"]}, {"n": "Tumbes", "u": "PE-TUM", "i": ["m0.0812264,0.2120025", "l0.0786396,0.2112222", "l0.0761929,0.2111692", "l0.0726426,0.2115581", "l0.0697905,0.2150455", "l0.0698274,0.2153182", "l0.0690278,0.2156654", "l0.0673659,0.2165593", "l0.0601805,0.2208902", "l0.0592298,0.2210038", "l0.0585481,0.2222500", "l0.0522968,0.2238359", "l0.0409513,0.2243131", "l0.0305306,0.2243131", "l0.0254363,0.2214571", "l0.0236897,0.2178649", "l0.0258398,0.2168965", "l0.0290272,0.2125934", "l0.0315071,0.2102159", "l0.0352748,0.2083826", "l0.0398311,0.2065152", "l0.0413050,0.2052967", "l0.0419149,0.2030316", "l0.0426813,0.2013169", "l0.0437738,0.1997816", "l0.0449751,0.1987614", "l0.0524682,0.1954293", "l0.0581041,0.1934179", "l0.0618829,0.1919659", "l0.0654019,0.1887551", "l0.0661647,0.1877563", "l0.0673843,0.1860682", "l0.0696726,0.1854230", "l0.0742713,0.1853712", "l0.0762150,0.1852980", "l0.0779414,0.1850000", "l0.0794816,0.1842172", "l0.0796437,0.1840593", "l0.0835570,0.1848788", "l0.0863354,0.1855139", "l0.0874924,0.1890051", "l0.0888816,0.1924962", "l0.0905029,0.1958283", "l0.0909672,0.2012235", "l0.0895762,0.2051907", "l0.0879567,0.2082058", "l0.0847141,0.2105859", "c"]}, {"n": "Ucayali", "u": "PE-UCA", "i": ["m0.5610197,0.3926237", "l0.5688426,0.3931881", "l0.5741929,0.3962917", "l0.5795452,0.3991136", "l0.5797018,0.4008308", "l0.5799321,0.4009167", "l0.5813857,0.4016742", "l0.5821337,0.4022715", "l0.5809528,0.4023586", "l0.5807630,0.4036515", "l0.5831563,0.4047348", "l0.5864302,0.4066111", "l0.5916940,0.4101831", "l0.5927644,0.4114949", "l0.5935309,0.4124558", "l0.5951577,0.4132285", "l0.6006297,0.4145947", "l0.6028148,0.4150000", "l0.6041929,0.4156452", "l0.6052063,0.4171023", "l0.6048580,0.4194179", "l0.6027208,0.4212222", "l0.5986602,0.4208611", "l0.5990563,0.4249242", "l0.6002852,0.4259533", "l0.6039405,0.4268624", "l0.6085171,0.4286338", "l0.6129204,0.4342967", "l0.6159880,0.4412096", "l0.6171893,0.4441098", "l0.6178341,0.4467929", "l0.6221270,0.4492967", "l0.6279379,0.4521073", "l0.6325808,0.4603270", "l0.6382720,0.4642197", "l0.6408164,0.4645101", "l0.6428154,0.4648624", "l0.6453063,0.4656225", "l0.6466605,0.4663826", "l0.6477752,0.4675114", "l0.6486042,0.4689861", "l0.6493265,0.4705215", "l0.6501795,0.4714394", "l0.6551430,0.4765833", "l0.6593142,0.4780960", "l0.6627282,0.4812475", "l0.6636125,0.4843573", "l0.6638520,0.4854798", "l0.6637673,0.4867601", "l0.6632846,0.4883333", "l0.6624113,0.4896288", "l0.6579121,0.4938636", "l0.6503748,0.4988674", "l0.6473385,0.5005543", "l0.6453819,0.5016692", "l0.6439835,0.5036111", "l0.6612763,0.5041578", "l0.6706247,0.5042336", "l0.6722866,0.5042020", "l0.6810030,0.5042790", "l0.6906812,0.5060732", "l0.7067802,0.5081086", "l0.7091846,0.5085985", "l0.7147007,0.5108005", "l0.7185569,0.5175202", "l0.7181516,0.5194558", "l0.7172341,0.5215189", "l0.7179397,0.5230732", "l0.7205983,0.5240846", "l0.7242371,0.5254773", "l0.7254586,0.5271780", "l0.7265585,0.5300215", "l0.7251767,0.5336869", "l0.7237986,0.5362992", "l0.7270983,0.5364205", "l0.7343077,0.5364205", "l0.7376074,0.5364053", "l0.7400523,0.5364053", "l0.7438993,0.5364053", "l0.7665738,0.5364053", "l0.7809483,0.5363902", "l0.7881153,0.5363763", "l0.7937494,0.5359141", "l0.8028712,0.5324798", "l0.8045625,0.5301831", "l0.8061654,0.5287601", "l0.8159633,0.5264255", "l0.8182129,0.5251149", "l0.8194731,0.5233308", "l0.8263453,0.5182298", "l0.8293595,0.5169015", "l0.8344280,0.5147298", "l0.8451103,0.5085000", "l0.8494142,0.5057866", "l0.8510300,0.5053864", "l0.8501290,0.5082917", "l0.8503114,0.5110934", "l0.8492391,0.5161439", "l0.8488891,0.5242803", "l0.8475257,0.5252247", "l0.8465087,0.5267033", "l0.8462452,0.5305000", "l0.8462673,0.5333636", "l0.8462581,0.5342816", "l0.8340005,0.5476162", "l0.8295124,0.5489167", "l0.8295124,0.5490720", "l0.8235006,0.5530126", "l0.8141246,0.5596957", "l0.8054984,0.5620076", "l0.8002494,0.5656073", "l0.7976221,0.5679205", "l0.7949967,0.5733169", "l0.7948659,0.5758598", "l0.7944163,0.5759242", "l0.7938728,0.5807715", "l0.7923713,0.5838548", "l0.7874962,0.5869394", "l0.7841210,0.5892525", "l0.7627435,0.5897664", "l0.7541615,0.5894520", "l0.7537709,0.5895644", "l0.7514126,0.5898295", "l0.7459517,0.5901250", "l0.7437445,0.5901250", "l0.7416700,0.5901250", "l0.7386558,0.5897904", "l0.7382744,0.5895682", "l0.7331156,0.5900240", "l0.7273176,0.5894028", "l0.7273415,0.5894255", "l0.7233638,0.5897664", "l0.7226157,0.5923371", "l0.7256152,0.5941364", "l0.7244895,0.5972197", "l0.7226157,0.6018460", "l0.7192404,0.6051881", "l0.7168508,0.6065909", "l0.7150821,0.6064066", "l0.7061814,0.6085152", "l0.7018112,0.6112311", "l0.6963061,0.6136894", "l0.6932145,0.6143043", "l0.6893049,0.6135985", "l0.6837777,0.6119444", "l0.6728320,0.6110947", "l0.6666286,0.6088030", "l0.6645098,0.6076048", "l0.6622473,0.6039419", "l0.6562558,0.6047083", "l0.6545681,0.6056566", "l0.6525802,0.6061490", "l0.6500247,0.6066654", "l0.6472059,0.6069987", "l0.6415275,0.6076048", "l0.6396041,0.6077866", "l0.6272286,0.6087917", "l0.6255409,0.6083207", "l0.6253917,0.6082525", "l0.6260623,0.6032172", "l0.6244134,0.5950366", "l0.6209736,0.5931843", "l0.6210105,0.5930492", "l0.6165924,0.5922146", "l0.6157706,0.5874192", "l0.6155827,0.5836982", "l0.6152566,0.5833447", "l0.6123622,0.5807626", "l0.6095986,0.5792563", "l0.5995279,0.5771578", "l0.5977482,0.5794609", "l0.5961084,0.5817020", "l0.5954341,0.5823535", "l0.5955981,0.5847386", "l0.5955981,0.5875606", "l0.5951872,0.5926376", "l0.5935401,0.5963043", "l0.5898369,0.5977159", "l0.5820140,0.5965871", "l0.5799560,0.5923561", "l0.5790698,0.5889104", "l0.5725145,0.5895934", "l0.5696901,0.5901452", "l0.5680190,0.5898169", "l0.5569038,0.5903813", "l0.5486719,0.5903813", "l0.5431575,0.5890316", "l0.5427596,0.5882298", "l0.5420834,0.5858359", "l0.5411143,0.5823447", "l0.5442446,0.5813687", "l0.5495986,0.5782045", "l0.5505806,0.5773093", "l0.5530292,0.5753573", "l0.5585122,0.5716338", "l0.5629892,0.5700455", "l0.5653917,0.5695152", "l0.5679490,0.5688788", "l0.5683212,0.5677298", "l0.5680688,0.5675139", "l0.5704897,0.5666831", "l0.5709006,0.5641452", "l0.5696643,0.5618889", "l0.5676063,0.5610429", "l0.5639012,0.5585038", "l0.5618433,0.5548359", "l0.5626668,0.5511679", "l0.5647266,0.5480644", "l0.5651375,0.5438333", "l0.5597853,0.5432702", "l0.5560802,0.5412942", "l0.5511407,0.5367816", "l0.5507298,0.5319848", "l0.5490827,0.5277525", "l0.5460243,0.5267929", "l0.5445080,0.5239040", "l0.5440843,0.5231288", "l0.5445541,0.5184432", "l0.5420852,0.5150593", "l0.5404381,0.5113902", "l0.5363222,0.5094167", "l0.5330298,0.5063131", "l0.5326171,0.5032109", "l0.5342642,0.5001073", "l0.5375566,0.4972866", "l0.5359113,0.4930543", "l0.5326171,0.4902336", "l0.5326171,0.4845909", "l0.5312187,0.4804848", "l0.5324715,0.4764066", "l0.5371034,0.4702336", "l0.5408619,0.4685619", "l0.5410996,0.4671654", "l0.5405763,0.4653447", "l0.5394064,0.4635051", "l0.5374626,0.4622071", "l0.5360090,0.4616881", "l0.5329948,0.4614331", "l0.5286264,0.4612222", "l0.5259605,0.4613586", "l0.5241918,0.4616591", "l0.5178189,0.4634407", "l0.5170229,0.4638157", "l0.5153279,0.4682285", "l0.5124464,0.4735896", "l0.5120355,0.4772563", "l0.5099757,0.4797955", "l0.5062725,0.4797955", "l0.5042126,0.4769747", "l0.4984496,0.4775379", "l0.4934880,0.4781869", "l0.4928616,0.4787904", "l0.4918648,0.4837449", "l0.4877470,0.4871301", "l0.4881597,0.4927727", "l0.4848655,0.4950290", "l0.4807495,0.4975682", "l0.4745738,0.4986970", "l0.4701225,0.4979646", "l0.4624544,0.5007058", "l0.4587843,0.5027096", "l0.4572901,0.5032462", "l0.4531686,0.5023636", "l0.4498763,0.4992614", "l0.4465839,0.4953119", "l0.4424661,0.4902336", "l0.4412317,0.4885404", "l0.4397743,0.4876667", "l0.4393837,0.4861641", "l0.4381935,0.4843573", "l0.4368946,0.4833939", "l0.4325244,0.4767083", "l0.4301090,0.4705202", "l0.4313527,0.4654078", "l0.4316069,0.4610354", "l0.4344037,0.4601995", "l0.4358021,0.4594167", "l0.4372428,0.4581540", "l0.4420497,0.4546490", "l0.4524262,0.4484621", "l0.4558567,0.4484621", "l0.4583698,0.4495063", "l0.4601827,0.4506199", "l0.4620399,0.4518220", "l0.4622738,0.4519583", "l0.4665003,0.4512336", "l0.4692234,0.4497828", "l0.4692234,0.4465063", "l0.4696343,0.4431212", "l0.4696343,0.4383258", "l0.4714509,0.4359495", "l0.4763701,0.4334104", "l0.4814607,0.4340114", "l0.4840917,0.4342134", "l0.4860999,0.4326843", "l0.4898068,0.4304268", "l0.4939209,0.4270417", "l0.5029782,0.4276061", "l0.5053402,0.4285770", "l0.5063019,0.4283813", "l0.5070942,0.4290164", "l0.5153279,0.4295808", "l0.5256196,0.4290164", "l0.5301483,0.4273232", "l0.5321123,0.4241806", "l0.5334978,0.4236477", "l0.5359666,0.4224621", "l0.5373650,0.4210429", "l0.5377574,0.4196540", "l0.5380412,0.4148952", "l0.5368399,0.4042020", "l0.5362945,0.4019596", "l0.5356258,0.3995240", "l0.5371457,0.3977020", "l0.5400273,0.3957285", "l0.5431870,0.3924798", "l0.5434044,0.3925783", "l0.5436200,0.3926995", "l0.5437324,0.3923422", "l0.5453776,0.3903674", "l0.5482592,0.3898030", "l0.5523770,0.3900859", "l0.5552566,0.3923422", "c"]}, {"n": "Lake Titicaca", "u": "PE-LKT", "i": ["m0.9129036,0.8197790", "l0.9190720,0.8232374", "l0.9207542,0.8278485", "l0.9263625,0.8278485", "l0.9308487,0.8286174", "l0.9336529,0.8324609", "l0.9415052,0.8328447", "l0.9448695,0.8347664", "l0.9477142,0.8356023", "l0.9412436,0.8450417", "l0.9476515,0.8567765", "l0.9539876,0.8683750", "l0.9568194,0.8693851", "l0.9629951,0.8722058", "l0.9684966,0.8749710", "l0.9644967,0.8766578", "l0.9611324,0.8808851", "l0.9538420,0.8828068", "l0.9476718,0.8820379", "l0.9437456,0.8778106", "l0.9398213,0.8778106", "l0.9325309,0.8801162", "l0.9280446,0.8770417", "l0.9302886,0.8728144", "l0.9342148,0.8697399", "l0.9330909,0.8674343", "l0.9246803,0.8662816", "l0.9214248,0.8650997", "l0.9213161,0.8655114", "l0.9145858,0.8655114", "l0.9123417,0.8624381", "l0.9106596,0.8593624", "l0.9084174,0.8601326", "l0.9061752,0.8632058", "l0.9033692,0.8624381", "l0.8994430,0.8601326", "l0.8960787,0.8601326", "l0.8915943,0.8605152", "l0.8899122,0.8570568", "l0.8887883,0.8528295", "l0.8871062,0.8486023", "l0.8927145,0.8470644", "l0.8966407,0.8459116", "l0.8983228,0.8424533", "l0.9016870,0.8420682", "l0.9016870,0.8370720", "l0.8977609,0.8355354", "l0.8966407,0.8316919", "l0.8994430,0.8297702", "l0.9039311,0.8278485", "l0.9028091,0.8224684", "l0.8994430,0.8213144", "l0.8927145,0.8216995", "l0.8876681,0.8213144", "l0.8826218,0.8213144", "l0.8814979,0.8190088", "l0.8826218,0.8167033", "l0.8887883,0.8163182", "l0.8949586,0.8163182", "l0.9005669,0.8174722", "l0.9072953,0.8186263", "c"]}]} """;
}
